/*
 * Copyright (c) 2013, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of Freescale Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "fsl_platform_common.h"
#include "fsl_device_registers.h"
#include "qspi_test.h"
#include "bootloader_common.h"


void init_hardware(void)
{

    // Enable all the ports
    HW_SIM_SCGC5_SET(SIM_BASE, BM_SIM_SCGC5_PORTA
                  | BM_SIM_SCGC5_PORTB
                  | BM_SIM_SCGC5_PORTC
                  | BM_SIM_SCGC5_PORTD
                  | BM_SIM_SCGC5_PORTE);

    HW_SIM_SOPT2_SET(SIM_BASE, BM_SIM_SOPT2_PLLFLLSEL); // set PLLFLLSEL to select the PLL for this clock source
    BR_SIM_SOPT2_LPUARTSRC(SIM_BASE) = 0x01; // set LPUART Clock source to MCGFLLCLK or MCGPLLCLK


}
//! @brief qspi unit test main function, sets up hardware then jumps to qspi_test().
int main()
{
   init_hardware();

    //debug_init();

    return qspi_test() == kStatus_Success ? 0 : 1;

}

////////////////////////////////////////////////////////////////////////////////
// EOF
////////////////////////////////////////////////////////////////////////////////
