;/*****************************************************************************
; * @file:    startup_MK66F18.s
; * @purpose: CMSIS Cortex-M4 Core Device Startup File
; *           MK66F18
; * @version: 1.1
; * @date:    2013-10-29
; *----------------------------------------------------------------------------
; *
; * Copyright: 1997 - 2014 Freescale Semiconductor, Inc. All Rights Reserved.
; *
; ******************************************************************************/


;
; The modules in this file are included in the libraries, and may be replaced
; by any user-defined modules that define the PUBLIC symbol _program_start or
; a user defined start symbol.
; To override the cstartup defined in the library, simply add your modified
; version to the workbench project.
;
; The vector table is normally located at address 0.
; When debugging in RAM, it can be located in RAM, aligned to at least 2^6.
; The name "__vector_table" has special meaning for C-SPY:
; it is where the SP start value is found, and the NVIC vector
; table register (VTOR) is initialized to this address if != 0.
;
; Cortex-M version
;

        MODULE  ?cstartup

        ;; Forward declaration of sections.
        SECTION CSTACK:DATA:NOROOT(3)

        SECTION .intvec:CODE:NOROOT(2)

        EXTERN  __iar_program_start
        EXTERN  SystemInit
        EXTERN  g_bootloaderTree
        PUBLIC  __vector_table
        PUBLIC  __vector_table_0x1c
        PUBLIC  __Vectors
        PUBLIC  __Vectors_End
        PUBLIC  __Vectors_Size

        DATA

__vector_table
        DCD     sfe(CSTACK)
        DCD     Reset_Handler

        DCD     NMI_Handler
        DCD     HardFault_Handler
        DCD     MemManage_Handler
        DCD     BusFault_Handler
        DCD     UsageFault_Handler
__vector_table_0x1c
        DCD     g_bootloaderTree
        DCD     0
        DCD     0
        DCD     0
        DCD     SVC_Handler
        DCD     DebugMon_Handler
        DCD     0
        DCD     PendSV_Handler
        DCD     SysTick_Handler

        ; External Interrupts
        DCD     DMA0_DMA16_IRQHandler  ; DMA Channel 0, 16 Transfer Complete
        DCD     DMA1_DMA17_IRQHandler  ; DMA Channel 1, 17 Transfer Complete
        DCD     DMA2_DMA18_IRQHandler  ; DMA Channel 2, 18 Transfer Complete
        DCD     DMA3_DMA19_IRQHandler  ; DMA Channel 3, 19 Transfer Complete
        DCD     DMA4_DMA20_IRQHandler  ; DMA Channel 4, 20 Transfer Complete
        DCD     DMA5_DMA21_IRQHandler  ; DMA Channel 5, 21 Transfer Complete
        DCD     DMA6_DMA22_IRQHandler  ; DMA Channel 6, 22 Transfer Complete
        DCD     DMA7_DMA23_IRQHandler  ; DMA Channel 7, 23 Transfer Complete
        DCD     DMA8_DMA24_IRQHandler  ; DMA Channel 8, 24 Transfer Complete
        DCD     DMA9_DMA25_IRQHandler  ; DMA Channel 9, 25 Transfer Complete
        DCD     DMA10_DMA26_IRQHandler  ; DMA Channel 10, 26 Transfer Complete
        DCD     DMA11_DMA27_IRQHandler  ; DMA Channel 11, 27 Transfer Complete
        DCD     DMA12_DMA28_IRQHandler  ; DMA Channel 12, 28 Transfer Complete
        DCD     DMA13_DMA29_IRQHandler  ; DMA Channel 13, 29 Transfer Complete
        DCD     DMA14_DMA30_IRQHandler  ; DMA Channel 14, 30 Transfer Complete
        DCD     DMA15_DMA31_IRQHandler  ; DMA Channel 15, 31 Transfer Complete
        DCD     DMA_Error_IRQHandler  ; DMA Error Interrupt
        DCD     MCM_IRQHandler  ; Normal Interrupt
        DCD     FTFE_IRQHandler  ; FTFE Command complete interrupt
        DCD     Read_Collision_IRQHandler  ; Read Collision Interrupt
        DCD     LVD_LVW_IRQHandler  ; Low Voltage Detect, Low Voltage Warning
        DCD     LLW_IRQHandler  ; Low Leakage Wakeup
        DCD     Watchdog_IRQHandler  ; WDOG Interrupt
        DCD     RNG_IRQHandler  ; RNG Interrupt
        DCD     I2C0_IRQHandler  ; I2C0 interrupt
        DCD     I2C1_IRQHandler  ; I2C1 interrupt
        DCD     SPI0_IRQHandler  ; SPI0 Interrupt
        DCD     SPI1_IRQHandler  ; SPI1 Interrupt
        DCD     I2S0_Tx_IRQHandler  ; I2S0 transmit interrupt
        DCD     I2S0_Rx_IRQHandler  ; I2S0 receive interrupt
        DCD     LPUART0_IRQHandler  ; UART0 LON interrupt
        DCD     LPUART1_IRQHandler  ; UART0 Receive/Transmit interrupt
        DCD     LPUART2_IRQHandler  ; UART0 Error interrupt
        DCD     LPUART3_IRQHandler  ; UART1 Receive/Transmit interrupt
        DCD     LPUART4_IRQHandler  ; UART1 Error interrupt
        DCD     Reserved51_IRQHandler  ; UART2 Receive/Transmit interrupt
        DCD     Reserved52_IRQHandler  ; UART2 Error interrupt
        DCD     EMVSIM0_IRQHandler  ; UART3 Receive/Transmit interrupt
        DCD     EMVSIM1_IRQHandler  ; UART3 Error interrupt
        DCD     ADC0_IRQHandler  ; ADC0 interrupt
        DCD     CMP0_IRQHandler  ; CMP0 interrupt
        DCD     CMP1_IRQHandler  ; CMP1 interrupt
        DCD     FTM0_IRQHandler  ; FTM0 fault, overflow and channels interrupt
        DCD     FTM1_IRQHandler  ; FTM1 fault, overflow and channels interrupt
        DCD     FTM2_IRQHandler  ; FTM2 fault, overflow and channels interrupt
        DCD     CMT_IRQHandler  ; CMT interrupt
        DCD     RTC_IRQHandler  ; RTC interrupt
        DCD     RTC_Seconds_IRQHandler  ; RTC seconds interrupt
        DCD     PIT0_IRQHandler  ; PIT timer channel 0 interrupt
        DCD     PIT1_IRQHandler  ; PIT timer channel 1 interrupt
        DCD     PIT2_IRQHandler  ; PIT timer channel 2 interrupt
        DCD     PIT3_IRQHandler  ; PIT timer channel 3 interrupt
        DCD     PDB0_IRQHandler  ; PDB0 Interrupt
        DCD     USB0_IRQHandler  ; USB0 interrupt
        DCD     USBDCD_IRQHandler  ; USBDCD Interrupt
        DCD     Reserved71_IRQHandler  ; Reserved interrupt 71
        DCD     DAC0_IRQHandler  ; DAC0 interrupt
        DCD     MCG_IRQHandler  ; MCG Interrupt
        DCD     LPTimer_IRQHandler  ; LPTimer interrupt
        DCD     PORTA_IRQHandler  ; Port A interrupt
        DCD     PORTB_IRQHandler  ; Port B interrupt
        DCD     PORTC_IRQHandler  ; Port C interrupt
        DCD     PORTD_IRQHandler  ; Port D interrupt
        DCD     PORTE_IRQHandler  ; Port E interrupt
        DCD     SWI_IRQHandler  ; Software interrupt
        DCD     SPI2_IRQHandler  ; SPI2 Interrupt
        DCD     Reserved82_IRQHandler  ; UART4 Receive/Transmit interrupt
        DCD     Reserved83_IRQHandler  ; UART4 Error interrupt
        DCD     Reserved84_IRQHandler  ; Reserved interrupt 84
        DCD     Reserved85_IRQHandler  ; Reserved interrupt 85
        DCD     FlexIO_IRQHandler  ; CMP2 interrupt
        DCD     FTM3_IRQHandler  ; FTM3 fault, overflow and channels interrupt
        DCD     DAC1_IRQHandler  ; DAC1 interrupt
        DCD     ADC1_IRQHandler  ; ADC1 interrupt
        DCD     I2C2_IRQHandler  ; I2C2 interrupt
        DCD     CAN0_ORed_Message_buffer_IRQHandler  ; CAN0 OR'd message buffers interrupt
        DCD     CAN0_Bus_Off_IRQHandler  ; CAN0 bus off interrupt
        DCD     CAN0_Error_IRQHandler  ; CAN0 error interrupt
        DCD     CAN0_Tx_Warning_IRQHandler  ; CAN0 Tx warning interrupt
        DCD     CAN0_Rx_Warning_IRQHandler  ; CAN0 Rx warning interrupt
        DCD     CAN0_Wake_Up_IRQHandler  ; CAN0 wake up interrupt
        DCD     SDHC_IRQHandler  ; SDHC interrupt
        DCD     ENET_1588_Timer_IRQHandler  ; Ethernet MAC IEEE 1588 Timer Interrupt
        DCD     ENET_Transmit_IRQHandler  ; Ethernet MAC Transmit Interrupt
        DCD     ENET_Receive_IRQHandler  ; Ethernet MAC Receive Interrupt
        DCD     ENET_Error_IRQHandler  ; Ethernet MAC Error and miscelaneous Interrupt
        DCD     Reserved102_IRQHandler  ; LPUART0 status/error interrupt
        DCD     TSI0_IRQHandler  ; TSI0 interrupt
        DCD     TPM1_IRQHandler  ; TPM1 fault, overflow and channels interrupt
        DCD     TPM2_IRQHandler  ; TPM2 fault, overflow and channels interrupt
        DCD     USBHSDCD_IRQHandler  ; USBHSDCD, USBHS Phy Interrupt
        DCD     I2C3_IRQHandler  ; I2C3 interrupt
        DCD     CMP3_IRQHandler  ; CMP3 interrupt
        DCD     USBHS_IRQHandler  ; USB high speed OTG interrupt
        DCD     CAN1_ORed_Message_buffer_IRQHandler  ; CAN1 OR'd message buffers interrupt
        DCD     CAN1_Bus_Off_IRQHandler  ; CAN1 bus off interrupt
        DCD     CAN1_Error_IRQHandler  ; CAN1 error interrupt
        DCD     CAN1_Tx_Warning_IRQHandler  ; CAN1 Tx warning interrupt
        DCD     CAN1_Rx_Warning_IRQHandler  ; CAN1 Rx warning interrupt
        DCD     CAN1_Wake_Up_IRQHandler  ; CAN1 wake up interrupt
__Vectors_End


__Vectors       EQU   __vector_table
__Vectors_Size 	EQU 	__Vectors_End - __Vectors


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Default interrupt handlers.
;;
        THUMB

        PUBWEAK init_data_bss
        SECTION .text:CODE:REORDER:NOROOT(1)
init_data_bss
        BX      R14

        PUBWEAK Reset_Handler
        SECTION .text:CODE:REORDER:NOROOT(2)
Reset_Handler
        LDR     R0, =SystemInit
        BLX     R0
        LDR     R0, =init_data_bss
        BLX     R0
        LDR     R0, =__iar_program_start
        BX      R0

        PUBWEAK NMI_Handler
        PUBWEAK HardFault_Handler
        PUBWEAK MemManage_Handler
        PUBWEAK BusFault_Handler
        PUBWEAK UsageFault_Handler
        PUBWEAK SVC_Handler
        PUBWEAK DebugMon_Handler
        PUBWEAK PendSV_Handler
        PUBWEAK SysTick_Handler
        PUBWEAK DMA0_DMA16_IRQHandler
        PUBWEAK DMA1_DMA17_IRQHandler
        PUBWEAK DMA2_DMA18_IRQHandler
        PUBWEAK DMA3_DMA19_IRQHandler
        PUBWEAK DMA4_DMA20_IRQHandler
        PUBWEAK DMA5_DMA21_IRQHandler
        PUBWEAK DMA6_DMA22_IRQHandler
        PUBWEAK DMA7_DMA23_IRQHandler
        PUBWEAK DMA8_DMA24_IRQHandler
        PUBWEAK DMA9_DMA25_IRQHandler
        PUBWEAK DMA10_DMA26_IRQHandler
        PUBWEAK DMA11_DMA27_IRQHandler
        PUBWEAK DMA12_DMA28_IRQHandler
        PUBWEAK DMA13_DMA29_IRQHandler
        PUBWEAK DMA14_DMA30_IRQHandler
        PUBWEAK DMA15_DMA31_IRQHandler
        PUBWEAK DMA_Error_IRQHandler
        PUBWEAK MCM_IRQHandler
        PUBWEAK FTFE_IRQHandler
        PUBWEAK Read_Collision_IRQHandler
        PUBWEAK LVD_LVW_IRQHandler
        PUBWEAK LLW_IRQHandler
        PUBWEAK Watchdog_IRQHandler
        PUBWEAK RNG_IRQHandler
        PUBWEAK I2C0_IRQHandler
        PUBWEAK I2C1_IRQHandler
        PUBWEAK SPI0_IRQHandler
        PUBWEAK SPI1_IRQHandler
        PUBWEAK I2S0_Tx_IRQHandler
        PUBWEAK I2S0_Rx_IRQHandler
        PUBWEAK LPUART0_IRQHandler
        PUBWEAK LPUART1_IRQHandler
        PUBWEAK LPUART2_IRQHandler
        PUBWEAK LPUART3_IRQHandler
        PUBWEAK LPUART4_IRQHandler
        PUBWEAK Reserved51_IRQHandler
        PUBWEAK Reserved52_IRQHandler
        PUBWEAK EMVSIM0_IRQHandler
        PUBWEAK EMVSIM1_IRQHandler
        PUBWEAK ADC0_IRQHandler
        PUBWEAK CMP0_IRQHandler
        PUBWEAK CMP1_IRQHandler
        PUBWEAK FTM0_IRQHandler
        PUBWEAK FTM1_IRQHandler
        PUBWEAK FTM2_IRQHandler
        PUBWEAK CMT_IRQHandler
        PUBWEAK RTC_IRQHandler
        PUBWEAK RTC_Seconds_IRQHandler
        PUBWEAK PIT0_IRQHandler
        PUBWEAK PIT1_IRQHandler
        PUBWEAK PIT2_IRQHandler
        PUBWEAK PIT3_IRQHandler
        PUBWEAK PDB0_IRQHandler
        PUBWEAK USB0_IRQHandler
        PUBWEAK USBDCD_IRQHandler
        PUBWEAK Reserved71_IRQHandler
        PUBWEAK DAC0_IRQHandler
        PUBWEAK MCG_IRQHandler
        PUBWEAK LPTimer_IRQHandler
        PUBWEAK PORTA_IRQHandler
        PUBWEAK PORTB_IRQHandler
        PUBWEAK PORTC_IRQHandler
        PUBWEAK PORTD_IRQHandler
        PUBWEAK PORTE_IRQHandler
        PUBWEAK SWI_IRQHandler
        PUBWEAK SPI2_IRQHandler
        PUBWEAK Reserved82_IRQHandler
        PUBWEAK Reserved83_IRQHandler
        PUBWEAK Reserved84_IRQHandler
        PUBWEAK Reserved85_IRQHandler
        PUBWEAK FlexIO_IRQHandler
        PUBWEAK FTM3_IRQHandler
        PUBWEAK DAC1_IRQHandler
        PUBWEAK ADC1_IRQHandler
        PUBWEAK I2C2_IRQHandler
        PUBWEAK CAN0_ORed_Message_buffer_IRQHandler
        PUBWEAK CAN0_Bus_Off_IRQHandler
        PUBWEAK CAN0_Error_IRQHandler
        PUBWEAK CAN0_Tx_Warning_IRQHandler
        PUBWEAK CAN0_Rx_Warning_IRQHandler
        PUBWEAK CAN0_Wake_Up_IRQHandler
        PUBWEAK SDHC_IRQHandler
        PUBWEAK ENET_1588_Timer_IRQHandler
        PUBWEAK ENET_Transmit_IRQHandler
        PUBWEAK ENET_Receive_IRQHandler
        PUBWEAK ENET_Error_IRQHandler
        PUBWEAK Reserved102_IRQHandler
        PUBWEAK TSI0_IRQHandler
        PUBWEAK TPM1_IRQHandler
        PUBWEAK TPM2_IRQHandler
        PUBWEAK USBHSDCD_IRQHandler
        PUBWEAK I2C3_IRQHandler
        PUBWEAK CMP3_IRQHandler
        PUBWEAK USBHS_IRQHandler
        PUBWEAK CAN1_ORed_Message_buffer_IRQHandler
        PUBWEAK CAN1_Bus_Off_IRQHandler
        PUBWEAK CAN1_Error_IRQHandler
        PUBWEAK CAN1_Tx_Warning_IRQHandler
        PUBWEAK CAN1_Rx_Warning_IRQHandler
        PUBWEAK CAN1_Wake_Up_IRQHandler
        PUBWEAK DefaultISR
        SECTION .text:CODE:REORDER:NOROOT(1)
NMI_Handler
HardFault_Handler
MemManage_Handler
BusFault_Handler
UsageFault_Handler
SVC_Handler
DebugMon_Handler
PendSV_Handler
SysTick_Handler
DMA0_DMA16_IRQHandler
DMA1_DMA17_IRQHandler
DMA2_DMA18_IRQHandler
DMA3_DMA19_IRQHandler
DMA4_DMA20_IRQHandler
DMA5_DMA21_IRQHandler
DMA6_DMA22_IRQHandler
DMA7_DMA23_IRQHandler
DMA8_DMA24_IRQHandler
DMA9_DMA25_IRQHandler
DMA10_DMA26_IRQHandler
DMA11_DMA27_IRQHandler
DMA12_DMA28_IRQHandler
DMA13_DMA29_IRQHandler
DMA14_DMA30_IRQHandler
DMA15_DMA31_IRQHandler
DMA_Error_IRQHandler
MCM_IRQHandler
FTFE_IRQHandler
Read_Collision_IRQHandler
LVD_LVW_IRQHandler
LLW_IRQHandler
Watchdog_IRQHandler
RNG_IRQHandler
I2C0_IRQHandler
I2C1_IRQHandler
SPI0_IRQHandler
SPI1_IRQHandler
I2S0_Tx_IRQHandler
I2S0_Rx_IRQHandler
LPUART0_IRQHandler
LPUART1_IRQHandler
LPUART2_IRQHandler
LPUART3_IRQHandler
LPUART4_IRQHandler
Reserved51_IRQHandler
Reserved52_IRQHandler
EMVSIM0_IRQHandler
EMVSIM1_IRQHandler
ADC0_IRQHandler
CMP0_IRQHandler
CMP1_IRQHandler
FTM0_IRQHandler
FTM1_IRQHandler
FTM2_IRQHandler
CMT_IRQHandler
RTC_IRQHandler
RTC_Seconds_IRQHandler
PIT0_IRQHandler
PIT1_IRQHandler
PIT2_IRQHandler
PIT3_IRQHandler
PDB0_IRQHandler
USB0_IRQHandler
USBDCD_IRQHandler
Reserved71_IRQHandler
DAC0_IRQHandler
MCG_IRQHandler
LPTimer_IRQHandler
PORTA_IRQHandler
PORTB_IRQHandler
PORTC_IRQHandler
PORTD_IRQHandler
PORTE_IRQHandler
SWI_IRQHandler
SPI2_IRQHandler
Reserved82_IRQHandler
Reserved83_IRQHandler
Reserved84_IRQHandler
Reserved85_IRQHandler
FlexIO_IRQHandler
FTM3_IRQHandler
DAC1_IRQHandler
ADC1_IRQHandler
I2C2_IRQHandler
CAN0_ORed_Message_buffer_IRQHandler
CAN0_Bus_Off_IRQHandler
CAN0_Error_IRQHandler
CAN0_Tx_Warning_IRQHandler
CAN0_Rx_Warning_IRQHandler
CAN0_Wake_Up_IRQHandler
SDHC_IRQHandler
ENET_1588_Timer_IRQHandler
ENET_Transmit_IRQHandler
ENET_Receive_IRQHandler
ENET_Error_IRQHandler
Reserved102_IRQHandler
TSI0_IRQHandler
TPM1_IRQHandler
TPM2_IRQHandler
USBHSDCD_IRQHandler
I2C3_IRQHandler
CMP3_IRQHandler
USBHS_IRQHandler
CAN1_ORed_Message_buffer_IRQHandler
CAN1_Bus_Off_IRQHandler
CAN1_Error_IRQHandler
CAN1_Tx_Warning_IRQHandler
CAN1_Rx_Warning_IRQHandler
CAN1_Wake_Up_IRQHandler
DefaultISR
        B .

        END
