/*
** ###################################################################
**     Compilers:           ARM Compiler
**                          Freescale C/C++ for Embedded ARM
**                          GNU C Compiler
**                          IAR ANSI C/C++ Compiler for ARM
**
**     Reference manual:    xxx
**     Version:             rev. 1.0, 2014-05-26
**     Build:               b140528
**
**     Abstract:
**         Extension to the CMSIS register access layer header.
**
**     Copyright (c) 2014 Freescale Semiconductor, Inc.
**     All rights reserved.
**
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
**     http:                 www.freescale.com
**     mail:                 support@freescale.com
**
**     Revisions:
**     - rev. 1.0 (2014-05-26)
**
** ###################################################################
*/

/*
 * WARNING! DO NOT EDIT THIS FILE DIRECTLY!
 *
 * This file was generated automatically and any changes may be lost.
 */
#ifndef __HW_LTC_K80_REGISTERS_H__
#define __HW_LTC_K80_REGISTERS_H__

#include "MK80F256.h"
#include "fsl_bitaccess.h"

/*
 * MK80F256 LTC_K80
 *
 * LTC
 *
 * Registers defined in this header file:
 * - HW_LTC_K80_LTCMR - LTC Mode Register (non-public-key use)
 * - HW_LTC_K80_LTCMR_PK - LTC Mode Register (PublicKey)
 * - HW_LTC_K80_LTCKSR - LTC Key Size Register
 * - HW_LTC_K80_LTCDSR - LTC Data Size Register
 * - HW_LTC_K80_LTCICVSR - LTC ICV Size Register
 * - HW_LTC_K80_LTCCOM - LTC Command Register
 * - HW_LTC_K80_LTCCTL - LTC Control Register
 * - HW_LTC_K80_LTCCWR - LTC Clear Written Register
 * - HW_LTC_K80_LTCSTA - LTC Status Register
 * - HW_LTC_K80_LTCESTA - LTC Error Status Register
 * - HW_LTC_K80_LTCAADSZR - LTC AAD Size Register
 * - HW_LTC_K80_LTCIVSZR - LTC IV Size Register
 * - HW_LTC_K80_LTCDPAMSR - LTC DPA Mask Seed Register
 * - HW_LTC_K80_LPKASZR - LTC PKHA A Size Register
 * - HW_LTC_K80_LPKBSZR - LTC PKHA B Size Register
 * - HW_LTC_K80_LPKNSZR - LTC PKHA N Size Register
 * - HW_LTC_K80_LPKESZR - LTC PKHA E Size Register
 * - HW_LTC_K80_LTCCTXR_0 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_1 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_2 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_3 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_4 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_5 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_6 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_7 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_8 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_9 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_10 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_11 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_12 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_13 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_14 - LTC Context Register
 * - HW_LTC_K80_LTCCTXR_15 - LTC Context Register
 * - HW_LTC_K80_LTCKEYR_0 - LTC Key Registers
 * - HW_LTC_K80_LTCKEYR_1 - LTC Key Registers
 * - HW_LTC_K80_LTCKEYR_2 - LTC Key Registers
 * - HW_LTC_K80_LTCKEYR_3 - LTC Key Registers
 * - HW_LTC_K80_LTCKEYR_4 - LTC Key Registers
 * - HW_LTC_K80_LTCKEYR_5 - LTC Key Registers
 * - HW_LTC_K80_LTCKEYR_6 - LTC Key Registers
 * - HW_LTC_K80_LTCKEYR_7 - LTC Key Registers
 * - HW_LTC_K80_LTCVID1 - LTC Version ID Register
 * - HW_LTC_K80_CHAVID - CHA Version ID Register
 * - HW_LTC_K80_LTCFIFOSTA - LTC FIFO Status Register
 * - HW_LTC_K80_LTCIFIFO - LTC Input Data FIFO
 * - HW_LTC_K80_LTCOFIFO - LTC Output Data FIFO
 * - HW_LTC_K80_LPKA0_0 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_1 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_2 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_3 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_4 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_5 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_6 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_7 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_8 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_9 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_10 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_11 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_12 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_13 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_14 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA0_15 - LTC PKHA A0 Register
 * - HW_LTC_K80_LPKA1_0 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_1 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_2 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_3 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_4 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_5 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_6 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_7 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_8 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_9 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_10 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_11 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_12 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_13 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_14 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA1_15 - LTC PKHA A1 Register
 * - HW_LTC_K80_LPKA2_0 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_1 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_2 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_3 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_4 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_5 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_6 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_7 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_8 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_9 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_10 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_11 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_12 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_13 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_14 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA2_15 - LTC PKHA A2 Register
 * - HW_LTC_K80_LPKA3_0 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_1 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_2 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_3 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_4 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_5 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_6 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_7 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_8 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_9 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_10 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_11 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_12 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_13 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_14 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKA3_15 - LTC PKHA A3 Register
 * - HW_LTC_K80_LPKB0_0 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_1 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_2 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_3 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_4 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_5 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_6 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_7 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_8 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_9 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_10 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_11 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_12 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_13 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_14 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB0_15 - LTC PKHA B0 Register
 * - HW_LTC_K80_LPKB1_0 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_1 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_2 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_3 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_4 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_5 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_6 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_7 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_8 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_9 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_10 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_11 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_12 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_13 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_14 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB1_15 - LTC PKHA B1 Register
 * - HW_LTC_K80_LPKB2_0 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_1 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_2 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_3 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_4 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_5 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_6 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_7 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_8 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_9 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_10 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_11 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_12 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_13 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_14 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB2_15 - LTC PKHA B2 Register
 * - HW_LTC_K80_LPKB3_0 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_1 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_2 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_3 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_4 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_5 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_6 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_7 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_8 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_9 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_10 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_11 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_12 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_13 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_14 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKB3_15 - LTC PKHA B3 Register
 * - HW_LTC_K80_LPKN0_0 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_1 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_2 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_3 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_4 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_5 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_6 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_7 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_8 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_9 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_10 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_11 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_12 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_13 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_14 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN0_15 - LTC PKHA N0 Register
 * - HW_LTC_K80_LPKN1_0 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_1 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_2 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_3 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_4 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_5 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_6 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_7 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_8 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_9 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_10 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_11 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_12 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_13 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_14 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN1_15 - LTC PKHA N1 Register
 * - HW_LTC_K80_LPKN2_0 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_1 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_2 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_3 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_4 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_5 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_6 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_7 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_8 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_9 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_10 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_11 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_12 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_13 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_14 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN2_15 - LTC PKHA N2 Register
 * - HW_LTC_K80_LPKN3_0 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_1 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_2 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_3 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_4 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_5 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_6 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_7 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_8 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_9 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_10 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_11 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_12 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_13 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_14 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKN3_15 - LTC PKHA N3 Register
 * - HW_LTC_K80_LPKE_0 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_1 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_2 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_3 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_4 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_5 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_6 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_7 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_8 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_9 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_10 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_11 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_12 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_13 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_14 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_15 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_16 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_17 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_18 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_19 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_20 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_21 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_22 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_23 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_24 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_25 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_26 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_27 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_28 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_29 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_30 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_31 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_32 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_33 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_34 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_35 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_36 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_37 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_38 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_39 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_40 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_41 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_42 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_43 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_44 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_45 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_46 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_47 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_48 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_49 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_50 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_51 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_52 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_53 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_54 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_55 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_56 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_57 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_58 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_59 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_60 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_61 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_62 - LTC PKHA E Register
 * - HW_LTC_K80_LPKE_63 - LTC PKHA E Register
 *
 * - hw_ltc_k80_t - Struct containing all module registers.
 */

#define HW_LTC_K80_INSTANCE_COUNT (1U) /*!< Number of instances of the LTC_K80 module. */

/*******************************************************************************
 * HW_LTC_K80_LTCMR - LTC Mode Register (non-public-key use)
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCMR - LTC Mode Register (non-public-key use) (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Mode Register is used to tells the cryptographic engines which operation is being requested.
 * The interpretation of this register will be unique for each CHA. This section defines the format
 * of the Mode Register when used with non-public-key algorithms.
 */
typedef union _hw_ltc_k80_ltcmr
{
    uint32_t U;
    struct _hw_ltc_k80_ltcmr_bitfields
    {
        uint32_t ENC : 1; /*!< [0] Encrypt/Decrypt. */
        uint32_t ICV_TEST : 1; /*!< [1] ICV Checking / Test AES fault detection. */
        uint32_t AS : 2; /*!< [3:2] Algorithm State. */
        uint32_t AAI : 9; /*!< [12:4] Additional Algorithm information. */
        uint32_t RESERVED0 : 3; /*!< [15:13] Reserved. */
        uint32_t ALG : 8; /*!< [23:16] Algorithm. */
        uint32_t RESERVED1 : 8; /*!< [31:24] Reserved. */
    } B;
} hw_ltc_k80_ltcmr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCMR register
 */
/*@{*/
#define HW_LTC_K80_LTCMR_ADDR(x)        ((x) + 0x0U)
#define HW_LTC_K80_LTCMR(x)             (*(__IO hw_ltc_k80_ltcmr_t *) HW_LTC_K80_LTCMR_ADDR(x))
#define HW_LTC_K80_LTCMR_RD(x)          (HW_LTC_K80_LTCMR(x).U)
#define HW_LTC_K80_LTCMR_WR(x, v)       (HW_LTC_K80_LTCMR(x).U = (v))
#define HW_LTC_K80_LTCMR_SET(x, v)      (HW_LTC_K80_LTCMR_WR(x, HW_LTC_K80_LTCMR_RD(x) |  (v)))
#define HW_LTC_K80_LTCMR_CLR(x, v)      (HW_LTC_K80_LTCMR_WR(x, HW_LTC_K80_LTCMR_RD(x) & ~(v)))
#define HW_LTC_K80_LTCMR_TOG(x, v)      (HW_LTC_K80_LTCMR_WR(x, HW_LTC_K80_LTCMR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCMR bitfields
 */

/*!
 * @name Register LTC_K80_LTCMR, field ENC[0] (RW)
 *
 * Encrypt/Decrypt. This bit selects encryption or decryption.
 *
 * Values:
 * - 0 - Decrypt.
 * - 1 - Encrypt.
 */
/*@{*/
#define BP_LTC_K80_LTCMR_ENC         (0U)      /*!< Bit position for LTC_K80_LTCMR_ENC. */
#define BM_LTC_K80_LTCMR_ENC         (0x00000001U)  /*!< Bit mask for LTC_K80_LTCMR_ENC. */
#define BS_LTC_K80_LTCMR_ENC         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCMR_ENC. */

/*! @brief Read current value of the LTC_K80_LTCMR_ENC field. */
#define BR_LTC_K80_LTCMR_ENC(x)   (HW_LTC_K80_LTCMR(x).B.ENC)

/*! @brief Format value for bitfield LTC_K80_LTCMR_ENC. */
#define BF_LTC_K80_LTCMR_ENC(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCMR_ENC) & BM_LTC_K80_LTCMR_ENC)

/*! @brief Set the ENC field to a new value. */
#define BW_LTC_K80_LTCMR_ENC(x, v)   (HW_LTC_K80_LTCMR_WR(x, (HW_LTC_K80_LTCMR_RD(x) & ~BM_LTC_K80_LTCMR_ENC) | BF_LTC_K80_LTCMR_ENC(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCMR, field ICV_TEST[1] (RW)
 *
 * ICV Checking / Test AES fault detection. For algorithms other than AES ECB mode: ICV Checking
 * This bit selects whether the current algorithm should compare the known ICV versus the calculated
 * ICV. This bit will be ignored by algorithms that do not support ICV checking. 0 - Don't compare 1
 * - Compare For AES ECB mode: Test AES fault detection In AES ECB mode, this bit activates fault
 * detection testing by injecting bit level errors into AES core logic as defined in the first 128
 * bits of the context. 0 - Don't inject bit errors 1 - Inject bit errors
 */
/*@{*/
#define BP_LTC_K80_LTCMR_ICV_TEST         (1U)      /*!< Bit position for LTC_K80_LTCMR_ICV_TEST. */
#define BM_LTC_K80_LTCMR_ICV_TEST         (0x00000002U)  /*!< Bit mask for LTC_K80_LTCMR_ICV_TEST. */
#define BS_LTC_K80_LTCMR_ICV_TEST         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCMR_ICV_TEST. */

/*! @brief Read current value of the LTC_K80_LTCMR_ICV_TEST field. */
#define BR_LTC_K80_LTCMR_ICV_TEST(x)   (HW_LTC_K80_LTCMR(x).B.ICV_TEST)

/*! @brief Format value for bitfield LTC_K80_LTCMR_ICV_TEST. */
#define BF_LTC_K80_LTCMR_ICV_TEST(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCMR_ICV_TEST) & BM_LTC_K80_LTCMR_ICV_TEST)

/*! @brief Set the ICV_TEST field to a new value. */
#define BW_LTC_K80_LTCMR_ICV_TEST(x, v)   (HW_LTC_K80_LTCMR_WR(x, (HW_LTC_K80_LTCMR_RD(x) & ~BM_LTC_K80_LTCMR_ICV_TEST) | BF_LTC_K80_LTCMR_ICV_TEST(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCMR, field AS[3:2] (RW)
 *
 * Algorithm State. This field defines the state of the algorithm that is being executed. This may
 * not be used by every algorithm.
 *
 * Values:
 * - 00 - Update
 * - 01 - Initialize
 * - 10 - Finalize
 * - 11 - Initialize/Finalize
 */
/*@{*/
#define BP_LTC_K80_LTCMR_AS         (2U)      /*!< Bit position for LTC_K80_LTCMR_AS. */
#define BM_LTC_K80_LTCMR_AS         (0x0000000CU)  /*!< Bit mask for LTC_K80_LTCMR_AS. */
#define BS_LTC_K80_LTCMR_AS         (2U)  /*!< Bitfield size in bits for LTC_K80_LTCMR_AS. */

/*! @brief Read current value of the LTC_K80_LTCMR_AS field. */
#define BR_LTC_K80_LTCMR_AS(x)   (HW_LTC_K80_LTCMR(x).B.AS)

/*! @brief Format value for bitfield LTC_K80_LTCMR_AS. */
#define BF_LTC_K80_LTCMR_AS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCMR_AS) & BM_LTC_K80_LTCMR_AS)

/*! @brief Set the AS field to a new value. */
#define BW_LTC_K80_LTCMR_AS(x, v)   (HW_LTC_K80_LTCMR_WR(x, (HW_LTC_K80_LTCMR_RD(x) & ~BM_LTC_K80_LTCMR_AS) | BF_LTC_K80_LTCMR_AS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCMR, field AAI[12:4] (RW)
 *
 * Additional Algorithm information. This field contains additional mode information that is
 * associated with the algorithm that is being executed. See also the section describing the
 * appropriate CHA. Some algorithms do not require additional algorithm information and in those
 * cases this field should be all 0s. AAI Interpretation for AES Modes [For AES the MSB of AAI is
 * the DK (Decrypt Key) bit.] Code The codes are mutually exclusive (i.e. they cannot be ORed with
 * each other). Interpretation Code Interpretation 00h CTR (mod 2 128) 80h CCM, CCM* 10h CBC 90h GCM
 * 20h ECB A0h CBC_XCBC_MAC 30h reserved B0h CTR_XCBC_MAC 40h reserved C0h Reserved 50h Reserved D0h
 * Reserved 60h CMAC E0h Reserved 70h XCBC-MAC Setting the DK bit (i.e. ORing 100h with any AES code
 * above) causes Key Register to be loaded with the AES Dcrypt key, rather than the AES Encrypt key.
 * AAI Interpretation for DES Code Interpretation Code Interpretation 10h CBC 30h CFB 20h ECB 40h
 * OFB 80h ORed with any DES code above: Check odd parity
 */
/*@{*/
#define BP_LTC_K80_LTCMR_AAI         (4U)      /*!< Bit position for LTC_K80_LTCMR_AAI. */
#define BM_LTC_K80_LTCMR_AAI         (0x00001FF0U)  /*!< Bit mask for LTC_K80_LTCMR_AAI. */
#define BS_LTC_K80_LTCMR_AAI         (9U)  /*!< Bitfield size in bits for LTC_K80_LTCMR_AAI. */

/*! @brief Read current value of the LTC_K80_LTCMR_AAI field. */
#define BR_LTC_K80_LTCMR_AAI(x)   (HW_LTC_K80_LTCMR(x).B.AAI)

/*! @brief Format value for bitfield LTC_K80_LTCMR_AAI. */
#define BF_LTC_K80_LTCMR_AAI(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCMR_AAI) & BM_LTC_K80_LTCMR_AAI)

/*! @brief Set the AAI field to a new value. */
#define BW_LTC_K80_LTCMR_AAI(x, v)   (HW_LTC_K80_LTCMR_WR(x, (HW_LTC_K80_LTCMR_RD(x) & ~BM_LTC_K80_LTCMR_AAI) | BF_LTC_K80_LTCMR_AAI(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCMR, field ALG[23:16] (RW)
 *
 * Algorithm. This field specifies which algorithm is being selected.
 *
 * Values:
 * - 00010000 - AES
 * - 00100000 - DES
 */
/*@{*/
#define BP_LTC_K80_LTCMR_ALG         (16U)      /*!< Bit position for LTC_K80_LTCMR_ALG. */
#define BM_LTC_K80_LTCMR_ALG         (0x00FF0000U)  /*!< Bit mask for LTC_K80_LTCMR_ALG. */
#define BS_LTC_K80_LTCMR_ALG         (8U)  /*!< Bitfield size in bits for LTC_K80_LTCMR_ALG. */

/*! @brief Read current value of the LTC_K80_LTCMR_ALG field. */
#define BR_LTC_K80_LTCMR_ALG(x)   (HW_LTC_K80_LTCMR(x).B.ALG)

/*! @brief Format value for bitfield LTC_K80_LTCMR_ALG. */
#define BF_LTC_K80_LTCMR_ALG(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCMR_ALG) & BM_LTC_K80_LTCMR_ALG)

/*! @brief Set the ALG field to a new value. */
#define BW_LTC_K80_LTCMR_ALG(x, v)   (HW_LTC_K80_LTCMR_WR(x, (HW_LTC_K80_LTCMR_RD(x) & ~BM_LTC_K80_LTCMR_ALG) | BF_LTC_K80_LTCMR_ALG(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCMR_PK - LTC Mode Register (PublicKey)
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCMR_PK - LTC Mode Register (PublicKey) (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Mode Register is used to tell the CHAs which operation is being requested. The interpretation
 * of this register is for public key operations (PKHA) only, and is described herein. The bit
 * assignments for the PKHA_MODE will be different depending on which of the three types of PKHA
 * functions is being called. The three function types are: 1) Clear Memory, 2) Modular Arithmetic,
 * and 3) Copy Memory. Detailed descriptions of their mode formats can be found in Table , Table and
 * Table .
 */
typedef union _hw_ltc_k80_ltcmr_pk
{
    uint32_t U;
    struct _hw_ltc_k80_ltcmr_pk_bitfields
    {
        uint32_t PKHA_MODE_LS : 12; /*!< [11:0] PKHA_MODE least significant 12 bits. */
        uint32_t RESERVED0 : 4; /*!< [15:12] Reserved */
        uint32_t PKHA_MODE_MS : 4; /*!< [19:16] PKHA_MODE most-significant 4 bits. */
        uint32_t ALG : 4; /*!< [23:20] Algorithm. */
        uint32_t RESERVED1 : 8; /*!< [31:24] Options bits. */
    } B;
} hw_ltc_k80_ltcmr_pk_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCMR_PK register
 */
/*@{*/
#define HW_LTC_K80_LTCMR_PK_ADDR(x)        ((x) + 0x0U)
#define HW_LTC_K80_LTCMR_PK(x)             (*(__IO hw_ltc_k80_ltcmr_pk_t *) HW_LTC_K80_LTCMR_PK_ADDR(x))
#define HW_LTC_K80_LTCMR_PK_RD(x)          (HW_LTC_K80_LTCMR_PK(x).U)
#define HW_LTC_K80_LTCMR_PK_WR(x, v)       (HW_LTC_K80_LTCMR_PK(x).U = (v))
#define HW_LTC_K80_LTCMR_PK_SET(x, v)      (HW_LTC_K80_LTCMR_PK_WR(x, HW_LTC_K80_LTCMR_PK_RD(x) |  (v)))
#define HW_LTC_K80_LTCMR_PK_CLR(x, v)      (HW_LTC_K80_LTCMR_PK_WR(x, HW_LTC_K80_LTCMR_PK_RD(x) & ~(v)))
#define HW_LTC_K80_LTCMR_PK_TOG(x, v)      (HW_LTC_K80_LTCMR_PK_WR(x, HW_LTC_K80_LTCMR_PK_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCMR_PK bitfields
 */

/*!
 * @name Register LTC_K80_LTCMR_PK, field PKHA_MODE_LS[11:0] (RW)
 *
 * PKHA_MODE least significant 12 bits. The format of the PKHA_MODE field differs depending on which
 * of the three types of PKHA functions is being executed. The three function types are: 1) Clear
 * Memory, 2) Modular Arithmetic, and 3) Copy Memory. Detailed descriptions of their mode formats
 * can be found in Table , Table and Table .
 */
/*@{*/
#define BP_LTC_K80_LTCMR_PK_PKHA_MODE_LS         (0U)      /*!< Bit position for LTC_K80_LTCMR_PK_PKHA_MODE_LS. */
#define BM_LTC_K80_LTCMR_PK_PKHA_MODE_LS         (0x00000FFFU)  /*!< Bit mask for LTC_K80_LTCMR_PK_PKHA_MODE_LS. */
#define BS_LTC_K80_LTCMR_PK_PKHA_MODE_LS         (12U)  /*!< Bitfield size in bits for LTC_K80_LTCMR_PK_PKHA_MODE_LS. */

/*! @brief Read current value of the LTC_K80_LTCMR_PK_PKHA_MODE_LS field. */
#define BR_LTC_K80_LTCMR_PK_PKHA_MODE_LS(x)   (HW_LTC_K80_LTCMR_PK(x).B.PKHA_MODE_LS)

/*! @brief Format value for bitfield LTC_K80_LTCMR_PK_PKHA_MODE_LS. */
#define BF_LTC_K80_LTCMR_PK_PKHA_MODE_LS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCMR_PK_PKHA_MODE_LS) & BM_LTC_K80_LTCMR_PK_PKHA_MODE_LS)

/*! @brief Set the PKHA_MODE_LS field to a new value. */
#define BW_LTC_K80_LTCMR_PK_PKHA_MODE_LS(x, v)   (HW_LTC_K80_LTCMR_PK_WR(x, (HW_LTC_K80_LTCMR_PK_RD(x) & ~BM_LTC_K80_LTCMR_PK_PKHA_MODE_LS) | BF_LTC_K80_LTCMR_PK_PKHA_MODE_LS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCMR_PK, field PKHA_MODE_MS[19:16] (RW)
 *
 * PKHA_MODE most-significant 4 bits. The format of the PKHA_MODE field differs depending on which
 * of the three types of PKHA functions is being executed. The three function types are: 1) Clear
 * Memory, 2) Modular Arithmetic, and 3) Copy Memory. Detailed descriptions of their mode formats
 * can be found in Table , Table and Table .
 */
/*@{*/
#define BP_LTC_K80_LTCMR_PK_PKHA_MODE_MS         (16U)      /*!< Bit position for LTC_K80_LTCMR_PK_PKHA_MODE_MS. */
#define BM_LTC_K80_LTCMR_PK_PKHA_MODE_MS         (0x000F0000U)  /*!< Bit mask for LTC_K80_LTCMR_PK_PKHA_MODE_MS. */
#define BS_LTC_K80_LTCMR_PK_PKHA_MODE_MS         (4U)  /*!< Bitfield size in bits for LTC_K80_LTCMR_PK_PKHA_MODE_MS. */

/*! @brief Read current value of the LTC_K80_LTCMR_PK_PKHA_MODE_MS field. */
#define BR_LTC_K80_LTCMR_PK_PKHA_MODE_MS(x)   (HW_LTC_K80_LTCMR_PK(x).B.PKHA_MODE_MS)

/*! @brief Format value for bitfield LTC_K80_LTCMR_PK_PKHA_MODE_MS. */
#define BF_LTC_K80_LTCMR_PK_PKHA_MODE_MS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCMR_PK_PKHA_MODE_MS) & BM_LTC_K80_LTCMR_PK_PKHA_MODE_MS)

/*! @brief Set the PKHA_MODE_MS field to a new value. */
#define BW_LTC_K80_LTCMR_PK_PKHA_MODE_MS(x, v)   (HW_LTC_K80_LTCMR_PK_WR(x, (HW_LTC_K80_LTCMR_PK_RD(x) & ~BM_LTC_K80_LTCMR_PK_PKHA_MODE_MS) | BF_LTC_K80_LTCMR_PK_PKHA_MODE_MS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCMR_PK, field ALG[23:20] (RW)
 *
 * Algorithm. This field specifies which algorithm is being selected.
 *
 * Values:
 * - 1000 - PKHA
 */
/*@{*/
#define BP_LTC_K80_LTCMR_PK_ALG         (20U)      /*!< Bit position for LTC_K80_LTCMR_PK_ALG. */
#define BM_LTC_K80_LTCMR_PK_ALG         (0x00F00000U)  /*!< Bit mask for LTC_K80_LTCMR_PK_ALG. */
#define BS_LTC_K80_LTCMR_PK_ALG         (4U)  /*!< Bitfield size in bits for LTC_K80_LTCMR_PK_ALG. */

/*! @brief Read current value of the LTC_K80_LTCMR_PK_ALG field. */
#define BR_LTC_K80_LTCMR_PK_ALG(x)   (HW_LTC_K80_LTCMR_PK(x).B.ALG)

/*! @brief Format value for bitfield LTC_K80_LTCMR_PK_ALG. */
#define BF_LTC_K80_LTCMR_PK_ALG(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCMR_PK_ALG) & BM_LTC_K80_LTCMR_PK_ALG)

/*! @brief Set the ALG field to a new value. */
#define BW_LTC_K80_LTCMR_PK_ALG(x, v)   (HW_LTC_K80_LTCMR_PK_WR(x, (HW_LTC_K80_LTCMR_PK_RD(x) & ~BM_LTC_K80_LTCMR_PK_ALG) | BF_LTC_K80_LTCMR_PK_ALG(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKSR - LTC Key Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKSR - LTC Key Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Size Register is used to tell the crypto engine(AES) the size of the key that was loaded
 * into the Key Register. The Key Size Register must be written after the key is written into the
 * Key Register. Writing to the Key Size Register will prevent the user from modifying the Key
 * Register. Only 16, 24, and 32 byte keys are supported.
 */
typedef union _hw_ltc_k80_ltcksr
{
    uint32_t U;
    struct _hw_ltc_k80_ltcksr_bitfields
    {
        uint32_t KS : 6; /*!< [5:0] Key Size. */
        uint32_t RESERVED0 : 26; /*!< [31:6] Reserved. */
    } B;
} hw_ltc_k80_ltcksr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKSR register
 */
/*@{*/
#define HW_LTC_K80_LTCKSR_ADDR(x)        ((x) + 0x8U)
#define HW_LTC_K80_LTCKSR(x)             (*(__IO hw_ltc_k80_ltcksr_t *) HW_LTC_K80_LTCKSR_ADDR(x))
#define HW_LTC_K80_LTCKSR_RD(x)          (HW_LTC_K80_LTCKSR(x).U)
#define HW_LTC_K80_LTCKSR_WR(x, v)       (HW_LTC_K80_LTCKSR(x).U = (v))
#define HW_LTC_K80_LTCKSR_SET(x, v)      (HW_LTC_K80_LTCKSR_WR(x, HW_LTC_K80_LTCKSR_RD(x) |  (v)))
#define HW_LTC_K80_LTCKSR_CLR(x, v)      (HW_LTC_K80_LTCKSR_WR(x, HW_LTC_K80_LTCKSR_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKSR_TOG(x, v)      (HW_LTC_K80_LTCKSR_WR(x, HW_LTC_K80_LTCKSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKSR bitfields
 */

/*!
 * @name Register LTC_K80_LTCKSR, field KS[5:0] (RW)
 *
 * Key Size. This is the size of a Key measured in bytes
 */
/*@{*/
#define BP_LTC_K80_LTCKSR_KS         (0U)      /*!< Bit position for LTC_K80_LTCKSR_KS. */
#define BM_LTC_K80_LTCKSR_KS         (0x0000003FU)  /*!< Bit mask for LTC_K80_LTCKSR_KS. */
#define BS_LTC_K80_LTCKSR_KS         (6U)  /*!< Bitfield size in bits for LTC_K80_LTCKSR_KS. */

/*! @brief Read current value of the LTC_K80_LTCKSR_KS field. */
#define BR_LTC_K80_LTCKSR_KS(x)   (HW_LTC_K80_LTCKSR(x).B.KS)

/*! @brief Format value for bitfield LTC_K80_LTCKSR_KS. */
#define BF_LTC_K80_LTCKSR_KS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKSR_KS) & BM_LTC_K80_LTCKSR_KS)

/*! @brief Set the KS field to a new value. */
#define BW_LTC_K80_LTCKSR_KS(x, v)   (HW_LTC_K80_LTCKSR_WR(x, (HW_LTC_K80_LTCKSR_RD(x) & ~BM_LTC_K80_LTCKSR_KS) | BF_LTC_K80_LTCKSR_KS(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCDSR - LTC Data Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCDSR - LTC Data Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Data Size Register is used to tell the AES the amount of data that will be loaded into the
 * Input Data FIFO. This register should only be written to once during a single operation. Note
 * that writing to the LTCAADSZR or LTCIVSZR will cause this register to also update. When this
 * register is then written directory to then the new value will be added to the previous value in
 * the register. That is, if the DS field currently has the value 16, writing 2 to the least-
 * significant half of the Data Size register (i.e. the DS field) will result in a value of 18 in
 * the DS field. Note that AES decrements this register, so reading the register may return a value
 * less than sum of the values that were written into it. This register is cleared whenever a key is
 * decrypted or encrypted.
 */
typedef union _hw_ltc_k80_ltcdsr
{
    uint32_t U;
    struct _hw_ltc_k80_ltcdsr_bitfields
    {
        uint32_t DS : 12; /*!< [11:0] Data Size. */
        uint32_t RESERVED0 : 20; /*!< [31:12] Reserved. */
    } B;
} hw_ltc_k80_ltcdsr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCDSR register
 */
/*@{*/
#define HW_LTC_K80_LTCDSR_ADDR(x)        ((x) + 0x10U)
#define HW_LTC_K80_LTCDSR(x)             (*(__IO hw_ltc_k80_ltcdsr_t *) HW_LTC_K80_LTCDSR_ADDR(x))
#define HW_LTC_K80_LTCDSR_RD(x)          (HW_LTC_K80_LTCDSR(x).U)
#define HW_LTC_K80_LTCDSR_WR(x, v)       (HW_LTC_K80_LTCDSR(x).U = (v))
#define HW_LTC_K80_LTCDSR_SET(x, v)      (HW_LTC_K80_LTCDSR_WR(x, HW_LTC_K80_LTCDSR_RD(x) |  (v)))
#define HW_LTC_K80_LTCDSR_CLR(x, v)      (HW_LTC_K80_LTCDSR_WR(x, HW_LTC_K80_LTCDSR_RD(x) & ~(v)))
#define HW_LTC_K80_LTCDSR_TOG(x, v)      (HW_LTC_K80_LTCDSR_WR(x, HW_LTC_K80_LTCDSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCDSR bitfields
 */

/*!
 * @name Register LTC_K80_LTCDSR, field DS[11:0] (RW)
 *
 * Data Size. This is the number of whole bytes of data that will be consumed by the CHA. Note that
 * writing the AAD Size Register or IV Size Register will result in this register also being written
 * to.
 */
/*@{*/
#define BP_LTC_K80_LTCDSR_DS         (0U)      /*!< Bit position for LTC_K80_LTCDSR_DS. */
#define BM_LTC_K80_LTCDSR_DS         (0x00000FFFU)  /*!< Bit mask for LTC_K80_LTCDSR_DS. */
#define BS_LTC_K80_LTCDSR_DS         (12U)  /*!< Bitfield size in bits for LTC_K80_LTCDSR_DS. */

/*! @brief Read current value of the LTC_K80_LTCDSR_DS field. */
#define BR_LTC_K80_LTCDSR_DS(x)   (HW_LTC_K80_LTCDSR(x).B.DS)

/*! @brief Format value for bitfield LTC_K80_LTCDSR_DS. */
#define BF_LTC_K80_LTCDSR_DS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCDSR_DS) & BM_LTC_K80_LTCDSR_DS)

/*! @brief Set the DS field to a new value. */
#define BW_LTC_K80_LTCDSR_DS(x, v)   (HW_LTC_K80_LTCDSR_WR(x, (HW_LTC_K80_LTCDSR_RD(x) & ~BM_LTC_K80_LTCDSR_DS) | BF_LTC_K80_LTCDSR_DS(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCICVSR - LTC ICV Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCICVSR - LTC ICV Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The ICV Size Register indicates how much of the last block of ICV is valid when performing AES
 * integrity check modes (e.g. AES-CMAC, AES-XCBC-MAC). This register must be written prior to the
 * corresponding word of data being consumed by AES. In practical terms, this means the register
 * must be written prior to the corresponding data being written to the Input Data FIFO.
 */
typedef union _hw_ltc_k80_ltcicvsr
{
    uint32_t U;
    struct _hw_ltc_k80_ltcicvsr_bitfields
    {
        uint32_t ICVS : 5; /*!< [4:0] ICV Size, in Bytes. */
        uint32_t RESERVED0 : 27; /*!< [31:5] Reserved. */
    } B;
} hw_ltc_k80_ltcicvsr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCICVSR register
 */
/*@{*/
#define HW_LTC_K80_LTCICVSR_ADDR(x)        ((x) + 0x18U)
#define HW_LTC_K80_LTCICVSR(x)             (*(__IO hw_ltc_k80_ltcicvsr_t *) HW_LTC_K80_LTCICVSR_ADDR(x))
#define HW_LTC_K80_LTCICVSR_RD(x)          (HW_LTC_K80_LTCICVSR(x).U)
#define HW_LTC_K80_LTCICVSR_WR(x, v)       (HW_LTC_K80_LTCICVSR(x).U = (v))
#define HW_LTC_K80_LTCICVSR_SET(x, v)      (HW_LTC_K80_LTCICVSR_WR(x, HW_LTC_K80_LTCICVSR_RD(x) |  (v)))
#define HW_LTC_K80_LTCICVSR_CLR(x, v)      (HW_LTC_K80_LTCICVSR_WR(x, HW_LTC_K80_LTCICVSR_RD(x) & ~(v)))
#define HW_LTC_K80_LTCICVSR_TOG(x, v)      (HW_LTC_K80_LTCICVSR_WR(x, HW_LTC_K80_LTCICVSR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCICVSR bitfields
 */

/*!
 * @name Register LTC_K80_LTCICVSR, field ICVS[4:0] (RW)
 *
 * ICV Size, in Bytes.
 */
/*@{*/
#define BP_LTC_K80_LTCICVSR_ICVS         (0U)      /*!< Bit position for LTC_K80_LTCICVSR_ICVS. */
#define BM_LTC_K80_LTCICVSR_ICVS         (0x0000001FU)  /*!< Bit mask for LTC_K80_LTCICVSR_ICVS. */
#define BS_LTC_K80_LTCICVSR_ICVS         (5U)  /*!< Bitfield size in bits for LTC_K80_LTCICVSR_ICVS. */

/*! @brief Read current value of the LTC_K80_LTCICVSR_ICVS field. */
#define BR_LTC_K80_LTCICVSR_ICVS(x)   (HW_LTC_K80_LTCICVSR(x).B.ICVS)

/*! @brief Format value for bitfield LTC_K80_LTCICVSR_ICVS. */
#define BF_LTC_K80_LTCICVSR_ICVS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCICVSR_ICVS) & BM_LTC_K80_LTCICVSR_ICVS)

/*! @brief Set the ICVS field to a new value. */
#define BW_LTC_K80_LTCICVSR_ICVS(x, v)   (HW_LTC_K80_LTCICVSR_WR(x, (HW_LTC_K80_LTCICVSR_RD(x) & ~BM_LTC_K80_LTCICVSR_ICVS) | BF_LTC_K80_LTCICVSR_ICVS(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCOM - LTC Command Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCOM - LTC Command Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC Command Register is used to send control signals to the Crypto Engines.
 */
typedef union _hw_ltc_k80_ltccom
{
    uint32_t U;
    struct _hw_ltc_k80_ltccom_bitfields
    {
        uint32_t ALL : 1; /*!< [0] Reset All Internal Logic. */
        uint32_t AES : 1; /*!< [1] Reset AESA. */
        uint32_t DES : 1; /*!< [2] Reset DESA. */
        uint32_t RESERVED1 : 3; /*!< [5:3] Reserved. */
        uint32_t PK : 1; /*!< [6] Reset PKHA. */
        uint32_t RESERVED8 : 25; /*!< [31:7] Reserved. */
    } B;
} hw_ltc_k80_ltccom_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCOM register
 */
/*@{*/
#define HW_LTC_K80_LTCCOM_ADDR(x)        ((x) + 0x30U)
#define HW_LTC_K80_LTCCOM(x)             (*(__IO hw_ltc_k80_ltccom_t *) HW_LTC_K80_LTCCOM_ADDR(x))
#define HW_LTC_K80_LTCCOM_RD(x)          (HW_LTC_K80_LTCCOM(x).U)
#define HW_LTC_K80_LTCCOM_WR(x, v)       (HW_LTC_K80_LTCCOM(x).U = (v))
#define HW_LTC_K80_LTCCOM_SET(x, v)      (HW_LTC_K80_LTCCOM_WR(x, HW_LTC_K80_LTCCOM_RD(x) |  (v)))
#define HW_LTC_K80_LTCCOM_CLR(x, v)      (HW_LTC_K80_LTCCOM_WR(x, HW_LTC_K80_LTCCOM_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCOM_TOG(x, v)      (HW_LTC_K80_LTCCOM_WR(x, HW_LTC_K80_LTCCOM_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCOM bitfields
 */

/*!
 * @name Register LTC_K80_LTCCOM, field ALL[0] (WO)
 *
 * Reset All Internal Logic. Writing to this bit will reset all accelerator engines and as well as
 * all the internal registers.
 *
 * Values:
 * - 0 - Do Not Reset
 * - 1 - Reset all CHAs in use by this CCB.
 */
/*@{*/
#define BP_LTC_K80_LTCCOM_ALL         (0U)      /*!< Bit position for LTC_K80_LTCCOM_ALL. */
#define BM_LTC_K80_LTCCOM_ALL         (0x00000001U)  /*!< Bit mask for LTC_K80_LTCCOM_ALL. */
#define BS_LTC_K80_LTCCOM_ALL         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCOM_ALL. */

/*! @brief Format value for bitfield LTC_K80_LTCCOM_ALL. */
#define BF_LTC_K80_LTCCOM_ALL(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCOM_ALL) & BM_LTC_K80_LTCCOM_ALL)

/*! @brief Set the ALL field to a new value. */
#define BW_LTC_K80_LTCCOM_ALL(x, v)   (HW_LTC_K80_LTCCOM_WR(x, (HW_LTC_K80_LTCCOM_RD(x) & ~BM_LTC_K80_LTCCOM_ALL) | BF_LTC_K80_LTCCOM_ALL(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCOM, field AES[1] (WO)
 *
 * Reset AESA. Writing a 1 to this bit resets the AES Accelerator core engine.
 *
 * Values:
 * - 0 - Do Not Reset
 * - 1 - Reset AES Accelerator
 */
/*@{*/
#define BP_LTC_K80_LTCCOM_AES         (1U)      /*!< Bit position for LTC_K80_LTCCOM_AES. */
#define BM_LTC_K80_LTCCOM_AES         (0x00000002U)  /*!< Bit mask for LTC_K80_LTCCOM_AES. */
#define BS_LTC_K80_LTCCOM_AES         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCOM_AES. */

/*! @brief Format value for bitfield LTC_K80_LTCCOM_AES. */
#define BF_LTC_K80_LTCCOM_AES(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCOM_AES) & BM_LTC_K80_LTCCOM_AES)

/*! @brief Set the AES field to a new value. */
#define BW_LTC_K80_LTCCOM_AES(x, v)   (HW_LTC_K80_LTCCOM_WR(x, (HW_LTC_K80_LTCCOM_RD(x) & ~BM_LTC_K80_LTCCOM_AES) | BF_LTC_K80_LTCCOM_AES(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCOM, field DES[2] (WO)
 *
 * Reset DESA. Writing a 1 to this bit resets the DES Accelerator.
 *
 * Values:
 * - 0 - Do Not Reset
 * - 1 - Reset DES Accelerator
 */
/*@{*/
#define BP_LTC_K80_LTCCOM_DES         (2U)      /*!< Bit position for LTC_K80_LTCCOM_DES. */
#define BM_LTC_K80_LTCCOM_DES         (0x00000004U)  /*!< Bit mask for LTC_K80_LTCCOM_DES. */
#define BS_LTC_K80_LTCCOM_DES         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCOM_DES. */

/*! @brief Format value for bitfield LTC_K80_LTCCOM_DES. */
#define BF_LTC_K80_LTCCOM_DES(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCOM_DES) & BM_LTC_K80_LTCCOM_DES)

/*! @brief Set the DES field to a new value. */
#define BW_LTC_K80_LTCCOM_DES(x, v)   (HW_LTC_K80_LTCCOM_WR(x, (HW_LTC_K80_LTCCOM_RD(x) & ~BM_LTC_K80_LTCCOM_DES) | BF_LTC_K80_LTCCOM_DES(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCOM, field PK[6] (WO)
 *
 * Reset PKHA. Writing a 1 to this bit resets the Public Key Hardware Accelerator.
 *
 * Values:
 * - 0 - Do Not Reset
 * - 1 - Reset Public Key Hardware Accelerator
 */
/*@{*/
#define BP_LTC_K80_LTCCOM_PK         (6U)      /*!< Bit position for LTC_K80_LTCCOM_PK. */
#define BM_LTC_K80_LTCCOM_PK         (0x00000040U)  /*!< Bit mask for LTC_K80_LTCCOM_PK. */
#define BS_LTC_K80_LTCCOM_PK         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCOM_PK. */

/*! @brief Format value for bitfield LTC_K80_LTCCOM_PK. */
#define BF_LTC_K80_LTCCOM_PK(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCOM_PK) & BM_LTC_K80_LTCCOM_PK)

/*! @brief Set the PK field to a new value. */
#define BW_LTC_K80_LTCCOM_PK(x, v)   (HW_LTC_K80_LTCCOM_WR(x, (HW_LTC_K80_LTCCOM_RD(x) & ~BM_LTC_K80_LTCCOM_PK) | BF_LTC_K80_LTCCOM_PK(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTL - LTC Control Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTL - LTC Control Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register is used for some of the internal controls of the LTC block.
 */
typedef union _hw_ltc_k80_ltcctl
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctl_bitfields
    {
        uint32_t IM : 1; /*!< [0] Interrupt Mask. */
        uint32_t RESERVED0 : 3; /*!< [3:1] Reserved. */
        uint32_t PDE : 1; /*!< [4] PKHA Register DMA Enable. */
        uint32_t RESERVED1 : 3; /*!< [7:5] Reserved. */
        uint32_t IFE : 1; /*!< [8] Input FIFO DMA Enable. */
        uint32_t IFR : 1; /*!< [9] Input FIFO DMA Request Size. */
        uint32_t RESERVED2 : 2; /*!< [11:10] Reserved. */
        uint32_t OFE : 1; /*!< [12] Output FIFO DMA Enable. */
        uint32_t OFR : 1; /*!< [13] Output FIFO DMA Request Size. */
        uint32_t RESERVED3 : 2; /*!< [15:14] Reserved. */
        uint32_t IFS : 1; /*!< [16] Input FIFO Byte Swap. */
        uint32_t OFS : 1; /*!< [17] Output FIFO Byte Swap. */
        uint32_t RESERVED4 : 2; /*!< [19:18] Reserved. */
        uint32_t KIS : 1; /*!< [20] Key Register Input Byte Swap. */
        uint32_t KOS : 1; /*!< [21] Key Register Output Byte Swap. */
        uint32_t CIS : 1; /*!< [22] Context Register Input Byte Swap. */
        uint32_t COS : 1; /*!< [23] Context Register Output Byte Swap. */
        uint32_t RESERVED5 : 7; /*!< [30:24] Reserved. */
        uint32_t KAL : 1; /*!< [31] Key Register Access Lock. */
    } B;
} hw_ltc_k80_ltcctl_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTL register
 */
/*@{*/
#define HW_LTC_K80_LTCCTL_ADDR(x)        ((x) + 0x34U)
#define HW_LTC_K80_LTCCTL(x)             (*(__IO hw_ltc_k80_ltcctl_t *) HW_LTC_K80_LTCCTL_ADDR(x))
#define HW_LTC_K80_LTCCTL_RD(x)          (HW_LTC_K80_LTCCTL(x).U)
#define HW_LTC_K80_LTCCTL_WR(x, v)       (HW_LTC_K80_LTCCTL(x).U = (v))
#define HW_LTC_K80_LTCCTL_SET(x, v)      (HW_LTC_K80_LTCCTL_WR(x, HW_LTC_K80_LTCCTL_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTL_CLR(x, v)      (HW_LTC_K80_LTCCTL_WR(x, HW_LTC_K80_LTCCTL_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTL_TOG(x, v)      (HW_LTC_K80_LTCCTL_WR(x, HW_LTC_K80_LTCCTL_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTL bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTL, field IM[0] (RW)
 *
 * Interrupt Mask. Once this bit is set, it can only be cleared by hard reset.
 *
 * Values:
 * - 0 - Interrupt not masked.
 * - 1 - Interrupt masked
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_IM         (0U)      /*!< Bit position for LTC_K80_LTCCTL_IM. */
#define BM_LTC_K80_LTCCTL_IM         (0x00000001U)  /*!< Bit mask for LTC_K80_LTCCTL_IM. */
#define BS_LTC_K80_LTCCTL_IM         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_IM. */

/*! @brief Read current value of the LTC_K80_LTCCTL_IM field. */
#define BR_LTC_K80_LTCCTL_IM(x)   (HW_LTC_K80_LTCCTL(x).B.IM)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_IM. */
#define BF_LTC_K80_LTCCTL_IM(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_IM) & BM_LTC_K80_LTCCTL_IM)

/*! @brief Set the IM field to a new value. */
#define BW_LTC_K80_LTCCTL_IM(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_IM) | BF_LTC_K80_LTCCTL_IM(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field PDE[4] (RW)
 *
 * PKHA Register DMA Enable.
 *
 * Values:
 * - 0 - DMA Request and Done signals disabled for the PKHA Registers.
 * - 1 - DMA Request and Done signals enabled for the PKHA Registers.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_PDE         (4U)      /*!< Bit position for LTC_K80_LTCCTL_PDE. */
#define BM_LTC_K80_LTCCTL_PDE         (0x00000010U)  /*!< Bit mask for LTC_K80_LTCCTL_PDE. */
#define BS_LTC_K80_LTCCTL_PDE         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_PDE. */

/*! @brief Read current value of the LTC_K80_LTCCTL_PDE field. */
#define BR_LTC_K80_LTCCTL_PDE(x)   (HW_LTC_K80_LTCCTL(x).B.PDE)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_PDE. */
#define BF_LTC_K80_LTCCTL_PDE(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_PDE) & BM_LTC_K80_LTCCTL_PDE)

/*! @brief Set the PDE field to a new value. */
#define BW_LTC_K80_LTCCTL_PDE(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_PDE) | BF_LTC_K80_LTCCTL_PDE(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field IFE[8] (RW)
 *
 * Input FIFO DMA Enable.
 *
 * Values:
 * - 0 - DMA Request and Done signals disabled for the Input FIFO.
 * - 1 - DMA Request and Done signals enabled for the Input FIFO.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_IFE         (8U)      /*!< Bit position for LTC_K80_LTCCTL_IFE. */
#define BM_LTC_K80_LTCCTL_IFE         (0x00000100U)  /*!< Bit mask for LTC_K80_LTCCTL_IFE. */
#define BS_LTC_K80_LTCCTL_IFE         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_IFE. */

/*! @brief Read current value of the LTC_K80_LTCCTL_IFE field. */
#define BR_LTC_K80_LTCCTL_IFE(x)   (HW_LTC_K80_LTCCTL(x).B.IFE)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_IFE. */
#define BF_LTC_K80_LTCCTL_IFE(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_IFE) & BM_LTC_K80_LTCCTL_IFE)

/*! @brief Set the IFE field to a new value. */
#define BW_LTC_K80_LTCCTL_IFE(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_IFE) | BF_LTC_K80_LTCCTL_IFE(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field IFR[9] (RW)
 *
 * Input FIFO DMA Request Size. The DMA request logic will only request data if the INPUT FIFO has
 * enough space for the request size.
 *
 * Values:
 * - 0 - DMA request size is 1 entry.
 * - 1 - DMA request size is 4 entries.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_IFR         (9U)      /*!< Bit position for LTC_K80_LTCCTL_IFR. */
#define BM_LTC_K80_LTCCTL_IFR         (0x00000200U)  /*!< Bit mask for LTC_K80_LTCCTL_IFR. */
#define BS_LTC_K80_LTCCTL_IFR         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_IFR. */

/*! @brief Read current value of the LTC_K80_LTCCTL_IFR field. */
#define BR_LTC_K80_LTCCTL_IFR(x)   (HW_LTC_K80_LTCCTL(x).B.IFR)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_IFR. */
#define BF_LTC_K80_LTCCTL_IFR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_IFR) & BM_LTC_K80_LTCCTL_IFR)

/*! @brief Set the IFR field to a new value. */
#define BW_LTC_K80_LTCCTL_IFR(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_IFR) | BF_LTC_K80_LTCCTL_IFR(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field OFE[12] (RW)
 *
 * Output FIFO DMA Enable.
 *
 * Values:
 * - 0 - DMA Request and Done signals disabled for the Output FIFO.
 * - 1 - DMA Request and Done signals enabled for the Output FIFO.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_OFE         (12U)      /*!< Bit position for LTC_K80_LTCCTL_OFE. */
#define BM_LTC_K80_LTCCTL_OFE         (0x00001000U)  /*!< Bit mask for LTC_K80_LTCCTL_OFE. */
#define BS_LTC_K80_LTCCTL_OFE         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_OFE. */

/*! @brief Read current value of the LTC_K80_LTCCTL_OFE field. */
#define BR_LTC_K80_LTCCTL_OFE(x)   (HW_LTC_K80_LTCCTL(x).B.OFE)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_OFE. */
#define BF_LTC_K80_LTCCTL_OFE(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_OFE) & BM_LTC_K80_LTCCTL_OFE)

/*! @brief Set the OFE field to a new value. */
#define BW_LTC_K80_LTCCTL_OFE(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_OFE) | BF_LTC_K80_LTCCTL_OFE(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field OFR[13] (RW)
 *
 * Output FIFO DMA Request Size. The DMA request logic will only request data if the OUTPUT FIFO has
 * enough data to satisfy the request.
 *
 * Values:
 * - 0 - DMA request size is 1 entry.
 * - 1 - DMA request size is 4 entries.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_OFR         (13U)      /*!< Bit position for LTC_K80_LTCCTL_OFR. */
#define BM_LTC_K80_LTCCTL_OFR         (0x00002000U)  /*!< Bit mask for LTC_K80_LTCCTL_OFR. */
#define BS_LTC_K80_LTCCTL_OFR         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_OFR. */

/*! @brief Read current value of the LTC_K80_LTCCTL_OFR field. */
#define BR_LTC_K80_LTCCTL_OFR(x)   (HW_LTC_K80_LTCCTL(x).B.OFR)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_OFR. */
#define BF_LTC_K80_LTCCTL_OFR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_OFR) & BM_LTC_K80_LTCCTL_OFR)

/*! @brief Set the OFR field to a new value. */
#define BW_LTC_K80_LTCCTL_OFR(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_OFR) | BF_LTC_K80_LTCCTL_OFR(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field IFS[16] (RW)
 *
 * Input FIFO Byte Swap. Byte swap all data that is written to the Input FIFO.
 *
 * Values:
 * - 0 - Do Not Byte Swap Data.
 * - 1 - Byte Swap Data.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_IFS         (16U)      /*!< Bit position for LTC_K80_LTCCTL_IFS. */
#define BM_LTC_K80_LTCCTL_IFS         (0x00010000U)  /*!< Bit mask for LTC_K80_LTCCTL_IFS. */
#define BS_LTC_K80_LTCCTL_IFS         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_IFS. */

/*! @brief Read current value of the LTC_K80_LTCCTL_IFS field. */
#define BR_LTC_K80_LTCCTL_IFS(x)   (HW_LTC_K80_LTCCTL(x).B.IFS)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_IFS. */
#define BF_LTC_K80_LTCCTL_IFS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_IFS) & BM_LTC_K80_LTCCTL_IFS)

/*! @brief Set the IFS field to a new value. */
#define BW_LTC_K80_LTCCTL_IFS(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_IFS) | BF_LTC_K80_LTCCTL_IFS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field OFS[17] (RW)
 *
 * Output FIFO Byte Swap. Byte swap all data that is read from the Onput FIFO.
 *
 * Values:
 * - 0 - Do Not Byte Swap Data.
 * - 1 - Byte Swap Data.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_OFS         (17U)      /*!< Bit position for LTC_K80_LTCCTL_OFS. */
#define BM_LTC_K80_LTCCTL_OFS         (0x00020000U)  /*!< Bit mask for LTC_K80_LTCCTL_OFS. */
#define BS_LTC_K80_LTCCTL_OFS         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_OFS. */

/*! @brief Read current value of the LTC_K80_LTCCTL_OFS field. */
#define BR_LTC_K80_LTCCTL_OFS(x)   (HW_LTC_K80_LTCCTL(x).B.OFS)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_OFS. */
#define BF_LTC_K80_LTCCTL_OFS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_OFS) & BM_LTC_K80_LTCCTL_OFS)

/*! @brief Set the OFS field to a new value. */
#define BW_LTC_K80_LTCCTL_OFS(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_OFS) | BF_LTC_K80_LTCCTL_OFS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field KIS[20] (RW)
 *
 * Key Register Input Byte Swap. Byte swap all data that is written to the key register. Data is
 * byte swapped only within a single word.
 *
 * Values:
 * - 0 - Do Not Byte Swap Data.
 * - 1 - Byte Swap Data.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_KIS         (20U)      /*!< Bit position for LTC_K80_LTCCTL_KIS. */
#define BM_LTC_K80_LTCCTL_KIS         (0x00100000U)  /*!< Bit mask for LTC_K80_LTCCTL_KIS. */
#define BS_LTC_K80_LTCCTL_KIS         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_KIS. */

/*! @brief Read current value of the LTC_K80_LTCCTL_KIS field. */
#define BR_LTC_K80_LTCCTL_KIS(x)   (HW_LTC_K80_LTCCTL(x).B.KIS)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_KIS. */
#define BF_LTC_K80_LTCCTL_KIS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_KIS) & BM_LTC_K80_LTCCTL_KIS)

/*! @brief Set the KIS field to a new value. */
#define BW_LTC_K80_LTCCTL_KIS(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_KIS) | BF_LTC_K80_LTCCTL_KIS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field KOS[21] (RW)
 *
 * Key Register Output Byte Swap. Byte swap all data that is read from the key register. Data is
 * byte swapped only within a single word.
 *
 * Values:
 * - 0 - Do Not Byte Swap Data.
 * - 1 - Byte Swap Data.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_KOS         (21U)      /*!< Bit position for LTC_K80_LTCCTL_KOS. */
#define BM_LTC_K80_LTCCTL_KOS         (0x00200000U)  /*!< Bit mask for LTC_K80_LTCCTL_KOS. */
#define BS_LTC_K80_LTCCTL_KOS         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_KOS. */

/*! @brief Read current value of the LTC_K80_LTCCTL_KOS field. */
#define BR_LTC_K80_LTCCTL_KOS(x)   (HW_LTC_K80_LTCCTL(x).B.KOS)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_KOS. */
#define BF_LTC_K80_LTCCTL_KOS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_KOS) & BM_LTC_K80_LTCCTL_KOS)

/*! @brief Set the KOS field to a new value. */
#define BW_LTC_K80_LTCCTL_KOS(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_KOS) | BF_LTC_K80_LTCCTL_KOS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field CIS[22] (RW)
 *
 * Context Register Input Byte Swap. Byte swap all data that is written to the context register.
 * Data is byte swapped only within a single word.
 *
 * Values:
 * - 0 - Do Not Byte Swap Data.
 * - 1 - Byte Swap Data.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_CIS         (22U)      /*!< Bit position for LTC_K80_LTCCTL_CIS. */
#define BM_LTC_K80_LTCCTL_CIS         (0x00400000U)  /*!< Bit mask for LTC_K80_LTCCTL_CIS. */
#define BS_LTC_K80_LTCCTL_CIS         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_CIS. */

/*! @brief Read current value of the LTC_K80_LTCCTL_CIS field. */
#define BR_LTC_K80_LTCCTL_CIS(x)   (HW_LTC_K80_LTCCTL(x).B.CIS)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_CIS. */
#define BF_LTC_K80_LTCCTL_CIS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_CIS) & BM_LTC_K80_LTCCTL_CIS)

/*! @brief Set the CIS field to a new value. */
#define BW_LTC_K80_LTCCTL_CIS(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_CIS) | BF_LTC_K80_LTCCTL_CIS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field COS[23] (RW)
 *
 * Context Register Output Byte Swap. Byte swap all data that is read from the context register.
 * Data is byte swapped only within a single word.
 *
 * Values:
 * - 0 - Do Not Byte Swap Data.
 * - 1 - Byte Swap Data.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_COS         (23U)      /*!< Bit position for LTC_K80_LTCCTL_COS. */
#define BM_LTC_K80_LTCCTL_COS         (0x00800000U)  /*!< Bit mask for LTC_K80_LTCCTL_COS. */
#define BS_LTC_K80_LTCCTL_COS         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_COS. */

/*! @brief Read current value of the LTC_K80_LTCCTL_COS field. */
#define BR_LTC_K80_LTCCTL_COS(x)   (HW_LTC_K80_LTCCTL(x).B.COS)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_COS. */
#define BF_LTC_K80_LTCCTL_COS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_COS) & BM_LTC_K80_LTCCTL_COS)

/*! @brief Set the COS field to a new value. */
#define BW_LTC_K80_LTCCTL_COS(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_COS) | BF_LTC_K80_LTCCTL_COS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCTL, field KAL[31] (RW)
 *
 * Key Register Access Lock. Read access to the key register is blocked. Any reads of the key
 * register will only return zero. Once this bit is set, it can only be cleared by hard reset.
 *
 * Values:
 * - 0 - Key Register is readable.
 * - 1 - Key Register is not readable.
 */
/*@{*/
#define BP_LTC_K80_LTCCTL_KAL         (31U)      /*!< Bit position for LTC_K80_LTCCTL_KAL. */
#define BM_LTC_K80_LTCCTL_KAL         (0x80000000U)  /*!< Bit mask for LTC_K80_LTCCTL_KAL. */
#define BS_LTC_K80_LTCCTL_KAL         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCTL_KAL. */

/*! @brief Read current value of the LTC_K80_LTCCTL_KAL field. */
#define BR_LTC_K80_LTCCTL_KAL(x)   (HW_LTC_K80_LTCCTL(x).B.KAL)

/*! @brief Format value for bitfield LTC_K80_LTCCTL_KAL. */
#define BF_LTC_K80_LTCCTL_KAL(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTL_KAL) & BM_LTC_K80_LTCCTL_KAL)

/*! @brief Set the KAL field to a new value. */
#define BW_LTC_K80_LTCCTL_KAL(x, v)   (HW_LTC_K80_LTCCTL_WR(x, (HW_LTC_K80_LTCCTL_RD(x) & ~BM_LTC_K80_LTCCTL_KAL) | BF_LTC_K80_LTCCTL_KAL(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCWR - LTC Clear Written Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCWR - LTC Clear Written Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Clear Written Register is used to clear many of the internal registers. All fields of this
 * register are self-clearing.
 */
typedef union _hw_ltc_k80_ltccwr
{
    uint32_t U;
    struct _hw_ltc_k80_ltccwr_bitfields
    {
        uint32_t CM : 1; /*!< [0] Clear the Mode Register. */
        uint32_t RESERVED0 : 1; /*!< [1] Reserved. */
        uint32_t CDS : 1; /*!< [2] Clear the Data Size Register. */
        uint32_t CICV : 1; /*!< [3] Clear the ICV Size Register. */
        uint32_t RESERVED1 : 1; /*!< [4] Reserved. */
        uint32_t CCR : 1; /*!< [5] Clear the Context Register. */
        uint32_t CKR : 1; /*!< [6] Clear the Key Register. */
        uint32_t RESERVED2 : 5; /*!< [11:7] Reserved. */
        uint32_t CPKA : 1; /*!< [12] Clear the PKHA A Size Register. */
        uint32_t CPKB : 1; /*!< [13] Clear the PKHA B Size Register. */
        uint32_t CPKN : 1; /*!< [14] Clear the PKHA N Size Register. */
        uint32_t CPKE : 1; /*!< [15] Clear the PKHA E Size Register. */
        uint32_t RESERVED3 : 14; /*!< [29:16] Reserved. */
        uint32_t COF : 1; /*!< [30] Clear Output FIFO. */
        uint32_t CIF : 1; /*!< [31] Clear Input FIFO. */
    } B;
} hw_ltc_k80_ltccwr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCWR register
 */
/*@{*/
#define HW_LTC_K80_LTCCWR_ADDR(x)        ((x) + 0x40U)
#define HW_LTC_K80_LTCCWR(x)             (*(__IO hw_ltc_k80_ltccwr_t *) HW_LTC_K80_LTCCWR_ADDR(x))
#define HW_LTC_K80_LTCCWR_RD(x)          (HW_LTC_K80_LTCCWR(x).U)
#define HW_LTC_K80_LTCCWR_WR(x, v)       (HW_LTC_K80_LTCCWR(x).U = (v))
#define HW_LTC_K80_LTCCWR_SET(x, v)      (HW_LTC_K80_LTCCWR_WR(x, HW_LTC_K80_LTCCWR_RD(x) |  (v)))
#define HW_LTC_K80_LTCCWR_CLR(x, v)      (HW_LTC_K80_LTCCWR_WR(x, HW_LTC_K80_LTCCWR_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCWR_TOG(x, v)      (HW_LTC_K80_LTCCWR_WR(x, HW_LTC_K80_LTCCWR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCWR bitfields
 */

/*!
 * @name Register LTC_K80_LTCCWR, field CM[0] (WO)
 *
 * Clear the Mode Register. Writing a one to this bit causes the Mode Register to be cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CM         (0U)      /*!< Bit position for LTC_K80_LTCCWR_CM. */
#define BM_LTC_K80_LTCCWR_CM         (0x00000001U)  /*!< Bit mask for LTC_K80_LTCCWR_CM. */
#define BS_LTC_K80_LTCCWR_CM         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CM. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CM. */
#define BF_LTC_K80_LTCCWR_CM(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CM) & BM_LTC_K80_LTCCWR_CM)

/*! @brief Set the CM field to a new value. */
#define BW_LTC_K80_LTCCWR_CM(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CM) | BF_LTC_K80_LTCCWR_CM(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CDS[2] (WO)
 *
 * Clear the Data Size Register. Writing a one to this bit causes the Data Size Register to be
 * cleared. This clears AAD Size as well.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CDS         (2U)      /*!< Bit position for LTC_K80_LTCCWR_CDS. */
#define BM_LTC_K80_LTCCWR_CDS         (0x00000004U)  /*!< Bit mask for LTC_K80_LTCCWR_CDS. */
#define BS_LTC_K80_LTCCWR_CDS         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CDS. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CDS. */
#define BF_LTC_K80_LTCCWR_CDS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CDS) & BM_LTC_K80_LTCCWR_CDS)

/*! @brief Set the CDS field to a new value. */
#define BW_LTC_K80_LTCCWR_CDS(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CDS) | BF_LTC_K80_LTCCWR_CDS(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CICV[3] (WO)
 *
 * Clear the ICV Size Register. Writing a one to this bit causes the ICV Size Register to be
 * cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CICV         (3U)      /*!< Bit position for LTC_K80_LTCCWR_CICV. */
#define BM_LTC_K80_LTCCWR_CICV         (0x00000008U)  /*!< Bit mask for LTC_K80_LTCCWR_CICV. */
#define BS_LTC_K80_LTCCWR_CICV         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CICV. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CICV. */
#define BF_LTC_K80_LTCCWR_CICV(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CICV) & BM_LTC_K80_LTCCWR_CICV)

/*! @brief Set the CICV field to a new value. */
#define BW_LTC_K80_LTCCWR_CICV(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CICV) | BF_LTC_K80_LTCCWR_CICV(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CCR[5] (WO)
 *
 * Clear the Context Register. Writing a one to this bit causes the Context Register to be cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CCR         (5U)      /*!< Bit position for LTC_K80_LTCCWR_CCR. */
#define BM_LTC_K80_LTCCWR_CCR         (0x00000020U)  /*!< Bit mask for LTC_K80_LTCCWR_CCR. */
#define BS_LTC_K80_LTCCWR_CCR         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CCR. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CCR. */
#define BF_LTC_K80_LTCCWR_CCR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CCR) & BM_LTC_K80_LTCCWR_CCR)

/*! @brief Set the CCR field to a new value. */
#define BW_LTC_K80_LTCCWR_CCR(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CCR) | BF_LTC_K80_LTCCWR_CCR(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CKR[6] (WO)
 *
 * Clear the Key Register. Writing a one to this bit causes the Key and Key Size Registers to be
 * cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CKR         (6U)      /*!< Bit position for LTC_K80_LTCCWR_CKR. */
#define BM_LTC_K80_LTCCWR_CKR         (0x00000040U)  /*!< Bit mask for LTC_K80_LTCCWR_CKR. */
#define BS_LTC_K80_LTCCWR_CKR         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CKR. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CKR. */
#define BF_LTC_K80_LTCCWR_CKR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CKR) & BM_LTC_K80_LTCCWR_CKR)

/*! @brief Set the CKR field to a new value. */
#define BW_LTC_K80_LTCCWR_CKR(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CKR) | BF_LTC_K80_LTCCWR_CKR(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CPKA[12] (WO)
 *
 * Clear the PKHA A Size Register. Writing a one to this bit causes the PKHA A Size Register to be
 * cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CPKA         (12U)      /*!< Bit position for LTC_K80_LTCCWR_CPKA. */
#define BM_LTC_K80_LTCCWR_CPKA         (0x00001000U)  /*!< Bit mask for LTC_K80_LTCCWR_CPKA. */
#define BS_LTC_K80_LTCCWR_CPKA         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CPKA. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CPKA. */
#define BF_LTC_K80_LTCCWR_CPKA(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CPKA) & BM_LTC_K80_LTCCWR_CPKA)

/*! @brief Set the CPKA field to a new value. */
#define BW_LTC_K80_LTCCWR_CPKA(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CPKA) | BF_LTC_K80_LTCCWR_CPKA(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CPKB[13] (WO)
 *
 * Clear the PKHA B Size Register. Writing a one to this bit causes the PKHA B Size Register to be
 * cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CPKB         (13U)      /*!< Bit position for LTC_K80_LTCCWR_CPKB. */
#define BM_LTC_K80_LTCCWR_CPKB         (0x00002000U)  /*!< Bit mask for LTC_K80_LTCCWR_CPKB. */
#define BS_LTC_K80_LTCCWR_CPKB         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CPKB. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CPKB. */
#define BF_LTC_K80_LTCCWR_CPKB(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CPKB) & BM_LTC_K80_LTCCWR_CPKB)

/*! @brief Set the CPKB field to a new value. */
#define BW_LTC_K80_LTCCWR_CPKB(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CPKB) | BF_LTC_K80_LTCCWR_CPKB(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CPKN[14] (WO)
 *
 * Clear the PKHA N Size Register. Writing a one to this bit causes the PKHA N Size Register to be
 * cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CPKN         (14U)      /*!< Bit position for LTC_K80_LTCCWR_CPKN. */
#define BM_LTC_K80_LTCCWR_CPKN         (0x00004000U)  /*!< Bit mask for LTC_K80_LTCCWR_CPKN. */
#define BS_LTC_K80_LTCCWR_CPKN         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CPKN. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CPKN. */
#define BF_LTC_K80_LTCCWR_CPKN(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CPKN) & BM_LTC_K80_LTCCWR_CPKN)

/*! @brief Set the CPKN field to a new value. */
#define BW_LTC_K80_LTCCWR_CPKN(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CPKN) | BF_LTC_K80_LTCCWR_CPKN(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CPKE[15] (WO)
 *
 * Clear the PKHA E Size Register. Writing a one to this bit causes the PKHA E Size Register to be
 * cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CPKE         (15U)      /*!< Bit position for LTC_K80_LTCCWR_CPKE. */
#define BM_LTC_K80_LTCCWR_CPKE         (0x00008000U)  /*!< Bit mask for LTC_K80_LTCCWR_CPKE. */
#define BS_LTC_K80_LTCCWR_CPKE         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CPKE. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CPKE. */
#define BF_LTC_K80_LTCCWR_CPKE(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CPKE) & BM_LTC_K80_LTCCWR_CPKE)

/*! @brief Set the CPKE field to a new value. */
#define BW_LTC_K80_LTCCWR_CPKE(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CPKE) | BF_LTC_K80_LTCCWR_CPKE(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field COF[30] (WO)
 *
 * Clear Output FIFO. Writing a 1 to this bit causes the Output FIFO to be cleared.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_COF         (30U)      /*!< Bit position for LTC_K80_LTCCWR_COF. */
#define BM_LTC_K80_LTCCWR_COF         (0x40000000U)  /*!< Bit mask for LTC_K80_LTCCWR_COF. */
#define BS_LTC_K80_LTCCWR_COF         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_COF. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_COF. */
#define BF_LTC_K80_LTCCWR_COF(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_COF) & BM_LTC_K80_LTCCWR_COF)

/*! @brief Set the COF field to a new value. */
#define BW_LTC_K80_LTCCWR_COF(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_COF) | BF_LTC_K80_LTCCWR_COF(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCCWR, field CIF[31] (WO)
 *
 * Clear Input FIFO. Writing a 1 to this bit causes the Input Data FIFO.
 */
/*@{*/
#define BP_LTC_K80_LTCCWR_CIF         (31U)      /*!< Bit position for LTC_K80_LTCCWR_CIF. */
#define BM_LTC_K80_LTCCWR_CIF         (0x80000000U)  /*!< Bit mask for LTC_K80_LTCCWR_CIF. */
#define BS_LTC_K80_LTCCWR_CIF         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCCWR_CIF. */

/*! @brief Format value for bitfield LTC_K80_LTCCWR_CIF. */
#define BF_LTC_K80_LTCCWR_CIF(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCWR_CIF) & BM_LTC_K80_LTCCWR_CIF)

/*! @brief Set the CIF field to a new value. */
#define BW_LTC_K80_LTCCWR_CIF(x, v)   (HW_LTC_K80_LTCCWR_WR(x, (HW_LTC_K80_LTCCWR_RD(x) & ~BM_LTC_K80_LTCCWR_CIF) | BF_LTC_K80_LTCCWR_CIF(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCSTA - LTC Status Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCSTA - LTC Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC Status Register shows the status of the internal Crypto engine and its internal
 * registers.
 */
typedef union _hw_ltc_k80_ltcsta
{
    uint32_t U;
    struct _hw_ltc_k80_ltcsta_bitfields
    {
        uint32_t RESERVED0 : 1; /*!< [0] Reserved. */
        uint32_t AB : 1; /*!< [1] AESA Busy. */
        uint32_t DB : 1; /*!< [2] DESA Busy. */
        uint32_t RESERVED2 : 3; /*!< [5:3] Reserved. */
        uint32_t PB : 1; /*!< [6] PKHA Busy. */
        uint32_t RESERVED7 : 9; /*!< [15:7] Reserved. */
        uint32_t DI : 1; /*!< [16] Done Interrupt. */
        uint32_t RESERVED8 : 3; /*!< [19:17] Reserved. */
        uint32_t EI : 1; /*!< [20] Error Interrupt. */
        uint32_t RESERVED9 : 7; /*!< [27:21] Reserved. */
        uint32_t PKP : 1; /*!< [28] Public Key is Prime. */
        uint32_t PKO : 1; /*!< [29] Public Key Operation is One. */
        uint32_t PKZ : 1; /*!< [30] Public Key Operation is Zero. */
        uint32_t RESERVED10 : 1; /*!< [31] Reserved. */
    } B;
} hw_ltc_k80_ltcsta_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCSTA register
 */
/*@{*/
#define HW_LTC_K80_LTCSTA_ADDR(x)        ((x) + 0x48U)
#define HW_LTC_K80_LTCSTA(x)             (*(__IO hw_ltc_k80_ltcsta_t *) HW_LTC_K80_LTCSTA_ADDR(x))
#define HW_LTC_K80_LTCSTA_RD(x)          (HW_LTC_K80_LTCSTA(x).U)
#define HW_LTC_K80_LTCSTA_WR(x, v)       (HW_LTC_K80_LTCSTA(x).U = (v))
#define HW_LTC_K80_LTCSTA_SET(x, v)      (HW_LTC_K80_LTCSTA_WR(x, HW_LTC_K80_LTCSTA_RD(x) |  (v)))
#define HW_LTC_K80_LTCSTA_CLR(x, v)      (HW_LTC_K80_LTCSTA_WR(x, HW_LTC_K80_LTCSTA_RD(x) & ~(v)))
#define HW_LTC_K80_LTCSTA_TOG(x, v)      (HW_LTC_K80_LTCSTA_WR(x, HW_LTC_K80_LTCSTA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCSTA bitfields
 */

/*!
 * @name Register LTC_K80_LTCSTA, field AB[1] (RO)
 *
 * AESA Busy. This bit indicates that the AES Accelertor is busy. The CHA can either be busy
 * processing data or resetting.
 *
 * Values:
 * - 0 - AESA Idle
 * - 1 - AESA Busy.
 */
/*@{*/
#define BP_LTC_K80_LTCSTA_AB         (1U)      /*!< Bit position for LTC_K80_LTCSTA_AB. */
#define BM_LTC_K80_LTCSTA_AB         (0x00000002U)  /*!< Bit mask for LTC_K80_LTCSTA_AB. */
#define BS_LTC_K80_LTCSTA_AB         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCSTA_AB. */

/*! @brief Read current value of the LTC_K80_LTCSTA_AB field. */
#define BR_LTC_K80_LTCSTA_AB(x)   (HW_LTC_K80_LTCSTA(x).B.AB)
/*@}*/

/*!
 * @name Register LTC_K80_LTCSTA, field DB[2] (RO)
 *
 * DESA Busy. This bit indicates that the DES Accelerator is busy. The CHA can either be busy
 * processing data or resetting.
 *
 * Values:
 * - 0 - DESA Idle
 * - 1 - DESA Busy.
 */
/*@{*/
#define BP_LTC_K80_LTCSTA_DB         (2U)      /*!< Bit position for LTC_K80_LTCSTA_DB. */
#define BM_LTC_K80_LTCSTA_DB         (0x00000004U)  /*!< Bit mask for LTC_K80_LTCSTA_DB. */
#define BS_LTC_K80_LTCSTA_DB         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCSTA_DB. */

/*! @brief Read current value of the LTC_K80_LTCSTA_DB field. */
#define BR_LTC_K80_LTCSTA_DB(x)   (HW_LTC_K80_LTCSTA(x).B.DB)
/*@}*/

/*!
 * @name Register LTC_K80_LTCSTA, field PB[6] (RO)
 *
 * PKHA Busy. This bit indicates that the Public Key Hardware Accelerator is busy. The CHA can
 * either be busy processing data or resetting.
 *
 * Values:
 * - 0 - PKHA Idle
 * - 1 - PKHA Busy.
 */
/*@{*/
#define BP_LTC_K80_LTCSTA_PB         (6U)      /*!< Bit position for LTC_K80_LTCSTA_PB. */
#define BM_LTC_K80_LTCSTA_PB         (0x00000040U)  /*!< Bit mask for LTC_K80_LTCSTA_PB. */
#define BS_LTC_K80_LTCSTA_PB         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCSTA_PB. */

/*! @brief Read current value of the LTC_K80_LTCSTA_PB field. */
#define BR_LTC_K80_LTCSTA_PB(x)   (HW_LTC_K80_LTCSTA(x).B.PB)
/*@}*/

/*!
 * @name Register LTC_K80_LTCSTA, field DI[16] (W1C)
 *
 * Done Interrupt. The Done Interrupt has been asserted. Value Read Write 0 No Done Interrupt No
 * change 1 Done Interrupt asserted Clear the Done Interrupt
 */
/*@{*/
#define BP_LTC_K80_LTCSTA_DI         (16U)      /*!< Bit position for LTC_K80_LTCSTA_DI. */
#define BM_LTC_K80_LTCSTA_DI         (0x00010000U)  /*!< Bit mask for LTC_K80_LTCSTA_DI. */
#define BS_LTC_K80_LTCSTA_DI         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCSTA_DI. */

/*! @brief Read current value of the LTC_K80_LTCSTA_DI field. */
#define BR_LTC_K80_LTCSTA_DI(x)   (HW_LTC_K80_LTCSTA(x).B.DI)

/*! @brief Format value for bitfield LTC_K80_LTCSTA_DI. */
#define BF_LTC_K80_LTCSTA_DI(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCSTA_DI) & BM_LTC_K80_LTCSTA_DI)

/*! @brief Set the DI field to a new value. */
#define BW_LTC_K80_LTCSTA_DI(x, v)   (HW_LTC_K80_LTCSTA_WR(x, (HW_LTC_K80_LTCSTA_RD(x) & ~BM_LTC_K80_LTCSTA_DI) | BF_LTC_K80_LTCSTA_DI(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCSTA, field EI[20] (RO)
 *
 * Error Interrupt. The Error Interrupt has been asserted. This error can only be cleared by
 * resetting LTC.
 *
 * Values:
 * - 0 - Not Error.
 * - 1 - Error Interrupt.
 */
/*@{*/
#define BP_LTC_K80_LTCSTA_EI         (20U)      /*!< Bit position for LTC_K80_LTCSTA_EI. */
#define BM_LTC_K80_LTCSTA_EI         (0x00100000U)  /*!< Bit mask for LTC_K80_LTCSTA_EI. */
#define BS_LTC_K80_LTCSTA_EI         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCSTA_EI. */

/*! @brief Read current value of the LTC_K80_LTCSTA_EI field. */
#define BR_LTC_K80_LTCSTA_EI(x)   (HW_LTC_K80_LTCSTA(x).B.EI)
/*@}*/

/*!
 * @name Register LTC_K80_LTCSTA, field PKP[28] (RO)
 *
 * Public Key is Prime. The given number is probably prime (that is, it passes the Miller-Rabin
 * primality test).
 */
/*@{*/
#define BP_LTC_K80_LTCSTA_PKP         (28U)      /*!< Bit position for LTC_K80_LTCSTA_PKP. */
#define BM_LTC_K80_LTCSTA_PKP         (0x10000000U)  /*!< Bit mask for LTC_K80_LTCSTA_PKP. */
#define BS_LTC_K80_LTCSTA_PKP         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCSTA_PKP. */

/*! @brief Read current value of the LTC_K80_LTCSTA_PKP field. */
#define BR_LTC_K80_LTCSTA_PKP(x)   (HW_LTC_K80_LTCSTA(x).B.PKP)
/*@}*/

/*!
 * @name Register LTC_K80_LTCSTA, field PKO[29] (RO)
 *
 * Public Key Operation is One. The greatest common divisor of two numbers is one (that is, the two
 * numbers are relatively prime) for GCD operation, or PKHA result = 1 for Finite Field operations.
 */
/*@{*/
#define BP_LTC_K80_LTCSTA_PKO         (29U)      /*!< Bit position for LTC_K80_LTCSTA_PKO. */
#define BM_LTC_K80_LTCSTA_PKO         (0x20000000U)  /*!< Bit mask for LTC_K80_LTCSTA_PKO. */
#define BS_LTC_K80_LTCSTA_PKO         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCSTA_PKO. */

/*! @brief Read current value of the LTC_K80_LTCSTA_PKO field. */
#define BR_LTC_K80_LTCSTA_PKO(x)   (HW_LTC_K80_LTCSTA(x).B.PKO)
/*@}*/

/*!
 * @name Register LTC_K80_LTCSTA, field PKZ[30] (RO)
 *
 * Public Key Operation is Zero. For Finite Field operations the result of a Public Key operation is
 * zero. For ECC operations, the result is Point at infinity.
 */
/*@{*/
#define BP_LTC_K80_LTCSTA_PKZ         (30U)      /*!< Bit position for LTC_K80_LTCSTA_PKZ. */
#define BM_LTC_K80_LTCSTA_PKZ         (0x40000000U)  /*!< Bit mask for LTC_K80_LTCSTA_PKZ. */
#define BS_LTC_K80_LTCSTA_PKZ         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCSTA_PKZ. */

/*! @brief Read current value of the LTC_K80_LTCSTA_PKZ field. */
#define BR_LTC_K80_LTCSTA_PKZ(x)   (HW_LTC_K80_LTCSTA(x).B.PKZ)
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCESTA - LTC Error Status Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCESTA - LTC Error Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC Error Register shows the status of the internal Crypto Engine and its internal registers.
 */
typedef union _hw_ltc_k80_ltcesta
{
    uint32_t U;
    struct _hw_ltc_k80_ltcesta_bitfields
    {
        uint32_t ERRID1 : 4; /*!< [3:0] Error ID 1. */
        uint32_t RESERVED0 : 4; /*!< [7:4] Reserved */
        uint32_t CL1 : 4; /*!< [11:8] algorithms. */
        uint32_t RESERVED1 : 20; /*!< [31:12] Reserved. */
    } B;
} hw_ltc_k80_ltcesta_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCESTA register
 */
/*@{*/
#define HW_LTC_K80_LTCESTA_ADDR(x)        ((x) + 0x4CU)
#define HW_LTC_K80_LTCESTA(x)             (*(__IO hw_ltc_k80_ltcesta_t *) HW_LTC_K80_LTCESTA_ADDR(x))
#define HW_LTC_K80_LTCESTA_RD(x)          (HW_LTC_K80_LTCESTA(x).U)
#define HW_LTC_K80_LTCESTA_WR(x, v)       (HW_LTC_K80_LTCESTA(x).U = (v))
#define HW_LTC_K80_LTCESTA_SET(x, v)      (HW_LTC_K80_LTCESTA_WR(x, HW_LTC_K80_LTCESTA_RD(x) |  (v)))
#define HW_LTC_K80_LTCESTA_CLR(x, v)      (HW_LTC_K80_LTCESTA_WR(x, HW_LTC_K80_LTCESTA_RD(x) & ~(v)))
#define HW_LTC_K80_LTCESTA_TOG(x, v)      (HW_LTC_K80_LTCESTA_WR(x, HW_LTC_K80_LTCESTA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCESTA bitfields
 */

/*!
 * @name Register LTC_K80_LTCESTA, field ERRID1[3:0] (RO)
 *
 * Error ID 1. These bits indicate the type of error that was found while processing the Descriptor.
 * The Algorithm that is associated with the error can be found in the CL1 field. Others reserved.
 *
 * Values:
 * - 0001 - Mode Error
 * - 0010 - Data Size Error, including PKHA N Register Size Error
 * - 0011 - Key Size Error, including PKHA E Register Size Error
 * - 0100 - PKHA A Register Size Error
 * - 0101 - PKHA B Register Size Error
 * - 0110 - Data Arrived out of Sequence Error
 * - 0111 - PKHA Divide by Zero Error
 * - 1000 - PKHA Modulus Even Error
 * - 1001 - DES Key Parity Error
 * - 1010 - ICV Check Failed
 * - 1011 - Internal Hardware Failure
 * - 1100 - CCM AAD Size Error (either 1. AAD flag in B0 =1 and no AAD type provided, 2. AAD flag in B0 = 0 and
 *     AAD povided, or 3. AAD flag in B0 =1 and not enough AAD provided - expecting more based on
 *     AAD size.)
 * - 1111 - Invalid Crypto Engine Selected
 */
/*@{*/
#define BP_LTC_K80_LTCESTA_ERRID1         (0U)      /*!< Bit position for LTC_K80_LTCESTA_ERRID1. */
#define BM_LTC_K80_LTCESTA_ERRID1         (0x0000000FU)  /*!< Bit mask for LTC_K80_LTCESTA_ERRID1. */
#define BS_LTC_K80_LTCESTA_ERRID1         (4U)  /*!< Bitfield size in bits for LTC_K80_LTCESTA_ERRID1. */

/*! @brief Read current value of the LTC_K80_LTCESTA_ERRID1 field. */
#define BR_LTC_K80_LTCESTA_ERRID1(x)   (HW_LTC_K80_LTCESTA(x).B.ERRID1)
/*@}*/

/*!
 * @name Register LTC_K80_LTCESTA, field CL1[11:8] (RO)
 *
 * algorithms. The algorithms field indicates which algorithm is asserting an error. Others reserved
 *
 * Values:
 * - 0000 - LTC General Error
 * - 0001 - AES
 * - 0010 - DES
 * - 1000 - Public Key
 */
/*@{*/
#define BP_LTC_K80_LTCESTA_CL1         (8U)      /*!< Bit position for LTC_K80_LTCESTA_CL1. */
#define BM_LTC_K80_LTCESTA_CL1         (0x00000F00U)  /*!< Bit mask for LTC_K80_LTCESTA_CL1. */
#define BS_LTC_K80_LTCESTA_CL1         (4U)  /*!< Bitfield size in bits for LTC_K80_LTCESTA_CL1. */

/*! @brief Read current value of the LTC_K80_LTCESTA_CL1 field. */
#define BR_LTC_K80_LTCESTA_CL1(x)   (HW_LTC_K80_LTCESTA(x).B.CL1)
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCAADSZR - LTC AAD Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCAADSZR - LTC AAD Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The AAD Size Register is used by AESA to determine how much of the last block of AAD is valid.
 * The write to this register should be the entire size of the AAD as it is also added directly to
 * the Data Size Register. The size added to the Data Size Register is the AAD size rounded up to
 * the next 16 byte boundary. For instance a size of 20 bytes written to the AAD size register will
 * cause 32 bytes to be added to the Data Size Register. The size stored in the AASZ field
 * represents the number of bytes valid in the final block of AAD. However the entire size of AAD
 * should be written to the LTCAADSZR address location. When authentication only is being done then
 * the AL bit needs to be written to tell the AES engine that this is the last of the data.
 */
typedef union _hw_ltc_k80_ltcaadszr
{
    uint32_t U;
    struct _hw_ltc_k80_ltcaadszr_bitfields
    {
        uint32_t AADSZ : 4; /*!< [3:0] AAD size in Bytes, mod 16. */
        uint32_t RESERVED0 : 27; /*!< [30:4] Reserved. */
        uint32_t AL : 1; /*!< [31] AAD Last. */
    } B;
} hw_ltc_k80_ltcaadszr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCAADSZR register
 */
/*@{*/
#define HW_LTC_K80_LTCAADSZR_ADDR(x)        ((x) + 0x58U)
#define HW_LTC_K80_LTCAADSZR(x)             (*(__IO hw_ltc_k80_ltcaadszr_t *) HW_LTC_K80_LTCAADSZR_ADDR(x))
#define HW_LTC_K80_LTCAADSZR_RD(x)          (HW_LTC_K80_LTCAADSZR(x).U)
#define HW_LTC_K80_LTCAADSZR_WR(x, v)       (HW_LTC_K80_LTCAADSZR(x).U = (v))
#define HW_LTC_K80_LTCAADSZR_SET(x, v)      (HW_LTC_K80_LTCAADSZR_WR(x, HW_LTC_K80_LTCAADSZR_RD(x) |  (v)))
#define HW_LTC_K80_LTCAADSZR_CLR(x, v)      (HW_LTC_K80_LTCAADSZR_WR(x, HW_LTC_K80_LTCAADSZR_RD(x) & ~(v)))
#define HW_LTC_K80_LTCAADSZR_TOG(x, v)      (HW_LTC_K80_LTCAADSZR_WR(x, HW_LTC_K80_LTCAADSZR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCAADSZR bitfields
 */

/*!
 * @name Register LTC_K80_LTCAADSZR, field AADSZ[3:0] (RW)
 *
 * AAD size in Bytes, mod 16.
 */
/*@{*/
#define BP_LTC_K80_LTCAADSZR_AADSZ         (0U)      /*!< Bit position for LTC_K80_LTCAADSZR_AADSZ. */
#define BM_LTC_K80_LTCAADSZR_AADSZ         (0x0000000FU)  /*!< Bit mask for LTC_K80_LTCAADSZR_AADSZ. */
#define BS_LTC_K80_LTCAADSZR_AADSZ         (4U)  /*!< Bitfield size in bits for LTC_K80_LTCAADSZR_AADSZ. */

/*! @brief Read current value of the LTC_K80_LTCAADSZR_AADSZ field. */
#define BR_LTC_K80_LTCAADSZR_AADSZ(x)   (HW_LTC_K80_LTCAADSZR(x).B.AADSZ)

/*! @brief Format value for bitfield LTC_K80_LTCAADSZR_AADSZ. */
#define BF_LTC_K80_LTCAADSZR_AADSZ(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCAADSZR_AADSZ) & BM_LTC_K80_LTCAADSZR_AADSZ)

/*! @brief Set the AADSZ field to a new value. */
#define BW_LTC_K80_LTCAADSZR_AADSZ(x, v)   (HW_LTC_K80_LTCAADSZR_WR(x, (HW_LTC_K80_LTCAADSZR_RD(x) & ~BM_LTC_K80_LTCAADSZR_AADSZ) | BF_LTC_K80_LTCAADSZR_AADSZ(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCAADSZR, field AL[31] (RW)
 *
 * AAD Last. Only AAD data will be written into the Input FIFO.
 */
/*@{*/
#define BP_LTC_K80_LTCAADSZR_AL         (31U)      /*!< Bit position for LTC_K80_LTCAADSZR_AL. */
#define BM_LTC_K80_LTCAADSZR_AL         (0x80000000U)  /*!< Bit mask for LTC_K80_LTCAADSZR_AL. */
#define BS_LTC_K80_LTCAADSZR_AL         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCAADSZR_AL. */

/*! @brief Read current value of the LTC_K80_LTCAADSZR_AL field. */
#define BR_LTC_K80_LTCAADSZR_AL(x)   (HW_LTC_K80_LTCAADSZR(x).B.AL)

/*! @brief Format value for bitfield LTC_K80_LTCAADSZR_AL. */
#define BF_LTC_K80_LTCAADSZR_AL(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCAADSZR_AL) & BM_LTC_K80_LTCAADSZR_AL)

/*! @brief Set the AL field to a new value. */
#define BW_LTC_K80_LTCAADSZR_AL(x, v)   (HW_LTC_K80_LTCAADSZR_WR(x, (HW_LTC_K80_LTCAADSZR_RD(x) & ~BM_LTC_K80_LTCAADSZR_AL) | BF_LTC_K80_LTCAADSZR_AL(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCIVSZR - LTC IV Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCIVSZR - LTC IV Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The IV Size Register is used by AESA to determine how much of the last block of IV is valid. The
 * write to this register should be the entire size of the IV as it is also added directly to the
 * Data Size Register. The size added to the Data Size Register is the IV size rounded up to the
 * next 16 byte boundary. For instance a size of 20 bytes written to the IV size register will cause
 * 32 bytes to be added to the Data Size Register. The size stored in the IVSZ field represents the
 * number of bytes valid in the final block of IV. However the entire size of IV should be written
 * to the LTCIVSZR address location. When IV only is being done then the IL bit needs to be written
 * to tell the AES engine that this is the last of the data.
 */
typedef union _hw_ltc_k80_ltcivszr
{
    uint32_t U;
    struct _hw_ltc_k80_ltcivszr_bitfields
    {
        uint32_t IVSZ : 4; /*!< [3:0] IV size in Bytes, mod 16. */
        uint32_t RESERVED0 : 27; /*!< [30:4] Reserved. */
        uint32_t IL : 1; /*!< [31] IV Last. */
    } B;
} hw_ltc_k80_ltcivszr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCIVSZR register
 */
/*@{*/
#define HW_LTC_K80_LTCIVSZR_ADDR(x)        ((x) + 0x60U)
#define HW_LTC_K80_LTCIVSZR(x)             (*(__IO hw_ltc_k80_ltcivszr_t *) HW_LTC_K80_LTCIVSZR_ADDR(x))
#define HW_LTC_K80_LTCIVSZR_RD(x)          (HW_LTC_K80_LTCIVSZR(x).U)
#define HW_LTC_K80_LTCIVSZR_WR(x, v)       (HW_LTC_K80_LTCIVSZR(x).U = (v))
#define HW_LTC_K80_LTCIVSZR_SET(x, v)      (HW_LTC_K80_LTCIVSZR_WR(x, HW_LTC_K80_LTCIVSZR_RD(x) |  (v)))
#define HW_LTC_K80_LTCIVSZR_CLR(x, v)      (HW_LTC_K80_LTCIVSZR_WR(x, HW_LTC_K80_LTCIVSZR_RD(x) & ~(v)))
#define HW_LTC_K80_LTCIVSZR_TOG(x, v)      (HW_LTC_K80_LTCIVSZR_WR(x, HW_LTC_K80_LTCIVSZR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCIVSZR bitfields
 */

/*!
 * @name Register LTC_K80_LTCIVSZR, field IVSZ[3:0] (RW)
 *
 * IV size in Bytes, mod 16.
 */
/*@{*/
#define BP_LTC_K80_LTCIVSZR_IVSZ         (0U)      /*!< Bit position for LTC_K80_LTCIVSZR_IVSZ. */
#define BM_LTC_K80_LTCIVSZR_IVSZ         (0x0000000FU)  /*!< Bit mask for LTC_K80_LTCIVSZR_IVSZ. */
#define BS_LTC_K80_LTCIVSZR_IVSZ         (4U)  /*!< Bitfield size in bits for LTC_K80_LTCIVSZR_IVSZ. */

/*! @brief Read current value of the LTC_K80_LTCIVSZR_IVSZ field. */
#define BR_LTC_K80_LTCIVSZR_IVSZ(x)   (HW_LTC_K80_LTCIVSZR(x).B.IVSZ)

/*! @brief Format value for bitfield LTC_K80_LTCIVSZR_IVSZ. */
#define BF_LTC_K80_LTCIVSZR_IVSZ(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCIVSZR_IVSZ) & BM_LTC_K80_LTCIVSZR_IVSZ)

/*! @brief Set the IVSZ field to a new value. */
#define BW_LTC_K80_LTCIVSZR_IVSZ(x, v)   (HW_LTC_K80_LTCIVSZR_WR(x, (HW_LTC_K80_LTCIVSZR_RD(x) & ~BM_LTC_K80_LTCIVSZR_IVSZ) | BF_LTC_K80_LTCIVSZR_IVSZ(v)))
/*@}*/

/*!
 * @name Register LTC_K80_LTCIVSZR, field IL[31] (RW)
 *
 * IV Last. Only IV data will be written into the Input FIFO.
 */
/*@{*/
#define BP_LTC_K80_LTCIVSZR_IL         (31U)      /*!< Bit position for LTC_K80_LTCIVSZR_IL. */
#define BM_LTC_K80_LTCIVSZR_IL         (0x80000000U)  /*!< Bit mask for LTC_K80_LTCIVSZR_IL. */
#define BS_LTC_K80_LTCIVSZR_IL         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCIVSZR_IL. */

/*! @brief Read current value of the LTC_K80_LTCIVSZR_IL field. */
#define BR_LTC_K80_LTCIVSZR_IL(x)   (HW_LTC_K80_LTCIVSZR(x).B.IL)

/*! @brief Format value for bitfield LTC_K80_LTCIVSZR_IL. */
#define BF_LTC_K80_LTCIVSZR_IL(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCIVSZR_IL) & BM_LTC_K80_LTCIVSZR_IL)

/*! @brief Set the IL field to a new value. */
#define BW_LTC_K80_LTCIVSZR_IL(x, v)   (HW_LTC_K80_LTCIVSZR_WR(x, (HW_LTC_K80_LTCIVSZR_RD(x) & ~BM_LTC_K80_LTCIVSZR_IL) | BF_LTC_K80_LTCIVSZR_IL(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCDPAMSR - LTC DPA Mask Seed Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCDPAMSR - LTC DPA Mask Seed Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The DPA Mask Seed Register is used to reseed the mask that provides resistance against
 * Differential Power Analysis attacks on AES keys.
 */
typedef union _hw_ltc_k80_ltcdpamsr
{
    uint32_t U;
    struct _hw_ltc_k80_ltcdpamsr_bitfields
    {
        uint32_t DPAMS : 32; /*!< [31:0] Differential Power Analysis Mask Seed.This resistance uses a randomly changing mask that introduces "noise" into the power consumed by the AESA. */
    } B;
} hw_ltc_k80_ltcdpamsr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCDPAMSR register
 */
/*@{*/
#define HW_LTC_K80_LTCDPAMSR_ADDR(x)        ((x) + 0x68U)
#define HW_LTC_K80_LTCDPAMSR(x)             (*(__O  hw_ltc_k80_ltcdpamsr_t *) HW_LTC_K80_LTCDPAMSR_ADDR(x))
#define HW_LTC_K80_LTCDPAMSR_WR(x, v)       (HW_LTC_K80_LTCDPAMSR(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCDPAMSR bitfields
 */

/*!
 * @name Register LTC_K80_LTCDPAMSR, field DPAMS[31:0] (WO)
 *
 * Differential Power Analysis Mask Seed.This resistance uses a randomly changing mask that
 * introduces "noise" into the power consumed by the AESA. This reduces the signal to noise ratio
 * that differential power analysis attacks use to "guess" bits of the AES key. This randomly
 * changing mask should be seeded at POR, and will continue to provide DPA resistance thereafter.
 * However, to provide even more DPA protection it is recommended that the DPA Mask be reseeded
 * after every 100 000 AESA blocks have been processed. At that time software can opt to write a new
 * seed (preferably obtained from an RNG) into the DPA Mask Seed Register (DPAMS), or software can
 * instead opt to provide new seed earlier or later, or not at all. DPA resistance continues even if
 * the DPA Mask is never reseeded.
 */
/*@{*/
#define BP_LTC_K80_LTCDPAMSR_DPAMS         (0U)      /*!< Bit position for LTC_K80_LTCDPAMSR_DPAMS. */
#define BM_LTC_K80_LTCDPAMSR_DPAMS         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCDPAMSR_DPAMS. */
#define BS_LTC_K80_LTCDPAMSR_DPAMS         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCDPAMSR_DPAMS. */

/*! @brief Format value for bitfield LTC_K80_LTCDPAMSR_DPAMS. */
#define BF_LTC_K80_LTCDPAMSR_DPAMS(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCDPAMSR_DPAMS) & BM_LTC_K80_LTCDPAMSR_DPAMS)

/*! @brief Set the DPAMS field to a new value. */
#define BW_LTC_K80_LTCDPAMSR_DPAMS(x, v)   (HW_LTC_K80_LTCDPAMSR_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKASZR - LTC PKHA A Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKASZR - LTC PKHA A Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A Size Register is used to indicate the number of bytes of valid data in the PKHA A
 * Register. That is, it indicates the size, in bytes, of the numeric value contained in the PKHA A
 * Register. Depending on the PKHA operation to be run, this register may need to be loaded prior to
 * starting the PKHA operation. Note that some PKHA operations update this value at the completion
 * of the operation.
 */
typedef union _hw_ltc_k80_lpkaszr
{
    uint32_t U;
    struct _hw_ltc_k80_lpkaszr_bitfields
    {
        uint32_t PKASZ : 9; /*!< [8:0] PKHA A Size. */
        uint32_t RESERVED0 : 23; /*!< [31:9] Reserved. */
    } B;
} hw_ltc_k80_lpkaszr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKASZR register
 */
/*@{*/
#define HW_LTC_K80_LPKASZR_ADDR(x)        ((x) + 0x80U)
#define HW_LTC_K80_LPKASZR(x)             (*(__IO hw_ltc_k80_lpkaszr_t *) HW_LTC_K80_LPKASZR_ADDR(x))
#define HW_LTC_K80_LPKASZR_RD(x)          (HW_LTC_K80_LPKASZR(x).U)
#define HW_LTC_K80_LPKASZR_WR(x, v)       (HW_LTC_K80_LPKASZR(x).U = (v))
#define HW_LTC_K80_LPKASZR_SET(x, v)      (HW_LTC_K80_LPKASZR_WR(x, HW_LTC_K80_LPKASZR_RD(x) |  (v)))
#define HW_LTC_K80_LPKASZR_CLR(x, v)      (HW_LTC_K80_LPKASZR_WR(x, HW_LTC_K80_LPKASZR_RD(x) & ~(v)))
#define HW_LTC_K80_LPKASZR_TOG(x, v)      (HW_LTC_K80_LPKASZR_WR(x, HW_LTC_K80_LPKASZR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKASZR bitfields
 */

/*!
 * @name Register LTC_K80_LPKASZR, field PKASZ[8:0] (RW)
 *
 * PKHA A Size. This is the size of the numeric value, in bytes, contained within the PKHA A
 * Register.
 */
/*@{*/
#define BP_LTC_K80_LPKASZR_PKASZ         (0U)      /*!< Bit position for LTC_K80_LPKASZR_PKASZ. */
#define BM_LTC_K80_LPKASZR_PKASZ         (0x000001FFU)  /*!< Bit mask for LTC_K80_LPKASZR_PKASZ. */
#define BS_LTC_K80_LPKASZR_PKASZ         (9U)  /*!< Bitfield size in bits for LTC_K80_LPKASZR_PKASZ. */

/*! @brief Read current value of the LTC_K80_LPKASZR_PKASZ field. */
#define BR_LTC_K80_LPKASZR_PKASZ(x)   (HW_LTC_K80_LPKASZR(x).B.PKASZ)

/*! @brief Format value for bitfield LTC_K80_LPKASZR_PKASZ. */
#define BF_LTC_K80_LPKASZR_PKASZ(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKASZR_PKASZ) & BM_LTC_K80_LPKASZR_PKASZ)

/*! @brief Set the PKASZ field to a new value. */
#define BW_LTC_K80_LPKASZR_PKASZ(x, v)   (HW_LTC_K80_LPKASZR_WR(x, (HW_LTC_K80_LPKASZR_RD(x) & ~BM_LTC_K80_LPKASZR_PKASZ) | BF_LTC_K80_LPKASZR_PKASZ(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKBSZR - LTC PKHA B Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKBSZR - LTC PKHA B Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B Size Register is used to indicate the number of bytes of valid data in the PKHA B
 * Register. That is, it indicates the size, in bytes, of the numeric value contained in the PKHA B
 * Register. Depending on the PKHA operation to be run, this register may need to be loaded prior to
 * starting the PKHA operation. Note that some PKHA operations update this value at the completion
 * of the operation.
 */
typedef union _hw_ltc_k80_lpkbszr
{
    uint32_t U;
    struct _hw_ltc_k80_lpkbszr_bitfields
    {
        uint32_t PKBSZ : 9; /*!< [8:0] PKHA B Size. */
        uint32_t RESERVED0 : 23; /*!< [31:9] Reserved. */
    } B;
} hw_ltc_k80_lpkbszr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKBSZR register
 */
/*@{*/
#define HW_LTC_K80_LPKBSZR_ADDR(x)        ((x) + 0x88U)
#define HW_LTC_K80_LPKBSZR(x)             (*(__IO hw_ltc_k80_lpkbszr_t *) HW_LTC_K80_LPKBSZR_ADDR(x))
#define HW_LTC_K80_LPKBSZR_RD(x)          (HW_LTC_K80_LPKBSZR(x).U)
#define HW_LTC_K80_LPKBSZR_WR(x, v)       (HW_LTC_K80_LPKBSZR(x).U = (v))
#define HW_LTC_K80_LPKBSZR_SET(x, v)      (HW_LTC_K80_LPKBSZR_WR(x, HW_LTC_K80_LPKBSZR_RD(x) |  (v)))
#define HW_LTC_K80_LPKBSZR_CLR(x, v)      (HW_LTC_K80_LPKBSZR_WR(x, HW_LTC_K80_LPKBSZR_RD(x) & ~(v)))
#define HW_LTC_K80_LPKBSZR_TOG(x, v)      (HW_LTC_K80_LPKBSZR_WR(x, HW_LTC_K80_LPKBSZR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKBSZR bitfields
 */

/*!
 * @name Register LTC_K80_LPKBSZR, field PKBSZ[8:0] (RW)
 *
 * PKHA B Size. This is the size of the numeric value, in bytes, contained within the PKHA B
 * Register.
 */
/*@{*/
#define BP_LTC_K80_LPKBSZR_PKBSZ         (0U)      /*!< Bit position for LTC_K80_LPKBSZR_PKBSZ. */
#define BM_LTC_K80_LPKBSZR_PKBSZ         (0x000001FFU)  /*!< Bit mask for LTC_K80_LPKBSZR_PKBSZ. */
#define BS_LTC_K80_LPKBSZR_PKBSZ         (9U)  /*!< Bitfield size in bits for LTC_K80_LPKBSZR_PKBSZ. */

/*! @brief Read current value of the LTC_K80_LPKBSZR_PKBSZ field. */
#define BR_LTC_K80_LPKBSZR_PKBSZ(x)   (HW_LTC_K80_LPKBSZR(x).B.PKBSZ)

/*! @brief Format value for bitfield LTC_K80_LPKBSZR_PKBSZ. */
#define BF_LTC_K80_LPKBSZR_PKBSZ(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKBSZR_PKBSZ) & BM_LTC_K80_LPKBSZR_PKBSZ)

/*! @brief Set the PKBSZ field to a new value. */
#define BW_LTC_K80_LPKBSZR_PKBSZ(x, v)   (HW_LTC_K80_LPKBSZR_WR(x, (HW_LTC_K80_LPKBSZR_RD(x) & ~BM_LTC_K80_LPKBSZR_PKBSZ) | BF_LTC_K80_LPKBSZR_PKBSZ(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKNSZR - LTC PKHA N Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKNSZR - LTC PKHA N Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N Size Register is used to indicate the number of bytes of valid data in the PKHA N
 * Register. That is, it indicates the size, in bytes, of the numeric value contained in the PKHA N
 * Register. Depending on the PKHA operation to be run, this register may need to be loaded prior to
 * starting the PKHA operation. Note that some PKHA operations update this value at the completion
 * of the operation.
 */
typedef union _hw_ltc_k80_lpknszr
{
    uint32_t U;
    struct _hw_ltc_k80_lpknszr_bitfields
    {
        uint32_t PKNSZ : 9; /*!< [8:0] PKHA N Size. */
        uint32_t RESERVED0 : 23; /*!< [31:9] Reserved. */
    } B;
} hw_ltc_k80_lpknszr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKNSZR register
 */
/*@{*/
#define HW_LTC_K80_LPKNSZR_ADDR(x)        ((x) + 0x90U)
#define HW_LTC_K80_LPKNSZR(x)             (*(__IO hw_ltc_k80_lpknszr_t *) HW_LTC_K80_LPKNSZR_ADDR(x))
#define HW_LTC_K80_LPKNSZR_RD(x)          (HW_LTC_K80_LPKNSZR(x).U)
#define HW_LTC_K80_LPKNSZR_WR(x, v)       (HW_LTC_K80_LPKNSZR(x).U = (v))
#define HW_LTC_K80_LPKNSZR_SET(x, v)      (HW_LTC_K80_LPKNSZR_WR(x, HW_LTC_K80_LPKNSZR_RD(x) |  (v)))
#define HW_LTC_K80_LPKNSZR_CLR(x, v)      (HW_LTC_K80_LPKNSZR_WR(x, HW_LTC_K80_LPKNSZR_RD(x) & ~(v)))
#define HW_LTC_K80_LPKNSZR_TOG(x, v)      (HW_LTC_K80_LPKNSZR_WR(x, HW_LTC_K80_LPKNSZR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKNSZR bitfields
 */

/*!
 * @name Register LTC_K80_LPKNSZR, field PKNSZ[8:0] (RW)
 *
 * PKHA N Size. This is the size of the numeric value, in bytes, contained within the PKHA N
 * Register.
 */
/*@{*/
#define BP_LTC_K80_LPKNSZR_PKNSZ         (0U)      /*!< Bit position for LTC_K80_LPKNSZR_PKNSZ. */
#define BM_LTC_K80_LPKNSZR_PKNSZ         (0x000001FFU)  /*!< Bit mask for LTC_K80_LPKNSZR_PKNSZ. */
#define BS_LTC_K80_LPKNSZR_PKNSZ         (9U)  /*!< Bitfield size in bits for LTC_K80_LPKNSZR_PKNSZ. */

/*! @brief Read current value of the LTC_K80_LPKNSZR_PKNSZ field. */
#define BR_LTC_K80_LPKNSZR_PKNSZ(x)   (HW_LTC_K80_LPKNSZR(x).B.PKNSZ)

/*! @brief Format value for bitfield LTC_K80_LPKNSZR_PKNSZ. */
#define BF_LTC_K80_LPKNSZR_PKNSZ(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKNSZR_PKNSZ) & BM_LTC_K80_LPKNSZR_PKNSZ)

/*! @brief Set the PKNSZ field to a new value. */
#define BW_LTC_K80_LPKNSZR_PKNSZ(x, v)   (HW_LTC_K80_LPKNSZR_WR(x, (HW_LTC_K80_LPKNSZR_RD(x) & ~BM_LTC_K80_LPKNSZR_PKNSZ) | BF_LTC_K80_LPKNSZR_PKNSZ(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKESZR - LTC PKHA E Size Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKESZR - LTC PKHA E Size Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Size Register is used to indicate the number of bytes of valid data in the PKHA E
 * Register. That is, it indicates the size, in bytes, of the numeric value contained in the PKHA E
 * Register. Depending on the PKHA operation to be run, this register may need to be loaded prior to
 * starting the PKHA operation. Note that some PKHA operations update this value at the completion
 * of the operation.
 */
typedef union _hw_ltc_k80_lpkeszr
{
    uint32_t U;
    struct _hw_ltc_k80_lpkeszr_bitfields
    {
        uint32_t PKESZ : 9; /*!< [8:0] PKHA E Size. */
        uint32_t RESERVED0 : 23; /*!< [31:9] Reserved. */
    } B;
} hw_ltc_k80_lpkeszr_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKESZR register
 */
/*@{*/
#define HW_LTC_K80_LPKESZR_ADDR(x)        ((x) + 0x98U)
#define HW_LTC_K80_LPKESZR(x)             (*(__IO hw_ltc_k80_lpkeszr_t *) HW_LTC_K80_LPKESZR_ADDR(x))
#define HW_LTC_K80_LPKESZR_RD(x)          (HW_LTC_K80_LPKESZR(x).U)
#define HW_LTC_K80_LPKESZR_WR(x, v)       (HW_LTC_K80_LPKESZR(x).U = (v))
#define HW_LTC_K80_LPKESZR_SET(x, v)      (HW_LTC_K80_LPKESZR_WR(x, HW_LTC_K80_LPKESZR_RD(x) |  (v)))
#define HW_LTC_K80_LPKESZR_CLR(x, v)      (HW_LTC_K80_LPKESZR_WR(x, HW_LTC_K80_LPKESZR_RD(x) & ~(v)))
#define HW_LTC_K80_LPKESZR_TOG(x, v)      (HW_LTC_K80_LPKESZR_WR(x, HW_LTC_K80_LPKESZR_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKESZR bitfields
 */

/*!
 * @name Register LTC_K80_LPKESZR, field PKESZ[8:0] (RW)
 *
 * PKHA E Size. This is the size of the numeric value, in bytes, contained within the PKHA E
 * Register.
 */
/*@{*/
#define BP_LTC_K80_LPKESZR_PKESZ         (0U)      /*!< Bit position for LTC_K80_LPKESZR_PKESZ. */
#define BM_LTC_K80_LPKESZR_PKESZ         (0x000001FFU)  /*!< Bit mask for LTC_K80_LPKESZR_PKESZ. */
#define BS_LTC_K80_LPKESZR_PKESZ         (9U)  /*!< Bitfield size in bits for LTC_K80_LPKESZR_PKESZ. */

/*! @brief Read current value of the LTC_K80_LPKESZR_PKESZ field. */
#define BR_LTC_K80_LPKESZR_PKESZ(x)   (HW_LTC_K80_LPKESZR(x).B.PKESZ)

/*! @brief Format value for bitfield LTC_K80_LPKESZR_PKESZ. */
#define BF_LTC_K80_LPKESZR_PKESZ(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKESZR_PKESZ) & BM_LTC_K80_LPKESZR_PKESZ)

/*! @brief Set the PKESZ field to a new value. */
#define BW_LTC_K80_LPKESZR_PKESZ(x, v)   (HW_LTC_K80_LPKESZR_WR(x, (HW_LTC_K80_LPKESZR_RD(x) & ~BM_LTC_K80_LPKESZR_PKESZ) | BF_LTC_K80_LPKESZR_PKESZ(v)))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_0 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_0 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_0
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_0_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_0 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_0_ADDR(x)        ((x) + 0x100U)
#define HW_LTC_K80_LTCCTXR_0(x)             (*(__IO hw_ltc_k80_ltcctxr_0_t *) HW_LTC_K80_LTCCTXR_0_ADDR(x))
#define HW_LTC_K80_LTCCTXR_0_RD(x)          (HW_LTC_K80_LTCCTXR_0(x).U)
#define HW_LTC_K80_LTCCTXR_0_WR(x, v)       (HW_LTC_K80_LTCCTXR_0(x).U = (v))
#define HW_LTC_K80_LTCCTXR_0_SET(x, v)      (HW_LTC_K80_LTCCTXR_0_WR(x, HW_LTC_K80_LTCCTXR_0_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_0_CLR(x, v)      (HW_LTC_K80_LTCCTXR_0_WR(x, HW_LTC_K80_LTCCTXR_0_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_0_TOG(x, v)      (HW_LTC_K80_LTCCTXR_0_WR(x, HW_LTC_K80_LTCCTXR_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_0 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_0, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_0_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_0_CTX. */
#define BM_LTC_K80_LTCCTXR_0_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_0_CTX. */
#define BS_LTC_K80_LTCCTXR_0_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_0_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_0_CTX field. */
#define BR_LTC_K80_LTCCTXR_0_CTX(x)      (HW_LTC_K80_LTCCTXR_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_0_CTX. */
#define BF_LTC_K80_LTCCTXR_0_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_0_CTX) & BM_LTC_K80_LTCCTXR_0_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_0_CTX(x, v)   (HW_LTC_K80_LTCCTXR_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_1 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_1 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_1
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_1_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_1 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_1_ADDR(x)        ((x) + 0x104U)
#define HW_LTC_K80_LTCCTXR_1(x)             (*(__IO hw_ltc_k80_ltcctxr_1_t *) HW_LTC_K80_LTCCTXR_1_ADDR(x))
#define HW_LTC_K80_LTCCTXR_1_RD(x)          (HW_LTC_K80_LTCCTXR_1(x).U)
#define HW_LTC_K80_LTCCTXR_1_WR(x, v)       (HW_LTC_K80_LTCCTXR_1(x).U = (v))
#define HW_LTC_K80_LTCCTXR_1_SET(x, v)      (HW_LTC_K80_LTCCTXR_1_WR(x, HW_LTC_K80_LTCCTXR_1_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_1_CLR(x, v)      (HW_LTC_K80_LTCCTXR_1_WR(x, HW_LTC_K80_LTCCTXR_1_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_1_TOG(x, v)      (HW_LTC_K80_LTCCTXR_1_WR(x, HW_LTC_K80_LTCCTXR_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_1 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_1, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_1_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_1_CTX. */
#define BM_LTC_K80_LTCCTXR_1_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_1_CTX. */
#define BS_LTC_K80_LTCCTXR_1_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_1_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_1_CTX field. */
#define BR_LTC_K80_LTCCTXR_1_CTX(x)      (HW_LTC_K80_LTCCTXR_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_1_CTX. */
#define BF_LTC_K80_LTCCTXR_1_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_1_CTX) & BM_LTC_K80_LTCCTXR_1_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_1_CTX(x, v)   (HW_LTC_K80_LTCCTXR_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_2 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_2 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_2
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_2_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_2 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_2_ADDR(x)        ((x) + 0x108U)
#define HW_LTC_K80_LTCCTXR_2(x)             (*(__IO hw_ltc_k80_ltcctxr_2_t *) HW_LTC_K80_LTCCTXR_2_ADDR(x))
#define HW_LTC_K80_LTCCTXR_2_RD(x)          (HW_LTC_K80_LTCCTXR_2(x).U)
#define HW_LTC_K80_LTCCTXR_2_WR(x, v)       (HW_LTC_K80_LTCCTXR_2(x).U = (v))
#define HW_LTC_K80_LTCCTXR_2_SET(x, v)      (HW_LTC_K80_LTCCTXR_2_WR(x, HW_LTC_K80_LTCCTXR_2_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_2_CLR(x, v)      (HW_LTC_K80_LTCCTXR_2_WR(x, HW_LTC_K80_LTCCTXR_2_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_2_TOG(x, v)      (HW_LTC_K80_LTCCTXR_2_WR(x, HW_LTC_K80_LTCCTXR_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_2 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_2, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_2_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_2_CTX. */
#define BM_LTC_K80_LTCCTXR_2_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_2_CTX. */
#define BS_LTC_K80_LTCCTXR_2_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_2_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_2_CTX field. */
#define BR_LTC_K80_LTCCTXR_2_CTX(x)      (HW_LTC_K80_LTCCTXR_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_2_CTX. */
#define BF_LTC_K80_LTCCTXR_2_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_2_CTX) & BM_LTC_K80_LTCCTXR_2_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_2_CTX(x, v)   (HW_LTC_K80_LTCCTXR_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_3 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_3 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_3
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_3_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_3 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_3_ADDR(x)        ((x) + 0x10CU)
#define HW_LTC_K80_LTCCTXR_3(x)             (*(__IO hw_ltc_k80_ltcctxr_3_t *) HW_LTC_K80_LTCCTXR_3_ADDR(x))
#define HW_LTC_K80_LTCCTXR_3_RD(x)          (HW_LTC_K80_LTCCTXR_3(x).U)
#define HW_LTC_K80_LTCCTXR_3_WR(x, v)       (HW_LTC_K80_LTCCTXR_3(x).U = (v))
#define HW_LTC_K80_LTCCTXR_3_SET(x, v)      (HW_LTC_K80_LTCCTXR_3_WR(x, HW_LTC_K80_LTCCTXR_3_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_3_CLR(x, v)      (HW_LTC_K80_LTCCTXR_3_WR(x, HW_LTC_K80_LTCCTXR_3_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_3_TOG(x, v)      (HW_LTC_K80_LTCCTXR_3_WR(x, HW_LTC_K80_LTCCTXR_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_3 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_3, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_3_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_3_CTX. */
#define BM_LTC_K80_LTCCTXR_3_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_3_CTX. */
#define BS_LTC_K80_LTCCTXR_3_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_3_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_3_CTX field. */
#define BR_LTC_K80_LTCCTXR_3_CTX(x)      (HW_LTC_K80_LTCCTXR_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_3_CTX. */
#define BF_LTC_K80_LTCCTXR_3_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_3_CTX) & BM_LTC_K80_LTCCTXR_3_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_3_CTX(x, v)   (HW_LTC_K80_LTCCTXR_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_4 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_4 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_4
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_4_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_4 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_4_ADDR(x)        ((x) + 0x110U)
#define HW_LTC_K80_LTCCTXR_4(x)             (*(__IO hw_ltc_k80_ltcctxr_4_t *) HW_LTC_K80_LTCCTXR_4_ADDR(x))
#define HW_LTC_K80_LTCCTXR_4_RD(x)          (HW_LTC_K80_LTCCTXR_4(x).U)
#define HW_LTC_K80_LTCCTXR_4_WR(x, v)       (HW_LTC_K80_LTCCTXR_4(x).U = (v))
#define HW_LTC_K80_LTCCTXR_4_SET(x, v)      (HW_LTC_K80_LTCCTXR_4_WR(x, HW_LTC_K80_LTCCTXR_4_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_4_CLR(x, v)      (HW_LTC_K80_LTCCTXR_4_WR(x, HW_LTC_K80_LTCCTXR_4_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_4_TOG(x, v)      (HW_LTC_K80_LTCCTXR_4_WR(x, HW_LTC_K80_LTCCTXR_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_4 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_4, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_4_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_4_CTX. */
#define BM_LTC_K80_LTCCTXR_4_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_4_CTX. */
#define BS_LTC_K80_LTCCTXR_4_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_4_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_4_CTX field. */
#define BR_LTC_K80_LTCCTXR_4_CTX(x)      (HW_LTC_K80_LTCCTXR_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_4_CTX. */
#define BF_LTC_K80_LTCCTXR_4_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_4_CTX) & BM_LTC_K80_LTCCTXR_4_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_4_CTX(x, v)   (HW_LTC_K80_LTCCTXR_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_5 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_5 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_5
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_5_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_5 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_5_ADDR(x)        ((x) + 0x114U)
#define HW_LTC_K80_LTCCTXR_5(x)             (*(__IO hw_ltc_k80_ltcctxr_5_t *) HW_LTC_K80_LTCCTXR_5_ADDR(x))
#define HW_LTC_K80_LTCCTXR_5_RD(x)          (HW_LTC_K80_LTCCTXR_5(x).U)
#define HW_LTC_K80_LTCCTXR_5_WR(x, v)       (HW_LTC_K80_LTCCTXR_5(x).U = (v))
#define HW_LTC_K80_LTCCTXR_5_SET(x, v)      (HW_LTC_K80_LTCCTXR_5_WR(x, HW_LTC_K80_LTCCTXR_5_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_5_CLR(x, v)      (HW_LTC_K80_LTCCTXR_5_WR(x, HW_LTC_K80_LTCCTXR_5_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_5_TOG(x, v)      (HW_LTC_K80_LTCCTXR_5_WR(x, HW_LTC_K80_LTCCTXR_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_5 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_5, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_5_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_5_CTX. */
#define BM_LTC_K80_LTCCTXR_5_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_5_CTX. */
#define BS_LTC_K80_LTCCTXR_5_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_5_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_5_CTX field. */
#define BR_LTC_K80_LTCCTXR_5_CTX(x)      (HW_LTC_K80_LTCCTXR_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_5_CTX. */
#define BF_LTC_K80_LTCCTXR_5_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_5_CTX) & BM_LTC_K80_LTCCTXR_5_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_5_CTX(x, v)   (HW_LTC_K80_LTCCTXR_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_6 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_6 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_6
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_6_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_6 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_6_ADDR(x)        ((x) + 0x118U)
#define HW_LTC_K80_LTCCTXR_6(x)             (*(__IO hw_ltc_k80_ltcctxr_6_t *) HW_LTC_K80_LTCCTXR_6_ADDR(x))
#define HW_LTC_K80_LTCCTXR_6_RD(x)          (HW_LTC_K80_LTCCTXR_6(x).U)
#define HW_LTC_K80_LTCCTXR_6_WR(x, v)       (HW_LTC_K80_LTCCTXR_6(x).U = (v))
#define HW_LTC_K80_LTCCTXR_6_SET(x, v)      (HW_LTC_K80_LTCCTXR_6_WR(x, HW_LTC_K80_LTCCTXR_6_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_6_CLR(x, v)      (HW_LTC_K80_LTCCTXR_6_WR(x, HW_LTC_K80_LTCCTXR_6_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_6_TOG(x, v)      (HW_LTC_K80_LTCCTXR_6_WR(x, HW_LTC_K80_LTCCTXR_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_6 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_6, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_6_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_6_CTX. */
#define BM_LTC_K80_LTCCTXR_6_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_6_CTX. */
#define BS_LTC_K80_LTCCTXR_6_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_6_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_6_CTX field. */
#define BR_LTC_K80_LTCCTXR_6_CTX(x)      (HW_LTC_K80_LTCCTXR_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_6_CTX. */
#define BF_LTC_K80_LTCCTXR_6_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_6_CTX) & BM_LTC_K80_LTCCTXR_6_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_6_CTX(x, v)   (HW_LTC_K80_LTCCTXR_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_7 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_7 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_7
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_7_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_7 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_7_ADDR(x)        ((x) + 0x11CU)
#define HW_LTC_K80_LTCCTXR_7(x)             (*(__IO hw_ltc_k80_ltcctxr_7_t *) HW_LTC_K80_LTCCTXR_7_ADDR(x))
#define HW_LTC_K80_LTCCTXR_7_RD(x)          (HW_LTC_K80_LTCCTXR_7(x).U)
#define HW_LTC_K80_LTCCTXR_7_WR(x, v)       (HW_LTC_K80_LTCCTXR_7(x).U = (v))
#define HW_LTC_K80_LTCCTXR_7_SET(x, v)      (HW_LTC_K80_LTCCTXR_7_WR(x, HW_LTC_K80_LTCCTXR_7_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_7_CLR(x, v)      (HW_LTC_K80_LTCCTXR_7_WR(x, HW_LTC_K80_LTCCTXR_7_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_7_TOG(x, v)      (HW_LTC_K80_LTCCTXR_7_WR(x, HW_LTC_K80_LTCCTXR_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_7 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_7, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_7_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_7_CTX. */
#define BM_LTC_K80_LTCCTXR_7_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_7_CTX. */
#define BS_LTC_K80_LTCCTXR_7_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_7_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_7_CTX field. */
#define BR_LTC_K80_LTCCTXR_7_CTX(x)      (HW_LTC_K80_LTCCTXR_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_7_CTX. */
#define BF_LTC_K80_LTCCTXR_7_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_7_CTX) & BM_LTC_K80_LTCCTXR_7_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_7_CTX(x, v)   (HW_LTC_K80_LTCCTXR_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_8 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_8 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_8
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_8_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_8 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_8_ADDR(x)        ((x) + 0x120U)
#define HW_LTC_K80_LTCCTXR_8(x)             (*(__IO hw_ltc_k80_ltcctxr_8_t *) HW_LTC_K80_LTCCTXR_8_ADDR(x))
#define HW_LTC_K80_LTCCTXR_8_RD(x)          (HW_LTC_K80_LTCCTXR_8(x).U)
#define HW_LTC_K80_LTCCTXR_8_WR(x, v)       (HW_LTC_K80_LTCCTXR_8(x).U = (v))
#define HW_LTC_K80_LTCCTXR_8_SET(x, v)      (HW_LTC_K80_LTCCTXR_8_WR(x, HW_LTC_K80_LTCCTXR_8_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_8_CLR(x, v)      (HW_LTC_K80_LTCCTXR_8_WR(x, HW_LTC_K80_LTCCTXR_8_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_8_TOG(x, v)      (HW_LTC_K80_LTCCTXR_8_WR(x, HW_LTC_K80_LTCCTXR_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_8 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_8, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_8_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_8_CTX. */
#define BM_LTC_K80_LTCCTXR_8_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_8_CTX. */
#define BS_LTC_K80_LTCCTXR_8_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_8_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_8_CTX field. */
#define BR_LTC_K80_LTCCTXR_8_CTX(x)      (HW_LTC_K80_LTCCTXR_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_8_CTX. */
#define BF_LTC_K80_LTCCTXR_8_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_8_CTX) & BM_LTC_K80_LTCCTXR_8_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_8_CTX(x, v)   (HW_LTC_K80_LTCCTXR_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_9 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_9 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_9
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_9_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_9 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_9_ADDR(x)        ((x) + 0x124U)
#define HW_LTC_K80_LTCCTXR_9(x)             (*(__IO hw_ltc_k80_ltcctxr_9_t *) HW_LTC_K80_LTCCTXR_9_ADDR(x))
#define HW_LTC_K80_LTCCTXR_9_RD(x)          (HW_LTC_K80_LTCCTXR_9(x).U)
#define HW_LTC_K80_LTCCTXR_9_WR(x, v)       (HW_LTC_K80_LTCCTXR_9(x).U = (v))
#define HW_LTC_K80_LTCCTXR_9_SET(x, v)      (HW_LTC_K80_LTCCTXR_9_WR(x, HW_LTC_K80_LTCCTXR_9_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_9_CLR(x, v)      (HW_LTC_K80_LTCCTXR_9_WR(x, HW_LTC_K80_LTCCTXR_9_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_9_TOG(x, v)      (HW_LTC_K80_LTCCTXR_9_WR(x, HW_LTC_K80_LTCCTXR_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_9 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_9, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_9_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_9_CTX. */
#define BM_LTC_K80_LTCCTXR_9_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_9_CTX. */
#define BS_LTC_K80_LTCCTXR_9_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_9_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_9_CTX field. */
#define BR_LTC_K80_LTCCTXR_9_CTX(x)      (HW_LTC_K80_LTCCTXR_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_9_CTX. */
#define BF_LTC_K80_LTCCTXR_9_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_9_CTX) & BM_LTC_K80_LTCCTXR_9_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_9_CTX(x, v)   (HW_LTC_K80_LTCCTXR_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_10 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_10 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_10
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_10_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_10 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_10_ADDR(x)        ((x) + 0x128U)
#define HW_LTC_K80_LTCCTXR_10(x)             (*(__IO hw_ltc_k80_ltcctxr_10_t *) HW_LTC_K80_LTCCTXR_10_ADDR(x))
#define HW_LTC_K80_LTCCTXR_10_RD(x)          (HW_LTC_K80_LTCCTXR_10(x).U)
#define HW_LTC_K80_LTCCTXR_10_WR(x, v)       (HW_LTC_K80_LTCCTXR_10(x).U = (v))
#define HW_LTC_K80_LTCCTXR_10_SET(x, v)      (HW_LTC_K80_LTCCTXR_10_WR(x, HW_LTC_K80_LTCCTXR_10_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_10_CLR(x, v)      (HW_LTC_K80_LTCCTXR_10_WR(x, HW_LTC_K80_LTCCTXR_10_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_10_TOG(x, v)      (HW_LTC_K80_LTCCTXR_10_WR(x, HW_LTC_K80_LTCCTXR_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_10 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_10, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_10_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_10_CTX. */
#define BM_LTC_K80_LTCCTXR_10_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_10_CTX. */
#define BS_LTC_K80_LTCCTXR_10_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_10_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_10_CTX field. */
#define BR_LTC_K80_LTCCTXR_10_CTX(x)      (HW_LTC_K80_LTCCTXR_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_10_CTX. */
#define BF_LTC_K80_LTCCTXR_10_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_10_CTX) & BM_LTC_K80_LTCCTXR_10_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_10_CTX(x, v)   (HW_LTC_K80_LTCCTXR_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_11 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_11 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_11
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_11_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_11 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_11_ADDR(x)        ((x) + 0x12CU)
#define HW_LTC_K80_LTCCTXR_11(x)             (*(__IO hw_ltc_k80_ltcctxr_11_t *) HW_LTC_K80_LTCCTXR_11_ADDR(x))
#define HW_LTC_K80_LTCCTXR_11_RD(x)          (HW_LTC_K80_LTCCTXR_11(x).U)
#define HW_LTC_K80_LTCCTXR_11_WR(x, v)       (HW_LTC_K80_LTCCTXR_11(x).U = (v))
#define HW_LTC_K80_LTCCTXR_11_SET(x, v)      (HW_LTC_K80_LTCCTXR_11_WR(x, HW_LTC_K80_LTCCTXR_11_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_11_CLR(x, v)      (HW_LTC_K80_LTCCTXR_11_WR(x, HW_LTC_K80_LTCCTXR_11_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_11_TOG(x, v)      (HW_LTC_K80_LTCCTXR_11_WR(x, HW_LTC_K80_LTCCTXR_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_11 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_11, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_11_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_11_CTX. */
#define BM_LTC_K80_LTCCTXR_11_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_11_CTX. */
#define BS_LTC_K80_LTCCTXR_11_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_11_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_11_CTX field. */
#define BR_LTC_K80_LTCCTXR_11_CTX(x)      (HW_LTC_K80_LTCCTXR_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_11_CTX. */
#define BF_LTC_K80_LTCCTXR_11_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_11_CTX) & BM_LTC_K80_LTCCTXR_11_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_11_CTX(x, v)   (HW_LTC_K80_LTCCTXR_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_12 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_12 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_12
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_12_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_12 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_12_ADDR(x)        ((x) + 0x130U)
#define HW_LTC_K80_LTCCTXR_12(x)             (*(__IO hw_ltc_k80_ltcctxr_12_t *) HW_LTC_K80_LTCCTXR_12_ADDR(x))
#define HW_LTC_K80_LTCCTXR_12_RD(x)          (HW_LTC_K80_LTCCTXR_12(x).U)
#define HW_LTC_K80_LTCCTXR_12_WR(x, v)       (HW_LTC_K80_LTCCTXR_12(x).U = (v))
#define HW_LTC_K80_LTCCTXR_12_SET(x, v)      (HW_LTC_K80_LTCCTXR_12_WR(x, HW_LTC_K80_LTCCTXR_12_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_12_CLR(x, v)      (HW_LTC_K80_LTCCTXR_12_WR(x, HW_LTC_K80_LTCCTXR_12_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_12_TOG(x, v)      (HW_LTC_K80_LTCCTXR_12_WR(x, HW_LTC_K80_LTCCTXR_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_12 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_12, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_12_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_12_CTX. */
#define BM_LTC_K80_LTCCTXR_12_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_12_CTX. */
#define BS_LTC_K80_LTCCTXR_12_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_12_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_12_CTX field. */
#define BR_LTC_K80_LTCCTXR_12_CTX(x)      (HW_LTC_K80_LTCCTXR_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_12_CTX. */
#define BF_LTC_K80_LTCCTXR_12_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_12_CTX) & BM_LTC_K80_LTCCTXR_12_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_12_CTX(x, v)   (HW_LTC_K80_LTCCTXR_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_13 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_13 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_13
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_13_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_13 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_13_ADDR(x)        ((x) + 0x134U)
#define HW_LTC_K80_LTCCTXR_13(x)             (*(__IO hw_ltc_k80_ltcctxr_13_t *) HW_LTC_K80_LTCCTXR_13_ADDR(x))
#define HW_LTC_K80_LTCCTXR_13_RD(x)          (HW_LTC_K80_LTCCTXR_13(x).U)
#define HW_LTC_K80_LTCCTXR_13_WR(x, v)       (HW_LTC_K80_LTCCTXR_13(x).U = (v))
#define HW_LTC_K80_LTCCTXR_13_SET(x, v)      (HW_LTC_K80_LTCCTXR_13_WR(x, HW_LTC_K80_LTCCTXR_13_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_13_CLR(x, v)      (HW_LTC_K80_LTCCTXR_13_WR(x, HW_LTC_K80_LTCCTXR_13_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_13_TOG(x, v)      (HW_LTC_K80_LTCCTXR_13_WR(x, HW_LTC_K80_LTCCTXR_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_13 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_13, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_13_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_13_CTX. */
#define BM_LTC_K80_LTCCTXR_13_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_13_CTX. */
#define BS_LTC_K80_LTCCTXR_13_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_13_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_13_CTX field. */
#define BR_LTC_K80_LTCCTXR_13_CTX(x)      (HW_LTC_K80_LTCCTXR_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_13_CTX. */
#define BF_LTC_K80_LTCCTXR_13_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_13_CTX) & BM_LTC_K80_LTCCTXR_13_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_13_CTX(x, v)   (HW_LTC_K80_LTCCTXR_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_14 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_14 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_14
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_14_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_14 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_14_ADDR(x)        ((x) + 0x138U)
#define HW_LTC_K80_LTCCTXR_14(x)             (*(__IO hw_ltc_k80_ltcctxr_14_t *) HW_LTC_K80_LTCCTXR_14_ADDR(x))
#define HW_LTC_K80_LTCCTXR_14_RD(x)          (HW_LTC_K80_LTCCTXR_14(x).U)
#define HW_LTC_K80_LTCCTXR_14_WR(x, v)       (HW_LTC_K80_LTCCTXR_14(x).U = (v))
#define HW_LTC_K80_LTCCTXR_14_SET(x, v)      (HW_LTC_K80_LTCCTXR_14_WR(x, HW_LTC_K80_LTCCTXR_14_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_14_CLR(x, v)      (HW_LTC_K80_LTCCTXR_14_WR(x, HW_LTC_K80_LTCCTXR_14_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_14_TOG(x, v)      (HW_LTC_K80_LTCCTXR_14_WR(x, HW_LTC_K80_LTCCTXR_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_14 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_14, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_14_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_14_CTX. */
#define BM_LTC_K80_LTCCTXR_14_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_14_CTX. */
#define BS_LTC_K80_LTCCTXR_14_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_14_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_14_CTX field. */
#define BR_LTC_K80_LTCCTXR_14_CTX(x)      (HW_LTC_K80_LTCCTXR_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_14_CTX. */
#define BF_LTC_K80_LTCCTXR_14_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_14_CTX) & BM_LTC_K80_LTCCTXR_14_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_14_CTX(x, v)   (HW_LTC_K80_LTCCTXR_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCCTXR_15 - LTC Context Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCCTXR_15 - LTC Context Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Context Register holds the context for the internal crypto engine. This register is 512 bits
 * in length. The IP bus write to the Context Register is accessible only as full-word reads or
 * writes to sixteen 32-bit registers. The MSB is located at offset 0100h with respect to the
 * register page. The bit assignments of this register are dependent on the algorithm, and in some
 * cases the mode of that algorithm. See the appropriate section for the Context Register format
 * used for that algorithm: AES ECB: Section AES CBC: Section AES CTR: Section AES CCM: Section DES:
 * Section Triple DES: Section
 */
typedef union _hw_ltc_k80_ltcctxr_15
{
    uint32_t U;
    struct _hw_ltc_k80_ltcctxr_15_bitfields
    {
        uint32_t CTX : 32; /*!< [31:0] CTX */
    } B;
} hw_ltc_k80_ltcctxr_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCCTXR_15 register
 */
/*@{*/
#define HW_LTC_K80_LTCCTXR_15_ADDR(x)        ((x) + 0x13CU)
#define HW_LTC_K80_LTCCTXR_15(x)             (*(__IO hw_ltc_k80_ltcctxr_15_t *) HW_LTC_K80_LTCCTXR_15_ADDR(x))
#define HW_LTC_K80_LTCCTXR_15_RD(x)          (HW_LTC_K80_LTCCTXR_15(x).U)
#define HW_LTC_K80_LTCCTXR_15_WR(x, v)       (HW_LTC_K80_LTCCTXR_15(x).U = (v))
#define HW_LTC_K80_LTCCTXR_15_SET(x, v)      (HW_LTC_K80_LTCCTXR_15_WR(x, HW_LTC_K80_LTCCTXR_15_RD(x) |  (v)))
#define HW_LTC_K80_LTCCTXR_15_CLR(x, v)      (HW_LTC_K80_LTCCTXR_15_WR(x, HW_LTC_K80_LTCCTXR_15_RD(x) & ~(v)))
#define HW_LTC_K80_LTCCTXR_15_TOG(x, v)      (HW_LTC_K80_LTCCTXR_15_WR(x, HW_LTC_K80_LTCCTXR_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCCTXR_15 bitfields
 */

/*!
 * @name Register LTC_K80_LTCCTXR_15, field CTX[31:0] (RW)
 *
 * CTX
 */
/*@{*/
#define BP_LTC_K80_LTCCTXR_15_CTX         (0U)      /*!< Bit position for LTC_K80_LTCCTXR_15_CTX. */
#define BM_LTC_K80_LTCCTXR_15_CTX         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCCTXR_15_CTX. */
#define BS_LTC_K80_LTCCTXR_15_CTX         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCCTXR_15_CTX. */

/*! @brief Read current value of the LTC_K80_LTCCTXR_15_CTX field. */
#define BR_LTC_K80_LTCCTXR_15_CTX(x)      (HW_LTC_K80_LTCCTXR_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCCTXR_15_CTX. */
#define BF_LTC_K80_LTCCTXR_15_CTX(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCCTXR_15_CTX) & BM_LTC_K80_LTCCTXR_15_CTX)

/*! @brief Set the CTX field to a new value. */
#define BW_LTC_K80_LTCCTXR_15_CTX(x, v)   (HW_LTC_K80_LTCCTXR_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKEYR_0 - LTC Key Registers
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKEYR_0 - LTC Key Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Register normally holds the left-aligned key for the internal crypto engine. The MSB is
 * in offset 200h. The Key Register is 256 bits in length. The IP bus write to the Context Register
 * is accessible only as full-word reads or writes to four 32-bit registers. Before the value in the
 * Key Register can be used in a cryptographic operation, the size of the key must be written into
 * the Key Size Register. Once the Key Size Register has been written, the Key Register cannot be
 * written again until the Key Size Register has been cleared.
 */
typedef union _hw_ltc_k80_ltckeyr_0
{
    uint32_t U;
    struct _hw_ltc_k80_ltckeyr_0_bitfields
    {
        uint32_t KEYR : 32; /*!< [31:0] KEYR */
    } B;
} hw_ltc_k80_ltckeyr_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKEYR_0 register
 */
/*@{*/
#define HW_LTC_K80_LTCKEYR_0_ADDR(x)        ((x) + 0x200U)
#define HW_LTC_K80_LTCKEYR_0(x)             (*(__IO hw_ltc_k80_ltckeyr_0_t *) HW_LTC_K80_LTCKEYR_0_ADDR(x))
#define HW_LTC_K80_LTCKEYR_0_RD(x)          (HW_LTC_K80_LTCKEYR_0(x).U)
#define HW_LTC_K80_LTCKEYR_0_WR(x, v)       (HW_LTC_K80_LTCKEYR_0(x).U = (v))
#define HW_LTC_K80_LTCKEYR_0_SET(x, v)      (HW_LTC_K80_LTCKEYR_0_WR(x, HW_LTC_K80_LTCKEYR_0_RD(x) |  (v)))
#define HW_LTC_K80_LTCKEYR_0_CLR(x, v)      (HW_LTC_K80_LTCKEYR_0_WR(x, HW_LTC_K80_LTCKEYR_0_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKEYR_0_TOG(x, v)      (HW_LTC_K80_LTCKEYR_0_WR(x, HW_LTC_K80_LTCKEYR_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKEYR_0 bitfields
 */

/*!
 * @name Register LTC_K80_LTCKEYR_0, field KEYR[31:0] (RW)
 *
 * KEYR
 */
/*@{*/
#define BP_LTC_K80_LTCKEYR_0_KEYR         (0U)      /*!< Bit position for LTC_K80_LTCKEYR_0_KEYR. */
#define BM_LTC_K80_LTCKEYR_0_KEYR         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCKEYR_0_KEYR. */
#define BS_LTC_K80_LTCKEYR_0_KEYR         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCKEYR_0_KEYR. */

/*! @brief Read current value of the LTC_K80_LTCKEYR_0_KEYR field. */
#define BR_LTC_K80_LTCKEYR_0_KEYR(x)      (HW_LTC_K80_LTCKEYR_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCKEYR_0_KEYR. */
#define BF_LTC_K80_LTCKEYR_0_KEYR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKEYR_0_KEYR) & BM_LTC_K80_LTCKEYR_0_KEYR)

/*! @brief Set the KEYR field to a new value. */
#define BW_LTC_K80_LTCKEYR_0_KEYR(x, v)   (HW_LTC_K80_LTCKEYR_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKEYR_1 - LTC Key Registers
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKEYR_1 - LTC Key Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Register normally holds the left-aligned key for the internal crypto engine. The MSB is
 * in offset 200h. The Key Register is 256 bits in length. The IP bus write to the Context Register
 * is accessible only as full-word reads or writes to four 32-bit registers. Before the value in the
 * Key Register can be used in a cryptographic operation, the size of the key must be written into
 * the Key Size Register. Once the Key Size Register has been written, the Key Register cannot be
 * written again until the Key Size Register has been cleared.
 */
typedef union _hw_ltc_k80_ltckeyr_1
{
    uint32_t U;
    struct _hw_ltc_k80_ltckeyr_1_bitfields
    {
        uint32_t KEYR : 32; /*!< [31:0] KEYR */
    } B;
} hw_ltc_k80_ltckeyr_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKEYR_1 register
 */
/*@{*/
#define HW_LTC_K80_LTCKEYR_1_ADDR(x)        ((x) + 0x204U)
#define HW_LTC_K80_LTCKEYR_1(x)             (*(__IO hw_ltc_k80_ltckeyr_1_t *) HW_LTC_K80_LTCKEYR_1_ADDR(x))
#define HW_LTC_K80_LTCKEYR_1_RD(x)          (HW_LTC_K80_LTCKEYR_1(x).U)
#define HW_LTC_K80_LTCKEYR_1_WR(x, v)       (HW_LTC_K80_LTCKEYR_1(x).U = (v))
#define HW_LTC_K80_LTCKEYR_1_SET(x, v)      (HW_LTC_K80_LTCKEYR_1_WR(x, HW_LTC_K80_LTCKEYR_1_RD(x) |  (v)))
#define HW_LTC_K80_LTCKEYR_1_CLR(x, v)      (HW_LTC_K80_LTCKEYR_1_WR(x, HW_LTC_K80_LTCKEYR_1_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKEYR_1_TOG(x, v)      (HW_LTC_K80_LTCKEYR_1_WR(x, HW_LTC_K80_LTCKEYR_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKEYR_1 bitfields
 */

/*!
 * @name Register LTC_K80_LTCKEYR_1, field KEYR[31:0] (RW)
 *
 * KEYR
 */
/*@{*/
#define BP_LTC_K80_LTCKEYR_1_KEYR         (0U)      /*!< Bit position for LTC_K80_LTCKEYR_1_KEYR. */
#define BM_LTC_K80_LTCKEYR_1_KEYR         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCKEYR_1_KEYR. */
#define BS_LTC_K80_LTCKEYR_1_KEYR         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCKEYR_1_KEYR. */

/*! @brief Read current value of the LTC_K80_LTCKEYR_1_KEYR field. */
#define BR_LTC_K80_LTCKEYR_1_KEYR(x)      (HW_LTC_K80_LTCKEYR_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCKEYR_1_KEYR. */
#define BF_LTC_K80_LTCKEYR_1_KEYR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKEYR_1_KEYR) & BM_LTC_K80_LTCKEYR_1_KEYR)

/*! @brief Set the KEYR field to a new value. */
#define BW_LTC_K80_LTCKEYR_1_KEYR(x, v)   (HW_LTC_K80_LTCKEYR_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKEYR_2 - LTC Key Registers
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKEYR_2 - LTC Key Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Register normally holds the left-aligned key for the internal crypto engine. The MSB is
 * in offset 200h. The Key Register is 256 bits in length. The IP bus write to the Context Register
 * is accessible only as full-word reads or writes to four 32-bit registers. Before the value in the
 * Key Register can be used in a cryptographic operation, the size of the key must be written into
 * the Key Size Register. Once the Key Size Register has been written, the Key Register cannot be
 * written again until the Key Size Register has been cleared.
 */
typedef union _hw_ltc_k80_ltckeyr_2
{
    uint32_t U;
    struct _hw_ltc_k80_ltckeyr_2_bitfields
    {
        uint32_t KEYR : 32; /*!< [31:0] KEYR */
    } B;
} hw_ltc_k80_ltckeyr_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKEYR_2 register
 */
/*@{*/
#define HW_LTC_K80_LTCKEYR_2_ADDR(x)        ((x) + 0x208U)
#define HW_LTC_K80_LTCKEYR_2(x)             (*(__IO hw_ltc_k80_ltckeyr_2_t *) HW_LTC_K80_LTCKEYR_2_ADDR(x))
#define HW_LTC_K80_LTCKEYR_2_RD(x)          (HW_LTC_K80_LTCKEYR_2(x).U)
#define HW_LTC_K80_LTCKEYR_2_WR(x, v)       (HW_LTC_K80_LTCKEYR_2(x).U = (v))
#define HW_LTC_K80_LTCKEYR_2_SET(x, v)      (HW_LTC_K80_LTCKEYR_2_WR(x, HW_LTC_K80_LTCKEYR_2_RD(x) |  (v)))
#define HW_LTC_K80_LTCKEYR_2_CLR(x, v)      (HW_LTC_K80_LTCKEYR_2_WR(x, HW_LTC_K80_LTCKEYR_2_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKEYR_2_TOG(x, v)      (HW_LTC_K80_LTCKEYR_2_WR(x, HW_LTC_K80_LTCKEYR_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKEYR_2 bitfields
 */

/*!
 * @name Register LTC_K80_LTCKEYR_2, field KEYR[31:0] (RW)
 *
 * KEYR
 */
/*@{*/
#define BP_LTC_K80_LTCKEYR_2_KEYR         (0U)      /*!< Bit position for LTC_K80_LTCKEYR_2_KEYR. */
#define BM_LTC_K80_LTCKEYR_2_KEYR         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCKEYR_2_KEYR. */
#define BS_LTC_K80_LTCKEYR_2_KEYR         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCKEYR_2_KEYR. */

/*! @brief Read current value of the LTC_K80_LTCKEYR_2_KEYR field. */
#define BR_LTC_K80_LTCKEYR_2_KEYR(x)      (HW_LTC_K80_LTCKEYR_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCKEYR_2_KEYR. */
#define BF_LTC_K80_LTCKEYR_2_KEYR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKEYR_2_KEYR) & BM_LTC_K80_LTCKEYR_2_KEYR)

/*! @brief Set the KEYR field to a new value. */
#define BW_LTC_K80_LTCKEYR_2_KEYR(x, v)   (HW_LTC_K80_LTCKEYR_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKEYR_3 - LTC Key Registers
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKEYR_3 - LTC Key Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Register normally holds the left-aligned key for the internal crypto engine. The MSB is
 * in offset 200h. The Key Register is 256 bits in length. The IP bus write to the Context Register
 * is accessible only as full-word reads or writes to four 32-bit registers. Before the value in the
 * Key Register can be used in a cryptographic operation, the size of the key must be written into
 * the Key Size Register. Once the Key Size Register has been written, the Key Register cannot be
 * written again until the Key Size Register has been cleared.
 */
typedef union _hw_ltc_k80_ltckeyr_3
{
    uint32_t U;
    struct _hw_ltc_k80_ltckeyr_3_bitfields
    {
        uint32_t KEYR : 32; /*!< [31:0] KEYR */
    } B;
} hw_ltc_k80_ltckeyr_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKEYR_3 register
 */
/*@{*/
#define HW_LTC_K80_LTCKEYR_3_ADDR(x)        ((x) + 0x20CU)
#define HW_LTC_K80_LTCKEYR_3(x)             (*(__IO hw_ltc_k80_ltckeyr_3_t *) HW_LTC_K80_LTCKEYR_3_ADDR(x))
#define HW_LTC_K80_LTCKEYR_3_RD(x)          (HW_LTC_K80_LTCKEYR_3(x).U)
#define HW_LTC_K80_LTCKEYR_3_WR(x, v)       (HW_LTC_K80_LTCKEYR_3(x).U = (v))
#define HW_LTC_K80_LTCKEYR_3_SET(x, v)      (HW_LTC_K80_LTCKEYR_3_WR(x, HW_LTC_K80_LTCKEYR_3_RD(x) |  (v)))
#define HW_LTC_K80_LTCKEYR_3_CLR(x, v)      (HW_LTC_K80_LTCKEYR_3_WR(x, HW_LTC_K80_LTCKEYR_3_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKEYR_3_TOG(x, v)      (HW_LTC_K80_LTCKEYR_3_WR(x, HW_LTC_K80_LTCKEYR_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKEYR_3 bitfields
 */

/*!
 * @name Register LTC_K80_LTCKEYR_3, field KEYR[31:0] (RW)
 *
 * KEYR
 */
/*@{*/
#define BP_LTC_K80_LTCKEYR_3_KEYR         (0U)      /*!< Bit position for LTC_K80_LTCKEYR_3_KEYR. */
#define BM_LTC_K80_LTCKEYR_3_KEYR         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCKEYR_3_KEYR. */
#define BS_LTC_K80_LTCKEYR_3_KEYR         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCKEYR_3_KEYR. */

/*! @brief Read current value of the LTC_K80_LTCKEYR_3_KEYR field. */
#define BR_LTC_K80_LTCKEYR_3_KEYR(x)      (HW_LTC_K80_LTCKEYR_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCKEYR_3_KEYR. */
#define BF_LTC_K80_LTCKEYR_3_KEYR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKEYR_3_KEYR) & BM_LTC_K80_LTCKEYR_3_KEYR)

/*! @brief Set the KEYR field to a new value. */
#define BW_LTC_K80_LTCKEYR_3_KEYR(x, v)   (HW_LTC_K80_LTCKEYR_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKEYR_4 - LTC Key Registers
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKEYR_4 - LTC Key Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Register normally holds the left-aligned key for the internal crypto engine. The MSB is
 * in offset 200h. The Key Register is 256 bits in length. The IP bus write to the Context Register
 * is accessible only as full-word reads or writes to four 32-bit registers. Before the value in the
 * Key Register can be used in a cryptographic operation, the size of the key must be written into
 * the Key Size Register. Once the Key Size Register has been written, the Key Register cannot be
 * written again until the Key Size Register has been cleared.
 */
typedef union _hw_ltc_k80_ltckeyr_4
{
    uint32_t U;
    struct _hw_ltc_k80_ltckeyr_4_bitfields
    {
        uint32_t KEYR : 32; /*!< [31:0] KEYR */
    } B;
} hw_ltc_k80_ltckeyr_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKEYR_4 register
 */
/*@{*/
#define HW_LTC_K80_LTCKEYR_4_ADDR(x)        ((x) + 0x210U)
#define HW_LTC_K80_LTCKEYR_4(x)             (*(__IO hw_ltc_k80_ltckeyr_4_t *) HW_LTC_K80_LTCKEYR_4_ADDR(x))
#define HW_LTC_K80_LTCKEYR_4_RD(x)          (HW_LTC_K80_LTCKEYR_4(x).U)
#define HW_LTC_K80_LTCKEYR_4_WR(x, v)       (HW_LTC_K80_LTCKEYR_4(x).U = (v))
#define HW_LTC_K80_LTCKEYR_4_SET(x, v)      (HW_LTC_K80_LTCKEYR_4_WR(x, HW_LTC_K80_LTCKEYR_4_RD(x) |  (v)))
#define HW_LTC_K80_LTCKEYR_4_CLR(x, v)      (HW_LTC_K80_LTCKEYR_4_WR(x, HW_LTC_K80_LTCKEYR_4_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKEYR_4_TOG(x, v)      (HW_LTC_K80_LTCKEYR_4_WR(x, HW_LTC_K80_LTCKEYR_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKEYR_4 bitfields
 */

/*!
 * @name Register LTC_K80_LTCKEYR_4, field KEYR[31:0] (RW)
 *
 * KEYR
 */
/*@{*/
#define BP_LTC_K80_LTCKEYR_4_KEYR         (0U)      /*!< Bit position for LTC_K80_LTCKEYR_4_KEYR. */
#define BM_LTC_K80_LTCKEYR_4_KEYR         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCKEYR_4_KEYR. */
#define BS_LTC_K80_LTCKEYR_4_KEYR         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCKEYR_4_KEYR. */

/*! @brief Read current value of the LTC_K80_LTCKEYR_4_KEYR field. */
#define BR_LTC_K80_LTCKEYR_4_KEYR(x)      (HW_LTC_K80_LTCKEYR_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCKEYR_4_KEYR. */
#define BF_LTC_K80_LTCKEYR_4_KEYR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKEYR_4_KEYR) & BM_LTC_K80_LTCKEYR_4_KEYR)

/*! @brief Set the KEYR field to a new value. */
#define BW_LTC_K80_LTCKEYR_4_KEYR(x, v)   (HW_LTC_K80_LTCKEYR_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKEYR_5 - LTC Key Registers
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKEYR_5 - LTC Key Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Register normally holds the left-aligned key for the internal crypto engine. The MSB is
 * in offset 200h. The Key Register is 256 bits in length. The IP bus write to the Context Register
 * is accessible only as full-word reads or writes to four 32-bit registers. Before the value in the
 * Key Register can be used in a cryptographic operation, the size of the key must be written into
 * the Key Size Register. Once the Key Size Register has been written, the Key Register cannot be
 * written again until the Key Size Register has been cleared.
 */
typedef union _hw_ltc_k80_ltckeyr_5
{
    uint32_t U;
    struct _hw_ltc_k80_ltckeyr_5_bitfields
    {
        uint32_t KEYR : 32; /*!< [31:0] KEYR */
    } B;
} hw_ltc_k80_ltckeyr_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKEYR_5 register
 */
/*@{*/
#define HW_LTC_K80_LTCKEYR_5_ADDR(x)        ((x) + 0x214U)
#define HW_LTC_K80_LTCKEYR_5(x)             (*(__IO hw_ltc_k80_ltckeyr_5_t *) HW_LTC_K80_LTCKEYR_5_ADDR(x))
#define HW_LTC_K80_LTCKEYR_5_RD(x)          (HW_LTC_K80_LTCKEYR_5(x).U)
#define HW_LTC_K80_LTCKEYR_5_WR(x, v)       (HW_LTC_K80_LTCKEYR_5(x).U = (v))
#define HW_LTC_K80_LTCKEYR_5_SET(x, v)      (HW_LTC_K80_LTCKEYR_5_WR(x, HW_LTC_K80_LTCKEYR_5_RD(x) |  (v)))
#define HW_LTC_K80_LTCKEYR_5_CLR(x, v)      (HW_LTC_K80_LTCKEYR_5_WR(x, HW_LTC_K80_LTCKEYR_5_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKEYR_5_TOG(x, v)      (HW_LTC_K80_LTCKEYR_5_WR(x, HW_LTC_K80_LTCKEYR_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKEYR_5 bitfields
 */

/*!
 * @name Register LTC_K80_LTCKEYR_5, field KEYR[31:0] (RW)
 *
 * KEYR
 */
/*@{*/
#define BP_LTC_K80_LTCKEYR_5_KEYR         (0U)      /*!< Bit position for LTC_K80_LTCKEYR_5_KEYR. */
#define BM_LTC_K80_LTCKEYR_5_KEYR         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCKEYR_5_KEYR. */
#define BS_LTC_K80_LTCKEYR_5_KEYR         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCKEYR_5_KEYR. */

/*! @brief Read current value of the LTC_K80_LTCKEYR_5_KEYR field. */
#define BR_LTC_K80_LTCKEYR_5_KEYR(x)      (HW_LTC_K80_LTCKEYR_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCKEYR_5_KEYR. */
#define BF_LTC_K80_LTCKEYR_5_KEYR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKEYR_5_KEYR) & BM_LTC_K80_LTCKEYR_5_KEYR)

/*! @brief Set the KEYR field to a new value. */
#define BW_LTC_K80_LTCKEYR_5_KEYR(x, v)   (HW_LTC_K80_LTCKEYR_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKEYR_6 - LTC Key Registers
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKEYR_6 - LTC Key Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Register normally holds the left-aligned key for the internal crypto engine. The MSB is
 * in offset 200h. The Key Register is 256 bits in length. The IP bus write to the Context Register
 * is accessible only as full-word reads or writes to four 32-bit registers. Before the value in the
 * Key Register can be used in a cryptographic operation, the size of the key must be written into
 * the Key Size Register. Once the Key Size Register has been written, the Key Register cannot be
 * written again until the Key Size Register has been cleared.
 */
typedef union _hw_ltc_k80_ltckeyr_6
{
    uint32_t U;
    struct _hw_ltc_k80_ltckeyr_6_bitfields
    {
        uint32_t KEYR : 32; /*!< [31:0] KEYR */
    } B;
} hw_ltc_k80_ltckeyr_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKEYR_6 register
 */
/*@{*/
#define HW_LTC_K80_LTCKEYR_6_ADDR(x)        ((x) + 0x218U)
#define HW_LTC_K80_LTCKEYR_6(x)             (*(__IO hw_ltc_k80_ltckeyr_6_t *) HW_LTC_K80_LTCKEYR_6_ADDR(x))
#define HW_LTC_K80_LTCKEYR_6_RD(x)          (HW_LTC_K80_LTCKEYR_6(x).U)
#define HW_LTC_K80_LTCKEYR_6_WR(x, v)       (HW_LTC_K80_LTCKEYR_6(x).U = (v))
#define HW_LTC_K80_LTCKEYR_6_SET(x, v)      (HW_LTC_K80_LTCKEYR_6_WR(x, HW_LTC_K80_LTCKEYR_6_RD(x) |  (v)))
#define HW_LTC_K80_LTCKEYR_6_CLR(x, v)      (HW_LTC_K80_LTCKEYR_6_WR(x, HW_LTC_K80_LTCKEYR_6_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKEYR_6_TOG(x, v)      (HW_LTC_K80_LTCKEYR_6_WR(x, HW_LTC_K80_LTCKEYR_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKEYR_6 bitfields
 */

/*!
 * @name Register LTC_K80_LTCKEYR_6, field KEYR[31:0] (RW)
 *
 * KEYR
 */
/*@{*/
#define BP_LTC_K80_LTCKEYR_6_KEYR         (0U)      /*!< Bit position for LTC_K80_LTCKEYR_6_KEYR. */
#define BM_LTC_K80_LTCKEYR_6_KEYR         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCKEYR_6_KEYR. */
#define BS_LTC_K80_LTCKEYR_6_KEYR         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCKEYR_6_KEYR. */

/*! @brief Read current value of the LTC_K80_LTCKEYR_6_KEYR field. */
#define BR_LTC_K80_LTCKEYR_6_KEYR(x)      (HW_LTC_K80_LTCKEYR_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCKEYR_6_KEYR. */
#define BF_LTC_K80_LTCKEYR_6_KEYR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKEYR_6_KEYR) & BM_LTC_K80_LTCKEYR_6_KEYR)

/*! @brief Set the KEYR field to a new value. */
#define BW_LTC_K80_LTCKEYR_6_KEYR(x, v)   (HW_LTC_K80_LTCKEYR_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCKEYR_7 - LTC Key Registers
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCKEYR_7 - LTC Key Registers (RW)
 *
 * Reset value: 0x00000000U
 *
 * The Key Register normally holds the left-aligned key for the internal crypto engine. The MSB is
 * in offset 200h. The Key Register is 256 bits in length. The IP bus write to the Context Register
 * is accessible only as full-word reads or writes to four 32-bit registers. Before the value in the
 * Key Register can be used in a cryptographic operation, the size of the key must be written into
 * the Key Size Register. Once the Key Size Register has been written, the Key Register cannot be
 * written again until the Key Size Register has been cleared.
 */
typedef union _hw_ltc_k80_ltckeyr_7
{
    uint32_t U;
    struct _hw_ltc_k80_ltckeyr_7_bitfields
    {
        uint32_t KEYR : 32; /*!< [31:0] KEYR */
    } B;
} hw_ltc_k80_ltckeyr_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCKEYR_7 register
 */
/*@{*/
#define HW_LTC_K80_LTCKEYR_7_ADDR(x)        ((x) + 0x21CU)
#define HW_LTC_K80_LTCKEYR_7(x)             (*(__IO hw_ltc_k80_ltckeyr_7_t *) HW_LTC_K80_LTCKEYR_7_ADDR(x))
#define HW_LTC_K80_LTCKEYR_7_RD(x)          (HW_LTC_K80_LTCKEYR_7(x).U)
#define HW_LTC_K80_LTCKEYR_7_WR(x, v)       (HW_LTC_K80_LTCKEYR_7(x).U = (v))
#define HW_LTC_K80_LTCKEYR_7_SET(x, v)      (HW_LTC_K80_LTCKEYR_7_WR(x, HW_LTC_K80_LTCKEYR_7_RD(x) |  (v)))
#define HW_LTC_K80_LTCKEYR_7_CLR(x, v)      (HW_LTC_K80_LTCKEYR_7_WR(x, HW_LTC_K80_LTCKEYR_7_RD(x) & ~(v)))
#define HW_LTC_K80_LTCKEYR_7_TOG(x, v)      (HW_LTC_K80_LTCKEYR_7_WR(x, HW_LTC_K80_LTCKEYR_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCKEYR_7 bitfields
 */

/*!
 * @name Register LTC_K80_LTCKEYR_7, field KEYR[31:0] (RW)
 *
 * KEYR
 */
/*@{*/
#define BP_LTC_K80_LTCKEYR_7_KEYR         (0U)      /*!< Bit position for LTC_K80_LTCKEYR_7_KEYR. */
#define BM_LTC_K80_LTCKEYR_7_KEYR         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCKEYR_7_KEYR. */
#define BS_LTC_K80_LTCKEYR_7_KEYR         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCKEYR_7_KEYR. */

/*! @brief Read current value of the LTC_K80_LTCKEYR_7_KEYR field. */
#define BR_LTC_K80_LTCKEYR_7_KEYR(x)      (HW_LTC_K80_LTCKEYR_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LTCKEYR_7_KEYR. */
#define BF_LTC_K80_LTCKEYR_7_KEYR(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCKEYR_7_KEYR) & BM_LTC_K80_LTCKEYR_7_KEYR)

/*! @brief Set the KEYR field to a new value. */
#define BW_LTC_K80_LTCKEYR_7_KEYR(x, v)   (HW_LTC_K80_LTCKEYR_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCVID1 - LTC Version ID Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCVID1 - LTC Version ID Register (RO)
 *
 * Reset value: 0x00340100U
 *
 * This register contains the ID for LTC and major and minor revision numbers.
 */
typedef union _hw_ltc_k80_ltcvid1
{
    uint32_t U;
    struct _hw_ltc_k80_ltcvid1_bitfields
    {
        uint32_t MIN_REV : 8; /*!< [7:0] Minor revision number(0x00). */
        uint32_t MAJ_REV : 8; /*!< [15:8] Major revision number(0x01). */
        uint32_t IP_ID : 16; /*!< [31:16] ID(0x0038). */
    } B;
} hw_ltc_k80_ltcvid1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCVID1 register
 */
/*@{*/
#define HW_LTC_K80_LTCVID1_ADDR(x)        ((x) + 0x4F0U)
#define HW_LTC_K80_LTCVID1(x)             (*(__I  hw_ltc_k80_ltcvid1_t *) HW_LTC_K80_LTCVID1_ADDR(x))
#define HW_LTC_K80_LTCVID1_RD(x)          (HW_LTC_K80_LTCVID1(x).U)
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCVID1 bitfields
 */

/*!
 * @name Register LTC_K80_LTCVID1, field MIN_REV[7:0] (RO)
 *
 * Minor revision number(0x00).
 */
/*@{*/
#define BP_LTC_K80_LTCVID1_MIN_REV         (0U)      /*!< Bit position for LTC_K80_LTCVID1_MIN_REV. */
#define BM_LTC_K80_LTCVID1_MIN_REV         (0x000000FFU)  /*!< Bit mask for LTC_K80_LTCVID1_MIN_REV. */
#define BS_LTC_K80_LTCVID1_MIN_REV         (8U)  /*!< Bitfield size in bits for LTC_K80_LTCVID1_MIN_REV. */

/*! @brief Read current value of the LTC_K80_LTCVID1_MIN_REV field. */
#define BR_LTC_K80_LTCVID1_MIN_REV(x)   (HW_LTC_K80_LTCVID1(x).B.MIN_REV)
/*@}*/

/*!
 * @name Register LTC_K80_LTCVID1, field MAJ_REV[15:8] (RO)
 *
 * Major revision number(0x01).
 */
/*@{*/
#define BP_LTC_K80_LTCVID1_MAJ_REV         (8U)      /*!< Bit position for LTC_K80_LTCVID1_MAJ_REV. */
#define BM_LTC_K80_LTCVID1_MAJ_REV         (0x0000FF00U)  /*!< Bit mask for LTC_K80_LTCVID1_MAJ_REV. */
#define BS_LTC_K80_LTCVID1_MAJ_REV         (8U)  /*!< Bitfield size in bits for LTC_K80_LTCVID1_MAJ_REV. */

/*! @brief Read current value of the LTC_K80_LTCVID1_MAJ_REV field. */
#define BR_LTC_K80_LTCVID1_MAJ_REV(x)   (HW_LTC_K80_LTCVID1(x).B.MAJ_REV)
/*@}*/

/*!
 * @name Register LTC_K80_LTCVID1, field IP_ID[31:16] (RO)
 *
 * ID(0x0038).
 */
/*@{*/
#define BP_LTC_K80_LTCVID1_IP_ID         (16U)      /*!< Bit position for LTC_K80_LTCVID1_IP_ID. */
#define BM_LTC_K80_LTCVID1_IP_ID         (0xFFFF0000U)  /*!< Bit mask for LTC_K80_LTCVID1_IP_ID. */
#define BS_LTC_K80_LTCVID1_IP_ID         (16U)  /*!< Bitfield size in bits for LTC_K80_LTCVID1_IP_ID. */

/*! @brief Read current value of the LTC_K80_LTCVID1_IP_ID field. */
#define BR_LTC_K80_LTCVID1_IP_ID(x)   (HW_LTC_K80_LTCVID1(x).B.IP_ID)
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_CHAVID - CHA Version ID Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_CHAVID - CHA Version ID Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register contains the Version ID and Revision Number for the CHAs contained within LTC.
 */
typedef union _hw_ltc_k80_chavid
{
    uint32_t U;
    struct _hw_ltc_k80_chavid_bitfields
    {
        uint32_t AESREV : 4; /*!< [3:0] AES Revision Number(0x1). */
        uint32_t AESVID : 4; /*!< [7:4] AES Version ID(0x5). */
        uint32_t DESREV : 4; /*!< [11:8] DES Revision Number(0x4). */
        uint32_t DESVID : 4; /*!< [15:12] DES Version ID(0x4). */
        uint32_t PKHAREV : 4; /*!< [19:16] PK Revision Number(0x4). */
        uint32_t PKHAVID : 4; /*!< [23:20] PK Version ID(0x4). */
        uint32_t RESERVED0 : 8; /*!< [31:24] Reserved */
    } B;
} hw_ltc_k80_chavid_t;

/*!
 * @name Constants and macros for entire LTC_K80_CHAVID register
 */
/*@{*/
#define HW_LTC_K80_CHAVID_ADDR(x)        ((x) + 0x4F8U)
#define HW_LTC_K80_CHAVID(x)             (*(__IO hw_ltc_k80_chavid_t *) HW_LTC_K80_CHAVID_ADDR(x))
#define HW_LTC_K80_CHAVID_RD(x)          (HW_LTC_K80_CHAVID(x).U)
#define HW_LTC_K80_CHAVID_WR(x, v)       (HW_LTC_K80_CHAVID(x).U = (v))
#define HW_LTC_K80_CHAVID_SET(x, v)      (HW_LTC_K80_CHAVID_WR(x, HW_LTC_K80_CHAVID_RD(x) |  (v)))
#define HW_LTC_K80_CHAVID_CLR(x, v)      (HW_LTC_K80_CHAVID_WR(x, HW_LTC_K80_CHAVID_RD(x) & ~(v)))
#define HW_LTC_K80_CHAVID_TOG(x, v)      (HW_LTC_K80_CHAVID_WR(x, HW_LTC_K80_CHAVID_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_CHAVID bitfields
 */

/*!
 * @name Register LTC_K80_CHAVID, field AESREV[3:0] (RO)
 *
 * AES Revision Number(0x1).
 */
/*@{*/
#define BP_LTC_K80_CHAVID_AESREV         (0U)      /*!< Bit position for LTC_K80_CHAVID_AESREV. */
#define BM_LTC_K80_CHAVID_AESREV         (0x0000000FU)  /*!< Bit mask for LTC_K80_CHAVID_AESREV. */
#define BS_LTC_K80_CHAVID_AESREV         (4U)  /*!< Bitfield size in bits for LTC_K80_CHAVID_AESREV. */

/*! @brief Read current value of the LTC_K80_CHAVID_AESREV field. */
#define BR_LTC_K80_CHAVID_AESREV(x)   (HW_LTC_K80_CHAVID(x).B.AESREV)
/*@}*/

/*!
 * @name Register LTC_K80_CHAVID, field AESVID[7:4] (RO)
 *
 * AES Version ID(0x5).
 */
/*@{*/
#define BP_LTC_K80_CHAVID_AESVID         (4U)      /*!< Bit position for LTC_K80_CHAVID_AESVID. */
#define BM_LTC_K80_CHAVID_AESVID         (0x000000F0U)  /*!< Bit mask for LTC_K80_CHAVID_AESVID. */
#define BS_LTC_K80_CHAVID_AESVID         (4U)  /*!< Bitfield size in bits for LTC_K80_CHAVID_AESVID. */

/*! @brief Read current value of the LTC_K80_CHAVID_AESVID field. */
#define BR_LTC_K80_CHAVID_AESVID(x)   (HW_LTC_K80_CHAVID(x).B.AESVID)
/*@}*/

/*!
 * @name Register LTC_K80_CHAVID, field DESREV[11:8] (RO)
 *
 * DES Revision Number(0x4).
 */
/*@{*/
#define BP_LTC_K80_CHAVID_DESREV         (8U)      /*!< Bit position for LTC_K80_CHAVID_DESREV. */
#define BM_LTC_K80_CHAVID_DESREV         (0x00000F00U)  /*!< Bit mask for LTC_K80_CHAVID_DESREV. */
#define BS_LTC_K80_CHAVID_DESREV         (4U)  /*!< Bitfield size in bits for LTC_K80_CHAVID_DESREV. */

/*! @brief Read current value of the LTC_K80_CHAVID_DESREV field. */
#define BR_LTC_K80_CHAVID_DESREV(x)   (HW_LTC_K80_CHAVID(x).B.DESREV)
/*@}*/

/*!
 * @name Register LTC_K80_CHAVID, field DESVID[15:12] (RO)
 *
 * DES Version ID(0x4).
 */
/*@{*/
#define BP_LTC_K80_CHAVID_DESVID         (12U)      /*!< Bit position for LTC_K80_CHAVID_DESVID. */
#define BM_LTC_K80_CHAVID_DESVID         (0x0000F000U)  /*!< Bit mask for LTC_K80_CHAVID_DESVID. */
#define BS_LTC_K80_CHAVID_DESVID         (4U)  /*!< Bitfield size in bits for LTC_K80_CHAVID_DESVID. */

/*! @brief Read current value of the LTC_K80_CHAVID_DESVID field. */
#define BR_LTC_K80_CHAVID_DESVID(x)   (HW_LTC_K80_CHAVID(x).B.DESVID)
/*@}*/

/*!
 * @name Register LTC_K80_CHAVID, field PKHAREV[19:16] (RO)
 *
 * PK Revision Number(0x4).
 */
/*@{*/
#define BP_LTC_K80_CHAVID_PKHAREV         (16U)      /*!< Bit position for LTC_K80_CHAVID_PKHAREV. */
#define BM_LTC_K80_CHAVID_PKHAREV         (0x000F0000U)  /*!< Bit mask for LTC_K80_CHAVID_PKHAREV. */
#define BS_LTC_K80_CHAVID_PKHAREV         (4U)  /*!< Bitfield size in bits for LTC_K80_CHAVID_PKHAREV. */

/*! @brief Read current value of the LTC_K80_CHAVID_PKHAREV field. */
#define BR_LTC_K80_CHAVID_PKHAREV(x)   (HW_LTC_K80_CHAVID(x).B.PKHAREV)
/*@}*/

/*!
 * @name Register LTC_K80_CHAVID, field PKHAVID[23:20] (RO)
 *
 * PK Version ID(0x4).
 */
/*@{*/
#define BP_LTC_K80_CHAVID_PKHAVID         (20U)      /*!< Bit position for LTC_K80_CHAVID_PKHAVID. */
#define BM_LTC_K80_CHAVID_PKHAVID         (0x00F00000U)  /*!< Bit mask for LTC_K80_CHAVID_PKHAVID. */
#define BS_LTC_K80_CHAVID_PKHAVID         (4U)  /*!< Bitfield size in bits for LTC_K80_CHAVID_PKHAVID. */

/*! @brief Read current value of the LTC_K80_CHAVID_PKHAVID field. */
#define BR_LTC_K80_CHAVID_PKHAVID(x)   (HW_LTC_K80_CHAVID(x).B.PKHAVID)
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCFIFOSTA - LTC FIFO Status Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCFIFOSTA - LTC FIFO Status Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC FIFO Status shows the current levels of the Input and Output FIFO.
 */
typedef union _hw_ltc_k80_ltcfifosta
{
    uint32_t U;
    struct _hw_ltc_k80_ltcfifosta_bitfields
    {
        uint32_t IFL : 7; /*!< [6:0] Input FIFO Level. */
        uint32_t RESERVED0 : 8; /*!< [14:7] Reserved */
        uint32_t IFF : 1; /*!< [15] Input FIFO Full. */
        uint32_t OFL : 7; /*!< [22:16] Output FIFO Level. */
        uint32_t RESERVED1 : 8; /*!< [30:23] Reserved */
        uint32_t OFF : 1; /*!< [31] Output FIFO Full. */
    } B;
} hw_ltc_k80_ltcfifosta_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCFIFOSTA register
 */
/*@{*/
#define HW_LTC_K80_LTCFIFOSTA_ADDR(x)        ((x) + 0x7C0U)
#define HW_LTC_K80_LTCFIFOSTA(x)             (*(__IO hw_ltc_k80_ltcfifosta_t *) HW_LTC_K80_LTCFIFOSTA_ADDR(x))
#define HW_LTC_K80_LTCFIFOSTA_RD(x)          (HW_LTC_K80_LTCFIFOSTA(x).U)
#define HW_LTC_K80_LTCFIFOSTA_WR(x, v)       (HW_LTC_K80_LTCFIFOSTA(x).U = (v))
#define HW_LTC_K80_LTCFIFOSTA_SET(x, v)      (HW_LTC_K80_LTCFIFOSTA_WR(x, HW_LTC_K80_LTCFIFOSTA_RD(x) |  (v)))
#define HW_LTC_K80_LTCFIFOSTA_CLR(x, v)      (HW_LTC_K80_LTCFIFOSTA_WR(x, HW_LTC_K80_LTCFIFOSTA_RD(x) & ~(v)))
#define HW_LTC_K80_LTCFIFOSTA_TOG(x, v)      (HW_LTC_K80_LTCFIFOSTA_WR(x, HW_LTC_K80_LTCFIFOSTA_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCFIFOSTA bitfields
 */

/*!
 * @name Register LTC_K80_LTCFIFOSTA, field IFL[6:0] (RO)
 *
 * Input FIFO Level. These bits indicate the current number of entries in the Input FIFO.
 */
/*@{*/
#define BP_LTC_K80_LTCFIFOSTA_IFL         (0U)      /*!< Bit position for LTC_K80_LTCFIFOSTA_IFL. */
#define BM_LTC_K80_LTCFIFOSTA_IFL         (0x0000007FU)  /*!< Bit mask for LTC_K80_LTCFIFOSTA_IFL. */
#define BS_LTC_K80_LTCFIFOSTA_IFL         (7U)  /*!< Bitfield size in bits for LTC_K80_LTCFIFOSTA_IFL. */

/*! @brief Read current value of the LTC_K80_LTCFIFOSTA_IFL field. */
#define BR_LTC_K80_LTCFIFOSTA_IFL(x)   (HW_LTC_K80_LTCFIFOSTA(x).B.IFL)
/*@}*/

/*!
 * @name Register LTC_K80_LTCFIFOSTA, field IFF[15] (RO)
 *
 * Input FIFO Full. The Input FIFO is full and should not be written to.
 */
/*@{*/
#define BP_LTC_K80_LTCFIFOSTA_IFF         (15U)      /*!< Bit position for LTC_K80_LTCFIFOSTA_IFF. */
#define BM_LTC_K80_LTCFIFOSTA_IFF         (0x00008000U)  /*!< Bit mask for LTC_K80_LTCFIFOSTA_IFF. */
#define BS_LTC_K80_LTCFIFOSTA_IFF         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCFIFOSTA_IFF. */

/*! @brief Read current value of the LTC_K80_LTCFIFOSTA_IFF field. */
#define BR_LTC_K80_LTCFIFOSTA_IFF(x)   (HW_LTC_K80_LTCFIFOSTA(x).B.IFF)
/*@}*/

/*!
 * @name Register LTC_K80_LTCFIFOSTA, field OFL[22:16] (RO)
 *
 * Output FIFO Level. These bits indicate the current number of entries in the Output FIFO.
 */
/*@{*/
#define BP_LTC_K80_LTCFIFOSTA_OFL         (16U)      /*!< Bit position for LTC_K80_LTCFIFOSTA_OFL. */
#define BM_LTC_K80_LTCFIFOSTA_OFL         (0x007F0000U)  /*!< Bit mask for LTC_K80_LTCFIFOSTA_OFL. */
#define BS_LTC_K80_LTCFIFOSTA_OFL         (7U)  /*!< Bitfield size in bits for LTC_K80_LTCFIFOSTA_OFL. */

/*! @brief Read current value of the LTC_K80_LTCFIFOSTA_OFL field. */
#define BR_LTC_K80_LTCFIFOSTA_OFL(x)   (HW_LTC_K80_LTCFIFOSTA(x).B.OFL)
/*@}*/

/*!
 * @name Register LTC_K80_LTCFIFOSTA, field OFF[31] (RO)
 *
 * Output FIFO Full. The Output FIFO is full and should not be written to.
 */
/*@{*/
#define BP_LTC_K80_LTCFIFOSTA_OFF         (31U)      /*!< Bit position for LTC_K80_LTCFIFOSTA_OFF. */
#define BM_LTC_K80_LTCFIFOSTA_OFF         (0x80000000U)  /*!< Bit mask for LTC_K80_LTCFIFOSTA_OFF. */
#define BS_LTC_K80_LTCFIFOSTA_OFF         (1U)  /*!< Bitfield size in bits for LTC_K80_LTCFIFOSTA_OFF. */

/*! @brief Read current value of the LTC_K80_LTCFIFOSTA_OFF field. */
#define BR_LTC_K80_LTCFIFOSTA_OFF(x)   (HW_LTC_K80_LTCFIFOSTA(x).B.OFF)
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCIFIFO - LTC Input Data FIFO
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCIFIFO - LTC Input Data FIFO (WO)
 *
 * Reset value: 0x00000000U
 *
 * Data to be processed by the various crypto engines is first pushed into the Input Data FIFO. The
 * Input Data FIFO supports byte enables, allowing one to four bytes to be written to the IFIFO from
 * the IP bus. The IFIFO is four entries deep, and each entry is four bytes. Care must be used to
 * not overflow the Input Data FIFO. Reads from this address will always return 0x0.
 */
typedef union _hw_ltc_k80_ltcififo
{
    uint32_t U;
    struct _hw_ltc_k80_ltcififo_bitfields
    {
        uint32_t IFIFO : 32; /*!< [31:0] IFIFO */
    } B;
} hw_ltc_k80_ltcififo_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCIFIFO register
 */
/*@{*/
#define HW_LTC_K80_LTCIFIFO_ADDR(x)        ((x) + 0x7E0U)
#define HW_LTC_K80_LTCIFIFO(x)             (*(__O  hw_ltc_k80_ltcififo_t *) HW_LTC_K80_LTCIFIFO_ADDR(x))
#define HW_LTC_K80_LTCIFIFO_WR(x, v)       (HW_LTC_K80_LTCIFIFO(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCIFIFO bitfields
 */

/*!
 * @name Register LTC_K80_LTCIFIFO, field IFIFO[31:0] (WO)
 *
 * IFIFO
 */
/*@{*/
#define BP_LTC_K80_LTCIFIFO_IFIFO         (0U)      /*!< Bit position for LTC_K80_LTCIFIFO_IFIFO. */
#define BM_LTC_K80_LTCIFIFO_IFIFO         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCIFIFO_IFIFO. */
#define BS_LTC_K80_LTCIFIFO_IFIFO         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCIFIFO_IFIFO. */

/*! @brief Format value for bitfield LTC_K80_LTCIFIFO_IFIFO. */
#define BF_LTC_K80_LTCIFIFO_IFIFO(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LTCIFIFO_IFIFO) & BM_LTC_K80_LTCIFIFO_IFIFO)

/*! @brief Set the IFIFO field to a new value. */
#define BW_LTC_K80_LTCIFIFO_IFIFO(x, v)   (HW_LTC_K80_LTCIFIFO_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LTCOFIFO - LTC Output Data FIFO
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LTCOFIFO - LTC Output Data FIFO (RO)
 *
 * Reset value: 0x00000000U
 *
 * Data that is output from the AES is pushed into the Output Data FIFO. The OFIFO is four entries
 * deep, and each entry is four bytes. During normal operation, the AES will never overflow the
 * Output Data FIFO. Writes to this register are ignored.
 */
typedef union _hw_ltc_k80_ltcofifo
{
    uint32_t U;
    struct _hw_ltc_k80_ltcofifo_bitfields
    {
        uint32_t OFIFO : 32; /*!< [31:0] Output FIFO */
    } B;
} hw_ltc_k80_ltcofifo_t;

/*!
 * @name Constants and macros for entire LTC_K80_LTCOFIFO register
 */
/*@{*/
#define HW_LTC_K80_LTCOFIFO_ADDR(x)        ((x) + 0x7F0U)
#define HW_LTC_K80_LTCOFIFO(x)             (*(__I  hw_ltc_k80_ltcofifo_t *) HW_LTC_K80_LTCOFIFO_ADDR(x))
#define HW_LTC_K80_LTCOFIFO_RD(x)          (HW_LTC_K80_LTCOFIFO(x).U)
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LTCOFIFO bitfields
 */

/*!
 * @name Register LTC_K80_LTCOFIFO, field OFIFO[31:0] (RO)
 *
 * Output FIFO
 */
/*@{*/
#define BP_LTC_K80_LTCOFIFO_OFIFO         (0U)      /*!< Bit position for LTC_K80_LTCOFIFO_OFIFO. */
#define BM_LTC_K80_LTCOFIFO_OFIFO         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LTCOFIFO_OFIFO. */
#define BS_LTC_K80_LTCOFIFO_OFIFO         (32U)  /*!< Bitfield size in bits for LTC_K80_LTCOFIFO_OFIFO. */

/*! @brief Read current value of the LTC_K80_LTCOFIFO_OFIFO field. */
#define BR_LTC_K80_LTCOFIFO_OFIFO(x)      (HW_LTC_K80_LTCOFIFO(x).U)
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_0 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_0 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_0_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_0_ADDR(x)        ((x) + 0x800U)
#define HW_LTC_K80_LPKA0_0(x)             (*(__IO hw_ltc_k80_lpka0_0_t *) HW_LTC_K80_LPKA0_0_ADDR(x))
#define HW_LTC_K80_LPKA0_0_RD(x)          (HW_LTC_K80_LPKA0_0(x).U)
#define HW_LTC_K80_LPKA0_0_WR(x, v)       (HW_LTC_K80_LPKA0_0(x).U = (v))
#define HW_LTC_K80_LPKA0_0_SET(x, v)      (HW_LTC_K80_LPKA0_0_WR(x, HW_LTC_K80_LPKA0_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_0_CLR(x, v)      (HW_LTC_K80_LPKA0_0_WR(x, HW_LTC_K80_LPKA0_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_0_TOG(x, v)      (HW_LTC_K80_LPKA0_0_WR(x, HW_LTC_K80_LPKA0_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_0, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_0_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_0_PKHA_A0. */
#define BM_LTC_K80_LPKA0_0_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_0_PKHA_A0. */
#define BS_LTC_K80_LPKA0_0_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_0_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_0_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_0_PKHA_A0(x)      (HW_LTC_K80_LPKA0_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_0_PKHA_A0. */
#define BF_LTC_K80_LPKA0_0_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_0_PKHA_A0) & BM_LTC_K80_LPKA0_0_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_0_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_1 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_1 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_1_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_1_ADDR(x)        ((x) + 0x804U)
#define HW_LTC_K80_LPKA0_1(x)             (*(__IO hw_ltc_k80_lpka0_1_t *) HW_LTC_K80_LPKA0_1_ADDR(x))
#define HW_LTC_K80_LPKA0_1_RD(x)          (HW_LTC_K80_LPKA0_1(x).U)
#define HW_LTC_K80_LPKA0_1_WR(x, v)       (HW_LTC_K80_LPKA0_1(x).U = (v))
#define HW_LTC_K80_LPKA0_1_SET(x, v)      (HW_LTC_K80_LPKA0_1_WR(x, HW_LTC_K80_LPKA0_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_1_CLR(x, v)      (HW_LTC_K80_LPKA0_1_WR(x, HW_LTC_K80_LPKA0_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_1_TOG(x, v)      (HW_LTC_K80_LPKA0_1_WR(x, HW_LTC_K80_LPKA0_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_1, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_1_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_1_PKHA_A0. */
#define BM_LTC_K80_LPKA0_1_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_1_PKHA_A0. */
#define BS_LTC_K80_LPKA0_1_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_1_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_1_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_1_PKHA_A0(x)      (HW_LTC_K80_LPKA0_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_1_PKHA_A0. */
#define BF_LTC_K80_LPKA0_1_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_1_PKHA_A0) & BM_LTC_K80_LPKA0_1_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_1_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_2 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_2 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_2_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_2_ADDR(x)        ((x) + 0x808U)
#define HW_LTC_K80_LPKA0_2(x)             (*(__IO hw_ltc_k80_lpka0_2_t *) HW_LTC_K80_LPKA0_2_ADDR(x))
#define HW_LTC_K80_LPKA0_2_RD(x)          (HW_LTC_K80_LPKA0_2(x).U)
#define HW_LTC_K80_LPKA0_2_WR(x, v)       (HW_LTC_K80_LPKA0_2(x).U = (v))
#define HW_LTC_K80_LPKA0_2_SET(x, v)      (HW_LTC_K80_LPKA0_2_WR(x, HW_LTC_K80_LPKA0_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_2_CLR(x, v)      (HW_LTC_K80_LPKA0_2_WR(x, HW_LTC_K80_LPKA0_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_2_TOG(x, v)      (HW_LTC_K80_LPKA0_2_WR(x, HW_LTC_K80_LPKA0_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_2, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_2_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_2_PKHA_A0. */
#define BM_LTC_K80_LPKA0_2_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_2_PKHA_A0. */
#define BS_LTC_K80_LPKA0_2_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_2_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_2_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_2_PKHA_A0(x)      (HW_LTC_K80_LPKA0_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_2_PKHA_A0. */
#define BF_LTC_K80_LPKA0_2_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_2_PKHA_A0) & BM_LTC_K80_LPKA0_2_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_2_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_3 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_3 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_3_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_3_ADDR(x)        ((x) + 0x80CU)
#define HW_LTC_K80_LPKA0_3(x)             (*(__IO hw_ltc_k80_lpka0_3_t *) HW_LTC_K80_LPKA0_3_ADDR(x))
#define HW_LTC_K80_LPKA0_3_RD(x)          (HW_LTC_K80_LPKA0_3(x).U)
#define HW_LTC_K80_LPKA0_3_WR(x, v)       (HW_LTC_K80_LPKA0_3(x).U = (v))
#define HW_LTC_K80_LPKA0_3_SET(x, v)      (HW_LTC_K80_LPKA0_3_WR(x, HW_LTC_K80_LPKA0_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_3_CLR(x, v)      (HW_LTC_K80_LPKA0_3_WR(x, HW_LTC_K80_LPKA0_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_3_TOG(x, v)      (HW_LTC_K80_LPKA0_3_WR(x, HW_LTC_K80_LPKA0_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_3, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_3_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_3_PKHA_A0. */
#define BM_LTC_K80_LPKA0_3_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_3_PKHA_A0. */
#define BS_LTC_K80_LPKA0_3_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_3_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_3_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_3_PKHA_A0(x)      (HW_LTC_K80_LPKA0_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_3_PKHA_A0. */
#define BF_LTC_K80_LPKA0_3_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_3_PKHA_A0) & BM_LTC_K80_LPKA0_3_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_3_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_4 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_4 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_4_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_4_ADDR(x)        ((x) + 0x810U)
#define HW_LTC_K80_LPKA0_4(x)             (*(__IO hw_ltc_k80_lpka0_4_t *) HW_LTC_K80_LPKA0_4_ADDR(x))
#define HW_LTC_K80_LPKA0_4_RD(x)          (HW_LTC_K80_LPKA0_4(x).U)
#define HW_LTC_K80_LPKA0_4_WR(x, v)       (HW_LTC_K80_LPKA0_4(x).U = (v))
#define HW_LTC_K80_LPKA0_4_SET(x, v)      (HW_LTC_K80_LPKA0_4_WR(x, HW_LTC_K80_LPKA0_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_4_CLR(x, v)      (HW_LTC_K80_LPKA0_4_WR(x, HW_LTC_K80_LPKA0_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_4_TOG(x, v)      (HW_LTC_K80_LPKA0_4_WR(x, HW_LTC_K80_LPKA0_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_4, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_4_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_4_PKHA_A0. */
#define BM_LTC_K80_LPKA0_4_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_4_PKHA_A0. */
#define BS_LTC_K80_LPKA0_4_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_4_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_4_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_4_PKHA_A0(x)      (HW_LTC_K80_LPKA0_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_4_PKHA_A0. */
#define BF_LTC_K80_LPKA0_4_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_4_PKHA_A0) & BM_LTC_K80_LPKA0_4_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_4_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_5 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_5 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_5_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_5_ADDR(x)        ((x) + 0x814U)
#define HW_LTC_K80_LPKA0_5(x)             (*(__IO hw_ltc_k80_lpka0_5_t *) HW_LTC_K80_LPKA0_5_ADDR(x))
#define HW_LTC_K80_LPKA0_5_RD(x)          (HW_LTC_K80_LPKA0_5(x).U)
#define HW_LTC_K80_LPKA0_5_WR(x, v)       (HW_LTC_K80_LPKA0_5(x).U = (v))
#define HW_LTC_K80_LPKA0_5_SET(x, v)      (HW_LTC_K80_LPKA0_5_WR(x, HW_LTC_K80_LPKA0_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_5_CLR(x, v)      (HW_LTC_K80_LPKA0_5_WR(x, HW_LTC_K80_LPKA0_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_5_TOG(x, v)      (HW_LTC_K80_LPKA0_5_WR(x, HW_LTC_K80_LPKA0_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_5, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_5_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_5_PKHA_A0. */
#define BM_LTC_K80_LPKA0_5_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_5_PKHA_A0. */
#define BS_LTC_K80_LPKA0_5_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_5_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_5_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_5_PKHA_A0(x)      (HW_LTC_K80_LPKA0_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_5_PKHA_A0. */
#define BF_LTC_K80_LPKA0_5_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_5_PKHA_A0) & BM_LTC_K80_LPKA0_5_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_5_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_6 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_6 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_6_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_6_ADDR(x)        ((x) + 0x818U)
#define HW_LTC_K80_LPKA0_6(x)             (*(__IO hw_ltc_k80_lpka0_6_t *) HW_LTC_K80_LPKA0_6_ADDR(x))
#define HW_LTC_K80_LPKA0_6_RD(x)          (HW_LTC_K80_LPKA0_6(x).U)
#define HW_LTC_K80_LPKA0_6_WR(x, v)       (HW_LTC_K80_LPKA0_6(x).U = (v))
#define HW_LTC_K80_LPKA0_6_SET(x, v)      (HW_LTC_K80_LPKA0_6_WR(x, HW_LTC_K80_LPKA0_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_6_CLR(x, v)      (HW_LTC_K80_LPKA0_6_WR(x, HW_LTC_K80_LPKA0_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_6_TOG(x, v)      (HW_LTC_K80_LPKA0_6_WR(x, HW_LTC_K80_LPKA0_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_6, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_6_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_6_PKHA_A0. */
#define BM_LTC_K80_LPKA0_6_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_6_PKHA_A0. */
#define BS_LTC_K80_LPKA0_6_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_6_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_6_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_6_PKHA_A0(x)      (HW_LTC_K80_LPKA0_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_6_PKHA_A0. */
#define BF_LTC_K80_LPKA0_6_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_6_PKHA_A0) & BM_LTC_K80_LPKA0_6_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_6_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_7 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_7 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_7_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_7_ADDR(x)        ((x) + 0x81CU)
#define HW_LTC_K80_LPKA0_7(x)             (*(__IO hw_ltc_k80_lpka0_7_t *) HW_LTC_K80_LPKA0_7_ADDR(x))
#define HW_LTC_K80_LPKA0_7_RD(x)          (HW_LTC_K80_LPKA0_7(x).U)
#define HW_LTC_K80_LPKA0_7_WR(x, v)       (HW_LTC_K80_LPKA0_7(x).U = (v))
#define HW_LTC_K80_LPKA0_7_SET(x, v)      (HW_LTC_K80_LPKA0_7_WR(x, HW_LTC_K80_LPKA0_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_7_CLR(x, v)      (HW_LTC_K80_LPKA0_7_WR(x, HW_LTC_K80_LPKA0_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_7_TOG(x, v)      (HW_LTC_K80_LPKA0_7_WR(x, HW_LTC_K80_LPKA0_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_7, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_7_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_7_PKHA_A0. */
#define BM_LTC_K80_LPKA0_7_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_7_PKHA_A0. */
#define BS_LTC_K80_LPKA0_7_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_7_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_7_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_7_PKHA_A0(x)      (HW_LTC_K80_LPKA0_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_7_PKHA_A0. */
#define BF_LTC_K80_LPKA0_7_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_7_PKHA_A0) & BM_LTC_K80_LPKA0_7_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_7_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_8 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_8 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_8_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_8_ADDR(x)        ((x) + 0x820U)
#define HW_LTC_K80_LPKA0_8(x)             (*(__IO hw_ltc_k80_lpka0_8_t *) HW_LTC_K80_LPKA0_8_ADDR(x))
#define HW_LTC_K80_LPKA0_8_RD(x)          (HW_LTC_K80_LPKA0_8(x).U)
#define HW_LTC_K80_LPKA0_8_WR(x, v)       (HW_LTC_K80_LPKA0_8(x).U = (v))
#define HW_LTC_K80_LPKA0_8_SET(x, v)      (HW_LTC_K80_LPKA0_8_WR(x, HW_LTC_K80_LPKA0_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_8_CLR(x, v)      (HW_LTC_K80_LPKA0_8_WR(x, HW_LTC_K80_LPKA0_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_8_TOG(x, v)      (HW_LTC_K80_LPKA0_8_WR(x, HW_LTC_K80_LPKA0_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_8, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_8_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_8_PKHA_A0. */
#define BM_LTC_K80_LPKA0_8_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_8_PKHA_A0. */
#define BS_LTC_K80_LPKA0_8_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_8_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_8_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_8_PKHA_A0(x)      (HW_LTC_K80_LPKA0_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_8_PKHA_A0. */
#define BF_LTC_K80_LPKA0_8_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_8_PKHA_A0) & BM_LTC_K80_LPKA0_8_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_8_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_9 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_9 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_9_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_9_ADDR(x)        ((x) + 0x824U)
#define HW_LTC_K80_LPKA0_9(x)             (*(__IO hw_ltc_k80_lpka0_9_t *) HW_LTC_K80_LPKA0_9_ADDR(x))
#define HW_LTC_K80_LPKA0_9_RD(x)          (HW_LTC_K80_LPKA0_9(x).U)
#define HW_LTC_K80_LPKA0_9_WR(x, v)       (HW_LTC_K80_LPKA0_9(x).U = (v))
#define HW_LTC_K80_LPKA0_9_SET(x, v)      (HW_LTC_K80_LPKA0_9_WR(x, HW_LTC_K80_LPKA0_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_9_CLR(x, v)      (HW_LTC_K80_LPKA0_9_WR(x, HW_LTC_K80_LPKA0_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_9_TOG(x, v)      (HW_LTC_K80_LPKA0_9_WR(x, HW_LTC_K80_LPKA0_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_9, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_9_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_9_PKHA_A0. */
#define BM_LTC_K80_LPKA0_9_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_9_PKHA_A0. */
#define BS_LTC_K80_LPKA0_9_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_9_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_9_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_9_PKHA_A0(x)      (HW_LTC_K80_LPKA0_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_9_PKHA_A0. */
#define BF_LTC_K80_LPKA0_9_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_9_PKHA_A0) & BM_LTC_K80_LPKA0_9_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_9_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_10 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_10 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_10_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_10_ADDR(x)        ((x) + 0x828U)
#define HW_LTC_K80_LPKA0_10(x)             (*(__IO hw_ltc_k80_lpka0_10_t *) HW_LTC_K80_LPKA0_10_ADDR(x))
#define HW_LTC_K80_LPKA0_10_RD(x)          (HW_LTC_K80_LPKA0_10(x).U)
#define HW_LTC_K80_LPKA0_10_WR(x, v)       (HW_LTC_K80_LPKA0_10(x).U = (v))
#define HW_LTC_K80_LPKA0_10_SET(x, v)      (HW_LTC_K80_LPKA0_10_WR(x, HW_LTC_K80_LPKA0_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_10_CLR(x, v)      (HW_LTC_K80_LPKA0_10_WR(x, HW_LTC_K80_LPKA0_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_10_TOG(x, v)      (HW_LTC_K80_LPKA0_10_WR(x, HW_LTC_K80_LPKA0_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_10, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_10_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_10_PKHA_A0. */
#define BM_LTC_K80_LPKA0_10_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_10_PKHA_A0. */
#define BS_LTC_K80_LPKA0_10_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_10_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_10_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_10_PKHA_A0(x)      (HW_LTC_K80_LPKA0_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_10_PKHA_A0. */
#define BF_LTC_K80_LPKA0_10_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_10_PKHA_A0) & BM_LTC_K80_LPKA0_10_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_10_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_11 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_11 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_11_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_11_ADDR(x)        ((x) + 0x82CU)
#define HW_LTC_K80_LPKA0_11(x)             (*(__IO hw_ltc_k80_lpka0_11_t *) HW_LTC_K80_LPKA0_11_ADDR(x))
#define HW_LTC_K80_LPKA0_11_RD(x)          (HW_LTC_K80_LPKA0_11(x).U)
#define HW_LTC_K80_LPKA0_11_WR(x, v)       (HW_LTC_K80_LPKA0_11(x).U = (v))
#define HW_LTC_K80_LPKA0_11_SET(x, v)      (HW_LTC_K80_LPKA0_11_WR(x, HW_LTC_K80_LPKA0_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_11_CLR(x, v)      (HW_LTC_K80_LPKA0_11_WR(x, HW_LTC_K80_LPKA0_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_11_TOG(x, v)      (HW_LTC_K80_LPKA0_11_WR(x, HW_LTC_K80_LPKA0_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_11, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_11_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_11_PKHA_A0. */
#define BM_LTC_K80_LPKA0_11_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_11_PKHA_A0. */
#define BS_LTC_K80_LPKA0_11_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_11_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_11_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_11_PKHA_A0(x)      (HW_LTC_K80_LPKA0_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_11_PKHA_A0. */
#define BF_LTC_K80_LPKA0_11_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_11_PKHA_A0) & BM_LTC_K80_LPKA0_11_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_11_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_12 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_12 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_12_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_12_ADDR(x)        ((x) + 0x830U)
#define HW_LTC_K80_LPKA0_12(x)             (*(__IO hw_ltc_k80_lpka0_12_t *) HW_LTC_K80_LPKA0_12_ADDR(x))
#define HW_LTC_K80_LPKA0_12_RD(x)          (HW_LTC_K80_LPKA0_12(x).U)
#define HW_LTC_K80_LPKA0_12_WR(x, v)       (HW_LTC_K80_LPKA0_12(x).U = (v))
#define HW_LTC_K80_LPKA0_12_SET(x, v)      (HW_LTC_K80_LPKA0_12_WR(x, HW_LTC_K80_LPKA0_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_12_CLR(x, v)      (HW_LTC_K80_LPKA0_12_WR(x, HW_LTC_K80_LPKA0_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_12_TOG(x, v)      (HW_LTC_K80_LPKA0_12_WR(x, HW_LTC_K80_LPKA0_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_12, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_12_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_12_PKHA_A0. */
#define BM_LTC_K80_LPKA0_12_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_12_PKHA_A0. */
#define BS_LTC_K80_LPKA0_12_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_12_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_12_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_12_PKHA_A0(x)      (HW_LTC_K80_LPKA0_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_12_PKHA_A0. */
#define BF_LTC_K80_LPKA0_12_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_12_PKHA_A0) & BM_LTC_K80_LPKA0_12_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_12_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_13 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_13 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_13_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_13_ADDR(x)        ((x) + 0x834U)
#define HW_LTC_K80_LPKA0_13(x)             (*(__IO hw_ltc_k80_lpka0_13_t *) HW_LTC_K80_LPKA0_13_ADDR(x))
#define HW_LTC_K80_LPKA0_13_RD(x)          (HW_LTC_K80_LPKA0_13(x).U)
#define HW_LTC_K80_LPKA0_13_WR(x, v)       (HW_LTC_K80_LPKA0_13(x).U = (v))
#define HW_LTC_K80_LPKA0_13_SET(x, v)      (HW_LTC_K80_LPKA0_13_WR(x, HW_LTC_K80_LPKA0_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_13_CLR(x, v)      (HW_LTC_K80_LPKA0_13_WR(x, HW_LTC_K80_LPKA0_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_13_TOG(x, v)      (HW_LTC_K80_LPKA0_13_WR(x, HW_LTC_K80_LPKA0_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_13, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_13_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_13_PKHA_A0. */
#define BM_LTC_K80_LPKA0_13_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_13_PKHA_A0. */
#define BS_LTC_K80_LPKA0_13_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_13_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_13_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_13_PKHA_A0(x)      (HW_LTC_K80_LPKA0_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_13_PKHA_A0. */
#define BF_LTC_K80_LPKA0_13_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_13_PKHA_A0) & BM_LTC_K80_LPKA0_13_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_13_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_14 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_14 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_14_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_14_ADDR(x)        ((x) + 0x838U)
#define HW_LTC_K80_LPKA0_14(x)             (*(__IO hw_ltc_k80_lpka0_14_t *) HW_LTC_K80_LPKA0_14_ADDR(x))
#define HW_LTC_K80_LPKA0_14_RD(x)          (HW_LTC_K80_LPKA0_14(x).U)
#define HW_LTC_K80_LPKA0_14_WR(x, v)       (HW_LTC_K80_LPKA0_14(x).U = (v))
#define HW_LTC_K80_LPKA0_14_SET(x, v)      (HW_LTC_K80_LPKA0_14_WR(x, HW_LTC_K80_LPKA0_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_14_CLR(x, v)      (HW_LTC_K80_LPKA0_14_WR(x, HW_LTC_K80_LPKA0_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_14_TOG(x, v)      (HW_LTC_K80_LPKA0_14_WR(x, HW_LTC_K80_LPKA0_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_14, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_14_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_14_PKHA_A0. */
#define BM_LTC_K80_LPKA0_14_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_14_PKHA_A0. */
#define BS_LTC_K80_LPKA0_14_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_14_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_14_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_14_PKHA_A0(x)      (HW_LTC_K80_LPKA0_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_14_PKHA_A0. */
#define BF_LTC_K80_LPKA0_14_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_14_PKHA_A0) & BM_LTC_K80_LPKA0_14_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_14_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA0_15 - LTC PKHA A0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA0_15 - LTC PKHA A0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 800h, in the right-most byte. The LTC PKHA A0 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A0 Register (or
 * {A3, A2, A1, A0}, if used as a single value) is limited by the LTC PKHA A Size Register
 * (LPKASZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpka0_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpka0_15_bitfields
    {
        uint32_t PKHA_A0 : 32; /*!< [31:0] A0 VALUE */
    } B;
} hw_ltc_k80_lpka0_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA0_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKA0_15_ADDR(x)        ((x) + 0x83CU)
#define HW_LTC_K80_LPKA0_15(x)             (*(__IO hw_ltc_k80_lpka0_15_t *) HW_LTC_K80_LPKA0_15_ADDR(x))
#define HW_LTC_K80_LPKA0_15_RD(x)          (HW_LTC_K80_LPKA0_15(x).U)
#define HW_LTC_K80_LPKA0_15_WR(x, v)       (HW_LTC_K80_LPKA0_15(x).U = (v))
#define HW_LTC_K80_LPKA0_15_SET(x, v)      (HW_LTC_K80_LPKA0_15_WR(x, HW_LTC_K80_LPKA0_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKA0_15_CLR(x, v)      (HW_LTC_K80_LPKA0_15_WR(x, HW_LTC_K80_LPKA0_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA0_15_TOG(x, v)      (HW_LTC_K80_LPKA0_15_WR(x, HW_LTC_K80_LPKA0_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA0_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA0_15, field PKHA_A0[31:0] (RW)
 *
 * A0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA0_15_PKHA_A0         (0U)      /*!< Bit position for LTC_K80_LPKA0_15_PKHA_A0. */
#define BM_LTC_K80_LPKA0_15_PKHA_A0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA0_15_PKHA_A0. */
#define BS_LTC_K80_LPKA0_15_PKHA_A0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA0_15_PKHA_A0. */

/*! @brief Read current value of the LTC_K80_LPKA0_15_PKHA_A0 field. */
#define BR_LTC_K80_LPKA0_15_PKHA_A0(x)      (HW_LTC_K80_LPKA0_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA0_15_PKHA_A0. */
#define BF_LTC_K80_LPKA0_15_PKHA_A0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA0_15_PKHA_A0) & BM_LTC_K80_LPKA0_15_PKHA_A0)

/*! @brief Set the PKHA_A0 field to a new value. */
#define BW_LTC_K80_LPKA0_15_PKHA_A0(x, v)   (HW_LTC_K80_LPKA0_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_0 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_0 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_0_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_0_ADDR(x)        ((x) + 0x840U)
#define HW_LTC_K80_LPKA1_0(x)             (*(__IO hw_ltc_k80_lpka1_0_t *) HW_LTC_K80_LPKA1_0_ADDR(x))
#define HW_LTC_K80_LPKA1_0_RD(x)          (HW_LTC_K80_LPKA1_0(x).U)
#define HW_LTC_K80_LPKA1_0_WR(x, v)       (HW_LTC_K80_LPKA1_0(x).U = (v))
#define HW_LTC_K80_LPKA1_0_SET(x, v)      (HW_LTC_K80_LPKA1_0_WR(x, HW_LTC_K80_LPKA1_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_0_CLR(x, v)      (HW_LTC_K80_LPKA1_0_WR(x, HW_LTC_K80_LPKA1_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_0_TOG(x, v)      (HW_LTC_K80_LPKA1_0_WR(x, HW_LTC_K80_LPKA1_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_0, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_0_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_0_PKHA_A1. */
#define BM_LTC_K80_LPKA1_0_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_0_PKHA_A1. */
#define BS_LTC_K80_LPKA1_0_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_0_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_0_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_0_PKHA_A1(x)      (HW_LTC_K80_LPKA1_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_0_PKHA_A1. */
#define BF_LTC_K80_LPKA1_0_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_0_PKHA_A1) & BM_LTC_K80_LPKA1_0_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_0_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_1 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_1 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_1_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_1_ADDR(x)        ((x) + 0x844U)
#define HW_LTC_K80_LPKA1_1(x)             (*(__IO hw_ltc_k80_lpka1_1_t *) HW_LTC_K80_LPKA1_1_ADDR(x))
#define HW_LTC_K80_LPKA1_1_RD(x)          (HW_LTC_K80_LPKA1_1(x).U)
#define HW_LTC_K80_LPKA1_1_WR(x, v)       (HW_LTC_K80_LPKA1_1(x).U = (v))
#define HW_LTC_K80_LPKA1_1_SET(x, v)      (HW_LTC_K80_LPKA1_1_WR(x, HW_LTC_K80_LPKA1_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_1_CLR(x, v)      (HW_LTC_K80_LPKA1_1_WR(x, HW_LTC_K80_LPKA1_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_1_TOG(x, v)      (HW_LTC_K80_LPKA1_1_WR(x, HW_LTC_K80_LPKA1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_1, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_1_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_1_PKHA_A1. */
#define BM_LTC_K80_LPKA1_1_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_1_PKHA_A1. */
#define BS_LTC_K80_LPKA1_1_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_1_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_1_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_1_PKHA_A1(x)      (HW_LTC_K80_LPKA1_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_1_PKHA_A1. */
#define BF_LTC_K80_LPKA1_1_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_1_PKHA_A1) & BM_LTC_K80_LPKA1_1_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_1_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_2 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_2 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_2_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_2_ADDR(x)        ((x) + 0x848U)
#define HW_LTC_K80_LPKA1_2(x)             (*(__IO hw_ltc_k80_lpka1_2_t *) HW_LTC_K80_LPKA1_2_ADDR(x))
#define HW_LTC_K80_LPKA1_2_RD(x)          (HW_LTC_K80_LPKA1_2(x).U)
#define HW_LTC_K80_LPKA1_2_WR(x, v)       (HW_LTC_K80_LPKA1_2(x).U = (v))
#define HW_LTC_K80_LPKA1_2_SET(x, v)      (HW_LTC_K80_LPKA1_2_WR(x, HW_LTC_K80_LPKA1_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_2_CLR(x, v)      (HW_LTC_K80_LPKA1_2_WR(x, HW_LTC_K80_LPKA1_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_2_TOG(x, v)      (HW_LTC_K80_LPKA1_2_WR(x, HW_LTC_K80_LPKA1_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_2, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_2_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_2_PKHA_A1. */
#define BM_LTC_K80_LPKA1_2_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_2_PKHA_A1. */
#define BS_LTC_K80_LPKA1_2_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_2_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_2_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_2_PKHA_A1(x)      (HW_LTC_K80_LPKA1_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_2_PKHA_A1. */
#define BF_LTC_K80_LPKA1_2_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_2_PKHA_A1) & BM_LTC_K80_LPKA1_2_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_2_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_3 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_3 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_3_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_3_ADDR(x)        ((x) + 0x84CU)
#define HW_LTC_K80_LPKA1_3(x)             (*(__IO hw_ltc_k80_lpka1_3_t *) HW_LTC_K80_LPKA1_3_ADDR(x))
#define HW_LTC_K80_LPKA1_3_RD(x)          (HW_LTC_K80_LPKA1_3(x).U)
#define HW_LTC_K80_LPKA1_3_WR(x, v)       (HW_LTC_K80_LPKA1_3(x).U = (v))
#define HW_LTC_K80_LPKA1_3_SET(x, v)      (HW_LTC_K80_LPKA1_3_WR(x, HW_LTC_K80_LPKA1_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_3_CLR(x, v)      (HW_LTC_K80_LPKA1_3_WR(x, HW_LTC_K80_LPKA1_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_3_TOG(x, v)      (HW_LTC_K80_LPKA1_3_WR(x, HW_LTC_K80_LPKA1_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_3, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_3_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_3_PKHA_A1. */
#define BM_LTC_K80_LPKA1_3_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_3_PKHA_A1. */
#define BS_LTC_K80_LPKA1_3_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_3_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_3_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_3_PKHA_A1(x)      (HW_LTC_K80_LPKA1_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_3_PKHA_A1. */
#define BF_LTC_K80_LPKA1_3_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_3_PKHA_A1) & BM_LTC_K80_LPKA1_3_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_3_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_4 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_4 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_4_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_4_ADDR(x)        ((x) + 0x850U)
#define HW_LTC_K80_LPKA1_4(x)             (*(__IO hw_ltc_k80_lpka1_4_t *) HW_LTC_K80_LPKA1_4_ADDR(x))
#define HW_LTC_K80_LPKA1_4_RD(x)          (HW_LTC_K80_LPKA1_4(x).U)
#define HW_LTC_K80_LPKA1_4_WR(x, v)       (HW_LTC_K80_LPKA1_4(x).U = (v))
#define HW_LTC_K80_LPKA1_4_SET(x, v)      (HW_LTC_K80_LPKA1_4_WR(x, HW_LTC_K80_LPKA1_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_4_CLR(x, v)      (HW_LTC_K80_LPKA1_4_WR(x, HW_LTC_K80_LPKA1_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_4_TOG(x, v)      (HW_LTC_K80_LPKA1_4_WR(x, HW_LTC_K80_LPKA1_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_4, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_4_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_4_PKHA_A1. */
#define BM_LTC_K80_LPKA1_4_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_4_PKHA_A1. */
#define BS_LTC_K80_LPKA1_4_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_4_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_4_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_4_PKHA_A1(x)      (HW_LTC_K80_LPKA1_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_4_PKHA_A1. */
#define BF_LTC_K80_LPKA1_4_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_4_PKHA_A1) & BM_LTC_K80_LPKA1_4_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_4_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_5 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_5 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_5_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_5_ADDR(x)        ((x) + 0x854U)
#define HW_LTC_K80_LPKA1_5(x)             (*(__IO hw_ltc_k80_lpka1_5_t *) HW_LTC_K80_LPKA1_5_ADDR(x))
#define HW_LTC_K80_LPKA1_5_RD(x)          (HW_LTC_K80_LPKA1_5(x).U)
#define HW_LTC_K80_LPKA1_5_WR(x, v)       (HW_LTC_K80_LPKA1_5(x).U = (v))
#define HW_LTC_K80_LPKA1_5_SET(x, v)      (HW_LTC_K80_LPKA1_5_WR(x, HW_LTC_K80_LPKA1_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_5_CLR(x, v)      (HW_LTC_K80_LPKA1_5_WR(x, HW_LTC_K80_LPKA1_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_5_TOG(x, v)      (HW_LTC_K80_LPKA1_5_WR(x, HW_LTC_K80_LPKA1_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_5, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_5_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_5_PKHA_A1. */
#define BM_LTC_K80_LPKA1_5_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_5_PKHA_A1. */
#define BS_LTC_K80_LPKA1_5_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_5_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_5_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_5_PKHA_A1(x)      (HW_LTC_K80_LPKA1_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_5_PKHA_A1. */
#define BF_LTC_K80_LPKA1_5_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_5_PKHA_A1) & BM_LTC_K80_LPKA1_5_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_5_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_6 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_6 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_6_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_6_ADDR(x)        ((x) + 0x858U)
#define HW_LTC_K80_LPKA1_6(x)             (*(__IO hw_ltc_k80_lpka1_6_t *) HW_LTC_K80_LPKA1_6_ADDR(x))
#define HW_LTC_K80_LPKA1_6_RD(x)          (HW_LTC_K80_LPKA1_6(x).U)
#define HW_LTC_K80_LPKA1_6_WR(x, v)       (HW_LTC_K80_LPKA1_6(x).U = (v))
#define HW_LTC_K80_LPKA1_6_SET(x, v)      (HW_LTC_K80_LPKA1_6_WR(x, HW_LTC_K80_LPKA1_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_6_CLR(x, v)      (HW_LTC_K80_LPKA1_6_WR(x, HW_LTC_K80_LPKA1_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_6_TOG(x, v)      (HW_LTC_K80_LPKA1_6_WR(x, HW_LTC_K80_LPKA1_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_6, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_6_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_6_PKHA_A1. */
#define BM_LTC_K80_LPKA1_6_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_6_PKHA_A1. */
#define BS_LTC_K80_LPKA1_6_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_6_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_6_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_6_PKHA_A1(x)      (HW_LTC_K80_LPKA1_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_6_PKHA_A1. */
#define BF_LTC_K80_LPKA1_6_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_6_PKHA_A1) & BM_LTC_K80_LPKA1_6_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_6_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_7 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_7 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_7_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_7_ADDR(x)        ((x) + 0x85CU)
#define HW_LTC_K80_LPKA1_7(x)             (*(__IO hw_ltc_k80_lpka1_7_t *) HW_LTC_K80_LPKA1_7_ADDR(x))
#define HW_LTC_K80_LPKA1_7_RD(x)          (HW_LTC_K80_LPKA1_7(x).U)
#define HW_LTC_K80_LPKA1_7_WR(x, v)       (HW_LTC_K80_LPKA1_7(x).U = (v))
#define HW_LTC_K80_LPKA1_7_SET(x, v)      (HW_LTC_K80_LPKA1_7_WR(x, HW_LTC_K80_LPKA1_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_7_CLR(x, v)      (HW_LTC_K80_LPKA1_7_WR(x, HW_LTC_K80_LPKA1_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_7_TOG(x, v)      (HW_LTC_K80_LPKA1_7_WR(x, HW_LTC_K80_LPKA1_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_7, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_7_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_7_PKHA_A1. */
#define BM_LTC_K80_LPKA1_7_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_7_PKHA_A1. */
#define BS_LTC_K80_LPKA1_7_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_7_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_7_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_7_PKHA_A1(x)      (HW_LTC_K80_LPKA1_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_7_PKHA_A1. */
#define BF_LTC_K80_LPKA1_7_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_7_PKHA_A1) & BM_LTC_K80_LPKA1_7_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_7_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_8 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_8 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_8_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_8_ADDR(x)        ((x) + 0x860U)
#define HW_LTC_K80_LPKA1_8(x)             (*(__IO hw_ltc_k80_lpka1_8_t *) HW_LTC_K80_LPKA1_8_ADDR(x))
#define HW_LTC_K80_LPKA1_8_RD(x)          (HW_LTC_K80_LPKA1_8(x).U)
#define HW_LTC_K80_LPKA1_8_WR(x, v)       (HW_LTC_K80_LPKA1_8(x).U = (v))
#define HW_LTC_K80_LPKA1_8_SET(x, v)      (HW_LTC_K80_LPKA1_8_WR(x, HW_LTC_K80_LPKA1_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_8_CLR(x, v)      (HW_LTC_K80_LPKA1_8_WR(x, HW_LTC_K80_LPKA1_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_8_TOG(x, v)      (HW_LTC_K80_LPKA1_8_WR(x, HW_LTC_K80_LPKA1_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_8, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_8_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_8_PKHA_A1. */
#define BM_LTC_K80_LPKA1_8_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_8_PKHA_A1. */
#define BS_LTC_K80_LPKA1_8_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_8_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_8_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_8_PKHA_A1(x)      (HW_LTC_K80_LPKA1_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_8_PKHA_A1. */
#define BF_LTC_K80_LPKA1_8_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_8_PKHA_A1) & BM_LTC_K80_LPKA1_8_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_8_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_9 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_9 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_9_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_9_ADDR(x)        ((x) + 0x864U)
#define HW_LTC_K80_LPKA1_9(x)             (*(__IO hw_ltc_k80_lpka1_9_t *) HW_LTC_K80_LPKA1_9_ADDR(x))
#define HW_LTC_K80_LPKA1_9_RD(x)          (HW_LTC_K80_LPKA1_9(x).U)
#define HW_LTC_K80_LPKA1_9_WR(x, v)       (HW_LTC_K80_LPKA1_9(x).U = (v))
#define HW_LTC_K80_LPKA1_9_SET(x, v)      (HW_LTC_K80_LPKA1_9_WR(x, HW_LTC_K80_LPKA1_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_9_CLR(x, v)      (HW_LTC_K80_LPKA1_9_WR(x, HW_LTC_K80_LPKA1_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_9_TOG(x, v)      (HW_LTC_K80_LPKA1_9_WR(x, HW_LTC_K80_LPKA1_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_9, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_9_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_9_PKHA_A1. */
#define BM_LTC_K80_LPKA1_9_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_9_PKHA_A1. */
#define BS_LTC_K80_LPKA1_9_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_9_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_9_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_9_PKHA_A1(x)      (HW_LTC_K80_LPKA1_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_9_PKHA_A1. */
#define BF_LTC_K80_LPKA1_9_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_9_PKHA_A1) & BM_LTC_K80_LPKA1_9_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_9_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_10 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_10 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_10_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_10_ADDR(x)        ((x) + 0x868U)
#define HW_LTC_K80_LPKA1_10(x)             (*(__IO hw_ltc_k80_lpka1_10_t *) HW_LTC_K80_LPKA1_10_ADDR(x))
#define HW_LTC_K80_LPKA1_10_RD(x)          (HW_LTC_K80_LPKA1_10(x).U)
#define HW_LTC_K80_LPKA1_10_WR(x, v)       (HW_LTC_K80_LPKA1_10(x).U = (v))
#define HW_LTC_K80_LPKA1_10_SET(x, v)      (HW_LTC_K80_LPKA1_10_WR(x, HW_LTC_K80_LPKA1_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_10_CLR(x, v)      (HW_LTC_K80_LPKA1_10_WR(x, HW_LTC_K80_LPKA1_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_10_TOG(x, v)      (HW_LTC_K80_LPKA1_10_WR(x, HW_LTC_K80_LPKA1_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_10, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_10_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_10_PKHA_A1. */
#define BM_LTC_K80_LPKA1_10_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_10_PKHA_A1. */
#define BS_LTC_K80_LPKA1_10_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_10_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_10_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_10_PKHA_A1(x)      (HW_LTC_K80_LPKA1_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_10_PKHA_A1. */
#define BF_LTC_K80_LPKA1_10_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_10_PKHA_A1) & BM_LTC_K80_LPKA1_10_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_10_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_11 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_11 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_11_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_11_ADDR(x)        ((x) + 0x86CU)
#define HW_LTC_K80_LPKA1_11(x)             (*(__IO hw_ltc_k80_lpka1_11_t *) HW_LTC_K80_LPKA1_11_ADDR(x))
#define HW_LTC_K80_LPKA1_11_RD(x)          (HW_LTC_K80_LPKA1_11(x).U)
#define HW_LTC_K80_LPKA1_11_WR(x, v)       (HW_LTC_K80_LPKA1_11(x).U = (v))
#define HW_LTC_K80_LPKA1_11_SET(x, v)      (HW_LTC_K80_LPKA1_11_WR(x, HW_LTC_K80_LPKA1_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_11_CLR(x, v)      (HW_LTC_K80_LPKA1_11_WR(x, HW_LTC_K80_LPKA1_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_11_TOG(x, v)      (HW_LTC_K80_LPKA1_11_WR(x, HW_LTC_K80_LPKA1_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_11, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_11_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_11_PKHA_A1. */
#define BM_LTC_K80_LPKA1_11_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_11_PKHA_A1. */
#define BS_LTC_K80_LPKA1_11_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_11_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_11_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_11_PKHA_A1(x)      (HW_LTC_K80_LPKA1_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_11_PKHA_A1. */
#define BF_LTC_K80_LPKA1_11_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_11_PKHA_A1) & BM_LTC_K80_LPKA1_11_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_11_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_12 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_12 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_12_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_12_ADDR(x)        ((x) + 0x870U)
#define HW_LTC_K80_LPKA1_12(x)             (*(__IO hw_ltc_k80_lpka1_12_t *) HW_LTC_K80_LPKA1_12_ADDR(x))
#define HW_LTC_K80_LPKA1_12_RD(x)          (HW_LTC_K80_LPKA1_12(x).U)
#define HW_LTC_K80_LPKA1_12_WR(x, v)       (HW_LTC_K80_LPKA1_12(x).U = (v))
#define HW_LTC_K80_LPKA1_12_SET(x, v)      (HW_LTC_K80_LPKA1_12_WR(x, HW_LTC_K80_LPKA1_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_12_CLR(x, v)      (HW_LTC_K80_LPKA1_12_WR(x, HW_LTC_K80_LPKA1_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_12_TOG(x, v)      (HW_LTC_K80_LPKA1_12_WR(x, HW_LTC_K80_LPKA1_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_12, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_12_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_12_PKHA_A1. */
#define BM_LTC_K80_LPKA1_12_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_12_PKHA_A1. */
#define BS_LTC_K80_LPKA1_12_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_12_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_12_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_12_PKHA_A1(x)      (HW_LTC_K80_LPKA1_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_12_PKHA_A1. */
#define BF_LTC_K80_LPKA1_12_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_12_PKHA_A1) & BM_LTC_K80_LPKA1_12_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_12_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_13 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_13 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_13_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_13_ADDR(x)        ((x) + 0x874U)
#define HW_LTC_K80_LPKA1_13(x)             (*(__IO hw_ltc_k80_lpka1_13_t *) HW_LTC_K80_LPKA1_13_ADDR(x))
#define HW_LTC_K80_LPKA1_13_RD(x)          (HW_LTC_K80_LPKA1_13(x).U)
#define HW_LTC_K80_LPKA1_13_WR(x, v)       (HW_LTC_K80_LPKA1_13(x).U = (v))
#define HW_LTC_K80_LPKA1_13_SET(x, v)      (HW_LTC_K80_LPKA1_13_WR(x, HW_LTC_K80_LPKA1_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_13_CLR(x, v)      (HW_LTC_K80_LPKA1_13_WR(x, HW_LTC_K80_LPKA1_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_13_TOG(x, v)      (HW_LTC_K80_LPKA1_13_WR(x, HW_LTC_K80_LPKA1_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_13, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_13_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_13_PKHA_A1. */
#define BM_LTC_K80_LPKA1_13_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_13_PKHA_A1. */
#define BS_LTC_K80_LPKA1_13_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_13_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_13_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_13_PKHA_A1(x)      (HW_LTC_K80_LPKA1_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_13_PKHA_A1. */
#define BF_LTC_K80_LPKA1_13_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_13_PKHA_A1) & BM_LTC_K80_LPKA1_13_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_13_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_14 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_14 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_14_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_14_ADDR(x)        ((x) + 0x878U)
#define HW_LTC_K80_LPKA1_14(x)             (*(__IO hw_ltc_k80_lpka1_14_t *) HW_LTC_K80_LPKA1_14_ADDR(x))
#define HW_LTC_K80_LPKA1_14_RD(x)          (HW_LTC_K80_LPKA1_14(x).U)
#define HW_LTC_K80_LPKA1_14_WR(x, v)       (HW_LTC_K80_LPKA1_14(x).U = (v))
#define HW_LTC_K80_LPKA1_14_SET(x, v)      (HW_LTC_K80_LPKA1_14_WR(x, HW_LTC_K80_LPKA1_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_14_CLR(x, v)      (HW_LTC_K80_LPKA1_14_WR(x, HW_LTC_K80_LPKA1_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_14_TOG(x, v)      (HW_LTC_K80_LPKA1_14_WR(x, HW_LTC_K80_LPKA1_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_14, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_14_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_14_PKHA_A1. */
#define BM_LTC_K80_LPKA1_14_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_14_PKHA_A1. */
#define BS_LTC_K80_LPKA1_14_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_14_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_14_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_14_PKHA_A1(x)      (HW_LTC_K80_LPKA1_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_14_PKHA_A1. */
#define BF_LTC_K80_LPKA1_14_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_14_PKHA_A1) & BM_LTC_K80_LPKA1_14_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_14_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA1_15 - LTC PKHA A1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA1_15 - LTC PKHA A1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 840h, in the right-most byte. The LTC PKHA A1 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A1 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka1_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpka1_15_bitfields
    {
        uint32_t PKHA_A1 : 32; /*!< [31:0] A1 VALUE */
    } B;
} hw_ltc_k80_lpka1_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA1_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKA1_15_ADDR(x)        ((x) + 0x87CU)
#define HW_LTC_K80_LPKA1_15(x)             (*(__IO hw_ltc_k80_lpka1_15_t *) HW_LTC_K80_LPKA1_15_ADDR(x))
#define HW_LTC_K80_LPKA1_15_RD(x)          (HW_LTC_K80_LPKA1_15(x).U)
#define HW_LTC_K80_LPKA1_15_WR(x, v)       (HW_LTC_K80_LPKA1_15(x).U = (v))
#define HW_LTC_K80_LPKA1_15_SET(x, v)      (HW_LTC_K80_LPKA1_15_WR(x, HW_LTC_K80_LPKA1_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKA1_15_CLR(x, v)      (HW_LTC_K80_LPKA1_15_WR(x, HW_LTC_K80_LPKA1_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA1_15_TOG(x, v)      (HW_LTC_K80_LPKA1_15_WR(x, HW_LTC_K80_LPKA1_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA1_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA1_15, field PKHA_A1[31:0] (RW)
 *
 * A1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA1_15_PKHA_A1         (0U)      /*!< Bit position for LTC_K80_LPKA1_15_PKHA_A1. */
#define BM_LTC_K80_LPKA1_15_PKHA_A1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA1_15_PKHA_A1. */
#define BS_LTC_K80_LPKA1_15_PKHA_A1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA1_15_PKHA_A1. */

/*! @brief Read current value of the LTC_K80_LPKA1_15_PKHA_A1 field. */
#define BR_LTC_K80_LPKA1_15_PKHA_A1(x)      (HW_LTC_K80_LPKA1_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA1_15_PKHA_A1. */
#define BF_LTC_K80_LPKA1_15_PKHA_A1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA1_15_PKHA_A1) & BM_LTC_K80_LPKA1_15_PKHA_A1)

/*! @brief Set the PKHA_A1 field to a new value. */
#define BW_LTC_K80_LPKA1_15_PKHA_A1(x, v)   (HW_LTC_K80_LPKA1_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_0 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_0 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_0_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_0_ADDR(x)        ((x) + 0x880U)
#define HW_LTC_K80_LPKA2_0(x)             (*(__IO hw_ltc_k80_lpka2_0_t *) HW_LTC_K80_LPKA2_0_ADDR(x))
#define HW_LTC_K80_LPKA2_0_RD(x)          (HW_LTC_K80_LPKA2_0(x).U)
#define HW_LTC_K80_LPKA2_0_WR(x, v)       (HW_LTC_K80_LPKA2_0(x).U = (v))
#define HW_LTC_K80_LPKA2_0_SET(x, v)      (HW_LTC_K80_LPKA2_0_WR(x, HW_LTC_K80_LPKA2_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_0_CLR(x, v)      (HW_LTC_K80_LPKA2_0_WR(x, HW_LTC_K80_LPKA2_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_0_TOG(x, v)      (HW_LTC_K80_LPKA2_0_WR(x, HW_LTC_K80_LPKA2_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_0, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_0_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_0_PKHA_A2. */
#define BM_LTC_K80_LPKA2_0_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_0_PKHA_A2. */
#define BS_LTC_K80_LPKA2_0_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_0_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_0_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_0_PKHA_A2(x)      (HW_LTC_K80_LPKA2_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_0_PKHA_A2. */
#define BF_LTC_K80_LPKA2_0_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_0_PKHA_A2) & BM_LTC_K80_LPKA2_0_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_0_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_1 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_1 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_1_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_1_ADDR(x)        ((x) + 0x884U)
#define HW_LTC_K80_LPKA2_1(x)             (*(__IO hw_ltc_k80_lpka2_1_t *) HW_LTC_K80_LPKA2_1_ADDR(x))
#define HW_LTC_K80_LPKA2_1_RD(x)          (HW_LTC_K80_LPKA2_1(x).U)
#define HW_LTC_K80_LPKA2_1_WR(x, v)       (HW_LTC_K80_LPKA2_1(x).U = (v))
#define HW_LTC_K80_LPKA2_1_SET(x, v)      (HW_LTC_K80_LPKA2_1_WR(x, HW_LTC_K80_LPKA2_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_1_CLR(x, v)      (HW_LTC_K80_LPKA2_1_WR(x, HW_LTC_K80_LPKA2_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_1_TOG(x, v)      (HW_LTC_K80_LPKA2_1_WR(x, HW_LTC_K80_LPKA2_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_1, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_1_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_1_PKHA_A2. */
#define BM_LTC_K80_LPKA2_1_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_1_PKHA_A2. */
#define BS_LTC_K80_LPKA2_1_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_1_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_1_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_1_PKHA_A2(x)      (HW_LTC_K80_LPKA2_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_1_PKHA_A2. */
#define BF_LTC_K80_LPKA2_1_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_1_PKHA_A2) & BM_LTC_K80_LPKA2_1_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_1_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_2 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_2 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_2_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_2_ADDR(x)        ((x) + 0x888U)
#define HW_LTC_K80_LPKA2_2(x)             (*(__IO hw_ltc_k80_lpka2_2_t *) HW_LTC_K80_LPKA2_2_ADDR(x))
#define HW_LTC_K80_LPKA2_2_RD(x)          (HW_LTC_K80_LPKA2_2(x).U)
#define HW_LTC_K80_LPKA2_2_WR(x, v)       (HW_LTC_K80_LPKA2_2(x).U = (v))
#define HW_LTC_K80_LPKA2_2_SET(x, v)      (HW_LTC_K80_LPKA2_2_WR(x, HW_LTC_K80_LPKA2_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_2_CLR(x, v)      (HW_LTC_K80_LPKA2_2_WR(x, HW_LTC_K80_LPKA2_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_2_TOG(x, v)      (HW_LTC_K80_LPKA2_2_WR(x, HW_LTC_K80_LPKA2_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_2, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_2_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_2_PKHA_A2. */
#define BM_LTC_K80_LPKA2_2_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_2_PKHA_A2. */
#define BS_LTC_K80_LPKA2_2_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_2_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_2_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_2_PKHA_A2(x)      (HW_LTC_K80_LPKA2_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_2_PKHA_A2. */
#define BF_LTC_K80_LPKA2_2_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_2_PKHA_A2) & BM_LTC_K80_LPKA2_2_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_2_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_3 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_3 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_3_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_3_ADDR(x)        ((x) + 0x88CU)
#define HW_LTC_K80_LPKA2_3(x)             (*(__IO hw_ltc_k80_lpka2_3_t *) HW_LTC_K80_LPKA2_3_ADDR(x))
#define HW_LTC_K80_LPKA2_3_RD(x)          (HW_LTC_K80_LPKA2_3(x).U)
#define HW_LTC_K80_LPKA2_3_WR(x, v)       (HW_LTC_K80_LPKA2_3(x).U = (v))
#define HW_LTC_K80_LPKA2_3_SET(x, v)      (HW_LTC_K80_LPKA2_3_WR(x, HW_LTC_K80_LPKA2_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_3_CLR(x, v)      (HW_LTC_K80_LPKA2_3_WR(x, HW_LTC_K80_LPKA2_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_3_TOG(x, v)      (HW_LTC_K80_LPKA2_3_WR(x, HW_LTC_K80_LPKA2_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_3, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_3_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_3_PKHA_A2. */
#define BM_LTC_K80_LPKA2_3_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_3_PKHA_A2. */
#define BS_LTC_K80_LPKA2_3_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_3_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_3_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_3_PKHA_A2(x)      (HW_LTC_K80_LPKA2_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_3_PKHA_A2. */
#define BF_LTC_K80_LPKA2_3_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_3_PKHA_A2) & BM_LTC_K80_LPKA2_3_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_3_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_4 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_4 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_4_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_4_ADDR(x)        ((x) + 0x890U)
#define HW_LTC_K80_LPKA2_4(x)             (*(__IO hw_ltc_k80_lpka2_4_t *) HW_LTC_K80_LPKA2_4_ADDR(x))
#define HW_LTC_K80_LPKA2_4_RD(x)          (HW_LTC_K80_LPKA2_4(x).U)
#define HW_LTC_K80_LPKA2_4_WR(x, v)       (HW_LTC_K80_LPKA2_4(x).U = (v))
#define HW_LTC_K80_LPKA2_4_SET(x, v)      (HW_LTC_K80_LPKA2_4_WR(x, HW_LTC_K80_LPKA2_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_4_CLR(x, v)      (HW_LTC_K80_LPKA2_4_WR(x, HW_LTC_K80_LPKA2_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_4_TOG(x, v)      (HW_LTC_K80_LPKA2_4_WR(x, HW_LTC_K80_LPKA2_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_4, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_4_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_4_PKHA_A2. */
#define BM_LTC_K80_LPKA2_4_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_4_PKHA_A2. */
#define BS_LTC_K80_LPKA2_4_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_4_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_4_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_4_PKHA_A2(x)      (HW_LTC_K80_LPKA2_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_4_PKHA_A2. */
#define BF_LTC_K80_LPKA2_4_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_4_PKHA_A2) & BM_LTC_K80_LPKA2_4_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_4_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_5 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_5 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_5_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_5_ADDR(x)        ((x) + 0x894U)
#define HW_LTC_K80_LPKA2_5(x)             (*(__IO hw_ltc_k80_lpka2_5_t *) HW_LTC_K80_LPKA2_5_ADDR(x))
#define HW_LTC_K80_LPKA2_5_RD(x)          (HW_LTC_K80_LPKA2_5(x).U)
#define HW_LTC_K80_LPKA2_5_WR(x, v)       (HW_LTC_K80_LPKA2_5(x).U = (v))
#define HW_LTC_K80_LPKA2_5_SET(x, v)      (HW_LTC_K80_LPKA2_5_WR(x, HW_LTC_K80_LPKA2_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_5_CLR(x, v)      (HW_LTC_K80_LPKA2_5_WR(x, HW_LTC_K80_LPKA2_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_5_TOG(x, v)      (HW_LTC_K80_LPKA2_5_WR(x, HW_LTC_K80_LPKA2_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_5, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_5_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_5_PKHA_A2. */
#define BM_LTC_K80_LPKA2_5_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_5_PKHA_A2. */
#define BS_LTC_K80_LPKA2_5_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_5_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_5_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_5_PKHA_A2(x)      (HW_LTC_K80_LPKA2_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_5_PKHA_A2. */
#define BF_LTC_K80_LPKA2_5_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_5_PKHA_A2) & BM_LTC_K80_LPKA2_5_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_5_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_6 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_6 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_6_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_6_ADDR(x)        ((x) + 0x898U)
#define HW_LTC_K80_LPKA2_6(x)             (*(__IO hw_ltc_k80_lpka2_6_t *) HW_LTC_K80_LPKA2_6_ADDR(x))
#define HW_LTC_K80_LPKA2_6_RD(x)          (HW_LTC_K80_LPKA2_6(x).U)
#define HW_LTC_K80_LPKA2_6_WR(x, v)       (HW_LTC_K80_LPKA2_6(x).U = (v))
#define HW_LTC_K80_LPKA2_6_SET(x, v)      (HW_LTC_K80_LPKA2_6_WR(x, HW_LTC_K80_LPKA2_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_6_CLR(x, v)      (HW_LTC_K80_LPKA2_6_WR(x, HW_LTC_K80_LPKA2_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_6_TOG(x, v)      (HW_LTC_K80_LPKA2_6_WR(x, HW_LTC_K80_LPKA2_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_6, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_6_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_6_PKHA_A2. */
#define BM_LTC_K80_LPKA2_6_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_6_PKHA_A2. */
#define BS_LTC_K80_LPKA2_6_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_6_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_6_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_6_PKHA_A2(x)      (HW_LTC_K80_LPKA2_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_6_PKHA_A2. */
#define BF_LTC_K80_LPKA2_6_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_6_PKHA_A2) & BM_LTC_K80_LPKA2_6_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_6_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_7 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_7 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_7_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_7_ADDR(x)        ((x) + 0x89CU)
#define HW_LTC_K80_LPKA2_7(x)             (*(__IO hw_ltc_k80_lpka2_7_t *) HW_LTC_K80_LPKA2_7_ADDR(x))
#define HW_LTC_K80_LPKA2_7_RD(x)          (HW_LTC_K80_LPKA2_7(x).U)
#define HW_LTC_K80_LPKA2_7_WR(x, v)       (HW_LTC_K80_LPKA2_7(x).U = (v))
#define HW_LTC_K80_LPKA2_7_SET(x, v)      (HW_LTC_K80_LPKA2_7_WR(x, HW_LTC_K80_LPKA2_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_7_CLR(x, v)      (HW_LTC_K80_LPKA2_7_WR(x, HW_LTC_K80_LPKA2_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_7_TOG(x, v)      (HW_LTC_K80_LPKA2_7_WR(x, HW_LTC_K80_LPKA2_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_7, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_7_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_7_PKHA_A2. */
#define BM_LTC_K80_LPKA2_7_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_7_PKHA_A2. */
#define BS_LTC_K80_LPKA2_7_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_7_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_7_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_7_PKHA_A2(x)      (HW_LTC_K80_LPKA2_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_7_PKHA_A2. */
#define BF_LTC_K80_LPKA2_7_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_7_PKHA_A2) & BM_LTC_K80_LPKA2_7_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_7_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_8 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_8 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_8_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_8_ADDR(x)        ((x) + 0x8A0U)
#define HW_LTC_K80_LPKA2_8(x)             (*(__IO hw_ltc_k80_lpka2_8_t *) HW_LTC_K80_LPKA2_8_ADDR(x))
#define HW_LTC_K80_LPKA2_8_RD(x)          (HW_LTC_K80_LPKA2_8(x).U)
#define HW_LTC_K80_LPKA2_8_WR(x, v)       (HW_LTC_K80_LPKA2_8(x).U = (v))
#define HW_LTC_K80_LPKA2_8_SET(x, v)      (HW_LTC_K80_LPKA2_8_WR(x, HW_LTC_K80_LPKA2_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_8_CLR(x, v)      (HW_LTC_K80_LPKA2_8_WR(x, HW_LTC_K80_LPKA2_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_8_TOG(x, v)      (HW_LTC_K80_LPKA2_8_WR(x, HW_LTC_K80_LPKA2_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_8, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_8_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_8_PKHA_A2. */
#define BM_LTC_K80_LPKA2_8_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_8_PKHA_A2. */
#define BS_LTC_K80_LPKA2_8_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_8_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_8_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_8_PKHA_A2(x)      (HW_LTC_K80_LPKA2_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_8_PKHA_A2. */
#define BF_LTC_K80_LPKA2_8_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_8_PKHA_A2) & BM_LTC_K80_LPKA2_8_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_8_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_9 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_9 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_9_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_9_ADDR(x)        ((x) + 0x8A4U)
#define HW_LTC_K80_LPKA2_9(x)             (*(__IO hw_ltc_k80_lpka2_9_t *) HW_LTC_K80_LPKA2_9_ADDR(x))
#define HW_LTC_K80_LPKA2_9_RD(x)          (HW_LTC_K80_LPKA2_9(x).U)
#define HW_LTC_K80_LPKA2_9_WR(x, v)       (HW_LTC_K80_LPKA2_9(x).U = (v))
#define HW_LTC_K80_LPKA2_9_SET(x, v)      (HW_LTC_K80_LPKA2_9_WR(x, HW_LTC_K80_LPKA2_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_9_CLR(x, v)      (HW_LTC_K80_LPKA2_9_WR(x, HW_LTC_K80_LPKA2_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_9_TOG(x, v)      (HW_LTC_K80_LPKA2_9_WR(x, HW_LTC_K80_LPKA2_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_9, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_9_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_9_PKHA_A2. */
#define BM_LTC_K80_LPKA2_9_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_9_PKHA_A2. */
#define BS_LTC_K80_LPKA2_9_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_9_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_9_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_9_PKHA_A2(x)      (HW_LTC_K80_LPKA2_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_9_PKHA_A2. */
#define BF_LTC_K80_LPKA2_9_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_9_PKHA_A2) & BM_LTC_K80_LPKA2_9_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_9_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_10 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_10 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_10_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_10_ADDR(x)        ((x) + 0x8A8U)
#define HW_LTC_K80_LPKA2_10(x)             (*(__IO hw_ltc_k80_lpka2_10_t *) HW_LTC_K80_LPKA2_10_ADDR(x))
#define HW_LTC_K80_LPKA2_10_RD(x)          (HW_LTC_K80_LPKA2_10(x).U)
#define HW_LTC_K80_LPKA2_10_WR(x, v)       (HW_LTC_K80_LPKA2_10(x).U = (v))
#define HW_LTC_K80_LPKA2_10_SET(x, v)      (HW_LTC_K80_LPKA2_10_WR(x, HW_LTC_K80_LPKA2_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_10_CLR(x, v)      (HW_LTC_K80_LPKA2_10_WR(x, HW_LTC_K80_LPKA2_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_10_TOG(x, v)      (HW_LTC_K80_LPKA2_10_WR(x, HW_LTC_K80_LPKA2_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_10, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_10_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_10_PKHA_A2. */
#define BM_LTC_K80_LPKA2_10_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_10_PKHA_A2. */
#define BS_LTC_K80_LPKA2_10_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_10_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_10_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_10_PKHA_A2(x)      (HW_LTC_K80_LPKA2_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_10_PKHA_A2. */
#define BF_LTC_K80_LPKA2_10_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_10_PKHA_A2) & BM_LTC_K80_LPKA2_10_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_10_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_11 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_11 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_11_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_11_ADDR(x)        ((x) + 0x8ACU)
#define HW_LTC_K80_LPKA2_11(x)             (*(__IO hw_ltc_k80_lpka2_11_t *) HW_LTC_K80_LPKA2_11_ADDR(x))
#define HW_LTC_K80_LPKA2_11_RD(x)          (HW_LTC_K80_LPKA2_11(x).U)
#define HW_LTC_K80_LPKA2_11_WR(x, v)       (HW_LTC_K80_LPKA2_11(x).U = (v))
#define HW_LTC_K80_LPKA2_11_SET(x, v)      (HW_LTC_K80_LPKA2_11_WR(x, HW_LTC_K80_LPKA2_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_11_CLR(x, v)      (HW_LTC_K80_LPKA2_11_WR(x, HW_LTC_K80_LPKA2_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_11_TOG(x, v)      (HW_LTC_K80_LPKA2_11_WR(x, HW_LTC_K80_LPKA2_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_11, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_11_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_11_PKHA_A2. */
#define BM_LTC_K80_LPKA2_11_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_11_PKHA_A2. */
#define BS_LTC_K80_LPKA2_11_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_11_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_11_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_11_PKHA_A2(x)      (HW_LTC_K80_LPKA2_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_11_PKHA_A2. */
#define BF_LTC_K80_LPKA2_11_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_11_PKHA_A2) & BM_LTC_K80_LPKA2_11_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_11_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_12 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_12 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_12_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_12_ADDR(x)        ((x) + 0x8B0U)
#define HW_LTC_K80_LPKA2_12(x)             (*(__IO hw_ltc_k80_lpka2_12_t *) HW_LTC_K80_LPKA2_12_ADDR(x))
#define HW_LTC_K80_LPKA2_12_RD(x)          (HW_LTC_K80_LPKA2_12(x).U)
#define HW_LTC_K80_LPKA2_12_WR(x, v)       (HW_LTC_K80_LPKA2_12(x).U = (v))
#define HW_LTC_K80_LPKA2_12_SET(x, v)      (HW_LTC_K80_LPKA2_12_WR(x, HW_LTC_K80_LPKA2_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_12_CLR(x, v)      (HW_LTC_K80_LPKA2_12_WR(x, HW_LTC_K80_LPKA2_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_12_TOG(x, v)      (HW_LTC_K80_LPKA2_12_WR(x, HW_LTC_K80_LPKA2_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_12, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_12_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_12_PKHA_A2. */
#define BM_LTC_K80_LPKA2_12_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_12_PKHA_A2. */
#define BS_LTC_K80_LPKA2_12_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_12_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_12_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_12_PKHA_A2(x)      (HW_LTC_K80_LPKA2_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_12_PKHA_A2. */
#define BF_LTC_K80_LPKA2_12_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_12_PKHA_A2) & BM_LTC_K80_LPKA2_12_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_12_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_13 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_13 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_13_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_13_ADDR(x)        ((x) + 0x8B4U)
#define HW_LTC_K80_LPKA2_13(x)             (*(__IO hw_ltc_k80_lpka2_13_t *) HW_LTC_K80_LPKA2_13_ADDR(x))
#define HW_LTC_K80_LPKA2_13_RD(x)          (HW_LTC_K80_LPKA2_13(x).U)
#define HW_LTC_K80_LPKA2_13_WR(x, v)       (HW_LTC_K80_LPKA2_13(x).U = (v))
#define HW_LTC_K80_LPKA2_13_SET(x, v)      (HW_LTC_K80_LPKA2_13_WR(x, HW_LTC_K80_LPKA2_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_13_CLR(x, v)      (HW_LTC_K80_LPKA2_13_WR(x, HW_LTC_K80_LPKA2_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_13_TOG(x, v)      (HW_LTC_K80_LPKA2_13_WR(x, HW_LTC_K80_LPKA2_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_13, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_13_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_13_PKHA_A2. */
#define BM_LTC_K80_LPKA2_13_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_13_PKHA_A2. */
#define BS_LTC_K80_LPKA2_13_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_13_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_13_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_13_PKHA_A2(x)      (HW_LTC_K80_LPKA2_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_13_PKHA_A2. */
#define BF_LTC_K80_LPKA2_13_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_13_PKHA_A2) & BM_LTC_K80_LPKA2_13_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_13_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_14 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_14 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_14_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_14_ADDR(x)        ((x) + 0x8B8U)
#define HW_LTC_K80_LPKA2_14(x)             (*(__IO hw_ltc_k80_lpka2_14_t *) HW_LTC_K80_LPKA2_14_ADDR(x))
#define HW_LTC_K80_LPKA2_14_RD(x)          (HW_LTC_K80_LPKA2_14(x).U)
#define HW_LTC_K80_LPKA2_14_WR(x, v)       (HW_LTC_K80_LPKA2_14(x).U = (v))
#define HW_LTC_K80_LPKA2_14_SET(x, v)      (HW_LTC_K80_LPKA2_14_WR(x, HW_LTC_K80_LPKA2_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_14_CLR(x, v)      (HW_LTC_K80_LPKA2_14_WR(x, HW_LTC_K80_LPKA2_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_14_TOG(x, v)      (HW_LTC_K80_LPKA2_14_WR(x, HW_LTC_K80_LPKA2_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_14, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_14_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_14_PKHA_A2. */
#define BM_LTC_K80_LPKA2_14_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_14_PKHA_A2. */
#define BS_LTC_K80_LPKA2_14_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_14_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_14_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_14_PKHA_A2(x)      (HW_LTC_K80_LPKA2_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_14_PKHA_A2. */
#define BF_LTC_K80_LPKA2_14_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_14_PKHA_A2) & BM_LTC_K80_LPKA2_14_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_14_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA2_15 - LTC PKHA A2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA2_15 - LTC PKHA A2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 880h, in the right-most byte. The LTC PKHA A2 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A2 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka2_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpka2_15_bitfields
    {
        uint32_t PKHA_A2 : 32; /*!< [31:0] A2 VALUE */
    } B;
} hw_ltc_k80_lpka2_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA2_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKA2_15_ADDR(x)        ((x) + 0x8BCU)
#define HW_LTC_K80_LPKA2_15(x)             (*(__IO hw_ltc_k80_lpka2_15_t *) HW_LTC_K80_LPKA2_15_ADDR(x))
#define HW_LTC_K80_LPKA2_15_RD(x)          (HW_LTC_K80_LPKA2_15(x).U)
#define HW_LTC_K80_LPKA2_15_WR(x, v)       (HW_LTC_K80_LPKA2_15(x).U = (v))
#define HW_LTC_K80_LPKA2_15_SET(x, v)      (HW_LTC_K80_LPKA2_15_WR(x, HW_LTC_K80_LPKA2_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKA2_15_CLR(x, v)      (HW_LTC_K80_LPKA2_15_WR(x, HW_LTC_K80_LPKA2_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA2_15_TOG(x, v)      (HW_LTC_K80_LPKA2_15_WR(x, HW_LTC_K80_LPKA2_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA2_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA2_15, field PKHA_A2[31:0] (RW)
 *
 * A2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA2_15_PKHA_A2         (0U)      /*!< Bit position for LTC_K80_LPKA2_15_PKHA_A2. */
#define BM_LTC_K80_LPKA2_15_PKHA_A2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA2_15_PKHA_A2. */
#define BS_LTC_K80_LPKA2_15_PKHA_A2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA2_15_PKHA_A2. */

/*! @brief Read current value of the LTC_K80_LPKA2_15_PKHA_A2 field. */
#define BR_LTC_K80_LPKA2_15_PKHA_A2(x)      (HW_LTC_K80_LPKA2_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA2_15_PKHA_A2. */
#define BF_LTC_K80_LPKA2_15_PKHA_A2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA2_15_PKHA_A2) & BM_LTC_K80_LPKA2_15_PKHA_A2)

/*! @brief Set the PKHA_A2 field to a new value. */
#define BW_LTC_K80_LPKA2_15_PKHA_A2(x, v)   (HW_LTC_K80_LPKA2_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_0 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_0 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_0_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_0_ADDR(x)        ((x) + 0x8C0U)
#define HW_LTC_K80_LPKA3_0(x)             (*(__IO hw_ltc_k80_lpka3_0_t *) HW_LTC_K80_LPKA3_0_ADDR(x))
#define HW_LTC_K80_LPKA3_0_RD(x)          (HW_LTC_K80_LPKA3_0(x).U)
#define HW_LTC_K80_LPKA3_0_WR(x, v)       (HW_LTC_K80_LPKA3_0(x).U = (v))
#define HW_LTC_K80_LPKA3_0_SET(x, v)      (HW_LTC_K80_LPKA3_0_WR(x, HW_LTC_K80_LPKA3_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_0_CLR(x, v)      (HW_LTC_K80_LPKA3_0_WR(x, HW_LTC_K80_LPKA3_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_0_TOG(x, v)      (HW_LTC_K80_LPKA3_0_WR(x, HW_LTC_K80_LPKA3_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_0, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_0_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_0_PKHA_A3. */
#define BM_LTC_K80_LPKA3_0_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_0_PKHA_A3. */
#define BS_LTC_K80_LPKA3_0_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_0_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_0_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_0_PKHA_A3(x)      (HW_LTC_K80_LPKA3_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_0_PKHA_A3. */
#define BF_LTC_K80_LPKA3_0_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_0_PKHA_A3) & BM_LTC_K80_LPKA3_0_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_0_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_1 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_1 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_1_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_1_ADDR(x)        ((x) + 0x8C4U)
#define HW_LTC_K80_LPKA3_1(x)             (*(__IO hw_ltc_k80_lpka3_1_t *) HW_LTC_K80_LPKA3_1_ADDR(x))
#define HW_LTC_K80_LPKA3_1_RD(x)          (HW_LTC_K80_LPKA3_1(x).U)
#define HW_LTC_K80_LPKA3_1_WR(x, v)       (HW_LTC_K80_LPKA3_1(x).U = (v))
#define HW_LTC_K80_LPKA3_1_SET(x, v)      (HW_LTC_K80_LPKA3_1_WR(x, HW_LTC_K80_LPKA3_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_1_CLR(x, v)      (HW_LTC_K80_LPKA3_1_WR(x, HW_LTC_K80_LPKA3_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_1_TOG(x, v)      (HW_LTC_K80_LPKA3_1_WR(x, HW_LTC_K80_LPKA3_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_1, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_1_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_1_PKHA_A3. */
#define BM_LTC_K80_LPKA3_1_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_1_PKHA_A3. */
#define BS_LTC_K80_LPKA3_1_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_1_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_1_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_1_PKHA_A3(x)      (HW_LTC_K80_LPKA3_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_1_PKHA_A3. */
#define BF_LTC_K80_LPKA3_1_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_1_PKHA_A3) & BM_LTC_K80_LPKA3_1_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_1_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_2 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_2 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_2_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_2_ADDR(x)        ((x) + 0x8C8U)
#define HW_LTC_K80_LPKA3_2(x)             (*(__IO hw_ltc_k80_lpka3_2_t *) HW_LTC_K80_LPKA3_2_ADDR(x))
#define HW_LTC_K80_LPKA3_2_RD(x)          (HW_LTC_K80_LPKA3_2(x).U)
#define HW_LTC_K80_LPKA3_2_WR(x, v)       (HW_LTC_K80_LPKA3_2(x).U = (v))
#define HW_LTC_K80_LPKA3_2_SET(x, v)      (HW_LTC_K80_LPKA3_2_WR(x, HW_LTC_K80_LPKA3_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_2_CLR(x, v)      (HW_LTC_K80_LPKA3_2_WR(x, HW_LTC_K80_LPKA3_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_2_TOG(x, v)      (HW_LTC_K80_LPKA3_2_WR(x, HW_LTC_K80_LPKA3_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_2, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_2_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_2_PKHA_A3. */
#define BM_LTC_K80_LPKA3_2_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_2_PKHA_A3. */
#define BS_LTC_K80_LPKA3_2_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_2_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_2_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_2_PKHA_A3(x)      (HW_LTC_K80_LPKA3_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_2_PKHA_A3. */
#define BF_LTC_K80_LPKA3_2_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_2_PKHA_A3) & BM_LTC_K80_LPKA3_2_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_2_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_3 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_3 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_3_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_3_ADDR(x)        ((x) + 0x8CCU)
#define HW_LTC_K80_LPKA3_3(x)             (*(__IO hw_ltc_k80_lpka3_3_t *) HW_LTC_K80_LPKA3_3_ADDR(x))
#define HW_LTC_K80_LPKA3_3_RD(x)          (HW_LTC_K80_LPKA3_3(x).U)
#define HW_LTC_K80_LPKA3_3_WR(x, v)       (HW_LTC_K80_LPKA3_3(x).U = (v))
#define HW_LTC_K80_LPKA3_3_SET(x, v)      (HW_LTC_K80_LPKA3_3_WR(x, HW_LTC_K80_LPKA3_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_3_CLR(x, v)      (HW_LTC_K80_LPKA3_3_WR(x, HW_LTC_K80_LPKA3_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_3_TOG(x, v)      (HW_LTC_K80_LPKA3_3_WR(x, HW_LTC_K80_LPKA3_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_3, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_3_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_3_PKHA_A3. */
#define BM_LTC_K80_LPKA3_3_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_3_PKHA_A3. */
#define BS_LTC_K80_LPKA3_3_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_3_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_3_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_3_PKHA_A3(x)      (HW_LTC_K80_LPKA3_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_3_PKHA_A3. */
#define BF_LTC_K80_LPKA3_3_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_3_PKHA_A3) & BM_LTC_K80_LPKA3_3_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_3_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_4 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_4 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_4_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_4_ADDR(x)        ((x) + 0x8D0U)
#define HW_LTC_K80_LPKA3_4(x)             (*(__IO hw_ltc_k80_lpka3_4_t *) HW_LTC_K80_LPKA3_4_ADDR(x))
#define HW_LTC_K80_LPKA3_4_RD(x)          (HW_LTC_K80_LPKA3_4(x).U)
#define HW_LTC_K80_LPKA3_4_WR(x, v)       (HW_LTC_K80_LPKA3_4(x).U = (v))
#define HW_LTC_K80_LPKA3_4_SET(x, v)      (HW_LTC_K80_LPKA3_4_WR(x, HW_LTC_K80_LPKA3_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_4_CLR(x, v)      (HW_LTC_K80_LPKA3_4_WR(x, HW_LTC_K80_LPKA3_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_4_TOG(x, v)      (HW_LTC_K80_LPKA3_4_WR(x, HW_LTC_K80_LPKA3_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_4, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_4_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_4_PKHA_A3. */
#define BM_LTC_K80_LPKA3_4_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_4_PKHA_A3. */
#define BS_LTC_K80_LPKA3_4_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_4_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_4_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_4_PKHA_A3(x)      (HW_LTC_K80_LPKA3_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_4_PKHA_A3. */
#define BF_LTC_K80_LPKA3_4_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_4_PKHA_A3) & BM_LTC_K80_LPKA3_4_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_4_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_5 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_5 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_5_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_5_ADDR(x)        ((x) + 0x8D4U)
#define HW_LTC_K80_LPKA3_5(x)             (*(__IO hw_ltc_k80_lpka3_5_t *) HW_LTC_K80_LPKA3_5_ADDR(x))
#define HW_LTC_K80_LPKA3_5_RD(x)          (HW_LTC_K80_LPKA3_5(x).U)
#define HW_LTC_K80_LPKA3_5_WR(x, v)       (HW_LTC_K80_LPKA3_5(x).U = (v))
#define HW_LTC_K80_LPKA3_5_SET(x, v)      (HW_LTC_K80_LPKA3_5_WR(x, HW_LTC_K80_LPKA3_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_5_CLR(x, v)      (HW_LTC_K80_LPKA3_5_WR(x, HW_LTC_K80_LPKA3_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_5_TOG(x, v)      (HW_LTC_K80_LPKA3_5_WR(x, HW_LTC_K80_LPKA3_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_5, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_5_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_5_PKHA_A3. */
#define BM_LTC_K80_LPKA3_5_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_5_PKHA_A3. */
#define BS_LTC_K80_LPKA3_5_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_5_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_5_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_5_PKHA_A3(x)      (HW_LTC_K80_LPKA3_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_5_PKHA_A3. */
#define BF_LTC_K80_LPKA3_5_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_5_PKHA_A3) & BM_LTC_K80_LPKA3_5_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_5_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_6 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_6 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_6_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_6_ADDR(x)        ((x) + 0x8D8U)
#define HW_LTC_K80_LPKA3_6(x)             (*(__IO hw_ltc_k80_lpka3_6_t *) HW_LTC_K80_LPKA3_6_ADDR(x))
#define HW_LTC_K80_LPKA3_6_RD(x)          (HW_LTC_K80_LPKA3_6(x).U)
#define HW_LTC_K80_LPKA3_6_WR(x, v)       (HW_LTC_K80_LPKA3_6(x).U = (v))
#define HW_LTC_K80_LPKA3_6_SET(x, v)      (HW_LTC_K80_LPKA3_6_WR(x, HW_LTC_K80_LPKA3_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_6_CLR(x, v)      (HW_LTC_K80_LPKA3_6_WR(x, HW_LTC_K80_LPKA3_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_6_TOG(x, v)      (HW_LTC_K80_LPKA3_6_WR(x, HW_LTC_K80_LPKA3_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_6, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_6_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_6_PKHA_A3. */
#define BM_LTC_K80_LPKA3_6_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_6_PKHA_A3. */
#define BS_LTC_K80_LPKA3_6_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_6_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_6_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_6_PKHA_A3(x)      (HW_LTC_K80_LPKA3_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_6_PKHA_A3. */
#define BF_LTC_K80_LPKA3_6_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_6_PKHA_A3) & BM_LTC_K80_LPKA3_6_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_6_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_7 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_7 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_7_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_7_ADDR(x)        ((x) + 0x8DCU)
#define HW_LTC_K80_LPKA3_7(x)             (*(__IO hw_ltc_k80_lpka3_7_t *) HW_LTC_K80_LPKA3_7_ADDR(x))
#define HW_LTC_K80_LPKA3_7_RD(x)          (HW_LTC_K80_LPKA3_7(x).U)
#define HW_LTC_K80_LPKA3_7_WR(x, v)       (HW_LTC_K80_LPKA3_7(x).U = (v))
#define HW_LTC_K80_LPKA3_7_SET(x, v)      (HW_LTC_K80_LPKA3_7_WR(x, HW_LTC_K80_LPKA3_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_7_CLR(x, v)      (HW_LTC_K80_LPKA3_7_WR(x, HW_LTC_K80_LPKA3_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_7_TOG(x, v)      (HW_LTC_K80_LPKA3_7_WR(x, HW_LTC_K80_LPKA3_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_7, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_7_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_7_PKHA_A3. */
#define BM_LTC_K80_LPKA3_7_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_7_PKHA_A3. */
#define BS_LTC_K80_LPKA3_7_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_7_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_7_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_7_PKHA_A3(x)      (HW_LTC_K80_LPKA3_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_7_PKHA_A3. */
#define BF_LTC_K80_LPKA3_7_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_7_PKHA_A3) & BM_LTC_K80_LPKA3_7_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_7_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_8 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_8 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_8_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_8_ADDR(x)        ((x) + 0x8E0U)
#define HW_LTC_K80_LPKA3_8(x)             (*(__IO hw_ltc_k80_lpka3_8_t *) HW_LTC_K80_LPKA3_8_ADDR(x))
#define HW_LTC_K80_LPKA3_8_RD(x)          (HW_LTC_K80_LPKA3_8(x).U)
#define HW_LTC_K80_LPKA3_8_WR(x, v)       (HW_LTC_K80_LPKA3_8(x).U = (v))
#define HW_LTC_K80_LPKA3_8_SET(x, v)      (HW_LTC_K80_LPKA3_8_WR(x, HW_LTC_K80_LPKA3_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_8_CLR(x, v)      (HW_LTC_K80_LPKA3_8_WR(x, HW_LTC_K80_LPKA3_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_8_TOG(x, v)      (HW_LTC_K80_LPKA3_8_WR(x, HW_LTC_K80_LPKA3_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_8, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_8_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_8_PKHA_A3. */
#define BM_LTC_K80_LPKA3_8_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_8_PKHA_A3. */
#define BS_LTC_K80_LPKA3_8_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_8_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_8_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_8_PKHA_A3(x)      (HW_LTC_K80_LPKA3_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_8_PKHA_A3. */
#define BF_LTC_K80_LPKA3_8_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_8_PKHA_A3) & BM_LTC_K80_LPKA3_8_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_8_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_9 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_9 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_9_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_9_ADDR(x)        ((x) + 0x8E4U)
#define HW_LTC_K80_LPKA3_9(x)             (*(__IO hw_ltc_k80_lpka3_9_t *) HW_LTC_K80_LPKA3_9_ADDR(x))
#define HW_LTC_K80_LPKA3_9_RD(x)          (HW_LTC_K80_LPKA3_9(x).U)
#define HW_LTC_K80_LPKA3_9_WR(x, v)       (HW_LTC_K80_LPKA3_9(x).U = (v))
#define HW_LTC_K80_LPKA3_9_SET(x, v)      (HW_LTC_K80_LPKA3_9_WR(x, HW_LTC_K80_LPKA3_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_9_CLR(x, v)      (HW_LTC_K80_LPKA3_9_WR(x, HW_LTC_K80_LPKA3_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_9_TOG(x, v)      (HW_LTC_K80_LPKA3_9_WR(x, HW_LTC_K80_LPKA3_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_9, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_9_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_9_PKHA_A3. */
#define BM_LTC_K80_LPKA3_9_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_9_PKHA_A3. */
#define BS_LTC_K80_LPKA3_9_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_9_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_9_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_9_PKHA_A3(x)      (HW_LTC_K80_LPKA3_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_9_PKHA_A3. */
#define BF_LTC_K80_LPKA3_9_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_9_PKHA_A3) & BM_LTC_K80_LPKA3_9_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_9_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_10 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_10 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_10_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_10_ADDR(x)        ((x) + 0x8E8U)
#define HW_LTC_K80_LPKA3_10(x)             (*(__IO hw_ltc_k80_lpka3_10_t *) HW_LTC_K80_LPKA3_10_ADDR(x))
#define HW_LTC_K80_LPKA3_10_RD(x)          (HW_LTC_K80_LPKA3_10(x).U)
#define HW_LTC_K80_LPKA3_10_WR(x, v)       (HW_LTC_K80_LPKA3_10(x).U = (v))
#define HW_LTC_K80_LPKA3_10_SET(x, v)      (HW_LTC_K80_LPKA3_10_WR(x, HW_LTC_K80_LPKA3_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_10_CLR(x, v)      (HW_LTC_K80_LPKA3_10_WR(x, HW_LTC_K80_LPKA3_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_10_TOG(x, v)      (HW_LTC_K80_LPKA3_10_WR(x, HW_LTC_K80_LPKA3_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_10, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_10_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_10_PKHA_A3. */
#define BM_LTC_K80_LPKA3_10_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_10_PKHA_A3. */
#define BS_LTC_K80_LPKA3_10_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_10_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_10_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_10_PKHA_A3(x)      (HW_LTC_K80_LPKA3_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_10_PKHA_A3. */
#define BF_LTC_K80_LPKA3_10_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_10_PKHA_A3) & BM_LTC_K80_LPKA3_10_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_10_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_11 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_11 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_11_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_11_ADDR(x)        ((x) + 0x8ECU)
#define HW_LTC_K80_LPKA3_11(x)             (*(__IO hw_ltc_k80_lpka3_11_t *) HW_LTC_K80_LPKA3_11_ADDR(x))
#define HW_LTC_K80_LPKA3_11_RD(x)          (HW_LTC_K80_LPKA3_11(x).U)
#define HW_LTC_K80_LPKA3_11_WR(x, v)       (HW_LTC_K80_LPKA3_11(x).U = (v))
#define HW_LTC_K80_LPKA3_11_SET(x, v)      (HW_LTC_K80_LPKA3_11_WR(x, HW_LTC_K80_LPKA3_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_11_CLR(x, v)      (HW_LTC_K80_LPKA3_11_WR(x, HW_LTC_K80_LPKA3_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_11_TOG(x, v)      (HW_LTC_K80_LPKA3_11_WR(x, HW_LTC_K80_LPKA3_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_11, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_11_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_11_PKHA_A3. */
#define BM_LTC_K80_LPKA3_11_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_11_PKHA_A3. */
#define BS_LTC_K80_LPKA3_11_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_11_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_11_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_11_PKHA_A3(x)      (HW_LTC_K80_LPKA3_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_11_PKHA_A3. */
#define BF_LTC_K80_LPKA3_11_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_11_PKHA_A3) & BM_LTC_K80_LPKA3_11_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_11_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_12 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_12 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_12_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_12_ADDR(x)        ((x) + 0x8F0U)
#define HW_LTC_K80_LPKA3_12(x)             (*(__IO hw_ltc_k80_lpka3_12_t *) HW_LTC_K80_LPKA3_12_ADDR(x))
#define HW_LTC_K80_LPKA3_12_RD(x)          (HW_LTC_K80_LPKA3_12(x).U)
#define HW_LTC_K80_LPKA3_12_WR(x, v)       (HW_LTC_K80_LPKA3_12(x).U = (v))
#define HW_LTC_K80_LPKA3_12_SET(x, v)      (HW_LTC_K80_LPKA3_12_WR(x, HW_LTC_K80_LPKA3_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_12_CLR(x, v)      (HW_LTC_K80_LPKA3_12_WR(x, HW_LTC_K80_LPKA3_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_12_TOG(x, v)      (HW_LTC_K80_LPKA3_12_WR(x, HW_LTC_K80_LPKA3_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_12, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_12_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_12_PKHA_A3. */
#define BM_LTC_K80_LPKA3_12_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_12_PKHA_A3. */
#define BS_LTC_K80_LPKA3_12_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_12_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_12_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_12_PKHA_A3(x)      (HW_LTC_K80_LPKA3_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_12_PKHA_A3. */
#define BF_LTC_K80_LPKA3_12_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_12_PKHA_A3) & BM_LTC_K80_LPKA3_12_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_12_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_13 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_13 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_13_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_13_ADDR(x)        ((x) + 0x8F4U)
#define HW_LTC_K80_LPKA3_13(x)             (*(__IO hw_ltc_k80_lpka3_13_t *) HW_LTC_K80_LPKA3_13_ADDR(x))
#define HW_LTC_K80_LPKA3_13_RD(x)          (HW_LTC_K80_LPKA3_13(x).U)
#define HW_LTC_K80_LPKA3_13_WR(x, v)       (HW_LTC_K80_LPKA3_13(x).U = (v))
#define HW_LTC_K80_LPKA3_13_SET(x, v)      (HW_LTC_K80_LPKA3_13_WR(x, HW_LTC_K80_LPKA3_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_13_CLR(x, v)      (HW_LTC_K80_LPKA3_13_WR(x, HW_LTC_K80_LPKA3_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_13_TOG(x, v)      (HW_LTC_K80_LPKA3_13_WR(x, HW_LTC_K80_LPKA3_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_13, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_13_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_13_PKHA_A3. */
#define BM_LTC_K80_LPKA3_13_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_13_PKHA_A3. */
#define BS_LTC_K80_LPKA3_13_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_13_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_13_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_13_PKHA_A3(x)      (HW_LTC_K80_LPKA3_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_13_PKHA_A3. */
#define BF_LTC_K80_LPKA3_13_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_13_PKHA_A3) & BM_LTC_K80_LPKA3_13_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_13_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_14 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_14 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_14_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_14_ADDR(x)        ((x) + 0x8F8U)
#define HW_LTC_K80_LPKA3_14(x)             (*(__IO hw_ltc_k80_lpka3_14_t *) HW_LTC_K80_LPKA3_14_ADDR(x))
#define HW_LTC_K80_LPKA3_14_RD(x)          (HW_LTC_K80_LPKA3_14(x).U)
#define HW_LTC_K80_LPKA3_14_WR(x, v)       (HW_LTC_K80_LPKA3_14(x).U = (v))
#define HW_LTC_K80_LPKA3_14_SET(x, v)      (HW_LTC_K80_LPKA3_14_WR(x, HW_LTC_K80_LPKA3_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_14_CLR(x, v)      (HW_LTC_K80_LPKA3_14_WR(x, HW_LTC_K80_LPKA3_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_14_TOG(x, v)      (HW_LTC_K80_LPKA3_14_WR(x, HW_LTC_K80_LPKA3_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_14, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_14_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_14_PKHA_A3. */
#define BM_LTC_K80_LPKA3_14_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_14_PKHA_A3. */
#define BS_LTC_K80_LPKA3_14_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_14_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_14_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_14_PKHA_A3(x)      (HW_LTC_K80_LPKA3_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_14_PKHA_A3. */
#define BF_LTC_K80_LPKA3_14_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_14_PKHA_A3) & BM_LTC_K80_LPKA3_14_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_14_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKA3_15 - LTC PKHA A3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKA3_15 - LTC PKHA A3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA A3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset 8C0h, in the right-most byte. The LTC PKHA A3 register is 512 bits in length. Note
 * that PKHA A3, A2, A1 and A0 Registers may be combined to contain a value of up to 2048 bits, with
 * A0 containing the least-significant 64 bytes of this value. The value in the PKHA A3 Register, if
 * used as a separate value, is limited by the LTC PKHA A Size Register (LPKASZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpka3_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpka3_15_bitfields
    {
        uint32_t PKHA_A3 : 32; /*!< [31:0] A3 VALUE */
    } B;
} hw_ltc_k80_lpka3_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKA3_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKA3_15_ADDR(x)        ((x) + 0x8FCU)
#define HW_LTC_K80_LPKA3_15(x)             (*(__IO hw_ltc_k80_lpka3_15_t *) HW_LTC_K80_LPKA3_15_ADDR(x))
#define HW_LTC_K80_LPKA3_15_RD(x)          (HW_LTC_K80_LPKA3_15(x).U)
#define HW_LTC_K80_LPKA3_15_WR(x, v)       (HW_LTC_K80_LPKA3_15(x).U = (v))
#define HW_LTC_K80_LPKA3_15_SET(x, v)      (HW_LTC_K80_LPKA3_15_WR(x, HW_LTC_K80_LPKA3_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKA3_15_CLR(x, v)      (HW_LTC_K80_LPKA3_15_WR(x, HW_LTC_K80_LPKA3_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKA3_15_TOG(x, v)      (HW_LTC_K80_LPKA3_15_WR(x, HW_LTC_K80_LPKA3_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKA3_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKA3_15, field PKHA_A3[31:0] (RW)
 *
 * A3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKA3_15_PKHA_A3         (0U)      /*!< Bit position for LTC_K80_LPKA3_15_PKHA_A3. */
#define BM_LTC_K80_LPKA3_15_PKHA_A3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKA3_15_PKHA_A3. */
#define BS_LTC_K80_LPKA3_15_PKHA_A3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKA3_15_PKHA_A3. */

/*! @brief Read current value of the LTC_K80_LPKA3_15_PKHA_A3 field. */
#define BR_LTC_K80_LPKA3_15_PKHA_A3(x)      (HW_LTC_K80_LPKA3_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKA3_15_PKHA_A3. */
#define BF_LTC_K80_LPKA3_15_PKHA_A3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKA3_15_PKHA_A3) & BM_LTC_K80_LPKA3_15_PKHA_A3)

/*! @brief Set the PKHA_A3 field to a new value. */
#define BW_LTC_K80_LPKA3_15_PKHA_A3(x, v)   (HW_LTC_K80_LPKA3_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_0 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_0 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_0_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_0_ADDR(x)        ((x) + 0xA00U)
#define HW_LTC_K80_LPKB0_0(x)             (*(__IO hw_ltc_k80_lpkb0_0_t *) HW_LTC_K80_LPKB0_0_ADDR(x))
#define HW_LTC_K80_LPKB0_0_RD(x)          (HW_LTC_K80_LPKB0_0(x).U)
#define HW_LTC_K80_LPKB0_0_WR(x, v)       (HW_LTC_K80_LPKB0_0(x).U = (v))
#define HW_LTC_K80_LPKB0_0_SET(x, v)      (HW_LTC_K80_LPKB0_0_WR(x, HW_LTC_K80_LPKB0_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_0_CLR(x, v)      (HW_LTC_K80_LPKB0_0_WR(x, HW_LTC_K80_LPKB0_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_0_TOG(x, v)      (HW_LTC_K80_LPKB0_0_WR(x, HW_LTC_K80_LPKB0_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_0, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_0_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_0_PKHA_B0. */
#define BM_LTC_K80_LPKB0_0_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_0_PKHA_B0. */
#define BS_LTC_K80_LPKB0_0_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_0_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_0_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_0_PKHA_B0(x)      (HW_LTC_K80_LPKB0_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_0_PKHA_B0. */
#define BF_LTC_K80_LPKB0_0_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_0_PKHA_B0) & BM_LTC_K80_LPKB0_0_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_0_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_1 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_1 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_1_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_1_ADDR(x)        ((x) + 0xA04U)
#define HW_LTC_K80_LPKB0_1(x)             (*(__IO hw_ltc_k80_lpkb0_1_t *) HW_LTC_K80_LPKB0_1_ADDR(x))
#define HW_LTC_K80_LPKB0_1_RD(x)          (HW_LTC_K80_LPKB0_1(x).U)
#define HW_LTC_K80_LPKB0_1_WR(x, v)       (HW_LTC_K80_LPKB0_1(x).U = (v))
#define HW_LTC_K80_LPKB0_1_SET(x, v)      (HW_LTC_K80_LPKB0_1_WR(x, HW_LTC_K80_LPKB0_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_1_CLR(x, v)      (HW_LTC_K80_LPKB0_1_WR(x, HW_LTC_K80_LPKB0_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_1_TOG(x, v)      (HW_LTC_K80_LPKB0_1_WR(x, HW_LTC_K80_LPKB0_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_1, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_1_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_1_PKHA_B0. */
#define BM_LTC_K80_LPKB0_1_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_1_PKHA_B0. */
#define BS_LTC_K80_LPKB0_1_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_1_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_1_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_1_PKHA_B0(x)      (HW_LTC_K80_LPKB0_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_1_PKHA_B0. */
#define BF_LTC_K80_LPKB0_1_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_1_PKHA_B0) & BM_LTC_K80_LPKB0_1_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_1_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_2 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_2 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_2_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_2_ADDR(x)        ((x) + 0xA08U)
#define HW_LTC_K80_LPKB0_2(x)             (*(__IO hw_ltc_k80_lpkb0_2_t *) HW_LTC_K80_LPKB0_2_ADDR(x))
#define HW_LTC_K80_LPKB0_2_RD(x)          (HW_LTC_K80_LPKB0_2(x).U)
#define HW_LTC_K80_LPKB0_2_WR(x, v)       (HW_LTC_K80_LPKB0_2(x).U = (v))
#define HW_LTC_K80_LPKB0_2_SET(x, v)      (HW_LTC_K80_LPKB0_2_WR(x, HW_LTC_K80_LPKB0_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_2_CLR(x, v)      (HW_LTC_K80_LPKB0_2_WR(x, HW_LTC_K80_LPKB0_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_2_TOG(x, v)      (HW_LTC_K80_LPKB0_2_WR(x, HW_LTC_K80_LPKB0_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_2, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_2_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_2_PKHA_B0. */
#define BM_LTC_K80_LPKB0_2_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_2_PKHA_B0. */
#define BS_LTC_K80_LPKB0_2_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_2_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_2_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_2_PKHA_B0(x)      (HW_LTC_K80_LPKB0_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_2_PKHA_B0. */
#define BF_LTC_K80_LPKB0_2_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_2_PKHA_B0) & BM_LTC_K80_LPKB0_2_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_2_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_3 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_3 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_3_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_3_ADDR(x)        ((x) + 0xA0CU)
#define HW_LTC_K80_LPKB0_3(x)             (*(__IO hw_ltc_k80_lpkb0_3_t *) HW_LTC_K80_LPKB0_3_ADDR(x))
#define HW_LTC_K80_LPKB0_3_RD(x)          (HW_LTC_K80_LPKB0_3(x).U)
#define HW_LTC_K80_LPKB0_3_WR(x, v)       (HW_LTC_K80_LPKB0_3(x).U = (v))
#define HW_LTC_K80_LPKB0_3_SET(x, v)      (HW_LTC_K80_LPKB0_3_WR(x, HW_LTC_K80_LPKB0_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_3_CLR(x, v)      (HW_LTC_K80_LPKB0_3_WR(x, HW_LTC_K80_LPKB0_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_3_TOG(x, v)      (HW_LTC_K80_LPKB0_3_WR(x, HW_LTC_K80_LPKB0_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_3, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_3_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_3_PKHA_B0. */
#define BM_LTC_K80_LPKB0_3_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_3_PKHA_B0. */
#define BS_LTC_K80_LPKB0_3_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_3_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_3_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_3_PKHA_B0(x)      (HW_LTC_K80_LPKB0_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_3_PKHA_B0. */
#define BF_LTC_K80_LPKB0_3_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_3_PKHA_B0) & BM_LTC_K80_LPKB0_3_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_3_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_4 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_4 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_4_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_4_ADDR(x)        ((x) + 0xA10U)
#define HW_LTC_K80_LPKB0_4(x)             (*(__IO hw_ltc_k80_lpkb0_4_t *) HW_LTC_K80_LPKB0_4_ADDR(x))
#define HW_LTC_K80_LPKB0_4_RD(x)          (HW_LTC_K80_LPKB0_4(x).U)
#define HW_LTC_K80_LPKB0_4_WR(x, v)       (HW_LTC_K80_LPKB0_4(x).U = (v))
#define HW_LTC_K80_LPKB0_4_SET(x, v)      (HW_LTC_K80_LPKB0_4_WR(x, HW_LTC_K80_LPKB0_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_4_CLR(x, v)      (HW_LTC_K80_LPKB0_4_WR(x, HW_LTC_K80_LPKB0_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_4_TOG(x, v)      (HW_LTC_K80_LPKB0_4_WR(x, HW_LTC_K80_LPKB0_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_4, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_4_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_4_PKHA_B0. */
#define BM_LTC_K80_LPKB0_4_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_4_PKHA_B0. */
#define BS_LTC_K80_LPKB0_4_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_4_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_4_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_4_PKHA_B0(x)      (HW_LTC_K80_LPKB0_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_4_PKHA_B0. */
#define BF_LTC_K80_LPKB0_4_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_4_PKHA_B0) & BM_LTC_K80_LPKB0_4_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_4_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_5 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_5 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_5_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_5_ADDR(x)        ((x) + 0xA14U)
#define HW_LTC_K80_LPKB0_5(x)             (*(__IO hw_ltc_k80_lpkb0_5_t *) HW_LTC_K80_LPKB0_5_ADDR(x))
#define HW_LTC_K80_LPKB0_5_RD(x)          (HW_LTC_K80_LPKB0_5(x).U)
#define HW_LTC_K80_LPKB0_5_WR(x, v)       (HW_LTC_K80_LPKB0_5(x).U = (v))
#define HW_LTC_K80_LPKB0_5_SET(x, v)      (HW_LTC_K80_LPKB0_5_WR(x, HW_LTC_K80_LPKB0_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_5_CLR(x, v)      (HW_LTC_K80_LPKB0_5_WR(x, HW_LTC_K80_LPKB0_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_5_TOG(x, v)      (HW_LTC_K80_LPKB0_5_WR(x, HW_LTC_K80_LPKB0_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_5, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_5_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_5_PKHA_B0. */
#define BM_LTC_K80_LPKB0_5_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_5_PKHA_B0. */
#define BS_LTC_K80_LPKB0_5_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_5_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_5_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_5_PKHA_B0(x)      (HW_LTC_K80_LPKB0_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_5_PKHA_B0. */
#define BF_LTC_K80_LPKB0_5_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_5_PKHA_B0) & BM_LTC_K80_LPKB0_5_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_5_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_6 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_6 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_6_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_6_ADDR(x)        ((x) + 0xA18U)
#define HW_LTC_K80_LPKB0_6(x)             (*(__IO hw_ltc_k80_lpkb0_6_t *) HW_LTC_K80_LPKB0_6_ADDR(x))
#define HW_LTC_K80_LPKB0_6_RD(x)          (HW_LTC_K80_LPKB0_6(x).U)
#define HW_LTC_K80_LPKB0_6_WR(x, v)       (HW_LTC_K80_LPKB0_6(x).U = (v))
#define HW_LTC_K80_LPKB0_6_SET(x, v)      (HW_LTC_K80_LPKB0_6_WR(x, HW_LTC_K80_LPKB0_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_6_CLR(x, v)      (HW_LTC_K80_LPKB0_6_WR(x, HW_LTC_K80_LPKB0_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_6_TOG(x, v)      (HW_LTC_K80_LPKB0_6_WR(x, HW_LTC_K80_LPKB0_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_6, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_6_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_6_PKHA_B0. */
#define BM_LTC_K80_LPKB0_6_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_6_PKHA_B0. */
#define BS_LTC_K80_LPKB0_6_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_6_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_6_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_6_PKHA_B0(x)      (HW_LTC_K80_LPKB0_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_6_PKHA_B0. */
#define BF_LTC_K80_LPKB0_6_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_6_PKHA_B0) & BM_LTC_K80_LPKB0_6_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_6_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_7 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_7 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_7_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_7_ADDR(x)        ((x) + 0xA1CU)
#define HW_LTC_K80_LPKB0_7(x)             (*(__IO hw_ltc_k80_lpkb0_7_t *) HW_LTC_K80_LPKB0_7_ADDR(x))
#define HW_LTC_K80_LPKB0_7_RD(x)          (HW_LTC_K80_LPKB0_7(x).U)
#define HW_LTC_K80_LPKB0_7_WR(x, v)       (HW_LTC_K80_LPKB0_7(x).U = (v))
#define HW_LTC_K80_LPKB0_7_SET(x, v)      (HW_LTC_K80_LPKB0_7_WR(x, HW_LTC_K80_LPKB0_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_7_CLR(x, v)      (HW_LTC_K80_LPKB0_7_WR(x, HW_LTC_K80_LPKB0_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_7_TOG(x, v)      (HW_LTC_K80_LPKB0_7_WR(x, HW_LTC_K80_LPKB0_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_7, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_7_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_7_PKHA_B0. */
#define BM_LTC_K80_LPKB0_7_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_7_PKHA_B0. */
#define BS_LTC_K80_LPKB0_7_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_7_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_7_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_7_PKHA_B0(x)      (HW_LTC_K80_LPKB0_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_7_PKHA_B0. */
#define BF_LTC_K80_LPKB0_7_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_7_PKHA_B0) & BM_LTC_K80_LPKB0_7_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_7_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_8 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_8 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_8_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_8_ADDR(x)        ((x) + 0xA20U)
#define HW_LTC_K80_LPKB0_8(x)             (*(__IO hw_ltc_k80_lpkb0_8_t *) HW_LTC_K80_LPKB0_8_ADDR(x))
#define HW_LTC_K80_LPKB0_8_RD(x)          (HW_LTC_K80_LPKB0_8(x).U)
#define HW_LTC_K80_LPKB0_8_WR(x, v)       (HW_LTC_K80_LPKB0_8(x).U = (v))
#define HW_LTC_K80_LPKB0_8_SET(x, v)      (HW_LTC_K80_LPKB0_8_WR(x, HW_LTC_K80_LPKB0_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_8_CLR(x, v)      (HW_LTC_K80_LPKB0_8_WR(x, HW_LTC_K80_LPKB0_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_8_TOG(x, v)      (HW_LTC_K80_LPKB0_8_WR(x, HW_LTC_K80_LPKB0_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_8, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_8_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_8_PKHA_B0. */
#define BM_LTC_K80_LPKB0_8_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_8_PKHA_B0. */
#define BS_LTC_K80_LPKB0_8_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_8_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_8_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_8_PKHA_B0(x)      (HW_LTC_K80_LPKB0_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_8_PKHA_B0. */
#define BF_LTC_K80_LPKB0_8_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_8_PKHA_B0) & BM_LTC_K80_LPKB0_8_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_8_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_9 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_9 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_9_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_9_ADDR(x)        ((x) + 0xA24U)
#define HW_LTC_K80_LPKB0_9(x)             (*(__IO hw_ltc_k80_lpkb0_9_t *) HW_LTC_K80_LPKB0_9_ADDR(x))
#define HW_LTC_K80_LPKB0_9_RD(x)          (HW_LTC_K80_LPKB0_9(x).U)
#define HW_LTC_K80_LPKB0_9_WR(x, v)       (HW_LTC_K80_LPKB0_9(x).U = (v))
#define HW_LTC_K80_LPKB0_9_SET(x, v)      (HW_LTC_K80_LPKB0_9_WR(x, HW_LTC_K80_LPKB0_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_9_CLR(x, v)      (HW_LTC_K80_LPKB0_9_WR(x, HW_LTC_K80_LPKB0_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_9_TOG(x, v)      (HW_LTC_K80_LPKB0_9_WR(x, HW_LTC_K80_LPKB0_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_9, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_9_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_9_PKHA_B0. */
#define BM_LTC_K80_LPKB0_9_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_9_PKHA_B0. */
#define BS_LTC_K80_LPKB0_9_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_9_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_9_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_9_PKHA_B0(x)      (HW_LTC_K80_LPKB0_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_9_PKHA_B0. */
#define BF_LTC_K80_LPKB0_9_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_9_PKHA_B0) & BM_LTC_K80_LPKB0_9_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_9_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_10 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_10 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_10_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_10_ADDR(x)        ((x) + 0xA28U)
#define HW_LTC_K80_LPKB0_10(x)             (*(__IO hw_ltc_k80_lpkb0_10_t *) HW_LTC_K80_LPKB0_10_ADDR(x))
#define HW_LTC_K80_LPKB0_10_RD(x)          (HW_LTC_K80_LPKB0_10(x).U)
#define HW_LTC_K80_LPKB0_10_WR(x, v)       (HW_LTC_K80_LPKB0_10(x).U = (v))
#define HW_LTC_K80_LPKB0_10_SET(x, v)      (HW_LTC_K80_LPKB0_10_WR(x, HW_LTC_K80_LPKB0_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_10_CLR(x, v)      (HW_LTC_K80_LPKB0_10_WR(x, HW_LTC_K80_LPKB0_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_10_TOG(x, v)      (HW_LTC_K80_LPKB0_10_WR(x, HW_LTC_K80_LPKB0_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_10, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_10_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_10_PKHA_B0. */
#define BM_LTC_K80_LPKB0_10_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_10_PKHA_B0. */
#define BS_LTC_K80_LPKB0_10_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_10_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_10_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_10_PKHA_B0(x)      (HW_LTC_K80_LPKB0_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_10_PKHA_B0. */
#define BF_LTC_K80_LPKB0_10_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_10_PKHA_B0) & BM_LTC_K80_LPKB0_10_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_10_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_11 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_11 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_11_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_11_ADDR(x)        ((x) + 0xA2CU)
#define HW_LTC_K80_LPKB0_11(x)             (*(__IO hw_ltc_k80_lpkb0_11_t *) HW_LTC_K80_LPKB0_11_ADDR(x))
#define HW_LTC_K80_LPKB0_11_RD(x)          (HW_LTC_K80_LPKB0_11(x).U)
#define HW_LTC_K80_LPKB0_11_WR(x, v)       (HW_LTC_K80_LPKB0_11(x).U = (v))
#define HW_LTC_K80_LPKB0_11_SET(x, v)      (HW_LTC_K80_LPKB0_11_WR(x, HW_LTC_K80_LPKB0_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_11_CLR(x, v)      (HW_LTC_K80_LPKB0_11_WR(x, HW_LTC_K80_LPKB0_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_11_TOG(x, v)      (HW_LTC_K80_LPKB0_11_WR(x, HW_LTC_K80_LPKB0_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_11, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_11_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_11_PKHA_B0. */
#define BM_LTC_K80_LPKB0_11_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_11_PKHA_B0. */
#define BS_LTC_K80_LPKB0_11_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_11_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_11_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_11_PKHA_B0(x)      (HW_LTC_K80_LPKB0_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_11_PKHA_B0. */
#define BF_LTC_K80_LPKB0_11_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_11_PKHA_B0) & BM_LTC_K80_LPKB0_11_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_11_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_12 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_12 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_12_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_12_ADDR(x)        ((x) + 0xA30U)
#define HW_LTC_K80_LPKB0_12(x)             (*(__IO hw_ltc_k80_lpkb0_12_t *) HW_LTC_K80_LPKB0_12_ADDR(x))
#define HW_LTC_K80_LPKB0_12_RD(x)          (HW_LTC_K80_LPKB0_12(x).U)
#define HW_LTC_K80_LPKB0_12_WR(x, v)       (HW_LTC_K80_LPKB0_12(x).U = (v))
#define HW_LTC_K80_LPKB0_12_SET(x, v)      (HW_LTC_K80_LPKB0_12_WR(x, HW_LTC_K80_LPKB0_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_12_CLR(x, v)      (HW_LTC_K80_LPKB0_12_WR(x, HW_LTC_K80_LPKB0_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_12_TOG(x, v)      (HW_LTC_K80_LPKB0_12_WR(x, HW_LTC_K80_LPKB0_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_12, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_12_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_12_PKHA_B0. */
#define BM_LTC_K80_LPKB0_12_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_12_PKHA_B0. */
#define BS_LTC_K80_LPKB0_12_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_12_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_12_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_12_PKHA_B0(x)      (HW_LTC_K80_LPKB0_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_12_PKHA_B0. */
#define BF_LTC_K80_LPKB0_12_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_12_PKHA_B0) & BM_LTC_K80_LPKB0_12_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_12_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_13 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_13 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_13_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_13_ADDR(x)        ((x) + 0xA34U)
#define HW_LTC_K80_LPKB0_13(x)             (*(__IO hw_ltc_k80_lpkb0_13_t *) HW_LTC_K80_LPKB0_13_ADDR(x))
#define HW_LTC_K80_LPKB0_13_RD(x)          (HW_LTC_K80_LPKB0_13(x).U)
#define HW_LTC_K80_LPKB0_13_WR(x, v)       (HW_LTC_K80_LPKB0_13(x).U = (v))
#define HW_LTC_K80_LPKB0_13_SET(x, v)      (HW_LTC_K80_LPKB0_13_WR(x, HW_LTC_K80_LPKB0_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_13_CLR(x, v)      (HW_LTC_K80_LPKB0_13_WR(x, HW_LTC_K80_LPKB0_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_13_TOG(x, v)      (HW_LTC_K80_LPKB0_13_WR(x, HW_LTC_K80_LPKB0_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_13, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_13_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_13_PKHA_B0. */
#define BM_LTC_K80_LPKB0_13_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_13_PKHA_B0. */
#define BS_LTC_K80_LPKB0_13_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_13_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_13_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_13_PKHA_B0(x)      (HW_LTC_K80_LPKB0_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_13_PKHA_B0. */
#define BF_LTC_K80_LPKB0_13_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_13_PKHA_B0) & BM_LTC_K80_LPKB0_13_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_13_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_14 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_14 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_14_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_14_ADDR(x)        ((x) + 0xA38U)
#define HW_LTC_K80_LPKB0_14(x)             (*(__IO hw_ltc_k80_lpkb0_14_t *) HW_LTC_K80_LPKB0_14_ADDR(x))
#define HW_LTC_K80_LPKB0_14_RD(x)          (HW_LTC_K80_LPKB0_14(x).U)
#define HW_LTC_K80_LPKB0_14_WR(x, v)       (HW_LTC_K80_LPKB0_14(x).U = (v))
#define HW_LTC_K80_LPKB0_14_SET(x, v)      (HW_LTC_K80_LPKB0_14_WR(x, HW_LTC_K80_LPKB0_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_14_CLR(x, v)      (HW_LTC_K80_LPKB0_14_WR(x, HW_LTC_K80_LPKB0_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_14_TOG(x, v)      (HW_LTC_K80_LPKB0_14_WR(x, HW_LTC_K80_LPKB0_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_14, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_14_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_14_PKHA_B0. */
#define BM_LTC_K80_LPKB0_14_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_14_PKHA_B0. */
#define BS_LTC_K80_LPKB0_14_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_14_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_14_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_14_PKHA_B0(x)      (HW_LTC_K80_LPKB0_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_14_PKHA_B0. */
#define BF_LTC_K80_LPKB0_14_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_14_PKHA_B0) & BM_LTC_K80_LPKB0_14_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_14_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB0_15 - LTC PKHA B0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB0_15 - LTC PKHA B0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A00h, in the right-most byte. The LTC PKHA B0 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B0 Register (or
 * in {B3, B2, B1, B0} if used as a single value) is limited by the LTC PKHA B Size Register
 * (LPKBSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkb0_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb0_15_bitfields
    {
        uint32_t PKHA_B0 : 32; /*!< [31:0] B0 VALUE */
    } B;
} hw_ltc_k80_lpkb0_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB0_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKB0_15_ADDR(x)        ((x) + 0xA3CU)
#define HW_LTC_K80_LPKB0_15(x)             (*(__IO hw_ltc_k80_lpkb0_15_t *) HW_LTC_K80_LPKB0_15_ADDR(x))
#define HW_LTC_K80_LPKB0_15_RD(x)          (HW_LTC_K80_LPKB0_15(x).U)
#define HW_LTC_K80_LPKB0_15_WR(x, v)       (HW_LTC_K80_LPKB0_15(x).U = (v))
#define HW_LTC_K80_LPKB0_15_SET(x, v)      (HW_LTC_K80_LPKB0_15_WR(x, HW_LTC_K80_LPKB0_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKB0_15_CLR(x, v)      (HW_LTC_K80_LPKB0_15_WR(x, HW_LTC_K80_LPKB0_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB0_15_TOG(x, v)      (HW_LTC_K80_LPKB0_15_WR(x, HW_LTC_K80_LPKB0_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB0_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB0_15, field PKHA_B0[31:0] (RW)
 *
 * B0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB0_15_PKHA_B0         (0U)      /*!< Bit position for LTC_K80_LPKB0_15_PKHA_B0. */
#define BM_LTC_K80_LPKB0_15_PKHA_B0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB0_15_PKHA_B0. */
#define BS_LTC_K80_LPKB0_15_PKHA_B0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB0_15_PKHA_B0. */

/*! @brief Read current value of the LTC_K80_LPKB0_15_PKHA_B0 field. */
#define BR_LTC_K80_LPKB0_15_PKHA_B0(x)      (HW_LTC_K80_LPKB0_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB0_15_PKHA_B0. */
#define BF_LTC_K80_LPKB0_15_PKHA_B0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB0_15_PKHA_B0) & BM_LTC_K80_LPKB0_15_PKHA_B0)

/*! @brief Set the PKHA_B0 field to a new value. */
#define BW_LTC_K80_LPKB0_15_PKHA_B0(x, v)   (HW_LTC_K80_LPKB0_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_0 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_0 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_0_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_0_ADDR(x)        ((x) + 0xA40U)
#define HW_LTC_K80_LPKB1_0(x)             (*(__IO hw_ltc_k80_lpkb1_0_t *) HW_LTC_K80_LPKB1_0_ADDR(x))
#define HW_LTC_K80_LPKB1_0_RD(x)          (HW_LTC_K80_LPKB1_0(x).U)
#define HW_LTC_K80_LPKB1_0_WR(x, v)       (HW_LTC_K80_LPKB1_0(x).U = (v))
#define HW_LTC_K80_LPKB1_0_SET(x, v)      (HW_LTC_K80_LPKB1_0_WR(x, HW_LTC_K80_LPKB1_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_0_CLR(x, v)      (HW_LTC_K80_LPKB1_0_WR(x, HW_LTC_K80_LPKB1_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_0_TOG(x, v)      (HW_LTC_K80_LPKB1_0_WR(x, HW_LTC_K80_LPKB1_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_0, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_0_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_0_PKHA_B1. */
#define BM_LTC_K80_LPKB1_0_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_0_PKHA_B1. */
#define BS_LTC_K80_LPKB1_0_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_0_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_0_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_0_PKHA_B1(x)      (HW_LTC_K80_LPKB1_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_0_PKHA_B1. */
#define BF_LTC_K80_LPKB1_0_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_0_PKHA_B1) & BM_LTC_K80_LPKB1_0_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_0_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_1 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_1 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_1_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_1_ADDR(x)        ((x) + 0xA44U)
#define HW_LTC_K80_LPKB1_1(x)             (*(__IO hw_ltc_k80_lpkb1_1_t *) HW_LTC_K80_LPKB1_1_ADDR(x))
#define HW_LTC_K80_LPKB1_1_RD(x)          (HW_LTC_K80_LPKB1_1(x).U)
#define HW_LTC_K80_LPKB1_1_WR(x, v)       (HW_LTC_K80_LPKB1_1(x).U = (v))
#define HW_LTC_K80_LPKB1_1_SET(x, v)      (HW_LTC_K80_LPKB1_1_WR(x, HW_LTC_K80_LPKB1_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_1_CLR(x, v)      (HW_LTC_K80_LPKB1_1_WR(x, HW_LTC_K80_LPKB1_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_1_TOG(x, v)      (HW_LTC_K80_LPKB1_1_WR(x, HW_LTC_K80_LPKB1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_1, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_1_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_1_PKHA_B1. */
#define BM_LTC_K80_LPKB1_1_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_1_PKHA_B1. */
#define BS_LTC_K80_LPKB1_1_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_1_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_1_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_1_PKHA_B1(x)      (HW_LTC_K80_LPKB1_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_1_PKHA_B1. */
#define BF_LTC_K80_LPKB1_1_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_1_PKHA_B1) & BM_LTC_K80_LPKB1_1_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_1_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_2 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_2 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_2_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_2_ADDR(x)        ((x) + 0xA48U)
#define HW_LTC_K80_LPKB1_2(x)             (*(__IO hw_ltc_k80_lpkb1_2_t *) HW_LTC_K80_LPKB1_2_ADDR(x))
#define HW_LTC_K80_LPKB1_2_RD(x)          (HW_LTC_K80_LPKB1_2(x).U)
#define HW_LTC_K80_LPKB1_2_WR(x, v)       (HW_LTC_K80_LPKB1_2(x).U = (v))
#define HW_LTC_K80_LPKB1_2_SET(x, v)      (HW_LTC_K80_LPKB1_2_WR(x, HW_LTC_K80_LPKB1_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_2_CLR(x, v)      (HW_LTC_K80_LPKB1_2_WR(x, HW_LTC_K80_LPKB1_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_2_TOG(x, v)      (HW_LTC_K80_LPKB1_2_WR(x, HW_LTC_K80_LPKB1_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_2, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_2_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_2_PKHA_B1. */
#define BM_LTC_K80_LPKB1_2_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_2_PKHA_B1. */
#define BS_LTC_K80_LPKB1_2_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_2_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_2_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_2_PKHA_B1(x)      (HW_LTC_K80_LPKB1_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_2_PKHA_B1. */
#define BF_LTC_K80_LPKB1_2_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_2_PKHA_B1) & BM_LTC_K80_LPKB1_2_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_2_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_3 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_3 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_3_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_3_ADDR(x)        ((x) + 0xA4CU)
#define HW_LTC_K80_LPKB1_3(x)             (*(__IO hw_ltc_k80_lpkb1_3_t *) HW_LTC_K80_LPKB1_3_ADDR(x))
#define HW_LTC_K80_LPKB1_3_RD(x)          (HW_LTC_K80_LPKB1_3(x).U)
#define HW_LTC_K80_LPKB1_3_WR(x, v)       (HW_LTC_K80_LPKB1_3(x).U = (v))
#define HW_LTC_K80_LPKB1_3_SET(x, v)      (HW_LTC_K80_LPKB1_3_WR(x, HW_LTC_K80_LPKB1_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_3_CLR(x, v)      (HW_LTC_K80_LPKB1_3_WR(x, HW_LTC_K80_LPKB1_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_3_TOG(x, v)      (HW_LTC_K80_LPKB1_3_WR(x, HW_LTC_K80_LPKB1_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_3, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_3_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_3_PKHA_B1. */
#define BM_LTC_K80_LPKB1_3_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_3_PKHA_B1. */
#define BS_LTC_K80_LPKB1_3_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_3_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_3_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_3_PKHA_B1(x)      (HW_LTC_K80_LPKB1_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_3_PKHA_B1. */
#define BF_LTC_K80_LPKB1_3_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_3_PKHA_B1) & BM_LTC_K80_LPKB1_3_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_3_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_4 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_4 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_4_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_4_ADDR(x)        ((x) + 0xA50U)
#define HW_LTC_K80_LPKB1_4(x)             (*(__IO hw_ltc_k80_lpkb1_4_t *) HW_LTC_K80_LPKB1_4_ADDR(x))
#define HW_LTC_K80_LPKB1_4_RD(x)          (HW_LTC_K80_LPKB1_4(x).U)
#define HW_LTC_K80_LPKB1_4_WR(x, v)       (HW_LTC_K80_LPKB1_4(x).U = (v))
#define HW_LTC_K80_LPKB1_4_SET(x, v)      (HW_LTC_K80_LPKB1_4_WR(x, HW_LTC_K80_LPKB1_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_4_CLR(x, v)      (HW_LTC_K80_LPKB1_4_WR(x, HW_LTC_K80_LPKB1_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_4_TOG(x, v)      (HW_LTC_K80_LPKB1_4_WR(x, HW_LTC_K80_LPKB1_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_4, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_4_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_4_PKHA_B1. */
#define BM_LTC_K80_LPKB1_4_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_4_PKHA_B1. */
#define BS_LTC_K80_LPKB1_4_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_4_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_4_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_4_PKHA_B1(x)      (HW_LTC_K80_LPKB1_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_4_PKHA_B1. */
#define BF_LTC_K80_LPKB1_4_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_4_PKHA_B1) & BM_LTC_K80_LPKB1_4_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_4_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_5 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_5 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_5_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_5_ADDR(x)        ((x) + 0xA54U)
#define HW_LTC_K80_LPKB1_5(x)             (*(__IO hw_ltc_k80_lpkb1_5_t *) HW_LTC_K80_LPKB1_5_ADDR(x))
#define HW_LTC_K80_LPKB1_5_RD(x)          (HW_LTC_K80_LPKB1_5(x).U)
#define HW_LTC_K80_LPKB1_5_WR(x, v)       (HW_LTC_K80_LPKB1_5(x).U = (v))
#define HW_LTC_K80_LPKB1_5_SET(x, v)      (HW_LTC_K80_LPKB1_5_WR(x, HW_LTC_K80_LPKB1_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_5_CLR(x, v)      (HW_LTC_K80_LPKB1_5_WR(x, HW_LTC_K80_LPKB1_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_5_TOG(x, v)      (HW_LTC_K80_LPKB1_5_WR(x, HW_LTC_K80_LPKB1_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_5, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_5_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_5_PKHA_B1. */
#define BM_LTC_K80_LPKB1_5_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_5_PKHA_B1. */
#define BS_LTC_K80_LPKB1_5_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_5_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_5_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_5_PKHA_B1(x)      (HW_LTC_K80_LPKB1_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_5_PKHA_B1. */
#define BF_LTC_K80_LPKB1_5_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_5_PKHA_B1) & BM_LTC_K80_LPKB1_5_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_5_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_6 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_6 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_6_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_6_ADDR(x)        ((x) + 0xA58U)
#define HW_LTC_K80_LPKB1_6(x)             (*(__IO hw_ltc_k80_lpkb1_6_t *) HW_LTC_K80_LPKB1_6_ADDR(x))
#define HW_LTC_K80_LPKB1_6_RD(x)          (HW_LTC_K80_LPKB1_6(x).U)
#define HW_LTC_K80_LPKB1_6_WR(x, v)       (HW_LTC_K80_LPKB1_6(x).U = (v))
#define HW_LTC_K80_LPKB1_6_SET(x, v)      (HW_LTC_K80_LPKB1_6_WR(x, HW_LTC_K80_LPKB1_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_6_CLR(x, v)      (HW_LTC_K80_LPKB1_6_WR(x, HW_LTC_K80_LPKB1_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_6_TOG(x, v)      (HW_LTC_K80_LPKB1_6_WR(x, HW_LTC_K80_LPKB1_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_6, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_6_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_6_PKHA_B1. */
#define BM_LTC_K80_LPKB1_6_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_6_PKHA_B1. */
#define BS_LTC_K80_LPKB1_6_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_6_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_6_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_6_PKHA_B1(x)      (HW_LTC_K80_LPKB1_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_6_PKHA_B1. */
#define BF_LTC_K80_LPKB1_6_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_6_PKHA_B1) & BM_LTC_K80_LPKB1_6_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_6_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_7 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_7 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_7_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_7_ADDR(x)        ((x) + 0xA5CU)
#define HW_LTC_K80_LPKB1_7(x)             (*(__IO hw_ltc_k80_lpkb1_7_t *) HW_LTC_K80_LPKB1_7_ADDR(x))
#define HW_LTC_K80_LPKB1_7_RD(x)          (HW_LTC_K80_LPKB1_7(x).U)
#define HW_LTC_K80_LPKB1_7_WR(x, v)       (HW_LTC_K80_LPKB1_7(x).U = (v))
#define HW_LTC_K80_LPKB1_7_SET(x, v)      (HW_LTC_K80_LPKB1_7_WR(x, HW_LTC_K80_LPKB1_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_7_CLR(x, v)      (HW_LTC_K80_LPKB1_7_WR(x, HW_LTC_K80_LPKB1_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_7_TOG(x, v)      (HW_LTC_K80_LPKB1_7_WR(x, HW_LTC_K80_LPKB1_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_7, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_7_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_7_PKHA_B1. */
#define BM_LTC_K80_LPKB1_7_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_7_PKHA_B1. */
#define BS_LTC_K80_LPKB1_7_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_7_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_7_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_7_PKHA_B1(x)      (HW_LTC_K80_LPKB1_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_7_PKHA_B1. */
#define BF_LTC_K80_LPKB1_7_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_7_PKHA_B1) & BM_LTC_K80_LPKB1_7_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_7_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_8 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_8 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_8_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_8_ADDR(x)        ((x) + 0xA60U)
#define HW_LTC_K80_LPKB1_8(x)             (*(__IO hw_ltc_k80_lpkb1_8_t *) HW_LTC_K80_LPKB1_8_ADDR(x))
#define HW_LTC_K80_LPKB1_8_RD(x)          (HW_LTC_K80_LPKB1_8(x).U)
#define HW_LTC_K80_LPKB1_8_WR(x, v)       (HW_LTC_K80_LPKB1_8(x).U = (v))
#define HW_LTC_K80_LPKB1_8_SET(x, v)      (HW_LTC_K80_LPKB1_8_WR(x, HW_LTC_K80_LPKB1_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_8_CLR(x, v)      (HW_LTC_K80_LPKB1_8_WR(x, HW_LTC_K80_LPKB1_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_8_TOG(x, v)      (HW_LTC_K80_LPKB1_8_WR(x, HW_LTC_K80_LPKB1_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_8, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_8_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_8_PKHA_B1. */
#define BM_LTC_K80_LPKB1_8_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_8_PKHA_B1. */
#define BS_LTC_K80_LPKB1_8_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_8_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_8_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_8_PKHA_B1(x)      (HW_LTC_K80_LPKB1_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_8_PKHA_B1. */
#define BF_LTC_K80_LPKB1_8_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_8_PKHA_B1) & BM_LTC_K80_LPKB1_8_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_8_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_9 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_9 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_9_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_9_ADDR(x)        ((x) + 0xA64U)
#define HW_LTC_K80_LPKB1_9(x)             (*(__IO hw_ltc_k80_lpkb1_9_t *) HW_LTC_K80_LPKB1_9_ADDR(x))
#define HW_LTC_K80_LPKB1_9_RD(x)          (HW_LTC_K80_LPKB1_9(x).U)
#define HW_LTC_K80_LPKB1_9_WR(x, v)       (HW_LTC_K80_LPKB1_9(x).U = (v))
#define HW_LTC_K80_LPKB1_9_SET(x, v)      (HW_LTC_K80_LPKB1_9_WR(x, HW_LTC_K80_LPKB1_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_9_CLR(x, v)      (HW_LTC_K80_LPKB1_9_WR(x, HW_LTC_K80_LPKB1_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_9_TOG(x, v)      (HW_LTC_K80_LPKB1_9_WR(x, HW_LTC_K80_LPKB1_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_9, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_9_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_9_PKHA_B1. */
#define BM_LTC_K80_LPKB1_9_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_9_PKHA_B1. */
#define BS_LTC_K80_LPKB1_9_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_9_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_9_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_9_PKHA_B1(x)      (HW_LTC_K80_LPKB1_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_9_PKHA_B1. */
#define BF_LTC_K80_LPKB1_9_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_9_PKHA_B1) & BM_LTC_K80_LPKB1_9_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_9_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_10 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_10 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_10_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_10_ADDR(x)        ((x) + 0xA68U)
#define HW_LTC_K80_LPKB1_10(x)             (*(__IO hw_ltc_k80_lpkb1_10_t *) HW_LTC_K80_LPKB1_10_ADDR(x))
#define HW_LTC_K80_LPKB1_10_RD(x)          (HW_LTC_K80_LPKB1_10(x).U)
#define HW_LTC_K80_LPKB1_10_WR(x, v)       (HW_LTC_K80_LPKB1_10(x).U = (v))
#define HW_LTC_K80_LPKB1_10_SET(x, v)      (HW_LTC_K80_LPKB1_10_WR(x, HW_LTC_K80_LPKB1_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_10_CLR(x, v)      (HW_LTC_K80_LPKB1_10_WR(x, HW_LTC_K80_LPKB1_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_10_TOG(x, v)      (HW_LTC_K80_LPKB1_10_WR(x, HW_LTC_K80_LPKB1_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_10, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_10_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_10_PKHA_B1. */
#define BM_LTC_K80_LPKB1_10_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_10_PKHA_B1. */
#define BS_LTC_K80_LPKB1_10_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_10_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_10_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_10_PKHA_B1(x)      (HW_LTC_K80_LPKB1_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_10_PKHA_B1. */
#define BF_LTC_K80_LPKB1_10_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_10_PKHA_B1) & BM_LTC_K80_LPKB1_10_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_10_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_11 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_11 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_11_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_11_ADDR(x)        ((x) + 0xA6CU)
#define HW_LTC_K80_LPKB1_11(x)             (*(__IO hw_ltc_k80_lpkb1_11_t *) HW_LTC_K80_LPKB1_11_ADDR(x))
#define HW_LTC_K80_LPKB1_11_RD(x)          (HW_LTC_K80_LPKB1_11(x).U)
#define HW_LTC_K80_LPKB1_11_WR(x, v)       (HW_LTC_K80_LPKB1_11(x).U = (v))
#define HW_LTC_K80_LPKB1_11_SET(x, v)      (HW_LTC_K80_LPKB1_11_WR(x, HW_LTC_K80_LPKB1_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_11_CLR(x, v)      (HW_LTC_K80_LPKB1_11_WR(x, HW_LTC_K80_LPKB1_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_11_TOG(x, v)      (HW_LTC_K80_LPKB1_11_WR(x, HW_LTC_K80_LPKB1_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_11, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_11_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_11_PKHA_B1. */
#define BM_LTC_K80_LPKB1_11_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_11_PKHA_B1. */
#define BS_LTC_K80_LPKB1_11_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_11_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_11_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_11_PKHA_B1(x)      (HW_LTC_K80_LPKB1_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_11_PKHA_B1. */
#define BF_LTC_K80_LPKB1_11_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_11_PKHA_B1) & BM_LTC_K80_LPKB1_11_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_11_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_12 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_12 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_12_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_12_ADDR(x)        ((x) + 0xA70U)
#define HW_LTC_K80_LPKB1_12(x)             (*(__IO hw_ltc_k80_lpkb1_12_t *) HW_LTC_K80_LPKB1_12_ADDR(x))
#define HW_LTC_K80_LPKB1_12_RD(x)          (HW_LTC_K80_LPKB1_12(x).U)
#define HW_LTC_K80_LPKB1_12_WR(x, v)       (HW_LTC_K80_LPKB1_12(x).U = (v))
#define HW_LTC_K80_LPKB1_12_SET(x, v)      (HW_LTC_K80_LPKB1_12_WR(x, HW_LTC_K80_LPKB1_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_12_CLR(x, v)      (HW_LTC_K80_LPKB1_12_WR(x, HW_LTC_K80_LPKB1_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_12_TOG(x, v)      (HW_LTC_K80_LPKB1_12_WR(x, HW_LTC_K80_LPKB1_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_12, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_12_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_12_PKHA_B1. */
#define BM_LTC_K80_LPKB1_12_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_12_PKHA_B1. */
#define BS_LTC_K80_LPKB1_12_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_12_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_12_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_12_PKHA_B1(x)      (HW_LTC_K80_LPKB1_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_12_PKHA_B1. */
#define BF_LTC_K80_LPKB1_12_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_12_PKHA_B1) & BM_LTC_K80_LPKB1_12_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_12_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_13 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_13 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_13_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_13_ADDR(x)        ((x) + 0xA74U)
#define HW_LTC_K80_LPKB1_13(x)             (*(__IO hw_ltc_k80_lpkb1_13_t *) HW_LTC_K80_LPKB1_13_ADDR(x))
#define HW_LTC_K80_LPKB1_13_RD(x)          (HW_LTC_K80_LPKB1_13(x).U)
#define HW_LTC_K80_LPKB1_13_WR(x, v)       (HW_LTC_K80_LPKB1_13(x).U = (v))
#define HW_LTC_K80_LPKB1_13_SET(x, v)      (HW_LTC_K80_LPKB1_13_WR(x, HW_LTC_K80_LPKB1_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_13_CLR(x, v)      (HW_LTC_K80_LPKB1_13_WR(x, HW_LTC_K80_LPKB1_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_13_TOG(x, v)      (HW_LTC_K80_LPKB1_13_WR(x, HW_LTC_K80_LPKB1_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_13, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_13_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_13_PKHA_B1. */
#define BM_LTC_K80_LPKB1_13_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_13_PKHA_B1. */
#define BS_LTC_K80_LPKB1_13_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_13_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_13_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_13_PKHA_B1(x)      (HW_LTC_K80_LPKB1_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_13_PKHA_B1. */
#define BF_LTC_K80_LPKB1_13_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_13_PKHA_B1) & BM_LTC_K80_LPKB1_13_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_13_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_14 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_14 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_14_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_14_ADDR(x)        ((x) + 0xA78U)
#define HW_LTC_K80_LPKB1_14(x)             (*(__IO hw_ltc_k80_lpkb1_14_t *) HW_LTC_K80_LPKB1_14_ADDR(x))
#define HW_LTC_K80_LPKB1_14_RD(x)          (HW_LTC_K80_LPKB1_14(x).U)
#define HW_LTC_K80_LPKB1_14_WR(x, v)       (HW_LTC_K80_LPKB1_14(x).U = (v))
#define HW_LTC_K80_LPKB1_14_SET(x, v)      (HW_LTC_K80_LPKB1_14_WR(x, HW_LTC_K80_LPKB1_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_14_CLR(x, v)      (HW_LTC_K80_LPKB1_14_WR(x, HW_LTC_K80_LPKB1_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_14_TOG(x, v)      (HW_LTC_K80_LPKB1_14_WR(x, HW_LTC_K80_LPKB1_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_14, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_14_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_14_PKHA_B1. */
#define BM_LTC_K80_LPKB1_14_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_14_PKHA_B1. */
#define BS_LTC_K80_LPKB1_14_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_14_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_14_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_14_PKHA_B1(x)      (HW_LTC_K80_LPKB1_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_14_PKHA_B1. */
#define BF_LTC_K80_LPKB1_14_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_14_PKHA_B1) & BM_LTC_K80_LPKB1_14_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_14_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB1_15 - LTC PKHA B1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB1_15 - LTC PKHA B1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A40h, in the right-most byte. The LTC PKHA B1 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B1 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb1_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb1_15_bitfields
    {
        uint32_t PKHA_B1 : 32; /*!< [31:0] B1 VALUE */
    } B;
} hw_ltc_k80_lpkb1_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB1_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKB1_15_ADDR(x)        ((x) + 0xA7CU)
#define HW_LTC_K80_LPKB1_15(x)             (*(__IO hw_ltc_k80_lpkb1_15_t *) HW_LTC_K80_LPKB1_15_ADDR(x))
#define HW_LTC_K80_LPKB1_15_RD(x)          (HW_LTC_K80_LPKB1_15(x).U)
#define HW_LTC_K80_LPKB1_15_WR(x, v)       (HW_LTC_K80_LPKB1_15(x).U = (v))
#define HW_LTC_K80_LPKB1_15_SET(x, v)      (HW_LTC_K80_LPKB1_15_WR(x, HW_LTC_K80_LPKB1_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKB1_15_CLR(x, v)      (HW_LTC_K80_LPKB1_15_WR(x, HW_LTC_K80_LPKB1_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB1_15_TOG(x, v)      (HW_LTC_K80_LPKB1_15_WR(x, HW_LTC_K80_LPKB1_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB1_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB1_15, field PKHA_B1[31:0] (RW)
 *
 * B1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB1_15_PKHA_B1         (0U)      /*!< Bit position for LTC_K80_LPKB1_15_PKHA_B1. */
#define BM_LTC_K80_LPKB1_15_PKHA_B1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB1_15_PKHA_B1. */
#define BS_LTC_K80_LPKB1_15_PKHA_B1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB1_15_PKHA_B1. */

/*! @brief Read current value of the LTC_K80_LPKB1_15_PKHA_B1 field. */
#define BR_LTC_K80_LPKB1_15_PKHA_B1(x)      (HW_LTC_K80_LPKB1_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB1_15_PKHA_B1. */
#define BF_LTC_K80_LPKB1_15_PKHA_B1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB1_15_PKHA_B1) & BM_LTC_K80_LPKB1_15_PKHA_B1)

/*! @brief Set the PKHA_B1 field to a new value. */
#define BW_LTC_K80_LPKB1_15_PKHA_B1(x, v)   (HW_LTC_K80_LPKB1_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_0 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_0 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_0_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_0_ADDR(x)        ((x) + 0xA80U)
#define HW_LTC_K80_LPKB2_0(x)             (*(__IO hw_ltc_k80_lpkb2_0_t *) HW_LTC_K80_LPKB2_0_ADDR(x))
#define HW_LTC_K80_LPKB2_0_RD(x)          (HW_LTC_K80_LPKB2_0(x).U)
#define HW_LTC_K80_LPKB2_0_WR(x, v)       (HW_LTC_K80_LPKB2_0(x).U = (v))
#define HW_LTC_K80_LPKB2_0_SET(x, v)      (HW_LTC_K80_LPKB2_0_WR(x, HW_LTC_K80_LPKB2_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_0_CLR(x, v)      (HW_LTC_K80_LPKB2_0_WR(x, HW_LTC_K80_LPKB2_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_0_TOG(x, v)      (HW_LTC_K80_LPKB2_0_WR(x, HW_LTC_K80_LPKB2_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_0, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_0_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_0_PKHA_B2. */
#define BM_LTC_K80_LPKB2_0_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_0_PKHA_B2. */
#define BS_LTC_K80_LPKB2_0_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_0_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_0_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_0_PKHA_B2(x)      (HW_LTC_K80_LPKB2_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_0_PKHA_B2. */
#define BF_LTC_K80_LPKB2_0_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_0_PKHA_B2) & BM_LTC_K80_LPKB2_0_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_0_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_1 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_1 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_1_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_1_ADDR(x)        ((x) + 0xA84U)
#define HW_LTC_K80_LPKB2_1(x)             (*(__IO hw_ltc_k80_lpkb2_1_t *) HW_LTC_K80_LPKB2_1_ADDR(x))
#define HW_LTC_K80_LPKB2_1_RD(x)          (HW_LTC_K80_LPKB2_1(x).U)
#define HW_LTC_K80_LPKB2_1_WR(x, v)       (HW_LTC_K80_LPKB2_1(x).U = (v))
#define HW_LTC_K80_LPKB2_1_SET(x, v)      (HW_LTC_K80_LPKB2_1_WR(x, HW_LTC_K80_LPKB2_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_1_CLR(x, v)      (HW_LTC_K80_LPKB2_1_WR(x, HW_LTC_K80_LPKB2_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_1_TOG(x, v)      (HW_LTC_K80_LPKB2_1_WR(x, HW_LTC_K80_LPKB2_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_1, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_1_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_1_PKHA_B2. */
#define BM_LTC_K80_LPKB2_1_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_1_PKHA_B2. */
#define BS_LTC_K80_LPKB2_1_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_1_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_1_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_1_PKHA_B2(x)      (HW_LTC_K80_LPKB2_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_1_PKHA_B2. */
#define BF_LTC_K80_LPKB2_1_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_1_PKHA_B2) & BM_LTC_K80_LPKB2_1_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_1_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_2 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_2 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_2_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_2_ADDR(x)        ((x) + 0xA88U)
#define HW_LTC_K80_LPKB2_2(x)             (*(__IO hw_ltc_k80_lpkb2_2_t *) HW_LTC_K80_LPKB2_2_ADDR(x))
#define HW_LTC_K80_LPKB2_2_RD(x)          (HW_LTC_K80_LPKB2_2(x).U)
#define HW_LTC_K80_LPKB2_2_WR(x, v)       (HW_LTC_K80_LPKB2_2(x).U = (v))
#define HW_LTC_K80_LPKB2_2_SET(x, v)      (HW_LTC_K80_LPKB2_2_WR(x, HW_LTC_K80_LPKB2_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_2_CLR(x, v)      (HW_LTC_K80_LPKB2_2_WR(x, HW_LTC_K80_LPKB2_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_2_TOG(x, v)      (HW_LTC_K80_LPKB2_2_WR(x, HW_LTC_K80_LPKB2_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_2, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_2_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_2_PKHA_B2. */
#define BM_LTC_K80_LPKB2_2_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_2_PKHA_B2. */
#define BS_LTC_K80_LPKB2_2_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_2_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_2_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_2_PKHA_B2(x)      (HW_LTC_K80_LPKB2_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_2_PKHA_B2. */
#define BF_LTC_K80_LPKB2_2_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_2_PKHA_B2) & BM_LTC_K80_LPKB2_2_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_2_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_3 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_3 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_3_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_3_ADDR(x)        ((x) + 0xA8CU)
#define HW_LTC_K80_LPKB2_3(x)             (*(__IO hw_ltc_k80_lpkb2_3_t *) HW_LTC_K80_LPKB2_3_ADDR(x))
#define HW_LTC_K80_LPKB2_3_RD(x)          (HW_LTC_K80_LPKB2_3(x).U)
#define HW_LTC_K80_LPKB2_3_WR(x, v)       (HW_LTC_K80_LPKB2_3(x).U = (v))
#define HW_LTC_K80_LPKB2_3_SET(x, v)      (HW_LTC_K80_LPKB2_3_WR(x, HW_LTC_K80_LPKB2_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_3_CLR(x, v)      (HW_LTC_K80_LPKB2_3_WR(x, HW_LTC_K80_LPKB2_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_3_TOG(x, v)      (HW_LTC_K80_LPKB2_3_WR(x, HW_LTC_K80_LPKB2_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_3, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_3_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_3_PKHA_B2. */
#define BM_LTC_K80_LPKB2_3_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_3_PKHA_B2. */
#define BS_LTC_K80_LPKB2_3_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_3_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_3_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_3_PKHA_B2(x)      (HW_LTC_K80_LPKB2_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_3_PKHA_B2. */
#define BF_LTC_K80_LPKB2_3_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_3_PKHA_B2) & BM_LTC_K80_LPKB2_3_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_3_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_4 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_4 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_4_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_4_ADDR(x)        ((x) + 0xA90U)
#define HW_LTC_K80_LPKB2_4(x)             (*(__IO hw_ltc_k80_lpkb2_4_t *) HW_LTC_K80_LPKB2_4_ADDR(x))
#define HW_LTC_K80_LPKB2_4_RD(x)          (HW_LTC_K80_LPKB2_4(x).U)
#define HW_LTC_K80_LPKB2_4_WR(x, v)       (HW_LTC_K80_LPKB2_4(x).U = (v))
#define HW_LTC_K80_LPKB2_4_SET(x, v)      (HW_LTC_K80_LPKB2_4_WR(x, HW_LTC_K80_LPKB2_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_4_CLR(x, v)      (HW_LTC_K80_LPKB2_4_WR(x, HW_LTC_K80_LPKB2_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_4_TOG(x, v)      (HW_LTC_K80_LPKB2_4_WR(x, HW_LTC_K80_LPKB2_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_4, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_4_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_4_PKHA_B2. */
#define BM_LTC_K80_LPKB2_4_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_4_PKHA_B2. */
#define BS_LTC_K80_LPKB2_4_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_4_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_4_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_4_PKHA_B2(x)      (HW_LTC_K80_LPKB2_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_4_PKHA_B2. */
#define BF_LTC_K80_LPKB2_4_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_4_PKHA_B2) & BM_LTC_K80_LPKB2_4_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_4_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_5 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_5 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_5_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_5_ADDR(x)        ((x) + 0xA94U)
#define HW_LTC_K80_LPKB2_5(x)             (*(__IO hw_ltc_k80_lpkb2_5_t *) HW_LTC_K80_LPKB2_5_ADDR(x))
#define HW_LTC_K80_LPKB2_5_RD(x)          (HW_LTC_K80_LPKB2_5(x).U)
#define HW_LTC_K80_LPKB2_5_WR(x, v)       (HW_LTC_K80_LPKB2_5(x).U = (v))
#define HW_LTC_K80_LPKB2_5_SET(x, v)      (HW_LTC_K80_LPKB2_5_WR(x, HW_LTC_K80_LPKB2_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_5_CLR(x, v)      (HW_LTC_K80_LPKB2_5_WR(x, HW_LTC_K80_LPKB2_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_5_TOG(x, v)      (HW_LTC_K80_LPKB2_5_WR(x, HW_LTC_K80_LPKB2_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_5, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_5_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_5_PKHA_B2. */
#define BM_LTC_K80_LPKB2_5_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_5_PKHA_B2. */
#define BS_LTC_K80_LPKB2_5_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_5_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_5_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_5_PKHA_B2(x)      (HW_LTC_K80_LPKB2_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_5_PKHA_B2. */
#define BF_LTC_K80_LPKB2_5_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_5_PKHA_B2) & BM_LTC_K80_LPKB2_5_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_5_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_6 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_6 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_6_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_6_ADDR(x)        ((x) + 0xA98U)
#define HW_LTC_K80_LPKB2_6(x)             (*(__IO hw_ltc_k80_lpkb2_6_t *) HW_LTC_K80_LPKB2_6_ADDR(x))
#define HW_LTC_K80_LPKB2_6_RD(x)          (HW_LTC_K80_LPKB2_6(x).U)
#define HW_LTC_K80_LPKB2_6_WR(x, v)       (HW_LTC_K80_LPKB2_6(x).U = (v))
#define HW_LTC_K80_LPKB2_6_SET(x, v)      (HW_LTC_K80_LPKB2_6_WR(x, HW_LTC_K80_LPKB2_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_6_CLR(x, v)      (HW_LTC_K80_LPKB2_6_WR(x, HW_LTC_K80_LPKB2_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_6_TOG(x, v)      (HW_LTC_K80_LPKB2_6_WR(x, HW_LTC_K80_LPKB2_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_6, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_6_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_6_PKHA_B2. */
#define BM_LTC_K80_LPKB2_6_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_6_PKHA_B2. */
#define BS_LTC_K80_LPKB2_6_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_6_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_6_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_6_PKHA_B2(x)      (HW_LTC_K80_LPKB2_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_6_PKHA_B2. */
#define BF_LTC_K80_LPKB2_6_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_6_PKHA_B2) & BM_LTC_K80_LPKB2_6_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_6_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_7 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_7 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_7_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_7_ADDR(x)        ((x) + 0xA9CU)
#define HW_LTC_K80_LPKB2_7(x)             (*(__IO hw_ltc_k80_lpkb2_7_t *) HW_LTC_K80_LPKB2_7_ADDR(x))
#define HW_LTC_K80_LPKB2_7_RD(x)          (HW_LTC_K80_LPKB2_7(x).U)
#define HW_LTC_K80_LPKB2_7_WR(x, v)       (HW_LTC_K80_LPKB2_7(x).U = (v))
#define HW_LTC_K80_LPKB2_7_SET(x, v)      (HW_LTC_K80_LPKB2_7_WR(x, HW_LTC_K80_LPKB2_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_7_CLR(x, v)      (HW_LTC_K80_LPKB2_7_WR(x, HW_LTC_K80_LPKB2_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_7_TOG(x, v)      (HW_LTC_K80_LPKB2_7_WR(x, HW_LTC_K80_LPKB2_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_7, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_7_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_7_PKHA_B2. */
#define BM_LTC_K80_LPKB2_7_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_7_PKHA_B2. */
#define BS_LTC_K80_LPKB2_7_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_7_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_7_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_7_PKHA_B2(x)      (HW_LTC_K80_LPKB2_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_7_PKHA_B2. */
#define BF_LTC_K80_LPKB2_7_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_7_PKHA_B2) & BM_LTC_K80_LPKB2_7_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_7_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_8 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_8 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_8_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_8_ADDR(x)        ((x) + 0xAA0U)
#define HW_LTC_K80_LPKB2_8(x)             (*(__IO hw_ltc_k80_lpkb2_8_t *) HW_LTC_K80_LPKB2_8_ADDR(x))
#define HW_LTC_K80_LPKB2_8_RD(x)          (HW_LTC_K80_LPKB2_8(x).U)
#define HW_LTC_K80_LPKB2_8_WR(x, v)       (HW_LTC_K80_LPKB2_8(x).U = (v))
#define HW_LTC_K80_LPKB2_8_SET(x, v)      (HW_LTC_K80_LPKB2_8_WR(x, HW_LTC_K80_LPKB2_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_8_CLR(x, v)      (HW_LTC_K80_LPKB2_8_WR(x, HW_LTC_K80_LPKB2_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_8_TOG(x, v)      (HW_LTC_K80_LPKB2_8_WR(x, HW_LTC_K80_LPKB2_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_8, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_8_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_8_PKHA_B2. */
#define BM_LTC_K80_LPKB2_8_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_8_PKHA_B2. */
#define BS_LTC_K80_LPKB2_8_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_8_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_8_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_8_PKHA_B2(x)      (HW_LTC_K80_LPKB2_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_8_PKHA_B2. */
#define BF_LTC_K80_LPKB2_8_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_8_PKHA_B2) & BM_LTC_K80_LPKB2_8_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_8_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_9 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_9 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_9_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_9_ADDR(x)        ((x) + 0xAA4U)
#define HW_LTC_K80_LPKB2_9(x)             (*(__IO hw_ltc_k80_lpkb2_9_t *) HW_LTC_K80_LPKB2_9_ADDR(x))
#define HW_LTC_K80_LPKB2_9_RD(x)          (HW_LTC_K80_LPKB2_9(x).U)
#define HW_LTC_K80_LPKB2_9_WR(x, v)       (HW_LTC_K80_LPKB2_9(x).U = (v))
#define HW_LTC_K80_LPKB2_9_SET(x, v)      (HW_LTC_K80_LPKB2_9_WR(x, HW_LTC_K80_LPKB2_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_9_CLR(x, v)      (HW_LTC_K80_LPKB2_9_WR(x, HW_LTC_K80_LPKB2_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_9_TOG(x, v)      (HW_LTC_K80_LPKB2_9_WR(x, HW_LTC_K80_LPKB2_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_9, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_9_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_9_PKHA_B2. */
#define BM_LTC_K80_LPKB2_9_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_9_PKHA_B2. */
#define BS_LTC_K80_LPKB2_9_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_9_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_9_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_9_PKHA_B2(x)      (HW_LTC_K80_LPKB2_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_9_PKHA_B2. */
#define BF_LTC_K80_LPKB2_9_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_9_PKHA_B2) & BM_LTC_K80_LPKB2_9_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_9_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_10 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_10 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_10_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_10_ADDR(x)        ((x) + 0xAA8U)
#define HW_LTC_K80_LPKB2_10(x)             (*(__IO hw_ltc_k80_lpkb2_10_t *) HW_LTC_K80_LPKB2_10_ADDR(x))
#define HW_LTC_K80_LPKB2_10_RD(x)          (HW_LTC_K80_LPKB2_10(x).U)
#define HW_LTC_K80_LPKB2_10_WR(x, v)       (HW_LTC_K80_LPKB2_10(x).U = (v))
#define HW_LTC_K80_LPKB2_10_SET(x, v)      (HW_LTC_K80_LPKB2_10_WR(x, HW_LTC_K80_LPKB2_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_10_CLR(x, v)      (HW_LTC_K80_LPKB2_10_WR(x, HW_LTC_K80_LPKB2_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_10_TOG(x, v)      (HW_LTC_K80_LPKB2_10_WR(x, HW_LTC_K80_LPKB2_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_10, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_10_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_10_PKHA_B2. */
#define BM_LTC_K80_LPKB2_10_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_10_PKHA_B2. */
#define BS_LTC_K80_LPKB2_10_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_10_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_10_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_10_PKHA_B2(x)      (HW_LTC_K80_LPKB2_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_10_PKHA_B2. */
#define BF_LTC_K80_LPKB2_10_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_10_PKHA_B2) & BM_LTC_K80_LPKB2_10_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_10_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_11 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_11 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_11_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_11_ADDR(x)        ((x) + 0xAACU)
#define HW_LTC_K80_LPKB2_11(x)             (*(__IO hw_ltc_k80_lpkb2_11_t *) HW_LTC_K80_LPKB2_11_ADDR(x))
#define HW_LTC_K80_LPKB2_11_RD(x)          (HW_LTC_K80_LPKB2_11(x).U)
#define HW_LTC_K80_LPKB2_11_WR(x, v)       (HW_LTC_K80_LPKB2_11(x).U = (v))
#define HW_LTC_K80_LPKB2_11_SET(x, v)      (HW_LTC_K80_LPKB2_11_WR(x, HW_LTC_K80_LPKB2_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_11_CLR(x, v)      (HW_LTC_K80_LPKB2_11_WR(x, HW_LTC_K80_LPKB2_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_11_TOG(x, v)      (HW_LTC_K80_LPKB2_11_WR(x, HW_LTC_K80_LPKB2_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_11, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_11_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_11_PKHA_B2. */
#define BM_LTC_K80_LPKB2_11_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_11_PKHA_B2. */
#define BS_LTC_K80_LPKB2_11_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_11_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_11_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_11_PKHA_B2(x)      (HW_LTC_K80_LPKB2_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_11_PKHA_B2. */
#define BF_LTC_K80_LPKB2_11_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_11_PKHA_B2) & BM_LTC_K80_LPKB2_11_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_11_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_12 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_12 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_12_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_12_ADDR(x)        ((x) + 0xAB0U)
#define HW_LTC_K80_LPKB2_12(x)             (*(__IO hw_ltc_k80_lpkb2_12_t *) HW_LTC_K80_LPKB2_12_ADDR(x))
#define HW_LTC_K80_LPKB2_12_RD(x)          (HW_LTC_K80_LPKB2_12(x).U)
#define HW_LTC_K80_LPKB2_12_WR(x, v)       (HW_LTC_K80_LPKB2_12(x).U = (v))
#define HW_LTC_K80_LPKB2_12_SET(x, v)      (HW_LTC_K80_LPKB2_12_WR(x, HW_LTC_K80_LPKB2_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_12_CLR(x, v)      (HW_LTC_K80_LPKB2_12_WR(x, HW_LTC_K80_LPKB2_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_12_TOG(x, v)      (HW_LTC_K80_LPKB2_12_WR(x, HW_LTC_K80_LPKB2_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_12, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_12_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_12_PKHA_B2. */
#define BM_LTC_K80_LPKB2_12_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_12_PKHA_B2. */
#define BS_LTC_K80_LPKB2_12_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_12_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_12_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_12_PKHA_B2(x)      (HW_LTC_K80_LPKB2_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_12_PKHA_B2. */
#define BF_LTC_K80_LPKB2_12_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_12_PKHA_B2) & BM_LTC_K80_LPKB2_12_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_12_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_13 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_13 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_13_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_13_ADDR(x)        ((x) + 0xAB4U)
#define HW_LTC_K80_LPKB2_13(x)             (*(__IO hw_ltc_k80_lpkb2_13_t *) HW_LTC_K80_LPKB2_13_ADDR(x))
#define HW_LTC_K80_LPKB2_13_RD(x)          (HW_LTC_K80_LPKB2_13(x).U)
#define HW_LTC_K80_LPKB2_13_WR(x, v)       (HW_LTC_K80_LPKB2_13(x).U = (v))
#define HW_LTC_K80_LPKB2_13_SET(x, v)      (HW_LTC_K80_LPKB2_13_WR(x, HW_LTC_K80_LPKB2_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_13_CLR(x, v)      (HW_LTC_K80_LPKB2_13_WR(x, HW_LTC_K80_LPKB2_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_13_TOG(x, v)      (HW_LTC_K80_LPKB2_13_WR(x, HW_LTC_K80_LPKB2_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_13, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_13_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_13_PKHA_B2. */
#define BM_LTC_K80_LPKB2_13_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_13_PKHA_B2. */
#define BS_LTC_K80_LPKB2_13_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_13_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_13_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_13_PKHA_B2(x)      (HW_LTC_K80_LPKB2_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_13_PKHA_B2. */
#define BF_LTC_K80_LPKB2_13_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_13_PKHA_B2) & BM_LTC_K80_LPKB2_13_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_13_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_14 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_14 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_14_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_14_ADDR(x)        ((x) + 0xAB8U)
#define HW_LTC_K80_LPKB2_14(x)             (*(__IO hw_ltc_k80_lpkb2_14_t *) HW_LTC_K80_LPKB2_14_ADDR(x))
#define HW_LTC_K80_LPKB2_14_RD(x)          (HW_LTC_K80_LPKB2_14(x).U)
#define HW_LTC_K80_LPKB2_14_WR(x, v)       (HW_LTC_K80_LPKB2_14(x).U = (v))
#define HW_LTC_K80_LPKB2_14_SET(x, v)      (HW_LTC_K80_LPKB2_14_WR(x, HW_LTC_K80_LPKB2_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_14_CLR(x, v)      (HW_LTC_K80_LPKB2_14_WR(x, HW_LTC_K80_LPKB2_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_14_TOG(x, v)      (HW_LTC_K80_LPKB2_14_WR(x, HW_LTC_K80_LPKB2_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_14, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_14_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_14_PKHA_B2. */
#define BM_LTC_K80_LPKB2_14_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_14_PKHA_B2. */
#define BS_LTC_K80_LPKB2_14_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_14_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_14_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_14_PKHA_B2(x)      (HW_LTC_K80_LPKB2_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_14_PKHA_B2. */
#define BF_LTC_K80_LPKB2_14_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_14_PKHA_B2) & BM_LTC_K80_LPKB2_14_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_14_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB2_15 - LTC PKHA B2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB2_15 - LTC PKHA B2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset A80h, in the right-most byte. The LTC PKHA B2 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B2 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb2_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb2_15_bitfields
    {
        uint32_t PKHA_B2 : 32; /*!< [31:0] B2 VALUE */
    } B;
} hw_ltc_k80_lpkb2_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB2_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKB2_15_ADDR(x)        ((x) + 0xABCU)
#define HW_LTC_K80_LPKB2_15(x)             (*(__IO hw_ltc_k80_lpkb2_15_t *) HW_LTC_K80_LPKB2_15_ADDR(x))
#define HW_LTC_K80_LPKB2_15_RD(x)          (HW_LTC_K80_LPKB2_15(x).U)
#define HW_LTC_K80_LPKB2_15_WR(x, v)       (HW_LTC_K80_LPKB2_15(x).U = (v))
#define HW_LTC_K80_LPKB2_15_SET(x, v)      (HW_LTC_K80_LPKB2_15_WR(x, HW_LTC_K80_LPKB2_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKB2_15_CLR(x, v)      (HW_LTC_K80_LPKB2_15_WR(x, HW_LTC_K80_LPKB2_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB2_15_TOG(x, v)      (HW_LTC_K80_LPKB2_15_WR(x, HW_LTC_K80_LPKB2_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB2_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB2_15, field PKHA_B2[31:0] (RW)
 *
 * B2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB2_15_PKHA_B2         (0U)      /*!< Bit position for LTC_K80_LPKB2_15_PKHA_B2. */
#define BM_LTC_K80_LPKB2_15_PKHA_B2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB2_15_PKHA_B2. */
#define BS_LTC_K80_LPKB2_15_PKHA_B2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB2_15_PKHA_B2. */

/*! @brief Read current value of the LTC_K80_LPKB2_15_PKHA_B2 field. */
#define BR_LTC_K80_LPKB2_15_PKHA_B2(x)      (HW_LTC_K80_LPKB2_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB2_15_PKHA_B2. */
#define BF_LTC_K80_LPKB2_15_PKHA_B2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB2_15_PKHA_B2) & BM_LTC_K80_LPKB2_15_PKHA_B2)

/*! @brief Set the PKHA_B2 field to a new value. */
#define BW_LTC_K80_LPKB2_15_PKHA_B2(x, v)   (HW_LTC_K80_LPKB2_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_0 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_0 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_0_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_0_ADDR(x)        ((x) + 0xAC0U)
#define HW_LTC_K80_LPKB3_0(x)             (*(__IO hw_ltc_k80_lpkb3_0_t *) HW_LTC_K80_LPKB3_0_ADDR(x))
#define HW_LTC_K80_LPKB3_0_RD(x)          (HW_LTC_K80_LPKB3_0(x).U)
#define HW_LTC_K80_LPKB3_0_WR(x, v)       (HW_LTC_K80_LPKB3_0(x).U = (v))
#define HW_LTC_K80_LPKB3_0_SET(x, v)      (HW_LTC_K80_LPKB3_0_WR(x, HW_LTC_K80_LPKB3_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_0_CLR(x, v)      (HW_LTC_K80_LPKB3_0_WR(x, HW_LTC_K80_LPKB3_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_0_TOG(x, v)      (HW_LTC_K80_LPKB3_0_WR(x, HW_LTC_K80_LPKB3_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_0, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_0_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_0_PKHA_B3. */
#define BM_LTC_K80_LPKB3_0_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_0_PKHA_B3. */
#define BS_LTC_K80_LPKB3_0_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_0_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_0_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_0_PKHA_B3(x)      (HW_LTC_K80_LPKB3_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_0_PKHA_B3. */
#define BF_LTC_K80_LPKB3_0_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_0_PKHA_B3) & BM_LTC_K80_LPKB3_0_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_0_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_1 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_1 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_1_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_1_ADDR(x)        ((x) + 0xAC4U)
#define HW_LTC_K80_LPKB3_1(x)             (*(__IO hw_ltc_k80_lpkb3_1_t *) HW_LTC_K80_LPKB3_1_ADDR(x))
#define HW_LTC_K80_LPKB3_1_RD(x)          (HW_LTC_K80_LPKB3_1(x).U)
#define HW_LTC_K80_LPKB3_1_WR(x, v)       (HW_LTC_K80_LPKB3_1(x).U = (v))
#define HW_LTC_K80_LPKB3_1_SET(x, v)      (HW_LTC_K80_LPKB3_1_WR(x, HW_LTC_K80_LPKB3_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_1_CLR(x, v)      (HW_LTC_K80_LPKB3_1_WR(x, HW_LTC_K80_LPKB3_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_1_TOG(x, v)      (HW_LTC_K80_LPKB3_1_WR(x, HW_LTC_K80_LPKB3_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_1, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_1_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_1_PKHA_B3. */
#define BM_LTC_K80_LPKB3_1_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_1_PKHA_B3. */
#define BS_LTC_K80_LPKB3_1_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_1_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_1_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_1_PKHA_B3(x)      (HW_LTC_K80_LPKB3_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_1_PKHA_B3. */
#define BF_LTC_K80_LPKB3_1_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_1_PKHA_B3) & BM_LTC_K80_LPKB3_1_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_1_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_2 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_2 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_2_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_2_ADDR(x)        ((x) + 0xAC8U)
#define HW_LTC_K80_LPKB3_2(x)             (*(__IO hw_ltc_k80_lpkb3_2_t *) HW_LTC_K80_LPKB3_2_ADDR(x))
#define HW_LTC_K80_LPKB3_2_RD(x)          (HW_LTC_K80_LPKB3_2(x).U)
#define HW_LTC_K80_LPKB3_2_WR(x, v)       (HW_LTC_K80_LPKB3_2(x).U = (v))
#define HW_LTC_K80_LPKB3_2_SET(x, v)      (HW_LTC_K80_LPKB3_2_WR(x, HW_LTC_K80_LPKB3_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_2_CLR(x, v)      (HW_LTC_K80_LPKB3_2_WR(x, HW_LTC_K80_LPKB3_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_2_TOG(x, v)      (HW_LTC_K80_LPKB3_2_WR(x, HW_LTC_K80_LPKB3_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_2, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_2_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_2_PKHA_B3. */
#define BM_LTC_K80_LPKB3_2_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_2_PKHA_B3. */
#define BS_LTC_K80_LPKB3_2_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_2_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_2_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_2_PKHA_B3(x)      (HW_LTC_K80_LPKB3_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_2_PKHA_B3. */
#define BF_LTC_K80_LPKB3_2_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_2_PKHA_B3) & BM_LTC_K80_LPKB3_2_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_2_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_3 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_3 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_3_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_3_ADDR(x)        ((x) + 0xACCU)
#define HW_LTC_K80_LPKB3_3(x)             (*(__IO hw_ltc_k80_lpkb3_3_t *) HW_LTC_K80_LPKB3_3_ADDR(x))
#define HW_LTC_K80_LPKB3_3_RD(x)          (HW_LTC_K80_LPKB3_3(x).U)
#define HW_LTC_K80_LPKB3_3_WR(x, v)       (HW_LTC_K80_LPKB3_3(x).U = (v))
#define HW_LTC_K80_LPKB3_3_SET(x, v)      (HW_LTC_K80_LPKB3_3_WR(x, HW_LTC_K80_LPKB3_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_3_CLR(x, v)      (HW_LTC_K80_LPKB3_3_WR(x, HW_LTC_K80_LPKB3_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_3_TOG(x, v)      (HW_LTC_K80_LPKB3_3_WR(x, HW_LTC_K80_LPKB3_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_3, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_3_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_3_PKHA_B3. */
#define BM_LTC_K80_LPKB3_3_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_3_PKHA_B3. */
#define BS_LTC_K80_LPKB3_3_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_3_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_3_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_3_PKHA_B3(x)      (HW_LTC_K80_LPKB3_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_3_PKHA_B3. */
#define BF_LTC_K80_LPKB3_3_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_3_PKHA_B3) & BM_LTC_K80_LPKB3_3_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_3_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_4 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_4 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_4_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_4_ADDR(x)        ((x) + 0xAD0U)
#define HW_LTC_K80_LPKB3_4(x)             (*(__IO hw_ltc_k80_lpkb3_4_t *) HW_LTC_K80_LPKB3_4_ADDR(x))
#define HW_LTC_K80_LPKB3_4_RD(x)          (HW_LTC_K80_LPKB3_4(x).U)
#define HW_LTC_K80_LPKB3_4_WR(x, v)       (HW_LTC_K80_LPKB3_4(x).U = (v))
#define HW_LTC_K80_LPKB3_4_SET(x, v)      (HW_LTC_K80_LPKB3_4_WR(x, HW_LTC_K80_LPKB3_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_4_CLR(x, v)      (HW_LTC_K80_LPKB3_4_WR(x, HW_LTC_K80_LPKB3_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_4_TOG(x, v)      (HW_LTC_K80_LPKB3_4_WR(x, HW_LTC_K80_LPKB3_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_4, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_4_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_4_PKHA_B3. */
#define BM_LTC_K80_LPKB3_4_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_4_PKHA_B3. */
#define BS_LTC_K80_LPKB3_4_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_4_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_4_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_4_PKHA_B3(x)      (HW_LTC_K80_LPKB3_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_4_PKHA_B3. */
#define BF_LTC_K80_LPKB3_4_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_4_PKHA_B3) & BM_LTC_K80_LPKB3_4_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_4_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_5 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_5 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_5_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_5_ADDR(x)        ((x) + 0xAD4U)
#define HW_LTC_K80_LPKB3_5(x)             (*(__IO hw_ltc_k80_lpkb3_5_t *) HW_LTC_K80_LPKB3_5_ADDR(x))
#define HW_LTC_K80_LPKB3_5_RD(x)          (HW_LTC_K80_LPKB3_5(x).U)
#define HW_LTC_K80_LPKB3_5_WR(x, v)       (HW_LTC_K80_LPKB3_5(x).U = (v))
#define HW_LTC_K80_LPKB3_5_SET(x, v)      (HW_LTC_K80_LPKB3_5_WR(x, HW_LTC_K80_LPKB3_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_5_CLR(x, v)      (HW_LTC_K80_LPKB3_5_WR(x, HW_LTC_K80_LPKB3_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_5_TOG(x, v)      (HW_LTC_K80_LPKB3_5_WR(x, HW_LTC_K80_LPKB3_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_5, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_5_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_5_PKHA_B3. */
#define BM_LTC_K80_LPKB3_5_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_5_PKHA_B3. */
#define BS_LTC_K80_LPKB3_5_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_5_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_5_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_5_PKHA_B3(x)      (HW_LTC_K80_LPKB3_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_5_PKHA_B3. */
#define BF_LTC_K80_LPKB3_5_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_5_PKHA_B3) & BM_LTC_K80_LPKB3_5_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_5_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_6 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_6 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_6_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_6_ADDR(x)        ((x) + 0xAD8U)
#define HW_LTC_K80_LPKB3_6(x)             (*(__IO hw_ltc_k80_lpkb3_6_t *) HW_LTC_K80_LPKB3_6_ADDR(x))
#define HW_LTC_K80_LPKB3_6_RD(x)          (HW_LTC_K80_LPKB3_6(x).U)
#define HW_LTC_K80_LPKB3_6_WR(x, v)       (HW_LTC_K80_LPKB3_6(x).U = (v))
#define HW_LTC_K80_LPKB3_6_SET(x, v)      (HW_LTC_K80_LPKB3_6_WR(x, HW_LTC_K80_LPKB3_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_6_CLR(x, v)      (HW_LTC_K80_LPKB3_6_WR(x, HW_LTC_K80_LPKB3_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_6_TOG(x, v)      (HW_LTC_K80_LPKB3_6_WR(x, HW_LTC_K80_LPKB3_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_6, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_6_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_6_PKHA_B3. */
#define BM_LTC_K80_LPKB3_6_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_6_PKHA_B3. */
#define BS_LTC_K80_LPKB3_6_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_6_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_6_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_6_PKHA_B3(x)      (HW_LTC_K80_LPKB3_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_6_PKHA_B3. */
#define BF_LTC_K80_LPKB3_6_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_6_PKHA_B3) & BM_LTC_K80_LPKB3_6_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_6_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_7 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_7 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_7_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_7_ADDR(x)        ((x) + 0xADCU)
#define HW_LTC_K80_LPKB3_7(x)             (*(__IO hw_ltc_k80_lpkb3_7_t *) HW_LTC_K80_LPKB3_7_ADDR(x))
#define HW_LTC_K80_LPKB3_7_RD(x)          (HW_LTC_K80_LPKB3_7(x).U)
#define HW_LTC_K80_LPKB3_7_WR(x, v)       (HW_LTC_K80_LPKB3_7(x).U = (v))
#define HW_LTC_K80_LPKB3_7_SET(x, v)      (HW_LTC_K80_LPKB3_7_WR(x, HW_LTC_K80_LPKB3_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_7_CLR(x, v)      (HW_LTC_K80_LPKB3_7_WR(x, HW_LTC_K80_LPKB3_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_7_TOG(x, v)      (HW_LTC_K80_LPKB3_7_WR(x, HW_LTC_K80_LPKB3_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_7, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_7_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_7_PKHA_B3. */
#define BM_LTC_K80_LPKB3_7_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_7_PKHA_B3. */
#define BS_LTC_K80_LPKB3_7_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_7_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_7_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_7_PKHA_B3(x)      (HW_LTC_K80_LPKB3_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_7_PKHA_B3. */
#define BF_LTC_K80_LPKB3_7_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_7_PKHA_B3) & BM_LTC_K80_LPKB3_7_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_7_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_8 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_8 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_8_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_8_ADDR(x)        ((x) + 0xAE0U)
#define HW_LTC_K80_LPKB3_8(x)             (*(__IO hw_ltc_k80_lpkb3_8_t *) HW_LTC_K80_LPKB3_8_ADDR(x))
#define HW_LTC_K80_LPKB3_8_RD(x)          (HW_LTC_K80_LPKB3_8(x).U)
#define HW_LTC_K80_LPKB3_8_WR(x, v)       (HW_LTC_K80_LPKB3_8(x).U = (v))
#define HW_LTC_K80_LPKB3_8_SET(x, v)      (HW_LTC_K80_LPKB3_8_WR(x, HW_LTC_K80_LPKB3_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_8_CLR(x, v)      (HW_LTC_K80_LPKB3_8_WR(x, HW_LTC_K80_LPKB3_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_8_TOG(x, v)      (HW_LTC_K80_LPKB3_8_WR(x, HW_LTC_K80_LPKB3_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_8, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_8_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_8_PKHA_B3. */
#define BM_LTC_K80_LPKB3_8_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_8_PKHA_B3. */
#define BS_LTC_K80_LPKB3_8_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_8_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_8_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_8_PKHA_B3(x)      (HW_LTC_K80_LPKB3_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_8_PKHA_B3. */
#define BF_LTC_K80_LPKB3_8_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_8_PKHA_B3) & BM_LTC_K80_LPKB3_8_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_8_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_9 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_9 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_9_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_9_ADDR(x)        ((x) + 0xAE4U)
#define HW_LTC_K80_LPKB3_9(x)             (*(__IO hw_ltc_k80_lpkb3_9_t *) HW_LTC_K80_LPKB3_9_ADDR(x))
#define HW_LTC_K80_LPKB3_9_RD(x)          (HW_LTC_K80_LPKB3_9(x).U)
#define HW_LTC_K80_LPKB3_9_WR(x, v)       (HW_LTC_K80_LPKB3_9(x).U = (v))
#define HW_LTC_K80_LPKB3_9_SET(x, v)      (HW_LTC_K80_LPKB3_9_WR(x, HW_LTC_K80_LPKB3_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_9_CLR(x, v)      (HW_LTC_K80_LPKB3_9_WR(x, HW_LTC_K80_LPKB3_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_9_TOG(x, v)      (HW_LTC_K80_LPKB3_9_WR(x, HW_LTC_K80_LPKB3_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_9, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_9_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_9_PKHA_B3. */
#define BM_LTC_K80_LPKB3_9_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_9_PKHA_B3. */
#define BS_LTC_K80_LPKB3_9_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_9_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_9_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_9_PKHA_B3(x)      (HW_LTC_K80_LPKB3_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_9_PKHA_B3. */
#define BF_LTC_K80_LPKB3_9_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_9_PKHA_B3) & BM_LTC_K80_LPKB3_9_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_9_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_10 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_10 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_10_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_10_ADDR(x)        ((x) + 0xAE8U)
#define HW_LTC_K80_LPKB3_10(x)             (*(__IO hw_ltc_k80_lpkb3_10_t *) HW_LTC_K80_LPKB3_10_ADDR(x))
#define HW_LTC_K80_LPKB3_10_RD(x)          (HW_LTC_K80_LPKB3_10(x).U)
#define HW_LTC_K80_LPKB3_10_WR(x, v)       (HW_LTC_K80_LPKB3_10(x).U = (v))
#define HW_LTC_K80_LPKB3_10_SET(x, v)      (HW_LTC_K80_LPKB3_10_WR(x, HW_LTC_K80_LPKB3_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_10_CLR(x, v)      (HW_LTC_K80_LPKB3_10_WR(x, HW_LTC_K80_LPKB3_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_10_TOG(x, v)      (HW_LTC_K80_LPKB3_10_WR(x, HW_LTC_K80_LPKB3_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_10, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_10_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_10_PKHA_B3. */
#define BM_LTC_K80_LPKB3_10_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_10_PKHA_B3. */
#define BS_LTC_K80_LPKB3_10_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_10_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_10_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_10_PKHA_B3(x)      (HW_LTC_K80_LPKB3_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_10_PKHA_B3. */
#define BF_LTC_K80_LPKB3_10_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_10_PKHA_B3) & BM_LTC_K80_LPKB3_10_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_10_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_11 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_11 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_11_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_11_ADDR(x)        ((x) + 0xAECU)
#define HW_LTC_K80_LPKB3_11(x)             (*(__IO hw_ltc_k80_lpkb3_11_t *) HW_LTC_K80_LPKB3_11_ADDR(x))
#define HW_LTC_K80_LPKB3_11_RD(x)          (HW_LTC_K80_LPKB3_11(x).U)
#define HW_LTC_K80_LPKB3_11_WR(x, v)       (HW_LTC_K80_LPKB3_11(x).U = (v))
#define HW_LTC_K80_LPKB3_11_SET(x, v)      (HW_LTC_K80_LPKB3_11_WR(x, HW_LTC_K80_LPKB3_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_11_CLR(x, v)      (HW_LTC_K80_LPKB3_11_WR(x, HW_LTC_K80_LPKB3_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_11_TOG(x, v)      (HW_LTC_K80_LPKB3_11_WR(x, HW_LTC_K80_LPKB3_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_11, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_11_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_11_PKHA_B3. */
#define BM_LTC_K80_LPKB3_11_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_11_PKHA_B3. */
#define BS_LTC_K80_LPKB3_11_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_11_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_11_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_11_PKHA_B3(x)      (HW_LTC_K80_LPKB3_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_11_PKHA_B3. */
#define BF_LTC_K80_LPKB3_11_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_11_PKHA_B3) & BM_LTC_K80_LPKB3_11_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_11_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_12 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_12 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_12_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_12_ADDR(x)        ((x) + 0xAF0U)
#define HW_LTC_K80_LPKB3_12(x)             (*(__IO hw_ltc_k80_lpkb3_12_t *) HW_LTC_K80_LPKB3_12_ADDR(x))
#define HW_LTC_K80_LPKB3_12_RD(x)          (HW_LTC_K80_LPKB3_12(x).U)
#define HW_LTC_K80_LPKB3_12_WR(x, v)       (HW_LTC_K80_LPKB3_12(x).U = (v))
#define HW_LTC_K80_LPKB3_12_SET(x, v)      (HW_LTC_K80_LPKB3_12_WR(x, HW_LTC_K80_LPKB3_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_12_CLR(x, v)      (HW_LTC_K80_LPKB3_12_WR(x, HW_LTC_K80_LPKB3_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_12_TOG(x, v)      (HW_LTC_K80_LPKB3_12_WR(x, HW_LTC_K80_LPKB3_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_12, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_12_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_12_PKHA_B3. */
#define BM_LTC_K80_LPKB3_12_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_12_PKHA_B3. */
#define BS_LTC_K80_LPKB3_12_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_12_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_12_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_12_PKHA_B3(x)      (HW_LTC_K80_LPKB3_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_12_PKHA_B3. */
#define BF_LTC_K80_LPKB3_12_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_12_PKHA_B3) & BM_LTC_K80_LPKB3_12_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_12_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_13 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_13 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_13_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_13_ADDR(x)        ((x) + 0xAF4U)
#define HW_LTC_K80_LPKB3_13(x)             (*(__IO hw_ltc_k80_lpkb3_13_t *) HW_LTC_K80_LPKB3_13_ADDR(x))
#define HW_LTC_K80_LPKB3_13_RD(x)          (HW_LTC_K80_LPKB3_13(x).U)
#define HW_LTC_K80_LPKB3_13_WR(x, v)       (HW_LTC_K80_LPKB3_13(x).U = (v))
#define HW_LTC_K80_LPKB3_13_SET(x, v)      (HW_LTC_K80_LPKB3_13_WR(x, HW_LTC_K80_LPKB3_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_13_CLR(x, v)      (HW_LTC_K80_LPKB3_13_WR(x, HW_LTC_K80_LPKB3_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_13_TOG(x, v)      (HW_LTC_K80_LPKB3_13_WR(x, HW_LTC_K80_LPKB3_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_13, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_13_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_13_PKHA_B3. */
#define BM_LTC_K80_LPKB3_13_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_13_PKHA_B3. */
#define BS_LTC_K80_LPKB3_13_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_13_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_13_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_13_PKHA_B3(x)      (HW_LTC_K80_LPKB3_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_13_PKHA_B3. */
#define BF_LTC_K80_LPKB3_13_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_13_PKHA_B3) & BM_LTC_K80_LPKB3_13_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_13_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_14 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_14 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_14_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_14_ADDR(x)        ((x) + 0xAF8U)
#define HW_LTC_K80_LPKB3_14(x)             (*(__IO hw_ltc_k80_lpkb3_14_t *) HW_LTC_K80_LPKB3_14_ADDR(x))
#define HW_LTC_K80_LPKB3_14_RD(x)          (HW_LTC_K80_LPKB3_14(x).U)
#define HW_LTC_K80_LPKB3_14_WR(x, v)       (HW_LTC_K80_LPKB3_14(x).U = (v))
#define HW_LTC_K80_LPKB3_14_SET(x, v)      (HW_LTC_K80_LPKB3_14_WR(x, HW_LTC_K80_LPKB3_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_14_CLR(x, v)      (HW_LTC_K80_LPKB3_14_WR(x, HW_LTC_K80_LPKB3_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_14_TOG(x, v)      (HW_LTC_K80_LPKB3_14_WR(x, HW_LTC_K80_LPKB3_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_14, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_14_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_14_PKHA_B3. */
#define BM_LTC_K80_LPKB3_14_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_14_PKHA_B3. */
#define BS_LTC_K80_LPKB3_14_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_14_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_14_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_14_PKHA_B3(x)      (HW_LTC_K80_LPKB3_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_14_PKHA_B3. */
#define BF_LTC_K80_LPKB3_14_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_14_PKHA_B3) & BM_LTC_K80_LPKB3_14_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_14_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKB3_15 - LTC PKHA B3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKB3_15 - LTC PKHA B3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA B3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset AC0h, in the right-most byte. The LTC PKHA B3 register is 512 bits in length. Note
 * that PKHA B3, B2, B1 and B0 Registers may be combined to contain a value of up to 2048 bits, with
 * B0 containing the least-significant 64 bytes of this value. The value in the PKHA B3 Register, if
 * used as a separate value, is limited by the LTC PKHA B Size Register (LPKBSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkb3_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpkb3_15_bitfields
    {
        uint32_t PKHA_B3 : 32; /*!< [31:0] B3 VALUE */
    } B;
} hw_ltc_k80_lpkb3_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKB3_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKB3_15_ADDR(x)        ((x) + 0xAFCU)
#define HW_LTC_K80_LPKB3_15(x)             (*(__IO hw_ltc_k80_lpkb3_15_t *) HW_LTC_K80_LPKB3_15_ADDR(x))
#define HW_LTC_K80_LPKB3_15_RD(x)          (HW_LTC_K80_LPKB3_15(x).U)
#define HW_LTC_K80_LPKB3_15_WR(x, v)       (HW_LTC_K80_LPKB3_15(x).U = (v))
#define HW_LTC_K80_LPKB3_15_SET(x, v)      (HW_LTC_K80_LPKB3_15_WR(x, HW_LTC_K80_LPKB3_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKB3_15_CLR(x, v)      (HW_LTC_K80_LPKB3_15_WR(x, HW_LTC_K80_LPKB3_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKB3_15_TOG(x, v)      (HW_LTC_K80_LPKB3_15_WR(x, HW_LTC_K80_LPKB3_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKB3_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKB3_15, field PKHA_B3[31:0] (RW)
 *
 * B3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKB3_15_PKHA_B3         (0U)      /*!< Bit position for LTC_K80_LPKB3_15_PKHA_B3. */
#define BM_LTC_K80_LPKB3_15_PKHA_B3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKB3_15_PKHA_B3. */
#define BS_LTC_K80_LPKB3_15_PKHA_B3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKB3_15_PKHA_B3. */

/*! @brief Read current value of the LTC_K80_LPKB3_15_PKHA_B3 field. */
#define BR_LTC_K80_LPKB3_15_PKHA_B3(x)      (HW_LTC_K80_LPKB3_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKB3_15_PKHA_B3. */
#define BF_LTC_K80_LPKB3_15_PKHA_B3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKB3_15_PKHA_B3) & BM_LTC_K80_LPKB3_15_PKHA_B3)

/*! @brief Set the PKHA_B3 field to a new value. */
#define BW_LTC_K80_LPKB3_15_PKHA_B3(x, v)   (HW_LTC_K80_LPKB3_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_0 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_0 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_0_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_0_ADDR(x)        ((x) + 0xC00U)
#define HW_LTC_K80_LPKN0_0(x)             (*(__IO hw_ltc_k80_lpkn0_0_t *) HW_LTC_K80_LPKN0_0_ADDR(x))
#define HW_LTC_K80_LPKN0_0_RD(x)          (HW_LTC_K80_LPKN0_0(x).U)
#define HW_LTC_K80_LPKN0_0_WR(x, v)       (HW_LTC_K80_LPKN0_0(x).U = (v))
#define HW_LTC_K80_LPKN0_0_SET(x, v)      (HW_LTC_K80_LPKN0_0_WR(x, HW_LTC_K80_LPKN0_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_0_CLR(x, v)      (HW_LTC_K80_LPKN0_0_WR(x, HW_LTC_K80_LPKN0_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_0_TOG(x, v)      (HW_LTC_K80_LPKN0_0_WR(x, HW_LTC_K80_LPKN0_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_0, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_0_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_0_PKHA_N0. */
#define BM_LTC_K80_LPKN0_0_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_0_PKHA_N0. */
#define BS_LTC_K80_LPKN0_0_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_0_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_0_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_0_PKHA_N0(x)      (HW_LTC_K80_LPKN0_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_0_PKHA_N0. */
#define BF_LTC_K80_LPKN0_0_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_0_PKHA_N0) & BM_LTC_K80_LPKN0_0_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_0_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_1 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_1 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_1_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_1_ADDR(x)        ((x) + 0xC04U)
#define HW_LTC_K80_LPKN0_1(x)             (*(__IO hw_ltc_k80_lpkn0_1_t *) HW_LTC_K80_LPKN0_1_ADDR(x))
#define HW_LTC_K80_LPKN0_1_RD(x)          (HW_LTC_K80_LPKN0_1(x).U)
#define HW_LTC_K80_LPKN0_1_WR(x, v)       (HW_LTC_K80_LPKN0_1(x).U = (v))
#define HW_LTC_K80_LPKN0_1_SET(x, v)      (HW_LTC_K80_LPKN0_1_WR(x, HW_LTC_K80_LPKN0_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_1_CLR(x, v)      (HW_LTC_K80_LPKN0_1_WR(x, HW_LTC_K80_LPKN0_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_1_TOG(x, v)      (HW_LTC_K80_LPKN0_1_WR(x, HW_LTC_K80_LPKN0_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_1, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_1_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_1_PKHA_N0. */
#define BM_LTC_K80_LPKN0_1_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_1_PKHA_N0. */
#define BS_LTC_K80_LPKN0_1_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_1_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_1_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_1_PKHA_N0(x)      (HW_LTC_K80_LPKN0_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_1_PKHA_N0. */
#define BF_LTC_K80_LPKN0_1_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_1_PKHA_N0) & BM_LTC_K80_LPKN0_1_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_1_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_2 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_2 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_2_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_2_ADDR(x)        ((x) + 0xC08U)
#define HW_LTC_K80_LPKN0_2(x)             (*(__IO hw_ltc_k80_lpkn0_2_t *) HW_LTC_K80_LPKN0_2_ADDR(x))
#define HW_LTC_K80_LPKN0_2_RD(x)          (HW_LTC_K80_LPKN0_2(x).U)
#define HW_LTC_K80_LPKN0_2_WR(x, v)       (HW_LTC_K80_LPKN0_2(x).U = (v))
#define HW_LTC_K80_LPKN0_2_SET(x, v)      (HW_LTC_K80_LPKN0_2_WR(x, HW_LTC_K80_LPKN0_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_2_CLR(x, v)      (HW_LTC_K80_LPKN0_2_WR(x, HW_LTC_K80_LPKN0_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_2_TOG(x, v)      (HW_LTC_K80_LPKN0_2_WR(x, HW_LTC_K80_LPKN0_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_2, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_2_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_2_PKHA_N0. */
#define BM_LTC_K80_LPKN0_2_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_2_PKHA_N0. */
#define BS_LTC_K80_LPKN0_2_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_2_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_2_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_2_PKHA_N0(x)      (HW_LTC_K80_LPKN0_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_2_PKHA_N0. */
#define BF_LTC_K80_LPKN0_2_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_2_PKHA_N0) & BM_LTC_K80_LPKN0_2_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_2_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_3 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_3 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_3_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_3_ADDR(x)        ((x) + 0xC0CU)
#define HW_LTC_K80_LPKN0_3(x)             (*(__IO hw_ltc_k80_lpkn0_3_t *) HW_LTC_K80_LPKN0_3_ADDR(x))
#define HW_LTC_K80_LPKN0_3_RD(x)          (HW_LTC_K80_LPKN0_3(x).U)
#define HW_LTC_K80_LPKN0_3_WR(x, v)       (HW_LTC_K80_LPKN0_3(x).U = (v))
#define HW_LTC_K80_LPKN0_3_SET(x, v)      (HW_LTC_K80_LPKN0_3_WR(x, HW_LTC_K80_LPKN0_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_3_CLR(x, v)      (HW_LTC_K80_LPKN0_3_WR(x, HW_LTC_K80_LPKN0_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_3_TOG(x, v)      (HW_LTC_K80_LPKN0_3_WR(x, HW_LTC_K80_LPKN0_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_3, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_3_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_3_PKHA_N0. */
#define BM_LTC_K80_LPKN0_3_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_3_PKHA_N0. */
#define BS_LTC_K80_LPKN0_3_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_3_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_3_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_3_PKHA_N0(x)      (HW_LTC_K80_LPKN0_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_3_PKHA_N0. */
#define BF_LTC_K80_LPKN0_3_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_3_PKHA_N0) & BM_LTC_K80_LPKN0_3_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_3_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_4 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_4 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_4_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_4_ADDR(x)        ((x) + 0xC10U)
#define HW_LTC_K80_LPKN0_4(x)             (*(__IO hw_ltc_k80_lpkn0_4_t *) HW_LTC_K80_LPKN0_4_ADDR(x))
#define HW_LTC_K80_LPKN0_4_RD(x)          (HW_LTC_K80_LPKN0_4(x).U)
#define HW_LTC_K80_LPKN0_4_WR(x, v)       (HW_LTC_K80_LPKN0_4(x).U = (v))
#define HW_LTC_K80_LPKN0_4_SET(x, v)      (HW_LTC_K80_LPKN0_4_WR(x, HW_LTC_K80_LPKN0_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_4_CLR(x, v)      (HW_LTC_K80_LPKN0_4_WR(x, HW_LTC_K80_LPKN0_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_4_TOG(x, v)      (HW_LTC_K80_LPKN0_4_WR(x, HW_LTC_K80_LPKN0_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_4, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_4_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_4_PKHA_N0. */
#define BM_LTC_K80_LPKN0_4_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_4_PKHA_N0. */
#define BS_LTC_K80_LPKN0_4_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_4_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_4_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_4_PKHA_N0(x)      (HW_LTC_K80_LPKN0_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_4_PKHA_N0. */
#define BF_LTC_K80_LPKN0_4_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_4_PKHA_N0) & BM_LTC_K80_LPKN0_4_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_4_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_5 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_5 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_5_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_5_ADDR(x)        ((x) + 0xC14U)
#define HW_LTC_K80_LPKN0_5(x)             (*(__IO hw_ltc_k80_lpkn0_5_t *) HW_LTC_K80_LPKN0_5_ADDR(x))
#define HW_LTC_K80_LPKN0_5_RD(x)          (HW_LTC_K80_LPKN0_5(x).U)
#define HW_LTC_K80_LPKN0_5_WR(x, v)       (HW_LTC_K80_LPKN0_5(x).U = (v))
#define HW_LTC_K80_LPKN0_5_SET(x, v)      (HW_LTC_K80_LPKN0_5_WR(x, HW_LTC_K80_LPKN0_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_5_CLR(x, v)      (HW_LTC_K80_LPKN0_5_WR(x, HW_LTC_K80_LPKN0_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_5_TOG(x, v)      (HW_LTC_K80_LPKN0_5_WR(x, HW_LTC_K80_LPKN0_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_5, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_5_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_5_PKHA_N0. */
#define BM_LTC_K80_LPKN0_5_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_5_PKHA_N0. */
#define BS_LTC_K80_LPKN0_5_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_5_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_5_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_5_PKHA_N0(x)      (HW_LTC_K80_LPKN0_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_5_PKHA_N0. */
#define BF_LTC_K80_LPKN0_5_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_5_PKHA_N0) & BM_LTC_K80_LPKN0_5_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_5_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_6 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_6 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_6_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_6_ADDR(x)        ((x) + 0xC18U)
#define HW_LTC_K80_LPKN0_6(x)             (*(__IO hw_ltc_k80_lpkn0_6_t *) HW_LTC_K80_LPKN0_6_ADDR(x))
#define HW_LTC_K80_LPKN0_6_RD(x)          (HW_LTC_K80_LPKN0_6(x).U)
#define HW_LTC_K80_LPKN0_6_WR(x, v)       (HW_LTC_K80_LPKN0_6(x).U = (v))
#define HW_LTC_K80_LPKN0_6_SET(x, v)      (HW_LTC_K80_LPKN0_6_WR(x, HW_LTC_K80_LPKN0_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_6_CLR(x, v)      (HW_LTC_K80_LPKN0_6_WR(x, HW_LTC_K80_LPKN0_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_6_TOG(x, v)      (HW_LTC_K80_LPKN0_6_WR(x, HW_LTC_K80_LPKN0_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_6, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_6_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_6_PKHA_N0. */
#define BM_LTC_K80_LPKN0_6_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_6_PKHA_N0. */
#define BS_LTC_K80_LPKN0_6_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_6_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_6_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_6_PKHA_N0(x)      (HW_LTC_K80_LPKN0_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_6_PKHA_N0. */
#define BF_LTC_K80_LPKN0_6_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_6_PKHA_N0) & BM_LTC_K80_LPKN0_6_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_6_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_7 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_7 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_7_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_7_ADDR(x)        ((x) + 0xC1CU)
#define HW_LTC_K80_LPKN0_7(x)             (*(__IO hw_ltc_k80_lpkn0_7_t *) HW_LTC_K80_LPKN0_7_ADDR(x))
#define HW_LTC_K80_LPKN0_7_RD(x)          (HW_LTC_K80_LPKN0_7(x).U)
#define HW_LTC_K80_LPKN0_7_WR(x, v)       (HW_LTC_K80_LPKN0_7(x).U = (v))
#define HW_LTC_K80_LPKN0_7_SET(x, v)      (HW_LTC_K80_LPKN0_7_WR(x, HW_LTC_K80_LPKN0_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_7_CLR(x, v)      (HW_LTC_K80_LPKN0_7_WR(x, HW_LTC_K80_LPKN0_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_7_TOG(x, v)      (HW_LTC_K80_LPKN0_7_WR(x, HW_LTC_K80_LPKN0_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_7, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_7_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_7_PKHA_N0. */
#define BM_LTC_K80_LPKN0_7_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_7_PKHA_N0. */
#define BS_LTC_K80_LPKN0_7_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_7_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_7_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_7_PKHA_N0(x)      (HW_LTC_K80_LPKN0_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_7_PKHA_N0. */
#define BF_LTC_K80_LPKN0_7_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_7_PKHA_N0) & BM_LTC_K80_LPKN0_7_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_7_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_8 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_8 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_8_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_8_ADDR(x)        ((x) + 0xC20U)
#define HW_LTC_K80_LPKN0_8(x)             (*(__IO hw_ltc_k80_lpkn0_8_t *) HW_LTC_K80_LPKN0_8_ADDR(x))
#define HW_LTC_K80_LPKN0_8_RD(x)          (HW_LTC_K80_LPKN0_8(x).U)
#define HW_LTC_K80_LPKN0_8_WR(x, v)       (HW_LTC_K80_LPKN0_8(x).U = (v))
#define HW_LTC_K80_LPKN0_8_SET(x, v)      (HW_LTC_K80_LPKN0_8_WR(x, HW_LTC_K80_LPKN0_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_8_CLR(x, v)      (HW_LTC_K80_LPKN0_8_WR(x, HW_LTC_K80_LPKN0_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_8_TOG(x, v)      (HW_LTC_K80_LPKN0_8_WR(x, HW_LTC_K80_LPKN0_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_8, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_8_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_8_PKHA_N0. */
#define BM_LTC_K80_LPKN0_8_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_8_PKHA_N0. */
#define BS_LTC_K80_LPKN0_8_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_8_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_8_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_8_PKHA_N0(x)      (HW_LTC_K80_LPKN0_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_8_PKHA_N0. */
#define BF_LTC_K80_LPKN0_8_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_8_PKHA_N0) & BM_LTC_K80_LPKN0_8_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_8_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_9 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_9 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_9_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_9_ADDR(x)        ((x) + 0xC24U)
#define HW_LTC_K80_LPKN0_9(x)             (*(__IO hw_ltc_k80_lpkn0_9_t *) HW_LTC_K80_LPKN0_9_ADDR(x))
#define HW_LTC_K80_LPKN0_9_RD(x)          (HW_LTC_K80_LPKN0_9(x).U)
#define HW_LTC_K80_LPKN0_9_WR(x, v)       (HW_LTC_K80_LPKN0_9(x).U = (v))
#define HW_LTC_K80_LPKN0_9_SET(x, v)      (HW_LTC_K80_LPKN0_9_WR(x, HW_LTC_K80_LPKN0_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_9_CLR(x, v)      (HW_LTC_K80_LPKN0_9_WR(x, HW_LTC_K80_LPKN0_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_9_TOG(x, v)      (HW_LTC_K80_LPKN0_9_WR(x, HW_LTC_K80_LPKN0_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_9, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_9_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_9_PKHA_N0. */
#define BM_LTC_K80_LPKN0_9_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_9_PKHA_N0. */
#define BS_LTC_K80_LPKN0_9_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_9_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_9_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_9_PKHA_N0(x)      (HW_LTC_K80_LPKN0_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_9_PKHA_N0. */
#define BF_LTC_K80_LPKN0_9_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_9_PKHA_N0) & BM_LTC_K80_LPKN0_9_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_9_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_10 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_10 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_10_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_10_ADDR(x)        ((x) + 0xC28U)
#define HW_LTC_K80_LPKN0_10(x)             (*(__IO hw_ltc_k80_lpkn0_10_t *) HW_LTC_K80_LPKN0_10_ADDR(x))
#define HW_LTC_K80_LPKN0_10_RD(x)          (HW_LTC_K80_LPKN0_10(x).U)
#define HW_LTC_K80_LPKN0_10_WR(x, v)       (HW_LTC_K80_LPKN0_10(x).U = (v))
#define HW_LTC_K80_LPKN0_10_SET(x, v)      (HW_LTC_K80_LPKN0_10_WR(x, HW_LTC_K80_LPKN0_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_10_CLR(x, v)      (HW_LTC_K80_LPKN0_10_WR(x, HW_LTC_K80_LPKN0_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_10_TOG(x, v)      (HW_LTC_K80_LPKN0_10_WR(x, HW_LTC_K80_LPKN0_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_10, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_10_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_10_PKHA_N0. */
#define BM_LTC_K80_LPKN0_10_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_10_PKHA_N0. */
#define BS_LTC_K80_LPKN0_10_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_10_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_10_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_10_PKHA_N0(x)      (HW_LTC_K80_LPKN0_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_10_PKHA_N0. */
#define BF_LTC_K80_LPKN0_10_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_10_PKHA_N0) & BM_LTC_K80_LPKN0_10_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_10_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_11 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_11 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_11_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_11_ADDR(x)        ((x) + 0xC2CU)
#define HW_LTC_K80_LPKN0_11(x)             (*(__IO hw_ltc_k80_lpkn0_11_t *) HW_LTC_K80_LPKN0_11_ADDR(x))
#define HW_LTC_K80_LPKN0_11_RD(x)          (HW_LTC_K80_LPKN0_11(x).U)
#define HW_LTC_K80_LPKN0_11_WR(x, v)       (HW_LTC_K80_LPKN0_11(x).U = (v))
#define HW_LTC_K80_LPKN0_11_SET(x, v)      (HW_LTC_K80_LPKN0_11_WR(x, HW_LTC_K80_LPKN0_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_11_CLR(x, v)      (HW_LTC_K80_LPKN0_11_WR(x, HW_LTC_K80_LPKN0_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_11_TOG(x, v)      (HW_LTC_K80_LPKN0_11_WR(x, HW_LTC_K80_LPKN0_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_11, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_11_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_11_PKHA_N0. */
#define BM_LTC_K80_LPKN0_11_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_11_PKHA_N0. */
#define BS_LTC_K80_LPKN0_11_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_11_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_11_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_11_PKHA_N0(x)      (HW_LTC_K80_LPKN0_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_11_PKHA_N0. */
#define BF_LTC_K80_LPKN0_11_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_11_PKHA_N0) & BM_LTC_K80_LPKN0_11_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_11_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_12 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_12 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_12_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_12_ADDR(x)        ((x) + 0xC30U)
#define HW_LTC_K80_LPKN0_12(x)             (*(__IO hw_ltc_k80_lpkn0_12_t *) HW_LTC_K80_LPKN0_12_ADDR(x))
#define HW_LTC_K80_LPKN0_12_RD(x)          (HW_LTC_K80_LPKN0_12(x).U)
#define HW_LTC_K80_LPKN0_12_WR(x, v)       (HW_LTC_K80_LPKN0_12(x).U = (v))
#define HW_LTC_K80_LPKN0_12_SET(x, v)      (HW_LTC_K80_LPKN0_12_WR(x, HW_LTC_K80_LPKN0_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_12_CLR(x, v)      (HW_LTC_K80_LPKN0_12_WR(x, HW_LTC_K80_LPKN0_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_12_TOG(x, v)      (HW_LTC_K80_LPKN0_12_WR(x, HW_LTC_K80_LPKN0_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_12, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_12_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_12_PKHA_N0. */
#define BM_LTC_K80_LPKN0_12_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_12_PKHA_N0. */
#define BS_LTC_K80_LPKN0_12_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_12_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_12_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_12_PKHA_N0(x)      (HW_LTC_K80_LPKN0_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_12_PKHA_N0. */
#define BF_LTC_K80_LPKN0_12_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_12_PKHA_N0) & BM_LTC_K80_LPKN0_12_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_12_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_13 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_13 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_13_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_13_ADDR(x)        ((x) + 0xC34U)
#define HW_LTC_K80_LPKN0_13(x)             (*(__IO hw_ltc_k80_lpkn0_13_t *) HW_LTC_K80_LPKN0_13_ADDR(x))
#define HW_LTC_K80_LPKN0_13_RD(x)          (HW_LTC_K80_LPKN0_13(x).U)
#define HW_LTC_K80_LPKN0_13_WR(x, v)       (HW_LTC_K80_LPKN0_13(x).U = (v))
#define HW_LTC_K80_LPKN0_13_SET(x, v)      (HW_LTC_K80_LPKN0_13_WR(x, HW_LTC_K80_LPKN0_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_13_CLR(x, v)      (HW_LTC_K80_LPKN0_13_WR(x, HW_LTC_K80_LPKN0_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_13_TOG(x, v)      (HW_LTC_K80_LPKN0_13_WR(x, HW_LTC_K80_LPKN0_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_13, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_13_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_13_PKHA_N0. */
#define BM_LTC_K80_LPKN0_13_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_13_PKHA_N0. */
#define BS_LTC_K80_LPKN0_13_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_13_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_13_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_13_PKHA_N0(x)      (HW_LTC_K80_LPKN0_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_13_PKHA_N0. */
#define BF_LTC_K80_LPKN0_13_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_13_PKHA_N0) & BM_LTC_K80_LPKN0_13_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_13_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_14 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_14 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_14_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_14_ADDR(x)        ((x) + 0xC38U)
#define HW_LTC_K80_LPKN0_14(x)             (*(__IO hw_ltc_k80_lpkn0_14_t *) HW_LTC_K80_LPKN0_14_ADDR(x))
#define HW_LTC_K80_LPKN0_14_RD(x)          (HW_LTC_K80_LPKN0_14(x).U)
#define HW_LTC_K80_LPKN0_14_WR(x, v)       (HW_LTC_K80_LPKN0_14(x).U = (v))
#define HW_LTC_K80_LPKN0_14_SET(x, v)      (HW_LTC_K80_LPKN0_14_WR(x, HW_LTC_K80_LPKN0_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_14_CLR(x, v)      (HW_LTC_K80_LPKN0_14_WR(x, HW_LTC_K80_LPKN0_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_14_TOG(x, v)      (HW_LTC_K80_LPKN0_14_WR(x, HW_LTC_K80_LPKN0_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_14, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_14_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_14_PKHA_N0. */
#define BM_LTC_K80_LPKN0_14_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_14_PKHA_N0. */
#define BS_LTC_K80_LPKN0_14_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_14_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_14_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_14_PKHA_N0(x)      (HW_LTC_K80_LPKN0_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_14_PKHA_N0. */
#define BF_LTC_K80_LPKN0_14_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_14_PKHA_N0) & BM_LTC_K80_LPKN0_14_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_14_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN0_15 - LTC PKHA N0 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN0_15 - LTC PKHA N0 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N0 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C00h, in the right-most byte. The LTC PKHA N0 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N0 Register (or
 * {N3, N2, N1, N0}, if used as a single value) is limited by the LTC PKHA N Size Register
 * (LPKNSZR). Note that the PKHA Registers can be read/written only when the LTC Mode Register
 * (LTCMR_PK) does not contain a value enabling a PKHA operation. If the LTCMR_PK contains a PKHA
 * operation mode value, then writes to PKHA Registers will be ignored, and reads of PKHA Registers
 * will return a value of zero.
 */
typedef union _hw_ltc_k80_lpkn0_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn0_15_bitfields
    {
        uint32_t PKHA_N0 : 32; /*!< [31:0] N0 VALUE */
    } B;
} hw_ltc_k80_lpkn0_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN0_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKN0_15_ADDR(x)        ((x) + 0xC3CU)
#define HW_LTC_K80_LPKN0_15(x)             (*(__IO hw_ltc_k80_lpkn0_15_t *) HW_LTC_K80_LPKN0_15_ADDR(x))
#define HW_LTC_K80_LPKN0_15_RD(x)          (HW_LTC_K80_LPKN0_15(x).U)
#define HW_LTC_K80_LPKN0_15_WR(x, v)       (HW_LTC_K80_LPKN0_15(x).U = (v))
#define HW_LTC_K80_LPKN0_15_SET(x, v)      (HW_LTC_K80_LPKN0_15_WR(x, HW_LTC_K80_LPKN0_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKN0_15_CLR(x, v)      (HW_LTC_K80_LPKN0_15_WR(x, HW_LTC_K80_LPKN0_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN0_15_TOG(x, v)      (HW_LTC_K80_LPKN0_15_WR(x, HW_LTC_K80_LPKN0_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN0_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN0_15, field PKHA_N0[31:0] (RW)
 *
 * N0 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN0_15_PKHA_N0         (0U)      /*!< Bit position for LTC_K80_LPKN0_15_PKHA_N0. */
#define BM_LTC_K80_LPKN0_15_PKHA_N0         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN0_15_PKHA_N0. */
#define BS_LTC_K80_LPKN0_15_PKHA_N0         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN0_15_PKHA_N0. */

/*! @brief Read current value of the LTC_K80_LPKN0_15_PKHA_N0 field. */
#define BR_LTC_K80_LPKN0_15_PKHA_N0(x)      (HW_LTC_K80_LPKN0_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN0_15_PKHA_N0. */
#define BF_LTC_K80_LPKN0_15_PKHA_N0(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN0_15_PKHA_N0) & BM_LTC_K80_LPKN0_15_PKHA_N0)

/*! @brief Set the PKHA_N0 field to a new value. */
#define BW_LTC_K80_LPKN0_15_PKHA_N0(x, v)   (HW_LTC_K80_LPKN0_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_0 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_0 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_0_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_0_ADDR(x)        ((x) + 0xC40U)
#define HW_LTC_K80_LPKN1_0(x)             (*(__IO hw_ltc_k80_lpkn1_0_t *) HW_LTC_K80_LPKN1_0_ADDR(x))
#define HW_LTC_K80_LPKN1_0_RD(x)          (HW_LTC_K80_LPKN1_0(x).U)
#define HW_LTC_K80_LPKN1_0_WR(x, v)       (HW_LTC_K80_LPKN1_0(x).U = (v))
#define HW_LTC_K80_LPKN1_0_SET(x, v)      (HW_LTC_K80_LPKN1_0_WR(x, HW_LTC_K80_LPKN1_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_0_CLR(x, v)      (HW_LTC_K80_LPKN1_0_WR(x, HW_LTC_K80_LPKN1_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_0_TOG(x, v)      (HW_LTC_K80_LPKN1_0_WR(x, HW_LTC_K80_LPKN1_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_0, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_0_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_0_PKHA_N1. */
#define BM_LTC_K80_LPKN1_0_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_0_PKHA_N1. */
#define BS_LTC_K80_LPKN1_0_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_0_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_0_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_0_PKHA_N1(x)      (HW_LTC_K80_LPKN1_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_0_PKHA_N1. */
#define BF_LTC_K80_LPKN1_0_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_0_PKHA_N1) & BM_LTC_K80_LPKN1_0_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_0_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_1 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_1 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_1_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_1_ADDR(x)        ((x) + 0xC44U)
#define HW_LTC_K80_LPKN1_1(x)             (*(__IO hw_ltc_k80_lpkn1_1_t *) HW_LTC_K80_LPKN1_1_ADDR(x))
#define HW_LTC_K80_LPKN1_1_RD(x)          (HW_LTC_K80_LPKN1_1(x).U)
#define HW_LTC_K80_LPKN1_1_WR(x, v)       (HW_LTC_K80_LPKN1_1(x).U = (v))
#define HW_LTC_K80_LPKN1_1_SET(x, v)      (HW_LTC_K80_LPKN1_1_WR(x, HW_LTC_K80_LPKN1_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_1_CLR(x, v)      (HW_LTC_K80_LPKN1_1_WR(x, HW_LTC_K80_LPKN1_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_1_TOG(x, v)      (HW_LTC_K80_LPKN1_1_WR(x, HW_LTC_K80_LPKN1_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_1, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_1_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_1_PKHA_N1. */
#define BM_LTC_K80_LPKN1_1_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_1_PKHA_N1. */
#define BS_LTC_K80_LPKN1_1_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_1_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_1_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_1_PKHA_N1(x)      (HW_LTC_K80_LPKN1_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_1_PKHA_N1. */
#define BF_LTC_K80_LPKN1_1_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_1_PKHA_N1) & BM_LTC_K80_LPKN1_1_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_1_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_2 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_2 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_2_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_2_ADDR(x)        ((x) + 0xC48U)
#define HW_LTC_K80_LPKN1_2(x)             (*(__IO hw_ltc_k80_lpkn1_2_t *) HW_LTC_K80_LPKN1_2_ADDR(x))
#define HW_LTC_K80_LPKN1_2_RD(x)          (HW_LTC_K80_LPKN1_2(x).U)
#define HW_LTC_K80_LPKN1_2_WR(x, v)       (HW_LTC_K80_LPKN1_2(x).U = (v))
#define HW_LTC_K80_LPKN1_2_SET(x, v)      (HW_LTC_K80_LPKN1_2_WR(x, HW_LTC_K80_LPKN1_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_2_CLR(x, v)      (HW_LTC_K80_LPKN1_2_WR(x, HW_LTC_K80_LPKN1_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_2_TOG(x, v)      (HW_LTC_K80_LPKN1_2_WR(x, HW_LTC_K80_LPKN1_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_2, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_2_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_2_PKHA_N1. */
#define BM_LTC_K80_LPKN1_2_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_2_PKHA_N1. */
#define BS_LTC_K80_LPKN1_2_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_2_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_2_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_2_PKHA_N1(x)      (HW_LTC_K80_LPKN1_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_2_PKHA_N1. */
#define BF_LTC_K80_LPKN1_2_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_2_PKHA_N1) & BM_LTC_K80_LPKN1_2_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_2_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_3 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_3 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_3_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_3_ADDR(x)        ((x) + 0xC4CU)
#define HW_LTC_K80_LPKN1_3(x)             (*(__IO hw_ltc_k80_lpkn1_3_t *) HW_LTC_K80_LPKN1_3_ADDR(x))
#define HW_LTC_K80_LPKN1_3_RD(x)          (HW_LTC_K80_LPKN1_3(x).U)
#define HW_LTC_K80_LPKN1_3_WR(x, v)       (HW_LTC_K80_LPKN1_3(x).U = (v))
#define HW_LTC_K80_LPKN1_3_SET(x, v)      (HW_LTC_K80_LPKN1_3_WR(x, HW_LTC_K80_LPKN1_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_3_CLR(x, v)      (HW_LTC_K80_LPKN1_3_WR(x, HW_LTC_K80_LPKN1_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_3_TOG(x, v)      (HW_LTC_K80_LPKN1_3_WR(x, HW_LTC_K80_LPKN1_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_3, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_3_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_3_PKHA_N1. */
#define BM_LTC_K80_LPKN1_3_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_3_PKHA_N1. */
#define BS_LTC_K80_LPKN1_3_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_3_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_3_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_3_PKHA_N1(x)      (HW_LTC_K80_LPKN1_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_3_PKHA_N1. */
#define BF_LTC_K80_LPKN1_3_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_3_PKHA_N1) & BM_LTC_K80_LPKN1_3_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_3_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_4 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_4 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_4_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_4_ADDR(x)        ((x) + 0xC50U)
#define HW_LTC_K80_LPKN1_4(x)             (*(__IO hw_ltc_k80_lpkn1_4_t *) HW_LTC_K80_LPKN1_4_ADDR(x))
#define HW_LTC_K80_LPKN1_4_RD(x)          (HW_LTC_K80_LPKN1_4(x).U)
#define HW_LTC_K80_LPKN1_4_WR(x, v)       (HW_LTC_K80_LPKN1_4(x).U = (v))
#define HW_LTC_K80_LPKN1_4_SET(x, v)      (HW_LTC_K80_LPKN1_4_WR(x, HW_LTC_K80_LPKN1_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_4_CLR(x, v)      (HW_LTC_K80_LPKN1_4_WR(x, HW_LTC_K80_LPKN1_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_4_TOG(x, v)      (HW_LTC_K80_LPKN1_4_WR(x, HW_LTC_K80_LPKN1_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_4, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_4_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_4_PKHA_N1. */
#define BM_LTC_K80_LPKN1_4_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_4_PKHA_N1. */
#define BS_LTC_K80_LPKN1_4_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_4_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_4_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_4_PKHA_N1(x)      (HW_LTC_K80_LPKN1_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_4_PKHA_N1. */
#define BF_LTC_K80_LPKN1_4_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_4_PKHA_N1) & BM_LTC_K80_LPKN1_4_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_4_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_5 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_5 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_5_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_5_ADDR(x)        ((x) + 0xC54U)
#define HW_LTC_K80_LPKN1_5(x)             (*(__IO hw_ltc_k80_lpkn1_5_t *) HW_LTC_K80_LPKN1_5_ADDR(x))
#define HW_LTC_K80_LPKN1_5_RD(x)          (HW_LTC_K80_LPKN1_5(x).U)
#define HW_LTC_K80_LPKN1_5_WR(x, v)       (HW_LTC_K80_LPKN1_5(x).U = (v))
#define HW_LTC_K80_LPKN1_5_SET(x, v)      (HW_LTC_K80_LPKN1_5_WR(x, HW_LTC_K80_LPKN1_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_5_CLR(x, v)      (HW_LTC_K80_LPKN1_5_WR(x, HW_LTC_K80_LPKN1_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_5_TOG(x, v)      (HW_LTC_K80_LPKN1_5_WR(x, HW_LTC_K80_LPKN1_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_5, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_5_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_5_PKHA_N1. */
#define BM_LTC_K80_LPKN1_5_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_5_PKHA_N1. */
#define BS_LTC_K80_LPKN1_5_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_5_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_5_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_5_PKHA_N1(x)      (HW_LTC_K80_LPKN1_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_5_PKHA_N1. */
#define BF_LTC_K80_LPKN1_5_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_5_PKHA_N1) & BM_LTC_K80_LPKN1_5_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_5_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_6 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_6 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_6_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_6_ADDR(x)        ((x) + 0xC58U)
#define HW_LTC_K80_LPKN1_6(x)             (*(__IO hw_ltc_k80_lpkn1_6_t *) HW_LTC_K80_LPKN1_6_ADDR(x))
#define HW_LTC_K80_LPKN1_6_RD(x)          (HW_LTC_K80_LPKN1_6(x).U)
#define HW_LTC_K80_LPKN1_6_WR(x, v)       (HW_LTC_K80_LPKN1_6(x).U = (v))
#define HW_LTC_K80_LPKN1_6_SET(x, v)      (HW_LTC_K80_LPKN1_6_WR(x, HW_LTC_K80_LPKN1_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_6_CLR(x, v)      (HW_LTC_K80_LPKN1_6_WR(x, HW_LTC_K80_LPKN1_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_6_TOG(x, v)      (HW_LTC_K80_LPKN1_6_WR(x, HW_LTC_K80_LPKN1_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_6, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_6_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_6_PKHA_N1. */
#define BM_LTC_K80_LPKN1_6_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_6_PKHA_N1. */
#define BS_LTC_K80_LPKN1_6_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_6_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_6_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_6_PKHA_N1(x)      (HW_LTC_K80_LPKN1_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_6_PKHA_N1. */
#define BF_LTC_K80_LPKN1_6_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_6_PKHA_N1) & BM_LTC_K80_LPKN1_6_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_6_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_7 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_7 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_7_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_7_ADDR(x)        ((x) + 0xC5CU)
#define HW_LTC_K80_LPKN1_7(x)             (*(__IO hw_ltc_k80_lpkn1_7_t *) HW_LTC_K80_LPKN1_7_ADDR(x))
#define HW_LTC_K80_LPKN1_7_RD(x)          (HW_LTC_K80_LPKN1_7(x).U)
#define HW_LTC_K80_LPKN1_7_WR(x, v)       (HW_LTC_K80_LPKN1_7(x).U = (v))
#define HW_LTC_K80_LPKN1_7_SET(x, v)      (HW_LTC_K80_LPKN1_7_WR(x, HW_LTC_K80_LPKN1_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_7_CLR(x, v)      (HW_LTC_K80_LPKN1_7_WR(x, HW_LTC_K80_LPKN1_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_7_TOG(x, v)      (HW_LTC_K80_LPKN1_7_WR(x, HW_LTC_K80_LPKN1_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_7, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_7_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_7_PKHA_N1. */
#define BM_LTC_K80_LPKN1_7_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_7_PKHA_N1. */
#define BS_LTC_K80_LPKN1_7_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_7_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_7_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_7_PKHA_N1(x)      (HW_LTC_K80_LPKN1_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_7_PKHA_N1. */
#define BF_LTC_K80_LPKN1_7_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_7_PKHA_N1) & BM_LTC_K80_LPKN1_7_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_7_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_8 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_8 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_8_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_8_ADDR(x)        ((x) + 0xC60U)
#define HW_LTC_K80_LPKN1_8(x)             (*(__IO hw_ltc_k80_lpkn1_8_t *) HW_LTC_K80_LPKN1_8_ADDR(x))
#define HW_LTC_K80_LPKN1_8_RD(x)          (HW_LTC_K80_LPKN1_8(x).U)
#define HW_LTC_K80_LPKN1_8_WR(x, v)       (HW_LTC_K80_LPKN1_8(x).U = (v))
#define HW_LTC_K80_LPKN1_8_SET(x, v)      (HW_LTC_K80_LPKN1_8_WR(x, HW_LTC_K80_LPKN1_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_8_CLR(x, v)      (HW_LTC_K80_LPKN1_8_WR(x, HW_LTC_K80_LPKN1_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_8_TOG(x, v)      (HW_LTC_K80_LPKN1_8_WR(x, HW_LTC_K80_LPKN1_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_8, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_8_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_8_PKHA_N1. */
#define BM_LTC_K80_LPKN1_8_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_8_PKHA_N1. */
#define BS_LTC_K80_LPKN1_8_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_8_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_8_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_8_PKHA_N1(x)      (HW_LTC_K80_LPKN1_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_8_PKHA_N1. */
#define BF_LTC_K80_LPKN1_8_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_8_PKHA_N1) & BM_LTC_K80_LPKN1_8_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_8_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_9 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_9 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_9_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_9_ADDR(x)        ((x) + 0xC64U)
#define HW_LTC_K80_LPKN1_9(x)             (*(__IO hw_ltc_k80_lpkn1_9_t *) HW_LTC_K80_LPKN1_9_ADDR(x))
#define HW_LTC_K80_LPKN1_9_RD(x)          (HW_LTC_K80_LPKN1_9(x).U)
#define HW_LTC_K80_LPKN1_9_WR(x, v)       (HW_LTC_K80_LPKN1_9(x).U = (v))
#define HW_LTC_K80_LPKN1_9_SET(x, v)      (HW_LTC_K80_LPKN1_9_WR(x, HW_LTC_K80_LPKN1_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_9_CLR(x, v)      (HW_LTC_K80_LPKN1_9_WR(x, HW_LTC_K80_LPKN1_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_9_TOG(x, v)      (HW_LTC_K80_LPKN1_9_WR(x, HW_LTC_K80_LPKN1_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_9, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_9_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_9_PKHA_N1. */
#define BM_LTC_K80_LPKN1_9_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_9_PKHA_N1. */
#define BS_LTC_K80_LPKN1_9_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_9_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_9_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_9_PKHA_N1(x)      (HW_LTC_K80_LPKN1_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_9_PKHA_N1. */
#define BF_LTC_K80_LPKN1_9_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_9_PKHA_N1) & BM_LTC_K80_LPKN1_9_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_9_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_10 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_10 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_10_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_10_ADDR(x)        ((x) + 0xC68U)
#define HW_LTC_K80_LPKN1_10(x)             (*(__IO hw_ltc_k80_lpkn1_10_t *) HW_LTC_K80_LPKN1_10_ADDR(x))
#define HW_LTC_K80_LPKN1_10_RD(x)          (HW_LTC_K80_LPKN1_10(x).U)
#define HW_LTC_K80_LPKN1_10_WR(x, v)       (HW_LTC_K80_LPKN1_10(x).U = (v))
#define HW_LTC_K80_LPKN1_10_SET(x, v)      (HW_LTC_K80_LPKN1_10_WR(x, HW_LTC_K80_LPKN1_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_10_CLR(x, v)      (HW_LTC_K80_LPKN1_10_WR(x, HW_LTC_K80_LPKN1_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_10_TOG(x, v)      (HW_LTC_K80_LPKN1_10_WR(x, HW_LTC_K80_LPKN1_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_10, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_10_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_10_PKHA_N1. */
#define BM_LTC_K80_LPKN1_10_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_10_PKHA_N1. */
#define BS_LTC_K80_LPKN1_10_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_10_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_10_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_10_PKHA_N1(x)      (HW_LTC_K80_LPKN1_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_10_PKHA_N1. */
#define BF_LTC_K80_LPKN1_10_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_10_PKHA_N1) & BM_LTC_K80_LPKN1_10_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_10_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_11 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_11 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_11_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_11_ADDR(x)        ((x) + 0xC6CU)
#define HW_LTC_K80_LPKN1_11(x)             (*(__IO hw_ltc_k80_lpkn1_11_t *) HW_LTC_K80_LPKN1_11_ADDR(x))
#define HW_LTC_K80_LPKN1_11_RD(x)          (HW_LTC_K80_LPKN1_11(x).U)
#define HW_LTC_K80_LPKN1_11_WR(x, v)       (HW_LTC_K80_LPKN1_11(x).U = (v))
#define HW_LTC_K80_LPKN1_11_SET(x, v)      (HW_LTC_K80_LPKN1_11_WR(x, HW_LTC_K80_LPKN1_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_11_CLR(x, v)      (HW_LTC_K80_LPKN1_11_WR(x, HW_LTC_K80_LPKN1_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_11_TOG(x, v)      (HW_LTC_K80_LPKN1_11_WR(x, HW_LTC_K80_LPKN1_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_11, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_11_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_11_PKHA_N1. */
#define BM_LTC_K80_LPKN1_11_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_11_PKHA_N1. */
#define BS_LTC_K80_LPKN1_11_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_11_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_11_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_11_PKHA_N1(x)      (HW_LTC_K80_LPKN1_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_11_PKHA_N1. */
#define BF_LTC_K80_LPKN1_11_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_11_PKHA_N1) & BM_LTC_K80_LPKN1_11_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_11_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_12 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_12 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_12_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_12_ADDR(x)        ((x) + 0xC70U)
#define HW_LTC_K80_LPKN1_12(x)             (*(__IO hw_ltc_k80_lpkn1_12_t *) HW_LTC_K80_LPKN1_12_ADDR(x))
#define HW_LTC_K80_LPKN1_12_RD(x)          (HW_LTC_K80_LPKN1_12(x).U)
#define HW_LTC_K80_LPKN1_12_WR(x, v)       (HW_LTC_K80_LPKN1_12(x).U = (v))
#define HW_LTC_K80_LPKN1_12_SET(x, v)      (HW_LTC_K80_LPKN1_12_WR(x, HW_LTC_K80_LPKN1_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_12_CLR(x, v)      (HW_LTC_K80_LPKN1_12_WR(x, HW_LTC_K80_LPKN1_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_12_TOG(x, v)      (HW_LTC_K80_LPKN1_12_WR(x, HW_LTC_K80_LPKN1_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_12, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_12_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_12_PKHA_N1. */
#define BM_LTC_K80_LPKN1_12_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_12_PKHA_N1. */
#define BS_LTC_K80_LPKN1_12_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_12_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_12_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_12_PKHA_N1(x)      (HW_LTC_K80_LPKN1_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_12_PKHA_N1. */
#define BF_LTC_K80_LPKN1_12_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_12_PKHA_N1) & BM_LTC_K80_LPKN1_12_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_12_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_13 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_13 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_13_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_13_ADDR(x)        ((x) + 0xC74U)
#define HW_LTC_K80_LPKN1_13(x)             (*(__IO hw_ltc_k80_lpkn1_13_t *) HW_LTC_K80_LPKN1_13_ADDR(x))
#define HW_LTC_K80_LPKN1_13_RD(x)          (HW_LTC_K80_LPKN1_13(x).U)
#define HW_LTC_K80_LPKN1_13_WR(x, v)       (HW_LTC_K80_LPKN1_13(x).U = (v))
#define HW_LTC_K80_LPKN1_13_SET(x, v)      (HW_LTC_K80_LPKN1_13_WR(x, HW_LTC_K80_LPKN1_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_13_CLR(x, v)      (HW_LTC_K80_LPKN1_13_WR(x, HW_LTC_K80_LPKN1_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_13_TOG(x, v)      (HW_LTC_K80_LPKN1_13_WR(x, HW_LTC_K80_LPKN1_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_13, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_13_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_13_PKHA_N1. */
#define BM_LTC_K80_LPKN1_13_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_13_PKHA_N1. */
#define BS_LTC_K80_LPKN1_13_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_13_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_13_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_13_PKHA_N1(x)      (HW_LTC_K80_LPKN1_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_13_PKHA_N1. */
#define BF_LTC_K80_LPKN1_13_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_13_PKHA_N1) & BM_LTC_K80_LPKN1_13_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_13_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_14 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_14 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_14_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_14_ADDR(x)        ((x) + 0xC78U)
#define HW_LTC_K80_LPKN1_14(x)             (*(__IO hw_ltc_k80_lpkn1_14_t *) HW_LTC_K80_LPKN1_14_ADDR(x))
#define HW_LTC_K80_LPKN1_14_RD(x)          (HW_LTC_K80_LPKN1_14(x).U)
#define HW_LTC_K80_LPKN1_14_WR(x, v)       (HW_LTC_K80_LPKN1_14(x).U = (v))
#define HW_LTC_K80_LPKN1_14_SET(x, v)      (HW_LTC_K80_LPKN1_14_WR(x, HW_LTC_K80_LPKN1_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_14_CLR(x, v)      (HW_LTC_K80_LPKN1_14_WR(x, HW_LTC_K80_LPKN1_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_14_TOG(x, v)      (HW_LTC_K80_LPKN1_14_WR(x, HW_LTC_K80_LPKN1_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_14, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_14_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_14_PKHA_N1. */
#define BM_LTC_K80_LPKN1_14_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_14_PKHA_N1. */
#define BS_LTC_K80_LPKN1_14_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_14_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_14_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_14_PKHA_N1(x)      (HW_LTC_K80_LPKN1_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_14_PKHA_N1. */
#define BF_LTC_K80_LPKN1_14_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_14_PKHA_N1) & BM_LTC_K80_LPKN1_14_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_14_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN1_15 - LTC PKHA N1 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN1_15 - LTC PKHA N1 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N1 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C40h, in the right-most byte. The LTC PKHA N1 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N1 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn1_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn1_15_bitfields
    {
        uint32_t PKHA_N1 : 32; /*!< [31:0] N1 VALUE */
    } B;
} hw_ltc_k80_lpkn1_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN1_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKN1_15_ADDR(x)        ((x) + 0xC7CU)
#define HW_LTC_K80_LPKN1_15(x)             (*(__IO hw_ltc_k80_lpkn1_15_t *) HW_LTC_K80_LPKN1_15_ADDR(x))
#define HW_LTC_K80_LPKN1_15_RD(x)          (HW_LTC_K80_LPKN1_15(x).U)
#define HW_LTC_K80_LPKN1_15_WR(x, v)       (HW_LTC_K80_LPKN1_15(x).U = (v))
#define HW_LTC_K80_LPKN1_15_SET(x, v)      (HW_LTC_K80_LPKN1_15_WR(x, HW_LTC_K80_LPKN1_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKN1_15_CLR(x, v)      (HW_LTC_K80_LPKN1_15_WR(x, HW_LTC_K80_LPKN1_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN1_15_TOG(x, v)      (HW_LTC_K80_LPKN1_15_WR(x, HW_LTC_K80_LPKN1_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN1_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN1_15, field PKHA_N1[31:0] (RW)
 *
 * N1 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN1_15_PKHA_N1         (0U)      /*!< Bit position for LTC_K80_LPKN1_15_PKHA_N1. */
#define BM_LTC_K80_LPKN1_15_PKHA_N1         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN1_15_PKHA_N1. */
#define BS_LTC_K80_LPKN1_15_PKHA_N1         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN1_15_PKHA_N1. */

/*! @brief Read current value of the LTC_K80_LPKN1_15_PKHA_N1 field. */
#define BR_LTC_K80_LPKN1_15_PKHA_N1(x)      (HW_LTC_K80_LPKN1_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN1_15_PKHA_N1. */
#define BF_LTC_K80_LPKN1_15_PKHA_N1(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN1_15_PKHA_N1) & BM_LTC_K80_LPKN1_15_PKHA_N1)

/*! @brief Set the PKHA_N1 field to a new value. */
#define BW_LTC_K80_LPKN1_15_PKHA_N1(x, v)   (HW_LTC_K80_LPKN1_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_0 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_0 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_0_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_0_ADDR(x)        ((x) + 0xC80U)
#define HW_LTC_K80_LPKN2_0(x)             (*(__IO hw_ltc_k80_lpkn2_0_t *) HW_LTC_K80_LPKN2_0_ADDR(x))
#define HW_LTC_K80_LPKN2_0_RD(x)          (HW_LTC_K80_LPKN2_0(x).U)
#define HW_LTC_K80_LPKN2_0_WR(x, v)       (HW_LTC_K80_LPKN2_0(x).U = (v))
#define HW_LTC_K80_LPKN2_0_SET(x, v)      (HW_LTC_K80_LPKN2_0_WR(x, HW_LTC_K80_LPKN2_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_0_CLR(x, v)      (HW_LTC_K80_LPKN2_0_WR(x, HW_LTC_K80_LPKN2_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_0_TOG(x, v)      (HW_LTC_K80_LPKN2_0_WR(x, HW_LTC_K80_LPKN2_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_0, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_0_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_0_PKHA_N2. */
#define BM_LTC_K80_LPKN2_0_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_0_PKHA_N2. */
#define BS_LTC_K80_LPKN2_0_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_0_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_0_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_0_PKHA_N2(x)      (HW_LTC_K80_LPKN2_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_0_PKHA_N2. */
#define BF_LTC_K80_LPKN2_0_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_0_PKHA_N2) & BM_LTC_K80_LPKN2_0_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_0_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_1 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_1 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_1_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_1_ADDR(x)        ((x) + 0xC84U)
#define HW_LTC_K80_LPKN2_1(x)             (*(__IO hw_ltc_k80_lpkn2_1_t *) HW_LTC_K80_LPKN2_1_ADDR(x))
#define HW_LTC_K80_LPKN2_1_RD(x)          (HW_LTC_K80_LPKN2_1(x).U)
#define HW_LTC_K80_LPKN2_1_WR(x, v)       (HW_LTC_K80_LPKN2_1(x).U = (v))
#define HW_LTC_K80_LPKN2_1_SET(x, v)      (HW_LTC_K80_LPKN2_1_WR(x, HW_LTC_K80_LPKN2_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_1_CLR(x, v)      (HW_LTC_K80_LPKN2_1_WR(x, HW_LTC_K80_LPKN2_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_1_TOG(x, v)      (HW_LTC_K80_LPKN2_1_WR(x, HW_LTC_K80_LPKN2_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_1, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_1_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_1_PKHA_N2. */
#define BM_LTC_K80_LPKN2_1_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_1_PKHA_N2. */
#define BS_LTC_K80_LPKN2_1_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_1_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_1_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_1_PKHA_N2(x)      (HW_LTC_K80_LPKN2_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_1_PKHA_N2. */
#define BF_LTC_K80_LPKN2_1_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_1_PKHA_N2) & BM_LTC_K80_LPKN2_1_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_1_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_2 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_2 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_2_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_2_ADDR(x)        ((x) + 0xC88U)
#define HW_LTC_K80_LPKN2_2(x)             (*(__IO hw_ltc_k80_lpkn2_2_t *) HW_LTC_K80_LPKN2_2_ADDR(x))
#define HW_LTC_K80_LPKN2_2_RD(x)          (HW_LTC_K80_LPKN2_2(x).U)
#define HW_LTC_K80_LPKN2_2_WR(x, v)       (HW_LTC_K80_LPKN2_2(x).U = (v))
#define HW_LTC_K80_LPKN2_2_SET(x, v)      (HW_LTC_K80_LPKN2_2_WR(x, HW_LTC_K80_LPKN2_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_2_CLR(x, v)      (HW_LTC_K80_LPKN2_2_WR(x, HW_LTC_K80_LPKN2_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_2_TOG(x, v)      (HW_LTC_K80_LPKN2_2_WR(x, HW_LTC_K80_LPKN2_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_2, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_2_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_2_PKHA_N2. */
#define BM_LTC_K80_LPKN2_2_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_2_PKHA_N2. */
#define BS_LTC_K80_LPKN2_2_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_2_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_2_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_2_PKHA_N2(x)      (HW_LTC_K80_LPKN2_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_2_PKHA_N2. */
#define BF_LTC_K80_LPKN2_2_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_2_PKHA_N2) & BM_LTC_K80_LPKN2_2_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_2_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_3 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_3 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_3_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_3_ADDR(x)        ((x) + 0xC8CU)
#define HW_LTC_K80_LPKN2_3(x)             (*(__IO hw_ltc_k80_lpkn2_3_t *) HW_LTC_K80_LPKN2_3_ADDR(x))
#define HW_LTC_K80_LPKN2_3_RD(x)          (HW_LTC_K80_LPKN2_3(x).U)
#define HW_LTC_K80_LPKN2_3_WR(x, v)       (HW_LTC_K80_LPKN2_3(x).U = (v))
#define HW_LTC_K80_LPKN2_3_SET(x, v)      (HW_LTC_K80_LPKN2_3_WR(x, HW_LTC_K80_LPKN2_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_3_CLR(x, v)      (HW_LTC_K80_LPKN2_3_WR(x, HW_LTC_K80_LPKN2_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_3_TOG(x, v)      (HW_LTC_K80_LPKN2_3_WR(x, HW_LTC_K80_LPKN2_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_3, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_3_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_3_PKHA_N2. */
#define BM_LTC_K80_LPKN2_3_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_3_PKHA_N2. */
#define BS_LTC_K80_LPKN2_3_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_3_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_3_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_3_PKHA_N2(x)      (HW_LTC_K80_LPKN2_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_3_PKHA_N2. */
#define BF_LTC_K80_LPKN2_3_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_3_PKHA_N2) & BM_LTC_K80_LPKN2_3_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_3_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_4 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_4 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_4_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_4_ADDR(x)        ((x) + 0xC90U)
#define HW_LTC_K80_LPKN2_4(x)             (*(__IO hw_ltc_k80_lpkn2_4_t *) HW_LTC_K80_LPKN2_4_ADDR(x))
#define HW_LTC_K80_LPKN2_4_RD(x)          (HW_LTC_K80_LPKN2_4(x).U)
#define HW_LTC_K80_LPKN2_4_WR(x, v)       (HW_LTC_K80_LPKN2_4(x).U = (v))
#define HW_LTC_K80_LPKN2_4_SET(x, v)      (HW_LTC_K80_LPKN2_4_WR(x, HW_LTC_K80_LPKN2_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_4_CLR(x, v)      (HW_LTC_K80_LPKN2_4_WR(x, HW_LTC_K80_LPKN2_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_4_TOG(x, v)      (HW_LTC_K80_LPKN2_4_WR(x, HW_LTC_K80_LPKN2_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_4, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_4_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_4_PKHA_N2. */
#define BM_LTC_K80_LPKN2_4_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_4_PKHA_N2. */
#define BS_LTC_K80_LPKN2_4_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_4_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_4_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_4_PKHA_N2(x)      (HW_LTC_K80_LPKN2_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_4_PKHA_N2. */
#define BF_LTC_K80_LPKN2_4_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_4_PKHA_N2) & BM_LTC_K80_LPKN2_4_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_4_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_5 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_5 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_5_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_5_ADDR(x)        ((x) + 0xC94U)
#define HW_LTC_K80_LPKN2_5(x)             (*(__IO hw_ltc_k80_lpkn2_5_t *) HW_LTC_K80_LPKN2_5_ADDR(x))
#define HW_LTC_K80_LPKN2_5_RD(x)          (HW_LTC_K80_LPKN2_5(x).U)
#define HW_LTC_K80_LPKN2_5_WR(x, v)       (HW_LTC_K80_LPKN2_5(x).U = (v))
#define HW_LTC_K80_LPKN2_5_SET(x, v)      (HW_LTC_K80_LPKN2_5_WR(x, HW_LTC_K80_LPKN2_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_5_CLR(x, v)      (HW_LTC_K80_LPKN2_5_WR(x, HW_LTC_K80_LPKN2_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_5_TOG(x, v)      (HW_LTC_K80_LPKN2_5_WR(x, HW_LTC_K80_LPKN2_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_5, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_5_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_5_PKHA_N2. */
#define BM_LTC_K80_LPKN2_5_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_5_PKHA_N2. */
#define BS_LTC_K80_LPKN2_5_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_5_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_5_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_5_PKHA_N2(x)      (HW_LTC_K80_LPKN2_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_5_PKHA_N2. */
#define BF_LTC_K80_LPKN2_5_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_5_PKHA_N2) & BM_LTC_K80_LPKN2_5_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_5_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_6 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_6 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_6_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_6_ADDR(x)        ((x) + 0xC98U)
#define HW_LTC_K80_LPKN2_6(x)             (*(__IO hw_ltc_k80_lpkn2_6_t *) HW_LTC_K80_LPKN2_6_ADDR(x))
#define HW_LTC_K80_LPKN2_6_RD(x)          (HW_LTC_K80_LPKN2_6(x).U)
#define HW_LTC_K80_LPKN2_6_WR(x, v)       (HW_LTC_K80_LPKN2_6(x).U = (v))
#define HW_LTC_K80_LPKN2_6_SET(x, v)      (HW_LTC_K80_LPKN2_6_WR(x, HW_LTC_K80_LPKN2_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_6_CLR(x, v)      (HW_LTC_K80_LPKN2_6_WR(x, HW_LTC_K80_LPKN2_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_6_TOG(x, v)      (HW_LTC_K80_LPKN2_6_WR(x, HW_LTC_K80_LPKN2_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_6, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_6_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_6_PKHA_N2. */
#define BM_LTC_K80_LPKN2_6_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_6_PKHA_N2. */
#define BS_LTC_K80_LPKN2_6_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_6_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_6_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_6_PKHA_N2(x)      (HW_LTC_K80_LPKN2_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_6_PKHA_N2. */
#define BF_LTC_K80_LPKN2_6_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_6_PKHA_N2) & BM_LTC_K80_LPKN2_6_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_6_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_7 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_7 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_7_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_7_ADDR(x)        ((x) + 0xC9CU)
#define HW_LTC_K80_LPKN2_7(x)             (*(__IO hw_ltc_k80_lpkn2_7_t *) HW_LTC_K80_LPKN2_7_ADDR(x))
#define HW_LTC_K80_LPKN2_7_RD(x)          (HW_LTC_K80_LPKN2_7(x).U)
#define HW_LTC_K80_LPKN2_7_WR(x, v)       (HW_LTC_K80_LPKN2_7(x).U = (v))
#define HW_LTC_K80_LPKN2_7_SET(x, v)      (HW_LTC_K80_LPKN2_7_WR(x, HW_LTC_K80_LPKN2_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_7_CLR(x, v)      (HW_LTC_K80_LPKN2_7_WR(x, HW_LTC_K80_LPKN2_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_7_TOG(x, v)      (HW_LTC_K80_LPKN2_7_WR(x, HW_LTC_K80_LPKN2_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_7, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_7_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_7_PKHA_N2. */
#define BM_LTC_K80_LPKN2_7_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_7_PKHA_N2. */
#define BS_LTC_K80_LPKN2_7_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_7_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_7_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_7_PKHA_N2(x)      (HW_LTC_K80_LPKN2_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_7_PKHA_N2. */
#define BF_LTC_K80_LPKN2_7_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_7_PKHA_N2) & BM_LTC_K80_LPKN2_7_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_7_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_8 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_8 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_8_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_8_ADDR(x)        ((x) + 0xCA0U)
#define HW_LTC_K80_LPKN2_8(x)             (*(__IO hw_ltc_k80_lpkn2_8_t *) HW_LTC_K80_LPKN2_8_ADDR(x))
#define HW_LTC_K80_LPKN2_8_RD(x)          (HW_LTC_K80_LPKN2_8(x).U)
#define HW_LTC_K80_LPKN2_8_WR(x, v)       (HW_LTC_K80_LPKN2_8(x).U = (v))
#define HW_LTC_K80_LPKN2_8_SET(x, v)      (HW_LTC_K80_LPKN2_8_WR(x, HW_LTC_K80_LPKN2_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_8_CLR(x, v)      (HW_LTC_K80_LPKN2_8_WR(x, HW_LTC_K80_LPKN2_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_8_TOG(x, v)      (HW_LTC_K80_LPKN2_8_WR(x, HW_LTC_K80_LPKN2_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_8, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_8_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_8_PKHA_N2. */
#define BM_LTC_K80_LPKN2_8_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_8_PKHA_N2. */
#define BS_LTC_K80_LPKN2_8_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_8_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_8_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_8_PKHA_N2(x)      (HW_LTC_K80_LPKN2_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_8_PKHA_N2. */
#define BF_LTC_K80_LPKN2_8_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_8_PKHA_N2) & BM_LTC_K80_LPKN2_8_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_8_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_9 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_9 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_9_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_9_ADDR(x)        ((x) + 0xCA4U)
#define HW_LTC_K80_LPKN2_9(x)             (*(__IO hw_ltc_k80_lpkn2_9_t *) HW_LTC_K80_LPKN2_9_ADDR(x))
#define HW_LTC_K80_LPKN2_9_RD(x)          (HW_LTC_K80_LPKN2_9(x).U)
#define HW_LTC_K80_LPKN2_9_WR(x, v)       (HW_LTC_K80_LPKN2_9(x).U = (v))
#define HW_LTC_K80_LPKN2_9_SET(x, v)      (HW_LTC_K80_LPKN2_9_WR(x, HW_LTC_K80_LPKN2_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_9_CLR(x, v)      (HW_LTC_K80_LPKN2_9_WR(x, HW_LTC_K80_LPKN2_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_9_TOG(x, v)      (HW_LTC_K80_LPKN2_9_WR(x, HW_LTC_K80_LPKN2_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_9, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_9_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_9_PKHA_N2. */
#define BM_LTC_K80_LPKN2_9_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_9_PKHA_N2. */
#define BS_LTC_K80_LPKN2_9_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_9_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_9_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_9_PKHA_N2(x)      (HW_LTC_K80_LPKN2_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_9_PKHA_N2. */
#define BF_LTC_K80_LPKN2_9_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_9_PKHA_N2) & BM_LTC_K80_LPKN2_9_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_9_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_10 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_10 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_10_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_10_ADDR(x)        ((x) + 0xCA8U)
#define HW_LTC_K80_LPKN2_10(x)             (*(__IO hw_ltc_k80_lpkn2_10_t *) HW_LTC_K80_LPKN2_10_ADDR(x))
#define HW_LTC_K80_LPKN2_10_RD(x)          (HW_LTC_K80_LPKN2_10(x).U)
#define HW_LTC_K80_LPKN2_10_WR(x, v)       (HW_LTC_K80_LPKN2_10(x).U = (v))
#define HW_LTC_K80_LPKN2_10_SET(x, v)      (HW_LTC_K80_LPKN2_10_WR(x, HW_LTC_K80_LPKN2_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_10_CLR(x, v)      (HW_LTC_K80_LPKN2_10_WR(x, HW_LTC_K80_LPKN2_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_10_TOG(x, v)      (HW_LTC_K80_LPKN2_10_WR(x, HW_LTC_K80_LPKN2_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_10, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_10_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_10_PKHA_N2. */
#define BM_LTC_K80_LPKN2_10_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_10_PKHA_N2. */
#define BS_LTC_K80_LPKN2_10_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_10_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_10_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_10_PKHA_N2(x)      (HW_LTC_K80_LPKN2_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_10_PKHA_N2. */
#define BF_LTC_K80_LPKN2_10_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_10_PKHA_N2) & BM_LTC_K80_LPKN2_10_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_10_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_11 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_11 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_11_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_11_ADDR(x)        ((x) + 0xCACU)
#define HW_LTC_K80_LPKN2_11(x)             (*(__IO hw_ltc_k80_lpkn2_11_t *) HW_LTC_K80_LPKN2_11_ADDR(x))
#define HW_LTC_K80_LPKN2_11_RD(x)          (HW_LTC_K80_LPKN2_11(x).U)
#define HW_LTC_K80_LPKN2_11_WR(x, v)       (HW_LTC_K80_LPKN2_11(x).U = (v))
#define HW_LTC_K80_LPKN2_11_SET(x, v)      (HW_LTC_K80_LPKN2_11_WR(x, HW_LTC_K80_LPKN2_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_11_CLR(x, v)      (HW_LTC_K80_LPKN2_11_WR(x, HW_LTC_K80_LPKN2_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_11_TOG(x, v)      (HW_LTC_K80_LPKN2_11_WR(x, HW_LTC_K80_LPKN2_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_11, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_11_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_11_PKHA_N2. */
#define BM_LTC_K80_LPKN2_11_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_11_PKHA_N2. */
#define BS_LTC_K80_LPKN2_11_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_11_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_11_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_11_PKHA_N2(x)      (HW_LTC_K80_LPKN2_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_11_PKHA_N2. */
#define BF_LTC_K80_LPKN2_11_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_11_PKHA_N2) & BM_LTC_K80_LPKN2_11_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_11_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_12 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_12 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_12_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_12_ADDR(x)        ((x) + 0xCB0U)
#define HW_LTC_K80_LPKN2_12(x)             (*(__IO hw_ltc_k80_lpkn2_12_t *) HW_LTC_K80_LPKN2_12_ADDR(x))
#define HW_LTC_K80_LPKN2_12_RD(x)          (HW_LTC_K80_LPKN2_12(x).U)
#define HW_LTC_K80_LPKN2_12_WR(x, v)       (HW_LTC_K80_LPKN2_12(x).U = (v))
#define HW_LTC_K80_LPKN2_12_SET(x, v)      (HW_LTC_K80_LPKN2_12_WR(x, HW_LTC_K80_LPKN2_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_12_CLR(x, v)      (HW_LTC_K80_LPKN2_12_WR(x, HW_LTC_K80_LPKN2_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_12_TOG(x, v)      (HW_LTC_K80_LPKN2_12_WR(x, HW_LTC_K80_LPKN2_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_12, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_12_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_12_PKHA_N2. */
#define BM_LTC_K80_LPKN2_12_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_12_PKHA_N2. */
#define BS_LTC_K80_LPKN2_12_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_12_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_12_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_12_PKHA_N2(x)      (HW_LTC_K80_LPKN2_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_12_PKHA_N2. */
#define BF_LTC_K80_LPKN2_12_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_12_PKHA_N2) & BM_LTC_K80_LPKN2_12_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_12_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_13 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_13 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_13_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_13_ADDR(x)        ((x) + 0xCB4U)
#define HW_LTC_K80_LPKN2_13(x)             (*(__IO hw_ltc_k80_lpkn2_13_t *) HW_LTC_K80_LPKN2_13_ADDR(x))
#define HW_LTC_K80_LPKN2_13_RD(x)          (HW_LTC_K80_LPKN2_13(x).U)
#define HW_LTC_K80_LPKN2_13_WR(x, v)       (HW_LTC_K80_LPKN2_13(x).U = (v))
#define HW_LTC_K80_LPKN2_13_SET(x, v)      (HW_LTC_K80_LPKN2_13_WR(x, HW_LTC_K80_LPKN2_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_13_CLR(x, v)      (HW_LTC_K80_LPKN2_13_WR(x, HW_LTC_K80_LPKN2_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_13_TOG(x, v)      (HW_LTC_K80_LPKN2_13_WR(x, HW_LTC_K80_LPKN2_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_13, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_13_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_13_PKHA_N2. */
#define BM_LTC_K80_LPKN2_13_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_13_PKHA_N2. */
#define BS_LTC_K80_LPKN2_13_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_13_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_13_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_13_PKHA_N2(x)      (HW_LTC_K80_LPKN2_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_13_PKHA_N2. */
#define BF_LTC_K80_LPKN2_13_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_13_PKHA_N2) & BM_LTC_K80_LPKN2_13_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_13_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_14 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_14 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_14_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_14_ADDR(x)        ((x) + 0xCB8U)
#define HW_LTC_K80_LPKN2_14(x)             (*(__IO hw_ltc_k80_lpkn2_14_t *) HW_LTC_K80_LPKN2_14_ADDR(x))
#define HW_LTC_K80_LPKN2_14_RD(x)          (HW_LTC_K80_LPKN2_14(x).U)
#define HW_LTC_K80_LPKN2_14_WR(x, v)       (HW_LTC_K80_LPKN2_14(x).U = (v))
#define HW_LTC_K80_LPKN2_14_SET(x, v)      (HW_LTC_K80_LPKN2_14_WR(x, HW_LTC_K80_LPKN2_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_14_CLR(x, v)      (HW_LTC_K80_LPKN2_14_WR(x, HW_LTC_K80_LPKN2_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_14_TOG(x, v)      (HW_LTC_K80_LPKN2_14_WR(x, HW_LTC_K80_LPKN2_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_14, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_14_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_14_PKHA_N2. */
#define BM_LTC_K80_LPKN2_14_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_14_PKHA_N2. */
#define BS_LTC_K80_LPKN2_14_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_14_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_14_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_14_PKHA_N2(x)      (HW_LTC_K80_LPKN2_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_14_PKHA_N2. */
#define BF_LTC_K80_LPKN2_14_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_14_PKHA_N2) & BM_LTC_K80_LPKN2_14_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_14_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN2_15 - LTC PKHA N2 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN2_15 - LTC PKHA N2 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N2 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset C80h, in the right-most byte. The LTC PKHA N2 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N2 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn2_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn2_15_bitfields
    {
        uint32_t PKHA_N2 : 32; /*!< [31:0] N2 VALUE */
    } B;
} hw_ltc_k80_lpkn2_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN2_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKN2_15_ADDR(x)        ((x) + 0xCBCU)
#define HW_LTC_K80_LPKN2_15(x)             (*(__IO hw_ltc_k80_lpkn2_15_t *) HW_LTC_K80_LPKN2_15_ADDR(x))
#define HW_LTC_K80_LPKN2_15_RD(x)          (HW_LTC_K80_LPKN2_15(x).U)
#define HW_LTC_K80_LPKN2_15_WR(x, v)       (HW_LTC_K80_LPKN2_15(x).U = (v))
#define HW_LTC_K80_LPKN2_15_SET(x, v)      (HW_LTC_K80_LPKN2_15_WR(x, HW_LTC_K80_LPKN2_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKN2_15_CLR(x, v)      (HW_LTC_K80_LPKN2_15_WR(x, HW_LTC_K80_LPKN2_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN2_15_TOG(x, v)      (HW_LTC_K80_LPKN2_15_WR(x, HW_LTC_K80_LPKN2_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN2_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN2_15, field PKHA_N2[31:0] (RW)
 *
 * N2 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN2_15_PKHA_N2         (0U)      /*!< Bit position for LTC_K80_LPKN2_15_PKHA_N2. */
#define BM_LTC_K80_LPKN2_15_PKHA_N2         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN2_15_PKHA_N2. */
#define BS_LTC_K80_LPKN2_15_PKHA_N2         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN2_15_PKHA_N2. */

/*! @brief Read current value of the LTC_K80_LPKN2_15_PKHA_N2 field. */
#define BR_LTC_K80_LPKN2_15_PKHA_N2(x)      (HW_LTC_K80_LPKN2_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN2_15_PKHA_N2. */
#define BF_LTC_K80_LPKN2_15_PKHA_N2(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN2_15_PKHA_N2) & BM_LTC_K80_LPKN2_15_PKHA_N2)

/*! @brief Set the PKHA_N2 field to a new value. */
#define BW_LTC_K80_LPKN2_15_PKHA_N2(x, v)   (HW_LTC_K80_LPKN2_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_0 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_0 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_0_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_0_ADDR(x)        ((x) + 0xCC0U)
#define HW_LTC_K80_LPKN3_0(x)             (*(__IO hw_ltc_k80_lpkn3_0_t *) HW_LTC_K80_LPKN3_0_ADDR(x))
#define HW_LTC_K80_LPKN3_0_RD(x)          (HW_LTC_K80_LPKN3_0(x).U)
#define HW_LTC_K80_LPKN3_0_WR(x, v)       (HW_LTC_K80_LPKN3_0(x).U = (v))
#define HW_LTC_K80_LPKN3_0_SET(x, v)      (HW_LTC_K80_LPKN3_0_WR(x, HW_LTC_K80_LPKN3_0_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_0_CLR(x, v)      (HW_LTC_K80_LPKN3_0_WR(x, HW_LTC_K80_LPKN3_0_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_0_TOG(x, v)      (HW_LTC_K80_LPKN3_0_WR(x, HW_LTC_K80_LPKN3_0_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_0, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_0_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_0_PKHA_N3. */
#define BM_LTC_K80_LPKN3_0_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_0_PKHA_N3. */
#define BS_LTC_K80_LPKN3_0_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_0_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_0_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_0_PKHA_N3(x)      (HW_LTC_K80_LPKN3_0(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_0_PKHA_N3. */
#define BF_LTC_K80_LPKN3_0_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_0_PKHA_N3) & BM_LTC_K80_LPKN3_0_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_0_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_1 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_1 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_1_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_1_ADDR(x)        ((x) + 0xCC4U)
#define HW_LTC_K80_LPKN3_1(x)             (*(__IO hw_ltc_k80_lpkn3_1_t *) HW_LTC_K80_LPKN3_1_ADDR(x))
#define HW_LTC_K80_LPKN3_1_RD(x)          (HW_LTC_K80_LPKN3_1(x).U)
#define HW_LTC_K80_LPKN3_1_WR(x, v)       (HW_LTC_K80_LPKN3_1(x).U = (v))
#define HW_LTC_K80_LPKN3_1_SET(x, v)      (HW_LTC_K80_LPKN3_1_WR(x, HW_LTC_K80_LPKN3_1_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_1_CLR(x, v)      (HW_LTC_K80_LPKN3_1_WR(x, HW_LTC_K80_LPKN3_1_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_1_TOG(x, v)      (HW_LTC_K80_LPKN3_1_WR(x, HW_LTC_K80_LPKN3_1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_1, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_1_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_1_PKHA_N3. */
#define BM_LTC_K80_LPKN3_1_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_1_PKHA_N3. */
#define BS_LTC_K80_LPKN3_1_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_1_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_1_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_1_PKHA_N3(x)      (HW_LTC_K80_LPKN3_1(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_1_PKHA_N3. */
#define BF_LTC_K80_LPKN3_1_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_1_PKHA_N3) & BM_LTC_K80_LPKN3_1_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_1_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_2 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_2 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_2_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_2_ADDR(x)        ((x) + 0xCC8U)
#define HW_LTC_K80_LPKN3_2(x)             (*(__IO hw_ltc_k80_lpkn3_2_t *) HW_LTC_K80_LPKN3_2_ADDR(x))
#define HW_LTC_K80_LPKN3_2_RD(x)          (HW_LTC_K80_LPKN3_2(x).U)
#define HW_LTC_K80_LPKN3_2_WR(x, v)       (HW_LTC_K80_LPKN3_2(x).U = (v))
#define HW_LTC_K80_LPKN3_2_SET(x, v)      (HW_LTC_K80_LPKN3_2_WR(x, HW_LTC_K80_LPKN3_2_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_2_CLR(x, v)      (HW_LTC_K80_LPKN3_2_WR(x, HW_LTC_K80_LPKN3_2_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_2_TOG(x, v)      (HW_LTC_K80_LPKN3_2_WR(x, HW_LTC_K80_LPKN3_2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_2, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_2_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_2_PKHA_N3. */
#define BM_LTC_K80_LPKN3_2_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_2_PKHA_N3. */
#define BS_LTC_K80_LPKN3_2_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_2_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_2_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_2_PKHA_N3(x)      (HW_LTC_K80_LPKN3_2(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_2_PKHA_N3. */
#define BF_LTC_K80_LPKN3_2_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_2_PKHA_N3) & BM_LTC_K80_LPKN3_2_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_2_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_3 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_3 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_3_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_3_ADDR(x)        ((x) + 0xCCCU)
#define HW_LTC_K80_LPKN3_3(x)             (*(__IO hw_ltc_k80_lpkn3_3_t *) HW_LTC_K80_LPKN3_3_ADDR(x))
#define HW_LTC_K80_LPKN3_3_RD(x)          (HW_LTC_K80_LPKN3_3(x).U)
#define HW_LTC_K80_LPKN3_3_WR(x, v)       (HW_LTC_K80_LPKN3_3(x).U = (v))
#define HW_LTC_K80_LPKN3_3_SET(x, v)      (HW_LTC_K80_LPKN3_3_WR(x, HW_LTC_K80_LPKN3_3_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_3_CLR(x, v)      (HW_LTC_K80_LPKN3_3_WR(x, HW_LTC_K80_LPKN3_3_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_3_TOG(x, v)      (HW_LTC_K80_LPKN3_3_WR(x, HW_LTC_K80_LPKN3_3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_3, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_3_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_3_PKHA_N3. */
#define BM_LTC_K80_LPKN3_3_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_3_PKHA_N3. */
#define BS_LTC_K80_LPKN3_3_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_3_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_3_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_3_PKHA_N3(x)      (HW_LTC_K80_LPKN3_3(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_3_PKHA_N3. */
#define BF_LTC_K80_LPKN3_3_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_3_PKHA_N3) & BM_LTC_K80_LPKN3_3_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_3_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_4 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_4 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_4_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_4_ADDR(x)        ((x) + 0xCD0U)
#define HW_LTC_K80_LPKN3_4(x)             (*(__IO hw_ltc_k80_lpkn3_4_t *) HW_LTC_K80_LPKN3_4_ADDR(x))
#define HW_LTC_K80_LPKN3_4_RD(x)          (HW_LTC_K80_LPKN3_4(x).U)
#define HW_LTC_K80_LPKN3_4_WR(x, v)       (HW_LTC_K80_LPKN3_4(x).U = (v))
#define HW_LTC_K80_LPKN3_4_SET(x, v)      (HW_LTC_K80_LPKN3_4_WR(x, HW_LTC_K80_LPKN3_4_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_4_CLR(x, v)      (HW_LTC_K80_LPKN3_4_WR(x, HW_LTC_K80_LPKN3_4_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_4_TOG(x, v)      (HW_LTC_K80_LPKN3_4_WR(x, HW_LTC_K80_LPKN3_4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_4, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_4_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_4_PKHA_N3. */
#define BM_LTC_K80_LPKN3_4_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_4_PKHA_N3. */
#define BS_LTC_K80_LPKN3_4_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_4_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_4_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_4_PKHA_N3(x)      (HW_LTC_K80_LPKN3_4(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_4_PKHA_N3. */
#define BF_LTC_K80_LPKN3_4_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_4_PKHA_N3) & BM_LTC_K80_LPKN3_4_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_4_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_5 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_5 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_5_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_5_ADDR(x)        ((x) + 0xCD4U)
#define HW_LTC_K80_LPKN3_5(x)             (*(__IO hw_ltc_k80_lpkn3_5_t *) HW_LTC_K80_LPKN3_5_ADDR(x))
#define HW_LTC_K80_LPKN3_5_RD(x)          (HW_LTC_K80_LPKN3_5(x).U)
#define HW_LTC_K80_LPKN3_5_WR(x, v)       (HW_LTC_K80_LPKN3_5(x).U = (v))
#define HW_LTC_K80_LPKN3_5_SET(x, v)      (HW_LTC_K80_LPKN3_5_WR(x, HW_LTC_K80_LPKN3_5_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_5_CLR(x, v)      (HW_LTC_K80_LPKN3_5_WR(x, HW_LTC_K80_LPKN3_5_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_5_TOG(x, v)      (HW_LTC_K80_LPKN3_5_WR(x, HW_LTC_K80_LPKN3_5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_5, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_5_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_5_PKHA_N3. */
#define BM_LTC_K80_LPKN3_5_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_5_PKHA_N3. */
#define BS_LTC_K80_LPKN3_5_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_5_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_5_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_5_PKHA_N3(x)      (HW_LTC_K80_LPKN3_5(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_5_PKHA_N3. */
#define BF_LTC_K80_LPKN3_5_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_5_PKHA_N3) & BM_LTC_K80_LPKN3_5_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_5_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_6 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_6 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_6_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_6_ADDR(x)        ((x) + 0xCD8U)
#define HW_LTC_K80_LPKN3_6(x)             (*(__IO hw_ltc_k80_lpkn3_6_t *) HW_LTC_K80_LPKN3_6_ADDR(x))
#define HW_LTC_K80_LPKN3_6_RD(x)          (HW_LTC_K80_LPKN3_6(x).U)
#define HW_LTC_K80_LPKN3_6_WR(x, v)       (HW_LTC_K80_LPKN3_6(x).U = (v))
#define HW_LTC_K80_LPKN3_6_SET(x, v)      (HW_LTC_K80_LPKN3_6_WR(x, HW_LTC_K80_LPKN3_6_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_6_CLR(x, v)      (HW_LTC_K80_LPKN3_6_WR(x, HW_LTC_K80_LPKN3_6_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_6_TOG(x, v)      (HW_LTC_K80_LPKN3_6_WR(x, HW_LTC_K80_LPKN3_6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_6, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_6_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_6_PKHA_N3. */
#define BM_LTC_K80_LPKN3_6_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_6_PKHA_N3. */
#define BS_LTC_K80_LPKN3_6_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_6_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_6_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_6_PKHA_N3(x)      (HW_LTC_K80_LPKN3_6(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_6_PKHA_N3. */
#define BF_LTC_K80_LPKN3_6_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_6_PKHA_N3) & BM_LTC_K80_LPKN3_6_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_6_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_7 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_7 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_7_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_7_ADDR(x)        ((x) + 0xCDCU)
#define HW_LTC_K80_LPKN3_7(x)             (*(__IO hw_ltc_k80_lpkn3_7_t *) HW_LTC_K80_LPKN3_7_ADDR(x))
#define HW_LTC_K80_LPKN3_7_RD(x)          (HW_LTC_K80_LPKN3_7(x).U)
#define HW_LTC_K80_LPKN3_7_WR(x, v)       (HW_LTC_K80_LPKN3_7(x).U = (v))
#define HW_LTC_K80_LPKN3_7_SET(x, v)      (HW_LTC_K80_LPKN3_7_WR(x, HW_LTC_K80_LPKN3_7_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_7_CLR(x, v)      (HW_LTC_K80_LPKN3_7_WR(x, HW_LTC_K80_LPKN3_7_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_7_TOG(x, v)      (HW_LTC_K80_LPKN3_7_WR(x, HW_LTC_K80_LPKN3_7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_7, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_7_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_7_PKHA_N3. */
#define BM_LTC_K80_LPKN3_7_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_7_PKHA_N3. */
#define BS_LTC_K80_LPKN3_7_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_7_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_7_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_7_PKHA_N3(x)      (HW_LTC_K80_LPKN3_7(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_7_PKHA_N3. */
#define BF_LTC_K80_LPKN3_7_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_7_PKHA_N3) & BM_LTC_K80_LPKN3_7_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_7_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_8 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_8 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_8_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_8_ADDR(x)        ((x) + 0xCE0U)
#define HW_LTC_K80_LPKN3_8(x)             (*(__IO hw_ltc_k80_lpkn3_8_t *) HW_LTC_K80_LPKN3_8_ADDR(x))
#define HW_LTC_K80_LPKN3_8_RD(x)          (HW_LTC_K80_LPKN3_8(x).U)
#define HW_LTC_K80_LPKN3_8_WR(x, v)       (HW_LTC_K80_LPKN3_8(x).U = (v))
#define HW_LTC_K80_LPKN3_8_SET(x, v)      (HW_LTC_K80_LPKN3_8_WR(x, HW_LTC_K80_LPKN3_8_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_8_CLR(x, v)      (HW_LTC_K80_LPKN3_8_WR(x, HW_LTC_K80_LPKN3_8_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_8_TOG(x, v)      (HW_LTC_K80_LPKN3_8_WR(x, HW_LTC_K80_LPKN3_8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_8, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_8_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_8_PKHA_N3. */
#define BM_LTC_K80_LPKN3_8_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_8_PKHA_N3. */
#define BS_LTC_K80_LPKN3_8_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_8_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_8_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_8_PKHA_N3(x)      (HW_LTC_K80_LPKN3_8(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_8_PKHA_N3. */
#define BF_LTC_K80_LPKN3_8_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_8_PKHA_N3) & BM_LTC_K80_LPKN3_8_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_8_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_9 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_9 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_9_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_9_ADDR(x)        ((x) + 0xCE4U)
#define HW_LTC_K80_LPKN3_9(x)             (*(__IO hw_ltc_k80_lpkn3_9_t *) HW_LTC_K80_LPKN3_9_ADDR(x))
#define HW_LTC_K80_LPKN3_9_RD(x)          (HW_LTC_K80_LPKN3_9(x).U)
#define HW_LTC_K80_LPKN3_9_WR(x, v)       (HW_LTC_K80_LPKN3_9(x).U = (v))
#define HW_LTC_K80_LPKN3_9_SET(x, v)      (HW_LTC_K80_LPKN3_9_WR(x, HW_LTC_K80_LPKN3_9_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_9_CLR(x, v)      (HW_LTC_K80_LPKN3_9_WR(x, HW_LTC_K80_LPKN3_9_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_9_TOG(x, v)      (HW_LTC_K80_LPKN3_9_WR(x, HW_LTC_K80_LPKN3_9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_9, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_9_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_9_PKHA_N3. */
#define BM_LTC_K80_LPKN3_9_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_9_PKHA_N3. */
#define BS_LTC_K80_LPKN3_9_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_9_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_9_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_9_PKHA_N3(x)      (HW_LTC_K80_LPKN3_9(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_9_PKHA_N3. */
#define BF_LTC_K80_LPKN3_9_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_9_PKHA_N3) & BM_LTC_K80_LPKN3_9_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_9_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_10 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_10 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_10_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_10_ADDR(x)        ((x) + 0xCE8U)
#define HW_LTC_K80_LPKN3_10(x)             (*(__IO hw_ltc_k80_lpkn3_10_t *) HW_LTC_K80_LPKN3_10_ADDR(x))
#define HW_LTC_K80_LPKN3_10_RD(x)          (HW_LTC_K80_LPKN3_10(x).U)
#define HW_LTC_K80_LPKN3_10_WR(x, v)       (HW_LTC_K80_LPKN3_10(x).U = (v))
#define HW_LTC_K80_LPKN3_10_SET(x, v)      (HW_LTC_K80_LPKN3_10_WR(x, HW_LTC_K80_LPKN3_10_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_10_CLR(x, v)      (HW_LTC_K80_LPKN3_10_WR(x, HW_LTC_K80_LPKN3_10_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_10_TOG(x, v)      (HW_LTC_K80_LPKN3_10_WR(x, HW_LTC_K80_LPKN3_10_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_10, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_10_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_10_PKHA_N3. */
#define BM_LTC_K80_LPKN3_10_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_10_PKHA_N3. */
#define BS_LTC_K80_LPKN3_10_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_10_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_10_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_10_PKHA_N3(x)      (HW_LTC_K80_LPKN3_10(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_10_PKHA_N3. */
#define BF_LTC_K80_LPKN3_10_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_10_PKHA_N3) & BM_LTC_K80_LPKN3_10_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_10_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_11 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_11 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_11_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_11_ADDR(x)        ((x) + 0xCECU)
#define HW_LTC_K80_LPKN3_11(x)             (*(__IO hw_ltc_k80_lpkn3_11_t *) HW_LTC_K80_LPKN3_11_ADDR(x))
#define HW_LTC_K80_LPKN3_11_RD(x)          (HW_LTC_K80_LPKN3_11(x).U)
#define HW_LTC_K80_LPKN3_11_WR(x, v)       (HW_LTC_K80_LPKN3_11(x).U = (v))
#define HW_LTC_K80_LPKN3_11_SET(x, v)      (HW_LTC_K80_LPKN3_11_WR(x, HW_LTC_K80_LPKN3_11_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_11_CLR(x, v)      (HW_LTC_K80_LPKN3_11_WR(x, HW_LTC_K80_LPKN3_11_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_11_TOG(x, v)      (HW_LTC_K80_LPKN3_11_WR(x, HW_LTC_K80_LPKN3_11_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_11, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_11_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_11_PKHA_N3. */
#define BM_LTC_K80_LPKN3_11_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_11_PKHA_N3. */
#define BS_LTC_K80_LPKN3_11_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_11_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_11_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_11_PKHA_N3(x)      (HW_LTC_K80_LPKN3_11(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_11_PKHA_N3. */
#define BF_LTC_K80_LPKN3_11_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_11_PKHA_N3) & BM_LTC_K80_LPKN3_11_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_11_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_12 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_12 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_12_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_12_ADDR(x)        ((x) + 0xCF0U)
#define HW_LTC_K80_LPKN3_12(x)             (*(__IO hw_ltc_k80_lpkn3_12_t *) HW_LTC_K80_LPKN3_12_ADDR(x))
#define HW_LTC_K80_LPKN3_12_RD(x)          (HW_LTC_K80_LPKN3_12(x).U)
#define HW_LTC_K80_LPKN3_12_WR(x, v)       (HW_LTC_K80_LPKN3_12(x).U = (v))
#define HW_LTC_K80_LPKN3_12_SET(x, v)      (HW_LTC_K80_LPKN3_12_WR(x, HW_LTC_K80_LPKN3_12_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_12_CLR(x, v)      (HW_LTC_K80_LPKN3_12_WR(x, HW_LTC_K80_LPKN3_12_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_12_TOG(x, v)      (HW_LTC_K80_LPKN3_12_WR(x, HW_LTC_K80_LPKN3_12_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_12, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_12_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_12_PKHA_N3. */
#define BM_LTC_K80_LPKN3_12_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_12_PKHA_N3. */
#define BS_LTC_K80_LPKN3_12_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_12_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_12_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_12_PKHA_N3(x)      (HW_LTC_K80_LPKN3_12(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_12_PKHA_N3. */
#define BF_LTC_K80_LPKN3_12_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_12_PKHA_N3) & BM_LTC_K80_LPKN3_12_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_12_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_13 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_13 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_13_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_13_ADDR(x)        ((x) + 0xCF4U)
#define HW_LTC_K80_LPKN3_13(x)             (*(__IO hw_ltc_k80_lpkn3_13_t *) HW_LTC_K80_LPKN3_13_ADDR(x))
#define HW_LTC_K80_LPKN3_13_RD(x)          (HW_LTC_K80_LPKN3_13(x).U)
#define HW_LTC_K80_LPKN3_13_WR(x, v)       (HW_LTC_K80_LPKN3_13(x).U = (v))
#define HW_LTC_K80_LPKN3_13_SET(x, v)      (HW_LTC_K80_LPKN3_13_WR(x, HW_LTC_K80_LPKN3_13_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_13_CLR(x, v)      (HW_LTC_K80_LPKN3_13_WR(x, HW_LTC_K80_LPKN3_13_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_13_TOG(x, v)      (HW_LTC_K80_LPKN3_13_WR(x, HW_LTC_K80_LPKN3_13_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_13, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_13_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_13_PKHA_N3. */
#define BM_LTC_K80_LPKN3_13_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_13_PKHA_N3. */
#define BS_LTC_K80_LPKN3_13_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_13_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_13_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_13_PKHA_N3(x)      (HW_LTC_K80_LPKN3_13(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_13_PKHA_N3. */
#define BF_LTC_K80_LPKN3_13_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_13_PKHA_N3) & BM_LTC_K80_LPKN3_13_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_13_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_14 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_14 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_14_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_14_ADDR(x)        ((x) + 0xCF8U)
#define HW_LTC_K80_LPKN3_14(x)             (*(__IO hw_ltc_k80_lpkn3_14_t *) HW_LTC_K80_LPKN3_14_ADDR(x))
#define HW_LTC_K80_LPKN3_14_RD(x)          (HW_LTC_K80_LPKN3_14(x).U)
#define HW_LTC_K80_LPKN3_14_WR(x, v)       (HW_LTC_K80_LPKN3_14(x).U = (v))
#define HW_LTC_K80_LPKN3_14_SET(x, v)      (HW_LTC_K80_LPKN3_14_WR(x, HW_LTC_K80_LPKN3_14_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_14_CLR(x, v)      (HW_LTC_K80_LPKN3_14_WR(x, HW_LTC_K80_LPKN3_14_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_14_TOG(x, v)      (HW_LTC_K80_LPKN3_14_WR(x, HW_LTC_K80_LPKN3_14_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_14, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_14_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_14_PKHA_N3. */
#define BM_LTC_K80_LPKN3_14_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_14_PKHA_N3. */
#define BS_LTC_K80_LPKN3_14_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_14_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_14_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_14_PKHA_N3(x)      (HW_LTC_K80_LPKN3_14(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_14_PKHA_N3. */
#define BF_LTC_K80_LPKN3_14_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_14_PKHA_N3) & BM_LTC_K80_LPKN3_14_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_14_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKN3_15 - LTC PKHA N3 Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKN3_15 - LTC PKHA N3 Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA N3 Register contains a numeric value of up to 64 bytes, right-justified. The LSByte
 * is in offset CC0h, in the right-most byte. The LTC PKHA N3 register is 512 bits in length. Note
 * that PKHA N3, N2, N1 and N0 Registers may be combined to contain a value of up to 2048 bits, with
 * N0 containing the least-significant 64 bytes of this value. The value in the PKHA N3 Register, if
 * used as a separate value, is limited by the LTC PKHA N Size Register (LPKNSZR). Note that the
 * PKHA Registers can be read/written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to PKHA Registers will be ignored, and reads of PKHA Registers will return a value of
 * zero.
 */
typedef union _hw_ltc_k80_lpkn3_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpkn3_15_bitfields
    {
        uint32_t PKHA_N3 : 32; /*!< [31:0] N3 VALUE */
    } B;
} hw_ltc_k80_lpkn3_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKN3_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKN3_15_ADDR(x)        ((x) + 0xCFCU)
#define HW_LTC_K80_LPKN3_15(x)             (*(__IO hw_ltc_k80_lpkn3_15_t *) HW_LTC_K80_LPKN3_15_ADDR(x))
#define HW_LTC_K80_LPKN3_15_RD(x)          (HW_LTC_K80_LPKN3_15(x).U)
#define HW_LTC_K80_LPKN3_15_WR(x, v)       (HW_LTC_K80_LPKN3_15(x).U = (v))
#define HW_LTC_K80_LPKN3_15_SET(x, v)      (HW_LTC_K80_LPKN3_15_WR(x, HW_LTC_K80_LPKN3_15_RD(x) |  (v)))
#define HW_LTC_K80_LPKN3_15_CLR(x, v)      (HW_LTC_K80_LPKN3_15_WR(x, HW_LTC_K80_LPKN3_15_RD(x) & ~(v)))
#define HW_LTC_K80_LPKN3_15_TOG(x, v)      (HW_LTC_K80_LPKN3_15_WR(x, HW_LTC_K80_LPKN3_15_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKN3_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKN3_15, field PKHA_N3[31:0] (RW)
 *
 * N3 VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKN3_15_PKHA_N3         (0U)      /*!< Bit position for LTC_K80_LPKN3_15_PKHA_N3. */
#define BM_LTC_K80_LPKN3_15_PKHA_N3         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKN3_15_PKHA_N3. */
#define BS_LTC_K80_LPKN3_15_PKHA_N3         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKN3_15_PKHA_N3. */

/*! @brief Read current value of the LTC_K80_LPKN3_15_PKHA_N3 field. */
#define BR_LTC_K80_LPKN3_15_PKHA_N3(x)      (HW_LTC_K80_LPKN3_15(x).U)

/*! @brief Format value for bitfield LTC_K80_LPKN3_15_PKHA_N3. */
#define BF_LTC_K80_LPKN3_15_PKHA_N3(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKN3_15_PKHA_N3) & BM_LTC_K80_LPKN3_15_PKHA_N3)

/*! @brief Set the PKHA_N3 field to a new value. */
#define BW_LTC_K80_LPKN3_15_PKHA_N3(x, v)   (HW_LTC_K80_LPKN3_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_0 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_0 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_0
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_0_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_0_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_0 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_0_ADDR(x)        ((x) + 0xE00U)
#define HW_LTC_K80_LPKE_0(x)             (*(__O  hw_ltc_k80_lpke_0_t *) HW_LTC_K80_LPKE_0_ADDR(x))
#define HW_LTC_K80_LPKE_0_WR(x, v)       (HW_LTC_K80_LPKE_0(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_0 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_0, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_0_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_0_PKHA_E. */
#define BM_LTC_K80_LPKE_0_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_0_PKHA_E. */
#define BS_LTC_K80_LPKE_0_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_0_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_0_PKHA_E. */
#define BF_LTC_K80_LPKE_0_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_0_PKHA_E) & BM_LTC_K80_LPKE_0_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_0_PKHA_E(x, v)   (HW_LTC_K80_LPKE_0_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_1 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_1 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_1
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_1_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_1_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_1 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_1_ADDR(x)        ((x) + 0xE04U)
#define HW_LTC_K80_LPKE_1(x)             (*(__O  hw_ltc_k80_lpke_1_t *) HW_LTC_K80_LPKE_1_ADDR(x))
#define HW_LTC_K80_LPKE_1_WR(x, v)       (HW_LTC_K80_LPKE_1(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_1 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_1, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_1_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_1_PKHA_E. */
#define BM_LTC_K80_LPKE_1_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_1_PKHA_E. */
#define BS_LTC_K80_LPKE_1_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_1_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_1_PKHA_E. */
#define BF_LTC_K80_LPKE_1_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_1_PKHA_E) & BM_LTC_K80_LPKE_1_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_1_PKHA_E(x, v)   (HW_LTC_K80_LPKE_1_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_2 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_2 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_2
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_2_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_2_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_2 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_2_ADDR(x)        ((x) + 0xE08U)
#define HW_LTC_K80_LPKE_2(x)             (*(__O  hw_ltc_k80_lpke_2_t *) HW_LTC_K80_LPKE_2_ADDR(x))
#define HW_LTC_K80_LPKE_2_WR(x, v)       (HW_LTC_K80_LPKE_2(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_2 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_2, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_2_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_2_PKHA_E. */
#define BM_LTC_K80_LPKE_2_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_2_PKHA_E. */
#define BS_LTC_K80_LPKE_2_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_2_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_2_PKHA_E. */
#define BF_LTC_K80_LPKE_2_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_2_PKHA_E) & BM_LTC_K80_LPKE_2_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_2_PKHA_E(x, v)   (HW_LTC_K80_LPKE_2_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_3 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_3 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_3
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_3_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_3_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_3 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_3_ADDR(x)        ((x) + 0xE0CU)
#define HW_LTC_K80_LPKE_3(x)             (*(__O  hw_ltc_k80_lpke_3_t *) HW_LTC_K80_LPKE_3_ADDR(x))
#define HW_LTC_K80_LPKE_3_WR(x, v)       (HW_LTC_K80_LPKE_3(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_3 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_3, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_3_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_3_PKHA_E. */
#define BM_LTC_K80_LPKE_3_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_3_PKHA_E. */
#define BS_LTC_K80_LPKE_3_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_3_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_3_PKHA_E. */
#define BF_LTC_K80_LPKE_3_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_3_PKHA_E) & BM_LTC_K80_LPKE_3_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_3_PKHA_E(x, v)   (HW_LTC_K80_LPKE_3_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_4 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_4 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_4
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_4_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_4_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_4 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_4_ADDR(x)        ((x) + 0xE10U)
#define HW_LTC_K80_LPKE_4(x)             (*(__O  hw_ltc_k80_lpke_4_t *) HW_LTC_K80_LPKE_4_ADDR(x))
#define HW_LTC_K80_LPKE_4_WR(x, v)       (HW_LTC_K80_LPKE_4(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_4 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_4, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_4_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_4_PKHA_E. */
#define BM_LTC_K80_LPKE_4_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_4_PKHA_E. */
#define BS_LTC_K80_LPKE_4_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_4_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_4_PKHA_E. */
#define BF_LTC_K80_LPKE_4_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_4_PKHA_E) & BM_LTC_K80_LPKE_4_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_4_PKHA_E(x, v)   (HW_LTC_K80_LPKE_4_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_5 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_5 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_5
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_5_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_5_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_5 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_5_ADDR(x)        ((x) + 0xE14U)
#define HW_LTC_K80_LPKE_5(x)             (*(__O  hw_ltc_k80_lpke_5_t *) HW_LTC_K80_LPKE_5_ADDR(x))
#define HW_LTC_K80_LPKE_5_WR(x, v)       (HW_LTC_K80_LPKE_5(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_5 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_5, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_5_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_5_PKHA_E. */
#define BM_LTC_K80_LPKE_5_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_5_PKHA_E. */
#define BS_LTC_K80_LPKE_5_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_5_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_5_PKHA_E. */
#define BF_LTC_K80_LPKE_5_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_5_PKHA_E) & BM_LTC_K80_LPKE_5_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_5_PKHA_E(x, v)   (HW_LTC_K80_LPKE_5_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_6 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_6 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_6
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_6_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_6_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_6 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_6_ADDR(x)        ((x) + 0xE18U)
#define HW_LTC_K80_LPKE_6(x)             (*(__O  hw_ltc_k80_lpke_6_t *) HW_LTC_K80_LPKE_6_ADDR(x))
#define HW_LTC_K80_LPKE_6_WR(x, v)       (HW_LTC_K80_LPKE_6(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_6 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_6, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_6_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_6_PKHA_E. */
#define BM_LTC_K80_LPKE_6_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_6_PKHA_E. */
#define BS_LTC_K80_LPKE_6_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_6_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_6_PKHA_E. */
#define BF_LTC_K80_LPKE_6_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_6_PKHA_E) & BM_LTC_K80_LPKE_6_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_6_PKHA_E(x, v)   (HW_LTC_K80_LPKE_6_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_7 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_7 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_7
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_7_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_7_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_7 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_7_ADDR(x)        ((x) + 0xE1CU)
#define HW_LTC_K80_LPKE_7(x)             (*(__O  hw_ltc_k80_lpke_7_t *) HW_LTC_K80_LPKE_7_ADDR(x))
#define HW_LTC_K80_LPKE_7_WR(x, v)       (HW_LTC_K80_LPKE_7(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_7 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_7, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_7_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_7_PKHA_E. */
#define BM_LTC_K80_LPKE_7_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_7_PKHA_E. */
#define BS_LTC_K80_LPKE_7_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_7_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_7_PKHA_E. */
#define BF_LTC_K80_LPKE_7_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_7_PKHA_E) & BM_LTC_K80_LPKE_7_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_7_PKHA_E(x, v)   (HW_LTC_K80_LPKE_7_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_8 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_8 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_8
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_8_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_8_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_8 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_8_ADDR(x)        ((x) + 0xE20U)
#define HW_LTC_K80_LPKE_8(x)             (*(__O  hw_ltc_k80_lpke_8_t *) HW_LTC_K80_LPKE_8_ADDR(x))
#define HW_LTC_K80_LPKE_8_WR(x, v)       (HW_LTC_K80_LPKE_8(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_8 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_8, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_8_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_8_PKHA_E. */
#define BM_LTC_K80_LPKE_8_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_8_PKHA_E. */
#define BS_LTC_K80_LPKE_8_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_8_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_8_PKHA_E. */
#define BF_LTC_K80_LPKE_8_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_8_PKHA_E) & BM_LTC_K80_LPKE_8_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_8_PKHA_E(x, v)   (HW_LTC_K80_LPKE_8_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_9 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_9 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_9
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_9_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_9_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_9 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_9_ADDR(x)        ((x) + 0xE24U)
#define HW_LTC_K80_LPKE_9(x)             (*(__O  hw_ltc_k80_lpke_9_t *) HW_LTC_K80_LPKE_9_ADDR(x))
#define HW_LTC_K80_LPKE_9_WR(x, v)       (HW_LTC_K80_LPKE_9(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_9 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_9, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_9_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_9_PKHA_E. */
#define BM_LTC_K80_LPKE_9_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_9_PKHA_E. */
#define BS_LTC_K80_LPKE_9_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_9_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_9_PKHA_E. */
#define BF_LTC_K80_LPKE_9_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_9_PKHA_E) & BM_LTC_K80_LPKE_9_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_9_PKHA_E(x, v)   (HW_LTC_K80_LPKE_9_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_10 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_10 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_10
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_10_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_10_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_10 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_10_ADDR(x)        ((x) + 0xE28U)
#define HW_LTC_K80_LPKE_10(x)             (*(__O  hw_ltc_k80_lpke_10_t *) HW_LTC_K80_LPKE_10_ADDR(x))
#define HW_LTC_K80_LPKE_10_WR(x, v)       (HW_LTC_K80_LPKE_10(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_10 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_10, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_10_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_10_PKHA_E. */
#define BM_LTC_K80_LPKE_10_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_10_PKHA_E. */
#define BS_LTC_K80_LPKE_10_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_10_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_10_PKHA_E. */
#define BF_LTC_K80_LPKE_10_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_10_PKHA_E) & BM_LTC_K80_LPKE_10_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_10_PKHA_E(x, v)   (HW_LTC_K80_LPKE_10_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_11 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_11 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_11
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_11_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_11_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_11 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_11_ADDR(x)        ((x) + 0xE2CU)
#define HW_LTC_K80_LPKE_11(x)             (*(__O  hw_ltc_k80_lpke_11_t *) HW_LTC_K80_LPKE_11_ADDR(x))
#define HW_LTC_K80_LPKE_11_WR(x, v)       (HW_LTC_K80_LPKE_11(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_11 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_11, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_11_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_11_PKHA_E. */
#define BM_LTC_K80_LPKE_11_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_11_PKHA_E. */
#define BS_LTC_K80_LPKE_11_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_11_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_11_PKHA_E. */
#define BF_LTC_K80_LPKE_11_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_11_PKHA_E) & BM_LTC_K80_LPKE_11_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_11_PKHA_E(x, v)   (HW_LTC_K80_LPKE_11_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_12 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_12 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_12
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_12_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_12_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_12 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_12_ADDR(x)        ((x) + 0xE30U)
#define HW_LTC_K80_LPKE_12(x)             (*(__O  hw_ltc_k80_lpke_12_t *) HW_LTC_K80_LPKE_12_ADDR(x))
#define HW_LTC_K80_LPKE_12_WR(x, v)       (HW_LTC_K80_LPKE_12(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_12 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_12, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_12_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_12_PKHA_E. */
#define BM_LTC_K80_LPKE_12_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_12_PKHA_E. */
#define BS_LTC_K80_LPKE_12_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_12_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_12_PKHA_E. */
#define BF_LTC_K80_LPKE_12_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_12_PKHA_E) & BM_LTC_K80_LPKE_12_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_12_PKHA_E(x, v)   (HW_LTC_K80_LPKE_12_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_13 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_13 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_13
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_13_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_13_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_13 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_13_ADDR(x)        ((x) + 0xE34U)
#define HW_LTC_K80_LPKE_13(x)             (*(__O  hw_ltc_k80_lpke_13_t *) HW_LTC_K80_LPKE_13_ADDR(x))
#define HW_LTC_K80_LPKE_13_WR(x, v)       (HW_LTC_K80_LPKE_13(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_13 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_13, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_13_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_13_PKHA_E. */
#define BM_LTC_K80_LPKE_13_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_13_PKHA_E. */
#define BS_LTC_K80_LPKE_13_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_13_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_13_PKHA_E. */
#define BF_LTC_K80_LPKE_13_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_13_PKHA_E) & BM_LTC_K80_LPKE_13_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_13_PKHA_E(x, v)   (HW_LTC_K80_LPKE_13_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_14 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_14 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_14
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_14_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_14_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_14 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_14_ADDR(x)        ((x) + 0xE38U)
#define HW_LTC_K80_LPKE_14(x)             (*(__O  hw_ltc_k80_lpke_14_t *) HW_LTC_K80_LPKE_14_ADDR(x))
#define HW_LTC_K80_LPKE_14_WR(x, v)       (HW_LTC_K80_LPKE_14(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_14 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_14, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_14_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_14_PKHA_E. */
#define BM_LTC_K80_LPKE_14_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_14_PKHA_E. */
#define BS_LTC_K80_LPKE_14_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_14_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_14_PKHA_E. */
#define BF_LTC_K80_LPKE_14_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_14_PKHA_E) & BM_LTC_K80_LPKE_14_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_14_PKHA_E(x, v)   (HW_LTC_K80_LPKE_14_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_15 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_15 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_15
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_15_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_15_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_15 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_15_ADDR(x)        ((x) + 0xE3CU)
#define HW_LTC_K80_LPKE_15(x)             (*(__O  hw_ltc_k80_lpke_15_t *) HW_LTC_K80_LPKE_15_ADDR(x))
#define HW_LTC_K80_LPKE_15_WR(x, v)       (HW_LTC_K80_LPKE_15(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_15 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_15, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_15_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_15_PKHA_E. */
#define BM_LTC_K80_LPKE_15_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_15_PKHA_E. */
#define BS_LTC_K80_LPKE_15_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_15_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_15_PKHA_E. */
#define BF_LTC_K80_LPKE_15_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_15_PKHA_E) & BM_LTC_K80_LPKE_15_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_15_PKHA_E(x, v)   (HW_LTC_K80_LPKE_15_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_16 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_16 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_16
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_16_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_16_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_16 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_16_ADDR(x)        ((x) + 0xE40U)
#define HW_LTC_K80_LPKE_16(x)             (*(__O  hw_ltc_k80_lpke_16_t *) HW_LTC_K80_LPKE_16_ADDR(x))
#define HW_LTC_K80_LPKE_16_WR(x, v)       (HW_LTC_K80_LPKE_16(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_16 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_16, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_16_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_16_PKHA_E. */
#define BM_LTC_K80_LPKE_16_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_16_PKHA_E. */
#define BS_LTC_K80_LPKE_16_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_16_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_16_PKHA_E. */
#define BF_LTC_K80_LPKE_16_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_16_PKHA_E) & BM_LTC_K80_LPKE_16_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_16_PKHA_E(x, v)   (HW_LTC_K80_LPKE_16_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_17 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_17 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_17
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_17_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_17_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_17 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_17_ADDR(x)        ((x) + 0xE44U)
#define HW_LTC_K80_LPKE_17(x)             (*(__O  hw_ltc_k80_lpke_17_t *) HW_LTC_K80_LPKE_17_ADDR(x))
#define HW_LTC_K80_LPKE_17_WR(x, v)       (HW_LTC_K80_LPKE_17(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_17 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_17, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_17_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_17_PKHA_E. */
#define BM_LTC_K80_LPKE_17_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_17_PKHA_E. */
#define BS_LTC_K80_LPKE_17_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_17_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_17_PKHA_E. */
#define BF_LTC_K80_LPKE_17_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_17_PKHA_E) & BM_LTC_K80_LPKE_17_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_17_PKHA_E(x, v)   (HW_LTC_K80_LPKE_17_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_18 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_18 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_18
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_18_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_18_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_18 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_18_ADDR(x)        ((x) + 0xE48U)
#define HW_LTC_K80_LPKE_18(x)             (*(__O  hw_ltc_k80_lpke_18_t *) HW_LTC_K80_LPKE_18_ADDR(x))
#define HW_LTC_K80_LPKE_18_WR(x, v)       (HW_LTC_K80_LPKE_18(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_18 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_18, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_18_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_18_PKHA_E. */
#define BM_LTC_K80_LPKE_18_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_18_PKHA_E. */
#define BS_LTC_K80_LPKE_18_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_18_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_18_PKHA_E. */
#define BF_LTC_K80_LPKE_18_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_18_PKHA_E) & BM_LTC_K80_LPKE_18_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_18_PKHA_E(x, v)   (HW_LTC_K80_LPKE_18_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_19 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_19 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_19
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_19_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_19_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_19 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_19_ADDR(x)        ((x) + 0xE4CU)
#define HW_LTC_K80_LPKE_19(x)             (*(__O  hw_ltc_k80_lpke_19_t *) HW_LTC_K80_LPKE_19_ADDR(x))
#define HW_LTC_K80_LPKE_19_WR(x, v)       (HW_LTC_K80_LPKE_19(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_19 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_19, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_19_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_19_PKHA_E. */
#define BM_LTC_K80_LPKE_19_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_19_PKHA_E. */
#define BS_LTC_K80_LPKE_19_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_19_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_19_PKHA_E. */
#define BF_LTC_K80_LPKE_19_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_19_PKHA_E) & BM_LTC_K80_LPKE_19_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_19_PKHA_E(x, v)   (HW_LTC_K80_LPKE_19_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_20 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_20 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_20
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_20_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_20_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_20 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_20_ADDR(x)        ((x) + 0xE50U)
#define HW_LTC_K80_LPKE_20(x)             (*(__O  hw_ltc_k80_lpke_20_t *) HW_LTC_K80_LPKE_20_ADDR(x))
#define HW_LTC_K80_LPKE_20_WR(x, v)       (HW_LTC_K80_LPKE_20(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_20 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_20, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_20_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_20_PKHA_E. */
#define BM_LTC_K80_LPKE_20_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_20_PKHA_E. */
#define BS_LTC_K80_LPKE_20_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_20_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_20_PKHA_E. */
#define BF_LTC_K80_LPKE_20_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_20_PKHA_E) & BM_LTC_K80_LPKE_20_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_20_PKHA_E(x, v)   (HW_LTC_K80_LPKE_20_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_21 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_21 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_21
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_21_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_21_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_21 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_21_ADDR(x)        ((x) + 0xE54U)
#define HW_LTC_K80_LPKE_21(x)             (*(__O  hw_ltc_k80_lpke_21_t *) HW_LTC_K80_LPKE_21_ADDR(x))
#define HW_LTC_K80_LPKE_21_WR(x, v)       (HW_LTC_K80_LPKE_21(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_21 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_21, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_21_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_21_PKHA_E. */
#define BM_LTC_K80_LPKE_21_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_21_PKHA_E. */
#define BS_LTC_K80_LPKE_21_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_21_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_21_PKHA_E. */
#define BF_LTC_K80_LPKE_21_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_21_PKHA_E) & BM_LTC_K80_LPKE_21_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_21_PKHA_E(x, v)   (HW_LTC_K80_LPKE_21_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_22 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_22 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_22
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_22_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_22_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_22 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_22_ADDR(x)        ((x) + 0xE58U)
#define HW_LTC_K80_LPKE_22(x)             (*(__O  hw_ltc_k80_lpke_22_t *) HW_LTC_K80_LPKE_22_ADDR(x))
#define HW_LTC_K80_LPKE_22_WR(x, v)       (HW_LTC_K80_LPKE_22(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_22 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_22, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_22_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_22_PKHA_E. */
#define BM_LTC_K80_LPKE_22_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_22_PKHA_E. */
#define BS_LTC_K80_LPKE_22_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_22_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_22_PKHA_E. */
#define BF_LTC_K80_LPKE_22_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_22_PKHA_E) & BM_LTC_K80_LPKE_22_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_22_PKHA_E(x, v)   (HW_LTC_K80_LPKE_22_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_23 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_23 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_23
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_23_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_23_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_23 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_23_ADDR(x)        ((x) + 0xE5CU)
#define HW_LTC_K80_LPKE_23(x)             (*(__O  hw_ltc_k80_lpke_23_t *) HW_LTC_K80_LPKE_23_ADDR(x))
#define HW_LTC_K80_LPKE_23_WR(x, v)       (HW_LTC_K80_LPKE_23(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_23 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_23, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_23_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_23_PKHA_E. */
#define BM_LTC_K80_LPKE_23_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_23_PKHA_E. */
#define BS_LTC_K80_LPKE_23_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_23_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_23_PKHA_E. */
#define BF_LTC_K80_LPKE_23_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_23_PKHA_E) & BM_LTC_K80_LPKE_23_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_23_PKHA_E(x, v)   (HW_LTC_K80_LPKE_23_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_24 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_24 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_24
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_24_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_24_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_24 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_24_ADDR(x)        ((x) + 0xE60U)
#define HW_LTC_K80_LPKE_24(x)             (*(__O  hw_ltc_k80_lpke_24_t *) HW_LTC_K80_LPKE_24_ADDR(x))
#define HW_LTC_K80_LPKE_24_WR(x, v)       (HW_LTC_K80_LPKE_24(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_24 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_24, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_24_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_24_PKHA_E. */
#define BM_LTC_K80_LPKE_24_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_24_PKHA_E. */
#define BS_LTC_K80_LPKE_24_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_24_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_24_PKHA_E. */
#define BF_LTC_K80_LPKE_24_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_24_PKHA_E) & BM_LTC_K80_LPKE_24_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_24_PKHA_E(x, v)   (HW_LTC_K80_LPKE_24_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_25 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_25 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_25
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_25_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_25_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_25 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_25_ADDR(x)        ((x) + 0xE64U)
#define HW_LTC_K80_LPKE_25(x)             (*(__O  hw_ltc_k80_lpke_25_t *) HW_LTC_K80_LPKE_25_ADDR(x))
#define HW_LTC_K80_LPKE_25_WR(x, v)       (HW_LTC_K80_LPKE_25(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_25 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_25, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_25_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_25_PKHA_E. */
#define BM_LTC_K80_LPKE_25_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_25_PKHA_E. */
#define BS_LTC_K80_LPKE_25_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_25_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_25_PKHA_E. */
#define BF_LTC_K80_LPKE_25_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_25_PKHA_E) & BM_LTC_K80_LPKE_25_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_25_PKHA_E(x, v)   (HW_LTC_K80_LPKE_25_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_26 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_26 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_26
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_26_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_26_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_26 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_26_ADDR(x)        ((x) + 0xE68U)
#define HW_LTC_K80_LPKE_26(x)             (*(__O  hw_ltc_k80_lpke_26_t *) HW_LTC_K80_LPKE_26_ADDR(x))
#define HW_LTC_K80_LPKE_26_WR(x, v)       (HW_LTC_K80_LPKE_26(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_26 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_26, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_26_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_26_PKHA_E. */
#define BM_LTC_K80_LPKE_26_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_26_PKHA_E. */
#define BS_LTC_K80_LPKE_26_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_26_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_26_PKHA_E. */
#define BF_LTC_K80_LPKE_26_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_26_PKHA_E) & BM_LTC_K80_LPKE_26_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_26_PKHA_E(x, v)   (HW_LTC_K80_LPKE_26_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_27 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_27 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_27
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_27_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_27_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_27 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_27_ADDR(x)        ((x) + 0xE6CU)
#define HW_LTC_K80_LPKE_27(x)             (*(__O  hw_ltc_k80_lpke_27_t *) HW_LTC_K80_LPKE_27_ADDR(x))
#define HW_LTC_K80_LPKE_27_WR(x, v)       (HW_LTC_K80_LPKE_27(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_27 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_27, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_27_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_27_PKHA_E. */
#define BM_LTC_K80_LPKE_27_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_27_PKHA_E. */
#define BS_LTC_K80_LPKE_27_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_27_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_27_PKHA_E. */
#define BF_LTC_K80_LPKE_27_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_27_PKHA_E) & BM_LTC_K80_LPKE_27_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_27_PKHA_E(x, v)   (HW_LTC_K80_LPKE_27_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_28 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_28 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_28
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_28_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_28_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_28 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_28_ADDR(x)        ((x) + 0xE70U)
#define HW_LTC_K80_LPKE_28(x)             (*(__O  hw_ltc_k80_lpke_28_t *) HW_LTC_K80_LPKE_28_ADDR(x))
#define HW_LTC_K80_LPKE_28_WR(x, v)       (HW_LTC_K80_LPKE_28(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_28 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_28, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_28_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_28_PKHA_E. */
#define BM_LTC_K80_LPKE_28_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_28_PKHA_E. */
#define BS_LTC_K80_LPKE_28_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_28_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_28_PKHA_E. */
#define BF_LTC_K80_LPKE_28_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_28_PKHA_E) & BM_LTC_K80_LPKE_28_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_28_PKHA_E(x, v)   (HW_LTC_K80_LPKE_28_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_29 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_29 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_29
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_29_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_29_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_29 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_29_ADDR(x)        ((x) + 0xE74U)
#define HW_LTC_K80_LPKE_29(x)             (*(__O  hw_ltc_k80_lpke_29_t *) HW_LTC_K80_LPKE_29_ADDR(x))
#define HW_LTC_K80_LPKE_29_WR(x, v)       (HW_LTC_K80_LPKE_29(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_29 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_29, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_29_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_29_PKHA_E. */
#define BM_LTC_K80_LPKE_29_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_29_PKHA_E. */
#define BS_LTC_K80_LPKE_29_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_29_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_29_PKHA_E. */
#define BF_LTC_K80_LPKE_29_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_29_PKHA_E) & BM_LTC_K80_LPKE_29_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_29_PKHA_E(x, v)   (HW_LTC_K80_LPKE_29_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_30 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_30 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_30
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_30_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_30_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_30 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_30_ADDR(x)        ((x) + 0xE78U)
#define HW_LTC_K80_LPKE_30(x)             (*(__O  hw_ltc_k80_lpke_30_t *) HW_LTC_K80_LPKE_30_ADDR(x))
#define HW_LTC_K80_LPKE_30_WR(x, v)       (HW_LTC_K80_LPKE_30(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_30 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_30, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_30_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_30_PKHA_E. */
#define BM_LTC_K80_LPKE_30_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_30_PKHA_E. */
#define BS_LTC_K80_LPKE_30_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_30_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_30_PKHA_E. */
#define BF_LTC_K80_LPKE_30_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_30_PKHA_E) & BM_LTC_K80_LPKE_30_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_30_PKHA_E(x, v)   (HW_LTC_K80_LPKE_30_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_31 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_31 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_31
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_31_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_31_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_31 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_31_ADDR(x)        ((x) + 0xE7CU)
#define HW_LTC_K80_LPKE_31(x)             (*(__O  hw_ltc_k80_lpke_31_t *) HW_LTC_K80_LPKE_31_ADDR(x))
#define HW_LTC_K80_LPKE_31_WR(x, v)       (HW_LTC_K80_LPKE_31(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_31 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_31, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_31_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_31_PKHA_E. */
#define BM_LTC_K80_LPKE_31_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_31_PKHA_E. */
#define BS_LTC_K80_LPKE_31_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_31_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_31_PKHA_E. */
#define BF_LTC_K80_LPKE_31_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_31_PKHA_E) & BM_LTC_K80_LPKE_31_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_31_PKHA_E(x, v)   (HW_LTC_K80_LPKE_31_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_32 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_32 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_32
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_32_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_32_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_32 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_32_ADDR(x)        ((x) + 0xE80U)
#define HW_LTC_K80_LPKE_32(x)             (*(__O  hw_ltc_k80_lpke_32_t *) HW_LTC_K80_LPKE_32_ADDR(x))
#define HW_LTC_K80_LPKE_32_WR(x, v)       (HW_LTC_K80_LPKE_32(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_32 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_32, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_32_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_32_PKHA_E. */
#define BM_LTC_K80_LPKE_32_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_32_PKHA_E. */
#define BS_LTC_K80_LPKE_32_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_32_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_32_PKHA_E. */
#define BF_LTC_K80_LPKE_32_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_32_PKHA_E) & BM_LTC_K80_LPKE_32_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_32_PKHA_E(x, v)   (HW_LTC_K80_LPKE_32_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_33 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_33 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_33
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_33_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_33_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_33 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_33_ADDR(x)        ((x) + 0xE84U)
#define HW_LTC_K80_LPKE_33(x)             (*(__O  hw_ltc_k80_lpke_33_t *) HW_LTC_K80_LPKE_33_ADDR(x))
#define HW_LTC_K80_LPKE_33_WR(x, v)       (HW_LTC_K80_LPKE_33(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_33 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_33, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_33_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_33_PKHA_E. */
#define BM_LTC_K80_LPKE_33_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_33_PKHA_E. */
#define BS_LTC_K80_LPKE_33_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_33_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_33_PKHA_E. */
#define BF_LTC_K80_LPKE_33_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_33_PKHA_E) & BM_LTC_K80_LPKE_33_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_33_PKHA_E(x, v)   (HW_LTC_K80_LPKE_33_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_34 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_34 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_34
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_34_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_34_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_34 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_34_ADDR(x)        ((x) + 0xE88U)
#define HW_LTC_K80_LPKE_34(x)             (*(__O  hw_ltc_k80_lpke_34_t *) HW_LTC_K80_LPKE_34_ADDR(x))
#define HW_LTC_K80_LPKE_34_WR(x, v)       (HW_LTC_K80_LPKE_34(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_34 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_34, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_34_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_34_PKHA_E. */
#define BM_LTC_K80_LPKE_34_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_34_PKHA_E. */
#define BS_LTC_K80_LPKE_34_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_34_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_34_PKHA_E. */
#define BF_LTC_K80_LPKE_34_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_34_PKHA_E) & BM_LTC_K80_LPKE_34_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_34_PKHA_E(x, v)   (HW_LTC_K80_LPKE_34_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_35 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_35 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_35
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_35_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_35_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_35 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_35_ADDR(x)        ((x) + 0xE8CU)
#define HW_LTC_K80_LPKE_35(x)             (*(__O  hw_ltc_k80_lpke_35_t *) HW_LTC_K80_LPKE_35_ADDR(x))
#define HW_LTC_K80_LPKE_35_WR(x, v)       (HW_LTC_K80_LPKE_35(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_35 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_35, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_35_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_35_PKHA_E. */
#define BM_LTC_K80_LPKE_35_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_35_PKHA_E. */
#define BS_LTC_K80_LPKE_35_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_35_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_35_PKHA_E. */
#define BF_LTC_K80_LPKE_35_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_35_PKHA_E) & BM_LTC_K80_LPKE_35_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_35_PKHA_E(x, v)   (HW_LTC_K80_LPKE_35_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_36 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_36 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_36
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_36_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_36_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_36 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_36_ADDR(x)        ((x) + 0xE90U)
#define HW_LTC_K80_LPKE_36(x)             (*(__O  hw_ltc_k80_lpke_36_t *) HW_LTC_K80_LPKE_36_ADDR(x))
#define HW_LTC_K80_LPKE_36_WR(x, v)       (HW_LTC_K80_LPKE_36(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_36 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_36, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_36_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_36_PKHA_E. */
#define BM_LTC_K80_LPKE_36_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_36_PKHA_E. */
#define BS_LTC_K80_LPKE_36_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_36_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_36_PKHA_E. */
#define BF_LTC_K80_LPKE_36_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_36_PKHA_E) & BM_LTC_K80_LPKE_36_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_36_PKHA_E(x, v)   (HW_LTC_K80_LPKE_36_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_37 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_37 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_37
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_37_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_37_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_37 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_37_ADDR(x)        ((x) + 0xE94U)
#define HW_LTC_K80_LPKE_37(x)             (*(__O  hw_ltc_k80_lpke_37_t *) HW_LTC_K80_LPKE_37_ADDR(x))
#define HW_LTC_K80_LPKE_37_WR(x, v)       (HW_LTC_K80_LPKE_37(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_37 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_37, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_37_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_37_PKHA_E. */
#define BM_LTC_K80_LPKE_37_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_37_PKHA_E. */
#define BS_LTC_K80_LPKE_37_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_37_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_37_PKHA_E. */
#define BF_LTC_K80_LPKE_37_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_37_PKHA_E) & BM_LTC_K80_LPKE_37_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_37_PKHA_E(x, v)   (HW_LTC_K80_LPKE_37_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_38 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_38 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_38
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_38_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_38_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_38 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_38_ADDR(x)        ((x) + 0xE98U)
#define HW_LTC_K80_LPKE_38(x)             (*(__O  hw_ltc_k80_lpke_38_t *) HW_LTC_K80_LPKE_38_ADDR(x))
#define HW_LTC_K80_LPKE_38_WR(x, v)       (HW_LTC_K80_LPKE_38(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_38 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_38, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_38_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_38_PKHA_E. */
#define BM_LTC_K80_LPKE_38_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_38_PKHA_E. */
#define BS_LTC_K80_LPKE_38_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_38_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_38_PKHA_E. */
#define BF_LTC_K80_LPKE_38_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_38_PKHA_E) & BM_LTC_K80_LPKE_38_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_38_PKHA_E(x, v)   (HW_LTC_K80_LPKE_38_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_39 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_39 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_39
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_39_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_39_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_39 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_39_ADDR(x)        ((x) + 0xE9CU)
#define HW_LTC_K80_LPKE_39(x)             (*(__O  hw_ltc_k80_lpke_39_t *) HW_LTC_K80_LPKE_39_ADDR(x))
#define HW_LTC_K80_LPKE_39_WR(x, v)       (HW_LTC_K80_LPKE_39(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_39 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_39, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_39_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_39_PKHA_E. */
#define BM_LTC_K80_LPKE_39_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_39_PKHA_E. */
#define BS_LTC_K80_LPKE_39_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_39_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_39_PKHA_E. */
#define BF_LTC_K80_LPKE_39_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_39_PKHA_E) & BM_LTC_K80_LPKE_39_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_39_PKHA_E(x, v)   (HW_LTC_K80_LPKE_39_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_40 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_40 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_40
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_40_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_40_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_40 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_40_ADDR(x)        ((x) + 0xEA0U)
#define HW_LTC_K80_LPKE_40(x)             (*(__O  hw_ltc_k80_lpke_40_t *) HW_LTC_K80_LPKE_40_ADDR(x))
#define HW_LTC_K80_LPKE_40_WR(x, v)       (HW_LTC_K80_LPKE_40(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_40 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_40, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_40_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_40_PKHA_E. */
#define BM_LTC_K80_LPKE_40_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_40_PKHA_E. */
#define BS_LTC_K80_LPKE_40_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_40_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_40_PKHA_E. */
#define BF_LTC_K80_LPKE_40_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_40_PKHA_E) & BM_LTC_K80_LPKE_40_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_40_PKHA_E(x, v)   (HW_LTC_K80_LPKE_40_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_41 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_41 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_41
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_41_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_41_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_41 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_41_ADDR(x)        ((x) + 0xEA4U)
#define HW_LTC_K80_LPKE_41(x)             (*(__O  hw_ltc_k80_lpke_41_t *) HW_LTC_K80_LPKE_41_ADDR(x))
#define HW_LTC_K80_LPKE_41_WR(x, v)       (HW_LTC_K80_LPKE_41(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_41 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_41, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_41_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_41_PKHA_E. */
#define BM_LTC_K80_LPKE_41_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_41_PKHA_E. */
#define BS_LTC_K80_LPKE_41_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_41_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_41_PKHA_E. */
#define BF_LTC_K80_LPKE_41_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_41_PKHA_E) & BM_LTC_K80_LPKE_41_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_41_PKHA_E(x, v)   (HW_LTC_K80_LPKE_41_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_42 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_42 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_42
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_42_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_42_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_42 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_42_ADDR(x)        ((x) + 0xEA8U)
#define HW_LTC_K80_LPKE_42(x)             (*(__O  hw_ltc_k80_lpke_42_t *) HW_LTC_K80_LPKE_42_ADDR(x))
#define HW_LTC_K80_LPKE_42_WR(x, v)       (HW_LTC_K80_LPKE_42(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_42 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_42, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_42_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_42_PKHA_E. */
#define BM_LTC_K80_LPKE_42_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_42_PKHA_E. */
#define BS_LTC_K80_LPKE_42_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_42_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_42_PKHA_E. */
#define BF_LTC_K80_LPKE_42_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_42_PKHA_E) & BM_LTC_K80_LPKE_42_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_42_PKHA_E(x, v)   (HW_LTC_K80_LPKE_42_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_43 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_43 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_43
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_43_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_43_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_43 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_43_ADDR(x)        ((x) + 0xEACU)
#define HW_LTC_K80_LPKE_43(x)             (*(__O  hw_ltc_k80_lpke_43_t *) HW_LTC_K80_LPKE_43_ADDR(x))
#define HW_LTC_K80_LPKE_43_WR(x, v)       (HW_LTC_K80_LPKE_43(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_43 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_43, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_43_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_43_PKHA_E. */
#define BM_LTC_K80_LPKE_43_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_43_PKHA_E. */
#define BS_LTC_K80_LPKE_43_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_43_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_43_PKHA_E. */
#define BF_LTC_K80_LPKE_43_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_43_PKHA_E) & BM_LTC_K80_LPKE_43_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_43_PKHA_E(x, v)   (HW_LTC_K80_LPKE_43_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_44 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_44 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_44
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_44_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_44_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_44 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_44_ADDR(x)        ((x) + 0xEB0U)
#define HW_LTC_K80_LPKE_44(x)             (*(__O  hw_ltc_k80_lpke_44_t *) HW_LTC_K80_LPKE_44_ADDR(x))
#define HW_LTC_K80_LPKE_44_WR(x, v)       (HW_LTC_K80_LPKE_44(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_44 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_44, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_44_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_44_PKHA_E. */
#define BM_LTC_K80_LPKE_44_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_44_PKHA_E. */
#define BS_LTC_K80_LPKE_44_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_44_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_44_PKHA_E. */
#define BF_LTC_K80_LPKE_44_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_44_PKHA_E) & BM_LTC_K80_LPKE_44_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_44_PKHA_E(x, v)   (HW_LTC_K80_LPKE_44_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_45 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_45 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_45
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_45_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_45_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_45 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_45_ADDR(x)        ((x) + 0xEB4U)
#define HW_LTC_K80_LPKE_45(x)             (*(__O  hw_ltc_k80_lpke_45_t *) HW_LTC_K80_LPKE_45_ADDR(x))
#define HW_LTC_K80_LPKE_45_WR(x, v)       (HW_LTC_K80_LPKE_45(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_45 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_45, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_45_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_45_PKHA_E. */
#define BM_LTC_K80_LPKE_45_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_45_PKHA_E. */
#define BS_LTC_K80_LPKE_45_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_45_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_45_PKHA_E. */
#define BF_LTC_K80_LPKE_45_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_45_PKHA_E) & BM_LTC_K80_LPKE_45_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_45_PKHA_E(x, v)   (HW_LTC_K80_LPKE_45_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_46 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_46 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_46
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_46_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_46_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_46 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_46_ADDR(x)        ((x) + 0xEB8U)
#define HW_LTC_K80_LPKE_46(x)             (*(__O  hw_ltc_k80_lpke_46_t *) HW_LTC_K80_LPKE_46_ADDR(x))
#define HW_LTC_K80_LPKE_46_WR(x, v)       (HW_LTC_K80_LPKE_46(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_46 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_46, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_46_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_46_PKHA_E. */
#define BM_LTC_K80_LPKE_46_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_46_PKHA_E. */
#define BS_LTC_K80_LPKE_46_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_46_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_46_PKHA_E. */
#define BF_LTC_K80_LPKE_46_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_46_PKHA_E) & BM_LTC_K80_LPKE_46_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_46_PKHA_E(x, v)   (HW_LTC_K80_LPKE_46_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_47 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_47 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_47
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_47_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_47_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_47 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_47_ADDR(x)        ((x) + 0xEBCU)
#define HW_LTC_K80_LPKE_47(x)             (*(__O  hw_ltc_k80_lpke_47_t *) HW_LTC_K80_LPKE_47_ADDR(x))
#define HW_LTC_K80_LPKE_47_WR(x, v)       (HW_LTC_K80_LPKE_47(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_47 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_47, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_47_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_47_PKHA_E. */
#define BM_LTC_K80_LPKE_47_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_47_PKHA_E. */
#define BS_LTC_K80_LPKE_47_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_47_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_47_PKHA_E. */
#define BF_LTC_K80_LPKE_47_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_47_PKHA_E) & BM_LTC_K80_LPKE_47_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_47_PKHA_E(x, v)   (HW_LTC_K80_LPKE_47_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_48 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_48 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_48
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_48_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_48_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_48 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_48_ADDR(x)        ((x) + 0xEC0U)
#define HW_LTC_K80_LPKE_48(x)             (*(__O  hw_ltc_k80_lpke_48_t *) HW_LTC_K80_LPKE_48_ADDR(x))
#define HW_LTC_K80_LPKE_48_WR(x, v)       (HW_LTC_K80_LPKE_48(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_48 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_48, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_48_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_48_PKHA_E. */
#define BM_LTC_K80_LPKE_48_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_48_PKHA_E. */
#define BS_LTC_K80_LPKE_48_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_48_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_48_PKHA_E. */
#define BF_LTC_K80_LPKE_48_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_48_PKHA_E) & BM_LTC_K80_LPKE_48_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_48_PKHA_E(x, v)   (HW_LTC_K80_LPKE_48_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_49 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_49 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_49
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_49_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_49_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_49 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_49_ADDR(x)        ((x) + 0xEC4U)
#define HW_LTC_K80_LPKE_49(x)             (*(__O  hw_ltc_k80_lpke_49_t *) HW_LTC_K80_LPKE_49_ADDR(x))
#define HW_LTC_K80_LPKE_49_WR(x, v)       (HW_LTC_K80_LPKE_49(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_49 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_49, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_49_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_49_PKHA_E. */
#define BM_LTC_K80_LPKE_49_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_49_PKHA_E. */
#define BS_LTC_K80_LPKE_49_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_49_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_49_PKHA_E. */
#define BF_LTC_K80_LPKE_49_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_49_PKHA_E) & BM_LTC_K80_LPKE_49_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_49_PKHA_E(x, v)   (HW_LTC_K80_LPKE_49_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_50 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_50 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_50
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_50_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_50_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_50 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_50_ADDR(x)        ((x) + 0xEC8U)
#define HW_LTC_K80_LPKE_50(x)             (*(__O  hw_ltc_k80_lpke_50_t *) HW_LTC_K80_LPKE_50_ADDR(x))
#define HW_LTC_K80_LPKE_50_WR(x, v)       (HW_LTC_K80_LPKE_50(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_50 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_50, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_50_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_50_PKHA_E. */
#define BM_LTC_K80_LPKE_50_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_50_PKHA_E. */
#define BS_LTC_K80_LPKE_50_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_50_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_50_PKHA_E. */
#define BF_LTC_K80_LPKE_50_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_50_PKHA_E) & BM_LTC_K80_LPKE_50_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_50_PKHA_E(x, v)   (HW_LTC_K80_LPKE_50_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_51 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_51 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_51
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_51_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_51_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_51 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_51_ADDR(x)        ((x) + 0xECCU)
#define HW_LTC_K80_LPKE_51(x)             (*(__O  hw_ltc_k80_lpke_51_t *) HW_LTC_K80_LPKE_51_ADDR(x))
#define HW_LTC_K80_LPKE_51_WR(x, v)       (HW_LTC_K80_LPKE_51(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_51 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_51, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_51_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_51_PKHA_E. */
#define BM_LTC_K80_LPKE_51_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_51_PKHA_E. */
#define BS_LTC_K80_LPKE_51_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_51_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_51_PKHA_E. */
#define BF_LTC_K80_LPKE_51_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_51_PKHA_E) & BM_LTC_K80_LPKE_51_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_51_PKHA_E(x, v)   (HW_LTC_K80_LPKE_51_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_52 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_52 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_52
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_52_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_52_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_52 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_52_ADDR(x)        ((x) + 0xED0U)
#define HW_LTC_K80_LPKE_52(x)             (*(__O  hw_ltc_k80_lpke_52_t *) HW_LTC_K80_LPKE_52_ADDR(x))
#define HW_LTC_K80_LPKE_52_WR(x, v)       (HW_LTC_K80_LPKE_52(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_52 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_52, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_52_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_52_PKHA_E. */
#define BM_LTC_K80_LPKE_52_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_52_PKHA_E. */
#define BS_LTC_K80_LPKE_52_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_52_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_52_PKHA_E. */
#define BF_LTC_K80_LPKE_52_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_52_PKHA_E) & BM_LTC_K80_LPKE_52_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_52_PKHA_E(x, v)   (HW_LTC_K80_LPKE_52_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_53 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_53 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_53
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_53_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_53_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_53 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_53_ADDR(x)        ((x) + 0xED4U)
#define HW_LTC_K80_LPKE_53(x)             (*(__O  hw_ltc_k80_lpke_53_t *) HW_LTC_K80_LPKE_53_ADDR(x))
#define HW_LTC_K80_LPKE_53_WR(x, v)       (HW_LTC_K80_LPKE_53(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_53 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_53, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_53_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_53_PKHA_E. */
#define BM_LTC_K80_LPKE_53_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_53_PKHA_E. */
#define BS_LTC_K80_LPKE_53_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_53_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_53_PKHA_E. */
#define BF_LTC_K80_LPKE_53_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_53_PKHA_E) & BM_LTC_K80_LPKE_53_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_53_PKHA_E(x, v)   (HW_LTC_K80_LPKE_53_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_54 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_54 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_54
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_54_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_54_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_54 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_54_ADDR(x)        ((x) + 0xED8U)
#define HW_LTC_K80_LPKE_54(x)             (*(__O  hw_ltc_k80_lpke_54_t *) HW_LTC_K80_LPKE_54_ADDR(x))
#define HW_LTC_K80_LPKE_54_WR(x, v)       (HW_LTC_K80_LPKE_54(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_54 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_54, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_54_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_54_PKHA_E. */
#define BM_LTC_K80_LPKE_54_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_54_PKHA_E. */
#define BS_LTC_K80_LPKE_54_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_54_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_54_PKHA_E. */
#define BF_LTC_K80_LPKE_54_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_54_PKHA_E) & BM_LTC_K80_LPKE_54_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_54_PKHA_E(x, v)   (HW_LTC_K80_LPKE_54_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_55 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_55 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_55
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_55_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_55_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_55 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_55_ADDR(x)        ((x) + 0xEDCU)
#define HW_LTC_K80_LPKE_55(x)             (*(__O  hw_ltc_k80_lpke_55_t *) HW_LTC_K80_LPKE_55_ADDR(x))
#define HW_LTC_K80_LPKE_55_WR(x, v)       (HW_LTC_K80_LPKE_55(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_55 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_55, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_55_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_55_PKHA_E. */
#define BM_LTC_K80_LPKE_55_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_55_PKHA_E. */
#define BS_LTC_K80_LPKE_55_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_55_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_55_PKHA_E. */
#define BF_LTC_K80_LPKE_55_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_55_PKHA_E) & BM_LTC_K80_LPKE_55_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_55_PKHA_E(x, v)   (HW_LTC_K80_LPKE_55_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_56 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_56 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_56
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_56_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_56_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_56 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_56_ADDR(x)        ((x) + 0xEE0U)
#define HW_LTC_K80_LPKE_56(x)             (*(__O  hw_ltc_k80_lpke_56_t *) HW_LTC_K80_LPKE_56_ADDR(x))
#define HW_LTC_K80_LPKE_56_WR(x, v)       (HW_LTC_K80_LPKE_56(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_56 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_56, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_56_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_56_PKHA_E. */
#define BM_LTC_K80_LPKE_56_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_56_PKHA_E. */
#define BS_LTC_K80_LPKE_56_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_56_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_56_PKHA_E. */
#define BF_LTC_K80_LPKE_56_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_56_PKHA_E) & BM_LTC_K80_LPKE_56_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_56_PKHA_E(x, v)   (HW_LTC_K80_LPKE_56_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_57 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_57 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_57
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_57_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_57_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_57 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_57_ADDR(x)        ((x) + 0xEE4U)
#define HW_LTC_K80_LPKE_57(x)             (*(__O  hw_ltc_k80_lpke_57_t *) HW_LTC_K80_LPKE_57_ADDR(x))
#define HW_LTC_K80_LPKE_57_WR(x, v)       (HW_LTC_K80_LPKE_57(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_57 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_57, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_57_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_57_PKHA_E. */
#define BM_LTC_K80_LPKE_57_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_57_PKHA_E. */
#define BS_LTC_K80_LPKE_57_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_57_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_57_PKHA_E. */
#define BF_LTC_K80_LPKE_57_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_57_PKHA_E) & BM_LTC_K80_LPKE_57_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_57_PKHA_E(x, v)   (HW_LTC_K80_LPKE_57_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_58 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_58 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_58
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_58_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_58_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_58 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_58_ADDR(x)        ((x) + 0xEE8U)
#define HW_LTC_K80_LPKE_58(x)             (*(__O  hw_ltc_k80_lpke_58_t *) HW_LTC_K80_LPKE_58_ADDR(x))
#define HW_LTC_K80_LPKE_58_WR(x, v)       (HW_LTC_K80_LPKE_58(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_58 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_58, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_58_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_58_PKHA_E. */
#define BM_LTC_K80_LPKE_58_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_58_PKHA_E. */
#define BS_LTC_K80_LPKE_58_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_58_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_58_PKHA_E. */
#define BF_LTC_K80_LPKE_58_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_58_PKHA_E) & BM_LTC_K80_LPKE_58_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_58_PKHA_E(x, v)   (HW_LTC_K80_LPKE_58_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_59 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_59 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_59
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_59_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_59_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_59 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_59_ADDR(x)        ((x) + 0xEECU)
#define HW_LTC_K80_LPKE_59(x)             (*(__O  hw_ltc_k80_lpke_59_t *) HW_LTC_K80_LPKE_59_ADDR(x))
#define HW_LTC_K80_LPKE_59_WR(x, v)       (HW_LTC_K80_LPKE_59(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_59 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_59, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_59_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_59_PKHA_E. */
#define BM_LTC_K80_LPKE_59_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_59_PKHA_E. */
#define BS_LTC_K80_LPKE_59_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_59_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_59_PKHA_E. */
#define BF_LTC_K80_LPKE_59_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_59_PKHA_E) & BM_LTC_K80_LPKE_59_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_59_PKHA_E(x, v)   (HW_LTC_K80_LPKE_59_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_60 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_60 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_60
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_60_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_60_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_60 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_60_ADDR(x)        ((x) + 0xEF0U)
#define HW_LTC_K80_LPKE_60(x)             (*(__O  hw_ltc_k80_lpke_60_t *) HW_LTC_K80_LPKE_60_ADDR(x))
#define HW_LTC_K80_LPKE_60_WR(x, v)       (HW_LTC_K80_LPKE_60(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_60 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_60, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_60_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_60_PKHA_E. */
#define BM_LTC_K80_LPKE_60_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_60_PKHA_E. */
#define BS_LTC_K80_LPKE_60_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_60_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_60_PKHA_E. */
#define BF_LTC_K80_LPKE_60_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_60_PKHA_E) & BM_LTC_K80_LPKE_60_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_60_PKHA_E(x, v)   (HW_LTC_K80_LPKE_60_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_61 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_61 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_61
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_61_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_61_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_61 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_61_ADDR(x)        ((x) + 0xEF4U)
#define HW_LTC_K80_LPKE_61(x)             (*(__O  hw_ltc_k80_lpke_61_t *) HW_LTC_K80_LPKE_61_ADDR(x))
#define HW_LTC_K80_LPKE_61_WR(x, v)       (HW_LTC_K80_LPKE_61(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_61 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_61, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_61_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_61_PKHA_E. */
#define BM_LTC_K80_LPKE_61_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_61_PKHA_E. */
#define BS_LTC_K80_LPKE_61_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_61_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_61_PKHA_E. */
#define BF_LTC_K80_LPKE_61_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_61_PKHA_E) & BM_LTC_K80_LPKE_61_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_61_PKHA_E(x, v)   (HW_LTC_K80_LPKE_61_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_62 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_62 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_62
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_62_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_62_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_62 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_62_ADDR(x)        ((x) + 0xEF8U)
#define HW_LTC_K80_LPKE_62(x)             (*(__O  hw_ltc_k80_lpke_62_t *) HW_LTC_K80_LPKE_62_ADDR(x))
#define HW_LTC_K80_LPKE_62_WR(x, v)       (HW_LTC_K80_LPKE_62(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_62 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_62, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_62_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_62_PKHA_E. */
#define BM_LTC_K80_LPKE_62_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_62_PKHA_E. */
#define BS_LTC_K80_LPKE_62_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_62_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_62_PKHA_E. */
#define BF_LTC_K80_LPKE_62_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_62_PKHA_E) & BM_LTC_K80_LPKE_62_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_62_PKHA_E(x, v)   (HW_LTC_K80_LPKE_62_WR(x, v))
/*@}*/

/*******************************************************************************
 * HW_LTC_K80_LPKE_63 - LTC PKHA E Register
 ******************************************************************************/

/*!
 * @brief HW_LTC_K80_LPKE_63 - LTC PKHA E Register (WO)
 *
 * Reset value: 0x00000000U
 *
 * The LTC PKHA E Register contains a numeric value of up to 256 bytes, right-justified. The LSByte
 * is in offset E00h, in the right-most byte. The LTC PKHA E register is 2048 bits in length. The
 * value in the PKHA E Register is limited by the LTC PKHA E Size Register (LPKESZR). Note that the
 * PKHA E Register can be written only when the LTC Mode Register (LTCMR_PK) does not contain a
 * value enabling a PKHA operation. If the LTCMR_PK contains a PKHA operation mode value, then
 * writes to the PKHA E Register will be ignored.
 */
typedef union _hw_ltc_k80_lpke_63
{
    uint32_t U;
    struct _hw_ltc_k80_lpke_63_bitfields
    {
        uint32_t PKHA_E : 32; /*!< [31:0] E VALUE */
    } B;
} hw_ltc_k80_lpke_63_t;

/*!
 * @name Constants and macros for entire LTC_K80_LPKE_63 register
 */
/*@{*/
#define HW_LTC_K80_LPKE_63_ADDR(x)        ((x) + 0xEFCU)
#define HW_LTC_K80_LPKE_63(x)             (*(__O  hw_ltc_k80_lpke_63_t *) HW_LTC_K80_LPKE_63_ADDR(x))
#define HW_LTC_K80_LPKE_63_WR(x, v)       (HW_LTC_K80_LPKE_63(x).U = (v))
/*@}*/

/*
 * Constants & macros for individual LTC_K80_LPKE_63 bitfields
 */

/*!
 * @name Register LTC_K80_LPKE_63, field PKHA_E[31:0] (WO)
 *
 * E VALUE
 */
/*@{*/
#define BP_LTC_K80_LPKE_63_PKHA_E         (0U)      /*!< Bit position for LTC_K80_LPKE_63_PKHA_E. */
#define BM_LTC_K80_LPKE_63_PKHA_E         (0xFFFFFFFFU)  /*!< Bit mask for LTC_K80_LPKE_63_PKHA_E. */
#define BS_LTC_K80_LPKE_63_PKHA_E         (32U)  /*!< Bitfield size in bits for LTC_K80_LPKE_63_PKHA_E. */

/*! @brief Format value for bitfield LTC_K80_LPKE_63_PKHA_E. */
#define BF_LTC_K80_LPKE_63_PKHA_E(v)      ((uint32_t)((uint32_t)(v) << BP_LTC_K80_LPKE_63_PKHA_E) & BM_LTC_K80_LPKE_63_PKHA_E)

/*! @brief Set the PKHA_E field to a new value. */
#define BW_LTC_K80_LPKE_63_PKHA_E(x, v)   (HW_LTC_K80_LPKE_63_WR(x, v))
/*@}*/

/*******************************************************************************
 * hw_ltc_k80_t - module struct
 ******************************************************************************/
/*!
 * @brief All LTC_K80 module registers.
 */
#pragma pack(1)
typedef struct _hw_ltc_k80
{
    __IO hw_ltc_k80_ltcmr_t LTCMR; /*!< [0x0] LTC Mode Register (non-public-key use) */
    __IO hw_ltc_k80_ltcmr_pk_t LTCMR_PK; /*!< [0x0] LTC Mode Register (PublicKey) */
         uint32_t _reserved0;
    __IO hw_ltc_k80_ltcksr_t LTCKSR; /*!< [0x8] LTC Key Size Register */
         uint32_t _reserved1;
    __IO hw_ltc_k80_ltcdsr_t LTCDSR; /*!< [0x10] LTC Data Size Register */
         uint32_t _reserved2;
    __IO hw_ltc_k80_ltcicvsr_t LTCICVSR; /*!< [0x18] LTC ICV Size Register */
         uint32_t _reserved3[5];
    __IO hw_ltc_k80_ltccom_t LTCCOM; /*!< [0x30] LTC Command Register */
    __IO hw_ltc_k80_ltcctl_t LTCCTL; /*!< [0x34] LTC Control Register */
         uint32_t _reserved4[2];
    __IO hw_ltc_k80_ltccwr_t LTCCWR; /*!< [0x40] LTC Clear Written Register */
         uint32_t _reserved5;
    __IO hw_ltc_k80_ltcsta_t LTCSTA; /*!< [0x48] LTC Status Register */
    __IO hw_ltc_k80_ltcesta_t LTCESTA; /*!< [0x4C] LTC Error Status Register */
         uint32_t _reserved6[2];
    __IO hw_ltc_k80_ltcaadszr_t LTCAADSZR; /*!< [0x58] LTC AAD Size Register */
         uint32_t _reserved7;
    __IO hw_ltc_k80_ltcivszr_t LTCIVSZR; /*!< [0x60] LTC IV Size Register */
         uint32_t _reserved8;
    __O  hw_ltc_k80_ltcdpamsr_t LTCDPAMSR; /*!< [0x68] LTC DPA Mask Seed Register */
         uint32_t _reserved9[5];
    __IO hw_ltc_k80_lpkaszr_t LPKASZR; /*!< [0x80] LTC PKHA A Size Register */
         uint32_t _reserved10;
    __IO hw_ltc_k80_lpkbszr_t LPKBSZR; /*!< [0x88] LTC PKHA B Size Register */
         uint32_t _reserved11;
    __IO hw_ltc_k80_lpknszr_t LPKNSZR; /*!< [0x90] LTC PKHA N Size Register */
         uint32_t _reserved12;
    __IO hw_ltc_k80_lpkeszr_t LPKESZR; /*!< [0x98] LTC PKHA E Size Register */
         uint32_t _reserved13[25];
    __IO hw_ltc_k80_ltcctxr_0_t LTCCTXR_0; /*!< [0x100] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_1_t LTCCTXR_1; /*!< [0x104] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_2_t LTCCTXR_2; /*!< [0x108] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_3_t LTCCTXR_3; /*!< [0x10C] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_4_t LTCCTXR_4; /*!< [0x110] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_5_t LTCCTXR_5; /*!< [0x114] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_6_t LTCCTXR_6; /*!< [0x118] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_7_t LTCCTXR_7; /*!< [0x11C] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_8_t LTCCTXR_8; /*!< [0x120] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_9_t LTCCTXR_9; /*!< [0x124] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_10_t LTCCTXR_10; /*!< [0x128] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_11_t LTCCTXR_11; /*!< [0x12C] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_12_t LTCCTXR_12; /*!< [0x130] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_13_t LTCCTXR_13; /*!< [0x134] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_14_t LTCCTXR_14; /*!< [0x138] LTC Context Register */
    __IO hw_ltc_k80_ltcctxr_15_t LTCCTXR_15; /*!< [0x13C] LTC Context Register */
         uint32_t _reserved14[48];
    __IO hw_ltc_k80_ltckeyr_0_t LTCKEYR_0; /*!< [0x200] LTC Key Registers */
    __IO hw_ltc_k80_ltckeyr_1_t LTCKEYR_1; /*!< [0x204] LTC Key Registers */
    __IO hw_ltc_k80_ltckeyr_2_t LTCKEYR_2; /*!< [0x208] LTC Key Registers */
    __IO hw_ltc_k80_ltckeyr_3_t LTCKEYR_3; /*!< [0x20C] LTC Key Registers */
    __IO hw_ltc_k80_ltckeyr_4_t LTCKEYR_4; /*!< [0x210] LTC Key Registers */
    __IO hw_ltc_k80_ltckeyr_5_t LTCKEYR_5; /*!< [0x214] LTC Key Registers */
    __IO hw_ltc_k80_ltckeyr_6_t LTCKEYR_6; /*!< [0x218] LTC Key Registers */
    __IO hw_ltc_k80_ltckeyr_7_t LTCKEYR_7; /*!< [0x21C] LTC Key Registers */
         uint32_t _reserved15[180];
    __I  hw_ltc_k80_ltcvid1_t LTCVID1; /*!< [0x4F0] LTC Version ID Register */
         uint32_t _reserved16;
    __IO hw_ltc_k80_chavid_t CHAVID; /*!< [0x4F8] CHA Version ID Register */
         uint32_t _reserved17[177];
    __IO hw_ltc_k80_ltcfifosta_t LTCFIFOSTA; /*!< [0x7C0] LTC FIFO Status Register */
         uint32_t _reserved18[7];
    __O  hw_ltc_k80_ltcififo_t LTCIFIFO; /*!< [0x7E0] LTC Input Data FIFO */
         uint32_t _reserved19[3];
    __I  hw_ltc_k80_ltcofifo_t LTCOFIFO; /*!< [0x7F0] LTC Output Data FIFO */
         uint32_t _reserved20[3];
    __IO hw_ltc_k80_lpka0_0_t LPKA0_0; /*!< [0x800] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_1_t LPKA0_1; /*!< [0x804] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_2_t LPKA0_2; /*!< [0x808] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_3_t LPKA0_3; /*!< [0x80C] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_4_t LPKA0_4; /*!< [0x810] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_5_t LPKA0_5; /*!< [0x814] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_6_t LPKA0_6; /*!< [0x818] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_7_t LPKA0_7; /*!< [0x81C] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_8_t LPKA0_8; /*!< [0x820] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_9_t LPKA0_9; /*!< [0x824] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_10_t LPKA0_10; /*!< [0x828] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_11_t LPKA0_11; /*!< [0x82C] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_12_t LPKA0_12; /*!< [0x830] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_13_t LPKA0_13; /*!< [0x834] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_14_t LPKA0_14; /*!< [0x838] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka0_15_t LPKA0_15; /*!< [0x83C] LTC PKHA A0 Register */
    __IO hw_ltc_k80_lpka1_0_t LPKA1_0; /*!< [0x840] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_1_t LPKA1_1; /*!< [0x844] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_2_t LPKA1_2; /*!< [0x848] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_3_t LPKA1_3; /*!< [0x84C] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_4_t LPKA1_4; /*!< [0x850] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_5_t LPKA1_5; /*!< [0x854] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_6_t LPKA1_6; /*!< [0x858] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_7_t LPKA1_7; /*!< [0x85C] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_8_t LPKA1_8; /*!< [0x860] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_9_t LPKA1_9; /*!< [0x864] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_10_t LPKA1_10; /*!< [0x868] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_11_t LPKA1_11; /*!< [0x86C] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_12_t LPKA1_12; /*!< [0x870] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_13_t LPKA1_13; /*!< [0x874] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_14_t LPKA1_14; /*!< [0x878] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka1_15_t LPKA1_15; /*!< [0x87C] LTC PKHA A1 Register */
    __IO hw_ltc_k80_lpka2_0_t LPKA2_0; /*!< [0x880] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_1_t LPKA2_1; /*!< [0x884] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_2_t LPKA2_2; /*!< [0x888] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_3_t LPKA2_3; /*!< [0x88C] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_4_t LPKA2_4; /*!< [0x890] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_5_t LPKA2_5; /*!< [0x894] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_6_t LPKA2_6; /*!< [0x898] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_7_t LPKA2_7; /*!< [0x89C] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_8_t LPKA2_8; /*!< [0x8A0] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_9_t LPKA2_9; /*!< [0x8A4] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_10_t LPKA2_10; /*!< [0x8A8] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_11_t LPKA2_11; /*!< [0x8AC] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_12_t LPKA2_12; /*!< [0x8B0] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_13_t LPKA2_13; /*!< [0x8B4] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_14_t LPKA2_14; /*!< [0x8B8] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka2_15_t LPKA2_15; /*!< [0x8BC] LTC PKHA A2 Register */
    __IO hw_ltc_k80_lpka3_0_t LPKA3_0; /*!< [0x8C0] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_1_t LPKA3_1; /*!< [0x8C4] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_2_t LPKA3_2; /*!< [0x8C8] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_3_t LPKA3_3; /*!< [0x8CC] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_4_t LPKA3_4; /*!< [0x8D0] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_5_t LPKA3_5; /*!< [0x8D4] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_6_t LPKA3_6; /*!< [0x8D8] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_7_t LPKA3_7; /*!< [0x8DC] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_8_t LPKA3_8; /*!< [0x8E0] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_9_t LPKA3_9; /*!< [0x8E4] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_10_t LPKA3_10; /*!< [0x8E8] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_11_t LPKA3_11; /*!< [0x8EC] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_12_t LPKA3_12; /*!< [0x8F0] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_13_t LPKA3_13; /*!< [0x8F4] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_14_t LPKA3_14; /*!< [0x8F8] LTC PKHA A3 Register */
    __IO hw_ltc_k80_lpka3_15_t LPKA3_15; /*!< [0x8FC] LTC PKHA A3 Register */
         uint32_t _reserved21[64];
    __IO hw_ltc_k80_lpkb0_0_t LPKB0_0; /*!< [0xA00] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_1_t LPKB0_1; /*!< [0xA04] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_2_t LPKB0_2; /*!< [0xA08] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_3_t LPKB0_3; /*!< [0xA0C] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_4_t LPKB0_4; /*!< [0xA10] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_5_t LPKB0_5; /*!< [0xA14] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_6_t LPKB0_6; /*!< [0xA18] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_7_t LPKB0_7; /*!< [0xA1C] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_8_t LPKB0_8; /*!< [0xA20] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_9_t LPKB0_9; /*!< [0xA24] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_10_t LPKB0_10; /*!< [0xA28] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_11_t LPKB0_11; /*!< [0xA2C] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_12_t LPKB0_12; /*!< [0xA30] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_13_t LPKB0_13; /*!< [0xA34] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_14_t LPKB0_14; /*!< [0xA38] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb0_15_t LPKB0_15; /*!< [0xA3C] LTC PKHA B0 Register */
    __IO hw_ltc_k80_lpkb1_0_t LPKB1_0; /*!< [0xA40] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_1_t LPKB1_1; /*!< [0xA44] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_2_t LPKB1_2; /*!< [0xA48] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_3_t LPKB1_3; /*!< [0xA4C] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_4_t LPKB1_4; /*!< [0xA50] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_5_t LPKB1_5; /*!< [0xA54] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_6_t LPKB1_6; /*!< [0xA58] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_7_t LPKB1_7; /*!< [0xA5C] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_8_t LPKB1_8; /*!< [0xA60] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_9_t LPKB1_9; /*!< [0xA64] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_10_t LPKB1_10; /*!< [0xA68] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_11_t LPKB1_11; /*!< [0xA6C] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_12_t LPKB1_12; /*!< [0xA70] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_13_t LPKB1_13; /*!< [0xA74] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_14_t LPKB1_14; /*!< [0xA78] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb1_15_t LPKB1_15; /*!< [0xA7C] LTC PKHA B1 Register */
    __IO hw_ltc_k80_lpkb2_0_t LPKB2_0; /*!< [0xA80] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_1_t LPKB2_1; /*!< [0xA84] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_2_t LPKB2_2; /*!< [0xA88] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_3_t LPKB2_3; /*!< [0xA8C] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_4_t LPKB2_4; /*!< [0xA90] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_5_t LPKB2_5; /*!< [0xA94] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_6_t LPKB2_6; /*!< [0xA98] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_7_t LPKB2_7; /*!< [0xA9C] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_8_t LPKB2_8; /*!< [0xAA0] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_9_t LPKB2_9; /*!< [0xAA4] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_10_t LPKB2_10; /*!< [0xAA8] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_11_t LPKB2_11; /*!< [0xAAC] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_12_t LPKB2_12; /*!< [0xAB0] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_13_t LPKB2_13; /*!< [0xAB4] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_14_t LPKB2_14; /*!< [0xAB8] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb2_15_t LPKB2_15; /*!< [0xABC] LTC PKHA B2 Register */
    __IO hw_ltc_k80_lpkb3_0_t LPKB3_0; /*!< [0xAC0] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_1_t LPKB3_1; /*!< [0xAC4] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_2_t LPKB3_2; /*!< [0xAC8] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_3_t LPKB3_3; /*!< [0xACC] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_4_t LPKB3_4; /*!< [0xAD0] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_5_t LPKB3_5; /*!< [0xAD4] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_6_t LPKB3_6; /*!< [0xAD8] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_7_t LPKB3_7; /*!< [0xADC] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_8_t LPKB3_8; /*!< [0xAE0] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_9_t LPKB3_9; /*!< [0xAE4] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_10_t LPKB3_10; /*!< [0xAE8] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_11_t LPKB3_11; /*!< [0xAEC] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_12_t LPKB3_12; /*!< [0xAF0] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_13_t LPKB3_13; /*!< [0xAF4] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_14_t LPKB3_14; /*!< [0xAF8] LTC PKHA B3 Register */
    __IO hw_ltc_k80_lpkb3_15_t LPKB3_15; /*!< [0xAFC] LTC PKHA B3 Register */
         uint32_t _reserved22[64];
    __IO hw_ltc_k80_lpkn0_0_t LPKN0_0; /*!< [0xC00] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_1_t LPKN0_1; /*!< [0xC04] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_2_t LPKN0_2; /*!< [0xC08] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_3_t LPKN0_3; /*!< [0xC0C] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_4_t LPKN0_4; /*!< [0xC10] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_5_t LPKN0_5; /*!< [0xC14] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_6_t LPKN0_6; /*!< [0xC18] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_7_t LPKN0_7; /*!< [0xC1C] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_8_t LPKN0_8; /*!< [0xC20] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_9_t LPKN0_9; /*!< [0xC24] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_10_t LPKN0_10; /*!< [0xC28] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_11_t LPKN0_11; /*!< [0xC2C] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_12_t LPKN0_12; /*!< [0xC30] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_13_t LPKN0_13; /*!< [0xC34] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_14_t LPKN0_14; /*!< [0xC38] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn0_15_t LPKN0_15; /*!< [0xC3C] LTC PKHA N0 Register */
    __IO hw_ltc_k80_lpkn1_0_t LPKN1_0; /*!< [0xC40] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_1_t LPKN1_1; /*!< [0xC44] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_2_t LPKN1_2; /*!< [0xC48] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_3_t LPKN1_3; /*!< [0xC4C] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_4_t LPKN1_4; /*!< [0xC50] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_5_t LPKN1_5; /*!< [0xC54] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_6_t LPKN1_6; /*!< [0xC58] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_7_t LPKN1_7; /*!< [0xC5C] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_8_t LPKN1_8; /*!< [0xC60] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_9_t LPKN1_9; /*!< [0xC64] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_10_t LPKN1_10; /*!< [0xC68] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_11_t LPKN1_11; /*!< [0xC6C] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_12_t LPKN1_12; /*!< [0xC70] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_13_t LPKN1_13; /*!< [0xC74] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_14_t LPKN1_14; /*!< [0xC78] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn1_15_t LPKN1_15; /*!< [0xC7C] LTC PKHA N1 Register */
    __IO hw_ltc_k80_lpkn2_0_t LPKN2_0; /*!< [0xC80] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_1_t LPKN2_1; /*!< [0xC84] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_2_t LPKN2_2; /*!< [0xC88] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_3_t LPKN2_3; /*!< [0xC8C] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_4_t LPKN2_4; /*!< [0xC90] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_5_t LPKN2_5; /*!< [0xC94] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_6_t LPKN2_6; /*!< [0xC98] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_7_t LPKN2_7; /*!< [0xC9C] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_8_t LPKN2_8; /*!< [0xCA0] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_9_t LPKN2_9; /*!< [0xCA4] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_10_t LPKN2_10; /*!< [0xCA8] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_11_t LPKN2_11; /*!< [0xCAC] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_12_t LPKN2_12; /*!< [0xCB0] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_13_t LPKN2_13; /*!< [0xCB4] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_14_t LPKN2_14; /*!< [0xCB8] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn2_15_t LPKN2_15; /*!< [0xCBC] LTC PKHA N2 Register */
    __IO hw_ltc_k80_lpkn3_0_t LPKN3_0; /*!< [0xCC0] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_1_t LPKN3_1; /*!< [0xCC4] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_2_t LPKN3_2; /*!< [0xCC8] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_3_t LPKN3_3; /*!< [0xCCC] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_4_t LPKN3_4; /*!< [0xCD0] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_5_t LPKN3_5; /*!< [0xCD4] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_6_t LPKN3_6; /*!< [0xCD8] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_7_t LPKN3_7; /*!< [0xCDC] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_8_t LPKN3_8; /*!< [0xCE0] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_9_t LPKN3_9; /*!< [0xCE4] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_10_t LPKN3_10; /*!< [0xCE8] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_11_t LPKN3_11; /*!< [0xCEC] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_12_t LPKN3_12; /*!< [0xCF0] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_13_t LPKN3_13; /*!< [0xCF4] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_14_t LPKN3_14; /*!< [0xCF8] LTC PKHA N3 Register */
    __IO hw_ltc_k80_lpkn3_15_t LPKN3_15; /*!< [0xCFC] LTC PKHA N3 Register */
         uint32_t _reserved23[64];
    __O  hw_ltc_k80_lpke_0_t LPKE_0; /*!< [0xE00] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_1_t LPKE_1; /*!< [0xE04] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_2_t LPKE_2; /*!< [0xE08] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_3_t LPKE_3; /*!< [0xE0C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_4_t LPKE_4; /*!< [0xE10] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_5_t LPKE_5; /*!< [0xE14] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_6_t LPKE_6; /*!< [0xE18] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_7_t LPKE_7; /*!< [0xE1C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_8_t LPKE_8; /*!< [0xE20] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_9_t LPKE_9; /*!< [0xE24] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_10_t LPKE_10; /*!< [0xE28] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_11_t LPKE_11; /*!< [0xE2C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_12_t LPKE_12; /*!< [0xE30] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_13_t LPKE_13; /*!< [0xE34] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_14_t LPKE_14; /*!< [0xE38] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_15_t LPKE_15; /*!< [0xE3C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_16_t LPKE_16; /*!< [0xE40] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_17_t LPKE_17; /*!< [0xE44] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_18_t LPKE_18; /*!< [0xE48] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_19_t LPKE_19; /*!< [0xE4C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_20_t LPKE_20; /*!< [0xE50] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_21_t LPKE_21; /*!< [0xE54] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_22_t LPKE_22; /*!< [0xE58] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_23_t LPKE_23; /*!< [0xE5C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_24_t LPKE_24; /*!< [0xE60] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_25_t LPKE_25; /*!< [0xE64] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_26_t LPKE_26; /*!< [0xE68] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_27_t LPKE_27; /*!< [0xE6C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_28_t LPKE_28; /*!< [0xE70] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_29_t LPKE_29; /*!< [0xE74] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_30_t LPKE_30; /*!< [0xE78] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_31_t LPKE_31; /*!< [0xE7C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_32_t LPKE_32; /*!< [0xE80] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_33_t LPKE_33; /*!< [0xE84] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_34_t LPKE_34; /*!< [0xE88] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_35_t LPKE_35; /*!< [0xE8C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_36_t LPKE_36; /*!< [0xE90] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_37_t LPKE_37; /*!< [0xE94] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_38_t LPKE_38; /*!< [0xE98] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_39_t LPKE_39; /*!< [0xE9C] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_40_t LPKE_40; /*!< [0xEA0] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_41_t LPKE_41; /*!< [0xEA4] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_42_t LPKE_42; /*!< [0xEA8] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_43_t LPKE_43; /*!< [0xEAC] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_44_t LPKE_44; /*!< [0xEB0] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_45_t LPKE_45; /*!< [0xEB4] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_46_t LPKE_46; /*!< [0xEB8] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_47_t LPKE_47; /*!< [0xEBC] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_48_t LPKE_48; /*!< [0xEC0] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_49_t LPKE_49; /*!< [0xEC4] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_50_t LPKE_50; /*!< [0xEC8] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_51_t LPKE_51; /*!< [0xECC] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_52_t LPKE_52; /*!< [0xED0] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_53_t LPKE_53; /*!< [0xED4] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_54_t LPKE_54; /*!< [0xED8] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_55_t LPKE_55; /*!< [0xEDC] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_56_t LPKE_56; /*!< [0xEE0] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_57_t LPKE_57; /*!< [0xEE4] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_58_t LPKE_58; /*!< [0xEE8] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_59_t LPKE_59; /*!< [0xEEC] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_60_t LPKE_60; /*!< [0xEF0] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_61_t LPKE_61; /*!< [0xEF4] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_62_t LPKE_62; /*!< [0xEF8] LTC PKHA E Register */
    __O  hw_ltc_k80_lpke_63_t LPKE_63; /*!< [0xEFC] LTC PKHA E Register */
} hw_ltc_k80_t;
#pragma pack()


/*! @brief Macro to access all LTC_K80 registers. */
/*! @param x LTC_K80 module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_LTC_K80(LTC_K800_BASE)</code>. */
#define HW_LTC_K80(x)      (*(hw_ltc_k80_t *)(x))

#endif /* __HW_LTC_K80_REGISTERS_H__ */
/* v29/140618/1.3 */
/* EOF */
