/*
** ###################################################################
**     Compilers:           ARM Compiler
**                          Freescale C/C++ for Embedded ARM
**                          GNU C Compiler
**                          IAR ANSI C/C++ Compiler for ARM
**
**     Reference manual:    xxx
**     Version:             rev. 1.0, 2014-05-26
**     Build:               b140528
**
**     Abstract:
**         Extension to the CMSIS register access layer header.
**
**     Copyright (c) 2014 Freescale Semiconductor, Inc.
**     All rights reserved.
**
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
**     http:                 www.freescale.com
**     mail:                 support@freescale.com
**
**     Revisions:
**     - rev. 1.0 (2014-05-26)
**
** ###################################################################
*/

/*
 * WARNING! DO NOT EDIT THIS FILE DIRECTLY!
 *
 * This file was generated automatically and any changes may be lost.
 */
#ifndef __HW_SIM_REGISTERS_H__
#define __HW_SIM_REGISTERS_H__

#include "MK80F256.h"
#include "fsl_bitaccess.h"

/*
 * MK80F256 SIM
 *
 * System Integration Module
 *
 * Registers defined in this header file:
 * - HW_SIM_SOPT1 - System Options Register 1
 * - HW_SIM_SOPT1CFG - SOPT1 Configuration Register
 * - HW_SIM_SOPT2 - System Options Register 2
 * - HW_SIM_SOPT3 - System Options Register 3
 * - HW_SIM_SOPT4 - System Options Register 4
 * - HW_SIM_SOPT5 - System Options Register 5
 * - HW_SIM_SOPT7 - System Options Register 7
 * - HW_SIM_SOPT8 - System Options Register 8
 * - HW_SIM_SOPT9 - System Options Register 9
 * - HW_SIM_SDID - System Device Identification Register
 * - HW_SIM_SCGC1 - System Clock Gating Control Register 1
 * - HW_SIM_SCGC2 - System Clock Gating Control Register 2
 * - HW_SIM_SCGC3 - System Clock Gating Control Register 3
 * - HW_SIM_SCGC4 - System Clock Gating Control Register 4
 * - HW_SIM_SCGC5 - System Clock Gating Control Register 5
 * - HW_SIM_SCGC6 - System Clock Gating Control Register 6
 * - HW_SIM_SCGC7 - System Clock Gating Control Register 7
 * - HW_SIM_CLKDIV1 - System Clock Divider Register 1
 * - HW_SIM_CLKDIV2 - System Clock Divider Register 2
 * - HW_SIM_FCFG1 - Flash Configuration Register 1
 * - HW_SIM_FCFG2 - Flash Configuration Register 2
 * - HW_SIM_UIDH - Unique Identification Register High
 * - HW_SIM_UIDMH - Unique Identification Register Mid-High
 * - HW_SIM_UIDML - Unique Identification Register Mid Low
 * - HW_SIM_UIDL - Unique Identification Register Low
 * - HW_SIM_CLKDIV3 - System Clock Divider Register 3
 * - HW_SIM_CLKDIV4 - System Clock Divider Register 4
 * - HW_SIM_SECKEY0 - Secure Key Register 0
 * - HW_SIM_SECKEY1 - Secure Key Register 1
 * - HW_SIM_SECKEY2 - Secure Key Register 2
 * - HW_SIM_SECKEY3 - Secure Key Register 3
 *
 * - hw_sim_t - Struct containing all module registers.
 */

#define HW_SIM_INSTANCE_COUNT (1U) /*!< Number of instances of the SIM module. */

/*******************************************************************************
 * HW_SIM_SOPT1 - System Options Register 1
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT1 - System Options Register 1 (RW)
 *
 * Reset value: 0x8000F03FU
 *
 * The SOPT1 register is only reset on POR or LVD.
 */
typedef union _hw_sim_sopt1
{
    uint32_t U;
    struct _hw_sim_sopt1_bitfields
    {
        uint32_t RESERVED0 : 12; /*!< [11:0] Reserved. */
        uint32_t RAMSIZE : 4; /*!< [15:12] RAM size */
        uint32_t RESERVED1 : 2; /*!< [17:16]  */
        uint32_t OSC32KSEL : 2; /*!< [19:18] 32K oscillator clock select */
        uint32_t RESERVED2 : 9; /*!< [28:20]  */
        uint32_t USBVSTBY : 1; /*!< [29] USB voltage regulator in standby mode during VLPR and VLPW modes */
        uint32_t USBSSTBY : 1; /*!< [30] USB voltage regulator in standby mode during Stop, VLPS, LLS and VLLS modes. */
        uint32_t USBREGEN : 1; /*!< [31] USB voltage regulator enable */
    } B;
} hw_sim_sopt1_t;

/*!
 * @name Constants and macros for entire SIM_SOPT1 register
 */
/*@{*/
#define HW_SIM_SOPT1_ADDR(x)        ((x) + 0x0U)
#define HW_SIM_SOPT1(x)             (*(__IO hw_sim_sopt1_t *) HW_SIM_SOPT1_ADDR(x))
#define HW_SIM_SOPT1_RD(x)          (HW_SIM_SOPT1(x).U)
#define HW_SIM_SOPT1_WR(x, v)       (HW_SIM_SOPT1(x).U = (v))
#define HW_SIM_SOPT1_SET(x, v)      (HW_SIM_SOPT1_WR(x, HW_SIM_SOPT1_RD(x) |  (v)))
#define HW_SIM_SOPT1_CLR(x, v)      (HW_SIM_SOPT1_WR(x, HW_SIM_SOPT1_RD(x) & ~(v)))
#define HW_SIM_SOPT1_TOG(x, v)      (HW_SIM_SOPT1_WR(x, HW_SIM_SOPT1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT1 bitfields
 */

/*!
 * @name Register SIM_SOPT1, field RAMSIZE[15:12] (RO)
 *
 * This field specifies the amount of system RAM available on the device.
 *
 * Values:
 * - 0001 - 8 KB
 * - 0011 - 16 KB
 * - 0100 - 24 KB
 * - 0101 - 32 KB
 * - 0110 - 48 KB
 * - 0111 - 64 KB
 * - 1000 - 96 KB
 * - 1001 - 128 KB
 * - 1011 - 256 KB
 */
/*@{*/
#define BP_SIM_SOPT1_RAMSIZE         (12U)      /*!< Bit position for SIM_SOPT1_RAMSIZE. */
#define BM_SIM_SOPT1_RAMSIZE         (0x0000F000U)  /*!< Bit mask for SIM_SOPT1_RAMSIZE. */
#define BS_SIM_SOPT1_RAMSIZE         (4U)  /*!< Bitfield size in bits for SIM_SOPT1_RAMSIZE. */

/*! @brief Read current value of the SIM_SOPT1_RAMSIZE field. */
#define BR_SIM_SOPT1_RAMSIZE(x)   (HW_SIM_SOPT1(x).B.RAMSIZE)
/*@}*/

/*!
 * @name Register SIM_SOPT1, field OSC32KSEL[19:18] (RW)
 *
 * Selects the 32 kHz clock source (ERCLK32K) for TSI,and LPTMR. This field is reset only on
 * POR/LVD.
 *
 * Values:
 * - 00 - System oscillator (OSC32KCLK)
 * - 01 - Reserved
 * - 10 - RTC 32.768kHz oscillator
 * - 11 - LPO 1 kHz
 */
/*@{*/
#define BP_SIM_SOPT1_OSC32KSEL         (18U)      /*!< Bit position for SIM_SOPT1_OSC32KSEL. */
#define BM_SIM_SOPT1_OSC32KSEL         (0x000C0000U)  /*!< Bit mask for SIM_SOPT1_OSC32KSEL. */
#define BS_SIM_SOPT1_OSC32KSEL         (2U)  /*!< Bitfield size in bits for SIM_SOPT1_OSC32KSEL. */

/*! @brief Read current value of the SIM_SOPT1_OSC32KSEL field. */
#define BR_SIM_SOPT1_OSC32KSEL(x)   (HW_SIM_SOPT1(x).B.OSC32KSEL)

/*! @brief Format value for bitfield SIM_SOPT1_OSC32KSEL. */
#define BF_SIM_SOPT1_OSC32KSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT1_OSC32KSEL) & BM_SIM_SOPT1_OSC32KSEL)

/*! @brief Set the OSC32KSEL field to a new value. */
#define BW_SIM_SOPT1_OSC32KSEL(x, v)   (HW_SIM_SOPT1_WR(x, (HW_SIM_SOPT1_RD(x) & ~BM_SIM_SOPT1_OSC32KSEL) | BF_SIM_SOPT1_OSC32KSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT1, field USBVSTBY[29] (RW)
 *
 * Controls whether the USB voltage regulator is placed in standby mode during VLPR and VLPW modes.
 *
 * Values:
 * - 0 - USB voltage regulator not in standby during VLPR and VLPW modes.
 * - 1 - USB voltage regulator in standby during VLPR and VLPW modes.
 */
/*@{*/
#define BP_SIM_SOPT1_USBVSTBY         (29U)      /*!< Bit position for SIM_SOPT1_USBVSTBY. */
#define BM_SIM_SOPT1_USBVSTBY         (0x20000000U)  /*!< Bit mask for SIM_SOPT1_USBVSTBY. */
#define BS_SIM_SOPT1_USBVSTBY         (1U)  /*!< Bitfield size in bits for SIM_SOPT1_USBVSTBY. */

/*! @brief Read current value of the SIM_SOPT1_USBVSTBY field. */
#define BR_SIM_SOPT1_USBVSTBY(x)   (HW_SIM_SOPT1(x).B.USBVSTBY)

/*! @brief Format value for bitfield SIM_SOPT1_USBVSTBY. */
#define BF_SIM_SOPT1_USBVSTBY(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT1_USBVSTBY) & BM_SIM_SOPT1_USBVSTBY)

/*! @brief Set the USBVSTBY field to a new value. */
#define BW_SIM_SOPT1_USBVSTBY(x, v)   (HW_SIM_SOPT1_WR(x, (HW_SIM_SOPT1_RD(x) & ~BM_SIM_SOPT1_USBVSTBY) | BF_SIM_SOPT1_USBVSTBY(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT1, field USBSSTBY[30] (RW)
 *
 * Controls whether the USB voltage regulator is placed in standby mode during Stop, VLPS, LLS and
 * VLLS modes.
 *
 * Values:
 * - 0 - USB voltage regulator not in standby during Stop, VLPS, LLS and VLLS modes.
 * - 1 - USB voltage regulator in standby during Stop, VLPS, LLS and VLLS modes.
 */
/*@{*/
#define BP_SIM_SOPT1_USBSSTBY         (30U)      /*!< Bit position for SIM_SOPT1_USBSSTBY. */
#define BM_SIM_SOPT1_USBSSTBY         (0x40000000U)  /*!< Bit mask for SIM_SOPT1_USBSSTBY. */
#define BS_SIM_SOPT1_USBSSTBY         (1U)  /*!< Bitfield size in bits for SIM_SOPT1_USBSSTBY. */

/*! @brief Read current value of the SIM_SOPT1_USBSSTBY field. */
#define BR_SIM_SOPT1_USBSSTBY(x)   (HW_SIM_SOPT1(x).B.USBSSTBY)

/*! @brief Format value for bitfield SIM_SOPT1_USBSSTBY. */
#define BF_SIM_SOPT1_USBSSTBY(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT1_USBSSTBY) & BM_SIM_SOPT1_USBSSTBY)

/*! @brief Set the USBSSTBY field to a new value. */
#define BW_SIM_SOPT1_USBSSTBY(x, v)   (HW_SIM_SOPT1_WR(x, (HW_SIM_SOPT1_RD(x) & ~BM_SIM_SOPT1_USBSSTBY) | BF_SIM_SOPT1_USBSSTBY(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT1, field USBREGEN[31] (RW)
 *
 * Controls whether the USB voltage regulator is enabled.
 *
 * Values:
 * - 0 - USB voltage regulator is disabled.
 * - 1 - USB voltage regulator is enabled.
 */
/*@{*/
#define BP_SIM_SOPT1_USBREGEN         (31U)      /*!< Bit position for SIM_SOPT1_USBREGEN. */
#define BM_SIM_SOPT1_USBREGEN         (0x80000000U)  /*!< Bit mask for SIM_SOPT1_USBREGEN. */
#define BS_SIM_SOPT1_USBREGEN         (1U)  /*!< Bitfield size in bits for SIM_SOPT1_USBREGEN. */

/*! @brief Read current value of the SIM_SOPT1_USBREGEN field. */
#define BR_SIM_SOPT1_USBREGEN(x)   (HW_SIM_SOPT1(x).B.USBREGEN)

/*! @brief Format value for bitfield SIM_SOPT1_USBREGEN. */
#define BF_SIM_SOPT1_USBREGEN(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT1_USBREGEN) & BM_SIM_SOPT1_USBREGEN)

/*! @brief Set the USBREGEN field to a new value. */
#define BW_SIM_SOPT1_USBREGEN(x, v)   (HW_SIM_SOPT1_WR(x, (HW_SIM_SOPT1_RD(x) & ~BM_SIM_SOPT1_USBREGEN) | BF_SIM_SOPT1_USBREGEN(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SOPT1CFG - SOPT1 Configuration Register
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT1CFG - SOPT1 Configuration Register (RW)
 *
 * Reset value: 0x00000000U
 *
 * The SOPT1CFG register is reset on System Reset not VLLS.
 */
typedef union _hw_sim_sopt1cfg
{
    uint32_t U;
    struct _hw_sim_sopt1cfg_bitfields
    {
        uint32_t RESERVED1 : 24; /*!< [23:0] Reserved. */
        uint32_t URWE : 1; /*!< [24] USB voltage regulator enable write enable */
        uint32_t UVSWE : 1; /*!< [25] USB voltage regulator VLP standby write enable */
        uint32_t USSWE : 1; /*!< [26] USB voltage regulator stop standby write enable */
        uint32_t RESERVED2 : 5; /*!< [31:27]  */
    } B;
} hw_sim_sopt1cfg_t;

/*!
 * @name Constants and macros for entire SIM_SOPT1CFG register
 */
/*@{*/
#define HW_SIM_SOPT1CFG_ADDR(x)        ((x) + 0x4U)
#define HW_SIM_SOPT1CFG(x)             (*(__IO hw_sim_sopt1cfg_t *) HW_SIM_SOPT1CFG_ADDR(x))
#define HW_SIM_SOPT1CFG_RD(x)          (HW_SIM_SOPT1CFG(x).U)
#define HW_SIM_SOPT1CFG_WR(x, v)       (HW_SIM_SOPT1CFG(x).U = (v))
#define HW_SIM_SOPT1CFG_SET(x, v)      (HW_SIM_SOPT1CFG_WR(x, HW_SIM_SOPT1CFG_RD(x) |  (v)))
#define HW_SIM_SOPT1CFG_CLR(x, v)      (HW_SIM_SOPT1CFG_WR(x, HW_SIM_SOPT1CFG_RD(x) & ~(v)))
#define HW_SIM_SOPT1CFG_TOG(x, v)      (HW_SIM_SOPT1CFG_WR(x, HW_SIM_SOPT1CFG_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT1CFG bitfields
 */

/*!
 * @name Register SIM_SOPT1CFG, field URWE[24] (RW)
 *
 * Writing one to the URWE bit allows the SOPT1 USBREGEN bit to be written. This register bit clears
 * after a write to USBREGEN.
 *
 * Values:
 * - 0 - SOPT1 USBREGEN cannot be written.
 * - 1 - SOPT1 USBREGEN can be written.
 */
/*@{*/
#define BP_SIM_SOPT1CFG_URWE         (24U)      /*!< Bit position for SIM_SOPT1CFG_URWE. */
#define BM_SIM_SOPT1CFG_URWE         (0x01000000U)  /*!< Bit mask for SIM_SOPT1CFG_URWE. */
#define BS_SIM_SOPT1CFG_URWE         (1U)  /*!< Bitfield size in bits for SIM_SOPT1CFG_URWE. */

/*! @brief Read current value of the SIM_SOPT1CFG_URWE field. */
#define BR_SIM_SOPT1CFG_URWE(x)   (HW_SIM_SOPT1CFG(x).B.URWE)

/*! @brief Format value for bitfield SIM_SOPT1CFG_URWE. */
#define BF_SIM_SOPT1CFG_URWE(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT1CFG_URWE) & BM_SIM_SOPT1CFG_URWE)

/*! @brief Set the URWE field to a new value. */
#define BW_SIM_SOPT1CFG_URWE(x, v)   (HW_SIM_SOPT1CFG_WR(x, (HW_SIM_SOPT1CFG_RD(x) & ~BM_SIM_SOPT1CFG_URWE) | BF_SIM_SOPT1CFG_URWE(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT1CFG, field UVSWE[25] (RW)
 *
 * Writing one to the UVSWE bit allows the SOPT1 USBVSTBY bit to be written. This register bit
 * clears after a write to USBVSTBY.
 *
 * Values:
 * - 0 - SOPT1 USBVSTBY cannot be written.
 * - 1 - SOPT1 USBVSTBY can be written.
 */
/*@{*/
#define BP_SIM_SOPT1CFG_UVSWE         (25U)      /*!< Bit position for SIM_SOPT1CFG_UVSWE. */
#define BM_SIM_SOPT1CFG_UVSWE         (0x02000000U)  /*!< Bit mask for SIM_SOPT1CFG_UVSWE. */
#define BS_SIM_SOPT1CFG_UVSWE         (1U)  /*!< Bitfield size in bits for SIM_SOPT1CFG_UVSWE. */

/*! @brief Read current value of the SIM_SOPT1CFG_UVSWE field. */
#define BR_SIM_SOPT1CFG_UVSWE(x)   (HW_SIM_SOPT1CFG(x).B.UVSWE)

/*! @brief Format value for bitfield SIM_SOPT1CFG_UVSWE. */
#define BF_SIM_SOPT1CFG_UVSWE(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT1CFG_UVSWE) & BM_SIM_SOPT1CFG_UVSWE)

/*! @brief Set the UVSWE field to a new value. */
#define BW_SIM_SOPT1CFG_UVSWE(x, v)   (HW_SIM_SOPT1CFG_WR(x, (HW_SIM_SOPT1CFG_RD(x) & ~BM_SIM_SOPT1CFG_UVSWE) | BF_SIM_SOPT1CFG_UVSWE(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT1CFG, field USSWE[26] (RW)
 *
 * Writing one to the USSWE bit allows the SOPT1 USBSSTBY bit to be written. This register bit
 * clears after a write to USBSSTBY.
 *
 * Values:
 * - 0 - SOPT1 USBSSTBY cannot be written.
 * - 1 - SOPT1 USBSSTBY can be written.
 */
/*@{*/
#define BP_SIM_SOPT1CFG_USSWE         (26U)      /*!< Bit position for SIM_SOPT1CFG_USSWE. */
#define BM_SIM_SOPT1CFG_USSWE         (0x04000000U)  /*!< Bit mask for SIM_SOPT1CFG_USSWE. */
#define BS_SIM_SOPT1CFG_USSWE         (1U)  /*!< Bitfield size in bits for SIM_SOPT1CFG_USSWE. */

/*! @brief Read current value of the SIM_SOPT1CFG_USSWE field. */
#define BR_SIM_SOPT1CFG_USSWE(x)   (HW_SIM_SOPT1CFG(x).B.USSWE)

/*! @brief Format value for bitfield SIM_SOPT1CFG_USSWE. */
#define BF_SIM_SOPT1CFG_USSWE(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT1CFG_USSWE) & BM_SIM_SOPT1CFG_USSWE)

/*! @brief Set the USSWE field to a new value. */
#define BW_SIM_SOPT1CFG_USSWE(x, v)   (HW_SIM_SOPT1CFG_WR(x, (HW_SIM_SOPT1CFG_RD(x) & ~BM_SIM_SOPT1CFG_USSWE) | BF_SIM_SOPT1CFG_USSWE(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SOPT2 - System Options Register 2
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT2 - System Options Register 2 (RW)
 *
 * Reset value: 0x00001000U
 *
 * SOPT2 contains the controls for selecting many of the module clock source options on this device.
 * See the Clock Distribution chapter for more information including clocking diagrams and
 * definitions of device clocks.
 */
typedef union _hw_sim_sopt2
{
    uint32_t U;
    struct _hw_sim_sopt2_bitfields
    {
        uint32_t RESERVED0 : 4; /*!< [3:0]  */
        uint32_t RTCCLKOUTSEL : 1; /*!< [4] RTC clock out select */
        uint32_t CLKOUTSEL : 3; /*!< [7:5] CLKOUT select */
        uint32_t FBSL : 2; /*!< [9:8] FlexBus security level */
        uint32_t RESERVED1 : 2; /*!< [11:10] Reserved. */
        uint32_t TRACECLKSEL : 1; /*!< [12] Debug trace clock select */
        uint32_t RESERVED2 : 3; /*!< [15:13]  */
        uint32_t PLLFLLSEL : 2; /*!< [17:16] PLL/FLL clock select */
        uint32_t USBSRC : 1; /*!< [18] USB clock source select */
        uint32_t RESERVED3 : 3; /*!< [21:19]  */
        uint32_t FLEXIOSRC : 2; /*!< [23:22] FlexIO Module Clock Source Select */
        uint32_t TPMSRC : 2; /*!< [25:24] TPM clock source select */
        uint32_t LPUARTSRC : 2; /*!< [27:26] LPUART clock source select */
        uint32_t SDHCSRC : 2; /*!< [29:28] SDHC clock source select */
        uint32_t EMVSIMSRC : 2; /*!< [31:30] EMVSIM Module Clock Source Select */
    } B;
} hw_sim_sopt2_t;

/*!
 * @name Constants and macros for entire SIM_SOPT2 register
 */
/*@{*/
#define HW_SIM_SOPT2_ADDR(x)        ((x) + 0x1004U)
#define HW_SIM_SOPT2(x)             (*(__IO hw_sim_sopt2_t *) HW_SIM_SOPT2_ADDR(x))
#define HW_SIM_SOPT2_RD(x)          (HW_SIM_SOPT2(x).U)
#define HW_SIM_SOPT2_WR(x, v)       (HW_SIM_SOPT2(x).U = (v))
#define HW_SIM_SOPT2_SET(x, v)      (HW_SIM_SOPT2_WR(x, HW_SIM_SOPT2_RD(x) |  (v)))
#define HW_SIM_SOPT2_CLR(x, v)      (HW_SIM_SOPT2_WR(x, HW_SIM_SOPT2_RD(x) & ~(v)))
#define HW_SIM_SOPT2_TOG(x, v)      (HW_SIM_SOPT2_WR(x, HW_SIM_SOPT2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT2 bitfields
 */

/*!
 * @name Register SIM_SOPT2, field RTCCLKOUTSEL[4] (RW)
 *
 * Selects either the RTC 1 Hz clock or the 32.768kHz clock to be output on the RTC_CLKOUT pin.
 *
 * Values:
 * - 0 - RTC 1 Hz clock is output on the RTC_CLKOUT pin.
 * - 1 - RTC 32.768kHz clock is output on the RTC_CLKOUT pin.
 */
/*@{*/
#define BP_SIM_SOPT2_RTCCLKOUTSEL         (4U)      /*!< Bit position for SIM_SOPT2_RTCCLKOUTSEL. */
#define BM_SIM_SOPT2_RTCCLKOUTSEL         (0x00000010U)  /*!< Bit mask for SIM_SOPT2_RTCCLKOUTSEL. */
#define BS_SIM_SOPT2_RTCCLKOUTSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT2_RTCCLKOUTSEL. */

/*! @brief Read current value of the SIM_SOPT2_RTCCLKOUTSEL field. */
#define BR_SIM_SOPT2_RTCCLKOUTSEL(x)   (HW_SIM_SOPT2(x).B.RTCCLKOUTSEL)

/*! @brief Format value for bitfield SIM_SOPT2_RTCCLKOUTSEL. */
#define BF_SIM_SOPT2_RTCCLKOUTSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_RTCCLKOUTSEL) & BM_SIM_SOPT2_RTCCLKOUTSEL)

/*! @brief Set the RTCCLKOUTSEL field to a new value. */
#define BW_SIM_SOPT2_RTCCLKOUTSEL(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_RTCCLKOUTSEL) | BF_SIM_SOPT2_RTCCLKOUTSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field CLKOUTSEL[7:5] (RW)
 *
 * Selects the clock to output on the CLKOUT pin.
 *
 * Values:
 * - 000 - FlexBus CLKOUT
 * - 001 - Reserved
 * - 010 - Flash clock
 * - 011 - LPO clock (1 kHz)
 * - 100 - MCGIRCLK
 * - 101 - RTC 32.768kHz clock
 * - 110 - OSCERCLK0
 * - 111 - IRC 48 MHz clock
 */
/*@{*/
#define BP_SIM_SOPT2_CLKOUTSEL         (5U)      /*!< Bit position for SIM_SOPT2_CLKOUTSEL. */
#define BM_SIM_SOPT2_CLKOUTSEL         (0x000000E0U)  /*!< Bit mask for SIM_SOPT2_CLKOUTSEL. */
#define BS_SIM_SOPT2_CLKOUTSEL         (3U)  /*!< Bitfield size in bits for SIM_SOPT2_CLKOUTSEL. */

/*! @brief Read current value of the SIM_SOPT2_CLKOUTSEL field. */
#define BR_SIM_SOPT2_CLKOUTSEL(x)   (HW_SIM_SOPT2(x).B.CLKOUTSEL)

/*! @brief Format value for bitfield SIM_SOPT2_CLKOUTSEL. */
#define BF_SIM_SOPT2_CLKOUTSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_CLKOUTSEL) & BM_SIM_SOPT2_CLKOUTSEL)

/*! @brief Set the CLKOUTSEL field to a new value. */
#define BW_SIM_SOPT2_CLKOUTSEL(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_CLKOUTSEL) | BF_SIM_SOPT2_CLKOUTSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field FBSL[9:8] (RW)
 *
 * If flash security is enabled, then this field affects what CPU operations can access off-chip via
 * the FlexBus or SDRAMinterface. This field has no effect if flash security is not enabled.
 *
 * Values:
 * - 00 - All off-chip accesses (instruction and data) via the FlexBus or SDRAM are disallowed.
 * - 01 - All off-chip accesses (instruction and data) via the FlexBus or SDRAM are disallowed.
 * - 10 - Off-chip instruction accesses are disallowed. Data accesses are allowed.
 * - 11 - Off-chip instruction accesses and data accesses are allowed.
 */
/*@{*/
#define BP_SIM_SOPT2_FBSL         (8U)      /*!< Bit position for SIM_SOPT2_FBSL. */
#define BM_SIM_SOPT2_FBSL         (0x00000300U)  /*!< Bit mask for SIM_SOPT2_FBSL. */
#define BS_SIM_SOPT2_FBSL         (2U)  /*!< Bitfield size in bits for SIM_SOPT2_FBSL. */

/*! @brief Read current value of the SIM_SOPT2_FBSL field. */
#define BR_SIM_SOPT2_FBSL(x)   (HW_SIM_SOPT2(x).B.FBSL)

/*! @brief Format value for bitfield SIM_SOPT2_FBSL. */
#define BF_SIM_SOPT2_FBSL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_FBSL) & BM_SIM_SOPT2_FBSL)

/*! @brief Set the FBSL field to a new value. */
#define BW_SIM_SOPT2_FBSL(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_FBSL) | BF_SIM_SOPT2_FBSL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field TRACECLKSEL[12] (RW)
 *
 * Selects the core/system clock, or MCG output clock (MCGOUTCLK) divided by the TRACECLK fractional
 * divider as configured by SIM_CLKDIV4[TRACEFRAC, TRACEDIV] as the trace clock source.
 *
 * Values:
 * - 0 - MCGOUTCLK, divided by the TRACECLK fractional divider as configured by SIM_CLKDIV4[TRACEFRAC,
 *     TRACEDIV]
 * - 1 - Core/system clock
 */
/*@{*/
#define BP_SIM_SOPT2_TRACECLKSEL         (12U)      /*!< Bit position for SIM_SOPT2_TRACECLKSEL. */
#define BM_SIM_SOPT2_TRACECLKSEL         (0x00001000U)  /*!< Bit mask for SIM_SOPT2_TRACECLKSEL. */
#define BS_SIM_SOPT2_TRACECLKSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT2_TRACECLKSEL. */

/*! @brief Read current value of the SIM_SOPT2_TRACECLKSEL field. */
#define BR_SIM_SOPT2_TRACECLKSEL(x)   (HW_SIM_SOPT2(x).B.TRACECLKSEL)

/*! @brief Format value for bitfield SIM_SOPT2_TRACECLKSEL. */
#define BF_SIM_SOPT2_TRACECLKSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_TRACECLKSEL) & BM_SIM_SOPT2_TRACECLKSEL)

/*! @brief Set the TRACECLKSEL field to a new value. */
#define BW_SIM_SOPT2_TRACECLKSEL(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_TRACECLKSEL) | BF_SIM_SOPT2_TRACECLKSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field PLLFLLSEL[17:16] (RW)
 *
 * Selects the high frequency clock for various peripheral clocking options.
 *
 * Values:
 * - 00 - MCGFLLCLK clock
 * - 01 - MCGPLLCLK clock
 * - 10 - Reserved
 * - 11 - IRC48 MHz clock
 */
/*@{*/
#define BP_SIM_SOPT2_PLLFLLSEL         (16U)      /*!< Bit position for SIM_SOPT2_PLLFLLSEL. */
#define BM_SIM_SOPT2_PLLFLLSEL         (0x00030000U)  /*!< Bit mask for SIM_SOPT2_PLLFLLSEL. */
#define BS_SIM_SOPT2_PLLFLLSEL         (2U)  /*!< Bitfield size in bits for SIM_SOPT2_PLLFLLSEL. */

/*! @brief Read current value of the SIM_SOPT2_PLLFLLSEL field. */
#define BR_SIM_SOPT2_PLLFLLSEL(x)   (HW_SIM_SOPT2(x).B.PLLFLLSEL)

/*! @brief Format value for bitfield SIM_SOPT2_PLLFLLSEL. */
#define BF_SIM_SOPT2_PLLFLLSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_PLLFLLSEL) & BM_SIM_SOPT2_PLLFLLSEL)

/*! @brief Set the PLLFLLSEL field to a new value. */
#define BW_SIM_SOPT2_PLLFLLSEL(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_PLLFLLSEL) | BF_SIM_SOPT2_PLLFLLSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field USBSRC[18] (RW)
 *
 * Selects the clock source for the USB 48 MHz clock.
 *
 * Values:
 * - 0 - External bypass clock (USB_CLKIN).
 * - 1 - MCGFLLCLK, or MCGPLLCLK, or IRC48M clock as selected by SOPT2[PLLFLLSEL], and then divided by the
 *     USB fractional divider as configured by SIM_CLKDIV2[USBFRAC, USBDIV].
 */
/*@{*/
#define BP_SIM_SOPT2_USBSRC         (18U)      /*!< Bit position for SIM_SOPT2_USBSRC. */
#define BM_SIM_SOPT2_USBSRC         (0x00040000U)  /*!< Bit mask for SIM_SOPT2_USBSRC. */
#define BS_SIM_SOPT2_USBSRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT2_USBSRC. */

/*! @brief Read current value of the SIM_SOPT2_USBSRC field. */
#define BR_SIM_SOPT2_USBSRC(x)   (HW_SIM_SOPT2(x).B.USBSRC)

/*! @brief Format value for bitfield SIM_SOPT2_USBSRC. */
#define BF_SIM_SOPT2_USBSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_USBSRC) & BM_SIM_SOPT2_USBSRC)

/*! @brief Set the USBSRC field to a new value. */
#define BW_SIM_SOPT2_USBSRC(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_USBSRC) | BF_SIM_SOPT2_USBSRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field FLEXIOSRC[23:22] (RW)
 *
 * Selects the clock source for the FlexIO transmit and receive clock.
 *
 * Values:
 * - 00 - Clock disabled
 * - 01 - MCGFLLCLK , or MCGPLLCLK, or IRC48M clock as selected by SOPT2[PLLFLLSEL], and then divided by the
 *     PLLFLLCLK fractional divider as configured by SIM_CLKDIV3[PLLFLLFRAC, PLLFLLDIV].
 * - 10 - OSCERCLK clock
 * - 11 - MCGIRCLK clock
 */
/*@{*/
#define BP_SIM_SOPT2_FLEXIOSRC         (22U)      /*!< Bit position for SIM_SOPT2_FLEXIOSRC. */
#define BM_SIM_SOPT2_FLEXIOSRC         (0x00C00000U)  /*!< Bit mask for SIM_SOPT2_FLEXIOSRC. */
#define BS_SIM_SOPT2_FLEXIOSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT2_FLEXIOSRC. */

/*! @brief Read current value of the SIM_SOPT2_FLEXIOSRC field. */
#define BR_SIM_SOPT2_FLEXIOSRC(x)   (HW_SIM_SOPT2(x).B.FLEXIOSRC)

/*! @brief Format value for bitfield SIM_SOPT2_FLEXIOSRC. */
#define BF_SIM_SOPT2_FLEXIOSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_FLEXIOSRC) & BM_SIM_SOPT2_FLEXIOSRC)

/*! @brief Set the FLEXIOSRC field to a new value. */
#define BW_SIM_SOPT2_FLEXIOSRC(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_FLEXIOSRC) | BF_SIM_SOPT2_FLEXIOSRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field TPMSRC[25:24] (RW)
 *
 * Selects the clock source for the TPM counter clock
 *
 * Values:
 * - 00 - Clock disabled
 * - 01 - MCGFLLCLK , or MCGPLLCLK, or IRC48M clock as selected by SOPT2[PLLFLLSEL], and then divided by the
 *     PLLFLLCLK fractional divider as configured by SIM_CLKDIV3[PLLFLLFRAC, PLLFLLDIV].
 * - 10 - OSCERCLK clock
 * - 11 - MCGIRCLK clock
 */
/*@{*/
#define BP_SIM_SOPT2_TPMSRC         (24U)      /*!< Bit position for SIM_SOPT2_TPMSRC. */
#define BM_SIM_SOPT2_TPMSRC         (0x03000000U)  /*!< Bit mask for SIM_SOPT2_TPMSRC. */
#define BS_SIM_SOPT2_TPMSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT2_TPMSRC. */

/*! @brief Read current value of the SIM_SOPT2_TPMSRC field. */
#define BR_SIM_SOPT2_TPMSRC(x)   (HW_SIM_SOPT2(x).B.TPMSRC)

/*! @brief Format value for bitfield SIM_SOPT2_TPMSRC. */
#define BF_SIM_SOPT2_TPMSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_TPMSRC) & BM_SIM_SOPT2_TPMSRC)

/*! @brief Set the TPMSRC field to a new value. */
#define BW_SIM_SOPT2_TPMSRC(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_TPMSRC) | BF_SIM_SOPT2_TPMSRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field LPUARTSRC[27:26] (RW)
 *
 * Selects the clock source for the LPUART transmit and receive clock.
 *
 * Values:
 * - 00 - Clock disabled
 * - 01 - MCGFLLCLK , or MCGPLLCLK, or IRC48M clock as selected by SOPT2[PLLFLLSEL], and then divided by the
 *     PLLFLLCLK fractional divider as configured by SIM_CLKDIV3[PLLFLLFRAC, PLLFLLDIV].
 * - 10 - OSCERCLK clock
 * - 11 - MCGIRCLK clock
 */
/*@{*/
#define BP_SIM_SOPT2_LPUARTSRC         (26U)      /*!< Bit position for SIM_SOPT2_LPUARTSRC. */
#define BM_SIM_SOPT2_LPUARTSRC         (0x0C000000U)  /*!< Bit mask for SIM_SOPT2_LPUARTSRC. */
#define BS_SIM_SOPT2_LPUARTSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT2_LPUARTSRC. */

/*! @brief Read current value of the SIM_SOPT2_LPUARTSRC field. */
#define BR_SIM_SOPT2_LPUARTSRC(x)   (HW_SIM_SOPT2(x).B.LPUARTSRC)

/*! @brief Format value for bitfield SIM_SOPT2_LPUARTSRC. */
#define BF_SIM_SOPT2_LPUARTSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_LPUARTSRC) & BM_SIM_SOPT2_LPUARTSRC)

/*! @brief Set the LPUARTSRC field to a new value. */
#define BW_SIM_SOPT2_LPUARTSRC(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_LPUARTSRC) | BF_SIM_SOPT2_LPUARTSRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field SDHCSRC[29:28] (RW)
 *
 * Selects the clock source for the SDHC clock .
 *
 * Values:
 * - 00 - Core/system clock.
 * - 01 - MCGFLLCLK, or MCGPLLCLK, or IRC48M clock as selected by SOPT2[PLLFLLSEL].
 * - 10 - OSCERCLK clock
 * - 11 - External bypass clock (SDHC0_CLKIN)
 */
/*@{*/
#define BP_SIM_SOPT2_SDHCSRC         (28U)      /*!< Bit position for SIM_SOPT2_SDHCSRC. */
#define BM_SIM_SOPT2_SDHCSRC         (0x30000000U)  /*!< Bit mask for SIM_SOPT2_SDHCSRC. */
#define BS_SIM_SOPT2_SDHCSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT2_SDHCSRC. */

/*! @brief Read current value of the SIM_SOPT2_SDHCSRC field. */
#define BR_SIM_SOPT2_SDHCSRC(x)   (HW_SIM_SOPT2(x).B.SDHCSRC)

/*! @brief Format value for bitfield SIM_SOPT2_SDHCSRC. */
#define BF_SIM_SOPT2_SDHCSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_SDHCSRC) & BM_SIM_SOPT2_SDHCSRC)

/*! @brief Set the SDHCSRC field to a new value. */
#define BW_SIM_SOPT2_SDHCSRC(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_SDHCSRC) | BF_SIM_SOPT2_SDHCSRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT2, field EMVSIMSRC[31:30] (RW)
 *
 * Selects the clock source for the EMVSIM transmit and receive clock.
 *
 * Values:
 * - 00 - Clock disabled
 * - 01 - MCGFLLCLK , or MCGPLLCLK, or IRC48M clock as selected by SOPT2[PLLFLLSEL], and then divided by the
 *     PLLFLLCLK fractional divider as configured by SIM_CLKDIV3[PLLFLLFRAC, PLLFLLDIV].
 * - 10 - OSCERCLK clock
 * - 11 - MCGIRCLK clock
 */
/*@{*/
#define BP_SIM_SOPT2_EMVSIMSRC         (30U)      /*!< Bit position for SIM_SOPT2_EMVSIMSRC. */
#define BM_SIM_SOPT2_EMVSIMSRC         (0xC0000000U)  /*!< Bit mask for SIM_SOPT2_EMVSIMSRC. */
#define BS_SIM_SOPT2_EMVSIMSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT2_EMVSIMSRC. */

/*! @brief Read current value of the SIM_SOPT2_EMVSIMSRC field. */
#define BR_SIM_SOPT2_EMVSIMSRC(x)   (HW_SIM_SOPT2(x).B.EMVSIMSRC)

/*! @brief Format value for bitfield SIM_SOPT2_EMVSIMSRC. */
#define BF_SIM_SOPT2_EMVSIMSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT2_EMVSIMSRC) & BM_SIM_SOPT2_EMVSIMSRC)

/*! @brief Set the EMVSIMSRC field to a new value. */
#define BW_SIM_SOPT2_EMVSIMSRC(x, v)   (HW_SIM_SOPT2_WR(x, (HW_SIM_SOPT2_RD(x) & ~BM_SIM_SOPT2_EMVSIMSRC) | BF_SIM_SOPT2_EMVSIMSRC(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SOPT3 - System Options Register 3
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT3 - System Options Register 3 (RW)
 *
 * Reset value: 0xEEAEADEDDEEEFFAFU
 */
typedef union _hw_sim_sopt3
{
    uint32_t U;
    struct _hw_sim_sopt3_bitfields
    {
        uint32_t BROMSUPV_B : 1; /*!< [0] Boot ROM Supervisor Only */
        uint32_t BROMEXEC_B : 1; /*!< [1] Boot ROM Execute Only */
        uint32_t FTFLLSOPT : 1; /*!< [2] FTF LLS recovery option */
        uint32_t RESERVED0 : 5; /*!< [7:3] Reserved. */
        uint32_t VALDIS : 1; /*!< [8] Self-Time Adjust Disable */
        uint32_t VALRD : 3; /*!< [11:9] Read Timing Control Value */
        uint32_t VALWR : 3; /*!< [14:12] Write Timing Control Value */
        uint32_t BROMEN : 1; /*!< [15] Boot ROM Enable */
        uint32_t FACEN : 1; /*!< [16] Flash Access Control Enable */
        uint32_t ENCDIS : 1; /*!< [17] Encryption disable */
        uint32_t RESERVED1 : 2; /*!< [19:18] Reserved. */
        uint32_t ESDHCDIS : 1; /*!< [20] eSDHC module disable */
        uint32_t RESERVED2 : 2; /*!< [22:21] Reserved. */
        uint32_t USBDIS : 1; /*!< [23] USB module disable */
        uint32_t DRYICEDIS : 1; /*!< [24] DryIce module disable */
        uint32_t RESERVED3 : 1; /*!< [25]  */
        uint32_t RFDIS : 1; /*!< [26] RF SiP Disable */
        uint32_t FPUDIS : 1; /*!< [27] FPU Disable */
        uint32_t RESERVED4 : 1; /*!< [28]  */
        uint32_t QSPIEN : 1; /*!< [29] QSPI Enable */
        uint32_t QSPI_SIPDIS : 1; /*!< [30] QSPI SiP Disable */
        uint32_t RESERVED5 : 1; /*!< [31]  */
    } B;
} hw_sim_sopt3_t;

/*!
 * @name Constants and macros for entire SIM_SOPT3 register
 */
/*@{*/
#define HW_SIM_SOPT3_ADDR(x)        ((x) + 0x1008U)
#define HW_SIM_SOPT3(x)             (*(__IO hw_sim_sopt3_t *) HW_SIM_SOPT3_ADDR(x))
#define HW_SIM_SOPT3_RD(x)          (HW_SIM_SOPT3(x).U)
#define HW_SIM_SOPT3_WR(x, v)       (HW_SIM_SOPT3(x).U = (v))
#define HW_SIM_SOPT3_SET(x, v)      (HW_SIM_SOPT3_WR(x, HW_SIM_SOPT3_RD(x) |  (v)))
#define HW_SIM_SOPT3_CLR(x, v)      (HW_SIM_SOPT3_WR(x, HW_SIM_SOPT3_RD(x) & ~(v)))
#define HW_SIM_SOPT3_TOG(x, v)      (HW_SIM_SOPT3_WR(x, HW_SIM_SOPT3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT3 bitfields
 */

/*!
 * @name Register SIM_SOPT3, field BROMSUPV_B[0] (RW)
 *
 * This bit is used to control access to the Boot ROM. This bit is used for device testing only and
 * is read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - BootROM is supervisor access only.
 * - 1 - BootROM is user/supervisor access.
 */
/*@{*/
#define BP_SIM_SOPT3_BROMSUPV_B         (0U)      /*!< Bit position for SIM_SOPT3_BROMSUPV_B. */
#define BM_SIM_SOPT3_BROMSUPV_B         (0x00000001U)  /*!< Bit mask for SIM_SOPT3_BROMSUPV_B. */
#define BS_SIM_SOPT3_BROMSUPV_B         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_BROMSUPV_B. */

/*! @brief Read current value of the SIM_SOPT3_BROMSUPV_B field. */
#define BR_SIM_SOPT3_BROMSUPV_B(x)   (HW_SIM_SOPT3(x).B.BROMSUPV_B)

/*! @brief Format value for bitfield SIM_SOPT3_BROMSUPV_B. */
#define BF_SIM_SOPT3_BROMSUPV_B(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_BROMSUPV_B) & BM_SIM_SOPT3_BROMSUPV_B)

/*! @brief Set the BROMSUPV_B field to a new value. */
#define BW_SIM_SOPT3_BROMSUPV_B(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_BROMSUPV_B) | BF_SIM_SOPT3_BROMSUPV_B(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field BROMEXEC_B[1] (RW)
 *
 * This bit is used to control access to the Boot ROM. This bit is used for device testing only and
 * is read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - Boot ROM supports execute access only.
 * - 1 - Boot ROM supports execute or read access.
 */
/*@{*/
#define BP_SIM_SOPT3_BROMEXEC_B         (1U)      /*!< Bit position for SIM_SOPT3_BROMEXEC_B. */
#define BM_SIM_SOPT3_BROMEXEC_B         (0x00000002U)  /*!< Bit mask for SIM_SOPT3_BROMEXEC_B. */
#define BS_SIM_SOPT3_BROMEXEC_B         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_BROMEXEC_B. */

/*! @brief Read current value of the SIM_SOPT3_BROMEXEC_B field. */
#define BR_SIM_SOPT3_BROMEXEC_B(x)   (HW_SIM_SOPT3(x).B.BROMEXEC_B)

/*! @brief Format value for bitfield SIM_SOPT3_BROMEXEC_B. */
#define BF_SIM_SOPT3_BROMEXEC_B(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_BROMEXEC_B) & BM_SIM_SOPT3_BROMEXEC_B)

/*! @brief Set the BROMEXEC_B field to a new value. */
#define BW_SIM_SOPT3_BROMEXEC_B(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_BROMEXEC_B) | BF_SIM_SOPT3_BROMEXEC_B(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field FTFLLSOPT[2] (RW)
 *
 * This bit is used to select between a fast LLS recovery without MGate wakeup or a slow LLS
 * recovery with MGate wakeup.
 *
 * Values:
 * - 0 - Slow LLS recovery with MGate wakeup
 * - 1 - Fast LLS recovery without MGate wakeup
 */
/*@{*/
#define BP_SIM_SOPT3_FTFLLSOPT         (2U)      /*!< Bit position for SIM_SOPT3_FTFLLSOPT. */
#define BM_SIM_SOPT3_FTFLLSOPT         (0x00000004U)  /*!< Bit mask for SIM_SOPT3_FTFLLSOPT. */
#define BS_SIM_SOPT3_FTFLLSOPT         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_FTFLLSOPT. */

/*! @brief Read current value of the SIM_SOPT3_FTFLLSOPT field. */
#define BR_SIM_SOPT3_FTFLLSOPT(x)   (HW_SIM_SOPT3(x).B.FTFLLSOPT)

/*! @brief Format value for bitfield SIM_SOPT3_FTFLLSOPT. */
#define BF_SIM_SOPT3_FTFLLSOPT(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_FTFLLSOPT) & BM_SIM_SOPT3_FTFLLSOPT)

/*! @brief Set the FTFLLSOPT field to a new value. */
#define BW_SIM_SOPT3_FTFLLSOPT(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_FTFLLSOPT) | BF_SIM_SOPT3_FTFLLSOPT(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field VALDIS[8] (RW)
 *
 * This field enables self-time adjust of compiled memories through the VALRD[2:0] and VALWR[2:0]
 * fields.
 *
 * Values:
 * - 0 - Enable self-time adjust of compiled memories.
 * - 1 - Disable self-time adjust of compiled memories.
 */
/*@{*/
#define BP_SIM_SOPT3_VALDIS         (8U)      /*!< Bit position for SIM_SOPT3_VALDIS. */
#define BM_SIM_SOPT3_VALDIS         (0x00000100U)  /*!< Bit mask for SIM_SOPT3_VALDIS. */
#define BS_SIM_SOPT3_VALDIS         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_VALDIS. */

/*! @brief Read current value of the SIM_SOPT3_VALDIS field. */
#define BR_SIM_SOPT3_VALDIS(x)   (HW_SIM_SOPT3(x).B.VALDIS)

/*! @brief Format value for bitfield SIM_SOPT3_VALDIS. */
#define BF_SIM_SOPT3_VALDIS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_VALDIS) & BM_SIM_SOPT3_VALDIS)

/*! @brief Set the VALDIS field to a new value. */
#define BW_SIM_SOPT3_VALDIS(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_VALDIS) | BF_SIM_SOPT3_VALDIS(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field VALRD[11:9] (RW)
 *
 * This field controls the read access self-time duration of compiled memories. Effective only when
 * VALDIS bit value is 0. Nominal value of VALRD[2:0] for read access timing is 011. Bit is
 * read/write in functional test mode and read-only in other modes.
 */
/*@{*/
#define BP_SIM_SOPT3_VALRD         (9U)      /*!< Bit position for SIM_SOPT3_VALRD. */
#define BM_SIM_SOPT3_VALRD         (0x00000E00U)  /*!< Bit mask for SIM_SOPT3_VALRD. */
#define BS_SIM_SOPT3_VALRD         (3U)  /*!< Bitfield size in bits for SIM_SOPT3_VALRD. */

/*! @brief Read current value of the SIM_SOPT3_VALRD field. */
#define BR_SIM_SOPT3_VALRD(x)   (HW_SIM_SOPT3(x).B.VALRD)

/*! @brief Format value for bitfield SIM_SOPT3_VALRD. */
#define BF_SIM_SOPT3_VALRD(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_VALRD) & BM_SIM_SOPT3_VALRD)

/*! @brief Set the VALRD field to a new value. */
#define BW_SIM_SOPT3_VALRD(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_VALRD) | BF_SIM_SOPT3_VALRD(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field VALWR[14:12] (RW)
 *
 * This field controls the write access self-time duration of compiled memories. Effective only when
 * VALDIS bit value is 0. Nominal value of VALWR[2:0] for write access timing is 011.
 */
/*@{*/
#define BP_SIM_SOPT3_VALWR         (12U)      /*!< Bit position for SIM_SOPT3_VALWR. */
#define BM_SIM_SOPT3_VALWR         (0x00007000U)  /*!< Bit mask for SIM_SOPT3_VALWR. */
#define BS_SIM_SOPT3_VALWR         (3U)  /*!< Bitfield size in bits for SIM_SOPT3_VALWR. */

/*! @brief Read current value of the SIM_SOPT3_VALWR field. */
#define BR_SIM_SOPT3_VALWR(x)   (HW_SIM_SOPT3(x).B.VALWR)

/*! @brief Format value for bitfield SIM_SOPT3_VALWR. */
#define BF_SIM_SOPT3_VALWR(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_VALWR) & BM_SIM_SOPT3_VALWR)

/*! @brief Set the VALWR field to a new value. */
#define BW_SIM_SOPT3_VALWR(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_VALWR) | BF_SIM_SOPT3_VALWR(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field BROMEN[15] (RW)
 *
 * This bit is used to enable booting from ROM. This bit is used for device testing only and is
 * read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - Booting from ROM disabled.
 * - 1 - Booting from ROM enabled.
 */
/*@{*/
#define BP_SIM_SOPT3_BROMEN         (15U)      /*!< Bit position for SIM_SOPT3_BROMEN. */
#define BM_SIM_SOPT3_BROMEN         (0x00008000U)  /*!< Bit mask for SIM_SOPT3_BROMEN. */
#define BS_SIM_SOPT3_BROMEN         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_BROMEN. */

/*! @brief Read current value of the SIM_SOPT3_BROMEN field. */
#define BR_SIM_SOPT3_BROMEN(x)   (HW_SIM_SOPT3(x).B.BROMEN)

/*! @brief Format value for bitfield SIM_SOPT3_BROMEN. */
#define BF_SIM_SOPT3_BROMEN(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_BROMEN) & BM_SIM_SOPT3_BROMEN)

/*! @brief Set the BROMEN field to a new value. */
#define BW_SIM_SOPT3_BROMEN(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_BROMEN) | BF_SIM_SOPT3_BROMEN(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field FACEN[16] (RW)
 *
 * This bit is used to enable the Flash Access Control feature. This bit is used for device testing
 * only and is read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - Flash Access Control disabled
 * - 1 - Flash Access Control enabled
 */
/*@{*/
#define BP_SIM_SOPT3_FACEN         (16U)      /*!< Bit position for SIM_SOPT3_FACEN. */
#define BM_SIM_SOPT3_FACEN         (0x00010000U)  /*!< Bit mask for SIM_SOPT3_FACEN. */
#define BS_SIM_SOPT3_FACEN         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_FACEN. */

/*! @brief Read current value of the SIM_SOPT3_FACEN field. */
#define BR_SIM_SOPT3_FACEN(x)   (HW_SIM_SOPT3(x).B.FACEN)

/*! @brief Format value for bitfield SIM_SOPT3_FACEN. */
#define BF_SIM_SOPT3_FACEN(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_FACEN) & BM_SIM_SOPT3_FACEN)

/*! @brief Set the FACEN field to a new value. */
#define BW_SIM_SOPT3_FACEN(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_FACEN) | BF_SIM_SOPT3_FACEN(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field ENCDIS[17] (RW)
 *
 * This bit is used to disable the the RNGA/TRNG and MMCAU modules. This bit is used for device
 * testing only and is read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - RNGA CGC bit can be enabled and MMCAU is accessible.
 * - 1 - RNGA CGC bit cannot be enabled and MMCAU is not accessible.
 */
/*@{*/
#define BP_SIM_SOPT3_ENCDIS         (17U)      /*!< Bit position for SIM_SOPT3_ENCDIS. */
#define BM_SIM_SOPT3_ENCDIS         (0x00020000U)  /*!< Bit mask for SIM_SOPT3_ENCDIS. */
#define BS_SIM_SOPT3_ENCDIS         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_ENCDIS. */

/*! @brief Read current value of the SIM_SOPT3_ENCDIS field. */
#define BR_SIM_SOPT3_ENCDIS(x)   (HW_SIM_SOPT3(x).B.ENCDIS)

/*! @brief Format value for bitfield SIM_SOPT3_ENCDIS. */
#define BF_SIM_SOPT3_ENCDIS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_ENCDIS) & BM_SIM_SOPT3_ENCDIS)

/*! @brief Set the ENCDIS field to a new value. */
#define BW_SIM_SOPT3_ENCDIS(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_ENCDIS) | BF_SIM_SOPT3_ENCDIS(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field ESDHCDIS[20] (RW)
 *
 * This bit is used to disable the eSDHC module. This bit is used for device testing only and is
 * read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - eSDHC CGC bit can be enabled.
 * - 1 - eSDHC CGC bit cannot be enabled.
 */
/*@{*/
#define BP_SIM_SOPT3_ESDHCDIS         (20U)      /*!< Bit position for SIM_SOPT3_ESDHCDIS. */
#define BM_SIM_SOPT3_ESDHCDIS         (0x00100000U)  /*!< Bit mask for SIM_SOPT3_ESDHCDIS. */
#define BS_SIM_SOPT3_ESDHCDIS         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_ESDHCDIS. */

/*! @brief Read current value of the SIM_SOPT3_ESDHCDIS field. */
#define BR_SIM_SOPT3_ESDHCDIS(x)   (HW_SIM_SOPT3(x).B.ESDHCDIS)

/*! @brief Format value for bitfield SIM_SOPT3_ESDHCDIS. */
#define BF_SIM_SOPT3_ESDHCDIS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_ESDHCDIS) & BM_SIM_SOPT3_ESDHCDIS)

/*! @brief Set the ESDHCDIS field to a new value. */
#define BW_SIM_SOPT3_ESDHCDIS(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_ESDHCDIS) | BF_SIM_SOPT3_ESDHCDIS(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field USBDIS[23] (RW)
 *
 * This bit is used to disable the USB DCD and OTG controller modules and configure the FAMILYID
 * field. This bit is used for device testing only and is read-only for the user. It is read/write
 * in functional test mode.
 *
 * Values:
 * - 0 - USB FS OTG and USB DCD CGC bits can be enabled.
 * - 1 - USB FS OTG and USB DCD CGC bits cannot be enabled.
 */
/*@{*/
#define BP_SIM_SOPT3_USBDIS         (23U)      /*!< Bit position for SIM_SOPT3_USBDIS. */
#define BM_SIM_SOPT3_USBDIS         (0x00800000U)  /*!< Bit mask for SIM_SOPT3_USBDIS. */
#define BS_SIM_SOPT3_USBDIS         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_USBDIS. */

/*! @brief Read current value of the SIM_SOPT3_USBDIS field. */
#define BR_SIM_SOPT3_USBDIS(x)   (HW_SIM_SOPT3(x).B.USBDIS)

/*! @brief Format value for bitfield SIM_SOPT3_USBDIS. */
#define BF_SIM_SOPT3_USBDIS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_USBDIS) & BM_SIM_SOPT3_USBDIS)

/*! @brief Set the USBDIS field to a new value. */
#define BW_SIM_SOPT3_USBDIS(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_USBDIS) | BF_SIM_SOPT3_USBDIS(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field DRYICEDIS[24] (RW)
 *
 * This bit is used to disable the DryIce and Secure Register File modules and configure the
 * SUBFAMID field. This bit is used for device testing only and is read-only for the user. It is
 * read/write in functional test mode.
 *
 * Values:
 * - 0 - DryIce CGC bit can be enabled.
 * - 1 - DryIce CGC bit cannot be enabled.
 */
/*@{*/
#define BP_SIM_SOPT3_DRYICEDIS         (24U)      /*!< Bit position for SIM_SOPT3_DRYICEDIS. */
#define BM_SIM_SOPT3_DRYICEDIS         (0x01000000U)  /*!< Bit mask for SIM_SOPT3_DRYICEDIS. */
#define BS_SIM_SOPT3_DRYICEDIS         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_DRYICEDIS. */

/*! @brief Read current value of the SIM_SOPT3_DRYICEDIS field. */
#define BR_SIM_SOPT3_DRYICEDIS(x)   (HW_SIM_SOPT3(x).B.DRYICEDIS)

/*! @brief Format value for bitfield SIM_SOPT3_DRYICEDIS. */
#define BF_SIM_SOPT3_DRYICEDIS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_DRYICEDIS) & BM_SIM_SOPT3_DRYICEDIS)

/*! @brief Set the DRYICEDIS field to a new value. */
#define BW_SIM_SOPT3_DRYICEDIS(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_DRYICEDIS) | BF_SIM_SOPT3_DRYICEDIS(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field RFDIS[26] (RW)
 *
 * This bit is used to disable the RF SiP logic and configure the SERIESID field. This bit is used
 * for device testing only and is read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - RF SiP logic is enabled.
 * - 1 - RF SiP logic is disabled.
 */
/*@{*/
#define BP_SIM_SOPT3_RFDIS         (26U)      /*!< Bit position for SIM_SOPT3_RFDIS. */
#define BM_SIM_SOPT3_RFDIS         (0x04000000U)  /*!< Bit mask for SIM_SOPT3_RFDIS. */
#define BS_SIM_SOPT3_RFDIS         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_RFDIS. */

/*! @brief Read current value of the SIM_SOPT3_RFDIS field. */
#define BR_SIM_SOPT3_RFDIS(x)   (HW_SIM_SOPT3(x).B.RFDIS)

/*! @brief Format value for bitfield SIM_SOPT3_RFDIS. */
#define BF_SIM_SOPT3_RFDIS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_RFDIS) & BM_SIM_SOPT3_RFDIS)

/*! @brief Set the RFDIS field to a new value. */
#define BW_SIM_SOPT3_RFDIS(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_RFDIS) | BF_SIM_SOPT3_RFDIS(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field FPUDIS[27] (RW)
 *
 * This bit is used to disable the Coretex-M4 FPU support. This bit is used for device testing only
 * and is read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - Cortex-M4 FPU is enabled.
 * - 1 - Cortex-M4 FPU is disabled.
 */
/*@{*/
#define BP_SIM_SOPT3_FPUDIS         (27U)      /*!< Bit position for SIM_SOPT3_FPUDIS. */
#define BM_SIM_SOPT3_FPUDIS         (0x08000000U)  /*!< Bit mask for SIM_SOPT3_FPUDIS. */
#define BS_SIM_SOPT3_FPUDIS         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_FPUDIS. */

/*! @brief Read current value of the SIM_SOPT3_FPUDIS field. */
#define BR_SIM_SOPT3_FPUDIS(x)   (HW_SIM_SOPT3(x).B.FPUDIS)

/*! @brief Format value for bitfield SIM_SOPT3_FPUDIS. */
#define BF_SIM_SOPT3_FPUDIS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_FPUDIS) & BM_SIM_SOPT3_FPUDIS)

/*! @brief Set the FPUDIS field to a new value. */
#define BW_SIM_SOPT3_FPUDIS(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_FPUDIS) | BF_SIM_SOPT3_FPUDIS(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field QSPIEN[29] (RW)
 *
 * This bit is used to enable the QuadSPI module. This bit is used for device testing only and is
 * read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - QSPI disabled.
 * - 1 - QSPI enabled.
 */
/*@{*/
#define BP_SIM_SOPT3_QSPIEN         (29U)      /*!< Bit position for SIM_SOPT3_QSPIEN. */
#define BM_SIM_SOPT3_QSPIEN         (0x20000000U)  /*!< Bit mask for SIM_SOPT3_QSPIEN. */
#define BS_SIM_SOPT3_QSPIEN         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_QSPIEN. */

/*! @brief Read current value of the SIM_SOPT3_QSPIEN field. */
#define BR_SIM_SOPT3_QSPIEN(x)   (HW_SIM_SOPT3(x).B.QSPIEN)

/*! @brief Format value for bitfield SIM_SOPT3_QSPIEN. */
#define BF_SIM_SOPT3_QSPIEN(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_QSPIEN) & BM_SIM_SOPT3_QSPIEN)

/*! @brief Set the QSPIEN field to a new value. */
#define BW_SIM_SOPT3_QSPIEN(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_QSPIEN) | BF_SIM_SOPT3_QSPIEN(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT3, field QSPI_SIPDIS[30] (RW)
 *
 * This bit is used to disable the QuadSPI SiP pinmuxing. This bit is used for device testing only
 * and is read-only for the user. It is read/write in functional test mode.
 *
 * Values:
 * - 0 - QSPI SiP pinmuxing is enabled.
 * - 1 - QSPI SiP pinmuxing is disabled.
 */
/*@{*/
#define BP_SIM_SOPT3_QSPI_SIPDIS         (30U)      /*!< Bit position for SIM_SOPT3_QSPI_SIPDIS. */
#define BM_SIM_SOPT3_QSPI_SIPDIS         (0x40000000U)  /*!< Bit mask for SIM_SOPT3_QSPI_SIPDIS. */
#define BS_SIM_SOPT3_QSPI_SIPDIS         (1U)  /*!< Bitfield size in bits for SIM_SOPT3_QSPI_SIPDIS. */

/*! @brief Read current value of the SIM_SOPT3_QSPI_SIPDIS field. */
#define BR_SIM_SOPT3_QSPI_SIPDIS(x)   (HW_SIM_SOPT3(x).B.QSPI_SIPDIS)

/*! @brief Format value for bitfield SIM_SOPT3_QSPI_SIPDIS. */
#define BF_SIM_SOPT3_QSPI_SIPDIS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT3_QSPI_SIPDIS) & BM_SIM_SOPT3_QSPI_SIPDIS)

/*! @brief Set the QSPI_SIPDIS field to a new value. */
#define BW_SIM_SOPT3_QSPI_SIPDIS(x, v)   (HW_SIM_SOPT3_WR(x, (HW_SIM_SOPT3_RD(x) & ~BM_SIM_SOPT3_QSPI_SIPDIS) | BF_SIM_SOPT3_QSPI_SIPDIS(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SOPT4 - System Options Register 4
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT4 - System Options Register 4 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_sopt4
{
    uint32_t U;
    struct _hw_sim_sopt4_bitfields
    {
        uint32_t FTM0FLT0 : 1; /*!< [0] FTM0 Fault 0 Select */
        uint32_t FTM0FLT1 : 1; /*!< [1] FTM0 Fault 1 Select */
        uint32_t RESERVED0 : 2; /*!< [3:2] Reserved. */
        uint32_t FTM1FLT0 : 1; /*!< [4] FTM1 Fault 0 Select */
        uint32_t RESERVED1 : 3; /*!< [7:5]  */
        uint32_t FTM2FLT0 : 1; /*!< [8] FTM2 Fault 0 Select */
        uint32_t RESERVED2 : 3; /*!< [11:9]  */
        uint32_t FTM3FLT0 : 1; /*!< [12] FTM3 Fault 0 Select */
        uint32_t RESERVED3 : 5; /*!< [17:13]  */
        uint32_t FTM1CH0SRC : 2; /*!< [19:18] FTM1 channel 0 input capture source select */
        uint32_t FTM2CH0SRC : 2; /*!< [21:20] FTM2 channel 0 input capture source select */
        uint32_t FTM2CH1SRC : 1; /*!< [22] FTM2 channel 1 input capture source select */
        uint32_t RESERVED4 : 1; /*!< [23]  */
        uint32_t FTM0CLKSEL : 1; /*!< [24] FlexTimer 0 External Clock Pin Select */
        uint32_t FTM1CLKSEL : 1; /*!< [25] FTM1 External Clock Pin Select */
        uint32_t FTM2CLKSEL : 1; /*!< [26] FlexTimer 2 External Clock Pin Select */
        uint32_t FTM3CLKSEL : 1; /*!< [27] FlexTimer 3 External Clock Pin Select */
        uint32_t FTM0TRG0SRC : 1; /*!< [28] FlexTimer 0 Hardware Trigger 0 Source Select */
        uint32_t FTM0TRG1SRC : 1; /*!< [29] FlexTimer 0 Hardware Trigger 1 Source Select */
        uint32_t FTM3TRG0SRC : 1; /*!< [30] FlexTimer 3 Hardware Trigger 0 Source Select */
        uint32_t FTM3TRG1SRC : 1; /*!< [31] FlexTimer 3 Hardware Trigger 1 Source Select */
    } B;
} hw_sim_sopt4_t;

/*!
 * @name Constants and macros for entire SIM_SOPT4 register
 */
/*@{*/
#define HW_SIM_SOPT4_ADDR(x)        ((x) + 0x100CU)
#define HW_SIM_SOPT4(x)             (*(__IO hw_sim_sopt4_t *) HW_SIM_SOPT4_ADDR(x))
#define HW_SIM_SOPT4_RD(x)          (HW_SIM_SOPT4(x).U)
#define HW_SIM_SOPT4_WR(x, v)       (HW_SIM_SOPT4(x).U = (v))
#define HW_SIM_SOPT4_SET(x, v)      (HW_SIM_SOPT4_WR(x, HW_SIM_SOPT4_RD(x) |  (v)))
#define HW_SIM_SOPT4_CLR(x, v)      (HW_SIM_SOPT4_WR(x, HW_SIM_SOPT4_RD(x) & ~(v)))
#define HW_SIM_SOPT4_TOG(x, v)      (HW_SIM_SOPT4_WR(x, HW_SIM_SOPT4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT4 bitfields
 */

/*!
 * @name Register SIM_SOPT4, field FTM0FLT0[0] (RW)
 *
 * Selects the source of FTM0 fault 0. The pin source for fault 0 must be configured for the FTM
 * module fault function through the appropriate pin control register in the port control module.
 *
 * Values:
 * - 0 - FTM0_FLT0 pin
 * - 1 - CMP0 out
 */
/*@{*/
#define BP_SIM_SOPT4_FTM0FLT0         (0U)      /*!< Bit position for SIM_SOPT4_FTM0FLT0. */
#define BM_SIM_SOPT4_FTM0FLT0         (0x00000001U)  /*!< Bit mask for SIM_SOPT4_FTM0FLT0. */
#define BS_SIM_SOPT4_FTM0FLT0         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM0FLT0. */

/*! @brief Read current value of the SIM_SOPT4_FTM0FLT0 field. */
#define BR_SIM_SOPT4_FTM0FLT0(x)   (HW_SIM_SOPT4(x).B.FTM0FLT0)

/*! @brief Format value for bitfield SIM_SOPT4_FTM0FLT0. */
#define BF_SIM_SOPT4_FTM0FLT0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM0FLT0) & BM_SIM_SOPT4_FTM0FLT0)

/*! @brief Set the FTM0FLT0 field to a new value. */
#define BW_SIM_SOPT4_FTM0FLT0(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM0FLT0) | BF_SIM_SOPT4_FTM0FLT0(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM0FLT1[1] (RW)
 *
 * Selects the source of FTM0 fault 1. The pin source for fault 1 must be configured for the FTM
 * module fault function through the appropriate pin control register in the port control module.
 *
 * Values:
 * - 0 - FTM0_FLT1 pin
 * - 1 - CMP1 out
 */
/*@{*/
#define BP_SIM_SOPT4_FTM0FLT1         (1U)      /*!< Bit position for SIM_SOPT4_FTM0FLT1. */
#define BM_SIM_SOPT4_FTM0FLT1         (0x00000002U)  /*!< Bit mask for SIM_SOPT4_FTM0FLT1. */
#define BS_SIM_SOPT4_FTM0FLT1         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM0FLT1. */

/*! @brief Read current value of the SIM_SOPT4_FTM0FLT1 field. */
#define BR_SIM_SOPT4_FTM0FLT1(x)   (HW_SIM_SOPT4(x).B.FTM0FLT1)

/*! @brief Format value for bitfield SIM_SOPT4_FTM0FLT1. */
#define BF_SIM_SOPT4_FTM0FLT1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM0FLT1) & BM_SIM_SOPT4_FTM0FLT1)

/*! @brief Set the FTM0FLT1 field to a new value. */
#define BW_SIM_SOPT4_FTM0FLT1(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM0FLT1) | BF_SIM_SOPT4_FTM0FLT1(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM1FLT0[4] (RW)
 *
 * Selects the source of FTM1 fault 0. The pin source for fault 0 must be configured for the FTM
 * module fault function through the appropriate pin control register in the port control module.
 *
 * Values:
 * - 0 - FTM1_FLT0 pin
 * - 1 - CMP0 out
 */
/*@{*/
#define BP_SIM_SOPT4_FTM1FLT0         (4U)      /*!< Bit position for SIM_SOPT4_FTM1FLT0. */
#define BM_SIM_SOPT4_FTM1FLT0         (0x00000010U)  /*!< Bit mask for SIM_SOPT4_FTM1FLT0. */
#define BS_SIM_SOPT4_FTM1FLT0         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM1FLT0. */

/*! @brief Read current value of the SIM_SOPT4_FTM1FLT0 field. */
#define BR_SIM_SOPT4_FTM1FLT0(x)   (HW_SIM_SOPT4(x).B.FTM1FLT0)

/*! @brief Format value for bitfield SIM_SOPT4_FTM1FLT0. */
#define BF_SIM_SOPT4_FTM1FLT0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM1FLT0) & BM_SIM_SOPT4_FTM1FLT0)

/*! @brief Set the FTM1FLT0 field to a new value. */
#define BW_SIM_SOPT4_FTM1FLT0(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM1FLT0) | BF_SIM_SOPT4_FTM1FLT0(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM2FLT0[8] (RW)
 *
 * Selects the source of FTM2 fault 0. The pin source for fault 0 must be configured for the FTM
 * module fault function through the appropriate PORTx pin control register.
 *
 * Values:
 * - 0 - FTM2_FLT0 pin
 * - 1 - CMP0 out
 */
/*@{*/
#define BP_SIM_SOPT4_FTM2FLT0         (8U)      /*!< Bit position for SIM_SOPT4_FTM2FLT0. */
#define BM_SIM_SOPT4_FTM2FLT0         (0x00000100U)  /*!< Bit mask for SIM_SOPT4_FTM2FLT0. */
#define BS_SIM_SOPT4_FTM2FLT0         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM2FLT0. */

/*! @brief Read current value of the SIM_SOPT4_FTM2FLT0 field. */
#define BR_SIM_SOPT4_FTM2FLT0(x)   (HW_SIM_SOPT4(x).B.FTM2FLT0)

/*! @brief Format value for bitfield SIM_SOPT4_FTM2FLT0. */
#define BF_SIM_SOPT4_FTM2FLT0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM2FLT0) & BM_SIM_SOPT4_FTM2FLT0)

/*! @brief Set the FTM2FLT0 field to a new value. */
#define BW_SIM_SOPT4_FTM2FLT0(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM2FLT0) | BF_SIM_SOPT4_FTM2FLT0(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM3FLT0[12] (RW)
 *
 * Selects the source of FTM3 fault 0. The pin source for fault 0 must be configured for the FTM
 * module fault function through the appropriate PORTx pin control register.
 *
 * Values:
 * - 0 - FTM3_FLT0 pin
 * - 1 - CMP0 out
 */
/*@{*/
#define BP_SIM_SOPT4_FTM3FLT0         (12U)      /*!< Bit position for SIM_SOPT4_FTM3FLT0. */
#define BM_SIM_SOPT4_FTM3FLT0         (0x00001000U)  /*!< Bit mask for SIM_SOPT4_FTM3FLT0. */
#define BS_SIM_SOPT4_FTM3FLT0         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM3FLT0. */

/*! @brief Read current value of the SIM_SOPT4_FTM3FLT0 field. */
#define BR_SIM_SOPT4_FTM3FLT0(x)   (HW_SIM_SOPT4(x).B.FTM3FLT0)

/*! @brief Format value for bitfield SIM_SOPT4_FTM3FLT0. */
#define BF_SIM_SOPT4_FTM3FLT0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM3FLT0) & BM_SIM_SOPT4_FTM3FLT0)

/*! @brief Set the FTM3FLT0 field to a new value. */
#define BW_SIM_SOPT4_FTM3FLT0(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM3FLT0) | BF_SIM_SOPT4_FTM3FLT0(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM1CH0SRC[19:18] (RW)
 *
 * Selects the source for FTM1 channel 0 input capture. When the FTM is not in input capture mode,
 * clear this field.
 *
 * Values:
 * - 00 - FTM1_CH0 signal
 * - 01 - CMP0 output
 * - 10 - CMP1 output
 * - 11 - USB start of frame pulse
 */
/*@{*/
#define BP_SIM_SOPT4_FTM1CH0SRC         (18U)      /*!< Bit position for SIM_SOPT4_FTM1CH0SRC. */
#define BM_SIM_SOPT4_FTM1CH0SRC         (0x000C0000U)  /*!< Bit mask for SIM_SOPT4_FTM1CH0SRC. */
#define BS_SIM_SOPT4_FTM1CH0SRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM1CH0SRC. */

/*! @brief Read current value of the SIM_SOPT4_FTM1CH0SRC field. */
#define BR_SIM_SOPT4_FTM1CH0SRC(x)   (HW_SIM_SOPT4(x).B.FTM1CH0SRC)

/*! @brief Format value for bitfield SIM_SOPT4_FTM1CH0SRC. */
#define BF_SIM_SOPT4_FTM1CH0SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM1CH0SRC) & BM_SIM_SOPT4_FTM1CH0SRC)

/*! @brief Set the FTM1CH0SRC field to a new value. */
#define BW_SIM_SOPT4_FTM1CH0SRC(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM1CH0SRC) | BF_SIM_SOPT4_FTM1CH0SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM2CH0SRC[21:20] (RW)
 *
 * Selects the source for FTM2 channel 0 input capture. When the FTM is not in input capture mode,
 * clear this field.
 *
 * Values:
 * - 00 - FTM2_CH0 signal
 * - 01 - CMP0 output
 * - 10 - CMP1 output
 * - 11 - Reserved
 */
/*@{*/
#define BP_SIM_SOPT4_FTM2CH0SRC         (20U)      /*!< Bit position for SIM_SOPT4_FTM2CH0SRC. */
#define BM_SIM_SOPT4_FTM2CH0SRC         (0x00300000U)  /*!< Bit mask for SIM_SOPT4_FTM2CH0SRC. */
#define BS_SIM_SOPT4_FTM2CH0SRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM2CH0SRC. */

/*! @brief Read current value of the SIM_SOPT4_FTM2CH0SRC field. */
#define BR_SIM_SOPT4_FTM2CH0SRC(x)   (HW_SIM_SOPT4(x).B.FTM2CH0SRC)

/*! @brief Format value for bitfield SIM_SOPT4_FTM2CH0SRC. */
#define BF_SIM_SOPT4_FTM2CH0SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM2CH0SRC) & BM_SIM_SOPT4_FTM2CH0SRC)

/*! @brief Set the FTM2CH0SRC field to a new value. */
#define BW_SIM_SOPT4_FTM2CH0SRC(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM2CH0SRC) | BF_SIM_SOPT4_FTM2CH0SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM2CH1SRC[22] (RW)
 *
 * Values:
 * - 0 - FTM2_CH1 signal
 * - 1 - Exclusive OR of FTM2_CH1, FTM2_CH0 and FTM1_CH1.
 */
/*@{*/
#define BP_SIM_SOPT4_FTM2CH1SRC         (22U)      /*!< Bit position for SIM_SOPT4_FTM2CH1SRC. */
#define BM_SIM_SOPT4_FTM2CH1SRC         (0x00400000U)  /*!< Bit mask for SIM_SOPT4_FTM2CH1SRC. */
#define BS_SIM_SOPT4_FTM2CH1SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM2CH1SRC. */

/*! @brief Read current value of the SIM_SOPT4_FTM2CH1SRC field. */
#define BR_SIM_SOPT4_FTM2CH1SRC(x)   (HW_SIM_SOPT4(x).B.FTM2CH1SRC)

/*! @brief Format value for bitfield SIM_SOPT4_FTM2CH1SRC. */
#define BF_SIM_SOPT4_FTM2CH1SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM2CH1SRC) & BM_SIM_SOPT4_FTM2CH1SRC)

/*! @brief Set the FTM2CH1SRC field to a new value. */
#define BW_SIM_SOPT4_FTM2CH1SRC(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM2CH1SRC) | BF_SIM_SOPT4_FTM2CH1SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM0CLKSEL[24] (RW)
 *
 * Selects the external pin used to drive the clock to the FTM0 module. The selected pin must also
 * be configured for the FTM external clock function through the appropriate pin control register in
 * the port control module.
 *
 * Values:
 * - 0 - FTM_CLK0 pin
 * - 1 - FTM_CLK1 pin
 */
/*@{*/
#define BP_SIM_SOPT4_FTM0CLKSEL         (24U)      /*!< Bit position for SIM_SOPT4_FTM0CLKSEL. */
#define BM_SIM_SOPT4_FTM0CLKSEL         (0x01000000U)  /*!< Bit mask for SIM_SOPT4_FTM0CLKSEL. */
#define BS_SIM_SOPT4_FTM0CLKSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM0CLKSEL. */

/*! @brief Read current value of the SIM_SOPT4_FTM0CLKSEL field. */
#define BR_SIM_SOPT4_FTM0CLKSEL(x)   (HW_SIM_SOPT4(x).B.FTM0CLKSEL)

/*! @brief Format value for bitfield SIM_SOPT4_FTM0CLKSEL. */
#define BF_SIM_SOPT4_FTM0CLKSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM0CLKSEL) & BM_SIM_SOPT4_FTM0CLKSEL)

/*! @brief Set the FTM0CLKSEL field to a new value. */
#define BW_SIM_SOPT4_FTM0CLKSEL(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM0CLKSEL) | BF_SIM_SOPT4_FTM0CLKSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM1CLKSEL[25] (RW)
 *
 * Selects the external pin used to drive the clock to the FTM1 module. The selected pin must also
 * be configured for the FTM external clock function through the appropriate pin control register in
 * the port control module.
 *
 * Values:
 * - 0 - FTM_CLK0 pin
 * - 1 - FTM_CLK1 pin
 */
/*@{*/
#define BP_SIM_SOPT4_FTM1CLKSEL         (25U)      /*!< Bit position for SIM_SOPT4_FTM1CLKSEL. */
#define BM_SIM_SOPT4_FTM1CLKSEL         (0x02000000U)  /*!< Bit mask for SIM_SOPT4_FTM1CLKSEL. */
#define BS_SIM_SOPT4_FTM1CLKSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM1CLKSEL. */

/*! @brief Read current value of the SIM_SOPT4_FTM1CLKSEL field. */
#define BR_SIM_SOPT4_FTM1CLKSEL(x)   (HW_SIM_SOPT4(x).B.FTM1CLKSEL)

/*! @brief Format value for bitfield SIM_SOPT4_FTM1CLKSEL. */
#define BF_SIM_SOPT4_FTM1CLKSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM1CLKSEL) & BM_SIM_SOPT4_FTM1CLKSEL)

/*! @brief Set the FTM1CLKSEL field to a new value. */
#define BW_SIM_SOPT4_FTM1CLKSEL(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM1CLKSEL) | BF_SIM_SOPT4_FTM1CLKSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM2CLKSEL[26] (RW)
 *
 * Selects the external pin used to drive the clock to the FTM2 module. The selected pin must also
 * be configured for the FTM2 module external clock function through the appropriate pin control
 * register in the port control module.
 *
 * Values:
 * - 0 - FTM2 external clock driven by FTM_CLK0 pin.
 * - 1 - FTM2 external clock driven by FTM_CLK1 pin.
 */
/*@{*/
#define BP_SIM_SOPT4_FTM2CLKSEL         (26U)      /*!< Bit position for SIM_SOPT4_FTM2CLKSEL. */
#define BM_SIM_SOPT4_FTM2CLKSEL         (0x04000000U)  /*!< Bit mask for SIM_SOPT4_FTM2CLKSEL. */
#define BS_SIM_SOPT4_FTM2CLKSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM2CLKSEL. */

/*! @brief Read current value of the SIM_SOPT4_FTM2CLKSEL field. */
#define BR_SIM_SOPT4_FTM2CLKSEL(x)   (HW_SIM_SOPT4(x).B.FTM2CLKSEL)

/*! @brief Format value for bitfield SIM_SOPT4_FTM2CLKSEL. */
#define BF_SIM_SOPT4_FTM2CLKSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM2CLKSEL) & BM_SIM_SOPT4_FTM2CLKSEL)

/*! @brief Set the FTM2CLKSEL field to a new value. */
#define BW_SIM_SOPT4_FTM2CLKSEL(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM2CLKSEL) | BF_SIM_SOPT4_FTM2CLKSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM3CLKSEL[27] (RW)
 *
 * Selects the external pin used to drive the clock to the FTM3 module. The selected pin must also
 * be configured for the FTM3 module external clock function through the appropriate pin control
 * register in the port control module.
 *
 * Values:
 * - 0 - FTM3 external clock driven by FTM_CLK0 pin.
 * - 1 - FTM3 external clock driven by FTM_CLK1 pin.
 */
/*@{*/
#define BP_SIM_SOPT4_FTM3CLKSEL         (27U)      /*!< Bit position for SIM_SOPT4_FTM3CLKSEL. */
#define BM_SIM_SOPT4_FTM3CLKSEL         (0x08000000U)  /*!< Bit mask for SIM_SOPT4_FTM3CLKSEL. */
#define BS_SIM_SOPT4_FTM3CLKSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM3CLKSEL. */

/*! @brief Read current value of the SIM_SOPT4_FTM3CLKSEL field. */
#define BR_SIM_SOPT4_FTM3CLKSEL(x)   (HW_SIM_SOPT4(x).B.FTM3CLKSEL)

/*! @brief Format value for bitfield SIM_SOPT4_FTM3CLKSEL. */
#define BF_SIM_SOPT4_FTM3CLKSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM3CLKSEL) & BM_SIM_SOPT4_FTM3CLKSEL)

/*! @brief Set the FTM3CLKSEL field to a new value. */
#define BW_SIM_SOPT4_FTM3CLKSEL(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM3CLKSEL) | BF_SIM_SOPT4_FTM3CLKSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM0TRG0SRC[28] (RW)
 *
 * Selects the source of FTM0 hardware trigger 0.
 *
 * Values:
 * - 0 - HSCMP0 output drives FTM0 hardware trigger 0
 * - 1 - FTM1 channel match drives FTM0 hardware trigger 0
 */
/*@{*/
#define BP_SIM_SOPT4_FTM0TRG0SRC         (28U)      /*!< Bit position for SIM_SOPT4_FTM0TRG0SRC. */
#define BM_SIM_SOPT4_FTM0TRG0SRC         (0x10000000U)  /*!< Bit mask for SIM_SOPT4_FTM0TRG0SRC. */
#define BS_SIM_SOPT4_FTM0TRG0SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM0TRG0SRC. */

/*! @brief Read current value of the SIM_SOPT4_FTM0TRG0SRC field. */
#define BR_SIM_SOPT4_FTM0TRG0SRC(x)   (HW_SIM_SOPT4(x).B.FTM0TRG0SRC)

/*! @brief Format value for bitfield SIM_SOPT4_FTM0TRG0SRC. */
#define BF_SIM_SOPT4_FTM0TRG0SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM0TRG0SRC) & BM_SIM_SOPT4_FTM0TRG0SRC)

/*! @brief Set the FTM0TRG0SRC field to a new value. */
#define BW_SIM_SOPT4_FTM0TRG0SRC(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM0TRG0SRC) | BF_SIM_SOPT4_FTM0TRG0SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM0TRG1SRC[29] (RW)
 *
 * Selects the source of FTM0 hardware trigger 1.
 *
 * Values:
 * - 0 - PDB output trigger 1 drives FTM0 hardware trigger 1
 * - 1 - FTM2 channel match drives FTM0 hardware trigger 1
 */
/*@{*/
#define BP_SIM_SOPT4_FTM0TRG1SRC         (29U)      /*!< Bit position for SIM_SOPT4_FTM0TRG1SRC. */
#define BM_SIM_SOPT4_FTM0TRG1SRC         (0x20000000U)  /*!< Bit mask for SIM_SOPT4_FTM0TRG1SRC. */
#define BS_SIM_SOPT4_FTM0TRG1SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM0TRG1SRC. */

/*! @brief Read current value of the SIM_SOPT4_FTM0TRG1SRC field. */
#define BR_SIM_SOPT4_FTM0TRG1SRC(x)   (HW_SIM_SOPT4(x).B.FTM0TRG1SRC)

/*! @brief Format value for bitfield SIM_SOPT4_FTM0TRG1SRC. */
#define BF_SIM_SOPT4_FTM0TRG1SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM0TRG1SRC) & BM_SIM_SOPT4_FTM0TRG1SRC)

/*! @brief Set the FTM0TRG1SRC field to a new value. */
#define BW_SIM_SOPT4_FTM0TRG1SRC(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM0TRG1SRC) | BF_SIM_SOPT4_FTM0TRG1SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM3TRG0SRC[30] (RW)
 *
 * Selects the source of FTM3 hardware trigger 0.
 *
 * Values:
 * - 0 - Reserved
 * - 1 - FTM1 channel match drives FTM3 hardware trigger 0
 */
/*@{*/
#define BP_SIM_SOPT4_FTM3TRG0SRC         (30U)      /*!< Bit position for SIM_SOPT4_FTM3TRG0SRC. */
#define BM_SIM_SOPT4_FTM3TRG0SRC         (0x40000000U)  /*!< Bit mask for SIM_SOPT4_FTM3TRG0SRC. */
#define BS_SIM_SOPT4_FTM3TRG0SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM3TRG0SRC. */

/*! @brief Read current value of the SIM_SOPT4_FTM3TRG0SRC field. */
#define BR_SIM_SOPT4_FTM3TRG0SRC(x)   (HW_SIM_SOPT4(x).B.FTM3TRG0SRC)

/*! @brief Format value for bitfield SIM_SOPT4_FTM3TRG0SRC. */
#define BF_SIM_SOPT4_FTM3TRG0SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM3TRG0SRC) & BM_SIM_SOPT4_FTM3TRG0SRC)

/*! @brief Set the FTM3TRG0SRC field to a new value. */
#define BW_SIM_SOPT4_FTM3TRG0SRC(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM3TRG0SRC) | BF_SIM_SOPT4_FTM3TRG0SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT4, field FTM3TRG1SRC[31] (RW)
 *
 * Selects the source of FTM3 hardware trigger 1.
 *
 * Values:
 * - 0 - Reserved
 * - 1 - FTM2 channel match drives FTM3 hardware trigger 1
 */
/*@{*/
#define BP_SIM_SOPT4_FTM3TRG1SRC         (31U)      /*!< Bit position for SIM_SOPT4_FTM3TRG1SRC. */
#define BM_SIM_SOPT4_FTM3TRG1SRC         (0x80000000U)  /*!< Bit mask for SIM_SOPT4_FTM3TRG1SRC. */
#define BS_SIM_SOPT4_FTM3TRG1SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT4_FTM3TRG1SRC. */

/*! @brief Read current value of the SIM_SOPT4_FTM3TRG1SRC field. */
#define BR_SIM_SOPT4_FTM3TRG1SRC(x)   (HW_SIM_SOPT4(x).B.FTM3TRG1SRC)

/*! @brief Format value for bitfield SIM_SOPT4_FTM3TRG1SRC. */
#define BF_SIM_SOPT4_FTM3TRG1SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT4_FTM3TRG1SRC) & BM_SIM_SOPT4_FTM3TRG1SRC)

/*! @brief Set the FTM3TRG1SRC field to a new value. */
#define BW_SIM_SOPT4_FTM3TRG1SRC(x, v)   (HW_SIM_SOPT4_WR(x, (HW_SIM_SOPT4_RD(x) & ~BM_SIM_SOPT4_FTM3TRG1SRC) | BF_SIM_SOPT4_FTM3TRG1SRC(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SOPT5 - System Options Register 5
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT5 - System Options Register 5 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_sopt5
{
    uint32_t U;
    struct _hw_sim_sopt5_bitfields
    {
        uint32_t RESERVED0 : 16; /*!< [15:0]  */
        uint32_t LPUART0TXSRC : 2; /*!< [17:16] LPUART0 transmit data source select */
        uint32_t LPUART0RXSRC : 2; /*!< [19:18] LPUART0 receive data source select */
        uint32_t LPUART1TXSRC : 2; /*!< [21:20] LPUART1 transmit data source select */
        uint32_t LPUART1RXSRC : 2; /*!< [23:22] LPUART1 receive data source select */
        uint32_t RESERVED1 : 8; /*!< [31:24]  */
    } B;
} hw_sim_sopt5_t;

/*!
 * @name Constants and macros for entire SIM_SOPT5 register
 */
/*@{*/
#define HW_SIM_SOPT5_ADDR(x)        ((x) + 0x1010U)
#define HW_SIM_SOPT5(x)             (*(__IO hw_sim_sopt5_t *) HW_SIM_SOPT5_ADDR(x))
#define HW_SIM_SOPT5_RD(x)          (HW_SIM_SOPT5(x).U)
#define HW_SIM_SOPT5_WR(x, v)       (HW_SIM_SOPT5(x).U = (v))
#define HW_SIM_SOPT5_SET(x, v)      (HW_SIM_SOPT5_WR(x, HW_SIM_SOPT5_RD(x) |  (v)))
#define HW_SIM_SOPT5_CLR(x, v)      (HW_SIM_SOPT5_WR(x, HW_SIM_SOPT5_RD(x) & ~(v)))
#define HW_SIM_SOPT5_TOG(x, v)      (HW_SIM_SOPT5_WR(x, HW_SIM_SOPT5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT5 bitfields
 */

/*!
 * @name Register SIM_SOPT5, field LPUART0TXSRC[17:16] (RW)
 *
 * Selects the source for the LPUART0 transmit data.
 *
 * Values:
 * - 00 - LPUART0_TX pin
 * - 01 - LPUART0_TX pin modulated with TPM1 channel 0 output
 * - 10 - LPUART0_TX pin modulated with TPM2 channel 0 output
 * - 11 - Reserved
 */
/*@{*/
#define BP_SIM_SOPT5_LPUART0TXSRC         (16U)      /*!< Bit position for SIM_SOPT5_LPUART0TXSRC. */
#define BM_SIM_SOPT5_LPUART0TXSRC         (0x00030000U)  /*!< Bit mask for SIM_SOPT5_LPUART0TXSRC. */
#define BS_SIM_SOPT5_LPUART0TXSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT5_LPUART0TXSRC. */

/*! @brief Read current value of the SIM_SOPT5_LPUART0TXSRC field. */
#define BR_SIM_SOPT5_LPUART0TXSRC(x)   (HW_SIM_SOPT5(x).B.LPUART0TXSRC)

/*! @brief Format value for bitfield SIM_SOPT5_LPUART0TXSRC. */
#define BF_SIM_SOPT5_LPUART0TXSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT5_LPUART0TXSRC) & BM_SIM_SOPT5_LPUART0TXSRC)

/*! @brief Set the LPUART0TXSRC field to a new value. */
#define BW_SIM_SOPT5_LPUART0TXSRC(x, v)   (HW_SIM_SOPT5_WR(x, (HW_SIM_SOPT5_RD(x) & ~BM_SIM_SOPT5_LPUART0TXSRC) | BF_SIM_SOPT5_LPUART0TXSRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT5, field LPUART0RXSRC[19:18] (RW)
 *
 * Selects the source for the LPUART0 receive data.
 *
 * Values:
 * - 00 - LPUART0_RX pin
 * - 01 - CMP0 output
 * - 10 - CMP1 output
 * - 11 - Reserved
 */
/*@{*/
#define BP_SIM_SOPT5_LPUART0RXSRC         (18U)      /*!< Bit position for SIM_SOPT5_LPUART0RXSRC. */
#define BM_SIM_SOPT5_LPUART0RXSRC         (0x000C0000U)  /*!< Bit mask for SIM_SOPT5_LPUART0RXSRC. */
#define BS_SIM_SOPT5_LPUART0RXSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT5_LPUART0RXSRC. */

/*! @brief Read current value of the SIM_SOPT5_LPUART0RXSRC field. */
#define BR_SIM_SOPT5_LPUART0RXSRC(x)   (HW_SIM_SOPT5(x).B.LPUART0RXSRC)

/*! @brief Format value for bitfield SIM_SOPT5_LPUART0RXSRC. */
#define BF_SIM_SOPT5_LPUART0RXSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT5_LPUART0RXSRC) & BM_SIM_SOPT5_LPUART0RXSRC)

/*! @brief Set the LPUART0RXSRC field to a new value. */
#define BW_SIM_SOPT5_LPUART0RXSRC(x, v)   (HW_SIM_SOPT5_WR(x, (HW_SIM_SOPT5_RD(x) & ~BM_SIM_SOPT5_LPUART0RXSRC) | BF_SIM_SOPT5_LPUART0RXSRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT5, field LPUART1TXSRC[21:20] (RW)
 *
 * Selects the source for the LPUART0 transmit data.
 *
 * Values:
 * - 00 - LPUART1_TX pin
 * - 01 - LPUART1_TX pin modulated with TPM1 channel 0 output
 * - 10 - LPUART0_TX pin modulated with TPM2 channel 0 output
 * - 11 - Reserved
 */
/*@{*/
#define BP_SIM_SOPT5_LPUART1TXSRC         (20U)      /*!< Bit position for SIM_SOPT5_LPUART1TXSRC. */
#define BM_SIM_SOPT5_LPUART1TXSRC         (0x00300000U)  /*!< Bit mask for SIM_SOPT5_LPUART1TXSRC. */
#define BS_SIM_SOPT5_LPUART1TXSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT5_LPUART1TXSRC. */

/*! @brief Read current value of the SIM_SOPT5_LPUART1TXSRC field. */
#define BR_SIM_SOPT5_LPUART1TXSRC(x)   (HW_SIM_SOPT5(x).B.LPUART1TXSRC)

/*! @brief Format value for bitfield SIM_SOPT5_LPUART1TXSRC. */
#define BF_SIM_SOPT5_LPUART1TXSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT5_LPUART1TXSRC) & BM_SIM_SOPT5_LPUART1TXSRC)

/*! @brief Set the LPUART1TXSRC field to a new value. */
#define BW_SIM_SOPT5_LPUART1TXSRC(x, v)   (HW_SIM_SOPT5_WR(x, (HW_SIM_SOPT5_RD(x) & ~BM_SIM_SOPT5_LPUART1TXSRC) | BF_SIM_SOPT5_LPUART1TXSRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT5, field LPUART1RXSRC[23:22] (RW)
 *
 * Selects the source for the LPUART1 receive data.
 *
 * Values:
 * - 00 - LPUART1_RX pin
 * - 01 - CMP0 output
 * - 10 - CMP1 output
 * - 11 - Reserved
 */
/*@{*/
#define BP_SIM_SOPT5_LPUART1RXSRC         (22U)      /*!< Bit position for SIM_SOPT5_LPUART1RXSRC. */
#define BM_SIM_SOPT5_LPUART1RXSRC         (0x00C00000U)  /*!< Bit mask for SIM_SOPT5_LPUART1RXSRC. */
#define BS_SIM_SOPT5_LPUART1RXSRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT5_LPUART1RXSRC. */

/*! @brief Read current value of the SIM_SOPT5_LPUART1RXSRC field. */
#define BR_SIM_SOPT5_LPUART1RXSRC(x)   (HW_SIM_SOPT5(x).B.LPUART1RXSRC)

/*! @brief Format value for bitfield SIM_SOPT5_LPUART1RXSRC. */
#define BF_SIM_SOPT5_LPUART1RXSRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT5_LPUART1RXSRC) & BM_SIM_SOPT5_LPUART1RXSRC)

/*! @brief Set the LPUART1RXSRC field to a new value. */
#define BW_SIM_SOPT5_LPUART1RXSRC(x, v)   (HW_SIM_SOPT5_WR(x, (HW_SIM_SOPT5_RD(x) & ~BM_SIM_SOPT5_LPUART1RXSRC) | BF_SIM_SOPT5_LPUART1RXSRC(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SOPT7 - System Options Register 7
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT7 - System Options Register 7 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_sopt7
{
    uint32_t U;
    struct _hw_sim_sopt7_bitfields
    {
        uint32_t ADC0TRGSEL : 4; /*!< [3:0] ADC0 trigger select */
        uint32_t ADC0PRETRGSEL : 1; /*!< [4] ADC0 pretrigger select */
        uint32_t RESERVED0 : 2; /*!< [6:5]  */
        uint32_t ADC0ALTTRGEN : 1; /*!< [7] ADC0 alternate trigger enable */
        uint32_t RESERVED1 : 24; /*!< [31:8] Reserved. */
    } B;
} hw_sim_sopt7_t;

/*!
 * @name Constants and macros for entire SIM_SOPT7 register
 */
/*@{*/
#define HW_SIM_SOPT7_ADDR(x)        ((x) + 0x1018U)
#define HW_SIM_SOPT7(x)             (*(__IO hw_sim_sopt7_t *) HW_SIM_SOPT7_ADDR(x))
#define HW_SIM_SOPT7_RD(x)          (HW_SIM_SOPT7(x).U)
#define HW_SIM_SOPT7_WR(x, v)       (HW_SIM_SOPT7(x).U = (v))
#define HW_SIM_SOPT7_SET(x, v)      (HW_SIM_SOPT7_WR(x, HW_SIM_SOPT7_RD(x) |  (v)))
#define HW_SIM_SOPT7_CLR(x, v)      (HW_SIM_SOPT7_WR(x, HW_SIM_SOPT7_RD(x) & ~(v)))
#define HW_SIM_SOPT7_TOG(x, v)      (HW_SIM_SOPT7_WR(x, HW_SIM_SOPT7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT7 bitfields
 */

/*!
 * @name Register SIM_SOPT7, field ADC0TRGSEL[3:0] (RW)
 *
 * Selects the ADC0 trigger source when alternative triggers are functional in stop and VLPS modes.
 * .
 *
 * Values:
 * - 0000 - PDB external trigger pin input (PDB0_EXTRG)
 * - 0001 - High speed comparator 0 output
 * - 0010 - High speed comparator 1 output
 * - 0011 - Reserved
 * - 0100 - PIT trigger 0
 * - 0101 - PIT trigger 1
 * - 0110 - PIT trigger 2
 * - 0111 - PIT trigger 3
 * - 1000 - FTM0 trigger
 * - 1001 - FTM1 trigger
 * - 1010 - FTM2 trigger
 * - 1011 - FTM3 trigger
 * - 1100 - RTC alarm
 * - 1101 - RTC seconds
 * - 1110 - Low-power timer (LPTMR) trigger
 * - 1111 - TPM1 channel 0 (A pretrigger) and channel 1 (B pretrigger)
 */
/*@{*/
#define BP_SIM_SOPT7_ADC0TRGSEL         (0U)      /*!< Bit position for SIM_SOPT7_ADC0TRGSEL. */
#define BM_SIM_SOPT7_ADC0TRGSEL         (0x0000000FU)  /*!< Bit mask for SIM_SOPT7_ADC0TRGSEL. */
#define BS_SIM_SOPT7_ADC0TRGSEL         (4U)  /*!< Bitfield size in bits for SIM_SOPT7_ADC0TRGSEL. */

/*! @brief Read current value of the SIM_SOPT7_ADC0TRGSEL field. */
#define BR_SIM_SOPT7_ADC0TRGSEL(x)   (HW_SIM_SOPT7(x).B.ADC0TRGSEL)

/*! @brief Format value for bitfield SIM_SOPT7_ADC0TRGSEL. */
#define BF_SIM_SOPT7_ADC0TRGSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT7_ADC0TRGSEL) & BM_SIM_SOPT7_ADC0TRGSEL)

/*! @brief Set the ADC0TRGSEL field to a new value. */
#define BW_SIM_SOPT7_ADC0TRGSEL(x, v)   (HW_SIM_SOPT7_WR(x, (HW_SIM_SOPT7_RD(x) & ~BM_SIM_SOPT7_ADC0TRGSEL) | BF_SIM_SOPT7_ADC0TRGSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT7, field ADC0PRETRGSEL[4] (RW)
 *
 * Selects the ADC0 pre-trigger source when alternative triggers are enabled through ADC0ALTTRGEN.
 * This field is not used when the TPM trigger source is selected.
 *
 * Values:
 * - 0 - Pre-trigger A
 * - 1 - Pre-trigger B
 */
/*@{*/
#define BP_SIM_SOPT7_ADC0PRETRGSEL         (4U)      /*!< Bit position for SIM_SOPT7_ADC0PRETRGSEL. */
#define BM_SIM_SOPT7_ADC0PRETRGSEL         (0x00000010U)  /*!< Bit mask for SIM_SOPT7_ADC0PRETRGSEL. */
#define BS_SIM_SOPT7_ADC0PRETRGSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT7_ADC0PRETRGSEL. */

/*! @brief Read current value of the SIM_SOPT7_ADC0PRETRGSEL field. */
#define BR_SIM_SOPT7_ADC0PRETRGSEL(x)   (HW_SIM_SOPT7(x).B.ADC0PRETRGSEL)

/*! @brief Format value for bitfield SIM_SOPT7_ADC0PRETRGSEL. */
#define BF_SIM_SOPT7_ADC0PRETRGSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT7_ADC0PRETRGSEL) & BM_SIM_SOPT7_ADC0PRETRGSEL)

/*! @brief Set the ADC0PRETRGSEL field to a new value. */
#define BW_SIM_SOPT7_ADC0PRETRGSEL(x, v)   (HW_SIM_SOPT7_WR(x, (HW_SIM_SOPT7_RD(x) & ~BM_SIM_SOPT7_ADC0PRETRGSEL) | BF_SIM_SOPT7_ADC0PRETRGSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT7, field ADC0ALTTRGEN[7] (RW)
 *
 * Enable alternative conversion triggers for ADC0.
 *
 * Values:
 * - 0 - PDB trigger selected for ADC0.
 * - 1 - Alternate trigger selected for ADC0.
 */
/*@{*/
#define BP_SIM_SOPT7_ADC0ALTTRGEN         (7U)      /*!< Bit position for SIM_SOPT7_ADC0ALTTRGEN. */
#define BM_SIM_SOPT7_ADC0ALTTRGEN         (0x00000080U)  /*!< Bit mask for SIM_SOPT7_ADC0ALTTRGEN. */
#define BS_SIM_SOPT7_ADC0ALTTRGEN         (1U)  /*!< Bitfield size in bits for SIM_SOPT7_ADC0ALTTRGEN. */

/*! @brief Read current value of the SIM_SOPT7_ADC0ALTTRGEN field. */
#define BR_SIM_SOPT7_ADC0ALTTRGEN(x)   (HW_SIM_SOPT7(x).B.ADC0ALTTRGEN)

/*! @brief Format value for bitfield SIM_SOPT7_ADC0ALTTRGEN. */
#define BF_SIM_SOPT7_ADC0ALTTRGEN(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT7_ADC0ALTTRGEN) & BM_SIM_SOPT7_ADC0ALTTRGEN)

/*! @brief Set the ADC0ALTTRGEN field to a new value. */
#define BW_SIM_SOPT7_ADC0ALTTRGEN(x, v)   (HW_SIM_SOPT7_WR(x, (HW_SIM_SOPT7_RD(x) & ~BM_SIM_SOPT7_ADC0ALTTRGEN) | BF_SIM_SOPT7_ADC0ALTTRGEN(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SOPT8 - System Options Register 8
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT8 - System Options Register 8 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_sopt8
{
    uint32_t U;
    struct _hw_sim_sopt8_bitfields
    {
        uint32_t FTM0SYNCBIT : 1; /*!< [0] FTM0 Hardware Trigger 0 Software Synchronization */
        uint32_t FTM1SYNCBIT : 1; /*!< [1] FTM1 Hardware Trigger 0 Software Synchronization */
        uint32_t FTM2SYNCBIT : 1; /*!< [2] FTM2 Hardware Trigger 0 Software Synchronization */
        uint32_t FTM3SYNCBIT : 1; /*!< [3] FTM3 Hardware Trigger 0 Software Synchronization */
        uint32_t RESERVED0 : 12; /*!< [15:4]  */
        uint32_t FTM0OCH0SRC : 1; /*!< [16] FTM0 channel 0 output source */
        uint32_t FTM0OCH1SRC : 1; /*!< [17] FTM0 channel 1 output source */
        uint32_t FTM0OCH2SRC : 1; /*!< [18] FTM0 channel 2 output source */
        uint32_t FTM0OCH3SRC : 1; /*!< [19] FTM0 channel 3 output source */
        uint32_t FTM0OCH4SRC : 1; /*!< [20] FTM0 channel 4 output source */
        uint32_t FTM0OCH5SRC : 1; /*!< [21] FTM0 channel 5 output source */
        uint32_t FTM0OCH6SRC : 1; /*!< [22] FTM0 channel 6 output source */
        uint32_t FTM0OCH7SRC : 1; /*!< [23] FTM0 channel 7 output source */
        uint32_t FTM3OCH0SRC : 1; /*!< [24] FTM3 channel 0 output source */
        uint32_t FTM3OCH1SRC : 1; /*!< [25] FTM3 channel 1 output source */
        uint32_t FTM3OCH2SRC : 1; /*!< [26] FTM3 channel 2 output source */
        uint32_t FTM3OCH3SRC : 1; /*!< [27] FTM3 channel 3 output source */
        uint32_t FTM3OCH4SRC : 1; /*!< [28] FTM3 channel 4 output source */
        uint32_t FTM3OCH5SRC : 1; /*!< [29] FTM3 channel 5 output source */
        uint32_t FTM3OCH6SRC : 1; /*!< [30] FTM3 channel 6 output source */
        uint32_t FTM3OCH7SRC : 1; /*!< [31] FTM3 channel 7 output source */
    } B;
} hw_sim_sopt8_t;

/*!
 * @name Constants and macros for entire SIM_SOPT8 register
 */
/*@{*/
#define HW_SIM_SOPT8_ADDR(x)        ((x) + 0x101CU)
#define HW_SIM_SOPT8(x)             (*(__IO hw_sim_sopt8_t *) HW_SIM_SOPT8_ADDR(x))
#define HW_SIM_SOPT8_RD(x)          (HW_SIM_SOPT8(x).U)
#define HW_SIM_SOPT8_WR(x, v)       (HW_SIM_SOPT8(x).U = (v))
#define HW_SIM_SOPT8_SET(x, v)      (HW_SIM_SOPT8_WR(x, HW_SIM_SOPT8_RD(x) |  (v)))
#define HW_SIM_SOPT8_CLR(x, v)      (HW_SIM_SOPT8_WR(x, HW_SIM_SOPT8_RD(x) & ~(v)))
#define HW_SIM_SOPT8_TOG(x, v)      (HW_SIM_SOPT8_WR(x, HW_SIM_SOPT8_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT8 bitfields
 */

/*!
 * @name Register SIM_SOPT8, field FTM0SYNCBIT[0] (RW)
 *
 * Values:
 * - 0 - No effect
 * - 1 - Write 1 to assert the TRIG0 input to FTM0, software must clear this bit to allow other trigger
 *     sources to assert.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0SYNCBIT         (0U)      /*!< Bit position for SIM_SOPT8_FTM0SYNCBIT. */
#define BM_SIM_SOPT8_FTM0SYNCBIT         (0x00000001U)  /*!< Bit mask for SIM_SOPT8_FTM0SYNCBIT. */
#define BS_SIM_SOPT8_FTM0SYNCBIT         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0SYNCBIT. */

/*! @brief Read current value of the SIM_SOPT8_FTM0SYNCBIT field. */
#define BR_SIM_SOPT8_FTM0SYNCBIT(x)   (HW_SIM_SOPT8(x).B.FTM0SYNCBIT)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0SYNCBIT. */
#define BF_SIM_SOPT8_FTM0SYNCBIT(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0SYNCBIT) & BM_SIM_SOPT8_FTM0SYNCBIT)

/*! @brief Set the FTM0SYNCBIT field to a new value. */
#define BW_SIM_SOPT8_FTM0SYNCBIT(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0SYNCBIT) | BF_SIM_SOPT8_FTM0SYNCBIT(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM1SYNCBIT[1] (RW)
 *
 * Values:
 * - 0 - No effect.
 * - 1 - Write 1 to assert the TRIG0 input to FTM1, software must clear this bit to allow other trigger
 *     sources to assert.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM1SYNCBIT         (1U)      /*!< Bit position for SIM_SOPT8_FTM1SYNCBIT. */
#define BM_SIM_SOPT8_FTM1SYNCBIT         (0x00000002U)  /*!< Bit mask for SIM_SOPT8_FTM1SYNCBIT. */
#define BS_SIM_SOPT8_FTM1SYNCBIT         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM1SYNCBIT. */

/*! @brief Read current value of the SIM_SOPT8_FTM1SYNCBIT field. */
#define BR_SIM_SOPT8_FTM1SYNCBIT(x)   (HW_SIM_SOPT8(x).B.FTM1SYNCBIT)

/*! @brief Format value for bitfield SIM_SOPT8_FTM1SYNCBIT. */
#define BF_SIM_SOPT8_FTM1SYNCBIT(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM1SYNCBIT) & BM_SIM_SOPT8_FTM1SYNCBIT)

/*! @brief Set the FTM1SYNCBIT field to a new value. */
#define BW_SIM_SOPT8_FTM1SYNCBIT(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM1SYNCBIT) | BF_SIM_SOPT8_FTM1SYNCBIT(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM2SYNCBIT[2] (RW)
 *
 * Values:
 * - 0 - No effect.
 * - 1 - Write 1 to assert the TRIG0 input to FTM2, software must clear this bit to allow other trigger
 *     sources to assert.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM2SYNCBIT         (2U)      /*!< Bit position for SIM_SOPT8_FTM2SYNCBIT. */
#define BM_SIM_SOPT8_FTM2SYNCBIT         (0x00000004U)  /*!< Bit mask for SIM_SOPT8_FTM2SYNCBIT. */
#define BS_SIM_SOPT8_FTM2SYNCBIT         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM2SYNCBIT. */

/*! @brief Read current value of the SIM_SOPT8_FTM2SYNCBIT field. */
#define BR_SIM_SOPT8_FTM2SYNCBIT(x)   (HW_SIM_SOPT8(x).B.FTM2SYNCBIT)

/*! @brief Format value for bitfield SIM_SOPT8_FTM2SYNCBIT. */
#define BF_SIM_SOPT8_FTM2SYNCBIT(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM2SYNCBIT) & BM_SIM_SOPT8_FTM2SYNCBIT)

/*! @brief Set the FTM2SYNCBIT field to a new value. */
#define BW_SIM_SOPT8_FTM2SYNCBIT(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM2SYNCBIT) | BF_SIM_SOPT8_FTM2SYNCBIT(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3SYNCBIT[3] (RW)
 *
 * Values:
 * - 0 - No effect.
 * - 1 - Write 1 to assert the TRIG0 input to FTM3, software must clear this bit to allow other trigger
 *     sources to assert.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3SYNCBIT         (3U)      /*!< Bit position for SIM_SOPT8_FTM3SYNCBIT. */
#define BM_SIM_SOPT8_FTM3SYNCBIT         (0x00000008U)  /*!< Bit mask for SIM_SOPT8_FTM3SYNCBIT. */
#define BS_SIM_SOPT8_FTM3SYNCBIT         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3SYNCBIT. */

/*! @brief Read current value of the SIM_SOPT8_FTM3SYNCBIT field. */
#define BR_SIM_SOPT8_FTM3SYNCBIT(x)   (HW_SIM_SOPT8(x).B.FTM3SYNCBIT)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3SYNCBIT. */
#define BF_SIM_SOPT8_FTM3SYNCBIT(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3SYNCBIT) & BM_SIM_SOPT8_FTM3SYNCBIT)

/*! @brief Set the FTM3SYNCBIT field to a new value. */
#define BW_SIM_SOPT8_FTM3SYNCBIT(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3SYNCBIT) | BF_SIM_SOPT8_FTM3SYNCBIT(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM0OCH0SRC[16] (RW)
 *
 * Values:
 * - 0 - FTM0_CH0 pin is output of FTM0 channel 0 output
 * - 1 - FTM0_CH0 pin is output of FTM0 channel 0 output, modulated by FTM1 channel 1 output
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0OCH0SRC         (16U)      /*!< Bit position for SIM_SOPT8_FTM0OCH0SRC. */
#define BM_SIM_SOPT8_FTM0OCH0SRC         (0x00010000U)  /*!< Bit mask for SIM_SOPT8_FTM0OCH0SRC. */
#define BS_SIM_SOPT8_FTM0OCH0SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0OCH0SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM0OCH0SRC field. */
#define BR_SIM_SOPT8_FTM0OCH0SRC(x)   (HW_SIM_SOPT8(x).B.FTM0OCH0SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0OCH0SRC. */
#define BF_SIM_SOPT8_FTM0OCH0SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0OCH0SRC) & BM_SIM_SOPT8_FTM0OCH0SRC)

/*! @brief Set the FTM0OCH0SRC field to a new value. */
#define BW_SIM_SOPT8_FTM0OCH0SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0OCH0SRC) | BF_SIM_SOPT8_FTM0OCH0SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM0OCH1SRC[17] (RW)
 *
 * Values:
 * - 0 - FTM0_CH1 pin is output of FTM0 channel 1 output
 * - 1 - FTM0_CH1 pin is output of FTM0 channel 1 output, modulated by FTM1 channel 1 output
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0OCH1SRC         (17U)      /*!< Bit position for SIM_SOPT8_FTM0OCH1SRC. */
#define BM_SIM_SOPT8_FTM0OCH1SRC         (0x00020000U)  /*!< Bit mask for SIM_SOPT8_FTM0OCH1SRC. */
#define BS_SIM_SOPT8_FTM0OCH1SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0OCH1SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM0OCH1SRC field. */
#define BR_SIM_SOPT8_FTM0OCH1SRC(x)   (HW_SIM_SOPT8(x).B.FTM0OCH1SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0OCH1SRC. */
#define BF_SIM_SOPT8_FTM0OCH1SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0OCH1SRC) & BM_SIM_SOPT8_FTM0OCH1SRC)

/*! @brief Set the FTM0OCH1SRC field to a new value. */
#define BW_SIM_SOPT8_FTM0OCH1SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0OCH1SRC) | BF_SIM_SOPT8_FTM0OCH1SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM0OCH2SRC[18] (RW)
 *
 * Values:
 * - 0 - FTM0_CH2 pin is output of FTM0 channel 2 output
 * - 1 - FTM0_CH2 pin is output of FTM0 channel 2 output, modulated by FTM1 channel 1 output
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0OCH2SRC         (18U)      /*!< Bit position for SIM_SOPT8_FTM0OCH2SRC. */
#define BM_SIM_SOPT8_FTM0OCH2SRC         (0x00040000U)  /*!< Bit mask for SIM_SOPT8_FTM0OCH2SRC. */
#define BS_SIM_SOPT8_FTM0OCH2SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0OCH2SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM0OCH2SRC field. */
#define BR_SIM_SOPT8_FTM0OCH2SRC(x)   (HW_SIM_SOPT8(x).B.FTM0OCH2SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0OCH2SRC. */
#define BF_SIM_SOPT8_FTM0OCH2SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0OCH2SRC) & BM_SIM_SOPT8_FTM0OCH2SRC)

/*! @brief Set the FTM0OCH2SRC field to a new value. */
#define BW_SIM_SOPT8_FTM0OCH2SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0OCH2SRC) | BF_SIM_SOPT8_FTM0OCH2SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM0OCH3SRC[19] (RW)
 *
 * Values:
 * - 0 - FTM0_CH3 pin is output of FTM0 channel 3 output
 * - 1 - FTM0_CH3 pin is output of FTM0 channel 3 output, modulated by FTM1 channel 1 output
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0OCH3SRC         (19U)      /*!< Bit position for SIM_SOPT8_FTM0OCH3SRC. */
#define BM_SIM_SOPT8_FTM0OCH3SRC         (0x00080000U)  /*!< Bit mask for SIM_SOPT8_FTM0OCH3SRC. */
#define BS_SIM_SOPT8_FTM0OCH3SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0OCH3SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM0OCH3SRC field. */
#define BR_SIM_SOPT8_FTM0OCH3SRC(x)   (HW_SIM_SOPT8(x).B.FTM0OCH3SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0OCH3SRC. */
#define BF_SIM_SOPT8_FTM0OCH3SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0OCH3SRC) & BM_SIM_SOPT8_FTM0OCH3SRC)

/*! @brief Set the FTM0OCH3SRC field to a new value. */
#define BW_SIM_SOPT8_FTM0OCH3SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0OCH3SRC) | BF_SIM_SOPT8_FTM0OCH3SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM0OCH4SRC[20] (RW)
 *
 * Values:
 * - 0 - FTM0_CH4 pin is output of FTM0 channel 4 output
 * - 1 - FTM0_CH4 pin is output of FTM0 channel 4 output, modulated by FTM1 channel 1 output
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0OCH4SRC         (20U)      /*!< Bit position for SIM_SOPT8_FTM0OCH4SRC. */
#define BM_SIM_SOPT8_FTM0OCH4SRC         (0x00100000U)  /*!< Bit mask for SIM_SOPT8_FTM0OCH4SRC. */
#define BS_SIM_SOPT8_FTM0OCH4SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0OCH4SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM0OCH4SRC field. */
#define BR_SIM_SOPT8_FTM0OCH4SRC(x)   (HW_SIM_SOPT8(x).B.FTM0OCH4SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0OCH4SRC. */
#define BF_SIM_SOPT8_FTM0OCH4SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0OCH4SRC) & BM_SIM_SOPT8_FTM0OCH4SRC)

/*! @brief Set the FTM0OCH4SRC field to a new value. */
#define BW_SIM_SOPT8_FTM0OCH4SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0OCH4SRC) | BF_SIM_SOPT8_FTM0OCH4SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM0OCH5SRC[21] (RW)
 *
 * Values:
 * - 0 - FTM0_CH5 pin is output of FTM0 channel 5 output
 * - 1 - FTM0_CH5 pin is output of FTM0 channel 5 output, modulated by FTM1 channel 1 output
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0OCH5SRC         (21U)      /*!< Bit position for SIM_SOPT8_FTM0OCH5SRC. */
#define BM_SIM_SOPT8_FTM0OCH5SRC         (0x00200000U)  /*!< Bit mask for SIM_SOPT8_FTM0OCH5SRC. */
#define BS_SIM_SOPT8_FTM0OCH5SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0OCH5SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM0OCH5SRC field. */
#define BR_SIM_SOPT8_FTM0OCH5SRC(x)   (HW_SIM_SOPT8(x).B.FTM0OCH5SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0OCH5SRC. */
#define BF_SIM_SOPT8_FTM0OCH5SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0OCH5SRC) & BM_SIM_SOPT8_FTM0OCH5SRC)

/*! @brief Set the FTM0OCH5SRC field to a new value. */
#define BW_SIM_SOPT8_FTM0OCH5SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0OCH5SRC) | BF_SIM_SOPT8_FTM0OCH5SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM0OCH6SRC[22] (RW)
 *
 * Values:
 * - 0 - FTM0_CH6 pin is output of FTM0 channel 6 output
 * - 1 - FTM0_CH6 pin is output of FTM0 channel 6 output, modulated by FTM1 channel 1 output
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0OCH6SRC         (22U)      /*!< Bit position for SIM_SOPT8_FTM0OCH6SRC. */
#define BM_SIM_SOPT8_FTM0OCH6SRC         (0x00400000U)  /*!< Bit mask for SIM_SOPT8_FTM0OCH6SRC. */
#define BS_SIM_SOPT8_FTM0OCH6SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0OCH6SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM0OCH6SRC field. */
#define BR_SIM_SOPT8_FTM0OCH6SRC(x)   (HW_SIM_SOPT8(x).B.FTM0OCH6SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0OCH6SRC. */
#define BF_SIM_SOPT8_FTM0OCH6SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0OCH6SRC) & BM_SIM_SOPT8_FTM0OCH6SRC)

/*! @brief Set the FTM0OCH6SRC field to a new value. */
#define BW_SIM_SOPT8_FTM0OCH6SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0OCH6SRC) | BF_SIM_SOPT8_FTM0OCH6SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM0OCH7SRC[23] (RW)
 *
 * Values:
 * - 0 - FTM0_CH7 pin is output of FTM0 channel 7 output
 * - 1 - FTM0_CH7 pin is output of FTM0 channel 7 output, modulated by FTM1 channel 1 output
 */
/*@{*/
#define BP_SIM_SOPT8_FTM0OCH7SRC         (23U)      /*!< Bit position for SIM_SOPT8_FTM0OCH7SRC. */
#define BM_SIM_SOPT8_FTM0OCH7SRC         (0x00800000U)  /*!< Bit mask for SIM_SOPT8_FTM0OCH7SRC. */
#define BS_SIM_SOPT8_FTM0OCH7SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM0OCH7SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM0OCH7SRC field. */
#define BR_SIM_SOPT8_FTM0OCH7SRC(x)   (HW_SIM_SOPT8(x).B.FTM0OCH7SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM0OCH7SRC. */
#define BF_SIM_SOPT8_FTM0OCH7SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM0OCH7SRC) & BM_SIM_SOPT8_FTM0OCH7SRC)

/*! @brief Set the FTM0OCH7SRC field to a new value. */
#define BW_SIM_SOPT8_FTM0OCH7SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM0OCH7SRC) | BF_SIM_SOPT8_FTM0OCH7SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3OCH0SRC[24] (RW)
 *
 * Values:
 * - 0 - FTM3_CH0 pin is output of FTM3 channel 0 output
 * - 1 - FTM3_CH0 pin is output of FTM3 channel 0 output modulated by FTM2 channel 1 output.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3OCH0SRC         (24U)      /*!< Bit position for SIM_SOPT8_FTM3OCH0SRC. */
#define BM_SIM_SOPT8_FTM3OCH0SRC         (0x01000000U)  /*!< Bit mask for SIM_SOPT8_FTM3OCH0SRC. */
#define BS_SIM_SOPT8_FTM3OCH0SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3OCH0SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM3OCH0SRC field. */
#define BR_SIM_SOPT8_FTM3OCH0SRC(x)   (HW_SIM_SOPT8(x).B.FTM3OCH0SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3OCH0SRC. */
#define BF_SIM_SOPT8_FTM3OCH0SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3OCH0SRC) & BM_SIM_SOPT8_FTM3OCH0SRC)

/*! @brief Set the FTM3OCH0SRC field to a new value. */
#define BW_SIM_SOPT8_FTM3OCH0SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3OCH0SRC) | BF_SIM_SOPT8_FTM3OCH0SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3OCH1SRC[25] (RW)
 *
 * Values:
 * - 0 - FTM3_CH1 pin is output of FTM3 channel 1 output
 * - 1 - FTM3_CH1 pin is output of FTM3 channel 1 output modulated by FTM2 channel 1 output.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3OCH1SRC         (25U)      /*!< Bit position for SIM_SOPT8_FTM3OCH1SRC. */
#define BM_SIM_SOPT8_FTM3OCH1SRC         (0x02000000U)  /*!< Bit mask for SIM_SOPT8_FTM3OCH1SRC. */
#define BS_SIM_SOPT8_FTM3OCH1SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3OCH1SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM3OCH1SRC field. */
#define BR_SIM_SOPT8_FTM3OCH1SRC(x)   (HW_SIM_SOPT8(x).B.FTM3OCH1SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3OCH1SRC. */
#define BF_SIM_SOPT8_FTM3OCH1SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3OCH1SRC) & BM_SIM_SOPT8_FTM3OCH1SRC)

/*! @brief Set the FTM3OCH1SRC field to a new value. */
#define BW_SIM_SOPT8_FTM3OCH1SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3OCH1SRC) | BF_SIM_SOPT8_FTM3OCH1SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3OCH2SRC[26] (RW)
 *
 * Values:
 * - 0 - FTM3_CH2 pin is output of FTM3 channel 2 output
 * - 1 - FTM3_CH2 pin is output of FTM3 channel 2 output modulated by FTM2 channel 1 output.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3OCH2SRC         (26U)      /*!< Bit position for SIM_SOPT8_FTM3OCH2SRC. */
#define BM_SIM_SOPT8_FTM3OCH2SRC         (0x04000000U)  /*!< Bit mask for SIM_SOPT8_FTM3OCH2SRC. */
#define BS_SIM_SOPT8_FTM3OCH2SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3OCH2SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM3OCH2SRC field. */
#define BR_SIM_SOPT8_FTM3OCH2SRC(x)   (HW_SIM_SOPT8(x).B.FTM3OCH2SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3OCH2SRC. */
#define BF_SIM_SOPT8_FTM3OCH2SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3OCH2SRC) & BM_SIM_SOPT8_FTM3OCH2SRC)

/*! @brief Set the FTM3OCH2SRC field to a new value. */
#define BW_SIM_SOPT8_FTM3OCH2SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3OCH2SRC) | BF_SIM_SOPT8_FTM3OCH2SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3OCH3SRC[27] (RW)
 *
 * Values:
 * - 0 - FTM3_CH3 pin is output of FTM3 channel 3 output
 * - 1 - FTM3_CH3 pin is output of FTM3 channel 3 output modulated by FTM2 channel 1 output.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3OCH3SRC         (27U)      /*!< Bit position for SIM_SOPT8_FTM3OCH3SRC. */
#define BM_SIM_SOPT8_FTM3OCH3SRC         (0x08000000U)  /*!< Bit mask for SIM_SOPT8_FTM3OCH3SRC. */
#define BS_SIM_SOPT8_FTM3OCH3SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3OCH3SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM3OCH3SRC field. */
#define BR_SIM_SOPT8_FTM3OCH3SRC(x)   (HW_SIM_SOPT8(x).B.FTM3OCH3SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3OCH3SRC. */
#define BF_SIM_SOPT8_FTM3OCH3SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3OCH3SRC) & BM_SIM_SOPT8_FTM3OCH3SRC)

/*! @brief Set the FTM3OCH3SRC field to a new value. */
#define BW_SIM_SOPT8_FTM3OCH3SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3OCH3SRC) | BF_SIM_SOPT8_FTM3OCH3SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3OCH4SRC[28] (RW)
 *
 * Values:
 * - 0 - FTM3_CH4 pin is output of FTM3 channel 4 output
 * - 1 - FTM3_CH4 pin is output of FTM3 channel 4 output modulated by FTM2 channel 1 output.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3OCH4SRC         (28U)      /*!< Bit position for SIM_SOPT8_FTM3OCH4SRC. */
#define BM_SIM_SOPT8_FTM3OCH4SRC         (0x10000000U)  /*!< Bit mask for SIM_SOPT8_FTM3OCH4SRC. */
#define BS_SIM_SOPT8_FTM3OCH4SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3OCH4SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM3OCH4SRC field. */
#define BR_SIM_SOPT8_FTM3OCH4SRC(x)   (HW_SIM_SOPT8(x).B.FTM3OCH4SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3OCH4SRC. */
#define BF_SIM_SOPT8_FTM3OCH4SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3OCH4SRC) & BM_SIM_SOPT8_FTM3OCH4SRC)

/*! @brief Set the FTM3OCH4SRC field to a new value. */
#define BW_SIM_SOPT8_FTM3OCH4SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3OCH4SRC) | BF_SIM_SOPT8_FTM3OCH4SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3OCH5SRC[29] (RW)
 *
 * Values:
 * - 0 - FTM3_CH5 pin is output of FTM3 channel 5 output
 * - 1 - FTM3_CH5 pin is output of FTM3 channel 5 output modulated by FTM2 channel 1 output.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3OCH5SRC         (29U)      /*!< Bit position for SIM_SOPT8_FTM3OCH5SRC. */
#define BM_SIM_SOPT8_FTM3OCH5SRC         (0x20000000U)  /*!< Bit mask for SIM_SOPT8_FTM3OCH5SRC. */
#define BS_SIM_SOPT8_FTM3OCH5SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3OCH5SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM3OCH5SRC field. */
#define BR_SIM_SOPT8_FTM3OCH5SRC(x)   (HW_SIM_SOPT8(x).B.FTM3OCH5SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3OCH5SRC. */
#define BF_SIM_SOPT8_FTM3OCH5SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3OCH5SRC) & BM_SIM_SOPT8_FTM3OCH5SRC)

/*! @brief Set the FTM3OCH5SRC field to a new value. */
#define BW_SIM_SOPT8_FTM3OCH5SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3OCH5SRC) | BF_SIM_SOPT8_FTM3OCH5SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3OCH6SRC[30] (RW)
 *
 * Values:
 * - 0 - FTM3_CH6 pin is output of FTM3 channel 6 output
 * - 1 - FTM3_CH6 pin is output of FTM3 channel 6 output modulated by FTM2 channel 1 output.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3OCH6SRC         (30U)      /*!< Bit position for SIM_SOPT8_FTM3OCH6SRC. */
#define BM_SIM_SOPT8_FTM3OCH6SRC         (0x40000000U)  /*!< Bit mask for SIM_SOPT8_FTM3OCH6SRC. */
#define BS_SIM_SOPT8_FTM3OCH6SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3OCH6SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM3OCH6SRC field. */
#define BR_SIM_SOPT8_FTM3OCH6SRC(x)   (HW_SIM_SOPT8(x).B.FTM3OCH6SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3OCH6SRC. */
#define BF_SIM_SOPT8_FTM3OCH6SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3OCH6SRC) & BM_SIM_SOPT8_FTM3OCH6SRC)

/*! @brief Set the FTM3OCH6SRC field to a new value. */
#define BW_SIM_SOPT8_FTM3OCH6SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3OCH6SRC) | BF_SIM_SOPT8_FTM3OCH6SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT8, field FTM3OCH7SRC[31] (RW)
 *
 * Values:
 * - 0 - FTM3_CH7 pin is output of FTM3 channel 7 output
 * - 1 - FTM3_CH7 pin is output of FTM3 channel 7 output modulated by FTM2 channel 1 output.
 */
/*@{*/
#define BP_SIM_SOPT8_FTM3OCH7SRC         (31U)      /*!< Bit position for SIM_SOPT8_FTM3OCH7SRC. */
#define BM_SIM_SOPT8_FTM3OCH7SRC         (0x80000000U)  /*!< Bit mask for SIM_SOPT8_FTM3OCH7SRC. */
#define BS_SIM_SOPT8_FTM3OCH7SRC         (1U)  /*!< Bitfield size in bits for SIM_SOPT8_FTM3OCH7SRC. */

/*! @brief Read current value of the SIM_SOPT8_FTM3OCH7SRC field. */
#define BR_SIM_SOPT8_FTM3OCH7SRC(x)   (HW_SIM_SOPT8(x).B.FTM3OCH7SRC)

/*! @brief Format value for bitfield SIM_SOPT8_FTM3OCH7SRC. */
#define BF_SIM_SOPT8_FTM3OCH7SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT8_FTM3OCH7SRC) & BM_SIM_SOPT8_FTM3OCH7SRC)

/*! @brief Set the FTM3OCH7SRC field to a new value. */
#define BW_SIM_SOPT8_FTM3OCH7SRC(x, v)   (HW_SIM_SOPT8_WR(x, (HW_SIM_SOPT8_RD(x) & ~BM_SIM_SOPT8_FTM3OCH7SRC) | BF_SIM_SOPT8_FTM3OCH7SRC(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SOPT9 - System Options Register 9
 ******************************************************************************/

/*!
 * @brief HW_SIM_SOPT9 - System Options Register 9 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_sopt9
{
    uint32_t U;
    struct _hw_sim_sopt9_bitfields
    {
        uint32_t RESERVED0 : 18; /*!< [17:0]  */
        uint32_t TPM1CH0SRC : 2; /*!< [19:18] TPM1 channel 0 input capture source select */
        uint32_t TPM2CH0SRC : 2; /*!< [21:20] TPM2 channel 0 input capture source select */
        uint32_t RESERVED1 : 3; /*!< [24:22]  */
        uint32_t TPM1CLKSEL : 1; /*!< [25] TPM1 External Clock Pin Select */
        uint32_t TPM2CLKSEL : 1; /*!< [26] TPM2 External Clock Pin Select */
        uint32_t RESERVED2 : 5; /*!< [31:27]  */
    } B;
} hw_sim_sopt9_t;

/*!
 * @name Constants and macros for entire SIM_SOPT9 register
 */
/*@{*/
#define HW_SIM_SOPT9_ADDR(x)        ((x) + 0x1020U)
#define HW_SIM_SOPT9(x)             (*(__IO hw_sim_sopt9_t *) HW_SIM_SOPT9_ADDR(x))
#define HW_SIM_SOPT9_RD(x)          (HW_SIM_SOPT9(x).U)
#define HW_SIM_SOPT9_WR(x, v)       (HW_SIM_SOPT9(x).U = (v))
#define HW_SIM_SOPT9_SET(x, v)      (HW_SIM_SOPT9_WR(x, HW_SIM_SOPT9_RD(x) |  (v)))
#define HW_SIM_SOPT9_CLR(x, v)      (HW_SIM_SOPT9_WR(x, HW_SIM_SOPT9_RD(x) & ~(v)))
#define HW_SIM_SOPT9_TOG(x, v)      (HW_SIM_SOPT9_WR(x, HW_SIM_SOPT9_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SOPT9 bitfields
 */

/*!
 * @name Register SIM_SOPT9, field TPM1CH0SRC[19:18] (RW)
 *
 * Selects the source for TPM1 channel 0 input capture. When the TPM is not in input capture mode,
 * clear this field.
 *
 * Values:
 * - 00 - TPM1_CH0 signal
 * - 01 - CMP0 output
 * - 10 - CMP1 output
 * - 11 - Reserved
 */
/*@{*/
#define BP_SIM_SOPT9_TPM1CH0SRC         (18U)      /*!< Bit position for SIM_SOPT9_TPM1CH0SRC. */
#define BM_SIM_SOPT9_TPM1CH0SRC         (0x000C0000U)  /*!< Bit mask for SIM_SOPT9_TPM1CH0SRC. */
#define BS_SIM_SOPT9_TPM1CH0SRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT9_TPM1CH0SRC. */

/*! @brief Read current value of the SIM_SOPT9_TPM1CH0SRC field. */
#define BR_SIM_SOPT9_TPM1CH0SRC(x)   (HW_SIM_SOPT9(x).B.TPM1CH0SRC)

/*! @brief Format value for bitfield SIM_SOPT9_TPM1CH0SRC. */
#define BF_SIM_SOPT9_TPM1CH0SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT9_TPM1CH0SRC) & BM_SIM_SOPT9_TPM1CH0SRC)

/*! @brief Set the TPM1CH0SRC field to a new value. */
#define BW_SIM_SOPT9_TPM1CH0SRC(x, v)   (HW_SIM_SOPT9_WR(x, (HW_SIM_SOPT9_RD(x) & ~BM_SIM_SOPT9_TPM1CH0SRC) | BF_SIM_SOPT9_TPM1CH0SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT9, field TPM2CH0SRC[21:20] (RW)
 *
 * Selects the source for TPM2 channel 0 input capture. When the TPM is not in input capture mode,
 * clear this field.
 *
 * Values:
 * - 00 - TPM2_CH0 signal
 * - 01 - CMP0 output
 * - 10 - CMP1 output
 * - 11 - Reserved
 */
/*@{*/
#define BP_SIM_SOPT9_TPM2CH0SRC         (20U)      /*!< Bit position for SIM_SOPT9_TPM2CH0SRC. */
#define BM_SIM_SOPT9_TPM2CH0SRC         (0x00300000U)  /*!< Bit mask for SIM_SOPT9_TPM2CH0SRC. */
#define BS_SIM_SOPT9_TPM2CH0SRC         (2U)  /*!< Bitfield size in bits for SIM_SOPT9_TPM2CH0SRC. */

/*! @brief Read current value of the SIM_SOPT9_TPM2CH0SRC field. */
#define BR_SIM_SOPT9_TPM2CH0SRC(x)   (HW_SIM_SOPT9(x).B.TPM2CH0SRC)

/*! @brief Format value for bitfield SIM_SOPT9_TPM2CH0SRC. */
#define BF_SIM_SOPT9_TPM2CH0SRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT9_TPM2CH0SRC) & BM_SIM_SOPT9_TPM2CH0SRC)

/*! @brief Set the TPM2CH0SRC field to a new value. */
#define BW_SIM_SOPT9_TPM2CH0SRC(x, v)   (HW_SIM_SOPT9_WR(x, (HW_SIM_SOPT9_RD(x) & ~BM_SIM_SOPT9_TPM2CH0SRC) | BF_SIM_SOPT9_TPM2CH0SRC(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT9, field TPM1CLKSEL[25] (RW)
 *
 * Selects the external pin used to drive the clock to the TPM1 module. The selected pin must also
 * be configured for the TPM external clock function through the appropriate pin control register in
 * the port control module.
 *
 * Values:
 * - 0 - TPM_CLKIN0 pin
 * - 1 - TPM_CLKIN1 pin
 */
/*@{*/
#define BP_SIM_SOPT9_TPM1CLKSEL         (25U)      /*!< Bit position for SIM_SOPT9_TPM1CLKSEL. */
#define BM_SIM_SOPT9_TPM1CLKSEL         (0x02000000U)  /*!< Bit mask for SIM_SOPT9_TPM1CLKSEL. */
#define BS_SIM_SOPT9_TPM1CLKSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT9_TPM1CLKSEL. */

/*! @brief Read current value of the SIM_SOPT9_TPM1CLKSEL field. */
#define BR_SIM_SOPT9_TPM1CLKSEL(x)   (HW_SIM_SOPT9(x).B.TPM1CLKSEL)

/*! @brief Format value for bitfield SIM_SOPT9_TPM1CLKSEL. */
#define BF_SIM_SOPT9_TPM1CLKSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT9_TPM1CLKSEL) & BM_SIM_SOPT9_TPM1CLKSEL)

/*! @brief Set the TPM1CLKSEL field to a new value. */
#define BW_SIM_SOPT9_TPM1CLKSEL(x, v)   (HW_SIM_SOPT9_WR(x, (HW_SIM_SOPT9_RD(x) & ~BM_SIM_SOPT9_TPM1CLKSEL) | BF_SIM_SOPT9_TPM1CLKSEL(v)))
/*@}*/

/*!
 * @name Register SIM_SOPT9, field TPM2CLKSEL[26] (RW)
 *
 * Selects the external pin used to drive the clock to the TPM2 module. The selected pin must also
 * be configured for the TPM external clock function through the appropriate pin control register in
 * the port control module.
 *
 * Values:
 * - 0 - TPM_CLKIN0 pin
 * - 1 - TPM_CLKIN1 pin
 */
/*@{*/
#define BP_SIM_SOPT9_TPM2CLKSEL         (26U)      /*!< Bit position for SIM_SOPT9_TPM2CLKSEL. */
#define BM_SIM_SOPT9_TPM2CLKSEL         (0x04000000U)  /*!< Bit mask for SIM_SOPT9_TPM2CLKSEL. */
#define BS_SIM_SOPT9_TPM2CLKSEL         (1U)  /*!< Bitfield size in bits for SIM_SOPT9_TPM2CLKSEL. */

/*! @brief Read current value of the SIM_SOPT9_TPM2CLKSEL field. */
#define BR_SIM_SOPT9_TPM2CLKSEL(x)   (HW_SIM_SOPT9(x).B.TPM2CLKSEL)

/*! @brief Format value for bitfield SIM_SOPT9_TPM2CLKSEL. */
#define BF_SIM_SOPT9_TPM2CLKSEL(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SOPT9_TPM2CLKSEL) & BM_SIM_SOPT9_TPM2CLKSEL)

/*! @brief Set the TPM2CLKSEL field to a new value. */
#define BW_SIM_SOPT9_TPM2CLKSEL(x, v)   (HW_SIM_SOPT9_WR(x, (HW_SIM_SOPT9_RD(x) & ~BM_SIM_SOPT9_TPM2CLKSEL) | BF_SIM_SOPT9_TPM2CLKSEL(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SDID - System Device Identification Register
 ******************************************************************************/

/*!
 * @brief HW_SIM_SDID - System Device Identification Register (RO)
 *
 * Reset value: 0x00000B80U
 */
typedef union _hw_sim_sdid
{
    uint32_t U;
    struct _hw_sim_sdid_bitfields
    {
        uint32_t PINID : 4; /*!< [3:0] Pincount identification */
        uint32_t FAMID : 3; /*!< [6:4] Kinetis family identification */
        uint32_t DIEID : 5; /*!< [11:7] Device Die ID */
        uint32_t REVID : 4; /*!< [15:12] Device revision number */
        uint32_t RESERVED0 : 4; /*!< [19:16]  */
        uint32_t SERIESID : 4; /*!< [23:20] Kinetis Series ID */
        uint32_t SUBFAMID : 4; /*!< [27:24] Kinetis Sub-Family ID */
        uint32_t FAMILYID : 4; /*!< [31:28] Kinetis Family ID */
    } B;
} hw_sim_sdid_t;

/*!
 * @name Constants and macros for entire SIM_SDID register
 */
/*@{*/
#define HW_SIM_SDID_ADDR(x)        ((x) + 0x1024U)
#define HW_SIM_SDID(x)             (*(__I  hw_sim_sdid_t *) HW_SIM_SDID_ADDR(x))
#define HW_SIM_SDID_RD(x)          (HW_SIM_SDID(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_SDID bitfields
 */

/*!
 * @name Register SIM_SDID, field PINID[3:0] (RO)
 *
 * Specifies the pincount of the device.
 *
 * Values:
 * - 0000 - Reserved
 * - 0001 - Reserved
 * - 0010 - 32-pin
 * - 0011 - Reserved
 * - 0100 - 48-pin
 * - 0101 - 64-pin
 * - 0110 - 80-pin
 * - 0111 - 81-pin or 121-pin
 * - 1000 - 100-pin
 * - 1001 - 121-pin
 * - 1010 - 144-pin
 * - 1011 - Custom pinout (WLCSP)
 * - 1100 - 169-pin
 * - 1101 - Reserved
 * - 1110 - 256-pin
 * - 1111 - Reserved
 */
/*@{*/
#define BP_SIM_SDID_PINID         (0U)      /*!< Bit position for SIM_SDID_PINID. */
#define BM_SIM_SDID_PINID         (0x0000000FU)  /*!< Bit mask for SIM_SDID_PINID. */
#define BS_SIM_SDID_PINID         (4U)  /*!< Bitfield size in bits for SIM_SDID_PINID. */

/*! @brief Read current value of the SIM_SDID_PINID field. */
#define BR_SIM_SDID_PINID(x)   (HW_SIM_SDID(x).B.PINID)
/*@}*/

/*!
 * @name Register SIM_SDID, field FAMID[6:4] (RO)
 *
 * This field is maintained for compatibility only, but has been superceded by the SERIESID,
 * FAMILYID and SUBFAMID fields in this register.
 *
 * Values:
 * - 000 - K1x Family (without tamper)
 * - 001 - K2x Family (without tamper)
 * - 010 - K3x Family or K1x/K6x Family (with tamper)
 * - 011 - K4x Family or K2x Family (with tamper)
 * - 100 - K6x Family (without tamper)
 * - 101 - K7x Family
 * - 110 - Reserved
 * - 111 - Reserved
 */
/*@{*/
#define BP_SIM_SDID_FAMID         (4U)      /*!< Bit position for SIM_SDID_FAMID. */
#define BM_SIM_SDID_FAMID         (0x00000070U)  /*!< Bit mask for SIM_SDID_FAMID. */
#define BS_SIM_SDID_FAMID         (3U)  /*!< Bitfield size in bits for SIM_SDID_FAMID. */

/*! @brief Read current value of the SIM_SDID_FAMID field. */
#define BR_SIM_SDID_FAMID(x)   (HW_SIM_SDID(x).B.FAMID)
/*@}*/

/*!
 * @name Register SIM_SDID, field DIEID[11:7] (RO)
 *
 * Specifies the silicon feature set identication number for the device.
 */
/*@{*/
#define BP_SIM_SDID_DIEID         (7U)      /*!< Bit position for SIM_SDID_DIEID. */
#define BM_SIM_SDID_DIEID         (0x00000F80U)  /*!< Bit mask for SIM_SDID_DIEID. */
#define BS_SIM_SDID_DIEID         (5U)  /*!< Bitfield size in bits for SIM_SDID_DIEID. */

/*! @brief Read current value of the SIM_SDID_DIEID field. */
#define BR_SIM_SDID_DIEID(x)   (HW_SIM_SDID(x).B.DIEID)
/*@}*/

/*!
 * @name Register SIM_SDID, field REVID[15:12] (RO)
 *
 * Specifies the silicon implementation number for the device.
 */
/*@{*/
#define BP_SIM_SDID_REVID         (12U)      /*!< Bit position for SIM_SDID_REVID. */
#define BM_SIM_SDID_REVID         (0x0000F000U)  /*!< Bit mask for SIM_SDID_REVID. */
#define BS_SIM_SDID_REVID         (4U)  /*!< Bitfield size in bits for SIM_SDID_REVID. */

/*! @brief Read current value of the SIM_SDID_REVID field. */
#define BR_SIM_SDID_REVID(x)   (HW_SIM_SDID(x).B.REVID)
/*@}*/

/*!
 * @name Register SIM_SDID, field SERIESID[23:20] (RO)
 *
 * Specifies the Kinetis series of the device.
 *
 * Values:
 * - 0000 - Kinetis K series
 * - 0001 - Kinetis L series
 * - 0101 - Kinetis W series
 * - 0110 - Kinetis V series
 */
/*@{*/
#define BP_SIM_SDID_SERIESID         (20U)      /*!< Bit position for SIM_SDID_SERIESID. */
#define BM_SIM_SDID_SERIESID         (0x00F00000U)  /*!< Bit mask for SIM_SDID_SERIESID. */
#define BS_SIM_SDID_SERIESID         (4U)  /*!< Bitfield size in bits for SIM_SDID_SERIESID. */

/*! @brief Read current value of the SIM_SDID_SERIESID field. */
#define BR_SIM_SDID_SERIESID(x)   (HW_SIM_SDID(x).B.SERIESID)
/*@}*/

/*!
 * @name Register SIM_SDID, field SUBFAMID[27:24] (RO)
 *
 * Specifies the Kinetis sub-family of the device.
 *
 * Values:
 * - 0000 - Kx0 Subfamily
 * - 0001 - Kx1 Subfamily (tamper detect)
 * - 0010 - Kx2 Subfamily
 * - 0011 - Kx3 Subfamily (tamper detect)
 * - 0100 - Kx4 Subfamily
 * - 0101 - Kx5 Subfamily (tamper detect)
 * - 0110 - Kx6 Subfamily
 */
/*@{*/
#define BP_SIM_SDID_SUBFAMID         (24U)      /*!< Bit position for SIM_SDID_SUBFAMID. */
#define BM_SIM_SDID_SUBFAMID         (0x0F000000U)  /*!< Bit mask for SIM_SDID_SUBFAMID. */
#define BS_SIM_SDID_SUBFAMID         (4U)  /*!< Bitfield size in bits for SIM_SDID_SUBFAMID. */

/*! @brief Read current value of the SIM_SDID_SUBFAMID field. */
#define BR_SIM_SDID_SUBFAMID(x)   (HW_SIM_SDID(x).B.SUBFAMID)
/*@}*/

/*!
 * @name Register SIM_SDID, field FAMILYID[31:28] (RO)
 *
 * Specifies the Kinetis family of the device.
 *
 * Values:
 * - 0000 - K0x Family
 * - 0001 - K1x Family
 * - 0010 - K2x Family
 * - 0011 - K3x Family
 * - 0100 - K4x Family
 * - 0110 - K6x Family
 * - 0111 - K7x Family
 */
/*@{*/
#define BP_SIM_SDID_FAMILYID         (28U)      /*!< Bit position for SIM_SDID_FAMILYID. */
#define BM_SIM_SDID_FAMILYID         (0xF0000000U)  /*!< Bit mask for SIM_SDID_FAMILYID. */
#define BS_SIM_SDID_FAMILYID         (4U)  /*!< Bitfield size in bits for SIM_SDID_FAMILYID. */

/*! @brief Read current value of the SIM_SDID_FAMILYID field. */
#define BR_SIM_SDID_FAMILYID(x)   (HW_SIM_SDID(x).B.FAMILYID)
/*@}*/

/*******************************************************************************
 * HW_SIM_SCGC1 - System Clock Gating Control Register 1
 ******************************************************************************/

/*!
 * @brief HW_SIM_SCGC1 - System Clock Gating Control Register 1 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_scgc1
{
    uint32_t U;
    struct _hw_sim_scgc1_bitfields
    {
        uint32_t RESERVED0 : 6; /*!< [5:0]  */
        uint32_t I2C2b : 1; /*!< [6] I2C2 Clock Gate Control */
        uint32_t I2C3b : 1; /*!< [7] I2C3 Clock Gate Control */
        uint32_t RESERVED7 : 24; /*!< [31:8] Reserved. */
    } B;
} hw_sim_scgc1_t;

/*!
 * @name Constants and macros for entire SIM_SCGC1 register
 */
/*@{*/
#define HW_SIM_SCGC1_ADDR(x)        ((x) + 0x1028U)
#define HW_SIM_SCGC1(x)             (*(__IO hw_sim_scgc1_t *) HW_SIM_SCGC1_ADDR(x))
#define HW_SIM_SCGC1_RD(x)          (HW_SIM_SCGC1(x).U)
#define HW_SIM_SCGC1_WR(x, v)       (HW_SIM_SCGC1(x).U = (v))
#define HW_SIM_SCGC1_SET(x, v)      (HW_SIM_SCGC1_WR(x, HW_SIM_SCGC1_RD(x) |  (v)))
#define HW_SIM_SCGC1_CLR(x, v)      (HW_SIM_SCGC1_WR(x, HW_SIM_SCGC1_RD(x) & ~(v)))
#define HW_SIM_SCGC1_TOG(x, v)      (HW_SIM_SCGC1_WR(x, HW_SIM_SCGC1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SCGC1 bitfields
 */

/*!
 * @name Register SIM_SCGC1, field I2C2[6] (RW)
 *
 * This bit controls the clock gate to the I2C2 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC1_I2C2         (6U)      /*!< Bit position for SIM_SCGC1_I2C2. */
#define BM_SIM_SCGC1_I2C2         (0x00000040U)  /*!< Bit mask for SIM_SCGC1_I2C2. */
#define BS_SIM_SCGC1_I2C2         (1U)  /*!< Bitfield size in bits for SIM_SCGC1_I2C2. */

/*! @brief Read current value of the SIM_SCGC1_I2C2 field. */
#define BR_SIM_SCGC1_I2C2(x)   (HW_SIM_SCGC1(x).B.I2C2)

/*! @brief Format value for bitfield SIM_SCGC1_I2C2. */
#define BF_SIM_SCGC1_I2C2(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC1_I2C2) & BM_SIM_SCGC1_I2C2)

/*! @brief Set the I2C2 field to a new value. */
#define BW_SIM_SCGC1_I2C2(x, v)   (HW_SIM_SCGC1_WR(x, (HW_SIM_SCGC1_RD(x) & ~BM_SIM_SCGC1_I2C2) | BF_SIM_SCGC1_I2C2(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC1, field I2C3[7] (RW)
 *
 * This bit controls the clock gate to the I2C3 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC1_I2C3         (7U)      /*!< Bit position for SIM_SCGC1_I2C3. */
#define BM_SIM_SCGC1_I2C3         (0x00000080U)  /*!< Bit mask for SIM_SCGC1_I2C3. */
#define BS_SIM_SCGC1_I2C3         (1U)  /*!< Bitfield size in bits for SIM_SCGC1_I2C3. */

/*! @brief Read current value of the SIM_SCGC1_I2C3 field. */
#define BR_SIM_SCGC1_I2C3(x)   (HW_SIM_SCGC1(x).B.I2C3)

/*! @brief Format value for bitfield SIM_SCGC1_I2C3. */
#define BF_SIM_SCGC1_I2C3(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC1_I2C3) & BM_SIM_SCGC1_I2C3)

/*! @brief Set the I2C3 field to a new value. */
#define BW_SIM_SCGC1_I2C3(x, v)   (HW_SIM_SCGC1_WR(x, (HW_SIM_SCGC1_RD(x) & ~BM_SIM_SCGC1_I2C3) | BF_SIM_SCGC1_I2C3(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SCGC2 - System Clock Gating Control Register 2
 ******************************************************************************/

/*!
 * @brief HW_SIM_SCGC2 - System Clock Gating Control Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_scgc2
{
    uint32_t U;
    struct _hw_sim_scgc2_bitfields
    {
        uint32_t RESERVED0 : 4; /*!< [3:0] Reserved. */
        uint32_t LPUART0b : 1; /*!< [4] LPUART0 Clock Gate Control */
        uint32_t LPUART1b : 1; /*!< [5] LPUART1 Clock Gate Control */
        uint32_t LPUART2b : 1; /*!< [6] LPUART2 Clock Gate Control */
        uint32_t LPUART3b : 1; /*!< [7] LPUART3 Clock Gate Control */
        uint32_t RESERVED1 : 1; /*!< [8]  */
        uint32_t TPM1b : 1; /*!< [9] TPM1 Clock Gate Control */
        uint32_t TPM2b : 1; /*!< [10] TPM2 Clock Gate Control */
        uint32_t RESERVED2 : 1; /*!< [11]  */
        uint32_t DAC0b : 1; /*!< [12] DAC0 Clock Gate Control */
        uint32_t RESERVED3 : 4; /*!< [16:13] Reserved. */
        uint32_t LTC : 1; /*!< [17] LTC Clock Gate Control */
        uint32_t RESERVED4 : 2; /*!< [19:18]  */
        uint32_t EMVSIM0 : 1; /*!< [20] EMVSIM0 Clock Gate Control */
        uint32_t EMVSIM1 : 1; /*!< [21] EMVSIM1 Clock Gate Control */
        uint32_t LPUART4b : 1; /*!< [22] LPUART4 Clock Gate Control */
        uint32_t RESERVED5 : 3; /*!< [25:23]  */
        uint32_t QSPI : 1; /*!< [26] QSPI Clock Gate Control */
        uint32_t RESERVED6 : 4; /*!< [30:27]  */
        uint32_t FLEXIOb : 1; /*!< [31] FlexIO Clock Gate Control */
    } B;
} hw_sim_scgc2_t;

/*!
 * @name Constants and macros for entire SIM_SCGC2 register
 */
/*@{*/
#define HW_SIM_SCGC2_ADDR(x)        ((x) + 0x102CU)
#define HW_SIM_SCGC2(x)             (*(__IO hw_sim_scgc2_t *) HW_SIM_SCGC2_ADDR(x))
#define HW_SIM_SCGC2_RD(x)          (HW_SIM_SCGC2(x).U)
#define HW_SIM_SCGC2_WR(x, v)       (HW_SIM_SCGC2(x).U = (v))
#define HW_SIM_SCGC2_SET(x, v)      (HW_SIM_SCGC2_WR(x, HW_SIM_SCGC2_RD(x) |  (v)))
#define HW_SIM_SCGC2_CLR(x, v)      (HW_SIM_SCGC2_WR(x, HW_SIM_SCGC2_RD(x) & ~(v)))
#define HW_SIM_SCGC2_TOG(x, v)      (HW_SIM_SCGC2_WR(x, HW_SIM_SCGC2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SCGC2 bitfields
 */

/*!
 * @name Register SIM_SCGC2, field LPUART0[4] (RW)
 *
 * This bit controls the clock gate to the LPUART0 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_LPUART0         (4U)      /*!< Bit position for SIM_SCGC2_LPUART0. */
#define BM_SIM_SCGC2_LPUART0         (0x00000010U)  /*!< Bit mask for SIM_SCGC2_LPUART0. */
#define BS_SIM_SCGC2_LPUART0         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_LPUART0. */

/*! @brief Read current value of the SIM_SCGC2_LPUART0 field. */
#define BR_SIM_SCGC2_LPUART0(x)   (HW_SIM_SCGC2(x).B.LPUART0)

/*! @brief Format value for bitfield SIM_SCGC2_LPUART0. */
#define BF_SIM_SCGC2_LPUART0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_LPUART0) & BM_SIM_SCGC2_LPUART0)

/*! @brief Set the LPUART0 field to a new value. */
#define BW_SIM_SCGC2_LPUART0(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_LPUART0) | BF_SIM_SCGC2_LPUART0(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field LPUART1[5] (RW)
 *
 * This bit controls the clock gate to the LPUART1 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_LPUART1         (5U)      /*!< Bit position for SIM_SCGC2_LPUART1. */
#define BM_SIM_SCGC2_LPUART1         (0x00000020U)  /*!< Bit mask for SIM_SCGC2_LPUART1. */
#define BS_SIM_SCGC2_LPUART1         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_LPUART1. */

/*! @brief Read current value of the SIM_SCGC2_LPUART1 field. */
#define BR_SIM_SCGC2_LPUART1(x)   (HW_SIM_SCGC2(x).B.LPUART1)

/*! @brief Format value for bitfield SIM_SCGC2_LPUART1. */
#define BF_SIM_SCGC2_LPUART1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_LPUART1) & BM_SIM_SCGC2_LPUART1)

/*! @brief Set the LPUART1 field to a new value. */
#define BW_SIM_SCGC2_LPUART1(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_LPUART1) | BF_SIM_SCGC2_LPUART1(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field LPUART2[6] (RW)
 *
 * This bit controls the clock gate to the LPUART2 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_LPUART2         (6U)      /*!< Bit position for SIM_SCGC2_LPUART2. */
#define BM_SIM_SCGC2_LPUART2         (0x00000040U)  /*!< Bit mask for SIM_SCGC2_LPUART2. */
#define BS_SIM_SCGC2_LPUART2         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_LPUART2. */

/*! @brief Read current value of the SIM_SCGC2_LPUART2 field. */
#define BR_SIM_SCGC2_LPUART2(x)   (HW_SIM_SCGC2(x).B.LPUART2)

/*! @brief Format value for bitfield SIM_SCGC2_LPUART2. */
#define BF_SIM_SCGC2_LPUART2(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_LPUART2) & BM_SIM_SCGC2_LPUART2)

/*! @brief Set the LPUART2 field to a new value. */
#define BW_SIM_SCGC2_LPUART2(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_LPUART2) | BF_SIM_SCGC2_LPUART2(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field LPUART3[7] (RW)
 *
 * This bit controls the clock gate to the LPUART3 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_LPUART3         (7U)      /*!< Bit position for SIM_SCGC2_LPUART3. */
#define BM_SIM_SCGC2_LPUART3         (0x00000080U)  /*!< Bit mask for SIM_SCGC2_LPUART3. */
#define BS_SIM_SCGC2_LPUART3         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_LPUART3. */

/*! @brief Read current value of the SIM_SCGC2_LPUART3 field. */
#define BR_SIM_SCGC2_LPUART3(x)   (HW_SIM_SCGC2(x).B.LPUART3)

/*! @brief Format value for bitfield SIM_SCGC2_LPUART3. */
#define BF_SIM_SCGC2_LPUART3(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_LPUART3) & BM_SIM_SCGC2_LPUART3)

/*! @brief Set the LPUART3 field to a new value. */
#define BW_SIM_SCGC2_LPUART3(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_LPUART3) | BF_SIM_SCGC2_LPUART3(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field TPM1[9] (RW)
 *
 * This bit controls the clock gate to the TPM1 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_TPM1         (9U)      /*!< Bit position for SIM_SCGC2_TPM1. */
#define BM_SIM_SCGC2_TPM1         (0x00000200U)  /*!< Bit mask for SIM_SCGC2_TPM1. */
#define BS_SIM_SCGC2_TPM1         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_TPM1. */

/*! @brief Read current value of the SIM_SCGC2_TPM1 field. */
#define BR_SIM_SCGC2_TPM1(x)   (HW_SIM_SCGC2(x).B.TPM1)

/*! @brief Format value for bitfield SIM_SCGC2_TPM1. */
#define BF_SIM_SCGC2_TPM1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_TPM1) & BM_SIM_SCGC2_TPM1)

/*! @brief Set the TPM1 field to a new value. */
#define BW_SIM_SCGC2_TPM1(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_TPM1) | BF_SIM_SCGC2_TPM1(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field TPM2[10] (RW)
 *
 * This bit controls the clock gate to the TPM2 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_TPM2         (10U)      /*!< Bit position for SIM_SCGC2_TPM2. */
#define BM_SIM_SCGC2_TPM2         (0x00000400U)  /*!< Bit mask for SIM_SCGC2_TPM2. */
#define BS_SIM_SCGC2_TPM2         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_TPM2. */

/*! @brief Read current value of the SIM_SCGC2_TPM2 field. */
#define BR_SIM_SCGC2_TPM2(x)   (HW_SIM_SCGC2(x).B.TPM2)

/*! @brief Format value for bitfield SIM_SCGC2_TPM2. */
#define BF_SIM_SCGC2_TPM2(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_TPM2) & BM_SIM_SCGC2_TPM2)

/*! @brief Set the TPM2 field to a new value. */
#define BW_SIM_SCGC2_TPM2(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_TPM2) | BF_SIM_SCGC2_TPM2(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field DAC0[12] (RW)
 *
 * This bit controls the clock gate to the DAC0 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_DAC0         (12U)      /*!< Bit position for SIM_SCGC2_DAC0. */
#define BM_SIM_SCGC2_DAC0         (0x00001000U)  /*!< Bit mask for SIM_SCGC2_DAC0. */
#define BS_SIM_SCGC2_DAC0         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_DAC0. */

/*! @brief Read current value of the SIM_SCGC2_DAC0 field. */
#define BR_SIM_SCGC2_DAC0(x)   (HW_SIM_SCGC2(x).B.DAC0)

/*! @brief Format value for bitfield SIM_SCGC2_DAC0. */
#define BF_SIM_SCGC2_DAC0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_DAC0) & BM_SIM_SCGC2_DAC0)

/*! @brief Set the DAC0 field to a new value. */
#define BW_SIM_SCGC2_DAC0(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_DAC0) | BF_SIM_SCGC2_DAC0(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field LTC[17] (RW)
 *
 * This bit controls the clock gate to the LTC module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_LTC         (17U)      /*!< Bit position for SIM_SCGC2_LTC. */
#define BM_SIM_SCGC2_LTC         (0x00020000U)  /*!< Bit mask for SIM_SCGC2_LTC. */
#define BS_SIM_SCGC2_LTC         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_LTC. */

/*! @brief Read current value of the SIM_SCGC2_LTC field. */
#define BR_SIM_SCGC2_LTC(x)   (HW_SIM_SCGC2(x).B.LTC)

/*! @brief Format value for bitfield SIM_SCGC2_LTC. */
#define BF_SIM_SCGC2_LTC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_LTC) & BM_SIM_SCGC2_LTC)

/*! @brief Set the LTC field to a new value. */
#define BW_SIM_SCGC2_LTC(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_LTC) | BF_SIM_SCGC2_LTC(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field EMVSIM0[20] (RW)
 *
 * This bit controls the clock gate to the EMVSIM0 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_EMVSIM0         (20U)      /*!< Bit position for SIM_SCGC2_EMVSIM0. */
#define BM_SIM_SCGC2_EMVSIM0         (0x00100000U)  /*!< Bit mask for SIM_SCGC2_EMVSIM0. */
#define BS_SIM_SCGC2_EMVSIM0         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_EMVSIM0. */

/*! @brief Read current value of the SIM_SCGC2_EMVSIM0 field. */
#define BR_SIM_SCGC2_EMVSIM0(x)   (HW_SIM_SCGC2(x).B.EMVSIM0)

/*! @brief Format value for bitfield SIM_SCGC2_EMVSIM0. */
#define BF_SIM_SCGC2_EMVSIM0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_EMVSIM0) & BM_SIM_SCGC2_EMVSIM0)

/*! @brief Set the EMVSIM0 field to a new value. */
#define BW_SIM_SCGC2_EMVSIM0(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_EMVSIM0) | BF_SIM_SCGC2_EMVSIM0(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field EMVSIM1[21] (RW)
 *
 * This bit controls the clock gate to the EMVSIM1 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_EMVSIM1         (21U)      /*!< Bit position for SIM_SCGC2_EMVSIM1. */
#define BM_SIM_SCGC2_EMVSIM1         (0x00200000U)  /*!< Bit mask for SIM_SCGC2_EMVSIM1. */
#define BS_SIM_SCGC2_EMVSIM1         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_EMVSIM1. */

/*! @brief Read current value of the SIM_SCGC2_EMVSIM1 field. */
#define BR_SIM_SCGC2_EMVSIM1(x)   (HW_SIM_SCGC2(x).B.EMVSIM1)

/*! @brief Format value for bitfield SIM_SCGC2_EMVSIM1. */
#define BF_SIM_SCGC2_EMVSIM1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_EMVSIM1) & BM_SIM_SCGC2_EMVSIM1)

/*! @brief Set the EMVSIM1 field to a new value. */
#define BW_SIM_SCGC2_EMVSIM1(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_EMVSIM1) | BF_SIM_SCGC2_EMVSIM1(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field LPUART4[22] (RW)
 *
 * This bit controls the clock gate to the LPUART4 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_LPUART4         (22U)      /*!< Bit position for SIM_SCGC2_LPUART4. */
#define BM_SIM_SCGC2_LPUART4         (0x00400000U)  /*!< Bit mask for SIM_SCGC2_LPUART4. */
#define BS_SIM_SCGC2_LPUART4         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_LPUART4. */

/*! @brief Read current value of the SIM_SCGC2_LPUART4 field. */
#define BR_SIM_SCGC2_LPUART4(x)   (HW_SIM_SCGC2(x).B.LPUART4)

/*! @brief Format value for bitfield SIM_SCGC2_LPUART4. */
#define BF_SIM_SCGC2_LPUART4(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_LPUART4) & BM_SIM_SCGC2_LPUART4)

/*! @brief Set the LPUART4 field to a new value. */
#define BW_SIM_SCGC2_LPUART4(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_LPUART4) | BF_SIM_SCGC2_LPUART4(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field QSPI[26] (RW)
 *
 * This bit controls the clock gate to the QuadSPI module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_QSPI         (26U)      /*!< Bit position for SIM_SCGC2_QSPI. */
#define BM_SIM_SCGC2_QSPI         (0x04000000U)  /*!< Bit mask for SIM_SCGC2_QSPI. */
#define BS_SIM_SCGC2_QSPI         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_QSPI. */

/*! @brief Read current value of the SIM_SCGC2_QSPI field. */
#define BR_SIM_SCGC2_QSPI(x)   (HW_SIM_SCGC2(x).B.QSPI)

/*! @brief Format value for bitfield SIM_SCGC2_QSPI. */
#define BF_SIM_SCGC2_QSPI(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_QSPI) & BM_SIM_SCGC2_QSPI)

/*! @brief Set the QSPI field to a new value. */
#define BW_SIM_SCGC2_QSPI(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_QSPI) | BF_SIM_SCGC2_QSPI(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC2, field FLEXIO[31] (RW)
 *
 * This bit controls the clock gate to the FlexIO module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC2_FLEXIO         (31U)      /*!< Bit position for SIM_SCGC2_FLEXIO. */
#define BM_SIM_SCGC2_FLEXIO         (0x80000000U)  /*!< Bit mask for SIM_SCGC2_FLEXIO. */
#define BS_SIM_SCGC2_FLEXIO         (1U)  /*!< Bitfield size in bits for SIM_SCGC2_FLEXIO. */

/*! @brief Read current value of the SIM_SCGC2_FLEXIO field. */
#define BR_SIM_SCGC2_FLEXIO(x)   (HW_SIM_SCGC2(x).B.FLEXIO)

/*! @brief Format value for bitfield SIM_SCGC2_FLEXIO. */
#define BF_SIM_SCGC2_FLEXIO(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC2_FLEXIO) & BM_SIM_SCGC2_FLEXIO)

/*! @brief Set the FLEXIO field to a new value. */
#define BW_SIM_SCGC2_FLEXIO(x, v)   (HW_SIM_SCGC2_WR(x, (HW_SIM_SCGC2_RD(x) & ~BM_SIM_SCGC2_FLEXIO) | BF_SIM_SCGC2_FLEXIO(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SCGC3 - System Clock Gating Control Register 3
 ******************************************************************************/

/*!
 * @brief HW_SIM_SCGC3 - System Clock Gating Control Register 3 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_scgc3
{
    uint32_t U;
    struct _hw_sim_scgc3_bitfields
    {
        uint32_t TRNG : 1; /*!< [0] TRNG Clock Gate Control */
        uint32_t RESERVED1 : 11; /*!< [11:1] Reserved. */
        uint32_t SPI2b : 1; /*!< [12] SPI2 Clock Gate Control */
        uint32_t RESERVED2 : 4; /*!< [16:13]  */
        uint32_t SDHC : 1; /*!< [17] SDHC Clock Gate Control */
        uint32_t RESERVED3 : 6; /*!< [23:18]  */
        uint32_t FTM2 : 1; /*!< [24] FTM2 Clock Gate Control */
        uint32_t FTM3 : 1; /*!< [25] FTM3 Clock Gate Control */
        uint32_t RESERVED7 : 6; /*!< [31:26] Reserved. */
    } B;
} hw_sim_scgc3_t;

/*!
 * @name Constants and macros for entire SIM_SCGC3 register
 */
/*@{*/
#define HW_SIM_SCGC3_ADDR(x)        ((x) + 0x1030U)
#define HW_SIM_SCGC3(x)             (*(__IO hw_sim_scgc3_t *) HW_SIM_SCGC3_ADDR(x))
#define HW_SIM_SCGC3_RD(x)          (HW_SIM_SCGC3(x).U)
#define HW_SIM_SCGC3_WR(x, v)       (HW_SIM_SCGC3(x).U = (v))
#define HW_SIM_SCGC3_SET(x, v)      (HW_SIM_SCGC3_WR(x, HW_SIM_SCGC3_RD(x) |  (v)))
#define HW_SIM_SCGC3_CLR(x, v)      (HW_SIM_SCGC3_WR(x, HW_SIM_SCGC3_RD(x) & ~(v)))
#define HW_SIM_SCGC3_TOG(x, v)      (HW_SIM_SCGC3_WR(x, HW_SIM_SCGC3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SCGC3 bitfields
 */

/*!
 * @name Register SIM_SCGC3, field TRNG[0] (RW)
 *
 * This bit controls the clock gate to the TRNG module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC3_TRNG         (0U)      /*!< Bit position for SIM_SCGC3_TRNG. */
#define BM_SIM_SCGC3_TRNG         (0x00000001U)  /*!< Bit mask for SIM_SCGC3_TRNG. */
#define BS_SIM_SCGC3_TRNG         (1U)  /*!< Bitfield size in bits for SIM_SCGC3_TRNG. */

/*! @brief Read current value of the SIM_SCGC3_TRNG field. */
#define BR_SIM_SCGC3_TRNG(x)   (HW_SIM_SCGC3(x).B.TRNG)

/*! @brief Format value for bitfield SIM_SCGC3_TRNG. */
#define BF_SIM_SCGC3_TRNG(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC3_TRNG) & BM_SIM_SCGC3_TRNG)

/*! @brief Set the TRNG field to a new value. */
#define BW_SIM_SCGC3_TRNG(x, v)   (HW_SIM_SCGC3_WR(x, (HW_SIM_SCGC3_RD(x) & ~BM_SIM_SCGC3_TRNG) | BF_SIM_SCGC3_TRNG(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC3, field SPI2[12] (RW)
 *
 * This bit controls the clock gate to the SPI2 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC3_SPI2         (12U)      /*!< Bit position for SIM_SCGC3_SPI2. */
#define BM_SIM_SCGC3_SPI2         (0x00001000U)  /*!< Bit mask for SIM_SCGC3_SPI2. */
#define BS_SIM_SCGC3_SPI2         (1U)  /*!< Bitfield size in bits for SIM_SCGC3_SPI2. */

/*! @brief Read current value of the SIM_SCGC3_SPI2 field. */
#define BR_SIM_SCGC3_SPI2(x)   (HW_SIM_SCGC3(x).B.SPI2)

/*! @brief Format value for bitfield SIM_SCGC3_SPI2. */
#define BF_SIM_SCGC3_SPI2(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC3_SPI2) & BM_SIM_SCGC3_SPI2)

/*! @brief Set the SPI2 field to a new value. */
#define BW_SIM_SCGC3_SPI2(x, v)   (HW_SIM_SCGC3_WR(x, (HW_SIM_SCGC3_RD(x) & ~BM_SIM_SCGC3_SPI2) | BF_SIM_SCGC3_SPI2(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC3, field SDHC[17] (RW)
 *
 * This bit controls the clock gate to the SDHC module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC3_SDHC         (17U)      /*!< Bit position for SIM_SCGC3_SDHC. */
#define BM_SIM_SCGC3_SDHC         (0x00020000U)  /*!< Bit mask for SIM_SCGC3_SDHC. */
#define BS_SIM_SCGC3_SDHC         (1U)  /*!< Bitfield size in bits for SIM_SCGC3_SDHC. */

/*! @brief Read current value of the SIM_SCGC3_SDHC field. */
#define BR_SIM_SCGC3_SDHC(x)   (HW_SIM_SCGC3(x).B.SDHC)

/*! @brief Format value for bitfield SIM_SCGC3_SDHC. */
#define BF_SIM_SCGC3_SDHC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC3_SDHC) & BM_SIM_SCGC3_SDHC)

/*! @brief Set the SDHC field to a new value. */
#define BW_SIM_SCGC3_SDHC(x, v)   (HW_SIM_SCGC3_WR(x, (HW_SIM_SCGC3_RD(x) & ~BM_SIM_SCGC3_SDHC) | BF_SIM_SCGC3_SDHC(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC3, field FTM2[24] (RW)
 *
 * This bit controls the clock gate to the FTM2 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC3_FTM2         (24U)      /*!< Bit position for SIM_SCGC3_FTM2. */
#define BM_SIM_SCGC3_FTM2         (0x01000000U)  /*!< Bit mask for SIM_SCGC3_FTM2. */
#define BS_SIM_SCGC3_FTM2         (1U)  /*!< Bitfield size in bits for SIM_SCGC3_FTM2. */

/*! @brief Read current value of the SIM_SCGC3_FTM2 field. */
#define BR_SIM_SCGC3_FTM2(x)   (HW_SIM_SCGC3(x).B.FTM2)

/*! @brief Format value for bitfield SIM_SCGC3_FTM2. */
#define BF_SIM_SCGC3_FTM2(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC3_FTM2) & BM_SIM_SCGC3_FTM2)

/*! @brief Set the FTM2 field to a new value. */
#define BW_SIM_SCGC3_FTM2(x, v)   (HW_SIM_SCGC3_WR(x, (HW_SIM_SCGC3_RD(x) & ~BM_SIM_SCGC3_FTM2) | BF_SIM_SCGC3_FTM2(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC3, field FTM3[25] (RW)
 *
 * This bit controls the clock gate to the FTM3 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC3_FTM3         (25U)      /*!< Bit position for SIM_SCGC3_FTM3. */
#define BM_SIM_SCGC3_FTM3         (0x02000000U)  /*!< Bit mask for SIM_SCGC3_FTM3. */
#define BS_SIM_SCGC3_FTM3         (1U)  /*!< Bitfield size in bits for SIM_SCGC3_FTM3. */

/*! @brief Read current value of the SIM_SCGC3_FTM3 field. */
#define BR_SIM_SCGC3_FTM3(x)   (HW_SIM_SCGC3(x).B.FTM3)

/*! @brief Format value for bitfield SIM_SCGC3_FTM3. */
#define BF_SIM_SCGC3_FTM3(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC3_FTM3) & BM_SIM_SCGC3_FTM3)

/*! @brief Set the FTM3 field to a new value. */
#define BW_SIM_SCGC3_FTM3(x, v)   (HW_SIM_SCGC3_WR(x, (HW_SIM_SCGC3_RD(x) & ~BM_SIM_SCGC3_FTM3) | BF_SIM_SCGC3_FTM3(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SCGC4 - System Clock Gating Control Register 4
 ******************************************************************************/

/*!
 * @brief HW_SIM_SCGC4 - System Clock Gating Control Register 4 (RW)
 *
 * Reset value: 0xF0100030U
 */
typedef union _hw_sim_scgc4
{
    uint32_t U;
    struct _hw_sim_scgc4_bitfields
    {
        uint32_t RESERVED0 : 1; /*!< [0]  */
        uint32_t EWM : 1; /*!< [1] EWM Clock Gate Control */
        uint32_t CMT : 1; /*!< [2] CMT Clock Gate Control */
        uint32_t RESERVED1 : 3; /*!< [5:3] Reserved. */
        uint32_t I2C0b : 1; /*!< [6] I2C0 Clock Gate Control */
        uint32_t I2C1b : 1; /*!< [7] I2C1 Clock Gate Control */
        uint32_t RESERVED6 : 10; /*!< [17:8] Reserved. */
        uint32_t USBOTG : 1; /*!< [18] USB Clock Gate Control */
        uint32_t CMPb : 1; /*!< [19] Comparator Clock Gate Control */
        uint32_t VREFb : 1; /*!< [20] VREF Clock Gate Control */
        uint32_t RESERVED7 : 11; /*!< [31:21] Reserved. */
    } B;
} hw_sim_scgc4_t;

/*!
 * @name Constants and macros for entire SIM_SCGC4 register
 */
/*@{*/
#define HW_SIM_SCGC4_ADDR(x)        ((x) + 0x1034U)
#define HW_SIM_SCGC4(x)             (*(__IO hw_sim_scgc4_t *) HW_SIM_SCGC4_ADDR(x))
#define HW_SIM_SCGC4_RD(x)          (HW_SIM_SCGC4(x).U)
#define HW_SIM_SCGC4_WR(x, v)       (HW_SIM_SCGC4(x).U = (v))
#define HW_SIM_SCGC4_SET(x, v)      (HW_SIM_SCGC4_WR(x, HW_SIM_SCGC4_RD(x) |  (v)))
#define HW_SIM_SCGC4_CLR(x, v)      (HW_SIM_SCGC4_WR(x, HW_SIM_SCGC4_RD(x) & ~(v)))
#define HW_SIM_SCGC4_TOG(x, v)      (HW_SIM_SCGC4_WR(x, HW_SIM_SCGC4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SCGC4 bitfields
 */

/*!
 * @name Register SIM_SCGC4, field EWM[1] (RW)
 *
 * This bit controls the clock gate to the EWM module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC4_EWM         (1U)      /*!< Bit position for SIM_SCGC4_EWM. */
#define BM_SIM_SCGC4_EWM         (0x00000002U)  /*!< Bit mask for SIM_SCGC4_EWM. */
#define BS_SIM_SCGC4_EWM         (1U)  /*!< Bitfield size in bits for SIM_SCGC4_EWM. */

/*! @brief Read current value of the SIM_SCGC4_EWM field. */
#define BR_SIM_SCGC4_EWM(x)   (HW_SIM_SCGC4(x).B.EWM)

/*! @brief Format value for bitfield SIM_SCGC4_EWM. */
#define BF_SIM_SCGC4_EWM(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC4_EWM) & BM_SIM_SCGC4_EWM)

/*! @brief Set the EWM field to a new value. */
#define BW_SIM_SCGC4_EWM(x, v)   (HW_SIM_SCGC4_WR(x, (HW_SIM_SCGC4_RD(x) & ~BM_SIM_SCGC4_EWM) | BF_SIM_SCGC4_EWM(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC4, field CMT[2] (RW)
 *
 * This bit controls the clock gate to the CMT module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC4_CMT         (2U)      /*!< Bit position for SIM_SCGC4_CMT. */
#define BM_SIM_SCGC4_CMT         (0x00000004U)  /*!< Bit mask for SIM_SCGC4_CMT. */
#define BS_SIM_SCGC4_CMT         (1U)  /*!< Bitfield size in bits for SIM_SCGC4_CMT. */

/*! @brief Read current value of the SIM_SCGC4_CMT field. */
#define BR_SIM_SCGC4_CMT(x)   (HW_SIM_SCGC4(x).B.CMT)

/*! @brief Format value for bitfield SIM_SCGC4_CMT. */
#define BF_SIM_SCGC4_CMT(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC4_CMT) & BM_SIM_SCGC4_CMT)

/*! @brief Set the CMT field to a new value. */
#define BW_SIM_SCGC4_CMT(x, v)   (HW_SIM_SCGC4_WR(x, (HW_SIM_SCGC4_RD(x) & ~BM_SIM_SCGC4_CMT) | BF_SIM_SCGC4_CMT(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC4, field I2C0[6] (RW)
 *
 * This bit controls the clock gate to the I 2 C0 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC4_I2C0         (6U)      /*!< Bit position for SIM_SCGC4_I2C0. */
#define BM_SIM_SCGC4_I2C0         (0x00000040U)  /*!< Bit mask for SIM_SCGC4_I2C0. */
#define BS_SIM_SCGC4_I2C0         (1U)  /*!< Bitfield size in bits for SIM_SCGC4_I2C0. */

/*! @brief Read current value of the SIM_SCGC4_I2C0 field. */
#define BR_SIM_SCGC4_I2C0(x)   (HW_SIM_SCGC4(x).B.I2C0)

/*! @brief Format value for bitfield SIM_SCGC4_I2C0. */
#define BF_SIM_SCGC4_I2C0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC4_I2C0) & BM_SIM_SCGC4_I2C0)

/*! @brief Set the I2C0 field to a new value. */
#define BW_SIM_SCGC4_I2C0(x, v)   (HW_SIM_SCGC4_WR(x, (HW_SIM_SCGC4_RD(x) & ~BM_SIM_SCGC4_I2C0) | BF_SIM_SCGC4_I2C0(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC4, field I2C1[7] (RW)
 *
 * This bit controls the clock gate to the I 2 C1 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC4_I2C1         (7U)      /*!< Bit position for SIM_SCGC4_I2C1. */
#define BM_SIM_SCGC4_I2C1         (0x00000080U)  /*!< Bit mask for SIM_SCGC4_I2C1. */
#define BS_SIM_SCGC4_I2C1         (1U)  /*!< Bitfield size in bits for SIM_SCGC4_I2C1. */

/*! @brief Read current value of the SIM_SCGC4_I2C1 field. */
#define BR_SIM_SCGC4_I2C1(x)   (HW_SIM_SCGC4(x).B.I2C1)

/*! @brief Format value for bitfield SIM_SCGC4_I2C1. */
#define BF_SIM_SCGC4_I2C1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC4_I2C1) & BM_SIM_SCGC4_I2C1)

/*! @brief Set the I2C1 field to a new value. */
#define BW_SIM_SCGC4_I2C1(x, v)   (HW_SIM_SCGC4_WR(x, (HW_SIM_SCGC4_RD(x) & ~BM_SIM_SCGC4_I2C1) | BF_SIM_SCGC4_I2C1(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC4, field USBOTG[18] (RW)
 *
 * This bit controls the clock gate to the USB module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC4_USBOTG         (18U)      /*!< Bit position for SIM_SCGC4_USBOTG. */
#define BM_SIM_SCGC4_USBOTG         (0x00040000U)  /*!< Bit mask for SIM_SCGC4_USBOTG. */
#define BS_SIM_SCGC4_USBOTG         (1U)  /*!< Bitfield size in bits for SIM_SCGC4_USBOTG. */

/*! @brief Read current value of the SIM_SCGC4_USBOTG field. */
#define BR_SIM_SCGC4_USBOTG(x)   (HW_SIM_SCGC4(x).B.USBOTG)

/*! @brief Format value for bitfield SIM_SCGC4_USBOTG. */
#define BF_SIM_SCGC4_USBOTG(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC4_USBOTG) & BM_SIM_SCGC4_USBOTG)

/*! @brief Set the USBOTG field to a new value. */
#define BW_SIM_SCGC4_USBOTG(x, v)   (HW_SIM_SCGC4_WR(x, (HW_SIM_SCGC4_RD(x) & ~BM_SIM_SCGC4_USBOTG) | BF_SIM_SCGC4_USBOTG(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC4, field CMP[19] (RW)
 *
 * This bit controls the clock gate to the comparator module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC4_CMP         (19U)      /*!< Bit position for SIM_SCGC4_CMP. */
#define BM_SIM_SCGC4_CMP         (0x00080000U)  /*!< Bit mask for SIM_SCGC4_CMP. */
#define BS_SIM_SCGC4_CMP         (1U)  /*!< Bitfield size in bits for SIM_SCGC4_CMP. */

/*! @brief Read current value of the SIM_SCGC4_CMP field. */
#define BR_SIM_SCGC4_CMP(x)   (HW_SIM_SCGC4(x).B.CMP)

/*! @brief Format value for bitfield SIM_SCGC4_CMP. */
#define BF_SIM_SCGC4_CMP(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC4_CMP) & BM_SIM_SCGC4_CMP)

/*! @brief Set the CMP field to a new value. */
#define BW_SIM_SCGC4_CMP(x, v)   (HW_SIM_SCGC4_WR(x, (HW_SIM_SCGC4_RD(x) & ~BM_SIM_SCGC4_CMP) | BF_SIM_SCGC4_CMP(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC4, field VREF[20] (RW)
 *
 * This bit controls the clock gate to the VREF module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC4_VREF         (20U)      /*!< Bit position for SIM_SCGC4_VREF. */
#define BM_SIM_SCGC4_VREF         (0x00100000U)  /*!< Bit mask for SIM_SCGC4_VREF. */
#define BS_SIM_SCGC4_VREF         (1U)  /*!< Bitfield size in bits for SIM_SCGC4_VREF. */

/*! @brief Read current value of the SIM_SCGC4_VREF field. */
#define BR_SIM_SCGC4_VREF(x)   (HW_SIM_SCGC4(x).B.VREF)

/*! @brief Format value for bitfield SIM_SCGC4_VREF. */
#define BF_SIM_SCGC4_VREF(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC4_VREF) & BM_SIM_SCGC4_VREF)

/*! @brief Set the VREF field to a new value. */
#define BW_SIM_SCGC4_VREF(x, v)   (HW_SIM_SCGC4_WR(x, (HW_SIM_SCGC4_RD(x) & ~BM_SIM_SCGC4_VREF) | BF_SIM_SCGC4_VREF(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SCGC5 - System Clock Gating Control Register 5
 ******************************************************************************/

/*!
 * @brief HW_SIM_SCGC5 - System Clock Gating Control Register 5 (RW)
 *
 * Reset value: 0x00040182U
 */
typedef union _hw_sim_scgc5
{
    uint32_t U;
    struct _hw_sim_scgc5_bitfields
    {
        uint32_t LPTMRb : 1; /*!< [0] Low Power Timer Access Control */
        uint32_t RESERVED0 : 1; /*!< [1]  */
        uint32_t DRYICE : 1; /*!< [2] DryIce Access Control */
        uint32_t SECREG : 1; /*!< [3] Secure Register Access Control */
        uint32_t LPTMR1 : 1; /*!< [4] LPTMR1 Clock Gate Control */
        uint32_t TSI : 1; /*!< [5] TSI Clock Gate Control */
        uint32_t RESERVED1 : 3; /*!< [8:6] Reserved. */
        uint32_t PORTAb : 1; /*!< [9] Port A Clock Gate Control */
        uint32_t PORTBb : 1; /*!< [10] Port B Clock Gate Control */
        uint32_t PORTCb : 1; /*!< [11] Port C Clock Gate Control */
        uint32_t PORTDb : 1; /*!< [12] Port D Clock Gate Control */
        uint32_t PORTEb : 1; /*!< [13] Port E Clock Gate Control */
        uint32_t RESERVED3 : 18; /*!< [31:14] Reserved. */
    } B;
} hw_sim_scgc5_t;

/*!
 * @name Constants and macros for entire SIM_SCGC5 register
 */
/*@{*/
#define HW_SIM_SCGC5_ADDR(x)        ((x) + 0x1038U)
#define HW_SIM_SCGC5(x)             (*(__IO hw_sim_scgc5_t *) HW_SIM_SCGC5_ADDR(x))
#define HW_SIM_SCGC5_RD(x)          (HW_SIM_SCGC5(x).U)
#define HW_SIM_SCGC5_WR(x, v)       (HW_SIM_SCGC5(x).U = (v))
#define HW_SIM_SCGC5_SET(x, v)      (HW_SIM_SCGC5_WR(x, HW_SIM_SCGC5_RD(x) |  (v)))
#define HW_SIM_SCGC5_CLR(x, v)      (HW_SIM_SCGC5_WR(x, HW_SIM_SCGC5_RD(x) & ~(v)))
#define HW_SIM_SCGC5_TOG(x, v)      (HW_SIM_SCGC5_WR(x, HW_SIM_SCGC5_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SCGC5 bitfields
 */

/*!
 * @name Register SIM_SCGC5, field LPTMR[0] (RW)
 *
 * This bit controls software access to the Low Power Timer module.
 *
 * Values:
 * - 0 - Access disabled
 * - 1 - Access enabled
 */
/*@{*/
#define BP_SIM_SCGC5_LPTMR         (0U)      /*!< Bit position for SIM_SCGC5_LPTMR. */
#define BM_SIM_SCGC5_LPTMR         (0x00000001U)  /*!< Bit mask for SIM_SCGC5_LPTMR. */
#define BS_SIM_SCGC5_LPTMR         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_LPTMR. */

/*! @brief Read current value of the SIM_SCGC5_LPTMR field. */
#define BR_SIM_SCGC5_LPTMR(x)   (HW_SIM_SCGC5(x).B.LPTMR)

/*! @brief Format value for bitfield SIM_SCGC5_LPTMR. */
#define BF_SIM_SCGC5_LPTMR(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_LPTMR) & BM_SIM_SCGC5_LPTMR)

/*! @brief Set the LPTMR field to a new value. */
#define BW_SIM_SCGC5_LPTMR(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_LPTMR) | BF_SIM_SCGC5_LPTMR(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field DRYICE[2] (RW)
 *
 * This bit controls software access and interrupt of the DryIce module.
 *
 * Values:
 * - 0 - Access and interrupt disabled
 * - 1 - Access and interrupt enabled
 */
/*@{*/
#define BP_SIM_SCGC5_DRYICE         (2U)      /*!< Bit position for SIM_SCGC5_DRYICE. */
#define BM_SIM_SCGC5_DRYICE         (0x00000004U)  /*!< Bit mask for SIM_SCGC5_DRYICE. */
#define BS_SIM_SCGC5_DRYICE         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_DRYICE. */

/*! @brief Read current value of the SIM_SCGC5_DRYICE field. */
#define BR_SIM_SCGC5_DRYICE(x)   (HW_SIM_SCGC5(x).B.DRYICE)

/*! @brief Format value for bitfield SIM_SCGC5_DRYICE. */
#define BF_SIM_SCGC5_DRYICE(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_DRYICE) & BM_SIM_SCGC5_DRYICE)

/*! @brief Set the DRYICE field to a new value. */
#define BW_SIM_SCGC5_DRYICE(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_DRYICE) | BF_SIM_SCGC5_DRYICE(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field SECREG[3] (RW)
 *
 * This bit controls software access to the DryIce Secure Registers.
 *
 * Values:
 * - 0 - Access disabled
 * - 1 - Access enabled
 */
/*@{*/
#define BP_SIM_SCGC5_SECREG         (3U)      /*!< Bit position for SIM_SCGC5_SECREG. */
#define BM_SIM_SCGC5_SECREG         (0x00000008U)  /*!< Bit mask for SIM_SCGC5_SECREG. */
#define BS_SIM_SCGC5_SECREG         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_SECREG. */

/*! @brief Read current value of the SIM_SCGC5_SECREG field. */
#define BR_SIM_SCGC5_SECREG(x)   (HW_SIM_SCGC5(x).B.SECREG)

/*! @brief Format value for bitfield SIM_SCGC5_SECREG. */
#define BF_SIM_SCGC5_SECREG(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_SECREG) & BM_SIM_SCGC5_SECREG)

/*! @brief Set the SECREG field to a new value. */
#define BW_SIM_SCGC5_SECREG(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_SECREG) | BF_SIM_SCGC5_SECREG(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field LPTMR1[4] (RW)
 *
 * This bit controls software access to the LPTMR1 module.
 *
 * Values:
 * - 0 - Access disabled
 * - 1 - Access enabled
 */
/*@{*/
#define BP_SIM_SCGC5_LPTMR1         (4U)      /*!< Bit position for SIM_SCGC5_LPTMR1. */
#define BM_SIM_SCGC5_LPTMR1         (0x00000010U)  /*!< Bit mask for SIM_SCGC5_LPTMR1. */
#define BS_SIM_SCGC5_LPTMR1         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_LPTMR1. */

/*! @brief Read current value of the SIM_SCGC5_LPTMR1 field. */
#define BR_SIM_SCGC5_LPTMR1(x)   (HW_SIM_SCGC5(x).B.LPTMR1)

/*! @brief Format value for bitfield SIM_SCGC5_LPTMR1. */
#define BF_SIM_SCGC5_LPTMR1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_LPTMR1) & BM_SIM_SCGC5_LPTMR1)

/*! @brief Set the LPTMR1 field to a new value. */
#define BW_SIM_SCGC5_LPTMR1(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_LPTMR1) | BF_SIM_SCGC5_LPTMR1(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field TSI[5] (RW)
 *
 * This bit controls the clock gate to the TSI module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC5_TSI         (5U)      /*!< Bit position for SIM_SCGC5_TSI. */
#define BM_SIM_SCGC5_TSI         (0x00000020U)  /*!< Bit mask for SIM_SCGC5_TSI. */
#define BS_SIM_SCGC5_TSI         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_TSI. */

/*! @brief Read current value of the SIM_SCGC5_TSI field. */
#define BR_SIM_SCGC5_TSI(x)   (HW_SIM_SCGC5(x).B.TSI)

/*! @brief Format value for bitfield SIM_SCGC5_TSI. */
#define BF_SIM_SCGC5_TSI(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_TSI) & BM_SIM_SCGC5_TSI)

/*! @brief Set the TSI field to a new value. */
#define BW_SIM_SCGC5_TSI(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_TSI) | BF_SIM_SCGC5_TSI(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field PORTA[9] (RW)
 *
 * This bit controls the clock gate to the Port A module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC5_PORTA         (9U)      /*!< Bit position for SIM_SCGC5_PORTA. */
#define BM_SIM_SCGC5_PORTA         (0x00000200U)  /*!< Bit mask for SIM_SCGC5_PORTA. */
#define BS_SIM_SCGC5_PORTA         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_PORTA. */

/*! @brief Read current value of the SIM_SCGC5_PORTA field. */
#define BR_SIM_SCGC5_PORTA(x)   (HW_SIM_SCGC5(x).B.PORTA)

/*! @brief Format value for bitfield SIM_SCGC5_PORTA. */
#define BF_SIM_SCGC5_PORTA(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_PORTA) & BM_SIM_SCGC5_PORTA)

/*! @brief Set the PORTA field to a new value. */
#define BW_SIM_SCGC5_PORTA(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_PORTA) | BF_SIM_SCGC5_PORTA(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field PORTB[10] (RW)
 *
 * This bit controls the clock gate to the Port B module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC5_PORTB         (10U)      /*!< Bit position for SIM_SCGC5_PORTB. */
#define BM_SIM_SCGC5_PORTB         (0x00000400U)  /*!< Bit mask for SIM_SCGC5_PORTB. */
#define BS_SIM_SCGC5_PORTB         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_PORTB. */

/*! @brief Read current value of the SIM_SCGC5_PORTB field. */
#define BR_SIM_SCGC5_PORTB(x)   (HW_SIM_SCGC5(x).B.PORTB)

/*! @brief Format value for bitfield SIM_SCGC5_PORTB. */
#define BF_SIM_SCGC5_PORTB(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_PORTB) & BM_SIM_SCGC5_PORTB)

/*! @brief Set the PORTB field to a new value. */
#define BW_SIM_SCGC5_PORTB(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_PORTB) | BF_SIM_SCGC5_PORTB(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field PORTC[11] (RW)
 *
 * This bit controls the clock gate to the Port C module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC5_PORTC         (11U)      /*!< Bit position for SIM_SCGC5_PORTC. */
#define BM_SIM_SCGC5_PORTC         (0x00000800U)  /*!< Bit mask for SIM_SCGC5_PORTC. */
#define BS_SIM_SCGC5_PORTC         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_PORTC. */

/*! @brief Read current value of the SIM_SCGC5_PORTC field. */
#define BR_SIM_SCGC5_PORTC(x)   (HW_SIM_SCGC5(x).B.PORTC)

/*! @brief Format value for bitfield SIM_SCGC5_PORTC. */
#define BF_SIM_SCGC5_PORTC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_PORTC) & BM_SIM_SCGC5_PORTC)

/*! @brief Set the PORTC field to a new value. */
#define BW_SIM_SCGC5_PORTC(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_PORTC) | BF_SIM_SCGC5_PORTC(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field PORTD[12] (RW)
 *
 * This bit controls the clock gate to the Port D module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC5_PORTD         (12U)      /*!< Bit position for SIM_SCGC5_PORTD. */
#define BM_SIM_SCGC5_PORTD         (0x00001000U)  /*!< Bit mask for SIM_SCGC5_PORTD. */
#define BS_SIM_SCGC5_PORTD         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_PORTD. */

/*! @brief Read current value of the SIM_SCGC5_PORTD field. */
#define BR_SIM_SCGC5_PORTD(x)   (HW_SIM_SCGC5(x).B.PORTD)

/*! @brief Format value for bitfield SIM_SCGC5_PORTD. */
#define BF_SIM_SCGC5_PORTD(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_PORTD) & BM_SIM_SCGC5_PORTD)

/*! @brief Set the PORTD field to a new value. */
#define BW_SIM_SCGC5_PORTD(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_PORTD) | BF_SIM_SCGC5_PORTD(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC5, field PORTE[13] (RW)
 *
 * This bit controls the clock gate to the Port E module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC5_PORTE         (13U)      /*!< Bit position for SIM_SCGC5_PORTE. */
#define BM_SIM_SCGC5_PORTE         (0x00002000U)  /*!< Bit mask for SIM_SCGC5_PORTE. */
#define BS_SIM_SCGC5_PORTE         (1U)  /*!< Bitfield size in bits for SIM_SCGC5_PORTE. */

/*! @brief Read current value of the SIM_SCGC5_PORTE field. */
#define BR_SIM_SCGC5_PORTE(x)   (HW_SIM_SCGC5(x).B.PORTE)

/*! @brief Format value for bitfield SIM_SCGC5_PORTE. */
#define BF_SIM_SCGC5_PORTE(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC5_PORTE) & BM_SIM_SCGC5_PORTE)

/*! @brief Set the PORTE field to a new value. */
#define BW_SIM_SCGC5_PORTE(x, v)   (HW_SIM_SCGC5_WR(x, (HW_SIM_SCGC5_RD(x) & ~BM_SIM_SCGC5_PORTE) | BF_SIM_SCGC5_PORTE(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SCGC6 - System Clock Gating Control Register 6
 ******************************************************************************/

/*!
 * @brief HW_SIM_SCGC6 - System Clock Gating Control Register 6 (RW)
 *
 * Reset value: 0x40000001U
 *
 * DAC0, FTM2 can be accessed through both AIPS0 and AIPS1. When accessing through AIPS1, define the
 * clock gate control bits in the SCGC2 and SCGC3. When accessing through AIPS0, define the clock
 * gate control bits in SCGC6. See the Chip Configuration chapter for the base addresses of FTM2,
 * and DAC0 accessed via AIPS0 and AIPS1.
 */
typedef union _hw_sim_scgc6
{
    uint32_t U;
    struct _hw_sim_scgc6_bitfields
    {
        uint32_t FTFb : 1; /*!< [0] Flash Memory Clock Gate Control */
        uint32_t DMAMUX : 1; /*!< [1] DMA Mux Clock Gate Control */
        uint32_t RESERVED3 : 10; /*!< [11:2] Reserved. */
        uint32_t SPI0b : 1; /*!< [12] SPI0 Clock Gate Control */
        uint32_t SPI1b : 1; /*!< [13] SPI1 Clock Gate Control */
        uint32_t RESERVED4 : 1; /*!< [14]  */
        uint32_t I2Sb : 1; /*!< [15] I2S Clock Gate Control */
        uint32_t RESERVED5 : 2; /*!< [17:16]  */
        uint32_t CRCb : 1; /*!< [18] CRC Clock Gate Control */
        uint32_t RESERVED6 : 2; /*!< [20:19]  */
        uint32_t USBDCD : 1; /*!< [21] USB DCD Clock Gate Control */
        uint32_t PDB : 1; /*!< [22] PDB Clock Gate Control */
        uint32_t PITb : 1; /*!< [23] PIT Clock Gate Control */
        uint32_t FTM0 : 1; /*!< [24] FTM0 Clock Gate Control */
        uint32_t FTM1 : 1; /*!< [25] FTM1 Clock Gate Control */
        uint32_t FTM2 : 1; /*!< [26] FTM2 Clock Gate Control */
        uint32_t ADC0b : 1; /*!< [27] ADC0 Clock Gate Control */
        uint32_t RESERVED7 : 1; /*!< [28]  */
        uint32_t RTCb : 1; /*!< [29] RTC Access Control */
        uint32_t RESERVED8 : 1; /*!< [30]  */
        uint32_t DAC0b : 1; /*!< [31] DAC0 Clock Gate Control */
    } B;
} hw_sim_scgc6_t;

/*!
 * @name Constants and macros for entire SIM_SCGC6 register
 */
/*@{*/
#define HW_SIM_SCGC6_ADDR(x)        ((x) + 0x103CU)
#define HW_SIM_SCGC6(x)             (*(__IO hw_sim_scgc6_t *) HW_SIM_SCGC6_ADDR(x))
#define HW_SIM_SCGC6_RD(x)          (HW_SIM_SCGC6(x).U)
#define HW_SIM_SCGC6_WR(x, v)       (HW_SIM_SCGC6(x).U = (v))
#define HW_SIM_SCGC6_SET(x, v)      (HW_SIM_SCGC6_WR(x, HW_SIM_SCGC6_RD(x) |  (v)))
#define HW_SIM_SCGC6_CLR(x, v)      (HW_SIM_SCGC6_WR(x, HW_SIM_SCGC6_RD(x) & ~(v)))
#define HW_SIM_SCGC6_TOG(x, v)      (HW_SIM_SCGC6_WR(x, HW_SIM_SCGC6_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SCGC6 bitfields
 */

/*!
 * @name Register SIM_SCGC6, field FTF[0] (RW)
 *
 * This bit controls the clock gate to the flash memory. Flash reads are still supported while the
 * flash memory is clock gated, but entry into low power modes is blocked.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_FTF         (0U)      /*!< Bit position for SIM_SCGC6_FTF. */
#define BM_SIM_SCGC6_FTF         (0x00000001U)  /*!< Bit mask for SIM_SCGC6_FTF. */
#define BS_SIM_SCGC6_FTF         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_FTF. */

/*! @brief Read current value of the SIM_SCGC6_FTF field. */
#define BR_SIM_SCGC6_FTF(x)   (HW_SIM_SCGC6(x).B.FTF)

/*! @brief Format value for bitfield SIM_SCGC6_FTF. */
#define BF_SIM_SCGC6_FTF(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_FTF) & BM_SIM_SCGC6_FTF)

/*! @brief Set the FTF field to a new value. */
#define BW_SIM_SCGC6_FTF(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_FTF) | BF_SIM_SCGC6_FTF(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field DMAMUX[1] (RW)
 *
 * This bit controls the clock gate to the DMA Mux module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_DMAMUX         (1U)      /*!< Bit position for SIM_SCGC6_DMAMUX. */
#define BM_SIM_SCGC6_DMAMUX         (0x00000002U)  /*!< Bit mask for SIM_SCGC6_DMAMUX. */
#define BS_SIM_SCGC6_DMAMUX         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_DMAMUX. */

/*! @brief Read current value of the SIM_SCGC6_DMAMUX field. */
#define BR_SIM_SCGC6_DMAMUX(x)   (HW_SIM_SCGC6(x).B.DMAMUX)

/*! @brief Format value for bitfield SIM_SCGC6_DMAMUX. */
#define BF_SIM_SCGC6_DMAMUX(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_DMAMUX) & BM_SIM_SCGC6_DMAMUX)

/*! @brief Set the DMAMUX field to a new value. */
#define BW_SIM_SCGC6_DMAMUX(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_DMAMUX) | BF_SIM_SCGC6_DMAMUX(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field SPI0[12] (RW)
 *
 * This bit controls the clock gate to the SPI0 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_SPI0         (12U)      /*!< Bit position for SIM_SCGC6_SPI0. */
#define BM_SIM_SCGC6_SPI0         (0x00001000U)  /*!< Bit mask for SIM_SCGC6_SPI0. */
#define BS_SIM_SCGC6_SPI0         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_SPI0. */

/*! @brief Read current value of the SIM_SCGC6_SPI0 field. */
#define BR_SIM_SCGC6_SPI0(x)   (HW_SIM_SCGC6(x).B.SPI0)

/*! @brief Format value for bitfield SIM_SCGC6_SPI0. */
#define BF_SIM_SCGC6_SPI0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_SPI0) & BM_SIM_SCGC6_SPI0)

/*! @brief Set the SPI0 field to a new value. */
#define BW_SIM_SCGC6_SPI0(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_SPI0) | BF_SIM_SCGC6_SPI0(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field SPI1[13] (RW)
 *
 * This bit controls the clock gate to the SPI1 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_SPI1         (13U)      /*!< Bit position for SIM_SCGC6_SPI1. */
#define BM_SIM_SCGC6_SPI1         (0x00002000U)  /*!< Bit mask for SIM_SCGC6_SPI1. */
#define BS_SIM_SCGC6_SPI1         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_SPI1. */

/*! @brief Read current value of the SIM_SCGC6_SPI1 field. */
#define BR_SIM_SCGC6_SPI1(x)   (HW_SIM_SCGC6(x).B.SPI1)

/*! @brief Format value for bitfield SIM_SCGC6_SPI1. */
#define BF_SIM_SCGC6_SPI1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_SPI1) & BM_SIM_SCGC6_SPI1)

/*! @brief Set the SPI1 field to a new value. */
#define BW_SIM_SCGC6_SPI1(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_SPI1) | BF_SIM_SCGC6_SPI1(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field I2S[15] (RW)
 *
 * This bit controls the clock gate to the I 2 S module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_I2S         (15U)      /*!< Bit position for SIM_SCGC6_I2S. */
#define BM_SIM_SCGC6_I2S         (0x00008000U)  /*!< Bit mask for SIM_SCGC6_I2S. */
#define BS_SIM_SCGC6_I2S         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_I2S. */

/*! @brief Read current value of the SIM_SCGC6_I2S field. */
#define BR_SIM_SCGC6_I2S(x)   (HW_SIM_SCGC6(x).B.I2S)

/*! @brief Format value for bitfield SIM_SCGC6_I2S. */
#define BF_SIM_SCGC6_I2S(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_I2S) & BM_SIM_SCGC6_I2S)

/*! @brief Set the I2S field to a new value. */
#define BW_SIM_SCGC6_I2S(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_I2S) | BF_SIM_SCGC6_I2S(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field CRC[18] (RW)
 *
 * This bit controls the clock gate to the CRC module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_CRC         (18U)      /*!< Bit position for SIM_SCGC6_CRC. */
#define BM_SIM_SCGC6_CRC         (0x00040000U)  /*!< Bit mask for SIM_SCGC6_CRC. */
#define BS_SIM_SCGC6_CRC         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_CRC. */

/*! @brief Read current value of the SIM_SCGC6_CRC field. */
#define BR_SIM_SCGC6_CRC(x)   (HW_SIM_SCGC6(x).B.CRC)

/*! @brief Format value for bitfield SIM_SCGC6_CRC. */
#define BF_SIM_SCGC6_CRC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_CRC) & BM_SIM_SCGC6_CRC)

/*! @brief Set the CRC field to a new value. */
#define BW_SIM_SCGC6_CRC(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_CRC) | BF_SIM_SCGC6_CRC(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field USBDCD[21] (RW)
 *
 * This bit controls the clock gate to the USB DCD module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_USBDCD         (21U)      /*!< Bit position for SIM_SCGC6_USBDCD. */
#define BM_SIM_SCGC6_USBDCD         (0x00200000U)  /*!< Bit mask for SIM_SCGC6_USBDCD. */
#define BS_SIM_SCGC6_USBDCD         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_USBDCD. */

/*! @brief Read current value of the SIM_SCGC6_USBDCD field. */
#define BR_SIM_SCGC6_USBDCD(x)   (HW_SIM_SCGC6(x).B.USBDCD)

/*! @brief Format value for bitfield SIM_SCGC6_USBDCD. */
#define BF_SIM_SCGC6_USBDCD(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_USBDCD) & BM_SIM_SCGC6_USBDCD)

/*! @brief Set the USBDCD field to a new value. */
#define BW_SIM_SCGC6_USBDCD(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_USBDCD) | BF_SIM_SCGC6_USBDCD(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field PDB[22] (RW)
 *
 * This bit controls the clock gate to the PDB module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_PDB         (22U)      /*!< Bit position for SIM_SCGC6_PDB. */
#define BM_SIM_SCGC6_PDB         (0x00400000U)  /*!< Bit mask for SIM_SCGC6_PDB. */
#define BS_SIM_SCGC6_PDB         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_PDB. */

/*! @brief Read current value of the SIM_SCGC6_PDB field. */
#define BR_SIM_SCGC6_PDB(x)   (HW_SIM_SCGC6(x).B.PDB)

/*! @brief Format value for bitfield SIM_SCGC6_PDB. */
#define BF_SIM_SCGC6_PDB(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_PDB) & BM_SIM_SCGC6_PDB)

/*! @brief Set the PDB field to a new value. */
#define BW_SIM_SCGC6_PDB(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_PDB) | BF_SIM_SCGC6_PDB(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field PIT[23] (RW)
 *
 * This bit controls the clock gate to the PIT module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_PIT         (23U)      /*!< Bit position for SIM_SCGC6_PIT. */
#define BM_SIM_SCGC6_PIT         (0x00800000U)  /*!< Bit mask for SIM_SCGC6_PIT. */
#define BS_SIM_SCGC6_PIT         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_PIT. */

/*! @brief Read current value of the SIM_SCGC6_PIT field. */
#define BR_SIM_SCGC6_PIT(x)   (HW_SIM_SCGC6(x).B.PIT)

/*! @brief Format value for bitfield SIM_SCGC6_PIT. */
#define BF_SIM_SCGC6_PIT(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_PIT) & BM_SIM_SCGC6_PIT)

/*! @brief Set the PIT field to a new value. */
#define BW_SIM_SCGC6_PIT(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_PIT) | BF_SIM_SCGC6_PIT(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field FTM0[24] (RW)
 *
 * This bit controls the clock gate to the FTM0 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_FTM0         (24U)      /*!< Bit position for SIM_SCGC6_FTM0. */
#define BM_SIM_SCGC6_FTM0         (0x01000000U)  /*!< Bit mask for SIM_SCGC6_FTM0. */
#define BS_SIM_SCGC6_FTM0         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_FTM0. */

/*! @brief Read current value of the SIM_SCGC6_FTM0 field. */
#define BR_SIM_SCGC6_FTM0(x)   (HW_SIM_SCGC6(x).B.FTM0)

/*! @brief Format value for bitfield SIM_SCGC6_FTM0. */
#define BF_SIM_SCGC6_FTM0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_FTM0) & BM_SIM_SCGC6_FTM0)

/*! @brief Set the FTM0 field to a new value. */
#define BW_SIM_SCGC6_FTM0(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_FTM0) | BF_SIM_SCGC6_FTM0(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field FTM1[25] (RW)
 *
 * This bit controls the clock gate to the FTM1 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_FTM1         (25U)      /*!< Bit position for SIM_SCGC6_FTM1. */
#define BM_SIM_SCGC6_FTM1         (0x02000000U)  /*!< Bit mask for SIM_SCGC6_FTM1. */
#define BS_SIM_SCGC6_FTM1         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_FTM1. */

/*! @brief Read current value of the SIM_SCGC6_FTM1 field. */
#define BR_SIM_SCGC6_FTM1(x)   (HW_SIM_SCGC6(x).B.FTM1)

/*! @brief Format value for bitfield SIM_SCGC6_FTM1. */
#define BF_SIM_SCGC6_FTM1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_FTM1) & BM_SIM_SCGC6_FTM1)

/*! @brief Set the FTM1 field to a new value. */
#define BW_SIM_SCGC6_FTM1(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_FTM1) | BF_SIM_SCGC6_FTM1(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field FTM2[26] (RW)
 *
 * This bit controls the clock gate to the FTM2 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_FTM2         (26U)      /*!< Bit position for SIM_SCGC6_FTM2. */
#define BM_SIM_SCGC6_FTM2         (0x04000000U)  /*!< Bit mask for SIM_SCGC6_FTM2. */
#define BS_SIM_SCGC6_FTM2         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_FTM2. */

/*! @brief Read current value of the SIM_SCGC6_FTM2 field. */
#define BR_SIM_SCGC6_FTM2(x)   (HW_SIM_SCGC6(x).B.FTM2)

/*! @brief Format value for bitfield SIM_SCGC6_FTM2. */
#define BF_SIM_SCGC6_FTM2(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_FTM2) & BM_SIM_SCGC6_FTM2)

/*! @brief Set the FTM2 field to a new value. */
#define BW_SIM_SCGC6_FTM2(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_FTM2) | BF_SIM_SCGC6_FTM2(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field ADC0[27] (RW)
 *
 * This bit controls the clock gate to the ADC0 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_ADC0         (27U)      /*!< Bit position for SIM_SCGC6_ADC0. */
#define BM_SIM_SCGC6_ADC0         (0x08000000U)  /*!< Bit mask for SIM_SCGC6_ADC0. */
#define BS_SIM_SCGC6_ADC0         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_ADC0. */

/*! @brief Read current value of the SIM_SCGC6_ADC0 field. */
#define BR_SIM_SCGC6_ADC0(x)   (HW_SIM_SCGC6(x).B.ADC0)

/*! @brief Format value for bitfield SIM_SCGC6_ADC0. */
#define BF_SIM_SCGC6_ADC0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_ADC0) & BM_SIM_SCGC6_ADC0)

/*! @brief Set the ADC0 field to a new value. */
#define BW_SIM_SCGC6_ADC0(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_ADC0) | BF_SIM_SCGC6_ADC0(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field RTC[29] (RW)
 *
 * This bit controls software access and interrupts to the RTC module.
 *
 * Values:
 * - 0 - Access and interrupts disabled
 * - 1 - Access and interrupts enabled
 */
/*@{*/
#define BP_SIM_SCGC6_RTC         (29U)      /*!< Bit position for SIM_SCGC6_RTC. */
#define BM_SIM_SCGC6_RTC         (0x20000000U)  /*!< Bit mask for SIM_SCGC6_RTC. */
#define BS_SIM_SCGC6_RTC         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_RTC. */

/*! @brief Read current value of the SIM_SCGC6_RTC field. */
#define BR_SIM_SCGC6_RTC(x)   (HW_SIM_SCGC6(x).B.RTC)

/*! @brief Format value for bitfield SIM_SCGC6_RTC. */
#define BF_SIM_SCGC6_RTC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_RTC) & BM_SIM_SCGC6_RTC)

/*! @brief Set the RTC field to a new value. */
#define BW_SIM_SCGC6_RTC(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_RTC) | BF_SIM_SCGC6_RTC(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC6, field DAC0[31] (RW)
 *
 * This bit controls the clock gate to the DAC0 module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC6_DAC0         (31U)      /*!< Bit position for SIM_SCGC6_DAC0. */
#define BM_SIM_SCGC6_DAC0         (0x80000000U)  /*!< Bit mask for SIM_SCGC6_DAC0. */
#define BS_SIM_SCGC6_DAC0         (1U)  /*!< Bitfield size in bits for SIM_SCGC6_DAC0. */

/*! @brief Read current value of the SIM_SCGC6_DAC0 field. */
#define BR_SIM_SCGC6_DAC0(x)   (HW_SIM_SCGC6(x).B.DAC0)

/*! @brief Format value for bitfield SIM_SCGC6_DAC0. */
#define BF_SIM_SCGC6_DAC0(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC6_DAC0) & BM_SIM_SCGC6_DAC0)

/*! @brief Set the DAC0 field to a new value. */
#define BW_SIM_SCGC6_DAC0(x, v)   (HW_SIM_SCGC6_WR(x, (HW_SIM_SCGC6_RD(x) & ~BM_SIM_SCGC6_DAC0) | BF_SIM_SCGC6_DAC0(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SCGC7 - System Clock Gating Control Register 7
 ******************************************************************************/

/*!
 * @brief HW_SIM_SCGC7 - System Clock Gating Control Register 7 (RW)
 *
 * Reset value: 0x00000006U
 */
typedef union _hw_sim_scgc7
{
    uint32_t U;
    struct _hw_sim_scgc7_bitfields
    {
        uint32_t FLEXBUS : 1; /*!< [0] FlexBus Clock Gate Control */
        uint32_t DMA : 1; /*!< [1] DMA Clock Gate Control */
        uint32_t MPU : 1; /*!< [2] MPU Clock Gate Control */
        uint32_t SDRAMC : 1; /*!< [3] SDRAMC Clock Gate Control */
        uint32_t RESERVED0 : 28; /*!< [31:4]  */
    } B;
} hw_sim_scgc7_t;

/*!
 * @name Constants and macros for entire SIM_SCGC7 register
 */
/*@{*/
#define HW_SIM_SCGC7_ADDR(x)        ((x) + 0x1040U)
#define HW_SIM_SCGC7(x)             (*(__IO hw_sim_scgc7_t *) HW_SIM_SCGC7_ADDR(x))
#define HW_SIM_SCGC7_RD(x)          (HW_SIM_SCGC7(x).U)
#define HW_SIM_SCGC7_WR(x, v)       (HW_SIM_SCGC7(x).U = (v))
#define HW_SIM_SCGC7_SET(x, v)      (HW_SIM_SCGC7_WR(x, HW_SIM_SCGC7_RD(x) |  (v)))
#define HW_SIM_SCGC7_CLR(x, v)      (HW_SIM_SCGC7_WR(x, HW_SIM_SCGC7_RD(x) & ~(v)))
#define HW_SIM_SCGC7_TOG(x, v)      (HW_SIM_SCGC7_WR(x, HW_SIM_SCGC7_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_SCGC7 bitfields
 */

/*!
 * @name Register SIM_SCGC7, field FLEXBUS[0] (RW)
 *
 * This bit controls the clock gate to the FlexBus module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC7_FLEXBUS         (0U)      /*!< Bit position for SIM_SCGC7_FLEXBUS. */
#define BM_SIM_SCGC7_FLEXBUS         (0x00000001U)  /*!< Bit mask for SIM_SCGC7_FLEXBUS. */
#define BS_SIM_SCGC7_FLEXBUS         (1U)  /*!< Bitfield size in bits for SIM_SCGC7_FLEXBUS. */

/*! @brief Read current value of the SIM_SCGC7_FLEXBUS field. */
#define BR_SIM_SCGC7_FLEXBUS(x)   (HW_SIM_SCGC7(x).B.FLEXBUS)

/*! @brief Format value for bitfield SIM_SCGC7_FLEXBUS. */
#define BF_SIM_SCGC7_FLEXBUS(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC7_FLEXBUS) & BM_SIM_SCGC7_FLEXBUS)

/*! @brief Set the FLEXBUS field to a new value. */
#define BW_SIM_SCGC7_FLEXBUS(x, v)   (HW_SIM_SCGC7_WR(x, (HW_SIM_SCGC7_RD(x) & ~BM_SIM_SCGC7_FLEXBUS) | BF_SIM_SCGC7_FLEXBUS(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC7, field DMA[1] (RW)
 *
 * This bit controls the clock gate to the DMA module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC7_DMA         (1U)      /*!< Bit position for SIM_SCGC7_DMA. */
#define BM_SIM_SCGC7_DMA         (0x00000002U)  /*!< Bit mask for SIM_SCGC7_DMA. */
#define BS_SIM_SCGC7_DMA         (1U)  /*!< Bitfield size in bits for SIM_SCGC7_DMA. */

/*! @brief Read current value of the SIM_SCGC7_DMA field. */
#define BR_SIM_SCGC7_DMA(x)   (HW_SIM_SCGC7(x).B.DMA)

/*! @brief Format value for bitfield SIM_SCGC7_DMA. */
#define BF_SIM_SCGC7_DMA(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC7_DMA) & BM_SIM_SCGC7_DMA)

/*! @brief Set the DMA field to a new value. */
#define BW_SIM_SCGC7_DMA(x, v)   (HW_SIM_SCGC7_WR(x, (HW_SIM_SCGC7_RD(x) & ~BM_SIM_SCGC7_DMA) | BF_SIM_SCGC7_DMA(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC7, field MPU[2] (RW)
 *
 * This bit controls the clock gate to the MPU module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC7_MPU         (2U)      /*!< Bit position for SIM_SCGC7_MPU. */
#define BM_SIM_SCGC7_MPU         (0x00000004U)  /*!< Bit mask for SIM_SCGC7_MPU. */
#define BS_SIM_SCGC7_MPU         (1U)  /*!< Bitfield size in bits for SIM_SCGC7_MPU. */

/*! @brief Read current value of the SIM_SCGC7_MPU field. */
#define BR_SIM_SCGC7_MPU(x)   (HW_SIM_SCGC7(x).B.MPU)

/*! @brief Format value for bitfield SIM_SCGC7_MPU. */
#define BF_SIM_SCGC7_MPU(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC7_MPU) & BM_SIM_SCGC7_MPU)

/*! @brief Set the MPU field to a new value. */
#define BW_SIM_SCGC7_MPU(x, v)   (HW_SIM_SCGC7_WR(x, (HW_SIM_SCGC7_RD(x) & ~BM_SIM_SCGC7_MPU) | BF_SIM_SCGC7_MPU(v)))
/*@}*/

/*!
 * @name Register SIM_SCGC7, field SDRAMC[3] (RW)
 *
 * This bit controls the clock gate to the SDRAMC module.
 *
 * Values:
 * - 0 - Clock disabled
 * - 1 - Clock enabled
 */
/*@{*/
#define BP_SIM_SCGC7_SDRAMC         (3U)      /*!< Bit position for SIM_SCGC7_SDRAMC. */
#define BM_SIM_SCGC7_SDRAMC         (0x00000008U)  /*!< Bit mask for SIM_SCGC7_SDRAMC. */
#define BS_SIM_SCGC7_SDRAMC         (1U)  /*!< Bitfield size in bits for SIM_SCGC7_SDRAMC. */

/*! @brief Read current value of the SIM_SCGC7_SDRAMC field. */
#define BR_SIM_SCGC7_SDRAMC(x)   (HW_SIM_SCGC7(x).B.SDRAMC)

/*! @brief Format value for bitfield SIM_SCGC7_SDRAMC. */
#define BF_SIM_SCGC7_SDRAMC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_SCGC7_SDRAMC) & BM_SIM_SCGC7_SDRAMC)

/*! @brief Set the SDRAMC field to a new value. */
#define BW_SIM_SCGC7_SDRAMC(x, v)   (HW_SIM_SCGC7_WR(x, (HW_SIM_SCGC7_RD(x) & ~BM_SIM_SCGC7_SDRAMC) | BF_SIM_SCGC7_SDRAMC(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_CLKDIV1 - System Clock Divider Register 1
 ******************************************************************************/

/*!
 * @brief HW_SIM_CLKDIV1 - System Clock Divider Register 1 (RW)
 *
 * Reset value: 0x10000EEAEADEDDEEEEFFFFBU
 *
 * When updating CLKDIV1, update all fields using the one write command. Attempting to write an
 * invalid clock ratio to the CLKDIV1 register will cause the write to be ignored. The maximum
 * divide ratio that can be programmed between core/system clock and the other divided clocks is
 * divide by 8. When OUTDIV1 equals 0000 (divide by 1), the other dividers cannot be set higher than
 * 0111 (divide by 8). The CLKDIV1 register cannot be written to when the device is in VLPR mode.
 */
typedef union _hw_sim_clkdiv1
{
    uint32_t U;
    struct _hw_sim_clkdiv1_bitfields
    {
        uint32_t RESERVED0 : 16; /*!< [15:0]  */
        uint32_t OUTDIV4 : 4; /*!< [19:16] Clock 4 output divider value */
        uint32_t OUTDIV3 : 4; /*!< [23:20] Clock 3 output divider value */
        uint32_t OUTDIV2 : 4; /*!< [27:24] Clock 2 output divider value */
        uint32_t OUTDIV1 : 4; /*!< [31:28] Clock 1 output divider value */
    } B;
} hw_sim_clkdiv1_t;

/*!
 * @name Constants and macros for entire SIM_CLKDIV1 register
 */
/*@{*/
#define HW_SIM_CLKDIV1_ADDR(x)        ((x) + 0x1044U)
#define HW_SIM_CLKDIV1(x)             (*(__IO hw_sim_clkdiv1_t *) HW_SIM_CLKDIV1_ADDR(x))
#define HW_SIM_CLKDIV1_RD(x)          (HW_SIM_CLKDIV1(x).U)
#define HW_SIM_CLKDIV1_WR(x, v)       (HW_SIM_CLKDIV1(x).U = (v))
#define HW_SIM_CLKDIV1_SET(x, v)      (HW_SIM_CLKDIV1_WR(x, HW_SIM_CLKDIV1_RD(x) |  (v)))
#define HW_SIM_CLKDIV1_CLR(x, v)      (HW_SIM_CLKDIV1_WR(x, HW_SIM_CLKDIV1_RD(x) & ~(v)))
#define HW_SIM_CLKDIV1_TOG(x, v)      (HW_SIM_CLKDIV1_WR(x, HW_SIM_CLKDIV1_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_CLKDIV1 bitfields
 */

/*!
 * @name Register SIM_CLKDIV1, field OUTDIV4[19:16] (RW)
 *
 * This field sets the divide value for the flash clock from MCGOUTCLK. At the end of reset, it is
 * loaded with either 0001 or 1111 depending on FTF_FOPT[LPBOOT]. The flash clock frequency must be
 * an integer divide of the system clock frequency.
 *
 * Values:
 * - 0000 - Divide-by-1.
 * - 0001 - Divide-by-2.
 * - 0010 - Divide-by-3.
 * - 0011 - Divide-by-4.
 * - 0100 - Divide-by-5.
 * - 0101 - Divide-by-6.
 * - 0110 - Divide-by-7.
 * - 0111 - Divide-by-8.
 * - 1000 - Divide-by-9.
 * - 1001 - Divide-by-10.
 * - 1010 - Divide-by-11.
 * - 1011 - Divide-by-12.
 * - 1100 - Divide-by-13.
 * - 1101 - Divide-by-14.
 * - 1110 - Divide-by-15.
 * - 1111 - Divide-by-16.
 */
/*@{*/
#define BP_SIM_CLKDIV1_OUTDIV4         (16U)      /*!< Bit position for SIM_CLKDIV1_OUTDIV4. */
#define BM_SIM_CLKDIV1_OUTDIV4         (0x000F0000U)  /*!< Bit mask for SIM_CLKDIV1_OUTDIV4. */
#define BS_SIM_CLKDIV1_OUTDIV4         (4U)  /*!< Bitfield size in bits for SIM_CLKDIV1_OUTDIV4. */

/*! @brief Read current value of the SIM_CLKDIV1_OUTDIV4 field. */
#define BR_SIM_CLKDIV1_OUTDIV4(x)   (HW_SIM_CLKDIV1(x).B.OUTDIV4)

/*! @brief Format value for bitfield SIM_CLKDIV1_OUTDIV4. */
#define BF_SIM_CLKDIV1_OUTDIV4(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV1_OUTDIV4) & BM_SIM_CLKDIV1_OUTDIV4)

/*! @brief Set the OUTDIV4 field to a new value. */
#define BW_SIM_CLKDIV1_OUTDIV4(x, v)   (HW_SIM_CLKDIV1_WR(x, (HW_SIM_CLKDIV1_RD(x) & ~BM_SIM_CLKDIV1_OUTDIV4) | BF_SIM_CLKDIV1_OUTDIV4(v)))
/*@}*/

/*!
 * @name Register SIM_CLKDIV1, field OUTDIV3[23:20] (RW)
 *
 * This field sets the divide value for the FlexBus clock (external pin FB_CLK) from MCGOUTCLK. At
 * the end of reset, it is loaded with either 0001 or 1111 depending on FTF_FOPT[LPBOOT]. The
 * FlexBus clock frequency must be an integer divide of the system clock frequency.
 *
 * Values:
 * - 0000 - Divide-by-1.
 * - 0001 - Divide-by-2.
 * - 0010 - Divide-by-3.
 * - 0011 - Divide-by-4.
 * - 0100 - Divide-by-5.
 * - 0101 - Divide-by-6.
 * - 0110 - Divide-by-7.
 * - 0111 - Divide-by-8.
 * - 1000 - Divide-by-9.
 * - 1001 - Divide-by-10.
 * - 1010 - Divide-by-11.
 * - 1011 - Divide-by-12.
 * - 1100 - Divide-by-13.
 * - 1101 - Divide-by-14.
 * - 1110 - Divide-by-15.
 * - 1111 - Divide-by-16.
 */
/*@{*/
#define BP_SIM_CLKDIV1_OUTDIV3         (20U)      /*!< Bit position for SIM_CLKDIV1_OUTDIV3. */
#define BM_SIM_CLKDIV1_OUTDIV3         (0x00F00000U)  /*!< Bit mask for SIM_CLKDIV1_OUTDIV3. */
#define BS_SIM_CLKDIV1_OUTDIV3         (4U)  /*!< Bitfield size in bits for SIM_CLKDIV1_OUTDIV3. */

/*! @brief Read current value of the SIM_CLKDIV1_OUTDIV3 field. */
#define BR_SIM_CLKDIV1_OUTDIV3(x)   (HW_SIM_CLKDIV1(x).B.OUTDIV3)

/*! @brief Format value for bitfield SIM_CLKDIV1_OUTDIV3. */
#define BF_SIM_CLKDIV1_OUTDIV3(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV1_OUTDIV3) & BM_SIM_CLKDIV1_OUTDIV3)

/*! @brief Set the OUTDIV3 field to a new value. */
#define BW_SIM_CLKDIV1_OUTDIV3(x, v)   (HW_SIM_CLKDIV1_WR(x, (HW_SIM_CLKDIV1_RD(x) & ~BM_SIM_CLKDIV1_OUTDIV3) | BF_SIM_CLKDIV1_OUTDIV3(v)))
/*@}*/

/*!
 * @name Register SIM_CLKDIV1, field OUTDIV2[27:24] (RW)
 *
 * This field sets the divide value for the bus clock from MCGOUTCLK. At the end of reset, it is
 * loaded with either 0000 or 0111 depending on FTF_FOPT[LPBOOT]. The bus clock frequency must be an
 * integer divide of the core/system clock frequency.
 *
 * Values:
 * - 0000 - Divide-by-1.
 * - 0001 - Divide-by-2.
 * - 0010 - Divide-by-3.
 * - 0011 - Divide-by-4.
 * - 0100 - Divide-by-5.
 * - 0101 - Divide-by-6.
 * - 0110 - Divide-by-7.
 * - 0111 - Divide-by-8.
 * - 1000 - Divide-by-9.
 * - 1001 - Divide-by-10.
 * - 1010 - Divide-by-11.
 * - 1011 - Divide-by-12.
 * - 1100 - Divide-by-13.
 * - 1101 - Divide-by-14.
 * - 1110 - Divide-by-15.
 * - 1111 - Divide-by-16.
 */
/*@{*/
#define BP_SIM_CLKDIV1_OUTDIV2         (24U)      /*!< Bit position for SIM_CLKDIV1_OUTDIV2. */
#define BM_SIM_CLKDIV1_OUTDIV2         (0x0F000000U)  /*!< Bit mask for SIM_CLKDIV1_OUTDIV2. */
#define BS_SIM_CLKDIV1_OUTDIV2         (4U)  /*!< Bitfield size in bits for SIM_CLKDIV1_OUTDIV2. */

/*! @brief Read current value of the SIM_CLKDIV1_OUTDIV2 field. */
#define BR_SIM_CLKDIV1_OUTDIV2(x)   (HW_SIM_CLKDIV1(x).B.OUTDIV2)

/*! @brief Format value for bitfield SIM_CLKDIV1_OUTDIV2. */
#define BF_SIM_CLKDIV1_OUTDIV2(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV1_OUTDIV2) & BM_SIM_CLKDIV1_OUTDIV2)

/*! @brief Set the OUTDIV2 field to a new value. */
#define BW_SIM_CLKDIV1_OUTDIV2(x, v)   (HW_SIM_CLKDIV1_WR(x, (HW_SIM_CLKDIV1_RD(x) & ~BM_SIM_CLKDIV1_OUTDIV2) | BF_SIM_CLKDIV1_OUTDIV2(v)))
/*@}*/

/*!
 * @name Register SIM_CLKDIV1, field OUTDIV1[31:28] (RW)
 *
 * This field sets the divide value for the core/system clock from MCGOUTCLK. At the end of reset,
 * it is loaded with either 0000 or 0111 depending on FTF_FOPT[LPBOOT].
 *
 * Values:
 * - 0000 - Divide-by-1.
 * - 0001 - Divide-by-2.
 * - 0010 - Divide-by-3.
 * - 0011 - Divide-by-4.
 * - 0100 - Divide-by-5.
 * - 0101 - Divide-by-6.
 * - 0110 - Divide-by-7.
 * - 0111 - Divide-by-8.
 * - 1000 - Divide-by-9.
 * - 1001 - Divide-by-10.
 * - 1010 - Divide-by-11.
 * - 1011 - Divide-by-12.
 * - 1100 - Divide-by-13.
 * - 1101 - Divide-by-14.
 * - 1110 - Divide-by-15.
 * - 1111 - Divide-by-16.
 */
/*@{*/
#define BP_SIM_CLKDIV1_OUTDIV1         (28U)      /*!< Bit position for SIM_CLKDIV1_OUTDIV1. */
#define BM_SIM_CLKDIV1_OUTDIV1         (0xF0000000U)  /*!< Bit mask for SIM_CLKDIV1_OUTDIV1. */
#define BS_SIM_CLKDIV1_OUTDIV1         (4U)  /*!< Bitfield size in bits for SIM_CLKDIV1_OUTDIV1. */

/*! @brief Read current value of the SIM_CLKDIV1_OUTDIV1 field. */
#define BR_SIM_CLKDIV1_OUTDIV1(x)   (HW_SIM_CLKDIV1(x).B.OUTDIV1)

/*! @brief Format value for bitfield SIM_CLKDIV1_OUTDIV1. */
#define BF_SIM_CLKDIV1_OUTDIV1(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV1_OUTDIV1) & BM_SIM_CLKDIV1_OUTDIV1)

/*! @brief Set the OUTDIV1 field to a new value. */
#define BW_SIM_CLKDIV1_OUTDIV1(x, v)   (HW_SIM_CLKDIV1_WR(x, (HW_SIM_CLKDIV1_RD(x) & ~BM_SIM_CLKDIV1_OUTDIV1) | BF_SIM_CLKDIV1_OUTDIV1(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_CLKDIV2 - System Clock Divider Register 2
 ******************************************************************************/

/*!
 * @brief HW_SIM_CLKDIV2 - System Clock Divider Register 2 (RW)
 *
 * Reset value: 0x00000000U
 */
typedef union _hw_sim_clkdiv2
{
    uint32_t U;
    struct _hw_sim_clkdiv2_bitfields
    {
        uint32_t USBFRAC : 1; /*!< [0] USB clock divider fraction */
        uint32_t USBDIV : 3; /*!< [3:1] USB clock divider divisor */
        uint32_t RESERVED0 : 28; /*!< [31:4]  */
    } B;
} hw_sim_clkdiv2_t;

/*!
 * @name Constants and macros for entire SIM_CLKDIV2 register
 */
/*@{*/
#define HW_SIM_CLKDIV2_ADDR(x)        ((x) + 0x1048U)
#define HW_SIM_CLKDIV2(x)             (*(__IO hw_sim_clkdiv2_t *) HW_SIM_CLKDIV2_ADDR(x))
#define HW_SIM_CLKDIV2_RD(x)          (HW_SIM_CLKDIV2(x).U)
#define HW_SIM_CLKDIV2_WR(x, v)       (HW_SIM_CLKDIV2(x).U = (v))
#define HW_SIM_CLKDIV2_SET(x, v)      (HW_SIM_CLKDIV2_WR(x, HW_SIM_CLKDIV2_RD(x) |  (v)))
#define HW_SIM_CLKDIV2_CLR(x, v)      (HW_SIM_CLKDIV2_WR(x, HW_SIM_CLKDIV2_RD(x) & ~(v)))
#define HW_SIM_CLKDIV2_TOG(x, v)      (HW_SIM_CLKDIV2_WR(x, HW_SIM_CLKDIV2_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_CLKDIV2 bitfields
 */

/*!
 * @name Register SIM_CLKDIV2, field USBFRAC[0] (RW)
 *
 * This field sets the fraction multiply value for the fractional clock divider when the MCGFLLCLK,
 * or MCGPLLCLK, or IRC48M clock is the USB clock source (SOPT2[USBSRC] = 1). Divider output clock =
 * Divider input clock × [ (USBFRAC+1) / (USBDIV+1) ]
 */
/*@{*/
#define BP_SIM_CLKDIV2_USBFRAC         (0U)      /*!< Bit position for SIM_CLKDIV2_USBFRAC. */
#define BM_SIM_CLKDIV2_USBFRAC         (0x00000001U)  /*!< Bit mask for SIM_CLKDIV2_USBFRAC. */
#define BS_SIM_CLKDIV2_USBFRAC         (1U)  /*!< Bitfield size in bits for SIM_CLKDIV2_USBFRAC. */

/*! @brief Read current value of the SIM_CLKDIV2_USBFRAC field. */
#define BR_SIM_CLKDIV2_USBFRAC(x)   (HW_SIM_CLKDIV2(x).B.USBFRAC)

/*! @brief Format value for bitfield SIM_CLKDIV2_USBFRAC. */
#define BF_SIM_CLKDIV2_USBFRAC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV2_USBFRAC) & BM_SIM_CLKDIV2_USBFRAC)

/*! @brief Set the USBFRAC field to a new value. */
#define BW_SIM_CLKDIV2_USBFRAC(x, v)   (HW_SIM_CLKDIV2_WR(x, (HW_SIM_CLKDIV2_RD(x) & ~BM_SIM_CLKDIV2_USBFRAC) | BF_SIM_CLKDIV2_USBFRAC(v)))
/*@}*/

/*!
 * @name Register SIM_CLKDIV2, field USBDIV[3:1] (RW)
 *
 * This field sets the divide value for the fractional clock divider when the MCGFLLCLK, or
 * MCGPLLCLK, or IRC48M clock is the USB clock source (SOPT2[USBSRC] = 1). Divider output clock =
 * Divider input clock × [ (USBFRAC+1) / (USBDIV+1) ]
 */
/*@{*/
#define BP_SIM_CLKDIV2_USBDIV         (1U)      /*!< Bit position for SIM_CLKDIV2_USBDIV. */
#define BM_SIM_CLKDIV2_USBDIV         (0x0000000EU)  /*!< Bit mask for SIM_CLKDIV2_USBDIV. */
#define BS_SIM_CLKDIV2_USBDIV         (3U)  /*!< Bitfield size in bits for SIM_CLKDIV2_USBDIV. */

/*! @brief Read current value of the SIM_CLKDIV2_USBDIV field. */
#define BR_SIM_CLKDIV2_USBDIV(x)   (HW_SIM_CLKDIV2(x).B.USBDIV)

/*! @brief Format value for bitfield SIM_CLKDIV2_USBDIV. */
#define BF_SIM_CLKDIV2_USBDIV(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV2_USBDIV) & BM_SIM_CLKDIV2_USBDIV)

/*! @brief Set the USBDIV field to a new value. */
#define BW_SIM_CLKDIV2_USBDIV(x, v)   (HW_SIM_CLKDIV2_WR(x, (HW_SIM_CLKDIV2_RD(x) & ~BM_SIM_CLKDIV2_USBDIV) | BF_SIM_CLKDIV2_USBDIV(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_FCFG1 - Flash Configuration Register 1
 ******************************************************************************/

/*!
 * @brief HW_SIM_FCFG1 - Flash Configuration Register 1 (RO)
 *
 * Reset value: 0xEEAEADEDDEEEFFAF0F0F0F00U
 */
typedef union _hw_sim_fcfg1
{
    uint32_t U;
    struct _hw_sim_fcfg1_bitfields
    {
        uint32_t FLASHDIS : 1; /*!< [0] Flash Disable */
        uint32_t FLASHDOZE : 1; /*!< [1] Flash Doze */
        uint32_t RESERVED3 : 22; /*!< [23:2] Reserved. */
        uint32_t PFSIZE : 4; /*!< [27:24] Program flash size */
        uint32_t RESERVED4 : 4; /*!< [31:28]  */
    } B;
} hw_sim_fcfg1_t;

/*!
 * @name Constants and macros for entire SIM_FCFG1 register
 */
/*@{*/
#define HW_SIM_FCFG1_ADDR(x)        ((x) + 0x104CU)
#define HW_SIM_FCFG1(x)             (*(__I  hw_sim_fcfg1_t *) HW_SIM_FCFG1_ADDR(x))
#define HW_SIM_FCFG1_RD(x)          (HW_SIM_FCFG1(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_FCFG1 bitfields
 */

/*!
 * @name Register SIM_FCFG1, field FLASHDIS[0] (RW)
 *
 * Flash accesses are disabled (and generate a bus error) and the Flash memory is placed in a low
 * power state. This bit should not be changed during VLP modes. Relocate the interrupt vectors out
 * of Flash memory before disabling the Flash.
 *
 * Values:
 * - 0 - Flash is enabled
 * - 1 - Flash is disabled
 */
/*@{*/
#define BP_SIM_FCFG1_FLASHDIS         (0U)      /*!< Bit position for SIM_FCFG1_FLASHDIS. */
#define BM_SIM_FCFG1_FLASHDIS         (0x00000001U)  /*!< Bit mask for SIM_FCFG1_FLASHDIS. */
#define BS_SIM_FCFG1_FLASHDIS         (1U)  /*!< Bitfield size in bits for SIM_FCFG1_FLASHDIS. */

/*! @brief Read current value of the SIM_FCFG1_FLASHDIS field. */
#define BR_SIM_FCFG1_FLASHDIS(x)   (HW_SIM_FCFG1(x).B.FLASHDIS)
/*@}*/

/*!
 * @name Register SIM_FCFG1, field FLASHDOZE[1] (RW)
 *
 * When set, Flash memory is disabled for the duration of Wait mode. An attempt by the DMA or other
 * bus master to access the Flash when the Flash is disabled will result in a bus error. This bit
 * should be clear during VLP modes. The Flash will be automatically enabled again at the end of
 * Wait mode so interrupt vectors do not need to be relocated out of Flash memory. The wakeup time
 * from Wait mode is extended when this bit is set.
 *
 * Values:
 * - 0 - Flash remains enabled during Wait mode
 * - 1 - Flash is disabled for the duration of Wait mode
 */
/*@{*/
#define BP_SIM_FCFG1_FLASHDOZE         (1U)      /*!< Bit position for SIM_FCFG1_FLASHDOZE. */
#define BM_SIM_FCFG1_FLASHDOZE         (0x00000002U)  /*!< Bit mask for SIM_FCFG1_FLASHDOZE. */
#define BS_SIM_FCFG1_FLASHDOZE         (1U)  /*!< Bitfield size in bits for SIM_FCFG1_FLASHDOZE. */

/*! @brief Read current value of the SIM_FCFG1_FLASHDOZE field. */
#define BR_SIM_FCFG1_FLASHDOZE(x)   (HW_SIM_FCFG1(x).B.FLASHDOZE)
/*@}*/

/*!
 * @name Register SIM_FCFG1, field PFSIZE[27:24] (RO)
 *
 * This field specifies the amount of program flash memory available on the device . Undefined
 * values are reserved.
 *
 * Values:
 * - 0011 - 32 KB of program flash memory
 * - 0101 - 64 KB of program flash memory
 * - 0111 - 128 KB of program flash memory
 * - 1001 - 256 KB of program flash memory
 * - 1011 - 512 KB of program flash memory
 * - 1101 - 1024 KB of program flash memory
 * - 1111 - 256 KB of program flash memory
 */
/*@{*/
#define BP_SIM_FCFG1_PFSIZE         (24U)      /*!< Bit position for SIM_FCFG1_PFSIZE. */
#define BM_SIM_FCFG1_PFSIZE         (0x0F000000U)  /*!< Bit mask for SIM_FCFG1_PFSIZE. */
#define BS_SIM_FCFG1_PFSIZE         (4U)  /*!< Bitfield size in bits for SIM_FCFG1_PFSIZE. */

/*! @brief Read current value of the SIM_FCFG1_PFSIZE field. */
#define BR_SIM_FCFG1_PFSIZE(x)   (HW_SIM_FCFG1(x).B.PFSIZE)
/*@}*/

/*******************************************************************************
 * HW_SIM_FCFG2 - Flash Configuration Register 2
 ******************************************************************************/

/*!
 * @brief HW_SIM_FCFG2 - Flash Configuration Register 2 (RO)
 *
 * Reset value: 0xEEAEADEDDEEEFFAF7FFF0000U
 */
typedef union _hw_sim_fcfg2
{
    uint32_t U;
    struct _hw_sim_fcfg2_bitfields
    {
        uint32_t RESERVED0 : 16; /*!< [15:0]  */
        uint32_t MAXADDR1 : 7; /*!< [22:16] Max address block 1 */
        uint32_t RESERVED1 : 1; /*!< [23]  */
        uint32_t MAXADDR0 : 7; /*!< [30:24] Max address block 0 */
        uint32_t RESERVED2 : 1; /*!< [31]  */
    } B;
} hw_sim_fcfg2_t;

/*!
 * @name Constants and macros for entire SIM_FCFG2 register
 */
/*@{*/
#define HW_SIM_FCFG2_ADDR(x)        ((x) + 0x1050U)
#define HW_SIM_FCFG2(x)             (*(__I  hw_sim_fcfg2_t *) HW_SIM_FCFG2_ADDR(x))
#define HW_SIM_FCFG2_RD(x)          (HW_SIM_FCFG2(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_FCFG2 bitfields
 */

/*!
 * @name Register SIM_FCFG2, field MAXADDR1[22:16] (RO)
 *
 * This field equals zero if there is only one program flash block, otherwise it equals the value of
 * the MAXADDR0 field. For example, with MAXADDR0 = MAXADDR1 = 0x20 the first invalid address of
 * flash block 1 is 0x4_0000 + 0x4_0000. This would be the MAXADDR1 value for a device with 512 KB
 * program flash memory across two flash blocks and no FlexNVM.
 */
/*@{*/
#define BP_SIM_FCFG2_MAXADDR1         (16U)      /*!< Bit position for SIM_FCFG2_MAXADDR1. */
#define BM_SIM_FCFG2_MAXADDR1         (0x007F0000U)  /*!< Bit mask for SIM_FCFG2_MAXADDR1. */
#define BS_SIM_FCFG2_MAXADDR1         (7U)  /*!< Bitfield size in bits for SIM_FCFG2_MAXADDR1. */

/*! @brief Read current value of the SIM_FCFG2_MAXADDR1 field. */
#define BR_SIM_FCFG2_MAXADDR1(x)   (HW_SIM_FCFG2(x).B.MAXADDR1)
/*@}*/

/*!
 * @name Register SIM_FCFG2, field MAXADDR0[30:24] (RO)
 *
 * This field concatenated with 13 trailing zeros indicates the first invalid address of each
 * program flash block. For example, if MAXADDR0 = 0x20 the first invalid address of flash block 0
 * is 0x0004_0000. This would be the MAXADDR0 value for a device with 256 KB program flash in flash
 * block 0.
 */
/*@{*/
#define BP_SIM_FCFG2_MAXADDR0         (24U)      /*!< Bit position for SIM_FCFG2_MAXADDR0. */
#define BM_SIM_FCFG2_MAXADDR0         (0x7F000000U)  /*!< Bit mask for SIM_FCFG2_MAXADDR0. */
#define BS_SIM_FCFG2_MAXADDR0         (7U)  /*!< Bitfield size in bits for SIM_FCFG2_MAXADDR0. */

/*! @brief Read current value of the SIM_FCFG2_MAXADDR0 field. */
#define BR_SIM_FCFG2_MAXADDR0(x)   (HW_SIM_FCFG2(x).B.MAXADDR0)
/*@}*/

/*******************************************************************************
 * HW_SIM_UIDH - Unique Identification Register High
 ******************************************************************************/

/*!
 * @brief HW_SIM_UIDH - Unique Identification Register High (RO)
 *
 * Reset value: 0xEEAEADEDDEEEFFAFU
 */
typedef union _hw_sim_uidh
{
    uint32_t U;
    struct _hw_sim_uidh_bitfields
    {
        uint32_t UID : 32; /*!< [31:0] Unique Identification */
    } B;
} hw_sim_uidh_t;

/*!
 * @name Constants and macros for entire SIM_UIDH register
 */
/*@{*/
#define HW_SIM_UIDH_ADDR(x)        ((x) + 0x1054U)
#define HW_SIM_UIDH(x)             (*(__I  hw_sim_uidh_t *) HW_SIM_UIDH_ADDR(x))
#define HW_SIM_UIDH_RD(x)          (HW_SIM_UIDH(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_UIDH bitfields
 */

/*!
 * @name Register SIM_UIDH, field UID[31:0] (RO)
 *
 * Unique identification for the device.
 */
/*@{*/
#define BP_SIM_UIDH_UID         (0U)      /*!< Bit position for SIM_UIDH_UID. */
#define BM_SIM_UIDH_UID         (0xFFFFFFFFU)  /*!< Bit mask for SIM_UIDH_UID. */
#define BS_SIM_UIDH_UID         (32U)  /*!< Bitfield size in bits for SIM_UIDH_UID. */

/*! @brief Read current value of the SIM_UIDH_UID field. */
#define BR_SIM_UIDH_UID(x)      (HW_SIM_UIDH(x).U)
/*@}*/

/*******************************************************************************
 * HW_SIM_UIDMH - Unique Identification Register Mid-High
 ******************************************************************************/

/*!
 * @brief HW_SIM_UIDMH - Unique Identification Register Mid-High (RO)
 *
 * Reset value: 0xEEAEADEDDEEEFFAFU
 */
typedef union _hw_sim_uidmh
{
    uint32_t U;
    struct _hw_sim_uidmh_bitfields
    {
        uint32_t UID : 32; /*!< [31:0] Unique Identification */
    } B;
} hw_sim_uidmh_t;

/*!
 * @name Constants and macros for entire SIM_UIDMH register
 */
/*@{*/
#define HW_SIM_UIDMH_ADDR(x)        ((x) + 0x1058U)
#define HW_SIM_UIDMH(x)             (*(__I  hw_sim_uidmh_t *) HW_SIM_UIDMH_ADDR(x))
#define HW_SIM_UIDMH_RD(x)          (HW_SIM_UIDMH(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_UIDMH bitfields
 */

/*!
 * @name Register SIM_UIDMH, field UID[31:0] (RO)
 *
 * Unique identification for the device.
 */
/*@{*/
#define BP_SIM_UIDMH_UID         (0U)      /*!< Bit position for SIM_UIDMH_UID. */
#define BM_SIM_UIDMH_UID         (0xFFFFFFFFU)  /*!< Bit mask for SIM_UIDMH_UID. */
#define BS_SIM_UIDMH_UID         (32U)  /*!< Bitfield size in bits for SIM_UIDMH_UID. */

/*! @brief Read current value of the SIM_UIDMH_UID field. */
#define BR_SIM_UIDMH_UID(x)      (HW_SIM_UIDMH(x).U)
/*@}*/

/*******************************************************************************
 * HW_SIM_UIDML - Unique Identification Register Mid Low
 ******************************************************************************/

/*!
 * @brief HW_SIM_UIDML - Unique Identification Register Mid Low (RO)
 *
 * Reset value: 0xEEAEADEDDEEEFFAFU
 */
typedef union _hw_sim_uidml
{
    uint32_t U;
    struct _hw_sim_uidml_bitfields
    {
        uint32_t UID : 32; /*!< [31:0] Unique Identification */
    } B;
} hw_sim_uidml_t;

/*!
 * @name Constants and macros for entire SIM_UIDML register
 */
/*@{*/
#define HW_SIM_UIDML_ADDR(x)        ((x) + 0x105CU)
#define HW_SIM_UIDML(x)             (*(__I  hw_sim_uidml_t *) HW_SIM_UIDML_ADDR(x))
#define HW_SIM_UIDML_RD(x)          (HW_SIM_UIDML(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_UIDML bitfields
 */

/*!
 * @name Register SIM_UIDML, field UID[31:0] (RO)
 *
 * Unique identification for the device.
 */
/*@{*/
#define BP_SIM_UIDML_UID         (0U)      /*!< Bit position for SIM_UIDML_UID. */
#define BM_SIM_UIDML_UID         (0xFFFFFFFFU)  /*!< Bit mask for SIM_UIDML_UID. */
#define BS_SIM_UIDML_UID         (32U)  /*!< Bitfield size in bits for SIM_UIDML_UID. */

/*! @brief Read current value of the SIM_UIDML_UID field. */
#define BR_SIM_UIDML_UID(x)      (HW_SIM_UIDML(x).U)
/*@}*/

/*******************************************************************************
 * HW_SIM_UIDL - Unique Identification Register Low
 ******************************************************************************/

/*!
 * @brief HW_SIM_UIDL - Unique Identification Register Low (RO)
 *
 * Reset value: 0xEEAEADEDDEEEFFAFU
 */
typedef union _hw_sim_uidl
{
    uint32_t U;
    struct _hw_sim_uidl_bitfields
    {
        uint32_t UID : 32; /*!< [31:0] Unique Identification */
    } B;
} hw_sim_uidl_t;

/*!
 * @name Constants and macros for entire SIM_UIDL register
 */
/*@{*/
#define HW_SIM_UIDL_ADDR(x)        ((x) + 0x1060U)
#define HW_SIM_UIDL(x)             (*(__I  hw_sim_uidl_t *) HW_SIM_UIDL_ADDR(x))
#define HW_SIM_UIDL_RD(x)          (HW_SIM_UIDL(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_UIDL bitfields
 */

/*!
 * @name Register SIM_UIDL, field UID[31:0] (RO)
 *
 * Unique identification for the device.
 */
/*@{*/
#define BP_SIM_UIDL_UID         (0U)      /*!< Bit position for SIM_UIDL_UID. */
#define BM_SIM_UIDL_UID         (0xFFFFFFFFU)  /*!< Bit mask for SIM_UIDL_UID. */
#define BS_SIM_UIDL_UID         (32U)  /*!< Bitfield size in bits for SIM_UIDL_UID. */

/*! @brief Read current value of the SIM_UIDL_UID field. */
#define BR_SIM_UIDL_UID(x)      (HW_SIM_UIDL(x).U)
/*@}*/

/*******************************************************************************
 * HW_SIM_CLKDIV3 - System Clock Divider Register 3
 ******************************************************************************/

/*!
 * @brief HW_SIM_CLKDIV3 - System Clock Divider Register 3 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register should only be written when the LPUART, EMVSIM, FlexIO and TPM modules are
 * disabled.
 */
typedef union _hw_sim_clkdiv3
{
    uint32_t U;
    struct _hw_sim_clkdiv3_bitfields
    {
        uint32_t PLLFLLFRAC : 1; /*!< [0] PLLFLL clock divider fraction */
        uint32_t PLLFLLDIV : 3; /*!< [3:1] PLLFLL clock divider divisor */
        uint32_t RESERVED0 : 28; /*!< [31:4]  */
    } B;
} hw_sim_clkdiv3_t;

/*!
 * @name Constants and macros for entire SIM_CLKDIV3 register
 */
/*@{*/
#define HW_SIM_CLKDIV3_ADDR(x)        ((x) + 0x1064U)
#define HW_SIM_CLKDIV3(x)             (*(__IO hw_sim_clkdiv3_t *) HW_SIM_CLKDIV3_ADDR(x))
#define HW_SIM_CLKDIV3_RD(x)          (HW_SIM_CLKDIV3(x).U)
#define HW_SIM_CLKDIV3_WR(x, v)       (HW_SIM_CLKDIV3(x).U = (v))
#define HW_SIM_CLKDIV3_SET(x, v)      (HW_SIM_CLKDIV3_WR(x, HW_SIM_CLKDIV3_RD(x) |  (v)))
#define HW_SIM_CLKDIV3_CLR(x, v)      (HW_SIM_CLKDIV3_WR(x, HW_SIM_CLKDIV3_RD(x) & ~(v)))
#define HW_SIM_CLKDIV3_TOG(x, v)      (HW_SIM_CLKDIV3_WR(x, HW_SIM_CLKDIV3_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_CLKDIV3 bitfields
 */

/*!
 * @name Register SIM_CLKDIV3, field PLLFLLFRAC[0] (RW)
 *
 * This field sets the divide value for the fractional clock divider used as a source for various
 * peripherals. The source clock for the fractional clock divider is set by the SOPT2 PLLFLLSEL
 * register bit. Divider output clock = Divider input clock*((PLLFLLFRAC+1)/(PLLFLLDIV+1))
 */
/*@{*/
#define BP_SIM_CLKDIV3_PLLFLLFRAC         (0U)      /*!< Bit position for SIM_CLKDIV3_PLLFLLFRAC. */
#define BM_SIM_CLKDIV3_PLLFLLFRAC         (0x00000001U)  /*!< Bit mask for SIM_CLKDIV3_PLLFLLFRAC. */
#define BS_SIM_CLKDIV3_PLLFLLFRAC         (1U)  /*!< Bitfield size in bits for SIM_CLKDIV3_PLLFLLFRAC. */

/*! @brief Read current value of the SIM_CLKDIV3_PLLFLLFRAC field. */
#define BR_SIM_CLKDIV3_PLLFLLFRAC(x)   (HW_SIM_CLKDIV3(x).B.PLLFLLFRAC)

/*! @brief Format value for bitfield SIM_CLKDIV3_PLLFLLFRAC. */
#define BF_SIM_CLKDIV3_PLLFLLFRAC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV3_PLLFLLFRAC) & BM_SIM_CLKDIV3_PLLFLLFRAC)

/*! @brief Set the PLLFLLFRAC field to a new value. */
#define BW_SIM_CLKDIV3_PLLFLLFRAC(x, v)   (HW_SIM_CLKDIV3_WR(x, (HW_SIM_CLKDIV3_RD(x) & ~BM_SIM_CLKDIV3_PLLFLLFRAC) | BF_SIM_CLKDIV3_PLLFLLFRAC(v)))
/*@}*/

/*!
 * @name Register SIM_CLKDIV3, field PLLFLLDIV[3:1] (RW)
 *
 * This field sets the divide value for the fractional clock divider used as a source for various
 * peripheral clocks. The source clock for the fractional clock divider is set by the SOPT2
 * PLLFLLSEL register bit. Divider output clock = Divider input clock *
 * ((PLLFLLFRAC+1)/(PLLFLLDIV+1))
 */
/*@{*/
#define BP_SIM_CLKDIV3_PLLFLLDIV         (1U)      /*!< Bit position for SIM_CLKDIV3_PLLFLLDIV. */
#define BM_SIM_CLKDIV3_PLLFLLDIV         (0x0000000EU)  /*!< Bit mask for SIM_CLKDIV3_PLLFLLDIV. */
#define BS_SIM_CLKDIV3_PLLFLLDIV         (3U)  /*!< Bitfield size in bits for SIM_CLKDIV3_PLLFLLDIV. */

/*! @brief Read current value of the SIM_CLKDIV3_PLLFLLDIV field. */
#define BR_SIM_CLKDIV3_PLLFLLDIV(x)   (HW_SIM_CLKDIV3(x).B.PLLFLLDIV)

/*! @brief Format value for bitfield SIM_CLKDIV3_PLLFLLDIV. */
#define BF_SIM_CLKDIV3_PLLFLLDIV(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV3_PLLFLLDIV) & BM_SIM_CLKDIV3_PLLFLLDIV)

/*! @brief Set the PLLFLLDIV field to a new value. */
#define BW_SIM_CLKDIV3_PLLFLLDIV(x, v)   (HW_SIM_CLKDIV3_WR(x, (HW_SIM_CLKDIV3_RD(x) & ~BM_SIM_CLKDIV3_PLLFLLDIV) | BF_SIM_CLKDIV3_PLLFLLDIV(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_CLKDIV4 - System Clock Divider Register 4
 ******************************************************************************/

/*!
 * @brief HW_SIM_CLKDIV4 - System Clock Divider Register 4 (RW)
 *
 * Reset value: 0x00000000U
 *
 * This register should only be written when the SOPT2 TRACECLKSEL register bit is set.
 */
typedef union _hw_sim_clkdiv4
{
    uint32_t U;
    struct _hw_sim_clkdiv4_bitfields
    {
        uint32_t TRACEFRAC : 1; /*!< [0] Trace clock divider fraction */
        uint32_t TRACEDIV : 3; /*!< [3:1] Trace clock divider divisor */
        uint32_t RESERVED0 : 28; /*!< [31:4]  */
    } B;
} hw_sim_clkdiv4_t;

/*!
 * @name Constants and macros for entire SIM_CLKDIV4 register
 */
/*@{*/
#define HW_SIM_CLKDIV4_ADDR(x)        ((x) + 0x1068U)
#define HW_SIM_CLKDIV4(x)             (*(__IO hw_sim_clkdiv4_t *) HW_SIM_CLKDIV4_ADDR(x))
#define HW_SIM_CLKDIV4_RD(x)          (HW_SIM_CLKDIV4(x).U)
#define HW_SIM_CLKDIV4_WR(x, v)       (HW_SIM_CLKDIV4(x).U = (v))
#define HW_SIM_CLKDIV4_SET(x, v)      (HW_SIM_CLKDIV4_WR(x, HW_SIM_CLKDIV4_RD(x) |  (v)))
#define HW_SIM_CLKDIV4_CLR(x, v)      (HW_SIM_CLKDIV4_WR(x, HW_SIM_CLKDIV4_RD(x) & ~(v)))
#define HW_SIM_CLKDIV4_TOG(x, v)      (HW_SIM_CLKDIV4_WR(x, HW_SIM_CLKDIV4_RD(x) ^  (v)))
/*@}*/

/*
 * Constants & macros for individual SIM_CLKDIV4 bitfields
 */

/*!
 * @name Register SIM_CLKDIV4, field TRACEFRAC[0] (RW)
 *
 * This field sets the divide value for the MCGCLKOUT fractional clock divider used as a source for
 * trace clock. The source clock for the trace clock is set by the SOPT2 TRACECLKSEL register bit.
 * Divider output clock = Divider input clock*((TRACEFRAC+1)/(TRACEDIV+1))
 */
/*@{*/
#define BP_SIM_CLKDIV4_TRACEFRAC         (0U)      /*!< Bit position for SIM_CLKDIV4_TRACEFRAC. */
#define BM_SIM_CLKDIV4_TRACEFRAC         (0x00000001U)  /*!< Bit mask for SIM_CLKDIV4_TRACEFRAC. */
#define BS_SIM_CLKDIV4_TRACEFRAC         (1U)  /*!< Bitfield size in bits for SIM_CLKDIV4_TRACEFRAC. */

/*! @brief Read current value of the SIM_CLKDIV4_TRACEFRAC field. */
#define BR_SIM_CLKDIV4_TRACEFRAC(x)   (HW_SIM_CLKDIV4(x).B.TRACEFRAC)

/*! @brief Format value for bitfield SIM_CLKDIV4_TRACEFRAC. */
#define BF_SIM_CLKDIV4_TRACEFRAC(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV4_TRACEFRAC) & BM_SIM_CLKDIV4_TRACEFRAC)

/*! @brief Set the TRACEFRAC field to a new value. */
#define BW_SIM_CLKDIV4_TRACEFRAC(x, v)   (HW_SIM_CLKDIV4_WR(x, (HW_SIM_CLKDIV4_RD(x) & ~BM_SIM_CLKDIV4_TRACEFRAC) | BF_SIM_CLKDIV4_TRACEFRAC(v)))
/*@}*/

/*!
 * @name Register SIM_CLKDIV4, field TRACEDIV[3:1] (RW)
 *
 * This field sets the divide value for the MCGCLKOUT fractional clock divider used as a source for
 * trace clock. The source clock for the trace clock is set by the SOPT2 TRACECLKSEL register bit.
 * Divider output clock = Divider input clock * ((TRACEFRAC+1)/(TRACEDIV+1))
 */
/*@{*/
#define BP_SIM_CLKDIV4_TRACEDIV         (1U)      /*!< Bit position for SIM_CLKDIV4_TRACEDIV. */
#define BM_SIM_CLKDIV4_TRACEDIV         (0x0000000EU)  /*!< Bit mask for SIM_CLKDIV4_TRACEDIV. */
#define BS_SIM_CLKDIV4_TRACEDIV         (3U)  /*!< Bitfield size in bits for SIM_CLKDIV4_TRACEDIV. */

/*! @brief Read current value of the SIM_CLKDIV4_TRACEDIV field. */
#define BR_SIM_CLKDIV4_TRACEDIV(x)   (HW_SIM_CLKDIV4(x).B.TRACEDIV)

/*! @brief Format value for bitfield SIM_CLKDIV4_TRACEDIV. */
#define BF_SIM_CLKDIV4_TRACEDIV(v)      ((uint32_t)((uint32_t)(v) << BP_SIM_CLKDIV4_TRACEDIV) & BM_SIM_CLKDIV4_TRACEDIV)

/*! @brief Set the TRACEDIV field to a new value. */
#define BW_SIM_CLKDIV4_TRACEDIV(x, v)   (HW_SIM_CLKDIV4_WR(x, (HW_SIM_CLKDIV4_RD(x) & ~BM_SIM_CLKDIV4_TRACEDIV) | BF_SIM_CLKDIV4_TRACEDIV(v)))
/*@}*/

/*******************************************************************************
 * HW_SIM_SECKEY0 - Secure Key Register 0
 ******************************************************************************/

/*!
 * @brief HW_SIM_SECKEY0 - Secure Key Register 0 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is only readable by ROM software in supervisor mode.
 */
typedef union _hw_sim_seckey0
{
    uint32_t U;
    struct _hw_sim_seckey0_bitfields
    {
        uint32_t SECKEY : 32; /*!< [31:0] Secure Key */
    } B;
} hw_sim_seckey0_t;

/*!
 * @name Constants and macros for entire SIM_SECKEY0 register
 */
/*@{*/
#define HW_SIM_SECKEY0_ADDR(x)        ((x) + 0x1090U)
#define HW_SIM_SECKEY0(x)             (*(__I  hw_sim_seckey0_t *) HW_SIM_SECKEY0_ADDR(x))
#define HW_SIM_SECKEY0_RD(x)          (HW_SIM_SECKEY0(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_SECKEY0 bitfields
 */

/*!
 * @name Register SIM_SECKEY0, field SECKEY[31:0] (RO)
 */
/*@{*/
#define BP_SIM_SECKEY0_SECKEY         (0U)      /*!< Bit position for SIM_SECKEY0_SECKEY. */
#define BM_SIM_SECKEY0_SECKEY         (0xFFFFFFFFU)  /*!< Bit mask for SIM_SECKEY0_SECKEY. */
#define BS_SIM_SECKEY0_SECKEY         (32U)  /*!< Bitfield size in bits for SIM_SECKEY0_SECKEY. */

/*! @brief Read current value of the SIM_SECKEY0_SECKEY field. */
#define BR_SIM_SECKEY0_SECKEY(x)      (HW_SIM_SECKEY0(x).U)
/*@}*/

/*******************************************************************************
 * HW_SIM_SECKEY1 - Secure Key Register 1
 ******************************************************************************/

/*!
 * @brief HW_SIM_SECKEY1 - Secure Key Register 1 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is only readable by ROM software in supervisor mode.
 */
typedef union _hw_sim_seckey1
{
    uint32_t U;
    struct _hw_sim_seckey1_bitfields
    {
        uint32_t SECKEY : 32; /*!< [31:0] Secure Key */
    } B;
} hw_sim_seckey1_t;

/*!
 * @name Constants and macros for entire SIM_SECKEY1 register
 */
/*@{*/
#define HW_SIM_SECKEY1_ADDR(x)        ((x) + 0x1094U)
#define HW_SIM_SECKEY1(x)             (*(__I  hw_sim_seckey1_t *) HW_SIM_SECKEY1_ADDR(x))
#define HW_SIM_SECKEY1_RD(x)          (HW_SIM_SECKEY1(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_SECKEY1 bitfields
 */

/*!
 * @name Register SIM_SECKEY1, field SECKEY[31:0] (RO)
 */
/*@{*/
#define BP_SIM_SECKEY1_SECKEY         (0U)      /*!< Bit position for SIM_SECKEY1_SECKEY. */
#define BM_SIM_SECKEY1_SECKEY         (0xFFFFFFFFU)  /*!< Bit mask for SIM_SECKEY1_SECKEY. */
#define BS_SIM_SECKEY1_SECKEY         (32U)  /*!< Bitfield size in bits for SIM_SECKEY1_SECKEY. */

/*! @brief Read current value of the SIM_SECKEY1_SECKEY field. */
#define BR_SIM_SECKEY1_SECKEY(x)      (HW_SIM_SECKEY1(x).U)
/*@}*/

/*******************************************************************************
 * HW_SIM_SECKEY2 - Secure Key Register 2
 ******************************************************************************/

/*!
 * @brief HW_SIM_SECKEY2 - Secure Key Register 2 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is only readable by ROM software in supervisor mode.
 */
typedef union _hw_sim_seckey2
{
    uint32_t U;
    struct _hw_sim_seckey2_bitfields
    {
        uint32_t SECKEY : 32; /*!< [31:0] Secure Key */
    } B;
} hw_sim_seckey2_t;

/*!
 * @name Constants and macros for entire SIM_SECKEY2 register
 */
/*@{*/
#define HW_SIM_SECKEY2_ADDR(x)        ((x) + 0x1098U)
#define HW_SIM_SECKEY2(x)             (*(__I  hw_sim_seckey2_t *) HW_SIM_SECKEY2_ADDR(x))
#define HW_SIM_SECKEY2_RD(x)          (HW_SIM_SECKEY2(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_SECKEY2 bitfields
 */

/*!
 * @name Register SIM_SECKEY2, field SECKEY[31:0] (RO)
 */
/*@{*/
#define BP_SIM_SECKEY2_SECKEY         (0U)      /*!< Bit position for SIM_SECKEY2_SECKEY. */
#define BM_SIM_SECKEY2_SECKEY         (0xFFFFFFFFU)  /*!< Bit mask for SIM_SECKEY2_SECKEY. */
#define BS_SIM_SECKEY2_SECKEY         (32U)  /*!< Bitfield size in bits for SIM_SECKEY2_SECKEY. */

/*! @brief Read current value of the SIM_SECKEY2_SECKEY field. */
#define BR_SIM_SECKEY2_SECKEY(x)      (HW_SIM_SECKEY2(x).U)
/*@}*/

/*******************************************************************************
 * HW_SIM_SECKEY3 - Secure Key Register 3
 ******************************************************************************/

/*!
 * @brief HW_SIM_SECKEY3 - Secure Key Register 3 (RO)
 *
 * Reset value: 0x00000000U
 *
 * This register is only readable by ROM software in supervisor mode.
 */
typedef union _hw_sim_seckey3
{
    uint32_t U;
    struct _hw_sim_seckey3_bitfields
    {
        uint32_t SECKEY : 32; /*!< [31:0] Secure Key */
    } B;
} hw_sim_seckey3_t;

/*!
 * @name Constants and macros for entire SIM_SECKEY3 register
 */
/*@{*/
#define HW_SIM_SECKEY3_ADDR(x)        ((x) + 0x109CU)
#define HW_SIM_SECKEY3(x)             (*(__I  hw_sim_seckey3_t *) HW_SIM_SECKEY3_ADDR(x))
#define HW_SIM_SECKEY3_RD(x)          (HW_SIM_SECKEY3(x).U)
/*@}*/

/*
 * Constants & macros for individual SIM_SECKEY3 bitfields
 */

/*!
 * @name Register SIM_SECKEY3, field SECKEY[31:0] (RO)
 */
/*@{*/
#define BP_SIM_SECKEY3_SECKEY         (0U)      /*!< Bit position for SIM_SECKEY3_SECKEY. */
#define BM_SIM_SECKEY3_SECKEY         (0xFFFFFFFFU)  /*!< Bit mask for SIM_SECKEY3_SECKEY. */
#define BS_SIM_SECKEY3_SECKEY         (32U)  /*!< Bitfield size in bits for SIM_SECKEY3_SECKEY. */

/*! @brief Read current value of the SIM_SECKEY3_SECKEY field. */
#define BR_SIM_SECKEY3_SECKEY(x)      (HW_SIM_SECKEY3(x).U)
/*@}*/

/*******************************************************************************
 * hw_sim_t - module struct
 ******************************************************************************/
/*!
 * @brief All SIM module registers.
 */
#pragma pack(1)
typedef struct _hw_sim
{
    __IO hw_sim_sopt1_t SOPT1; /*!< [0x0] System Options Register 1 */
    __IO hw_sim_sopt1cfg_t SOPT1CFG; /*!< [0x4] SOPT1 Configuration Register */
         uint32_t _reserved0[1023];
    __IO hw_sim_sopt2_t SOPT2; /*!< [0x1004] System Options Register 2 */
    __IO hw_sim_sopt3_t SOPT3; /*!< [0x1008] System Options Register 3 */
    __IO hw_sim_sopt4_t SOPT4; /*!< [0x100C] System Options Register 4 */
    __IO hw_sim_sopt5_t SOPT5; /*!< [0x1010] System Options Register 5 */
         uint32_t _reserved2;
    __IO hw_sim_sopt7_t SOPT7; /*!< [0x1018] System Options Register 7 */
    __IO hw_sim_sopt8_t SOPT8; /*!< [0x101C] System Options Register 8 */
    __IO hw_sim_sopt9_t SOPT9; /*!< [0x1020] System Options Register 9 */
    __I  hw_sim_sdid_t SDID; /*!< [0x1024] System Device Identification Register */
    __IO hw_sim_scgc1_t SCGC1; /*!< [0x1028] System Clock Gating Control Register 1 */
    __IO hw_sim_scgc2_t SCGC2; /*!< [0x102C] System Clock Gating Control Register 2 */
    __IO hw_sim_scgc3_t SCGC3; /*!< [0x1030] System Clock Gating Control Register 3 */
    __IO hw_sim_scgc4_t SCGC4; /*!< [0x1034] System Clock Gating Control Register 4 */
    __IO hw_sim_scgc5_t SCGC5; /*!< [0x1038] System Clock Gating Control Register 5 */
    __IO hw_sim_scgc6_t SCGC6; /*!< [0x103C] System Clock Gating Control Register 6 */
    __IO hw_sim_scgc7_t SCGC7; /*!< [0x1040] System Clock Gating Control Register 7 */
    __IO hw_sim_clkdiv1_t CLKDIV1; /*!< [0x1044] System Clock Divider Register 1 */
    __IO hw_sim_clkdiv2_t CLKDIV2; /*!< [0x1048] System Clock Divider Register 2 */
    __I  hw_sim_fcfg1_t FCFG1; /*!< [0x104C] Flash Configuration Register 1 */
    __I  hw_sim_fcfg2_t FCFG2; /*!< [0x1050] Flash Configuration Register 2 */
    __I  hw_sim_uidh_t UIDH; /*!< [0x1054] Unique Identification Register High */
    __I  hw_sim_uidmh_t UIDMH; /*!< [0x1058] Unique Identification Register Mid-High */
    __I  hw_sim_uidml_t UIDML; /*!< [0x105C] Unique Identification Register Mid Low */
    __I  hw_sim_uidl_t UIDL; /*!< [0x1060] Unique Identification Register Low */
    __IO hw_sim_clkdiv3_t CLKDIV3; /*!< [0x1064] System Clock Divider Register 3 */
    __IO hw_sim_clkdiv4_t CLKDIV4; /*!< [0x1068] System Clock Divider Register 4 */
         uint32_t _reserved4[9];
    __I  hw_sim_seckey0_t SECKEY0; /*!< [0x1090] Secure Key Register 0 */
    __I  hw_sim_seckey1_t SECKEY1; /*!< [0x1094] Secure Key Register 1 */
    __I  hw_sim_seckey2_t SECKEY2; /*!< [0x1098] Secure Key Register 2 */
    __I  hw_sim_seckey3_t SECKEY3; /*!< [0x109C] Secure Key Register 3 */
} hw_sim_t;
#pragma pack()


/*! @brief Macro to access all SIM registers. */
/*! @param x SIM module instance base address. */
/*! @return Reference (not a pointer) to the registers struct. To get a pointer to the struct,
 *     use the '&' operator, like <code>&HW_SIM(SIM0_BASE)</code>. */
#define HW_SIM(x)      (*(hw_sim_t *)(x))

#endif /* __HW_SIM_REGISTERS_H__ */
/* v30/140722/1.3.1 */
/* EOF */
